----------------------------------------------------------------------

local AB_SAVE_FILENAME_LUA  = "ROAD_RIOT_AB_TEST.lua";
local AB_SAVE_FILENAME_JSON = "a83b13t38e823s922t.jp5";

----------------------------------------------------------------------

AbTestMgr  =
{
};

----------------------------------------------------------------------

AbTestMgr.IAP_LOOP_INDEX =
{
   1,
   2,
   4,
   8,
   12,
   16
};

----------------------------------------------------------------------

AbTestMgr.VEHICLE_NAME =
{
   "Sports",
   "Magnet",
   "Missile",
   "Laser",
   "Blast",

   "Sports2",
   "Magnet2",
   "Missile2",
   "Laser2",
   "Blast2"
};

----------------------------------------------------------------------
--We are not respecting the perfect ratio to avoid sending too many FLurry event and risking a crash
AbTestMgr.IAP_LOOP_ID =
{
   ["gem-01"]              =  AbTestMgr.IAP_LOOP_INDEX[1], -- $01.99
   ["gem-11"]              =  AbTestMgr.IAP_LOOP_INDEX[1], -- $01.99
   ["gem-02"]              =  AbTestMgr.IAP_LOOP_INDEX[2], -- $04.99
   ["gem-12"]              =  AbTestMgr.IAP_LOOP_INDEX[2], -- $04.99
   ["special-starter-01"]  =  AbTestMgr.IAP_LOOP_INDEX[2], -- $04.99
   ["gem-03"]              =  AbTestMgr.IAP_LOOP_INDEX[3], -- $09.99
   ["gem-13"]              =  AbTestMgr.IAP_LOOP_INDEX[3], -- $09.99
   ["gem-04"]              =  AbTestMgr.IAP_LOOP_INDEX[4], -- $19.99
   ["gem-14"]              =  AbTestMgr.IAP_LOOP_INDEX[4], -- $19.99
   ["gem-05"]              =  AbTestMgr.IAP_LOOP_INDEX[5], -- $49.99
   ["gem-15"]              =  AbTestMgr.IAP_LOOP_INDEX[5], -- $49.99
   ["gem-06"]              =  AbTestMgr.IAP_LOOP_INDEX[6], -- $99.99
   ["gem-16"]              =  AbTestMgr.IAP_LOOP_INDEX[6], -- $99.99
};

AbTestMgr.IAP_COST =
{
   ["gem-01"]              =  1.99,
   ["gem-11"]              =  1.99,
   ["gem-02"]              =  4.99,
   ["gem-12"]              =  4.99,
   ["special-starter-01"]  =  4.99,
   ["gem-03"]              =  9.99,
   ["gem-13"]              =  9.99,
   ["gem-04"]              =  19.99,
   ["gem-14"]              =  19.99,
   ["gem-05"]              =  49.99,
   ["gem-15"]              =  49.99,
   ["gem-06"]              =  99.99,
   ["gem-16"]              =  99.99,
};

----------------------------------------------------------------------

function AbTestMgr:init()

   self:_load()

   EventMgr:addListener( self, self._onUpdateOptions,    "cloud:master-data-ab-test"       );
   EventMgr:addListener( self, self._onUpdateOptions,    "cloud:file-data-ab-test-winners" );

   self:_initListeners();

end

----------------------------------------------------------------------

function AbTestMgr:choose(value, abValue)
   if abValue ~= nil then
      return abValue;
   else
      return value;
   end
end

----------------------------------------------------------------------

function AbTestMgr:_onUpdateOptions( data )

   local content = (data or {}).content;

   for k,v in pairs(content) do

      self._winners[k]     = v.winner;
      self._defaults[k]    = v.default;
      self._flurryIds[k]   = v.flurryId or k;
      self._targets[k]     = v.targets;
      self._choices[k]     = v.choices;
      self._extras[k]      = v.extras;

   end

   self._storeGemMap         = nil;
   self._storeGoldMap        = nil;
   self._storeKeyMap         = nil;
   self._thiefVideoMap       = nil;
   self._vehicleInfoTableMap = nil;
   self._rewardInfoTableMap  = nil;

   self._bossDifficultyMap   = nil;
   self._videoButtonMap      = nil;
   self._bountySelectionMap  = nil;
   self._hudTargetMap        = nil;
   self._reviveCostMap       = nil;
   self._authenRewardMap     = nil;
   self._gameCenterMap       = nil;
   self._interstitialMap     = nil;
   self._videoRewardsMap     = nil;
   self._videoRewardsLvlMap  = nil;
   self._autoSelectAllMap    = nil;
   self._newPlayButton       = nil;
   self._guestFriendMap      = nil;
   self._droneSettingsMap    = nil;
   self._droneButtonLocMap   = nil;
   self._starterPackMap      = nil;
   self._hintPopupMap        = nil;
   self._leagueMap           = nil;
   self._promoMap            = nil;
   self._consumableMap       = nil;

   self:_save();

end

----------------------------------------------------------------------

function AbTestMgr:_initListeners()

   self._listeners                             = {};
   self._listeners["vehicle_info_v4"]          = require("app/ab-test/listeners/ab-vehicle_info"          );
   self._listeners["reward_info"]              = require("app/ab-test/listeners/ab-reward_info"           );
   self._listeners["video_rewards_v7"]         = require("app/ab-test/listeners/ab-video_rewards"         );
   self._listeners["video_button"]             = require("app/ab-test/listeners/ab-video-button"          );
   self._listeners["iap_verification"]         = require("app/ab-test/listeners/ab-iap-verification"      );
   self._listeners["game_difficulty"]          = require("app/ab-test/listeners/ab-game_difficulty"       );
   self._listeners["gift_key_time"]            = require("app/ab-test/listeners/ab-gift_key_time"         );
   self._listeners["consumable_cost_v2"]       = require("app/ab-test/listeners/ab-consumable_cost"       );
   self._listeners["xp_level_req_k"]           = require("app/ab-test/listeners/ab-xp_level_req_k"        );
   self._listeners["thief_game_to_video_v2"]   = require("app/ab-test/listeners/ab-thief_game_to_video"   );
   self._listeners["store_gem_amount"]         = require("app/ab-test/listeners/ab-store_gem_amount"      );
   self._listeners["store_gold_amount_v2"]     = require("app/ab-test/listeners/ab-store_gold_amount"     );
   self._listeners["store_key_amount"]         = require("app/ab-test/listeners/ab-store_key_amount"      );
   self._listeners["mystery_odds_2"]           = require("app/ab-test/listeners/ab-mystery-odds"          );
   self._listeners["auto_authentication"]      = require("app/ab-test/listeners/ab-auto_authentication"   );
   self._listeners["authentication_reward"]    = require("app/ab-test/listeners/ab-authentication-reward" );
   self._listeners["boss_difficulty_v2"]       = require("app/ab-test/listeners/ab-boss-difficulty"       );
   self._listeners["feed_enabling"]            = require("app/ab-test/listeners/ab-feed_enabling"         );
   self._listeners["bounty_selection_v2"]      = require("app/ab-test/listeners/ab-bounty-selection"      );
   self._listeners["hud_target"]               = require("app/ab-test/listeners/ab-hud-target"            );
   self._listeners["revive_cost_v5"]           = require("app/ab-test/listeners/ab-revive-cost"           );
   self._listeners["game_center"]              = require("app/ab-test/listeners/ab-game-center"           );
   self._listeners["interstitial_schedule_v2"] = require("app/ab-test/listeners/ab-interstitial"          );
   self._listeners["auto_select_all_v2"]       = require("app/ab-test/listeners/ab-auto-select-all"       );
   self._listeners["rollout_cooldowns"]        = require("app/ab-test/listeners/ab-rollout-cooldowns"     );
   self._listeners["guide_info"]               = require("app/ab-test/listeners/ab-guide-info"            );
   self._listeners["notification_info"]        = require("app/ab-test/listeners/ab-notification-info"     );
   self._listeners["guest_friend"]             = require("app/ab-test/listeners/ab-guest-friend"          );
   self._listeners["drone_settings_v2"]        = require("app/ab-test/listeners/ab-drone-settings"        );
   self._listeners["drone_button_loc"]         = require("app/ab-test/listeners/ab-drone-button-loc"      );
   self._listeners["starter_pack_v3"]          = require("app/ab-test/listeners/ab-starter-pack"          );
   self._listeners["hint_popup"]               = require("app/ab-test/listeners/ab-hint-popup"            );
   self._listeners["league_structure_v3"]      = require("app/ab-test/listeners/ab-league-structure"      );
   self._listeners["promo_settings_v2"]        = require("app/ab-test/listeners/ab-promo-popups"          );
   self._listeners["native_ads_v4"]            = require("app/ab-test/listeners/ab-native-ads"            );

   --Will activate all listeners
   for k,v in pairs(self._listeners) do
      if v and v.activate and type(v.activate) == "function" then
         v:activate();
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:onSuccess( id, successId, eventOnceEnable, valueIdExtra )

   local winner = self._winners[id];

   --Dont care if we have a winner... it is over
   if winner == nil then

      local participating = self._participating[id];

      if participating then

         local pick = self._picks[id];

         if pick ~= nil then

            local flurryId = "ab-test-"..(self._flurryPicks[id] or id);
            local valueId  = pick.value;

            if valueIdExtra then
               valueId = valueId .. tostring(valueIdExtra);
            end

            successId = successId or "success";

            --first Time
            if not (pick[tostring(successId)]) then

               pick[tostring(successId)] = true;

               self:_save();

               if eventOnceEnable then
                  --Use pick.value for once to not confuse us since the event
                  -- only happens once and we want to know if the "broad" category really happened
                  MOAIFlurry:event(flurryId,    tostring(successId).."-once",  tostring(pick.value)
                                           ,    tostring(successId),           tostring(valueId) );
               else
                  MOAIFlurry:event(flurryId,    tostring(successId),           tostring(valueId) );
               end

            else

               MOAIFlurry:event(flurryId, tostring(successId), tostring(valueId) );

            end

         else
           -- Dont assert because in some case like key regen, we call a success for game play
           -- and we might not have pick an ab yet (if your key are full)
           -- Debug.assert(pick, "AbTestMgr:onSuccess-cant find pick"..tostring(id));
         end
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:resetValue( id )
    local winner  = self._winners[id];

    if winner ~= nil then
        self._winners[id] = nil;
    end
end

----------------------------------------------------------------------

function AbTestMgr:getValue( id )

   local winner  = self._winners[id];

   --If we have a winners, it overwrite everything
   if winner ~= nil then
      return winner;
   else

      if self:_checkParticipating(id) then

         local value = (self._picks[id] or {}).value;

         if value == nil then

            local choices  = self._choices[id];

            if choices then
               value = self:_pickRandom( choices );
            end

            if value ~= nil then

               Debug.assert( self._flurryPicks[id], "AbTestMgr:getValue ->self._flurryPicks[id]" );

               MOAIFlurry:event("ab-test-"..(self._flurryPicks[id] or id), "pick", tostring(value) );
               self._picks[id] = { value = value };
               self:_save();
            end

         end

         return value;

      end

   end

   return self._defaults[id];

end

----------------------------------------------------------------------

function AbTestMgr:_isTangoUser( )

   return MOAITangoSdk:tangoHasSdkSupport();

end

----------------------------------------------------------------------

function AbTestMgr:_checkParticipating( id )

   Debug.assert( self._participating,  "AbTestMgr:_checkParticipating -> self._participating" );
   Debug.assert( id,                   "AbTestMgr:_checkParticipating -> id"                  );

   local participating = (self._participating or {})[id];

   if participating == nil then

      if self._targets then

         local targets = self._targets[id];

         if targets then

            participating = false;

            for i, tgtInfo in ipairs(targets) do

               local tgt  = tgtInfo[1] or "all";
               local odds = tgtInfo[2] or 1;
               if odds > 0 and math.random() <= odds then

                  if tgt == "all" then

                     participating = true;

                  elseif tgt == "old" then

                     if (not self:_isNewUser()) then
                        participating = true;
                     end

                  elseif tgt == "old-tango" then

                     if ( not self:_isNewUser()) and (self:_isTangoUser()) then
                        participating = true;
                     end

                  elseif tgt == "old-notango" then

                     if (not self:_isNewUser()) and (not self:_isTangoUser()) then
                        participating = true;
                     end

                  elseif tgt == "newbie" or tgt == "new" then

                     if self:_isNewUser() then
                        participating = true;
                     end

                  elseif tgt == "new-english" or tgt == "newbie-english" then

                     local language = LocalizationMgr:getLanguage()

                     if self:_isNewUser() and ( language == "en" or language:find("en_", 1) ) then
                        participating = true;
                     end

                  elseif tgt == "new-noenglish" or tgt == "newbie-noenglish" then

                     local language = LocalizationMgr:getLanguage()

                     if self:_isNewUser() and ( language ~= "en" and language:find("en_", 1) == nil ) then
                        participating = true;
                     end

                  elseif tgt == "new-tango" or tgt == "newbie-tango" then

                     if self:_isNewUser() and self:_isTangoUser() then
                        participating = true;
                     end

                  elseif tgt == "new-notango" or tgt == "newbie-notango" then
                     if (self:_isNewUser()) and (not self:_isTangoUser()) then
                        participating = true;
                     end

                  elseif tgt == "english"  then

                     if  LocalizationMgr:getLanguage() == "en" then
                        participating = true;
                     end
                  end
               end
            end

            self._flurryPicks[id]   = self._flurryIds[id] or id;
            self._participating[id] = participating;

            self:_save();

         end

      else

         Debug.assert(self._targets);

      end

   end

   return participating;

end

----------------------------------------------------------------------

function AbTestMgr:_load(  )

   local tbl = loadFileMultiFormat(AB_SAVE_FILENAME_LUA, AB_SAVE_FILENAME_JSON) or {};

   self._winners        = tbl.winners        or {};
   self._defaults       = tbl.defaults       or {};
   self._flurryIds      = tbl.flurryIds      or {};
   self._participating  = tbl.participating  or {};
   self._flurryPicks    = tbl.flurryPicks    or {};
   self._picks          = tbl.picks          or {};
   self._targets        = tbl.targets        or {};
   self._choices        = tbl.choices        or {};
   self._extras         = tbl.extras         or {};

end

----------------------------------------------------------------------

function AbTestMgr:_save(  )

   local toSave         = {};

   toSave.winners       = self._winners;
   toSave.defaults      = self._defaults;
   toSave.flurryIds     = self._flurryIds;
   toSave.participating = self._participating;
   toSave.flurryPicks   = self._flurryPicks;
   toSave.picks         = self._picks;
   toSave.targets       = self._targets;
   toSave.choices       = self._choices;
   toSave.extras        = self._extras;

   saveFileMultiFormat( AB_SAVE_FILENAME_LUA, AB_SAVE_FILENAME_JSON, toSave, App:calcEncryptionKey() );

end

----------------------------------------------------------------------

function AbTestMgr:_isNewUser()

   local  firstVersionPlayed = App.data:getValue("first-version-played" );

   -- a new user is someone that started using Road Riot with the current version
   if       firstVersionPlayed
      and   App.info.versionNumber        then

      return firstVersionPlayed >= App.info.versionNumber;

   else

      Debug.assert( App.info.versionNumber,  "AbTestMgr:_checkParticipating : new -> App.info.version" );
      Debug.assert( firstVersionPlayed,      "AbTestMgr:_checkParticipating : new -> firstVersionPlayed" );

   end

end

----------------------------------------------------------------------

function AbTestMgr:_pickRandom( choices  )

   if choices then

      local pick  = nil;
      local total = 0;

      for i,choice   in ipairs(choices) do
         local value = choice[1];
         local odd   = choice[2];

         if (value  ~= nil) and ( odd ) and ( odd > 0 ) then
            total = total + odd;

            if math.random() <= math.min(odd/total,1) then

               pick = value;
            end
         end

      end

      return pick;

   end

end

----------------------------------------------------------------------

function AbTestMgr:_getReviveCostTable( )

   if not self._reviveCostMap then

      local s = self:getValue( "revive_cost_v5" );

      if s then
         local t = self:parseValueString( s );
         if type(t) == "table" then

            self._reviveCostMap = {};

            for i,v in ipairs(t) do

               self._reviveCostMap[i] = { gem = tonumber(v) };

            end

         end

      end
   end

   return self._reviveCostMap;

end

----------------------------------------------------------------------

function AbTestMgr:getReviveCost(  index  )

   if index then

      local tbl = self:_getReviveCostTable( );

      if tbl and tbl[index] then
         return tbl[index];
      end

   end

end

----------------------------------------------------------------------

function AbTestMgr:getReviveMax(    )

   local tbl = self:_getReviveCostTable( );

   if tbl  then
      return #tbl;
   end

end


----------------------------------------------------------------------

function AbTestMgr:_getGoldAmountTable( )

   if self._storeGoldMap == nil then

      local s = self:getValue( "store_gold_amount_v2" );

      if s then
         local t = self:parseValueString( s );
         if t and #t == 12 then
            self._storeGoldMap =  { { gems = tonumber(t[01]),  gold = tonumber(t[02])  },
                                    { gems = tonumber(t[03]),  gold = tonumber(t[04])  },
                                    { gems = tonumber(t[05]),  gold = tonumber(t[06])  },
                                    { gems = tonumber(t[07]),  gold = tonumber(t[08])  },
                                    { gems = tonumber(t[09]),  gold = tonumber(t[10]) },
                                    { gems = tonumber(t[11]),  gold = tonumber(t[12]) } };
         end
      end
   end


   return self._storeGoldMap;


end


----------------------------------------------------------------------

function AbTestMgr:getStoreGoldAmount( index  )

   if index then

      local tbl = self:_getGoldAmountTable( );

      if tbl and tbl[index] then
         return tbl[index].gold;
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStoreGoldCost(  index  )

   if index then

      local tbl = self:_getGoldAmountTable( );

      if tbl and tbl[index] then
         return tbl[index].gems;
      end

   end

end

----------------------------------------------------------------------

function AbTestMgr:_getThiefVideoMap( )

   if not self._thiefVideoMap then

      local s = self:getValue( "thief_game_to_video_v2" );

      if s then
         local t = self:parseValueString( s );
         if t and #t == 4  and t[1] == "before" and t[3] == "after" then
            self._thiefVideoMap =  {  before = tonumber(t[2]), after = tonumber(t[4])  };
         else
            Debug.assert(t and #t == 4  and t[1] == "before" and t[3] == "after" , "AbTestMgr:_thiefVideoMap -> " .. tostring(t[1]) .."  " .. tostring(t[3]) );
         end
      end

   end

   return self._thiefVideoMap;

end

----------------------------------------------------------------------

function AbTestMgr:getVideoThiefGameBefore()

   local tbl = self:_getThiefVideoMap( );

   if tbl then
      return tbl.before;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoThiefGameAfter()

   local tbl = self:_getThiefVideoMap();

   if tbl then
      return tbl.after;
   end

end

----------------------------------------------------------------------

function AbTestMgr:_getStoreKeyTable( )

   if not self._storeKeyMap then

      local s = self:getValue( "store_key_amount" );

      if s then
         local t = self:parseValueString( s );
         if t and #t == 12 then
            self._storeKeyMap =  {  { gems = tonumber(t[1]),  keys = tonumber(t[2])  },
                                    { gems = tonumber(t[3]),  keys = tonumber(t[4])  },
                                    { gems = tonumber(t[5]),  keys = tonumber(t[6])  },
                                    { gems = tonumber(t[7]),  keys = tonumber(t[8])  },
                                    { gems = tonumber(t[9]),  keys = tonumber(t[10]) },
                                    { gems = tonumber(t[11]), keys = tonumber(t[12]) }   };
         end
      end

   end

   return self._storeKeyMap;

end

----------------------------------------------------------------------

function AbTestMgr:getStoreKeyAmount( index  )

   if index then
      local tbl = self:_getStoreKeyTable( );

      if tbl and tbl[index] then
         return tbl[index].keys;
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStoreKeyCost(  index  )

   if index then
      local tbl = self:_getStoreKeyTable( );

      if tbl and tbl[index] then
         return tbl[index].gems;
      end

   end

end

----------------------------------------------------------------------

function AbTestMgr:getGemAmountTable( )

   if self._storeGemMap == nil then

      local s = self:getValue( "store_gem_amount" );

      if s then
         local t = self:parseValueString( s );
         if t and #t == 12 then
            self._storeGemMap =  { tonumber(t[2]),
                                   tonumber(t[4]),
                                   tonumber(t[6]),
                                   tonumber(t[8]),
                                   tonumber(t[10]),
                                   tonumber(t[12])   };
         end
      end

   end

   return self._storeGemMap;

end

----------------------------------------------------------------------

function AbTestMgr:getGhostDifficultySubmit( )

   local t = self:getBountySelectionMap();

   if t then
      return t.submit;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGhostDifficultyScoreK( )

   local t = self:getBountySelectionMap();

   if t then
      return t.scoreK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoMap( )

   if self._videoRewardsMap == nil then

      local s        = self:getValue( "video_rewards_v7" );
      local extras   = self._extras["video_rewards_v7"];

      if s  and extras then
         local extra = extras[s];

         if extra then
            local r = {};
            local tInsert = { rewardConsumable=extra.rewardConsumable, lvl=1, dl=extra.daily_limit, rt=extra.reset_time, k=extra.key, g=extra.gold, gde="first", gde_lvl=extra.guide_first };
            table.insert(r, tInsert);

            if extra.gold_increase then

               for i,v in pairs(extra.gold_increase) do

                  --i is odd
                  if not (i % 2 == 0) then

                     local guide = nil;
                     if extra.guide_increase then
                        guide = "new";
                     end
                     tInsert = { lvl=v, dl=extra.daily_limit, rt=extra.reset_time, k=extra.key, g=extra.gold_increase[i+1], gde=guide, gde_lvl=v };
                     table.insert(r, tInsert);
                  end
               end
            end

            self._videoRewardsMap = r;

         end

      end
   end

   return self._videoRewardsMap;

end

----------------------------------------------------------------------

function AbTestMgr:getVideoConsumableRewardIndex()

   local t = self:getVideoMap();

   if t and t[1] and t[1].rewardConsumable then
      return t[1].rewardConsumable;
   end

   return nil;

end

----------------------------------------------------------------------

function AbTestMgr:getVideoLvlTable( )

   local cLvl = App.data:getCurrentPlayerLevel() or 1;

   if self._videoRewardsLvlMap and  self._videoRewardsLvlMap._lvlCached ~= cLvl then
      self._videoRewardsLvlMap = nil;
   end

   if self._videoRewardsLvlMap == nil then

      local t           = self:getVideoMap();
      local savedLvl    = nil;
      local tablePick   = nil;
      if t then
         for i,v in pairs(t) do

            if v.lvl and cLvl >= v.lvl then
               if not savedLvl or v.lvl > savedLvl then
                  savedLvl = v.lvl;
                  tablePick = v;
               end
            end
         end
         self._videoRewardsLvlMap            = tablePick;
         self._videoRewardsLvlMap._lvlCached = cLvl;
      end
   end

   return self._videoRewardsLvlMap;

end

----------------------------------------------------------------------

function AbTestMgr:getVideoMapLimit( )

   local t = self:getVideoLvlTable();
   if t and t.dl then
      return t.dl;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoMapKeys( )

   local t = self:getVideoLvlTable();
   if t and t.k then
      return t.k;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoMapGold( )

   local t = self:getVideoLvlTable();
   if t and t.g then
      return t.g;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoMapGuide( )

   local t = self:getVideoLvlTable();
   if t and t.gde and t.lvl then
      return t.gde, t.gde_lvl;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoMapReset( )

   local t = self:getVideoLvlTable();
   if t and t.rt then
      return t.rt*60*60;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameDifficultyMap( )

   local s = self:getValue( "game_difficulty" );
   local t;

   if s then
      t = self:parseValueString( s );
      if t then
         if t[1]=="speedK" and t[3]=="damageK" then
            return { speedK=tonumber(t[2]), damageK=tonumber(t[4]) };
         end
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameDifficultySpeedK( )

   local t = self:getGameDifficultyMap();

   if t then
      return t.speedK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameDifficultyDamageK( )

   local t = self:getGameDifficultyMap();

   if t then
      return t.damageK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getConsumableMap( )

   if not self._consumableMap then

      local id     = self:getValue("consumable_cost_v2");
      local extras = self._extras["consumable_cost_v2"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            self._consumableMap =
            {
               enableStore          = extra.enableStore,
               consumableSettings   = extra.consumableSettings,
            };
         end
      end
   end

   return self._consumableMap;

end

----------------------------------------------------------------------

function AbTestMgr:getConsumableCost( index )

   Debug.assertType(index, "string", "AbTestMgr:getConsumableCost -> index");

   local t = self:getConsumableMap();

   if index and t and t.consumableSettings and t.consumableSettings[index] and t.consumableSettings[index].cost then
      return t.consumableSettings[index].cost;
   end

   return nil;

end

----------------------------------------------------------------------

function AbTestMgr:getConsumableDuration( index )

   Debug.assertType(index, "string", "AbTestMgr:getConsumableDuration -> index");

   local t = self:getConsumableMap();

   if index and t and t.consumableSettings and t.consumableSettings[index] and t.consumableSettings[index].duration then
      return t.consumableSettings[index].duration;
   end

   return nil;

end

----------------------------------------------------------------------

function AbTestMgr:getConsumablePowerTpl( index )

   Debug.assertType(index, "string", "AbTestMgr:getConsumablePowerTpl -> index");

   local t = self:getConsumableMap();

   if index and t and t.consumableSettings and t.consumableSettings[index] and t.consumableSettings[index].tplPowerup then
      return t.consumableSettings[index].tplPowerup;
   end

   return nil;

end

----------------------------------------------------------------------

function AbTestMgr:getConsumableQuantity( index )

   Debug.assertType(index, "string", "AbTestMgr:getConsumableQuantity -> index");

   local t = self:getConsumableMap();

   if index and t and t.consumableSettings and t.consumableSettings[index] and t.consumableSettings[index].quantity then
      return t.consumableSettings[index].quantity;
   end

   return nil;

end

----------------------------------------------------------------------

function AbTestMgr:isConsumableOnSale( index )

   Debug.assertType(index, "string", "AbTestMgr:isConsumableOnSale -> index");

   local t = self:getConsumableMap();

   if index and t and t.consumableSettings and t.consumableSettings[index] and t.consumableSettings[index].onSale then
      if t.consumableSettings[index].onSale == "enable" then
         return true;
      end
   end

   return nil;

end

----------------------------------------------------------------------

function AbTestMgr:isConsumableStoreEnabled()

   local t = self:getConsumableMap();

   if t and t.enableStore ~= nil then
      if t.enableStore == "enable" then
         return true;
      end
   end

   return false;

end

----------------------------------------------------------------------

function AbTestMgr:getVideoButtonMap( )

   if self._videoButtonMap == nil then
      local s = self:getValue( "video_button" );
      local t;
      if s then
         t = self:parseValueString( s );
         if t then

            if t[1]=="guide" and t[3]=="rollout" and t[5]=="target" then

               local r = { guide=tonumber(t[2]), rollout=tonumber(t[4]), sparkle=tonumber(t[4]), target=t[6] };

               if r.guide and r.rollout and r.sparkle and r.target then
                  self._videoButtonMap = r;
               end
            elseif t[1]=="guide" and t[3]=="rollout" and t[5]=="sparkle" and t[7]=="target" then

               local r = { guide=tonumber(t[2]), rollout=tonumber(t[4]), sparkle=tonumber(t[6]), target=t[8] };

               if r.guide and r.rollout and r.sparkle and r.target then
                  self._videoButtonMap = r;
               end

            end
         end
      end
   end

   return self._videoButtonMap;


end


----------------------------------------------------------------------

function AbTestMgr:getVideoButtonGuideLvl( )

   local t = self:getVideoButtonMap();
   if t then
      return t.guide;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoButtonTarget( )

   local t = self:getVideoButtonMap();
   if t then
      return t.target;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoButtonRollout( )

   local t = self:getVideoButtonMap();
   if t then
      return t.rollout;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoButtonSparkle( )

   local t = self:getVideoButtonMap();
   if t then
      return t.sparkle;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVideoButtonEnabled( )

   local t = self:getVideoButtonMap();
   if t then
      return true;
   else
      return false;
   end

end


----------------------------------------------------------------------

function AbTestMgr:getMysteryOddsTable( )

   local s = self:getValue( "mystery_odds_2" );
   local t;
   if s then
      t = self:parseValueString( s );
      if t then
         local odds = {};
         --joe: the gem cost needs to be tied to the chance table. last entry in the ab test is the cost.
         for i=1,(#t-1) do
            odds[i] = tonumber(t[i]);
         end
         return odds;
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:getMysteryGemCost( )

   local s = self:getValue( "mystery_odds_2" );
   local t;
   if s then
      t = self:parseValueString( s );
      if t then
         return tonumber(t[#t]);
      end
   end

end


----------------------------------------------------------------

function AbTestMgr:parseValueString( s )

   if s and type(s) == "string" then

      local len = string.len(s);
      local t = {};
      local sIndex = 1;
      local eIndex = 1;

      if len then
         for i=1,len do
            if eIndex >= len then
               if #t > 0 then
                  return t;
               else
                  return nil
               end
            else
               if s then
                  local sI,eI = string.find(s, "_", sIndex);
                  if sI and eI then
                     eIndex = eI-1;
                     local insString = string.sub(s, sIndex, eIndex);
                     sIndex = eI+1;
                     if insString then
                        table.insert(t, insString);
                     end
                  else
                     local insString = string.sub(s, sIndex, len);
                     if insString then
                        table.insert(t, insString);
                        return t;
                     end
                  end
               end
            end
         end
      end

   end


end

----------------------------------------------------------------------

function AbTestMgr:createKVTable( t )

   local rt = {};

   for i=1,#t do

      if self:isOdd(i) and t[i+1] then
         local k = t[i];
         local v = t[i+1];
         if rt[k] then
            --add this to the existing table
         else
            --create a new entry named k
            rt[k] = v;
         end
      end

   end

   for h,j in pairs(rt) do print(h,j) end
   return rt;


end

----------------------------------------------------------------------

function AbTestMgr:isOdd( i )

   if (i % 2 == 0) then
       return false;
   else
      return true;
   end

end


----------------------------------------------------------------------

function AbTestMgr:getFeedEnablingMap( )

   local s = self:getValue( "feed_enabling" );

   if s then
      local t = self:parseValueString( s );
      if t then
         if t[1]=="default" and t[3]=="guide" then
            return { default=string.lower(t[2])=="true", guide=tonumber(t[4]) };
         end
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:getFeedEnablingDefault( )

   local t = self:getFeedEnablingMap();

   if t then
      return t.default;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getFeedEnablingGuide( )

   local t = self:getFeedEnablingMap();

   if t then
      return t.guide;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getVehicleInfoTableMap( )

   if not self._vehicleInfoTableMap then

      local id       = self:getValue( "vehicle_info_v4" );
      local extras   = self._extras["vehicle_info_v4"];

      if id and extras then
         local extra = extras[id];
         if extra then
            self._vehicleInfoTableMap = extra;
         end
      end

   end

   return self._vehicleInfoTableMap;

end

function AbTestMgr:getVehicleInfoTable(id)

   local map = self:getVehicleInfoTableMap() or {};

   return map[id];

end


----------------------------------------------------------------------

function AbTestMgr:getRewardInfoTableMap( )

   if not self._rewardInfoTableMap then

      local id       = self:getValue( "reward_info" );

      local extras   = self._extras["reward_info"];
      if id and extras then
         local extra = extras[id];
         if extra then
            self._rewardInfoTableMap = extra;
         end
      end

   end

   return self._rewardInfoTableMap;

end

----------------------------------------------------------------------

function AbTestMgr:getRewardInfoTable(id)

   local map = self:getRewardInfoTableMap() or {};

   return map[id];

end

----------------------------------------------------------------------

function AbTestMgr:_calcBossDifficultyMap( )

   local s = self:getValue( "boss_difficulty_v2" );

   if s then

      local t = self:parseValueString( s );

      if t then

         local r = {};

         Debug.assert( t[1]  == "encounterRate"  );

         r["encounterRate"]	= tonumber(t[2]);
         r["healthK"]			= {tonumber(t[4])/100, tonumber(t[8])/100};
         r["damageK"]			= {tonumber(t[6])/100, tonumber(t[10])/100};
         r["mysteryDropRate"]	= {tonumber(t[12]), tonumber(t[14])};

         return r;
      end
   end

end

----------------------------------------------------------------------

function AbTestMgr:getBossDifficultyMap( )

   if not self._bossDifficultyMap then
      self._bossDifficultyMap = self:_calcBossDifficultyMap();
   end

   return self._bossDifficultyMap;

end

----------------------------------------------------------------------

function AbTestMgr:getBossDamageScale( index )

	local map	= self:getBossDifficultyMap();
	local i		= index or 1;
	local t		= type(map["damageK"]);

	if t == "table" then
		return map["damageK"][i];
	elseif t == "number" then
		return map["damageK"];
	end

end

----------------------------------------------------------------------

function AbTestMgr:getBossHealthScale( index )

	local map	= self:getBossDifficultyMap();
	local i		= index or 1;
	local t		= type(map["healthK"]);

	if t == "table" then
		return map["healthK"][i];
	elseif t == "number" then
		return map["healthK"];
	end

end

----------------------------------------------------------------------

function AbTestMgr:getBossEncounterRate()

	local map = self:getBossDifficultyMap();

	return map["encounterRate"];

end

----------------------------------------------------------------------

function AbTestMgr:getBossMysteryDropRate()

	local map = self:getBossDifficultyMap();

	return map["mysteryDropRate"];

end

----------------------------------------------------------------------

function AbTestMgr:getBountySelectionMap( )

	if not self._bountySelectionMap then

		local s = self:getValue( "bounty_selection_v2" );

		if s then
			local t = self:parseValueString( s );
			if t then
				if t[1]=="cap" and t[3]=="reward" and t[5]=="penZeroScore" and t[7]=="penPrevScoreK" and t[9]=="penGhostK" and t[11]=="penPursuitK" and t[13]=="submit" and t[15]=="scoreK" then
					self._bountySelectionMap =
               {
                  bountyCap=tonumber(t[2]),
                  reward={ gem=tonumber(t[4])},
                  penZeroScore=tonumber(t[6]),
                  penPScoreK=tonumber(t[8])/100,
                  penGhostK=tonumber(t[10])/100,
                  penPursuitK=tonumber(t[12])/100,
                  submit=t[14],
                  scoreK=tonumber(t[16])/100 };
				end
			end
		end
	end

	return self._bountySelectionMap;

end

----------------------------------------------------------------------

function AbTestMgr:getBountyCap()

   local t = self:getBountySelectionMap();

   if t then

      if LeagueMgr:isLeagueEnabled() then
         if App.data:isLeagueUnlocked() then
            return t.bountyCap;
         else
            return 3;  --return the number of ghosts
         end
      end

		return t.bountyCap;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getBountyReward()

   local t = self:getBountySelectionMap();

   if t then
      return t.reward;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getBountyZeroScorePenalty()

   local t = self:getBountySelectionMap();

   if t then
      return t.penZeroScore;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getBountyPrevScorePenaltyScale()

   local t = self:getBountySelectionMap();

   if t then
      return t.penPScoreK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getBountyGhostPenaltyScale()

   local t = self:getBountySelectionMap();

   if t then
      return t.penGhostK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getBountyPursuitPenaltyScale()

   local t = self:getBountySelectionMap();

   if t then
      return t.penPursuitK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getHUDTargetMap()

	if not self._hudTargetMap then

		local s = self:getValue( "hud_target" );

		if s then
			local t = self:parseValueString( s );
			if t then
				if t[1]=="selection" then
					self._hudTargetMap = { selection=t[2] };
				end
			end
		end
	end

	return self._hudTargetMap;

end

----------------------------------------------------------------------

function AbTestMgr:getHUDTargetSelectionGroup()

	local t = self:getHUDTargetMap();

	if t then
		return t.selection;
	end

end

----------------------------------------------------------------------

function AbTestMgr:getVehicleCostSales()

--TODO : FIXME
--[[
   local t = self:getVehicleInfoTableMap();

   if t and t.sales then

      local curTime = TimeMgr:getTimeGMT() or 0;
      if curTime and curTime > 0 then

         local r = {};
         for i,v in ipairs( t.sales ) do

            local sTime = TimeMgr:convertWebDateToTimeGMT( v.from );
            local eTime = TimeMgr:convertWebDateToTimeGMT( v.to );

            if sTime and eTime and sTime <= eTime then

               if curTime >= sTime and curTime <= eTime then
                  local tbl	= self:copyTable(v);

                  tbl.from		= sTime;
                  tbl.to		= eTime;
                  table.insert(r, tbl);
               end
            else
               Debug.assert("AbTestMgr:getVehicleCostSales -> start date is later than end date");
            end
         end

         if #r > 0 then
            return r
         end
      end
   end
]]
end

----------------------------------------------------------------------

function AbTestMgr:getAuthenticationRewardMap( )

	if not self._authenRewardMap then

		local s = self:getValue( "authentication_reward" );

		if s then
			local t = self:parseValueString( s );
			if t then
				self._authenRewardMap = {};

				if t[1]=="tangoInstalled" and t[3]=="notInstalled" then
					self._authenRewardMap["tangoInstalled"]	= tonumber(t[2]);
					self._authenRewardMap["notInstalled"]		= tonumber(t[4]);
				end
			end
		end
	end

	return self._authenRewardMap;

end

----------------------------------------------------------------------

function AbTestMgr:getAuthenticationRewardTangoInstalled( )

	local t = self:getAuthenticationRewardMap();

	if t then
		return t.tangoInstalled;
	end

end

----------------------------------------------------------------------

function AbTestMgr:getAuthenticationRewardTangoNotInstalled( )

	local t = self:getAuthenticationRewardMap();

	if t then
		return t.notInstalled;
	end

end

----------------------------------------------------------------------

function AbTestMgr:getGameCenterMap( )

   if MOAIGameCenterIOS and (not self._gameCenterMap) then

      local id       = self:getValue( "game_center" );
      local extras   = self._extras["game_center"];

      if id and extras then

         local extra = extras[id];

         if type(extra) == "table" then
            self._gameCenterMap = {};
            self._gameCenterMap.enabled               = extra.enabled;
            self._gameCenterMap.guide                 = extra.guide;
            self._gameCenterMap.submit_leaderboard_id = extra.submit_leaderboard_id;
            self._gameCenterMap.show_leaderboard_id   = extra.show_leaderboard_id;

            if type(extra.gc_ui_time_scope) == "string" then
               if string.lower(extra.gc_ui_time_scope) == "today" then
                  self._gameCenterMap.gc_ui_time_scope = MOAIGameCenterIOS.TIME_SCOPE_TODAY;
               elseif string.lower(extra.gc_ui_time_scope) == "week" then
                  self._gameCenterMap.gc_ui_time_scope = MOAIGameCenterIOS.TIME_SCOPE_WEEK;
               else
                  self._gameCenterMap.gc_ui_time_scope = MOAIGameCenterIOS.TIME_SCOPE_ALL_TIME;
               end
            end
         end

      end
   end

   return self._gameCenterMap;

end

----------------------------------------------------------------------

function AbTestMgr:isGameCenterEnabled()

   local t = self:getGameCenterMap();

   if t then
      return t.enabled;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameCenterGuide()

   local t = self:getGameCenterMap();

   if t then
      return t.guide;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameCenterGcUiTimeScope()

   local t = self:getGameCenterMap();

   if t then
      return t.gc_ui_time_scope;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameCenterSubmitLeaderboardId()

   local t = self:getGameCenterMap();

   if t then
      return t.submit_leaderboard_id;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGameCenterShowLeaderboardId()

   local t = self:getGameCenterMap();

   if t then
      return t.show_leaderboard_id;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getInterstitialExtra()

   if not self._interstitialMap then

      local id       = self:getValue( "interstitial_schedule_v2" );
      local extras   = self._extras["interstitial_schedule_v2"];

      if id and extras then
         return extras[id];
      end

   end

   return self._interstitialMap;

end

----------------------------------------------------------------------

function AbTestMgr:getAutoSelectAllMap( )

	if not self._autoSelectAllMap then

      local id       = self:getValue( "auto_select_all_v2" );
      local extras   = self._extras["auto_select_all_v2"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._autoSelectAllMap then
               self._autoSelectAllMap				= {};
            end

				if extra.autoBrag ~= nil then
					self._autoSelectAllMap.autoBrag		= extra.autoBrag;
				end

				if extra.autoInvite ~= nil then
					self._autoSelectAllMap.autoInvite	= extra.autoInvite;
				end
         end
      end
   end

	return self._autoSelectAllMap;

end

----------------------------------------------------------------------

function AbTestMgr:getBragAutoSelectAll( )

   local t = self:getAutoSelectAllMap();

   if t then
		return t.autoBrag;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getInviteAutoSelectAll( )

   local t = self:getAutoSelectAllMap();

   if t then
		return t.autoInvite;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getRolloutMap()

   if not self._rolloutMap then

      local id       = self:getValue( "rollout_cooldowns" );
      local extras   = self._extras["rollout_cooldowns"];

      if id and extras then

         local extra = extras[id];

         if type(extra) == "table" then

            if not self._rolloutMap then
               self._rolloutMap = {};
            end
            if extra.default_games and extra.default_time then
               self._rolloutMap["default"]         = {};
               self._rolloutMap["default"].games   = extra.default_games;
               self._rolloutMap["default"].time    = extra.default_time;
            end
            if extra.daily_games or extra.daily_time then
               self._rolloutMap["daily"]        = {};
               self._rolloutMap["daily"].games  = extra.daily_games;
               self._rolloutMap["daily"].time   = extra.daily_time;
            end
            if extra.mission_games or extra.mission_time then
               self._rolloutMap["mission"]         = {};
               self._rolloutMap["mission"].games   = extra.mission_games;
               self._rolloutMap["mission"].time    = extra.mission_time;
            end
            if extra.achv_games or extra.achv_time then
               self._rolloutMap["achv"]         = {};
               self._rolloutMap["achv"].games   = extra.achv_games;
               self._rolloutMap["achv"].time    = extra.achv_time;
            end
            if extra.mystery_games or extra.mystery_time then
               self._rolloutMap["mystery"]         = {};
               self._rolloutMap["mystery"].games   = extra.mystery_games;
               self._rolloutMap["mystery"].time    = extra.mystery_time;
            end
            if extra.video_games or extra.video_time then
               self._rolloutMap["video"]           = {};
               self._rolloutMap["video"].games     = extra.video_games;
               self._rolloutMap["video"].time      = extra.video_time;
            end
         end

      end
   end

   return self._rolloutMap;

end

----------------------------------------------------------------------

function AbTestMgr:getRolloutGames( button )

   local t = self:getRolloutMap();
   local games = nil;
   if t and t[button] then
      games = t[button].games;
   elseif t and t["default"] then
      games = t["default"].games;
   end

   return games;

end

----------------------------------------------------------------------

function AbTestMgr:getRolloutTime( button )

   local t = self:getRolloutMap();
   local time = nil;
   if t and t[button] then
      time = t[button].time;
   elseif t and t["default"] then
      time = t["default"].time;
   end

   return time;

end

----------------------------------------------------------------------

function AbTestMgr:getGuideMap()

   if not self._guideMap then

      local id       = self:getValue( "guide_info" );
      local extras   = self._extras["guide_info"];

      if id and extras then

         local extra = extras[id];

         if type(extra) == "table" then

            if not self._guideMap then
               self._guideMap = {};
            end
            if extra.guideInfo then
               self._guideMap["guideInfo"] = extra.guideInfo;
            end

         end

      end
   end

   return self._guideMap;

end

----------------------------------------------------------------------

function AbTestMgr:getGuideInfo()

   local map = self:getGuideMap();
   if map and map.guideInfo then
      return map.guideInfo;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getNotificationMap()

   if not self._notificationMap then

      local id       = self:getValue( "notification_info" );
      local extras   = self._extras["notification_info"];

      if id and extras then

         local extra = extras[id];

         if type(extra) == "table" then

            if extra then
               self._notificationMap = extra;
            end

         end

      end
   end

   return self._notificationMap;

end

----------------------------------------------------------------------

function AbTestMgr:getNotificationInfo()

   local map = self:getNotificationMap();
   if map then
      return map;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendMap( )

	if not self._guestFriendMap then

      local id       = self:getValue( "guest_friend" );
      local extras   = self._extras["guest_friend"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._guestFriendMap then
               self._guestFriendMap = {};
            end

				if extra.enable ~= nil then
					self._guestFriendMap.enable = extra.enable;
				end

				if extra.unlockLevel ~= nil then
					self._guestFriendMap.unlockLevel = extra.unlockLevel;
				end

				if extra.tangoOn ~= nil then
					self._guestFriendMap.tangoOn = extra.tangoOn;
				end

				if extra.pickCount ~= nil then
					self._guestFriendMap.pickCount = extra.pickCount;
				end

				if extra.cycleCount ~= nil then
					self._guestFriendMap.cycleCount = extra.cycleCount;
				end

				if extra.initUpdateK ~= nil then
					self._guestFriendMap.initUpdateK = extra.initUpdateK;
				end

				if extra.initScoreK ~= nil then
					self._guestFriendMap.initScoreK = extra.initScoreK;
				end

				if extra.scoreUpdateK ~= nil then
					self._guestFriendMap.scoreUpdateK = extra.scoreUpdateK;
				end

				if extra.scoreRangeK ~= nil then
					self._guestFriendMap.scoreRangeK = extra.scoreRangeK;
				end

				if extra.giftUpdateK ~= nil then
					self._guestFriendMap.giftUpdateK = extra.giftUpdateK;
				end

				if extra.giftRepayK ~= nil then
					self._guestFriendMap.giftRepayK = extra.giftRepayK;
				end

				if extra.levelUpdateK ~= nil then
					self._guestFriendMap.levelUpdateK = extra.levelUpdateK;
				end

				if extra.levelRangeK ~= nil then
					self._guestFriendMap.levelRangeK = extra.levelRangeK;
				end

				if extra.rankPageOffset ~= nil then
					self._guestFriendMap.rankPageOffset = extra.rankPageOffset;
				end

				if extra.scoreOldK ~= nil then
					self._guestFriendMap.scoreOldK = extra.scoreOldK;
				end

				if extra.scoreNewK ~= nil then
					self._guestFriendMap.scoreNewK = extra.scoreNewK;
				end

				if extra.weeklyScoreCapK ~= nil then
					self._guestFriendMap.weeklyScoreCapK = extra.weeklyScoreCapK;
				end
         end
      end
   end

   return self._guestFriendMap;

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendEnable()

   local t = self:getGuestFriendMap();

   if t then
		return t.enable;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendUnlockLevel()

   local t = self:getGuestFriendMap();

   if t then
		return t.unlockLevel;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendTangoOn( )

   local t = self:getGuestFriendMap();

   if t then
		return t.tangoOn;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendMax( )

   local t = self:getGuestFriendMap();

   if t then
		return t.pickCount;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendCycle( )

   local t = self:getGuestFriendMap();

   if t then
		return t.cycleCount;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendInitUpdateK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.initUpdateK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendInitScoreK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.initScoreK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendScoreUpdateK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.scoreUpdateK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendScoreRangeK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.scoreRangeK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendScoreIncrementK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.scoreIncK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendGiftUpdateK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.giftUpdateK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendGiftRepayK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.giftRepayK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendLevelUpdateK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.levelUpdateK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendLevelRangeK( )

   local t = self:getGuestFriendMap();

   if t then
		return t.levelRangeK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendRankPageOffset()

   local t = self:getGuestFriendMap();

   if t then
		return t.rankPageOffset;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendOldScoreK()

   local t = self:getGuestFriendMap();

   if t then
		return t.scoreOldK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendNewScoreK()

   local t = self:getGuestFriendMap();

   if t then
		return t.scoreNewK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getGuestFriendWeeklyScoreCapK()

   local t = self:getGuestFriendMap();

   if t then
		return t.weeklyScoreCapK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getNotificationMap()

   if not self._notificationMap then

      local id       = self:getValue( "notification_info" );
      local extras   = self._extras["notification_info"];

      if id and extras then

         local extra = extras[id];

         if type(extra) == "table" then

            if extra then
               self._notificationMap = extra;
            end

         end

      end
   end

   return self._notificationMap;

end

----------------------------------------------------------------------

function AbTestMgr:getLeagueMap()

	if not self._leagueMap then

      local id       = self:getValue( "league_structure_v3" );
      local extras   = self._extras["league_structure_v3"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._leagueMap then
               self._leagueMap = {};
            end

				if extra ~= nil then
					self._leagueMap.structure = extra;
				end
			end
      end
   end

   return self._leagueMap;

end

----------------------------------------------------------------------

function AbTestMgr:getLeagueStructure()

	local t = self:getLeagueMap();

	if t then
		return t.structure;
	end

end

----------------------------------------------------------------

function AbTestMgr:copyTable( t )

   if t then
      local u = { }
      for k, v in pairs(t) do u[k] = v end

      return setmetatable(u, getmetatable(t))
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneSettingsMap( )

   if not self._droneSettingsMap then

      local id     = self:getValue( "drone_settings_v2" );
      local extras = self._extras["drone_settings_v2"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._droneSettingsMap then
               self._droneSettingsMap = {};
            end

            if extra.enable ~= nil then
               self._droneSettingsMap.enable = extra.enable;
            end

            if extra.droneMinLevel ~= nil then
               self._droneSettingsMap.droneMinLevel = extra.droneMinLevel;
            end

            if extra.droneDupeResolve ~= nil then
               self._droneSettingsMap.droneDupeResolve = extra.droneDupeResolve;
            end

            if extra.droneMountUnlockCost ~= nil then
               self._droneSettingsMap.droneMountUnlockCost = extra.droneMountUnlockCost;
            end

            if extra.droneBuildCost ~= nil then
               self._droneSettingsMap.droneBuildCost = extra.droneBuildCost;
            end

            if extra.droneUpgradeCost ~= nil then
               self._droneSettingsMap.droneUpgradeCost = extra.droneUpgradeCost;
            end

            if extra.droneEvolveCost ~= nil then
               self._droneSettingsMap.droneEvolveCost = extra.droneEvolveCost;
            end

            if extra.droneAbilityOdds ~= nil then
               self._droneSettingsMap.droneAbilityOdds = extra.droneAbilityOdds;
            end

            if extra.droneAbilityOddsK ~= nil then
               self._droneSettingsMap.droneAbilityOddsK = extra.droneAbilityOddsK;
            end

            if extra.droneBuildOrder ~= nil then
               self._droneSettingsMap.droneBuildOrder = extra.droneBuildOrder;
            end

            if extra.droneRarityOdds ~= nil then
               self._droneSettingsMap.droneRarityOdds = extra.droneRarityOdds;
            end
         end
      end
   end

   return self._droneSettingsMap;

end

----------------------------------------------------------------------

function AbTestMgr:getDroneEnabled()

   local t = self:getDroneSettingsMap();

   if t then
		return t.enable;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneMinLevel()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneMinLevel;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneDupeResolve()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneDupeResolve;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneFinishCost()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneBuildFinishCost;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneMountCost()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneMountUnlockCost;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneBuildCost()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneBuildCost;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneUpgradeCost()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneUpgradeCost;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneEvolveCost()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneEvolveCost;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneAbilityOdds()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneAbilityOdds;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneAbilityOddsK()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneAbilityOddsK;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneBuildOrder()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneBuildOrder;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneRarityOdds()

   local t = self:getDroneSettingsMap();

   if t then
		return t.droneRarityOdds;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getDroneButtonLocMap( )

	if not self._droneButtonLocMap then

      local id       = self:getValue( "drone_button_loc" );
      local extras   = self._extras["drone_button_loc"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._droneButtonLocMap then
               self._droneButtonLocMap = {};
            end

				if extra.rankingScreen ~= nil then
					self._droneButtonLocMap.rankingScreen = extra.rankingScreen;
				end
         end
      end
   end

   return self._droneButtonLocMap;

end

----------------------------------------------------------------------

function AbTestMgr:isDroneButtonLocOnRanking()

   local t = self:getDroneButtonLocMap();

   if t then
		return t.rankingScreen;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStarterPackMap( )

   if not self._starterPackMap then

      local id       = self:getValue( "starter_pack_v3" );
      local extras   = self._extras["starter_pack_v3"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._starterPackMap then
               self._starterPackMap = {};
            end

            if extra.enable ~= nil then
               self._starterPackMap.enable = extra.enable;
            end

            if extra.level ~= nil then
               self._starterPackMap.level = extra.level;
            end

            if extra.games ~= nil then
               self._starterPackMap.games = extra.games;
            end

            if extra.amount ~= nil then
               self._starterPackMap.amount = extra.amount;
            end

            if extra.cost ~= nil then
               self._starterPackMap.cost = extra.cost;
            end
         end
      end
   end

   return self._starterPackMap;

end

----------------------------------------------------------------------

function AbTestMgr:isStarterPackEnabled()

   local t = self:getStarterPackMap();

   if t ~= nil then
      return t.enable;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStarterPackLevel()

   local t = self:getStarterPackMap();

   if t then
      return t.level;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStarterPackGamesBeforeRepeat()

   local t = self:getStarterPackMap();

   if t then
      return t.games;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStarterPackAmount()

   local t = self:getStarterPackMap();

   if t then
      return t.amount;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getStarterPackCost()

   local t = self:getStarterPackMap();

   if t then
      return t.cost;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getHintPopupMap( )

	if not self._hintPopupMap then

      local id       = self:getValue( "hint_popup" );
      local extras   = self._extras["hint_popup"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._hintPopupMap then
               self._hintPopupMap = {};
            end

				if extra.enable ~= nil then
					self._hintPopupMap.enable = extra.enable;
				end
         end
      end
   end

   return self._hintPopupMap;

end

----------------------------------------------------------------------

function AbTestMgr:isHintPopupEnabled()

   local t = self:getHintPopupMap();

   if t ~= nil then
		return t.enable;
   end

	return App.data:getValue("App.settings.hint-screen", false);

end

----------------------------------------------------------------------

function AbTestMgr:getPromoMap( )

	if not self._promoMap then

      local id       = self:getValue( "promo_settings_v2" );
      local extras   = self._extras["promo_settings_v2"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            if not self._promoMap then
               self._promoMap = {};
            end

				if extra.settings ~= nil then
					self._promoMap.settings = extra.settings;
				end
         end
      end
   end

   return self._promoMap.settings or {};

end

----------------------------------------------------------------------

function AbTestMgr:isPromoEnabled( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].enable ~= nil then
      return t[name].enable;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoOdds( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].odds ~= nil then
      return t[name].odds;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoTango( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].tango ~= nil then
      return t[name].tango;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoOnline( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].online ~= nil then
      return t[name].online;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoUpToDate( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].upToDate ~= nil then
      return t[name].upToDate;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoMinLevel( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].minLevel ~= nil then
      return t[name].minLevel;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoMaxLevel( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].maxLevel ~= nil then
      return t[name].maxLevel;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getPromoSchedule( name )

   local t = self:getPromoMap();

   if name == nil or type(name) ~= "string" then
      return;
   end

   if t ~= nil and t[name] and t[name].schedule ~= nil then
      return t[name].schedule;
   end

end

----------------------------------------------------------------------

function AbTestMgr:getNativeAdsMap()

   if not self._nativeAdSettingsMap then

      local id     = self:getValue("native_ads_v4");
      local extras = self._extras["native_ads_v4"];

      if id and extras then

         local extra = extras[id] or extras.default;

         if type(extra) == "table" then

            self._nativeAdSettingsMap = {

               enable = extra.enable,
               enableForSpenders = extra.enableForSpenders,
               adSpacing = extra.adSpacing,
               useExternalBrowser = extra.useExternalBrowser,
            };

         end
      end
   end

   return self._nativeAdSettingsMap;
end


function AbTestMgr:getNativeAdsEnabled()

   local t = self:getNativeAdsMap();

   if t then
      return t.enable;
   end
end


function AbTestMgr:getNativeAdsEnabledForSpenders()

   local t = self:getNativeAdsMap();

   if t then
      return t.enableForSpenders;
   end
end


function AbTestMgr:getDesiredAdSpacing()

   local t = self:getNativeAdsMap();

   if t then
      return t.adSpacing;
   end
end


function AbTestMgr:shouldAdsUseExternalBrowser()

   local t = self:getNativeAdsMap();

   if t then
      return t.useExternalBrowser;
   end
end
