----------------------------------------------------------------------

local AB_TEST_NAME   = "auto_authentication";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onAuthentication,   "will-authenticate"           );
   EventMgr:addListener( self, self._onTangoPopup,       "tango-request-popup"         );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event  then

      local loop = 1;

      if event.id and AbTestMgr.IAP_LOOP_ID then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop" );
      end

   end
end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   --Ok to let thief send data
   if event then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play", true );

      if LoginMgr:isTango() then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play-tango", true );
      end

   end

end

----------------------------------------------------------------------

function listener:_onAuthentication( event )

   --Ok to let thief send data
   if event then
      AbTestMgr:onSuccess( AB_TEST_NAME, "authenticate-attempt", true );
   end

end

----------------------------------------------------------------------

--Use an event for when the popup shows

function listener:_onTangoPopup( event )

   --Ok to let thief send data
   if event then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "tango-request-popup", true );
   end

end

----------------------------------------------------------------------

return listener;

