----------------------------------------------------------------------

local AB_TEST_NAME   = "boss_difficulty_v2";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onVideoGold,        "video-gold"                  );
   EventMgr:addListener( self, self._onBuyGold,          "gold-bought"                 );
	EventMgr:addListener( self, self._onRevive,           "revive-used"                 );
   EventMgr:addListener( self, self._onUpgdadeSuccess,   "upgrade-success"             );
   EventMgr:addListener( self, self._onBossKill,         "boss-kill"                   );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event  then

      local loop = 1;

      if event.id and AbTestMgr.IAP_LOOP_ID then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
      end

   end

end


----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if ( not App.data:isThief() ) then
      if App.data:isBossUnlocked() then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play-boss", true);
      end
   end

end

----------------------------------------------------------------------

function listener:_onBuyGold( event )

   Debug.assert( event );

   if App.data:isBossUnlocked() then
      if ( not App.data:isThief() ) then
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-gold" );
      end
   end
end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   Debug.assert( event );

   if App.data:isBossUnlocked() then
      if ( not App.data:isThief() ) then
         AbTestMgr:onSuccess( AB_TEST_NAME, "video" );
      end
   end

end

----------------------------------------------------------------------

function listener:_onRevive( event )

   if App.data:isBossUnlocked() then
      if ( not App.data:isThief() ) then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "revive" );
      end
   end

end

----------------------------------------------------------------------

function listener:_onUpgdadeSuccess( event )

   if App.data:isBossUnlocked() then
      if ( not App.data:isThief() ) then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "upgrade"   );
      end
   end

end


----------------------------------------------------------------------

function listener:_onBossKill( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "boss-kill"   );
   end

end

----------------------------------------------------------------------

return listener;

