----------------------------------------------------------------------

local AB_TEST_NAME   = "drone_button_loc";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

	--MQL: disable a/b
   --EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );

   --EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   --EventMgr:addListener( self, self._onVideo,            "video-gold"                  );
   --EventMgr:addListener( self, self._onVideo,            "video-key"                   );
   --EventMgr:addListener( self, self._onUpgdadeSuccess,   "upgrade-success"             );
   --EventMgr:addListener( self, self._onWeeklyReward,     "weekly-reward"               );
   --EventMgr:addListener( self, self._onLogin,            "login-success"               );
   --EventMgr:addListener( self, self._onRevive,           "revive-used"                 );
   --EventMgr:addListener( self, self._onConsumableUsed,   "consumable-used"             );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event.id and AbTestMgr.IAP_LOOP_ID then
      loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
   end

   for i=1,loop do
      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
   end

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

   end

end

----------------------------------------------------------------------

function listener:_onVideo( event )

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess( AB_TEST_NAME, "video" );

   end

end

----------------------------------------------------------------------

function listener:_onUpgdadeSuccess( event )

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "upgrade"   );

   end

end

----------------------------------------------------------------------

function listener:_onWeeklyReward( event )

   if ( not App.data:isThief() ) then

      if event and event.rank and event.rank < 4 then
         AbTestMgr:onSuccess( AB_TEST_NAME, "weekly-reward" );
         AbTestMgr:onSuccess( AB_TEST_NAME, "weekly-reward-detail", false, " : rank = " .. event.rank .. " active weeks = " .. event.weeksActive );
      end
   end

end

----------------------------------------------------------------------

function listener:_onLogin( event )

   if event and ( not App.data:isThief() ) then

      if event.tango and event.tangoLoginCount == 1 then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "Login-Tango-Authenticate-once"  );
      end

   end

end

----------------------------------------------------------------------

function listener:_onRevive( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "consumable-revive", false, " : revive" );
   end

end

----------------------------------------------------------------------

function listener:_onConsumableUsed( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "consumable-revive", false, " : " .. tostring(event.type) );
   end

end

----------------------------------------------------------------------

return listener;

