----------------------------------------------------------------------

local AB_TEST_NAME   = "feed_enabling";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onFeedPosted,       "feed-post-success"           );
   EventMgr:addListener( self, self._onFriendPlaying,    "friend-playing-count"        );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if       App.data:getValue("iap-fake", 0 ) == 0
      and   FeedMgr:isEnable()                     then

      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true );

   end

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if     App.data:getValue("iap-fake", 0 ) == 0
      and FeedMgr:isEnable()                          then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

      if event.count == 100 then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play-100" );
      end

   end

end

----------------------------------------------------------------------

function listener:_onFeedPosted( event )

   if       App.data:getValue("iap-fake", 0 ) == 0
      and   FeedMgr:isEnable()                        then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "FeedPosted", true   );

      if event.count == 25 then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "FeedPosted-25"   );
      end

   end

end

----------------------------------------------------------------------

function listener:_onFriendPlaying( event )

   if       App.data:getValue("iap-fake", 0 ) == 0
      and   FeedMgr:isEnable()                        then

      if type(event.previous) == "number" and  type(event.playing) then

         --To avoid some kind of bug which could mess our data
         -- or sending too much data to Flurry limit to 5
         local diff = math.min(event.playing - event.previous,5);

         for i=1, diff do
            AbTestMgr:onSuccess(  AB_TEST_NAME, "NewFriend", true   );
         end
      end

   end
end
----------------------------------------------------------------------

return listener;

