----------------------------------------------------------------------

local AB_TEST_NAME   = "game_difficulty";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onVideoGold,        "video-gold"                  );
   EventMgr:addListener( self, self._onVideoKey,         "video-key"                   );
   EventMgr:addListener( self, self._onUpgdadeSuccess,   "upgrade-success"             );


end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true );

end


----------------------------------------------------------------------

function listener:_onGamePlay( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "video",        true);

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video",        true   );

end

----------------------------------------------------------------------

function listener:_onUpgdadeSuccess( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "upgrade"   );

end
----------------------------------------------------------------------

return listener;

