----------------------------------------------------------------------

local AB_TEST_NAME   = "gift_key_time";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,   "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,      "game-start"                  );
   EventMgr:addListener( self, self._onVideoKey,      "video-key"                   );
   EventMgr:addListener( self, self._onBuySuccess,    "buy-success"                 );
   EventMgr:addListener( self, self._onGiftSent,      "gift-sent"                   );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified" );

end


----------------------------------------------------------------------

function listener:_onGamePlay( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video-key"            );

end

----------------------------------------------------------------------

function listener:_onBuySuccess( event )

   if event.item == "key" then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "buy-key"            );
   end

end

----------------------------------------------------------------------

function listener:_onGiftSent( event )

   if event.item == "key" then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "gift-key" );
   end

end

----------------------------------------------------------------------

return listener;

