----------------------------------------------------------------------

local AB_TEST_NAME   = "hud_target";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()
--[[
EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
EventMgr:addListener( self, self._onVideoGold,        "video-gold"                  );
EventMgr:addListener( self, self._onVideoKey,         "video-key"                   );
EventMgr:addListener( self, self._onConsumableUsed,   "consumable-used"             );
EventMgr:addListener( self, self._onReviveUsed,       "revive-used"                 );
]]
end

----------------------------------------------------------------------

function listener:deactivate()

	EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true );
   end

end


----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

      if event.count == 100 then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play-100" );
      end
   end

end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess( AB_TEST_NAME, "video" );
   end

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "video"   );
   end

end

----------------------------------------------------------------------

function listener:_onConsumableUsed( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "consumable"   );
   end

end

----------------------------------------------------------------------

function listener:_onReviveUsed( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "revive"   );
   end

end

----------------------------------------------------------------------

return listener;

