----------------------------------------------------------------------

local AB_TEST_NAME   = "iap_verification";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAP,                       "IAP.succeed"                 );
   EventMgr:addListener( self, self._onIAPVerificationAccepted,   "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onIAPVerificationFake,       "iap-verification-declined"   );
   EventMgr:addListener( self, self._onIAPVerificationFailure,    "iap-verification-failure"    );
   EventMgr:addListener( self, self._onGamePlay,                  "game-start"                  );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAP( event )


   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap" );

end

----------------------------------------------------------------------

function listener:_onIAPVerificationAccepted( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verification-accepted"   );

end

----------------------------------------------------------------------

function listener:_onIAPVerificationFake( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verification-fake"        );

end

----------------------------------------------------------------------

function listener:_onIAPVerificationFailure( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "buy-iap-verification-failure"   );

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

end

----------------------------------------------------------------------

return listener;

