----------------------------------------------------------------------

local AB_TEST_NAME   = "mystery_odds_2";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,   "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,      "game-start"                  );
   EventMgr:addListener( self, self._onMysterySpin,   "mystery-spin"                );
   EventMgr:addListener( self, self._onFreebies,      "More-Freebies"               );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event  then

      local loop = 1;

      if event.id and AbTestMgr.IAP_LOOP_ID then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
      end

   end

end


----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if event and ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );
   end

end

----------------------------------------------------------------------

function listener:_onMysterySpin( event )

   if event and ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "spin" );

      if event.costType == "gems" then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "spin-paid", true );

         if event.spinCount >= 20 then
            AbTestMgr:onSuccess(  AB_TEST_NAME, "spin-paid > 20", true );
         end

      end

   end

end

----------------------------------------------------------------------

function listener:_onFreebies( event )

   if event and event.type == "freebie-mystery" and event.reason == "drop" and ( not App.data:isThief() ) then
      AbTestMgr:onSuccess( AB_TEST_NAME, "Pickup-Mystery-Token");
   end

end

----------------------------------------------------------------------

return listener;

