----------------------------------------------------------------------

local AB_TEST_NAME   = "revive_cost_v5";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onFirstBuyFromIAP,  "AnalyticsMgr.Spend-Gem-Honnest-1st-Buy-After-IAP"    );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
	EventMgr:addListener( self, self._onRevive,           "revive-used"                 );


end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event  then

      local loop = 1;

      if event.id and AbTestMgr.IAP_LOOP_ID then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
      end

   end

end

----------------------------------------------------------------------

function listener:_onFirstBuyFromIAP( event )

   Debug.assert( event );

   if event and ( not App.data:isThief() ) then

      if event.reason == "revive" then

         AbTestMgr:onSuccess(  AB_TEST_NAME, "IAP-For-Revive",         true );
         AbTestMgr:onSuccess(  AB_TEST_NAME, "IAP-For-Revive-Details", false, " - IAP-GEM=" .. tostring(event.iap_gem) );

      end
   end

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play");
   end

end

----------------------------------------------------------------------

function listener:_onRevive( event )

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "revive", true );

      if event and event.cost then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "revive-details", false, " -> cost = " .. (event.cost.gem or 0) .. " gems" );
      end

   end

end


----------------------------------------------------------------------

return listener;

