----------------------------------------------------------------------

local AB_TEST_NAME   = "rollout_cooldowns";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,                        "iap-verification-accepted"            );
   EventMgr:addListener( self, self._onLevelUp,                            "player-level-up"                      );
   EventMgr:addListener( self, self._onVideo,                              "video-gold"                           );
   EventMgr:addListener( self, self._onVideo,                              "video-key"                            );
   EventMgr:addListener( self, self._onBuyKey,                             "keys-bought"                          );
   EventMgr:addListener( self, self._onMysterySpin,                        "mystery-spin"                         );
   EventMgr:addListener( self, self._onDailyCollected,                     "daily-reward-collected"               );
   EventMgr:addListener( self, self._onMissionCollected,                   "mission-reward-collected"             );
   EventMgr:addListener( self, self._onGameCenterShowLeaderboardSuccess,   "game-center-show-leaderboard-success" );

end

----------------------------------------------------------------------

function listener:deactivate()
   EventMgr:rmvListener( self );
end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event  then

      local loop = 1;

      if event.id and AbTestMgr.IAP_LOOP_ID then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
      end

   end

end

----------------------------------------------------------------------

function listener:_onLevelUp( event )

   if event and event.level and ( not App.data:isThief() ) then

      if math.abs(event.level % 5) < 1 then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "Level-Up", false, " - " .. tostring(event.level)  );
      end
   end

end

----------------------------------------------------------------------

function listener:_onVideo( event )

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess( AB_TEST_NAME, "video" );

   end

end


----------------------------------------------------------------------

function listener:_onBuyKey( event )

   Debug.assert( event );

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-key", false, " - KEYS-INDEX=" .. tostring(event.index) );

   end

end

----------------------------------------------------------------------

function listener:_onMysterySpin( event )

   if event and ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "spin" );

   end

end

----------------------------------------------------------------------

function listener:_onDailyCollected( event )

   if event and ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "daily-collected" );

   end

end

----------------------------------------------------------------------

function listener:_onMissionCollected( event )

   if event and ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "mission-collected" );

   end

end

----------------------------------------------------------------------

function listener:_onGameCenterShowLeaderboardSuccess( event )

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess(  AB_TEST_NAME, "open-leaderboard" );

   end

end

----------------------------------------------------------------------

return listener;

