----------------------------------------------------------------------

local AB_TEST_NAME   = "store_gem_amount";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGemBought,        "gems-bought"                 );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   Debug.assert( event );

   if event and event.id and ( not App.data:isThief() ) then

      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified-"..tostring( event.id or "" )  );

      --Give an overview of how much money but also conversion rate
      local loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
      end

   end

end

----------------------------------------------------------------------

function listener:_onGemBought( event )

   Debug.assert( event );

   if event and event.index and ( not App.data:isThief() ) then
      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-source", false, "-From:"..event.source );
   end

end

----------------------------------------------------------------------

return listener;

