----------------------------------------------------------------------

local AB_TEST_NAME   = "store_key_amount";
local listener       = {};


----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"                           );
   EventMgr:addListener( self, self._onFirstBuyFromIAP,  "AnalyticsMgr.Spend-Gem-Honnest-1st-Buy-After-IAP"    );
   EventMgr:addListener( self, self._onVideoGold,        "video-gold"                                          );
   EventMgr:addListener( self, self._onVideoKey,         "video-key"                                           );
   EventMgr:addListener( self, self._onBuyKey,           "keys-bought"                                         );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                                          );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   Debug.assert( event );

   if event and ( not App.data:isThief() ) then

      local loop = 1;

      if event.id then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop", true );
      end

   end

end

----------------------------------------------------------------------

function listener:_onFirstBuyFromIAP( event )

   Debug.assert( event );

   if event and ( not App.data:isThief() ) then

      if event.reason == "buy-key" then

         AbTestMgr:onSuccess(  AB_TEST_NAME, "IAP-For-Keys",         true );
         AbTestMgr:onSuccess(  AB_TEST_NAME, "IAP-For-Keys-Details", false, " - IAP-GEM=" .. tostring(event.iap_gem) );

      end
   end

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );
   end

end

----------------------------------------------------------------------

function listener:_onBuyKey( event )

   Debug.assert( event );

   if ( not App.data:isThief() ) then

      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-key", true, " - KEYS-INDEX=" .. tostring(event.index) );

   end

end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   Debug.assert( event );

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess( AB_TEST_NAME, "video" );
   end

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   Debug.assert( event );

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "video"     );
   end

end

----------------------------------------------------------------------

return listener;

