----------------------------------------------------------------------

local AB_TEST_NAME   = "thief_game_to_video_v2";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onVideoThief,       "video-thief"                 );
   EventMgr:addListener( self, self._onVideoThiefAttempt,"video-thief-attempt"         );
   EventMgr:addListener( self, self._onVideoGold,        "video-gold"                  );
   EventMgr:addListener( self, self._onVideoKey,         "video-key"                   );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true );

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

end

----------------------------------------------------------------------

function listener:_onVideoThief( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "video-thief", false, " : " .. event.playType );
   AbTestMgr:onSuccess( AB_TEST_NAME, "video", true);

end

----------------------------------------------------------------------

function listener:_onVideoThiefAttempt( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "video-thief-attempt", false, " : " .. event.playType );

end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "video-gold");
   AbTestMgr:onSuccess( AB_TEST_NAME, "video", true);

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video-key"     );
   AbTestMgr:onSuccess(  AB_TEST_NAME, "video", true   );

end

----------------------------------------------------------------------

return listener;

