----------------------------------------------------------------------

local AB_TEST_NAME   = "vehicle_info_v4";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onFirstBuyFromIAP,  "AnalyticsMgr.Spend-Gem-Honnest-1st-Buy-After-IAP"    );
   EventMgr:addListener( self, self._onUnlockSuccess,    "unlock-success"              );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onSpendGem,         "Spend-Gem"                   );
   EventMgr:addListener( self, self._onMoreGem,          "More-Gem"                    );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   if event  then

      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true, " : $" .. tostring(AbTestMgr.IAP_COST[event.id]) );

   end

end

----------------------------------------------------------------------

function listener:_onFirstBuyFromIAP( event )

   Debug.assert( event );

   if event and ( not App.data:isThief() ) then

      if event.reason == "unlock-vehicle" or event.reason == "upgrade-side-weapon" or event.reason == "upgrade-turret-weapon" then

         AbTestMgr:onSuccess(  AB_TEST_NAME, "IAP-For-Vehicle", true, "  iap:" .. event.iap_gem .. " => " .. event.reason .. ":" .. event.cost );

      end
   end

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   if event and ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );
   end

end

----------------------------------------------------------------------

function listener:_onUnlockSuccess( event )

   if event and ( not App.data:isThief() ) then

      local vehName;

      if event.item == "vehicle" then

         vehName = tostring(AbTestMgr.VEHICLE_NAME[event.vehicle]);

      elseif event.item == "vehicle-side-weapon" then

         vehName = tostring(AbTestMgr.VEHICLE_NAME[event.vehicle]) .. "-SW";

      end

      if vehName ~= nil then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "unlock-vehicle",  true,   " => " .. vehName .. ":" .. tostring(event.costGem) );
      end

   end

end

----------------------------------------------------------------------

function listener:_onSpendGem( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "spend-gem", false, "   amount : " .. tostring(event.cost) );
   end

end

----------------------------------------------------------------------

function listener:_onMoreGem( event )

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "more-gem", false, "   amount : " .. tostring(event.gem) );
   end

end


----------------------------------------------------------------------

return listener;

