----------------------------------------------------------------------

local AB_TEST_NAME   = "video_button";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,   "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,      "game-start"                  );
   EventMgr:addListener( self, self._onVideoGold,     "video-gold"                  );
   EventMgr:addListener( self, self._onVideoKey,      "video-key"                   );
   EventMgr:addListener( self, self._onDailyReward,   "daily-reward"                );
   EventMgr:addListener( self, self._onMissionReward, "mission-reward"              );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   print("video button: IAP");

   if event and ( not App.data:isThief() ) then

      local loop = 1;

      if event.id then
         loop = AbTestMgr.IAP_LOOP_ID[event.id] or 1;
      end

      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true );

      for i=1,loop do
         AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified_loop" );
      end

   end

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   print("video button: game play");

   AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   print("video button: video gold");

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video"        );
   AbTestMgr:onSuccess(  AB_TEST_NAME, "video-gold"   );

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   print("video button: video key");

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video"        );
   AbTestMgr:onSuccess(  AB_TEST_NAME, "video-key"   );

end

----------------------------------------------------------------------

function listener:_onDailyReward( event )

   print("video button: daily collect");

   AbTestMgr:onSuccess(  AB_TEST_NAME, "daily-collected"      );

end

----------------------------------------------------------------------

function listener:_onMissionReward( event )

   print("video button: mission collect");

   AbTestMgr:onSuccess(  AB_TEST_NAME, "mission-collected"    );

end

----------------------------------------------------------------------

return listener;

