----------------------------------------------------------------------

local AB_TEST_NAME   = "video_rewards_v7";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onLevelUp,          "player-level-up"             );
   EventMgr:addListener( self, self._onVideoGold,        "video-gold"                  );
   EventMgr:addListener( self, self._onVideoKey,         "video-key"                   );
   EventMgr:addListener( self, self._onBuyGold,          "gold-bought"                 );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   Debug.assert( event );

   if event and event.id and ( not App.data:isThief() ) then
      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true, " : $" .. tostring(AbTestMgr.IAP_COST[event.id]) );
   end

end

----------------------------------------------------------------------

function listener:_onLevelUp( event )

   if event and event.level and ( not App.data:isThief() ) then
      if math.abs(event.level % 5) < 1 then
         AbTestMgr:onSuccess(  AB_TEST_NAME, "Level-Up", false, " - " .. tostring(event.level)  );
      end
   end

end

----------------------------------------------------------------------

function listener:_onBuyGold( event )

   Debug.assert( event );

   if ( not App.data:isThief() ) then
      AbTestMgr:onSuccess( AB_TEST_NAME, "buy-gold", true, " - GOLD-INDEX=" .. tostring(event.index) );
   end

end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "video-gold"             );
   AbTestMgr:onSuccess( AB_TEST_NAME, "video",        true     );

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video-key"            );
   AbTestMgr:onSuccess(  AB_TEST_NAME, "video",        true   );

end


----------------------------------------------------------------------

return listener;

