----------------------------------------------------------------------

local AB_TEST_NAME   = "xp_level_req_k";
local listener       = {};

----------------------------------------------------------------------

function listener:activate()

   EventMgr:addListener( self, self._onIAPVerified,      "iap-verification-accepted"   );
   EventMgr:addListener( self, self._onGamePlay,         "game-start"                  );
   EventMgr:addListener( self, self._onVideoGold,        "video-gold"                  );
   EventMgr:addListener( self, self._onVideoKey,         "video-key"                   );
   EventMgr:addListener( self, self._onUpgdadeSuccess,   "upgrade-success"             );
   EventMgr:addListener( self, self._onConsumableUsed,   "consumable-used"             );
   EventMgr:addListener( self, self._onReviveUsed,       "revive-used"                 );
   EventMgr:addListener( self, self._onLevelUp,          "player-level-up"             );

end

----------------------------------------------------------------------

function listener:deactivate()

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function listener:_onIAPVerified( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "buy-iap-verified", true );

end

----------------------------------------------------------------------

function listener:_onGamePlay( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play" );

   if event.count == 100 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "game-play-100" );
   end


end

----------------------------------------------------------------------

function listener:_onVideoGold( event )

   AbTestMgr:onSuccess( AB_TEST_NAME, "video");

end

----------------------------------------------------------------------

function listener:_onVideoKey( event )

   AbTestMgr:onSuccess(  AB_TEST_NAME, "video"   );

end

----------------------------------------------------------------------

function listener:_onUpgdadeSuccess( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "upgrade"   );
   end

end

----------------------------------------------------------------------

function listener:_onConsumableUsed( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "consumable"   );
   end

end

----------------------------------------------------------------------

function listener:_onReviveUsed( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "revive"   );
   end

end

----------------------------------------------------------------------

function listener:_onLevelUp( event )

   if App.data:getValue("iap-fake", 0 ) == 0 then
      AbTestMgr:onSuccess(  AB_TEST_NAME, "level-up"   );
   end

end


----------------------------------------------------------------------

return listener;

