require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalAvoidHazard = Base:new();

----------------------------------------------------------------------

function AchievementGoalAvoidHazard:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalAvoidHazard:activate( reset )

   Base.activate( self, reset );

   if not self:isCompleted() then
      
      EventMgr:addListener( self, self.onAvatarAvoid,       "barricade-avoided" );
      EventMgr:addListener( self, self.onAvatarAvoid,       "barricade-destroyed" );
      EventMgr:addListener( self, self.onAvatarAvoid,       "missile-avoided" );
      EventMgr:addListener( self, self.onMissileDestroyed,  "missile-destroyed" );
      
   end

end

----------------------------------------------------------------------

function AchievementGoalAvoidHazard:onAvatarAvoid( event )


   if not self:isCompleted() then

      self.progress = self.progress + 1;

      if self.progress >= self.template.objective then
         self:_OnCompleted();
      end
      
   end
end

----------------------------------------------------------------------

function AchievementGoalAvoidHazard:onMissileDestroyed( event )

   if not self:isCompleted() and event.invincible then

      self.progress = self.progress + 1;

      if self.progress >= self.template.objective then
         self:_OnCompleted();
      end
      
   end
end



