require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalDailyStreak = Base:new();

----------------------------------------------------------------------

function AchievementGoalDailyStreak:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalDailyStreak:activate( reset )

   Base.activate( self, reset );

   if not self:isCompleted() then
      EventMgr:addListener(self, self.onDailyComplete, "daily-success" );
   end

end

----------------------------------------------------------------------

function AchievementGoalDailyStreak:achievementScreenFocus( )

   Base.achievementScreenFocus( self );

   if not self:isCompleted() then

      local streak = App.data:getValue("achievement-daily-streak");

      if not streak then
         self.progress  = 0;
      else
         local currentStreak = App.data:getDailyChallengeStreak();
         if currentStreak then
            if streak > currentStreak then
               self.progress = 0;
               App.data:setValue("achievement-daily-streak", 0 );
            end
         end
      end

   end

end

----------------------------------------------------------------------

function AchievementGoalDailyStreak:onDailyComplete( event )

   if not self:isCompleted() then

      local streak = App.data:getValue("achievement-daily-streak");

      -- print("AchievementGoalDailyStreak:onDailyComplete-2", event.currentStreak, streak );
      if not streak or streak > event.currentStreak then
         self.progress  = 1;
         App.data:setValue("achievement-daily-streak", 1 );
      elseif streak < event.currentStreak then
         self.progress = self.progress + 1;
         App.data:setValue("achievement-daily-streak", event.currentStreak  );
      end

      -- print("AchievementGoalDailyStreak:onDailyComplete-3", self.progress, self.template.objective );

      if self.progress >= self.template.objective then
         self:_OnCompleted();
      end

   end
end
