require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalDistance = Base:new();

----------------------------------------------------------------------

function AchievementGoalDistance:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalDistance:activate( reset )

   Base.activate( self, reset );

   self.distance = 0;

   if not self:isCompleted() then
  	 EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
	end
end


----------------------------------------------------------------------

function AchievementGoalDistance:onAvatarScore( event, eventType )

   if not self:isCompleted() then

		self.distance = self.distance or 0;

      if type(event.distance) == "number" and type(self.distance) == "number" then

         local delta   = (event.distance-self.distance);
         local delta2  = math.floor(delta);
         --Progress should be a nice round integer
         self.progress = self.progress + delta2;
         self.distance = self.distance + delta2;

         if self.progress >= self.template.objective then

            self:_OnCompleted();

         end
      else

         Debug.assert( type(event.distance) == "number", "AchievementGoalDistance:onAvatarScore -> type(event.distance) == number ::" .. type(event.distance) );
         Debug.assert( type(self.distance)  == "number", "AchievementGoalDistance:onAvatarScore -> type(self.distance) == number ::"  .. type(self.distance) );

      end
   end
end


----------------------------------------------------------------------

function AchievementGoalDistance:onGameStart(event)

   Base.onGameStart( self, event);

   self.distance = 0;

end
