require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalLevelUp = Base:new();

----------------------------------------------------------------------

function AchievementGoalLevelUp:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalLevelUp:activate( reset )

   Base.activate( self, reset );

   self.progress = App.data:getCurrentPlayerLevel();

   if self.progress >= self.template.objective then
      self:_OnCompleted();
   end

   if not self:isCompleted() then

      EventMgr:addListener( self, self.onLevelUp, "player-level-up");

   end

end
----------------------------------------------------------------------

function AchievementGoalLevelUp:achievementScreenFocus()

   Base.achievementScreenFocus( self );

   if not self:isCompleted() then

      self.progress = App.data:getCurrentPlayerLevel();

      if  self.progress >= self.template.objective then
         self:_OnCompleted();
      end
   end
end

----------------------------------------------------------------------

function AchievementGoalLevelUp:onLevelUp( event )


   if not self:isCompleted() then

      self.progress = self.progress + 1;

      -- print("AchievementGoalLevelUp", self.progress, self.template.objective );

      if self.progress >= self.template.objective then
         self:_OnCompleted();
      end

   end
end
