require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalLogin = Base:new();

----------------------------------------------------------------------

function AchievementGoalLogin:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalLogin:activate( reset )

   Base.activate( self, reset );
   
   if LoginMgr:isTango() then
      self.progress = self.progress + 1;
   end
   
   if self.progress >= self.template.objective then
      self:_OnCompleted();
   end

   if not self:isCompleted() then

      EventMgr:addListener(self, self.onLogin,  "login-success" );

   end

end

----------------------------------------------------------------------

function AchievementGoalLogin:onLogin( event )

   Base.onLogin( event );

   if not self:isCompleted() then
   
      if event.tango then

         self.progress = self.progress + 1;

         if self.progress >= self.template.objective then
            self:_OnCompleted();
         end

      end
      
   end
end
