require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalScore = Base:new();

----------------------------------------------------------------------

function AchievementGoalScore:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalScore:activate()

   Base.activate( self );

   if not self:isCompleted() then
      EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   end

end

----------------------------------------------------------------------

function AchievementGoalScore:onGameStart(event)

   Base.onGameStart(self, event);

   if not self:isCompleted() then

      EventMgr:postEvent( {objective=self.template.objective} , "achv-score-objective" );

   end

end

----------------------------------------------------------------------

function AchievementGoalScore:onAvatarScore( event, type )

   if not self:isCompleted() then
   
      self.progress = event.score;

      if self.progress >= self.template.objective then

         self:_OnCompleted();

      end
   end
end


