require('app/achievement/goal/achievement-goal')

----------------------------------------------------------------------

local Base = AchievementGoal;

AchievementGoalUpgrade = Base:new();

----------------------------------------------------------------------

function AchievementGoalUpgrade:new( achievement, template  )

   local goal  = Base.new( self, achievement, template );

   return goal;

end

----------------------------------------------------------------------

function AchievementGoalUpgrade:activate()

   Base.activate( self );

   if not self:isCompleted() then
   	  self:countUpgrades();
   end
   if not self:isCompleted() then
      EventMgr:addListener( self, self.onUpgrade, "upgrade-success" );
   end

end

----------------------------------------------------------------------

function AchievementGoalUpgrade:achievementScreenFocus()

   Base.achievementScreenFocus( self );

   if not self:isCompleted() then
      self:countUpgrades();
   end

end

----------------------------------------------------------------------

function AchievementGoalUpgrade:countUpgrades()

   local count = App.data:getPlayerVehicleCount();
   if count then
      self.progress = 0;
      for i=1,count do

         local unlocked = App.data:isPlayerVehicleUnlocked( i );
         if unlocked then

            local currentLvl = 0;
            
            currentLvl = App.data:getPlayerArmorLevel(i);
            if currentLvl then
               self.progress = self.progress + currentLvl;
            end

            currentLvl = App.data:getPlayerWeaponLevel(i);
            if currentLvl then
               self.progress = self.progress + currentLvl;
            end

            currentLvl = App.data:getPlayerSideWeaponLevel(i);
            if currentLvl then
               self.progress = self.progress + currentLvl;
            end

            currentLvl = App.data:getPlayerTurretWeaponLevel(i);
            if currentLvl then
               self.progress = self.progress + currentLvl;
            end

         end
      end
   end

   if self.progress >= self.template.objective then
      self:_OnCompleted();
   end

end

----------------------------------------------------------------------

function AchievementGoalUpgrade:onUpgrade( event, type )

   self.progress = self.progress + 1;
   
   if self.progress >= self.template.objective then

      self:_OnCompleted();

   end

end
