----------------------------------------------------------------------

----------------------------------------------------------------------

AnalyticsMgr  =
{
};

----------------------------------------------------------------------

AnalyticsMgr.MESSAGE_TO_TO_FLURRY_EVENT_ID =
{
   ["brag"]     = "Tango-Brag",
   ["invite"]   = "Tango-Invite",
   ["gift"]     = "Tango-Gift",
};

----------------------------------------------------------------------

AnalyticsMgr.FLURRY_LEVEL_GROUP =
{
   [0002] = true,    [0003] = true,    [0004] = true,    [0005] = true,
   [0006] = true,    [0007] = true,    [0008] = true,    [0009] = true,
   [0010] = true,    [0015] = true,    [0020] = true,    [0025] = true,
   [0030] = true,    [0035] = true,    [0040] = true,    [0045] = true,
   [0050] = true,    [0055] = true,    [0060] = true,    [0070] = true,
   [0080] = true,    [0090] = true,    [0100] = true,    [0150] = true,
   [0200] = true,    [0300] = true,    [0400] = true,    [0500] = true,
   [0600] = true,    [0800] = true,    [1000] = true,
};

----------------------------------------------------------------------

function AnalyticsMgr:init()

   self._tempData = {};

   self:_initListeners();

end

----------------------------------------------------------------------

function AnalyticsMgr:_initListeners()

   EventMgr:addListener( self, self._onSpendGem,                         "Spend-Gem"                            );
   EventMgr:addListener( self, self._onMoreGem,                          "More-Gem"                             );
   EventMgr:addListener( self, self._onPickup,                           "avatar-pickup"                        );
   EventMgr:addListener( self, self._onRewardVideoAttempt,               "reward-video-attempt"                 );
   EventMgr:addListener( self, self._onRewardVideoSuccess,               "reward-video-success"                 );
   EventMgr:addListener( self, self._onRewardVideoFailure,               "reward-video-failure"                 );
   EventMgr:addListener( self, self._onInterstitialAttempt,              "interstitial-attempt"                 );
   EventMgr:addListener( self, self._onInterstitialSuccess,              "interstitial-success"                 );
   EventMgr:addListener( self, self._onInterstitialFailure,              "interstitial-failure"                 );
   EventMgr:addListener( self, self._onUnlockSuccess,                    "unlock-success"                       );
   EventMgr:addListener( self, self._onPostNotification,                 "post-notification"                    );
   EventMgr:addListener( self, self._onGameCenterAuthenticationAttempt,  "game-center-authentication-attempt"   );
   EventMgr:addListener( self, self._onGameCenterAuthenticationSuccess,  "game-center-authentication-success"   );
   EventMgr:addListener( self, self._onGameCenterAuthenticationFailure,  "game-center-authentication-failure"   );
   EventMgr:addListener( self, self._onGameCenterUploadScoreAttempt,     "game-center-upload-score-attempt"     );
   EventMgr:addListener( self, self._onGameCenterUploadScoreSuccess,     "game-center-upload-score-success"     );
   EventMgr:addListener( self, self._onGameCenterUploadScoreFailure,     "game-center-upload-score-failure"     );
   EventMgr:addListener( self, self._onGameCenterShowLeaderboardAttempt, "game-center-show-leaderboard-attempt" );
   EventMgr:addListener( self, self._onGameCenterShowLeaderboardSuccess, "game-center-show-leaderboard-success" );
   EventMgr:addListener( self, self._onGameCenterShowLeaderboardFailure, "game-center-show-leaderboard-failure" );
   EventMgr:addListener( self, self._onPlayerLevelUp,                    "player-level-up"                      );
   EventMgr:addListener( self, self._onCrashDetected,                    "crash-detected"                       );
   EventMgr:addListener( self, self._onFraudDetected,                    "FraudMgr.detectCheater"               );
   EventMgr:addListener( self, self._onFraudCrash,                       "Fraud.Data.Crash"                     );
   EventMgr:addListener( self, self._onIAPAttempt,                       "IAP.attempt"                          );
   EventMgr:addListener( self, self._onIAPSuccess,                       "IAP.success"                          );
   EventMgr:addListener( self, self._onIAPFailure,                       "IAP.failure"                          );
   EventMgr:addListener( self, self._onLowMemoryWarning,                 "low-memory-warning"                   );
   EventMgr:addListener( self, self._onTutorialStart,                    "tutorial.start"                       );
   EventMgr:addListener( self, self._onTutorialProgress,                 "tutorial.progress"                    );
   EventMgr:addListener( self, self._onTutorialFinish,                   "tutorial.finish"                      );
   EventMgr:addListener( self, self._onTangoMessageAttempt,              "tango.message.attempt"                );
   EventMgr:addListener( self, self._onTangoMessageSuccess,              "tango.message.success"                );
   EventMgr:addListener( self, self._onTangoMessageFailure,              "tango.message.failure"                );
   EventMgr:addListener( self, self._onStateFocus,                       "StateMgr.state.new"                   );
   EventMgr:addListener( self, self._onNativeAdRequest,                  "native-ad-request"                    );
   EventMgr:addListener( self, self._onNativeAdResponse,                 "native-ad-response"                   );
   EventMgr:addListener( self, self._onNativeAdImpressed,                "native-ad-impressed"                  );
   EventMgr:addListener( self, self._onNativeAdImpressedFinished,        "native-ad-impressed-finished"         );
   EventMgr:addListener( self, self._onNativeAdClicked,                  "native-ad-clicked"                    );
   EventMgr:addListener( self, self._onNativeAdClickedFinished,          "native-ad-clicked-finished"           );
   EventMgr:addListener( self, self._onNativeAdReceivedInvalidAd,        "native-ad-received-invalid-ad"        );
   EventMgr:addListener( self, self._onDroneBayUnlock,                   "drone-bay-unlock"                     );
   EventMgr:addListener( self, self._onDroneBuild,                       "drone-build"                          );
   EventMgr:addListener( self, self._onDroneUpgrade,                     "drone-upgrade"                        );
   EventMgr:addListener( self, self._onDroneEvolve,                      "drone-evolve"                         );
   EventMgr:addListener( self, self._onOnlineMgrOnline,                  "online-mgr:online"                    );
   EventMgr:addListener( self, self._onPlayerChooseData,                 "player-choose-data"                   );
   EventMgr:addListener( self, self._onPlayerChooseSuccess,              "choose-data-success"                  );
   EventMgr:addListener( self, self._onDataMerged,                       "data-merged"                          );
   EventMgr:addListener( self, self._onFileDownload,                     "file-download"                        );
   EventMgr:addListener( self, self._onGameStart,                        "game-start"                           );
   EventMgr:addListener( self, self._onGameOver,                          "game-over"                             );

end

----------------------------------------------------------------------

function AnalyticsMgr:_getTangoStatusExp()

   if LoginMgr:isTango() then
      return "tango-authenticated";
   end

   if MOAITangoSdk:tangoHasSdkSupport() then
     return "tango-on-device-not-authenticated";
   end

   return "no-tango";

end



----------------------------------------------------------------------

function AnalyticsMgr:_GetDaysPlayed()

   local firstLaunch = App.data:getValue("firstLaunch") or os.time();
   return math.floor((os.time()-firstLaunch)/(24*60*60));

end

----------------------------------------------------------------------

function AnalyticsMgr:_GetCurrentPlayerSimple()

   local curVeh = App.data:getCurrentPlayerVehicle();

   if curVeh then
      return         "car-"   .. tostring(curVeh);
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_GetCurrentPlayerDetailed()

   local curVeh = App.data:getCurrentPlayerVehicle();

   if curVeh then
      return         "car-"   .. tostring(curVeh)
               ..    "-m"     .. tostring(App.data:getPlayerMainWeaponLevel(curVeh))
               ..    "-a"     .. tostring(App.data:getPlayerArmorLevel(curVeh))
               ..    "-s"     .. tostring(App.data:getPlayerSideWeaponLevel(curVeh))
               ..    "-t"     .. tostring(App.data:getPlayerTurretWeaponLevel(curVeh));
   end

end



----------------------------------------------------------------------

function AnalyticsMgr:_calcTimeDiffSec( timeBefore, timeAfter )

   return math.floor( (timeAfter or 0) - (timeBefore or 0) );

end

----------------------------------------------------------------------

function AnalyticsMgr:_By10( number )

   return math.max(math.floor(tonumber(number)/10)*10,1);

end

----------------------------------------------------------------------

function AnalyticsMgr:_By100( number )

   return math.max(math.floor(tonumber(number)/100)*100,1);

end

----------------------------------------------------------------------

function AnalyticsMgr:_By1000( number )

   return math.max(math.floor(tonumber(number)/1000)*1000,1);

end


----------------------------------------------------------------------

function AnalyticsMgr:_onSpendGem( event )


   if event then

      MOAIFlurry:event(    "Spend-Gem",
                           "type",          tostring(event.reason),
                           "type-gem",      tostring(event.reason).."-"..tostring(event.cost),
                           "amount-gem",    tostring(event.cost)        );

      --We can only verify Tango user
      if not App.data:isThief() then

         MOAIAdjust:trackEvent(  App.adjustMap["HC-Spend"],
                                 "type",                          "gem",
                                 "item",                          tostring(event.reason),
                                 "value",                         tostring(event.cost),
                                 "level",                         tostring(App.data:getCurrentPlayerLevel()),
                                 "game-played",                   tostring(App.data:getGamePlayed())             );

         MOAIFlurry:event(    "Spend-Gem-Honnest",
                              "type",                       tostring(event.reason),
                              "amount-gem",                 tostring(event.cost),
                              "type-gem",                   tostring(event.reason).."-"..tostring(event.cost),
                              "Tango",                      tostring(self:_getTangoStatusExp()),
                              "buyer",                      tostring(App.data:getValue("iap-verified", 0 ) > 0 )      );

         if LoginMgr:isTango() then

            MOAIFlurry:event(    "Spend-Gem-Honnest-Tango",
                                 "type",                       tostring(event.reason),
                                 "type-gem",                   tostring(event.reason).."-"..tostring(event.cost),
                                 "amount-gem",                 tostring(event.cost),
                                 "buyer",                      tostring(App.data:getValue("iap-verified", 0 ) > 0 )  );

         end

         if App.data:getValue("iap-verified", 0 ) > 0 then

            MOAIFlurry:event(    "Spend-Gem-Honnest-Buyer",
                                 "type",                       tostring(event.reason),
                                 "amount-gem",                 tostring(event.cost),
                                 "type-gem",                   tostring(event.reason).."-"..tostring(event.cost),
                                 "Tango",                      tostring(self:_getTangoStatusExp()),
                                 "iap-verified",               tostring(App.data:getValue("iap-verified", 0 ))          );




         end

         local gemIAP = App.data:getValue("AnalyticsMgr.Gem.IAP", 0);

         if gemIAP > 0 then

            App.data:deltaValue("AnalyticsMgr.Gem.IAP", -math.min(gemIAP, event.cost) );

            MOAIFlurry:event(    "Spend-Gem-Honnest-From-IAP",
                                 "type",                       tostring(event.reason),
                                 "amount-gem",                 tostring(event.cost),
                                 "type-gem",                   tostring(event.reason).."-"..tostring(event.cost),
                                 "Tango",                      tostring(self:_getTangoStatusExp()),
                                 "iap-verified",               tostring(App.data:getValue("iap-verified", 0 )),
                                 "level",                      tostring(App.data:getCurrentPlayerLevel()),
                                 "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) )        );

            if App.data:getValue("AnalyticsMgr.Gem.IAP.New") then


               --First buy after IAP, help understand what was the reason to do IAP
               EventMgr:postEvent({ iap_gem     = App.data:getValue("AnalyticsMgr.Gem.IAP.New"),
                                    reason      = event.reason,
                                    cost        = event.cost,
                                    tango       = self:_getTangoStatusExp() }, "AnalyticsMgr.Spend-Gem-Honnest-1st-Buy-After-IAP" );

               App.data:setValue("AnalyticsMgr.Gem.IAP.New", nil);

               MOAIFlurry:event(    "Spend-Gem-Honnest-1st-Buy-After-IAP",
                                    "type",                       tostring(event.reason),
                                    "amount-gem",                 tostring(event.cost),
                                    "type-gem",                   tostring(event.reason).."-"..tostring(event.cost),
                                    "Tango",                      tostring(self:_getTangoStatusExp()),
                                    "iap-verified",               tostring(App.data:getValue("iap-verified", 0 )),
                                    "level",                      tostring(App.data:getCurrentPlayerLevel()),
                                    "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) )          );

            end

            if App.data:getValue("AnalyticsMgr.Gem.IAP.First") then

               App.data:setValue("AnalyticsMgr.Gem.IAP.First", false);

               MOAIFlurry:event(    "Spend-Gem-Honnest-1st-Buy-After-1st-IAP",
                                    "type",                       tostring(event.reason),
                                    "amount-gem",                 tostring(event.cost),
                                    "type-gem",                   tostring(event.reason).."-"..tostring(event.cost),
                                    "Tango",                      tostring(self:_getTangoStatusExp()),
                                    "iap-verified",               tostring(App.data:getValue("iap-verified", 0 )),
                                    "level",                      tostring(App.data:getCurrentPlayerLevel()),
                                    "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) )          );


            end

         else

            Debug.assert(gemIAP >= 0, "AnalyticsMgr:_onSpendGem  -->  gemIAP >= 0");

         end
      end
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onMoreGem( event )

   if event and event.gem and event.gem > 0 then

      MOAIFlurry:event(    "More-Gem",
                           "type",            (event.type or "unknown"),
                           "type-2",          (event.type or "unknown") .. "-"..tostring(event.gem),
                           "amount-gem",      tostring(event.gem)           );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onPickup( event )

   if event.pickup.pickupType == "bounty" and event.pickup.tangoId then

      MOAIFlurry:event(    "Bounty-Pickup",
                           "Tango",                      tostring(self:_getTangoStatusExp()),
                           "level",                      tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) )          );



   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onRewardVideoAttempt( event )

   local attemptCount = App.data:deltaValue("AnalyticsMgr.Video-Attempt-Count",1);

   MOAIFlurry:eventStart(  "Video-Reward-Attempt",
                           "result",                              "processing",
                           "Network",                             tostring(event.network),
                           "attempt-count",                       tostring(attemptCount),
                           "level",                               tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                         tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                           "gold by 1000",                        tostring(self:_By1000(App.data:getGoldCount())),
                           "gem by 10",                           tostring(self:_By10(App.data:getGemCount())),
                           "Tango",                               tostring(self:_getTangoStatusExp()),
                           "online",                              tostring(OnlineMgr:isOnline())                                );


   MOAIAdjust:trackEvent( App.adjustMap["Video-Attempt"] );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onRewardVideoSuccess( event )

   if event then

      local successCount = App.data:deltaValue("AnalyticsMgr.Video-Succeeded-Count",1);

      MOAIFlurry:eventStop("Video-Reward-Attempt",
                           "result",                           tostring(event.result)  );

      MOAIFlurry:event(    "Video-Reward-Success",
                           "Network",                          tostring(event.network),
                           "success-count",                    tostring(successCount),
                           "success-count by 10",              tostring(self:_By10(successCount)),
                           "level",                            tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                      tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                           "level by 100",                     tostring(self:_By100(App.data:getCurrentPlayerLevel())),
                           "gold by 1000",                     tostring(self:_By1000(App.data:getGoldCount())),
                           "gem by 10",                        tostring(self:_By10(App.data:getGemCount())),
                           "Tango",                            tostring(self:_getTangoStatusExp())                   );


      MOAIAdjust:trackEvent( App.adjustMap["Video-Success"] );

   else

      Debug.assert( event, "AnalyticsMgr:_onRewardVideoSuccess -> event" );

   end

end


----------------------------------------------------------------------

function AnalyticsMgr:_onRewardVideoFailure( event )

   if event then

      local failureCount = App.data:deltaValue("AnalyticsMgr.Video-Failure-Count",1);

      MOAIFlurry:eventStop("Video-Reward-Attempt",
                           "result",                           tostring(event.result) );

      MOAIFlurry:event(    "Video-Reward-Failure",
                           "Network",                          tostring(event.network),
                           "failure-reason",                   tostring(event.reason),
                           "failure-count",                    tostring(failureCount),
                           "level",                            tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                      tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                           "gold by 1000",                     tostring(self:_By1000(App.data:getGoldCount())),
                           "gem by 10",                        tostring(self:_By10(App.data:getGemCount())),
                           "Tango",                            tostring(self:_getTangoStatusExp()),
                           "online",                           tostring(OnlineMgr:isOnline())                                  );

      MOAIAdjust:trackEvent( App.adjustMap["Video-Failure"] );


   else

      Debug.assert( event, "AnalyticsMgr:_onRewardVideoFailure -> event" );

   end

end



----------------------------------------------------------------------

function AnalyticsMgr:_onInterstitialAttempt( event )

   local attemptCount = App.data:deltaValue("AnalyticsMgr.Interstitial-Attempt-Count",1);

   MOAIFlurry:eventStart(  "Interstitial-Attempt",
                           "result",                              "processing",
                           "location",                            tostring(event.location),
                           "Network",                             tostring(event.network),
                           "attempt-count",                       tostring(attemptCount),
                           "level",                               tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                         tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                           "Tango",                               tostring(self:_getTangoStatusExp()),
                           "online",                              tostring(OnlineMgr:isOnline())                                );

   MOAIAdjust:trackEvent( App.adjustMap["Interstitial-Attempt"] );


end

----------------------------------------------------------------------

function AnalyticsMgr:_onInterstitialSuccess( event )

   if event then

      local successCount = App.data:deltaValue("AnalyticsMgr.Interstitial-Succeeded-Count",1);

      MOAIFlurry:eventStop("Interstitial-Attempt",
                           "result",                           "success",
                           "location",                         tostring(event.location)  );

      MOAIFlurry:event(    "Interstitial-Success",
                           "location",                         tostring(event.location),
                           "Network",                          tostring(event.network),
                           "success-count",                    tostring(successCount),
                           "success-count by 10",              tostring(self:_By10(successCount)),
                           "level",                            tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                      tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                           "level by 100",                     tostring(self:_By100(App.data:getCurrentPlayerLevel())),
                           "Tango",                            tostring(self:_getTangoStatusExp())                   );


      MOAIAdjust:trackEvent( App.adjustMap["Interstitial-Success"] );

   else

      Debug.assert( event, "AnalyticsMgr:_onInterstitialSuccess -> event" );

   end

end


----------------------------------------------------------------------

function AnalyticsMgr:_onInterstitialFailure( event )

   if event then

      local failureCount = App.data:deltaValue("AnalyticsMgr.Interstitial-Failure-Count",1);

      MOAIFlurry:eventStop("Interstitial-Attempt",
                           "result",                           "failure",
                           "location",                         tostring(event.location));

      MOAIFlurry:event(    "Interstitial-Failure",
                           "location",                         tostring(event.location),
                           "Network",                          tostring(event.network),
                           "failure-reason",                   tostring(event.reason),
                           "failure-count",                    tostring(failureCount),
                           "level",                            tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",                      tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                           "Tango",                            tostring(self:_getTangoStatusExp()),
                           "online",                           tostring(OnlineMgr:isOnline())                                  );

      MOAIAdjust:trackEvent( App.adjustMap["Interstitial-Failure"] );

   else

      Debug.assert( event, "AnalyticsMgr:_onInterstitialFailure -> event" );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onUnlockSuccess( event )

   if event then

      if event.item == "vehicle" then

         self:_onUnlockVehicle( event );

      end

   else

      Debug.assert( event, "AnalyticsMgr:_onUnlockSuccess -> event" );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onUnlockVehicle( event )

   if not App.data:isThief() then

      if event and event.item == "vehicle" then

         MOAIFlurry:event(    "Use-Garage",
                              "type",              "unlock-vehicle",
                              "count",             tostring(App.data:getValue("garage-use-count"))     );

         local allVehiclesUnlocked = "";
         local prevVehiclesUnlocked = "";

         for i=1,10 do

            if i==event.vehicle then

               allVehiclesUnlocked  = allVehiclesUnlocked  .. "- XXXX  ";
               prevVehiclesUnlocked = prevVehiclesUnlocked .. "- XXXX  ";

            else

               if App.data:isPlayerVehicleUnlocked(i) then

                  allVehiclesUnlocked = allVehiclesUnlocked .. "- true  ";
                  if i < event.vehicle then
                     prevVehiclesUnlocked = prevVehiclesUnlocked .. "- true  ";
                  end

               else

                  allVehiclesUnlocked = allVehiclesUnlocked.."- false ";
                  if i < event.vehicle then
                     prevVehiclesUnlocked = prevVehiclesUnlocked .. "- false ";
                  end

               end

            end
         end


         --Delay because iap-verified would not be set for a few frame
         delay( 0.25,
               function()
                  MOAIFlurry:event(    "Unlock-Vehicle-V2",
                                       "vehicle",                 tostring(event.vehicle),
                                       "all  vehicles",           tostring(allVehiclesUnlocked),
                                       "prev vehicles",           tostring(prevVehiclesUnlocked),
                                       "cost-gem",                tostring(event.costGem),
                                       "iap-verified",            tostring(App.data:getValue("iap-verified", 0 ) ),
                                       "tango",                   tostring(self:_getTangoStatusExp()),
                                       "level",                   tostring(App.data:getCurrentPlayerLevel()),
                                       "level by 10",             tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                                       "vehicle-level",           "veh-" ..tostring(event.vehicle) .. "-lvl-" .. tostring(App.data:getCurrentPlayerLevel()),
                                       "vehicle-level by 10",     "veh-" ..tostring(event.vehicle) .. "-lvl-" .. tostring(self:_By10(App.data:getCurrentPlayerLevel()))    );
               end );
      else

         Debug.assert( event and event.item == "vehicle", "AnalyticsMgr:_onUnlockVehicle -> event and event.item == vehicle" );

      end
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onPostNotification( event)

   if event then

      if event.timer then

         local notifTime   = os.date("%H", os.time() + event.timer) .. ":" ..   os.date("%M", os.time() + event.timer);

         MOAIFlurry:event(    "Local-Notification",
                              "Type",                    tostring(event.type),
                              "Time",                    os.date("%H", os.time()) .. ":" ..   os.date("%M", os.time()),
                              "Today",                   tostring(os.date("%x", os.time()))               .. "  "  .. tostring(os.date("%X", os.time())),
                              "Push-Day",                tostring(os.date("%x", os.time() + event.timer)) .. "  "  .. tostring(os.date("%X", os.time() + event.timer)),
                              "tango",                   tostring(self:_getTangoStatusExp()),
                              "level",                   tostring(App.data:getCurrentPlayerLevel()),
                              "level by 10",             tostring(self:_By10(App.data:getCurrentPlayerLevel())),
                              "Notification Time",       tostring(notifTime),
                              "Type-Notif Time",         tostring(event.type) .. "-" .. tostring(notifTime)
                           );

      else

         Debug.assert( event.timer, "AnalyticsMgr:_onPostNotification => event.timer" );

      end

      if event.type == "daily-warning" or event.type == "daily-reminder" then

         if event.timer and App.data:getDailyChallengeTime() then

            if event.type == "daily-warning" then
               Debug.assert( event.timer <= App.data:getDailyChallengeTimer(), "AnalyticsMgr:_onPostNotification : daily-warning -> event.timer <= App.data:getDailyChallengeTimer() " );
            elseif event.type == "daily-reminder" then
               Debug.assert( event.timer >= App.data:getDailyChallengeTimer(), "AnalyticsMgr:_onPostNotification : daily-reminder -> event.timer >= App.data:getDailyChallengeTimer() " );
               -- Debug.assert( event.timer <=  (60*60*24),                       "AnalyticsMgr:_onPostNotification : event.timer  <  (60*60*24) " );
            end
         else

            Debug.assert( event.timer,                      "AnalyticsMgr:_onPostNotification-Daily => event.timer" );
            Debug.assert( App.data:getDailyChallengeTime(), "AnalyticsMgr:_onPostNotification-Daily => App.data:getDailyChallengeTime()" );

         end

      elseif event.type == "weekly-warning" or event.type == "weekly-reminder" then

         local weeklyTimer = RankingMgr:getTimeToReset();

         if event.timer and weeklyTimer then

            if event.type == "weekly-warning" then
            --   Debug.assert( event.timer <= weeklyTimer, "AnalyticsMgr:_onPostNotification : event.timer <= weeklyTimer" );

            elseif event.type == "weekly-reminder" then
               Debug.assert( event.timer > weeklyTimer, "AnalyticsMgr:_onPostNotification : event.timer > weeklyTimer" );
            end

         else

            Debug.assert( event.timer, "AnalyticsMgr:_onPostNotification - week => event.timer" );
            Debug.assert( weeklyTimer, "AnalyticsMgr:_onPostNotification - week => weeklyTimer" );

         end
      end

   else

      Debug.assert( event, "AnalyticsMgr:_onPostNotification => event" );

   end
end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterAuthenticationAttempt( event )

   MOAIFlurry:eventStart(  "GameCenter-Authentication",
                           "result",                              "processing"   );
end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterAuthenticationSuccess( event )

   MOAIFlurry:eventStop(   "GameCenter-Authentication",
                           "result",                              "success"   );


   MOAIFlurry:event(       "GameCenter-Authentication-Success"                );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterAuthenticationFailure( event )

   MOAIFlurry:eventStop(   "GameCenter-Authentication",
                           "result",                              "failure",
                           "failure-reason",                      tostring(event.error));

end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterUploadScoreAttempt( event )

   MOAIFlurry:eventStart(  "GameCenter-Upload-Score",
                           "result",                              "processing"   );
end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterUploadScoreSuccess( event )

   MOAIFlurry:eventStop(   "GameCenter-Upload-Score",
                           "result",                              "success"   );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterUploadScoreFailure( event )

   MOAIFlurry:eventStop(   "GameCenter-Upload-Score",
                           "result",                              "failure",
                           "failure-reason",                      tostring(event.error));

end



----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterShowLeaderboardAttempt( event )

   MOAIFlurry:eventStart(  "GameCenter-Show-Leaderboard",
                           "result",                              "processing"   );
end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterShowLeaderboardSuccess( event )

   MOAIFlurry:eventStop(   "GameCenter-Show-Leaderboard",
                           "result",                              "success"   );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameCenterShowLeaderboardFailure( event )

   MOAIFlurry:eventStop(   "GameCenter-Show-Leaderboard",
                           "result",                              "failure",
                           "failure-reason",                      tostring(event.error));

end

----------------------------------------------------------------------

function AnalyticsMgr:_onPlayerLevelUp( event )

   if event.level and AnalyticsMgr.FLURRY_LEVEL_GROUP[event.level] then

      MOAIFlurry:event( "LevelUp-"..event.level,
                        "level-gameplayed",              tostring(event.levelGamePlayed),
                        "gameplayed",                    tostring(App.data:getGamePlayed()),
                        "gameplayed by 10",              tostring(self:_By10( App.data:getGamePlayed())),
                        "gameplayed by 100",             tostring(self:_By100(App.data:getGamePlayed())),
                        "mission",                       tostring(App.data:getMissionIndex()),
                        "car-only",                      tostring(self:_GetCurrentPlayerSimple()),
                        "car-details",                   tostring(self:_GetCurrentPlayerDetailed()),
                        "daysPlayed",                    tostring(self:_GetDaysPlayed()),
                        "thief",                         tostring(App.data:isThief()),
                        "level hi-score",                tostring(self:_By1000(event.levelHiScore))            );
   end

   if event.level and event.level == 5 then
      MOAIAdjust:trackEvent( App.adjustMap["Level-5"] );
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onCrashDetected(event)

   MOAIFlurry:event( "Error-Crash-Detected-V2",
                     "count",                         tostring(event.count),
                     "state",                         tostring(event.state),
                     "session.games",                 tostring(event.sessionGames),
                     "device-type",                   tostring(MOAIEnvironment.osBrand)
                                          .. "-" ..   tostring(MOAIEnvironment.devBrand)
                                          .. "-" ..   tostring(MOAIEnvironment.devManufacturer)
                                          .. "-" ..   tostring(MOAIEnvironment.devName)
                                          .. "-" ..   tostring(MOAIEnvironment.devModel)
                                          .. "-" ..   tostring(MOAIEnvironment.devProduct),
                     "level",                         tostring(App.data:getCurrentPlayerLevel()),
                     "level by 10",                   tostring(self:_By10(App.data:getCurrentPlayerLevel()) ),
                     "tango",                         tostring(self:_getTangoStatusExp()),
                     "daysPlayed",                    tostring(self:_GetDaysPlayed())                             );


end

----------------------------------------------------------------------

function AnalyticsMgr:_onFraudDetected(event)

   if event.report then

      local gem            =  App.data:getValue("gem");
      local gemC           =  App.data:getValueFromCritical("gem");
      local gold           =  App.data:getValue("gold");
      local goldC          =  App.data:getValueFromCritical("gold");
      local iapFake        =  App.data:getValue("iap-fake",     0 );
      local iapReal        =  App.data:getValue("iap-verified", 0 );
      local dataCritDiff   =  "";

      if (gem ~= gemC) then
         dataCritDiff  = dataCritDiff  .. "  Gem=( " .. "Data:"..tostring(gem) .." Crit:"..tostring(gemC).. " )";
      else
         dataCritDiff  = dataCritDiff  .. "  Gem:Same ";
      end

      if (gold ~= goldC) then
         dataCritDiff  = dataCritDiff  .. "  Gold=( " .. "Data:"..tostring(gem) .." Crit:"..tostring(gemC).. " )";
      else
         dataCritDiff  = dataCritDiff  .. "  Gold:Same ";
      end

      local fraudEventId      = "Fraud.Detected";
      local fraudTypeEventId  = "Fraud." .. tostring(event.type) .. ".Detected";

      local params =
      {
         "type",                          tostring(event.type),

         "count",                         tostring(event.count),

         "type-count",                    tostring(event.type)      .. ":"..  tostring(event.typeCount),

         "gem-gemC-gold-goldC",           " gem="  .. tostring(gem)     .. " gemC="     .. tostring(gemC)
                                       .. " gold=" .. tostring(gold)    .. " goldC="    .. tostring(goldC),

         "iap",                           "Fake=" .. tostring(iapFake) .. " Verified=" .. tostring(iapReal),

         "tango",                         tostring(self:_getTangoStatusExp()),

         "data-crit-diff",                dataCritDiff,

         "model",                         "my=" .. tostring(event.myDevModel)   .. "  " .. "device=" .. tostring(event.devModel),

         "product",                       "my=" .. tostring(event.myDevProduct) .. "  " .. "device=" ..  tostring(event.devProduct),

         "secret",                        "my=" .. tostring(event.mySecret) .. "  data=" ..tostring(event.dataSecret),
      };

      if event.count == 1 then
         MOAIFlurry:event( fraudEventId     .. ".New",            unpack(params) );
      end

      if (event.typeCount or 1 ) == 1 then
         MOAIFlurry:event( fraudTypeEventId .. ".New",            unpack(params) );
      end

      MOAIFlurry:event( fraudEventId,                             unpack(params) );
      MOAIFlurry:event( fraudTypeEventId,                         unpack(params) );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onFraudCrash( event )

   MOAIFlurry:event( "Fraud.Crash" );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onIAPAttempt( event )

   if event and event.requestId then

      local dataId    = "iap." .. tostring(event.requestId) .. ".time";
      self._tempData[ dataId ] = MOAISim.getDeviceTime();

      MOAIFlurry:eventStart(  "IAP.attempt",
                              "type",                 tostring(event.type),
                              "id",                   tostring(event.id),
                              "requestId",            tostring(event.requestId),
                              "productId",            tostring(event.productId),
                              "cost",                 tostring(event.cost),
                              "amount",               tostring(event.amount),
                              "ending",               "processing"                     );


      MOAIAdjust:trackEvent( App.adjustMap["IAP-Clicked"] );


   else

      Debug.assert(  event and event.requestId ,
                     "AnalyticsMgr:_onIAPAttempt ->  event and event.requestId");

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onIAPSuccess( event )

   if not Debug.assertType(event, "table", "AnalyticsMgr:_onIAPSuccess -> event") then
      return;
   end

   local dataId    = "iap." .. tostring(event.requestId) .. ".time";

   MOAIFlurry:event(       "IAP.success",
                           "type",                 tostring(event.type),
                           "id",                   tostring(event.id),
                           "requestId",            tostring(event.requestId),
                           "productId",            tostring(event.productId),
                           "cost",                 tostring(event.cost),
                           "amount",               tostring(event.gemAmount),
                           "verified",             tostring(event.verified),
                           "recovered",            tostring(event.recovered)    );

   MOAIFlurry:eventStop(   "IAP.attempt",
                           "ending",               "success",
                           "recovered",            tostring(event.recovered),
                           "verified",             tostring(event.verified),
                           "time",                 tostring( self:_calcTimeDiffSec(self._tempData[ dataId ] , MOAISim.getDeviceTime())) );


   if event.type == "gems" then

      local since       = self:_GetDaysPlayed();
      local launch      = App.data:getValue("launch-count") or 0;

      if event.numberPurchased == 1 then

         MOAIFlurry:event( "First-Buy",
                           "gamePlayed",     tostring(App.data:getGamePlayed()),
                           "gamePlayed-10",  tostring(math.floor(App.data:getGamePlayed()/10)),
                           "days",           tostring(since),
                           "weeks",          tostring(math.floor(since/7)),
                           "launch",         tostring(launch),
                           "gem-quantity",   tostring(event.gemAmount or 0 ),
                           "level",          tostring(App.data:getCurrentPlayerLevel()),
                           "level/10",       tostring(math.floor(App.data:getCurrentPlayerLevel()/10)),
                           "hour",           tostring(os.date("%H", os.time()))                             );


         if event.verified then

            App.data:setValue("AnalyticsMgr.Gem.IAP.First", true);

            MOAIFlurry:event(    "First-Buy-Verified",
                                 "gemBefore by 10",      tostring(math.floor(event.gemBefore/10)*10),
                                 "gamePlayed by 10",     tostring(math.max(math.floor(App.data:getGamePlayed()/10)*10,1)),
                                 "gamePlayed by 100",    tostring(math.max(math.floor(App.data:getGamePlayed()/100)*100,1)),
                                 "days",                 tostring(since),
                                 "weeks",                tostring(math.floor(since/7)),
                                 "gem-quantity",         tostring(event.gemAmount),
                                 "level",                tostring(App.data:getCurrentPlayerLevel()),
                                 "level by 10",          tostring(self:_By10(App.data:getCurrentPlayerLevel()) ),
                                 "tango",                tostring(self:_getTangoStatusExp())                                               );
         end

      end

      MOAIAdjust:trackRevenue(event.cost,
                              App.adjustMap["IAP"],
                              "product-id",              tostring(event.productId),
                              "receipt",                 tostring(event.verified));


      MOAIFlurry:event(    "Buy-Gem-Success",
                           "cost",                 tostring(event.cost),
                           "numberPurchase",       tostring(event.numberPurchased),
                           "gem-quantity",         tostring(event.gemAmount),
                           "hour",                 tostring(os.date("%H", os.time())),
                           "level",                tostring(App.data:getCurrentPlayerLevel()),
                           "level by 10",          tostring(self:_By10(App.data:getCurrentPlayerLevel()) ),
                           "needReceipt",          tostring(event.verified),
                           "tango",                tostring(self:_getTangoStatusExp())                                  );


      print(true, event.productId, event.type, event.id, event.cost, "USD")
      MOAIFabric:logPurchase(true, event.productId, event.type, event.id, event.cost, "USD");

      MOAIFacebook:logPurchase(event.cost, "USD");

      if event.verified then

         App.data:setValue(  "AnalyticsMgr.Gem.IAP.New", event.gemAmount );
         App.data:deltaValue("AnalyticsMgr.Gem.IAP",     event.gemAmount );

         MOAIFlurry:event(    "Buy-Gem-Success-Verified",
                              "numberPurchase",             tostring(event.numberPurchased),
                              "gemBefore by 10",            tostring(math.floor(event.gemBefore/10)*10),
                              "gamePlayed by 10",           tostring(math.max(math.floor(App.data:getGamePlayed()/10)*10,1)),
                              "gamePlayed by 100",          tostring(math.max(math.floor(App.data:getGamePlayed()/100)*100,1)),
                              "weeks",                      tostring(math.floor(since/7)),
                              "gem-quantity",               tostring(event.gemAmount),
                              "level",                      tostring(App.data:getCurrentPlayerLevel()),
                              "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) ),
                              "tango",                      tostring(self:_getTangoStatusExp())                                                   );

         --Dont care if we are authenticated or not
         if MOAITangoSdk:tangoHasSdkSupport() then

            MOAIFlurry:event(    "Buy-Gem-Success-Verified-Tango",
                                 "numberPurchase",             tostring(event.numberPurchased),
                                 "gemBefore by 10",            tostring(math.floor(event.gemBefore/10)*10),
                                 "gamePlayed by 10",           tostring(math.max(math.floor(App.data:getGamePlayed()/10)*10,1)),
                                 "gamePlayed by 100",          tostring(math.max(math.floor(App.data:getGamePlayed()/100)*100,1)),
                                 "weeks",                      tostring(math.floor(since/7)),
                                 "gem-quantity",               tostring(event.gemAmount),
                                 "level",                      tostring(App.data:getCurrentPlayerLevel()),
                                 "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) )              );

         else

            MOAIFlurry:event(    "Buy-Gem-Success-Verified-Not-Tango",
                                 "numberPurchase",             tostring(event.numberPurchased),
                                 "gemBefore by 10",            tostring(math.floor(event.gemBefore/10)*10),
                                 "gamePlayed by 10",           tostring(math.max(math.floor(App.data:getGamePlayed()/10)*10,1)),
                                 "gamePlayed by 100",          tostring(math.max(math.floor(App.data:getGamePlayed()/100)*100,1)),
                                 "weeks",                      tostring(math.floor(since/7)),
                                 "gem-quantity",               tostring(event.gemAmount),
                                 "level",                      tostring(App.data:getCurrentPlayerLevel()),
                                 "level by 10",                tostring(self:_By10(App.data:getCurrentPlayerLevel()) )              );

         end
      end
   end

end


----------------------------------------------------------------------

function AnalyticsMgr:_onIAPFailure( event )

   if not Debug.assertType(event, "table", "AnalyticsMgr:_onIAPSuccess -> event")
   or not Debug.assertType(event.requestId, "string", "AnalyticsMgr:_onIAPFailure -> event.requestId") then
      return;
   end

   local dataId = "iap." .. tostring(event.requestId) .. ".time";

   MOAIFlurry:event(       "IAP.failure",
                           "fail.reason",          tostring(event.reason),
                           "fail.code",            tostring(event.code),
                           "type",                 tostring(event.type),
                           "id",                   tostring(event.id),
                           "requestId",            tostring(event.requestId),
                           "productId",            tostring(event.productId),
                           "cost",                 tostring(event.cost),
                           "amount",               tostring(event.gemAmount),
                           "recovered",            tostring(event.recovered)     );

   MOAIFlurry:eventStop(   "IAP.attempt",
                           "ending",               "failure",
                           "fail.reason",          tostring(event.reason),
                           "fail.code",            tostring(event.code),
                           "time",                 tostring( self:_calcTimeDiffSec(self._tempData[ dataId ] , MOAISim.getDeviceTime())) );

   print(true, event.productId, event.type, event.id, event.cost, "USD")
   MOAIFabric:logPurchase(false, event.productId, event.type, event.id, event.cost, "USD");

   -- Provide detailed failure event
   if event.failureReason then
      MOAIFlurry:event( "IAP.failure-detailed",
                        "productId",       tostring(event.productId or event.id),
                        "reason-detailed", tostring(event.failureReason) );
      print("Failure for product: " .. tostring(event.productId or event.id) .. " reason:  "..tostring(event.failureReason));
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onLowMemoryWarning( event )

   local MIN_TIME_BETWEEN_LOWMEMORY_REPORT = 2; -- in seconds

   local lastFlurryReportTime = self._tempData["lowmemory.time"] or 0;
   local curTime = MOAISim.getDeviceTime();

   self._tempData["lowmemory.count"] = (self._tempData["lowmemory.count"] or 0) + 1;

   -- Report the event
   if event then

      if curTime > ( lastFlurryReportTime + MIN_TIME_BETWEEN_LOWMEMORY_REPORT ) then
         MOAIFlurry:event( "low-memory-warning",
                           "rough-memory-total", tostring(ProfilerMgr:getTotalMemoryUsed()),
                           "games", tostring(App.data:getValue("session.games")),
                           "state", tostring(App.data:getValue("App.data.crash.state")),
                           "count", tostring(self._tempData["lowmemory.count"]) );

         self._tempData["lowmemory.time"] = curTime;
      end

   end
end

----------------------------------------------------------------------

function AnalyticsMgr:_onTutorialStart( event )

   MOAIFlurry:eventStart(  "Tutorial", "ending", "quit" );

   MOAIAdjust:trackEvent(  App.adjustMap["Tutorial-Start"]  );

end


----------------------------------------------------------------------

function AnalyticsMgr:_onTutorialProgress( event )

--Since there is not really any stage, (our step are just time),
-- lets not send too much stuff
--[[
   if event then

      MOAIFlurry:event(       "Tutorial-Progress",
                              "phase",                               tostring(event.phase));

      MOAIAdjust:trackEvent(  App.adjustMap["Tutorial-Progress"],
                              "step",                                tostring(event.phase));


   else

      Debug.assert( event, "AnalyticsMgr:_onTutorialProgress -> event" );

   end
]]
end

----------------------------------------------------------------------

function AnalyticsMgr:_onTutorialFinish( event )

   MOAIAdjust:trackEvent(  App.adjustMap["Tutorial-Finish"]  );

   MOAIFlurry:eventStop(  "Tutorial",
                           "ending",         "completed" );
   MOAIFlurry:event(      "Tutorial-Completed" );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onTangoMessageAttempt( event )

   if event then

      local tangoType = AnalyticsMgr.MESSAGE_TO_TO_FLURRY_EVENT_ID[event.type];

      if tangoType then

         MOAIFlurry:eventStart(     tangoType,
                                    "ending",         "unknown",
                                    "count",          "unknown"           );

      end

      MOAIFlurry:eventStart(  "Tango-Message",
                              "ending",            "unknown",
                              "type",              tostring(event.type)    );

   else

      Debug.assert(event, "AnalyticsMgr:_onTangoMessageAttempt -> event");

   end
end

----------------------------------------------------------------------

function AnalyticsMgr:_onTangoMessageSuccess( event )

   if event then

      local tangoType = AnalyticsMgr.MESSAGE_TO_TO_FLURRY_EVENT_ID[event.type];

      if tangoType then

         MOAIFlurry:eventStop(  tangoType,
                                 "ending",         "success",
                                 "count",          tostring(event.count),
                                 "batch",          tostring(event.batch)      );

      end


      MOAIFlurry:eventStop(  "Tango-Message",
                              "ending",            "success",
                              "type",              tostring(event.type)       );

      if       event.type == "invite"
         and   type(event.recipientList) == "table" then

         for i,contact in pairs(event.recipientList) do

            if type(contact.getAccountId) == "function" then
               MOAIAdjust:trackEvent(  App.adjustMap["Invite-Sent"],
                                       "channel",                          "tango",
                                       "tID",                              tostring(contact:getAccountId())        );
               MOAIFabric:logInvite("Tango");
            end
         end

      end

   else

      Debug.assert( event,    "AnalyticsMgr:_onTangoMessageSuccess -> event" );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onTangoMessageFailure( event )

   if event then

      local tangoType = AnalyticsMgr.MESSAGE_TO_TO_FLURRY_EVENT_ID[event.type];

      if tangoType then

         MOAIFlurry:eventStop(  tangoType,
                                 "ending",         "failure",
                                 "count",          tostring(event.count),
                                 "batch",          tostring(event.batch)      );

      end

      MOAIFlurry:eventStop(  "Tango-Message",
                              "ending",            "failure",
                              "type",              tostring(event.type)       );
   else

      Debug.assert( event,    "AnalyticsMgr:_onTangoMessageFailure -> event" );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onStateFocus( event )

   if event then

      if event.state == "state/state-coin.lua" or event.state == "state/state-key.lua" then

         MOAIAdjust:trackEvent( App.adjustMap["View-Store"] );

      elseif event.state == "state/state-gem.lua" then

         MOAIAdjust:trackEvent( App.adjustMap["View-IAP-Store"] );

      end

   else

      Debug.assert( event,    "AnalyticsMgr:_onStateFocus -> event" );

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onOnlineMgrOnline( event )

   MOAIFlurry:event( "OnlineMgr-Online" );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onNativeAdRequest( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdRequest -> event" );
   Debug.assertType( event.count, "number", "AnalyticsMgr:_onNativeAdRequest -> event.count" );

   MOAIFlurry:event( "NativeAd-Request",
                     "count", tostring(event.count) );
end


function AnalyticsMgr:_onNativeAdResponse( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdResponse -> event" );
   Debug.assertType( event.result, "string", "AnalyticsMgr:_onNativeAdRequest -> event.result" );

   MOAIFlurry:event( "NativeAd-Response",
                     "result", tostring(event.result) );
end


function AnalyticsMgr:_onNativeAdImpressed( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdImpressed -> event" );
   Debug.assertType( event.title, "string", "AnalyticsMgr:_onNativeAdImpressed -> event.title" );
   Debug.assertType( event.provider, "string", "AnalyticsMgr:_onNativeAdImpressed -> event.provider" );

   MOAIFlurry:event( "NativeAd-Impressed",
                     "title", tostring(event.title),
                     "provider", tostring(event.provider) );
end


function AnalyticsMgr:_onNativeAdImpressedFinished( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdImpressedFinished -> event" );
   Debug.assertType( event.result, "string", "AnalyticsMgr:_onNativeAdImpressedFinished -> event.result" );
   Debug.assertType( event.title, "string", "AnalyticsMgr:_onNativeAdImpressedFinished -> event.title" );
   Debug.assertType( event.provider, "string", "AnalyticsMgr:_onNativeAdImpressedFinished -> event.provider" );
   Debug.assertType( event.url, "string", "AnalyticsMgr:_onNativeAdImpressedFinished -> event.url" );

   MOAIFlurry:event( "NativeAd-Impressed-Finished",
                     "result", tostring(event.result),
                     "title", tostring(event.title),
                     "provider", tostring(event.provider),
                     "url", tostring(event.url) );
end


function AnalyticsMgr:_onNativeAdClicked( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdClicked -> event" );
   Debug.assertType( event.title, "string", "AnalyticsMgr:_onNativeAdClicked -> event.title" );
   Debug.assertType( event.provider, "string", "AnalyticsMgr:_onNativeAdClicked -> event.provider" );

   MOAIFlurry:event( "NativeAd-Clicked",
                     "title", tostring(event.title),
                     "provider", tostring(event.provider) );
end


function AnalyticsMgr:_onNativeAdClickedFinished( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdClickedFinished -> event" );
   Debug.assertType( event.result, "string", "AnalyticsMgr:_onNativeAdClickedFinished -> event.result" );
   Debug.assertType( event.title, "string", "AnalyticsMgr:_onNativeAdClickedFinished -> event.title" );
   Debug.assertType( event.provider, "string", "AnalyticsMgr:_onNativeAdClickedFinished -> event.provider" );
   Debug.assertType( event.url, "string", "AnalyticsMgr:_onNativeAdClickedFinished -> event.url" );

   MOAIFlurry:event( "NativeAd-Clicked-Finished",
                     "result", tostring(event.result),
                     "title", tostring(event.title),
                     "provider", tostring(event.provider),
                     "url", tostring(event.url) );
end


function AnalyticsMgr:_onNativeAdReceivedInvalidAd( event )

   Debug.assertType( event, "table", "AnalyticsMgr:_onNativeAdReceivedInvalidAd -> event" );
   Debug.assertType( event.title, {"string", "nil"}, "AnalyticsMgr:_onNativeAdReceivedInvalidAd -> event.title" );
   Debug.assertType( event.provider, {"string", "nil"}, "AnalyticsMgr:_onNativeAdReceivedInvalidAd -> event.provider" );
   Debug.assertType( event.clickUrl, {"string", "nil"}, "AnalyticsMgr:_onNativeAdReceivedInvalidAd -> event.clickUrl" );

   MOAIFlurry:event( "NativeAd-ReceivedInvalidAd",
                     "title", tostring(event.title),
                     "provider", tostring(event.provider),
                     "clickUrl", tostring(event.clickUrl) );
end

----------------------------------------------------------------------

function AnalyticsMgr:_onDroneBayUnlock( event )

   if event and event.level and event.cost then

      MOAIFlurry:event( "Drone-Bay-Unlock",
                        "level", tostring(event.level),
                        "cost",  tostring(event.cost) );
   else
      Debug.assert(event, "AnalyticsMgr:_onDroneBayUnlock -> event")
      Debug.assert(event.level, "AnalyticsMgr:_onDroneBayUnlock -> event.level")
      Debug.assert(event.cost, "AnalyticsMgr:_onDroneBayUnlock -> event.cost")
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onDroneBuild( event )

   if event and event.level and event.cost and event.side and event.dType then

      MOAIFlurry:event( "Drone-Build",
                        "side",  tostring(event.side),
                        "type",  tostring(event.dType),
                        "level", tostring(event.level),
                        "cost",  tostring(event.cost) );
   else
      Debug.assert(event, "AnalyticsMgr:_onDroneBuild -> event")
      Debug.assert(event.level, "AnalyticsMgr:_onDroneBuild -> event.level")
      Debug.assert(event.cost, "AnalyticsMgr:_onDroneBuild -> event.cost")
      Debug.assert(event.side, "AnalyticsMgr:_onDroneBuild -> event.side")
      Debug.assert(event.dType, "AnalyticsMgr:_onDroneBuild -> event.dType")
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onDroneUpgrade( event )

   if event and event.level and event.dType then

      MOAIFlurry:event( "Drone-Upgrade",
                        "type",  tostring(event.dType),
                        "level", tostring(event.level)	);
   else
      Debug.assert(event, "AnalyticsMgr:_onDroneUpgrade -> event")
      Debug.assert(event.level, "AnalyticsMgr:_onDroneUpgrade -> event.level")
      Debug.assert(event.dType, "AnalyticsMgr:_onDroneUpgrade -> event.dType")
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onDroneEvolve( event )

   if event and event.level and event.cost and event.dType then

      MOAIFlurry:event( "Drone-Evolve",
                        "type",  tostring(event.dType),
                        "level", tostring(event.level),
                        "cost",  tostring(event.cost) );
   else
      Debug.assert(event, "AnalyticsMgr:_onDroneEvolve -> event")
      Debug.assert(event.level, "AnalyticsMgr:_onDroneEvolve -> event.level")
      Debug.assert(event.cost, "AnalyticsMgr:_onDroneEvolve -> event.cost")
      Debug.assert(event.dType, "AnalyticsMgr:_onDroneEvolve -> event.dType")
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onPlayerChooseData( event )

   -- Which data did players choose? local or cloud?

   MOAIFlurry:event( "Account-Sync-Choose",
                     "choose", tostring(event.data) );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onPlayerChooseSuccess( event )

   -- There was a success when choosing a certain data profile.

   MOAIFlurry:event( "Account-Sync-Choose",
                     "confirm_data_sync", tostring(event.data) );

end

----------------------------------------------------------------------

function AnalyticsMgr:_onDataMerged( event )

   -- event.strategy, event.replayStatus

   if event.replayStatus then

      MOAIFlurry:event( "Account-Sync-Merge",
                        "strategy", tostring(event.strategy),
                        "replay_status", tostring(event.replayStatus) );

   else

      MOAIFlurry:event( "Account-Sync-Merge",
                        "strategy", tostring(event.strategy) );
   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onFileDownload( event )

   if event.state == "started" then

      MOAIFlurry:event( "File-Download-2",
                        "state", event.state,
                        "url", event.url );


   elseif event.state == "finished" then

      MOAIFlurry:event( "File-Download-2",
                        "state", event.state,
                        "url", event.url,
                        "fileSaved", tostring(event.saved) );

   elseif event.state == "failed" then

      MOAIFlurry:event( "File-Download-2",
                        "state", event.state,
                        "url", event.url );

   else

      Debug.error("Invalid event state \"" .. tostring(event.state) .. "\" in _onFileDownload.");

   end

end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameStart( event )
   print("MOAIFabric:logLevelStart(\"Standard\");");
   MOAIFabric:logLevelStart("Standard");
end

----------------------------------------------------------------------

function AnalyticsMgr:_onGameOver( event )
   MOAIFabric:logLevelEnd("Standard", event.score, true);
end
