require('app/server/tango')


local Base = TangoServer;
CompetitorsManager = Base:new();

function CompetitorsManager:new()
   return Base.new(self);
end

function CompetitorsManager:makeSuccessCallback(callObj, callSuccess, result, successMessage)
   return function(result)
      local response;
      if result then
         response = MOAIJsonParser.decode ( result )
      end
      print(successMessage);
      self:callCallback(callObj, callSuccess, response);
   end
end

function CompetitorsManager:makeFailureCallback(callObj, callFailure, code, text, failureMessage)
   return function(code, text)
      print('inboxManager failure callback: code:' .. code ..',text:' .. ',msg:'..failureMessage);
      self:callCallback(callObj, callFailure, code, text);
   end
end
function CompetitorsManager:getCompetitors(callObj, maxUsers, excludeUserIds, callSuccess, callFailure)

   local requestData = {}
   requestData["MaxUsers"] = maxUsers
   requestData["ExcludeUserIds"] = excludeUserIds
   dataString = MOAIJsonParser.encode(requestData)

   local requestOptions = {
      requestClass = MOAITangoGetCompetitorsRequest,
      requestData = dataString,
      successFunc = self:makeSuccessCallback(callObj, callSuccess, result, "get competitors  succeeded, response is:\n"),
      failureFunc = self:makeFailureCallback(callObj, callFailure, code, text, "get competitors failed:\n"),
   }

   NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

end
