
require('app/server/tango')

----------------------------------------------------------------------

local Base           = TangoServer;
CarInfoUploader      = Base:new();

--TODO: Centralize (for now, there is duplicate in the retriever)
local CAR            = "carInfo2";

----------------------------------------------------------------------

function CarInfoUploader:new( accountId, carInfo )

   Debug.assert( accountId,   "CarInfoUploader:new ->  accountId"       );
   Debug.assert( carInfo,     "CarInfoUploader:new ->  carInfo"         );

   local uploader          = Base.new(self);

   uploader.myAccountId    = accountId;

   uploader.carInfo        = carInfo or 1;

   return uploader;

end

----------------------------------------------------------------------

function CarInfoUploader:exec( callObj, callSuccess, callFailure )

   if OnlineMgr:isOnline() then

      if self.myAccountId and self.carInfo then

         local successFunc = function( result )

            self:callCallback( callObj, callSuccess, self.level);

         end

         local failureFunc = function(code, message)

            self:callCallback( callObj,  callFailure, code, message  );

         end

         local metricData = {
            {
               metric = CAR,
               value = self.carInfo,
               rollups = {
                  MOAITangoMetrics.MAX,
                  MOAITangoMetrics.MAX_THIS_WEEK,
                  MOAITangoMetrics.MAX_LAST_WEEK,
                  MOAITangoMetrics.MAX_THIS_DAY,
                  MOAITangoMetrics.MAX_LAST_DAY,
                  MOAITangoMetrics.MAX_THIS_HOUR,
                  MOAITangoMetrics.MAX_LAST_HOUR
               }
            }
         }

         local requestOptions = {
            requestClass = MOAITangoSetRawMetricsRequest,
            requestData = {metricData},
            successFunc = successFunc,
            failureFunc = failureFunc,
         }

         NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

   else

      delay(   0.1,
               function ()
                  self:callCallback( callObj,  callFailure, -1, "Missing info"  );
            end   );

end


   else

      delay(   0.1,
               function ()
                  self:callCallback( callObj,  callFailure, -1, "You are offline"  );
               end   );

   end

end

----------------------------------------------------------------------
