--
require('app/server/tango')

----------------------------------------------------------------------

local Base        = TangoServer;
ContactRetriever  = Base:new();

----------------------------------------------------------------------

function  ContactRetriever:new(  )

   local o     = Base.new(self);
   return o;

end


local fake =
{
   {"Adam","Smith"},
   {"AdreanContreras","AdrianAoun"},
   {"AhmadHamzawiAladdin","RajabAlainMaksoud"},
   {"AlbertShinAllaMezhvinsky","AmitAdvaniAnandRamesh"},
   {"AnastasiosKasiolasAndyTianAngelaChenAngeliqueNikitasAnthonySciola"},
   {"AnthonyYolAriPathi","AviGoshenAvniShahAymanItaniBahjatMirza"},
   {"BartonSanoBaudouinCORMANBenjaminJanofskyBernard","MoonBernhardSuterBettyNguyenBillMooney"},
   {"BrendanGarnerCatherinaBalloutCatherineMooreCathyB","eaupainCesarBocanegraCharbelKhoneisserCharlesMassinChristineMoon"},
   {"ChristineYoonChristopherRussellChristosApartoglouClemens","BuehlingCopyrightServiceCrisPerdueDaliKilaniDaniloAlibertiDaveDePaulis"},
   {"DavidKahnDavidLandhuisDavidStiverDinaH.SherifDylan","DunnanEdwinTangehabhussenElenaMigunovaEliasDarwisheliekhawand"},
   {"EratoSchmidtEricSettonEricTholoméEricWoodEyalManor","FaYoeuFadwaMohannaFaisalJawdatFaresGhandourFarzanFallahFerhatBuyukkokten"},
   {"HaddadFrankBarchardFrankySzeFredSauerGauravDesaiGeor","geSalemGokulRajaramGrahamSpencer"},
   {"GregButterfieldGusTaiGuyTavorHabibHaddadHannahMestelH","elenRileyHelenSchochHongZhangHuanNguyenHunterWalkIanWang"},
   {"IanWangIgalPerelmanInderjeetSinghIoannisTsochantaridi","sIssamBazzijjJamieGerdesJamieOdellJanetePerezJasonYaoJean"},
   {"PierreRabbathJenniferDonahoeJimmyClidarasJingJiJingxi","LiJodyWyattJohnChenJohnLutherJohn W.OsvaldJonathanFlesherJosephBironas"},
   {"DavidPirnazarKarimFarisKarimKaramKevinYoungKostasKass","arasKrishnaGadepalliLarsBakLaszloBock"},
   {"LeoJiangLiboSongLoganHanksLorenNewmanLuigiChronoMakra","mMansourManosMoschousMarcTohmeMaria del MarAlonsoMarinaShilmanMarioGuajardo"},
   {"MartinSchmidtMattCuttsMatthewJaquishMaureenHernandezm","ayamalekMichaelSantulloMichelMailhotMichelleMikeMazaMohammadSharafeddineNagendraModadugu"},
   {"NagiSalloumNavneetSinghNickANicoleHartvigNikeshMistry","NikoVuoriNivEfronNoamBenHaimNoelleOdedPelledOliviaHatalsky"},
   {"OriGershonyPabloPaniaguaPaulAutranPaulBottoPaulGrayPa","ulHullPeterSarossyPhyllisGoodPhyllisGoodPoojaBansalPramodSharma"},
   {"RamiroEstrugoRandyNealsRaoulBardawilRaviGampalaRenatoI","wersenRepairmanBillRezaHelaliRicardoJenezRichardIphoneRickKlauRobMcElvaney"},
   {"RodolpheKatraRonRabbatRongOuRoniZeigerRonyHONEINRoulaF","ayadSameerAjmaniSAmerEadSamirNaikSandeepRonaldSarahMoussa"},
   {"ScottGlobusShaiMagzimofSherynAngSierraMichels Slettvet","SinaMiriSteveLawrenceSteveParkisSudhir KumarRama RaoSunilPatroTarekSaadTeijaAhlfors"},
   {"TerenceFungTimboDraysenToddArnoldTonyFeghaliTrevorSchr","oederTyLimUriRazUriRazVaibhavAmbugaVinitPatwaVishalKapoor"},
   {"VoiceMailWadihRennoWalterSusongWielandHolfelderWifeyXu","LiuYa-BingChuYaowuXuYasminaBrihiYevgeniLitvinZhenYuSha"},
}
----------------------------------------------------------------------

function ContactRetriever:exec( callObj, successFunc, failureFunc )

   assert( LoginMgr:isTango() );

   self.contacts = {};

   if OnlineMgr:isOnline() then

      local requestSuccessFunc = function( contacts )

         print("ContactRetriever:exec", "success");

         for _, c in ipairs(contacts) do

            if c:isPlatformSupported(MOAITangoContact.PLATFORM_IOS)
            or c:isPlatformSupported(MOAITangoContact.PLATFORM_ANDROID) then
               table.insert(self.contacts, c);
            end

         end

         -- for i,tbl in ipairs(fake) do
         --    local  c   =  MOAITangoContact.new();

         --    c:setFirstName(tbl[1]);
         --    c:setLastName(tbl[2]);
         --    c:setAccountId("fake"..i);

         --    --It should be already saved but be 100% safe
         --    c:setAppInstalled(false);

         --    table.insert(self.contacts, c);

         -- end

         if successFunc then
            successFunc(callObj, self.contacts);
         end

      end

      local requestFailureFunc = function(code, message)

         print("ContactRetriever:exec", "failed");
         if failureFunc then
            failureFunc(callObj, code, message);
         end

      end

      local requestOptions = {
         requestClass = MOAITangoContactsRequest,
         requestData = {},
         successFunc = requestSuccessFunc,
         failureFunc = requestFailureFunc,
      }

      NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

   else

      -- Use a timer to create be more consistent with the authenticate mode
      self.timer = MOAITimer.new();
      self.timer:setSpan( 0.1 );
      self.timer:setListener( MOAITimer.EVENT_TIMER_END_SPAN,
            function ()
               self.timer:stop( );
               self.timer = nil;

               if failureFunc then
                  failureFunc( callObj, -1, "You are Offline" );
               end

      end
      );
      self.timer:start();


   end


end

----------------------------------------------------------------------
