--
require('app/server/tango')

----------------------------------------------------------------------

local Base        = TangoServer;
ProfileRetriever  = Base:new();

----------------------------------------------------------------------

function  ProfileRetriever:new(  )

   local o     = Base.new(self);
   return o;

end

----------------------------------------------------------------------

function ProfileRetriever:exec( callObj,  successFunc, failureFunc )

   assert( LoginMgr:isTango() );

   print("ProfileRetriever:exec" );
   if OnlineMgr:isOnline() then

      local requestSuccessFunc = function( profile )

         self.profile = profile;

         print("ProfileRetriever:exec", "success" );
         if successFunc then
            successFunc(callObj, self.profile);
         end

      end

      local requestFailureFunc = function(code, message)

         print("ProfileRetriever:exec", "failed" );
         if failureFunc then
            failureFunc(callObj, code, message);
         end

      end

      local requestOptions = {
         requestClass = MOAITangoGetMyProfileRequest,
         requestData = {},
         successFunc = requestSuccessFunc,
         failureFunc = requestFailureFunc,
      }

      NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

   else

      -- Use a timer to create be more consistent with the authenticate mode
      self.timer = MOAITimer.new();
      self.timer:setSpan( 0.1 );
      self.timer:setListener( MOAITimer.EVENT_TIMER_END_SPAN,
            function ()
               self.timer:stop( );
               self.timer = nil;

               if failureFunc then
                  failureFunc( callObj, -1, "You are Offline" );
               end

      end
      );
      self.timer:start();

   end

end

----------------------------------------------------------------------
