require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionAddFreebie     = Base:_new("DataTransactionAddFreebie");

----------------------------------------------------------------------

function DataTransactionAddFreebie:new( data, type, amount, reason )

   Debug.assert(data and type and amount);

   local task     = Base.new(  self );
   task.type      = type or "unknown";
   task.amount    = amount;
   task.reason    = reason;

   return task;

end

----------------------------------------------------------------------

function DataTransactionAddFreebie:testMe()

   print("DataTransactionAddFreebie:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionAddFreebie:buildValues(data)

   if self.amount and self.amount > 0 then

      self.newAmount          = data:getValue(self.type, 0) + self.amount;
      self._values            =  {};
      self._values[self.type] =  self.newAmount;

      return self._values;

   else

      Debug.assert( amount and amount > 0 and amount < 100000 );

   end

end

----------------------------------------------------------------------

function DataTransactionAddFreebie:onSuccess(data)

   MOAIFlurry:event(    "More-Freebies",
                        "type",              self.type or "unknown",
                        "added",             tostring(self.amount),
                        "total",             tostring(self.newAmount),
                        "reason",            self.reason or "unknown"      );

   EventMgr:postEvent( {type = self.type, reason = self.reason or "unknown"}, "More-Freebies");

end


----------------------------------------------------------------------
