require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionAddGem         = Base:_new("DataTransactionAddGem");

----------------------------------------------------------------------

function DataTransactionAddGem:new( data, amount, type )

   local task  = Base.new(  self );
   task.amount = amount;
   task.type   = type;
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionAddGem:testMe()

   print("DataTransactionAddGem:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionAddGem:buildValues(data)

   if self.amount > 0 then

      local gem      = data:getValue("gem") + self.amount;

      self._values   =  {    gem   = gem   };
                                               
      return self._values;
      
   end   

end

----------------------------------------------------------------------

function DataTransactionAddGem:onSuccess(data)

   if self.amount > 0 then

      EventMgr:postEvent( { type=self.type, gem=self.amount }, "More-Gem" );

   end
end

----------------------------------------------------------------------
