require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionAddGold        = Base:_new("DataTransactionAddGold");

----------------------------------------------------------------------

function DataTransactionAddGold:new( data, amount, type )

   local task  = Base.new(  self );
   task.amount = amount;
   task.type   = type;
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionAddGold:testMe()

   print("DataTransactionAddGold:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionAddGold:buildValues(data)

   if self.amount > 0 then

      local gold      = data:getValue("gold") + self.amount;

      self._values   =  {    gold   = gold   };
                                               
      return self._values;
      
   end   

end

----------------------------------------------------------------------

function DataTransactionAddGold:onSuccess(data)

   MOAIFlurry:event(    "More-Gold",
                        "type",          self.type or "unknown",
                        "amount-gold",   ""..self.amount           );
   
end

----------------------------------------------------------------------
