require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionAddKey         = Base:_new("DataTransactionAddKey");

----------------------------------------------------------------------

function DataTransactionAddKey:new( data, amount, type )

   local task  = Base.new(  self );
   task.amount = amount;
   task.type   = type;
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionAddKeytestMe()

   print("DataTransactionAddKey:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionAddKey:buildValues(data)

   if self.amount > 0 then

      local key      = data:getValue("key") + self.amount;
      local count    = data:getValue("weekly-gifts-collected", 0);
print("DataTransactionAddKey:buildValues - Before", count, self.type)
      if self.type == "Gift" then
         count = count + self.amount;
      end
print("DataTransactionAddKey:buildValues - After", count)
      self._values                              =  {};
      self._values["key"]                       = key;
      self._values["weekly-gifts-collected"]    = count;

      return self._values;
   end   

end

----------------------------------------------------------------------

function DataTransactionAddKey:onSuccess(data)

   MOAIFlurry:event(    "More-Key",
                        "type",          self.type or "unknown",
                        "amount-key",    ""..self.amount           );
end


----------------------------------------------------------------------
