require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                     	= DataTransaction;
DataTransactionAddRewardLevel		= Base:_new("DataTransactionAddRewardLevel");

print("_G[DataTransactionUpgradeMainWeapon]",DataTransactionAddRewardLevel, _G, _G.DataTransactionAddRewardLevel, _G["DataTransactionAddRewardLevel"] );
print("more", _G[DataTransactionAddRewardLevel]);

----------------------------------------------------------------------

function DataTransactionAddRewardLevel:new( data, level )

   local task		= Base.new(  self );
	local count		= level or 1;
	
	task.curLevel		= data:getCurrentPlayerLevel();
   task.rwdLevel		= data:getCurrentRewardLevel();
	task.levelUpCount	= count;
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionAddRewardLevel:buildValues( data )

	local curLevel		= self.curLevel;
	local rwdLevel		= self.rwdLevel;
	
	if curLevel ~= data:getCurrentPlayerLevel() then
		
		curLevel = data:getCurrentPlayerLevel();
		rwdLevel = data:getCurrentRewardLevel();
	end
	
	if curLevel > rwdLevel then
		
		self._values	=	{};
		
		self._values.rewardLevel = rwdLevel + 1;
		
		self.reward = data:getLevelReward(self._values.rewardLevel);

		if self.reward.gold > 0 then
		
			local gold = data:getValue("gold") + self.reward.gold;

			self._values.gold = gold;
		end
	
		if self.reward.gem > 0 then
		
			local gem = data:getValue("gem") + self.reward.gem;

			self._values.gem = gem;
		end
	
		self.keys = 0;

		if self.reward.key then

         if self.reward.key > 0 then

            self._values.key = data:getValue("key") + self.reward.key;

         elseif self.reward.key < 0 then

            self.keys = data:getKeyMaxRegen() - data:getKeyCount();

            if self.keys > 0 then

               self._values.key = data:getKeyMaxRegen();
            end

         end
		end
		
		return self._values;
	
	end

end


----------------------------------------------------------------------

function DataTransactionAddRewardLevel:onSuccess( data )

	local reward = self.reward;
	
	if reward then
	
		if reward.gold > 0 then
			
			EventMgr:postEvent( {  gold=reward.gold }, "level-reward" );

         MOAIFlurry:event(    "More-Gold",
                              "type",         "level",
                              "amount-gold",   ""..reward.gold           );

		end

		if reward.gem > 0 then

			EventMgr:postEvent( {  gem=reward.gem }, "level-reward" );

         EventMgr:postEvent( { type="level", gem=reward.gem }, "More-Gem" );

      end

		if self.keys > 0 then

			EventMgr:postEvent( {  keys=self.keys }, "level-reward" );
		end
	
		if reward.unlockVehc > 1 then
			
			if data:getCurrentRewardLevel() == data:getVehicleUnlockableLevel(reward.unlockVehc) and
				not App.data:isPlayerVehicleUnlocked(reward.unlockVehc) then
			
				EventMgr:postEvent( {  unlockVehc=reward.unlockVehc }, "level-reward" );
			end
		end
	
		if reward.unlockMission then
			
			if data:getCurrentRewardLevel() == data:getMissionUnlockLevel() then
				
				EventMgr:postEvent( {  unlockMission=true }, "level-reward" );
			end
		end
		
		if reward.unlockDaily then
			
			if data:getCurrentRewardLevel() == data:getDailyUnlockLevel() then
				
				EventMgr:postEvent( {  unlockDaily=true }, "level-reward" );
			end
		end
		
		if reward.unlockRevive then
			
			if data:getCurrentRewardLevel() == data:getReviveUnlockLevel() then
				
				EventMgr:postEvent( {  unlockRevive=true }, "level-reward" );
			end
		end
		
		if reward.unlockScoreBonus > 0 then
			
			EventMgr:postEvent( {  scoreBonus=reward.unlockScoreBonus }, "level-reward" );
		end
	
	end

end

----------------------------------------------------------------------
