require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionBuyGold        = Base:_new("DataTransactionBuyGold");

----------------------------------------------------------------------

function DataTransactionBuyGold:new( data,  index  )

   local task  = Base.new(  self );
   --save the cost and reward here in case we tweak and the user retry the transaction
   task.index        = index;
   task.rewardGold   = data:getStoreGoldAmount( index );
   task.costGem      = ((( data:getStoreGoldCost( index ) or {} ).gem) or 0);
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionBuyGold:testMe()

   print("DataTransactionBuyGold:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionBuyGold:buildValues(data)

   local gem   = data:getGemCount()  or 0;
   local gold  = data:getGoldCount() or 0;
   
   if  gem >= self.costGem then

      if self.rewardGold >= 0 then
      
         self._values               =  {};
         self._values["gold"]       = math.max( gold+self.rewardGold,   0        );
         self._values["gem"]        = math.max( gem-self.costGem,       0        );
      
         return self._values;

      end
   end
   
end

----------------------------------------------------------------------

function DataTransactionBuyGold:onSuccess(data)

   EventMgr:postEvent({ item     = "gold",
                        index    = self.index  },
                        "buy-success"              );


   EventMgr:postEvent({ reason    = "buy-gold",
                        cost      = self.costGem  },
                        "Spend-Gem"                   );


   MOAIFlurry:event(    "Buy-Gold",
                        "index",          ""..self.index,
                        "cost-gem",       ""..self.costGem,
                        "amount-gold",    ""..self.rewardGold,
                        "gold",           ""..self._values.gold,
                        "gem",            ""..self._values.gem );

   MOAIFlurry:event(    "More-Gold",
                        "type",          "store",
                        "amount-gold",   ""..self.rewardGold         );
                        
   

end

----------------------------------------------------------------------
