require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionBuyKey         = Base:_new("DataTransactionBuyKey");

----------------------------------------------------------------------

function DataTransactionBuyKey:new( data,  index  )


   local task  = Base.new(  self );
   --save the cost and reward here in case we tweak and the user retry the transaction
   task.index     = index;
   task.rewardKey = data:getStoreKeyAmount( index );
   task.costGem   = ((( data:getStoreKeyCost( index ) or {} ).gem)  or 0);
   task.costGold  = ((( data:getStoreKeyCost( index ) or {} ).gold) or 0);
   
print( "DataTransactionBuyKey:new", index, task.rewardKey, task.costGem, task.costGold );

   return task;

end

----------------------------------------------------------------------

function DataTransactionBuyKey:testMe()

   print("DataTransactionBuyKey:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionBuyKey:buildValues(data)

   local gem   = data:getGemCount()  or 0;
   local gold  = data:getGoldCount() or 0;
   local key   = data:getKeyCount()  or 0;
   
   print("DataTransactionBuyKey:exec", key,self.rewardKey);
   if       gem  >= self.costGem 
      and   gold >= self.costGold  then

      if self.rewardKey >= 0 then
      
         self._values            =  {};
         self._values["key"]     = math.max( key+self.rewardKey,     0        );
         self._values["gold"]    = math.max( gold-self.costGold,     0        );
         self._values["gem"]     = math.max( gem-self.costGem,       0        );
      
   print("DataTransactionBuyKey:exec-3", self._values["key"], self._values["gem"] );
   



         return self._values;

      end
   end
   
end

----------------------------------------------------------------------


function DataTransactionBuyKey:onSuccess(data)

   assert(data);

   EventMgr:postEvent({ item     = "key",
                        index    = self.index,
                        cost     = self.costGem    },
                        "buy-success"          );

   MOAIFlurry:event(    "Buy-Key",
                        "index",          ""..self.index,
                        "cost-gem",       ""..self.costGem,
                        "cost-gold",      ""..self.costGold,
                        "amount-key",     ""..self.rewardKey,
                        "gold",           ""..self._values.gold,
                        "gem",            ""..self._values.gem      );

   MOAIFlurry:event(    "More-Key",
                        "type",          "store",
                        "amount-key",   ""..self.rewardKey           );
                        
   if self.costGem > 0 then
      EventMgr:postEvent({ reason    = "buy-key",
                           cost      = self.costGem  },
                           "Spend-Gem"                   );
   end

   if self.costGold > 0 then
      MOAIFlurry:event(    "Spend-Gold",
                           "type",          "buy-key",
                           "amount-gold",   ""..self.costGold           );
   end
      
end

----------------------------------------------------------------------
