require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                       = DataTransaction;
DataTransactionConsumeConsumable = Base:_new("DataTransactionConsumeConsumable");

----------------------------------------------------------------------

function DataTransactionConsumeConsumable:new( data, index, freeUse )

   Debug.assertType(index, "number", "DataTransactionConsumeConsumable:new -> index");

	if	data and index then

		local task				= Base.new( self );

      task.index           = index;
      task.consumableId    = data:createConsumableId(index);
      task.template        = ConsumableMgr:getTemplate(index);
      task.freeUse         = freeUse;

      if task.freeUse == nil then
         task.freeUse = false;
      end
      
		return task;
	end

end

----------------------------------------------------------------------

function DataTransactionConsumeConsumable:buildValues( data )

   Debug.assert(self.template, "DataTransactionConsumeConsumable:buildValues - > template nil");

   local inventory   = data:getValue(self.consumableId, 0);

   self._values      = {};

   if self.freeUse then
   	self._values[self.consumableId]  = inventory;
   elseif inventory - 1 >= 0 then
      self._values[self.consumableId]  = inventory - 1;
   end

   return self._values;

end

----------------------------------------------------------------------

function DataTransactionConsumeConsumable:onSuccess( data )

	if self.template then
      EventMgr:postEvent( {type=self.template.type}, "consumable-used" );
	end

end

----------------------------------------------------------------------
