require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionConsumeKey     = Base:_new("DataTransactionConsumeKey");

----------------------------------------------------------------------

function DataTransactionConsumeKey:new( data )

   local task  = Base.new(  self, data );
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionConsumeKey:testMe()

   print("DataTransactionConsumeKey:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionConsumeKey:buildValues(data)

   local key = data:getValue("key");
   
   if key > 0 then

      local keyTimeStamp = data:getValue("keyTimeStamp");
      key = key - 1;
      
      if not ( keyTimeStamp and keyTimeStamp > 0 ) then
         keyTimeStamp = data:getKeyReferenceTime();
      end

      self._values =  {    key            = key,
                           keyTimeStamp   = keyTimeStamp    };

      return self._values;
      
   end   

end

----------------------------------------------------------------------

function DataTransactionConsumeKey:onSuccess(data)

   EventMgr:postEvent(  {},       "consume-key-success"   );

end


----------------------------------------------------------------------
