require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                          = DataTransaction;
DataTransactionDailyCollectReward   = Base:_new("DataTransactionDailyCollectReward");

----------------------------------------------------------------------

function DataTransactionDailyCollectReward:new( data )

print("DataTransactionDailyCollectReward:new");

   local task           = Base.new(  self );
   task.type            = type;
   task.dailyRewardGem  = math.max( data:getValue("dailyRewardGem")  or 0, 0 );
   task.dailyRewardGold = math.max( data:getValue("dailyRewardGold") or 0, 0 );

   return task;

end

----------------------------------------------------------------------

function DataTransactionDailyCollectReward:testMe()

   print("DataTransactionDailyCollectReward:testMe()");

end

----------------------------------------------------------------------

function DataTransactionDailyCollectReward:buildValues(data)

   -- Do we have any reward
   if    self.dailyRewardGem   > 0
      or self.dailyRewardGold  > 0     then

      self._values                     = {};
      self._values["gold"]             = data:getGoldCount() + self.dailyRewardGold;
      self._values["gem"]              = data:getGemCount()  + self.dailyRewardGem;
      self._values["dailyRewardGem"]   = 0;
      self._values["dailyRewardGold"]  = 0;

      return self._values;

   end

end

----------------------------------------------------------------------

function DataTransactionDailyCollectReward:onSuccess(data)

   EventMgr:postEvent(  {
                           gold  = self.dailyRewardGold
                        ,  gem   = self.dailyRewardGem
                        }
                        ,  "daily-reward-collected"   );

   if self.dailyRewardGold  > 0 then
      MOAIFlurry:event(    "More-Gold",
                           "type",          "daily-reward",
                           "amount-gold",   ""..self.dailyRewardGold         );
   end

   if self.dailyRewardGem > 0 then

      EventMgr:postEvent( { type="daily-reward", gem=self.dailyRewardGem }, "More-Gem" );

   end

end

----------------------------------------------------------------------
