require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionIapVerify      = Base:_new("DataTransactionIapVerify");

----------------------------------------------------------------------

function DataTransactionIapVerify:new( data, result )

   local task  = Base.new(  self );
   task.result = result;
   task.alwaysExecute = true;

   return task;

end

----------------------------------------------------------------------

function DataTransactionIapVerify:testMe()

   print("DataTransactionIapVerify:testMe()");

end

----------------------------------------------------------------------

function DataTransactionIapVerify:buildValues(data)

   if self.result == "verified" then

      local count      = data:getValue("iap-verified",0) + 1;

      self._values   =  {};
      self._values["iap-verified"] = count;

      return self._values;

   elseif self.result == "fake" then

      local count      = data:getValue("iap-fake", 0) + 1;

      self._values   =  {};
      self._values["iap-fake"] = count;

      return self._values;

   end

end

----------------------------------------------------------------------

function DataTransactionIapVerify:onSuccess( data )

   MOAIFlurry:event( "DataTransactionIapVerify",
                     "result",                     tostring(self.result),
                     "iap-verified",               tostring(data:getValue("iap-verified",0)),
                     "iap-fake",                   tostring(data:getValue("iap-fake",0))               );

   if self.result == "fake" then

      MOAIFlurry:event( "Thief" );

   end

end

----------------------------------------------------------------------
