require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionInvite         = Base:_new("DataTransactionInvite");

----------------------------------------------------------------------

function DataTransactionInvite:new( data, destination, rewardGold, rewardGem )

   local task              = Base.new(  self );
   task.destination        = destination;
   task.rewardGold         = rewardGold or 0;
   task.rewardGem          = rewardGem  or 0;
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionInvite:testMe()

   print("DataTransactionInvite:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionInvite:buildValues(data)

   if self.rewardGold > 0 or self.rewardGem > 0 then

      local gold        = data:getValue("gold") + self.rewardGold;
      local gem         = data:getValue("gem")  + self.rewardGem;
      --Assume it is gold
      local totalReward = data:getValue("invite-total-reward",0) + self.rewardGold;

      self._values   =  {     gold              = gold
                        ,     gem               = gem };
      self._values["invite-total-reward"] = totalReward;
                                               
      return self._values;
      
   end   

end

----------------------------------------------------------------------

function DataTransactionInvite:onSuccess(data)

   if self.rewardGem > 0 then

      EventMgr:postEvent( { type="invite", gem=self.rewardGem }, "More-Gem" );

   end
   
   if self.rewardGold  > 0 then
      MOAIFlurry:event(    "More-Gold",
                           "type",          "invite",
                           "amount-gold",   ""..self.rewardGold           );
   end
   
end

----------------------------------------------------------------------
