require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base                    = DataTransaction;
DataTransactionSpendGem       = Base:_new("DataTransactionSpendGem");

----------------------------------------------------------------------

function DataTransactionSpendGem:new( data, amount, type )

print("DataTransactionSpendGem:new", amount);
   local task  = Base.new(  self );
   task.amount = math.max(amount or 0, 0);
   task.type   = type;
   
   return task;

end

----------------------------------------------------------------------

function DataTransactionSpendGem:testMe()

   print("DataTransactionSpendGem:testMe()");
   
end

----------------------------------------------------------------------

function DataTransactionSpendGem:buildValues(data)

   local gem   = data:getValue("gem") - self.amount;

   if gem >= 0 and self.amount > 0 then
      
      self._values = {    gem   = gem   };
          
      return self._values;
      
   end 

end

----------------------------------------------------------------------

function DataTransactionSpendGem:onSuccess(data)

   if self.amount > 0 and self._values['gem'] then

      EventMgr:postEvent({ reason    = self.type or "unknown",
                           cost      = self.amount  },
                           "Spend-Gem"                            );

   end

end

----------------------------------------------------------------------
