require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base									= DataTransaction;
DataTransactionUpdateBountyReward	= Base:_new("DataTransactionUpdateBountyReward");

----------------------------------------------------------------------

function DataTransactionUpdateBountyReward:new( data, id )

   Debug.assert(data, "DataTransactionUpdateBountyReward -> data");

   local task		= Base.new( self );
	
	task.id			= id;
	task.curCount	= data:getBountyRewardCount();
	task.maxCount	= math.min(AbTestMgr:getBountyCap(), BountyMgr:getBountySelectionSize());
   task.reward		= (App.data:getBountyReward() or {}).gem;

   return task;

end

----------------------------------------------------------------------

function DataTransactionUpdateBountyReward:buildValues( data )

	if self.id then

		self._values = {};

		if self.id == "reset" then

			self._values["bountyPlayerCount"] = 0;
		else

			if self.curCount >= self.maxCount then
				return nil;
			end

			if BountyMgr:isBountyEntryCollectReady(self.id) then
				self._values["bountyPlayerCount"]	= self.curCount + 1;
				self._values["gem"]						= data:getValue("gem") + self.reward;

				BountyMgr:setBountyEntryStateCollected(self.id);
			else
				return nil;
			end
		end

		return self._values;
	end

end


----------------------------------------------------------------------

function DataTransactionUpdateBountyReward:onSuccess( data )

	if self.reward and self.id ~= "reset" then
		EventMgr:postEvent( { gem=self.reward, id==self.id }, "bounty-collected" );
		EventMgr:postEvent( { type="bounty", gem=self.reward }, "More-Gem" );
	end

end

----------------------------------------------------------------------
