require('app/data/transaction/data-transaction')
require('app/possession/possession-manager')

----------------------------------------------------------------------

local Base = DataTransaction;
DataTransactionUpdateLevel = Base:_new("DataTransactionUpdateLevel");

----------------------------------------------------------------------

function DataTransactionUpdateLevel:new( data, level, xp )

   local lvl  = level or 0;
   local exp  = xp or 0;
   local task = Base.new( self );

   task.level = lvl;
   task.xp    = exp;

   return task;

end

----------------------------------------------------------------------

function DataTransactionUpdateLevel:buildValues( data )

   self._values = {};

   self._values.currentLevel = self.level;
   self._values.xp = self.xp ;

   if self._values.xp < 0  then
      self._values.xp = 0;
   end

   return self._values;

end


----------------------------------------------------------------------

function DataTransactionUpdateLevel:onSuccess( data )

   RankingMgr:submitLevel( self.level );

end

----------------------------------------------------------------------
