require('engine/object/object')

----------------------------------------------------------------------

local Base           = Object;
DataTransaction      = Base:new();

----------------------------------------------------------------------

function DataTransaction:_new( className )

   local task        = Base.new( self );
   task._className   = className;

   return task;

end

----------------------------------------------------------------------

function DataTransaction:new()

   local task        = Base.new( self );

   --We need to save the class name to recreate from a save file
   task._className   = self._className
   task._values      = nil;

   return task;

end

----------------------------------------------------------------------

function DataTransaction:getValues()

   return self._values;

end


----------------------------------------------------------------------

function DataTransaction:testMe()

   print("DataTransaction:testMe()");

end

----------------------------------------------------------------------

function DataTransaction:fixeMetatable()

   local class = _G[self._className] or DataTransaction;

   Debug.assert( class );

   setmetatable(self, class);

   class.__index = class;

   print( "DataTransaction:fixeMetatable", self:testMe() );

end

----------------------------------------------------------------------

function DataTransaction:onSuccess( data, values )
end

----------------------------------------------------------------------

function DataTransaction:buildValues()
end

----------------------------------------------------------------------

function DataTransaction:isUseless()
   return true;
end

----------------------------------------------------------------------
