require('app/server/tango')

-----------------------------------------------------------------------

local Base = TangoServer;
SharingFeed = Base:new();

-----------------------------------------------------------------------

function SharingFeed:new(data, display_target, userData, image, thumbnail, forwardable)

   local o = Base.new(self);

   o.sharingData = MOAITangoSharingData.new();
   o.sharingData:setCaption(data.caption);
   o.sharingData:setLinkText(data.linkText);
   o.sharingData:setDisplayTarget(display_target);
   o.sharingData:setUserParams(userData);
   o.sharingData:setAttachment(image);
   if thumbnail then
    o.sharingData:setThumbnail(thumbnail);
   end

   if forwardable then
    o.sharingData:setForwardable(forwardable);
   else
    o.sharingData:setForwardable(false);
   end

   return o;

end

-----------------------------------------------------------------------

function SharingFeed:exec(callObj, callSuccess, callFailure)

   local requestSuccessFunc = function( result )

      print("Share successfully\n");
      self.posting = false;
      self:callCallback(callObj, callSuccess, result);

   end

   local requestFailureFunc = function(code, message)

      print("Share failed\n");
      self.posting = false;
      self:callCallback(callObj, callFailure, code, message);

   end

   local requestOptions = {
      requestClass = MOAITangoShareRequest,
      requestData = { self.sharingData },
      successFunc = requestSuccessFunc,
      failureFunc = requestFailureFunc,
   }

   NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

end

-----------------------------------------------------------------------
