require('engine/utility/tableUtil')

----------------------------------------------------------------------

-- Store all the default data for leagues and divisions
LeagueMgr	=
{
	_loggedIn	= false,
	_leagues		=
	{
		{
			name			= "Diamond",
			minScore		= 200000000,
			maxScore		= 1000000000,
			divisions	=
			{
				{
					name						= "I",
					minPercentile			= 0.7,	-- min percentile of league
					maxPercentile			= 1.0,	-- max percentile of league
					promotionCount			= 0,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=15,	gold=0,		minRank=3	},
						{	gem=5,	gold=0,		minRank=15	},
						{	gem=0,	gold=15000,	minRank=20	},
					},
				},
				{
					name						= "II",
					minPercentile			= 0.4,	-- min percentile of league
					maxPercentile			= 0.7,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=14,	gold=0,		minRank=3	},
						{	gem=5,	gold=0,		minRank=15	},
						{	gem=0,	gold=10000,	minRank=20	},
					},
				},
				{
					name						= "III",
					minPercentile			= 0.0,	-- min percentile of league
					maxPercentile			= 0.4,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 0,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=13,	gold=0,		minRank=3	},
						{	gem=0,	gold=10000,	minRank=15	},
						{	gem=0,	gold=7500,	minRank=20	},
					},
				},
			},
		},
		{
			name			= "Platinum",
			minScore		= 50000000,
			maxScore		= 200000000,
			divisions	=
			{
				{
					name						= "I",
					minPercentile			= 0.7,	-- min percentile of league
					maxPercentile			= 1.0,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=12,	gold=0,		minRank=3	},
						{	gem=4,	gold=0,		minRank=15	},
						{	gem=0,	gold=7500,	minRank=20	},
					},
				},
				{
					name						= "II",
					minPercentile			= 0.4,	-- min percentile of league
					maxPercentile			= 0.7,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=11,	gold=0,		minRank=3	},
						{	gem=4,	gold=0,		minRank=15	},
						{	gem=0,	gold=5000,	minRank=20	},
					},
				},
				{
					name						= "III",
					minPercentile			= 0.0,	-- min percentile of league
					maxPercentile			= 0.4,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 0,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=10,	gold=0,		minRank=3	},
						{	gem=0,	gold=5000,	minRank=15	},
						{	gem=0,	gold=3500,	minRank=20	},
					},
				},
			},
		},
		{
			name			= "Gold",
			minScore		= 1000000,
			maxScore		= 50000000,
			divisions	=
			{
				{
					name						= "I",
					minPercentile			= 0.7,	-- min percentile of league
					maxPercentile			= 1.0,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=9,	gold=0,		minRank=3	},
						{	gem=3,	gold=0,		minRank=15	},
						{	gem=0,	gold=3500,	minRank=20	},
					},
				},
				{
					name						= "II",
					minPercentile			= 0.4,	-- min percentile of league
					maxPercentile			= 0.7,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=8,	gold=0,		minRank=3	},
						{	gem=3,	gold=0,		minRank=15	},
						{	gem=0,	gold=3000,	minRank=20	},
					},
				},
				{
					name						= "III",
					minPercentile			= 0.0,	-- min percentile of league
					maxPercentile			= 0.4,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 0,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=7,	gold=0,		minRank=3	},
						{	gem=0,	gold=3000,	minRank=15	},
						{	gem=0,	gold=2000,	minRank=20	},
					},
				},
			},
		},
		{
			name			= "Silver",
			minScore		= 500000,
			maxScore		= 1000000,
			divisions	=
			{
				{
					name						= "I",
					minPercentile			= 0.7,	-- min percentile of league
					maxPercentile			= 1.0,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=6,	gold=0,		minRank=3	},
						{	gem=2,	gold=0,		minRank=15	},
						{	gem=0,	gold=2000,	minRank=20	},
					},
				},
				{
					name						= "II",
					minPercentile			= 0.4,	-- min percentile of league
					maxPercentile			= 0.7,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=5,	gold=0,		minRank=3	},
						{	gem=2,	gold=0,		minRank=15	},
						{	gem=0,	gold=1500,	minRank=20	},
					},
				},
				{
					name						= "III",
					minPercentile			= 0.0,	-- min percentile of league
					maxPercentile			= 0.4,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 0,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=4,	gold=0,		minRank=3	},
						{	gem=0,	gold=1500,	minRank=15	},
						{	gem=0,	gold=1000,	minRank=20	},
					},
				},
			},
		},
		{
			name			= "Bronze",
			minScore		= 0,
			maxScore		= 500000,
			divisions	=
			{
				{
					name						= "I",
					minPercentile			= 0.7,	-- min percentile of league
					maxPercentile			= 1.0,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=3,	gold=0,		minRank=3	},
						{	gem=1,	gold=0,		minRank=15	},
						{	gem=0,	gold=1000,	minRank=20	},
					},
				},
				{
					name						= "II",
					minPercentile			= 0.4,	-- min percentile of league
					maxPercentile			= 0.7,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 5,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=2,	gold=0,		minRank=3	},
						{	gem=1,	gold=1000,	minRank=15	},
						{	gem=0,	gold=500,	minRank=20	},
					},
				},
				{
					name						= "III",
					minPercentile			= 0.0,	-- min percentile of league
					maxPercentile			= 0.4,	-- max percentile of league
					promotionCount			= 3,		-- number of players at the top of the cohort that are promoted to next division
					demotionCount			= 0,		-- bottom percentile demoted to previous division/league
					cohortSize				= 20,
					reward					=
					{
						{	gem=1,	gold=0,		minRank=3	},
						{	gem=0,	gold=500,	minRank=15	},
						{	gem=0,	gold=250,	minRank=20	},
					},
				},
			},
		},
	},
};

----------------------------------------------------------------------

function LeagueMgr:init()

   EventMgr:addListener( self, self._onUpdateMasterLeagueInfo,	"cloud:master-data-league-info"	);

end

----------------------------------------------------------------------

function LeagueMgr:_onUpdateMasterLeagueInfo( data )

   local content	= (data or {}).content;

	if content then
		self._leagues	= content;
	end

	if self._loggedIn then
		self:_initLeagueStructure();
	end

end

----------------------------------------------------------------------
-- Events
----------------------------------------------------------------------

function LeagueMgr:onLoginSuccess()

   self._loggedIn = true;
   self:_initLeagueStructure();

end

----------------------------------------------------------------------

function LeagueMgr:_initLeagueStructure()
   self._leagues = AbTestMgr:getLeagueStructure() or self._leagues;
end

----------------------------------------------------------------------
-- Utility
----------------------------------------------------------------------

function LeagueMgr:calcPlacement( score )

   if not LeagueMgr:isLeagueEnabled() then
      Debug.error("LeagueMgr:calcPlacement is only valid when leagues are enabled.");
      return;
   end

   local leagueIndex, divIndex	= self:getLowestLeagueDiv();

   if score then

      for k, v in ipairs(self._leagues) do

         if score >= v.minScore or k == #self._leagues then

            local delta	= v.maxScore - v.minScore;

            leagueIndex = k;

            for key,val in ipairs(v.divisions) do

               if score >= (val.minPercentile * delta) or key == #v.divisions then
                  divIndex = key;

                  return leagueIndex, divIndex;
               end
            end
         end
      end
   end

   return leagueIndex, divIndex;
end

----------------------------------------------------------------------

function LeagueMgr:doesMatchPlayer( leagueIndex, divIndex )

   if not Debug.assertType(leagueIndex, "number", "LeagueMgr:doesMatchPlayer -> leagueIndex") then
      return false;
   end

   if not Debug.assertType(divIndex, "number", "LeagueMgr:doesMatchPlayer -> divIndex") then
      return false;
   end

   local l = App.data:getLeagueIndex();
   local d = App.data:getDivisionIndex();

   return l == leagueIndex and d == divIndex;
end

----------------------------------------------------------------------

function LeagueMgr:getDemoCount( leagueIndex, divIndex )

   if not Debug.assertType(leagueIndex, "number", "LeagueMgr:getDemoCount -> leagueIndex") then
      return 0;
   end

   if not Debug.assertType(divIndex, "number", "LeagueMgr:getDemoCount -> divIndex") then
      return 0;
   end

   local league = self._leagues[leagueIndex];
   if not league then
      return 0;
   end

   local division = self._leagues[leagueIndex].divisions[divIndex];
   if not division then
      return 0;
   end

   return division.demotionCount;
end

----------------------------------------------------------------------

function LeagueMgr:getPromoCount( leagueIndex, divIndex )

   if not Debug.assertType(leagueIndex, "number", "LeagueMgr:getPromoCount -> leagueIndex") then
      return 0;
   end

   if not Debug.assertType(divIndex, "number", "LeagueMgr:getPromoCount -> divIndex") then
      return 0;
   end

   local league = self._leagues[leagueIndex];

   if not league then
      return 0;
   end

   local division = league.divisions[divIndex];
   if division then
      return 0;
   end

   return division.promotionCount;
end

----------------------------------------------------------------------

function LeagueMgr:getDemoResult( leagueIndex, divIndex )

   local l, d = self:_calcDemotion( leagueIndex, divIndex );

   return l, d;
end

----------------------------------------------------------------------

function LeagueMgr:getPromoResult( leagueIndex, divIndex )

   local l, d = self:_calcPromotion( leagueIndex, divIndex );

   return l, d;
end

----------------------------------------------------------------------

function LeagueMgr:isValidLeagueDiv(leagueIndex, divisionIndex)

   -- "Lower" leagues and divisions actually have higher indexes (i.e. the index gets smaller as you rank up)

   local highestLeague, highestDivision = self:getHighestLeagueDiv();
   local lowestLeague, lowestDivision = self:getLowestLeagueDiv();

   if leagueIndex < highestLeague or leagueIndex > lowestLeague then
      return false;
   end

   -- ASSUMPTION: All leagues have the same number of divisions.
   -- Otherwise, query the league data for the correct number of divisions.

   if divisionIndex < highestDivision or divisionIndex > lowestDivision then
      return false;
   end

   return true;
end

----------------------------------------------------------------------

function LeagueMgr:getHighestLeagueDiv()
   return 1, 1;
end

----------------------------------------------------------------------

function LeagueMgr:getLowestLeagueDiv()

   if not Debug.assertType(self._leagues, "table", "LeagueMgr:getLowestLeagueDiv -> self._leagues") then
      return 1, 1;
   end

   if self._leagues[#self._leagues] and #self._leagues[#self._leagues].divisions then
      return #self._leagues, #self._leagues[#self._leagues].divisions;
   end

   return 1, 1;
end

----------------------------------------------------------------------

function LeagueMgr:getLeagueName( leagueIndex, divIndex )

   divIndex = divIndex or 3;

   if not Debug.assertType(self._leagues, "table", "LeagueMgr:getLeagueName -> self._leagues") then
      return "", "";
   end

   if self._leagues[leagueIndex] and self._leagues[leagueIndex].name then

      local lName = self._leagues[leagueIndex].name or "";
      local dName = "";

      if self._leagues[leagueIndex].divisions and self._leagues[leagueIndex].divisions[divIndex] then
         dName	= self._leagues[leagueIndex].divisions[divIndex].name or "";
      end

      return lName, dName;
   end

   return "", "";
end

----------------------------------------------------------------------

function LeagueMgr:getLeagueDivCount( leagueIndex )

   if not Debug.assertType(self._leagues, "table", "LeagueMgr:getLeagueDivCount -> self._leagues") then
      return "", "";
   end

   if self._leagues[leagueIndex] and self._leagues[leagueIndex].divisions then
      return #self._leagues[leagueIndex].divisions;
   end

   return 0;
end

----------------------------------------------------------------------

function LeagueMgr:getStartingLeagueDiv()

   local l, d = self:getLowestLeagueDiv();

   return l, d;
end

----------------------------------------------------------------------

function LeagueMgr:getPlayerPlacement()

   local leagueIndex = App.data:getLeagueIndex();
   local divIndex    = App.data:getDivisionIndex();

   if self:isLeagueEnabled() then

      local league = self._leagues[leagueIndex];

      if (leagueIndex <= 0) or (divIndex <= 0) or (league == nil) or (league.divisions[divIndex] == nil) then

         self:resetLeague();

         leagueIndex, divIndex = self:getLowestLeagueDiv();
      end
   end

   Debug.assertType(leagueIndex, "number", "LeagueMgr:getPlayerPlacement -> leagueIndex");
   Debug.assertType(divIndex, "number", "LeagueMgr:getPlayerPlacement -> divIndex");

   return leagueIndex, divIndex;

end

----------------------------------------------------------------------

function LeagueMgr:getPlayerCohortSize()

   local leagueIndex = math.max(App.data:getLeagueIndex(), 1);
   local divIndex    = math.max(App.data:getDivisionIndex(), 1);

   if self._leagues[leagueIndex] and self._leagues[leagueIndex].divisions[divIndex] then
      return self._leagues[leagueIndex].divisions[divIndex].cohortSize;
   end

end

----------------------------------------------------------------------

function LeagueMgr:isLeagueEnabled()

   if not Debug.assertType(self._leagues, "table", "LeagueMgr:isLeagueEnabled -> self._leagues") then
      return false;
   end

   return not isTableEmpty(self._leagues);
end

----------------------------------------------------------------------

function LeagueMgr:isLeagueLoggedIn()
   return self._loggedIn;
end

----------------------------------------------------------------------

function LeagueMgr:resetLeague()

   local l,d = self:getLowestLeagueDiv();

   App.data:updateLeagueData(l, d);

end


----------------------------------------------------------------------
-- demotion/promotion
----------------------------------------------------------------------

function LeagueMgr:_calcDemotion( leagueIndex, divIndex )

   local l = math.clamp(leagueIndex, 1, #self._leagues);
   local d = math.clamp(divIndex, 1, #self._leagues[l].divisions);

   if l == #self._leagues and d == #self._leagues[l].divisions then
      return l, d;
   elseif d >= #self._leagues[l].divisions then
      return math.min(l+1, #self._leagues) , 1;
   elseif d < #self._leagues[l].divisions then
      return l, d+1;
   else
      return l, d;
   end

end

----------------------------------------------------------------------

function LeagueMgr:_calcPromotion( leagueIndex, divIndex )

   local l = math.clamp(leagueIndex, 1, #self._leagues);
   local d = math.clamp(divIndex, 1, #self._leagues[leagueIndex].divisions);

   if d > 1 then
      return l, d-1;
   else
      return math.max(l-1, 1), #self._leagues[math.max(l-1, 1)].divisions;
   end

end

----------------------------------------------------------------------

function LeagueMgr:canDemote( leagueIndex, divIndex, rank )

   if     self:isLeagueEnabled()
      and leagueIndex
      and divIndex
      and rank then

      local leagueIndex = math.clamp(leagueIndex, 1, #self._leagues);
      local divIndex    = math.clamp(divIndex, 1, #self._leagues[leagueIndex].divisions);
      local min         = self._leagues[leagueIndex].divisions[divIndex].cohortSize - self._leagues[leagueIndex].divisions[divIndex].demotionCount;

      if self._leagues[leagueIndex].divisions[divIndex].demotionCount <= 0 then
         return false;
      elseif rank > min then
         return true;
      end

      -- TODO Else what?
   end

end

----------------------------------------------------------------------

function LeagueMgr:canPromote( leagueIndex, divIndex, rank )

   if not self:isLeagueEnabled() then
      return false;
   end

   if leagueIndex and divIndex and rank then

      local leagueIndex = math.clamp(leagueIndex, 1, #self._leagues);
      local divIndex    = math.clamp(divIndex, 1, #self._leagues[leagueIndex].divisions);

      if self._leagues[leagueIndex].divisions[divIndex].promotionCount <= 0 then
         return false;
      elseif rank <= self._leagues[leagueIndex].divisions[divIndex].promotionCount then
         return true;
      end
   end

end

----------------------------------------------------------------------

function LeagueMgr:getReward( leagueIndex, divIndex, rank )

   if not self:isLeagueEnabled() then
      return;
   end

   if leagueIndex and divIndex and rank then

      local leagueIndex = math.clamp(leagueIndex, 1, #self._leagues);
      local divIndex    = math.clamp(divIndex, 1, #self._leagues[leagueIndex].divisions);

      if self._leagues[leagueIndex].divisions[divIndex].reward then

         for _, v in ipairs(self._leagues[leagueIndex].divisions[divIndex].reward) do

            if v.gem and v.gold and v.minRank and rank <= v.minRank then
               return {gem = v.gem, gold = v.gold, rank = rank};
            end

         end

         return { gem = 0,  gold = 0, rank = (rank or 1) };
      end
   end

end

----------------------------------------------------------------------

function LeagueMgr:getRewardTable( leagueIndex, divIndex )

   if not self:isLeagueEnabled() then
      return;
   end

   if leagueIndex and divIndex then

      local leagueIndex = math.clamp(leagueIndex, 1, #self._leagues);
      local divIndex    = math.clamp(divIndex, 1, #self._leagues[leagueIndex].divisions);

      if self._leagues[leagueIndex].divisions[divIndex].reward then

         local tbl = {};

         for _, v in ipairs(self._leagues[leagueIndex].divisions[divIndex].reward) do

            if v.gem and v.gold and v.minRank then
               table.insert(tbl, v);
            end

         end

         return tbl;
      end
   end

end

----------------------------------------------------------------------

function LeagueMgr:demote( leagueIndex, divIndex, rank, forceSet )

   if leagueIndex and divIndex and rank then

      local l, d  = self:_calcDemotion(leagueIndex, divIndex);
      local prize = self:getReward(leagueIndex, divIndex, rank);

      App.data:updateLeagueData(l, d, prize, forceSet);

      return prize;
   end

end

----------------------------------------------------------------------

function LeagueMgr:promote( leagueIndex, divIndex, rank, forceSet )

   if leagueIndex and divIndex and rank then

      local l, d  = self:_calcPromotion(leagueIndex, divIndex);
      local prize = self:getReward(leagueIndex, divIndex, rank);

      App.data:updateLeagueData(l, d, prize, forceSet);

      return prize;
   end

end

----------------------------------------------------------------------

function LeagueMgr:awardPrize( leagueIndex, divIndex, rank )

   if leagueIndex and divIndex and rank then

      if self:canDemote(leagueIndex, divIndex, rank) then
         return self:demote(leagueIndex, divIndex, rank);

      elseif self:canPromote(leagueIndex, divIndex, rank) then
         return self:promote(leagueIndex, divIndex, rank);

      else
         local prize = self:getReward(leagueIndex, divIndex, rank);

         App.data:updateLeagueData(leagueIndex, divIndex, prize);

         return prize;
      end
   end

end

----------------------------------------------------------------------
