
----------------------------------------------------------------

LoaderMgr =
{
   taskList = {};
   text     = nil;
};

----------------------------------------------------------------

function LoaderMgr:update( dt )

   self.text = nil;

   if #self.taskList > 0 then

      local task = self.taskList[1];

      local done = task.callFunc(  task.callObj, task.userData );

      if task.repeatUntilDone then

         Debug.assertType(done, "boolean", "LoaderMgr:update -> done")

         if done then
            table.remove( self.taskList, 1 );
         end
      else
         table.remove( self.taskList, 1 );
      end

      self.text = task.text or self.text;

   end

end

----------------------------------------------------------------

function LoaderMgr:addTask( text, callObj, callFunc, userData, repeatUntilDone )

   local task =
   {
      text     = text,
      callObj  = callObj,
      callFunc = callFunc,
      userData = userData,
      repeatUntilDone = repeatUntilDone
   }

   table.insert( self.taskList, task );

end



----------------------------------------------------------------

function LoaderMgr:isBusy( )

   return  #self.taskList > 0;

end

----------------------------------------------------------------

function LoaderMgr:getTaskCount( )

   return  #self.taskList;

end

----------------------------------------------------------------

function LoaderMgr:getText( )

   return self.text;

end

----------------------------------------------------------------
