
----------------------------------------------------------------------

LoginMgr  =
{
   STATE_NOT         = 0;
   STATE_GUEST       = 1;
   STATE_TANGO       = 2;
};

----------------------------------------------------------------------

function LoginMgr:init()

   self._state = LoginMgr.STATE_NOT;

end

----------------------------------------------------------------------

function LoginMgr:activate( forceReactivate )

   Debug.assert( self._state ~= nil, "LoginMgr:activate -> self._state ~= nil");

   if forceReactivate or self._state == LoginMgr.STATE_NOT then

      if MOAITangoSdk:isAuthenticated() then
         self._state = LoginMgr.STATE_TANGO;
      else

         if not App.data:isGuestMode() then

            if not MOAITangoSdk:tangoIsInstalled() then
               MOAIFlurry:event("Tango-Not-Installed");
            end

            --If you dont have a tango supporting Games,
            --Signin as a guest
            App.data:setGuestMode( GUEST_MODE_VERSION_1 );

         end

         self._state = LoginMgr.STATE_GUEST;

      end
   end

end

function LoginMgr:isJune()
       return (App:getJunePlayerId() ~= nil);
end


----------------------------------------------------------------------

function LoginMgr:deactivate()

   self._state = LoginMgr.STATE_NOT;
end

----------------------------------------------------------------------

function LoginMgr:isTango()

   return self._state == LoginMgr.STATE_TANGO;
end

----------------------------------------------------------------------

function LoginMgr:isGuest()

   return self._state == LoginMgr.STATE_GUEST;
end

----------------------------------------------------------------------
