require('app/message/message-mailbox')

----------------------------------------------------------------------

MessageMgr  =
{
   _mailbox    = MessageMailbox;
   _template   = {};
};

----------------------------------------------------------------------

function MessageMgr:init()

   EventMgr:addListener( self, self._onCloudInfoData, "cloud:file-data-message-info" );

   if self._mailbox then
      self._mailbox:init();
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:update()

   if self._mailbox then
      self._mailbox:update();
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:checkMailNow()

   if self._mailbox then
      self._mailbox:checkNow();
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------

function MessageMgr:anyGiftWaiting()

   if self._mailbox then
      return self._mailbox:anyGiftWaiting();
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------

function MessageMgr:consumeGift()

   if self._mailbox then
      return self._mailbox:consumeGift();
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------

function MessageMgr:setEnableAutoCheck( enable )

   if self._mailbox then
      return self._mailbox:setEnableAutoCheck(enable);
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:createGiftIdTo( type, destId )

   return "gift-" .. type .. "-to-"..destId;

end

----------------------------------------------------------------------

function MessageMgr:createGiftConsumedId( type, sender )

   return "gift-" .. type .. "-consumed-"..sender;

end

----------------------------------------------------------------------

function MessageMgr:isBusy()

   if self._mailbox then
      return self._mailbox:isBusy();
   else
      Debug.assert(self._mailbox);
   end
end

----------------------------------------------------------------------

function MessageMgr:sendBrag( msgTpl, dest, callObj,  successFunc, failureFunc )


   if self._mailbox then
      return self._mailbox:sendBrag(msgTpl, dest, callObj,  successFunc, failureFunc);
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:sendGift( msgTpl, dest, callObj,  successFunc, failureFunc )

   if self._mailbox then
      return self._mailbox:sendGift(  msgTpl, dest, callObj,  successFunc, failureFunc);
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:sendInvite( msgTpl, dest, totalReward, callObj, successFunc, failureFunc )

   if self._mailbox then
      return self._mailbox:sendInvite(msgTpl, dest, totalReward, callObj, successFunc, failureFunc);
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:onMessageDone( message )

   if self._mailbox then
      return self._mailbox:onMessageDone(message);
   else
      Debug.assert(self._mailbox);
   end

end

----------------------------------------------------------------------

function MessageMgr:getInviteTemplateList(  )

   if self._template then

      return      self:_getTemplateList("invite", LocalizationMgr:getLanguage() )
            or    self:_getTemplateList("invite", LocalizationMgr:getDefaultLanguage() );

   end

end

----------------------------------------------------------------------

function MessageMgr:getBragTemplateList(  )

   if self._template then

      return      self:_getTemplateList("brag", LocalizationMgr:getLanguage() )
            or    self:_getTemplateList("brag", LocalizationMgr:getDefaultLanguage() );

   end

end

----------------------------------------------------------------------

function MessageMgr:getGiftTemplateList(  )

   if self._template then

      return      self:_getTemplateList("gift", LocalizationMgr:getLanguage() )
            or    self:_getTemplateList("gift", LocalizationMgr:getDefaultLanguage() );

   end

end

----------------------------------------------------------------------

function MessageMgr:_onCloudInfoData( data )

   self._template = ( data or {} ).content;

end

----------------------------------------------------------------------

function MessageMgr:_getTemplateList( messageType, language )

   if language and messageType then

      local list  = self._template[messageType];

      if list then
         return list[language];
      else
         Debug.assert( list, "MessageMgr:_getTemplateList -> list, aka self._template[messageType] : " .. messageType .. " / " .. language );
      end

   else

      Debug.assert( language,       "MessageMgr:_getTemplateList -> language"     );
      Debug.assert(  messageType ,  "MessageMgr:_getTemplateList -> messageType"  );

   end

end

----------------------------------------------------------------------