--
require('app/message/server/sender')

----------------------------------------------------------------------

local Base        = MessageSender;
MessageSenderBrag = Base:new();

----------------------------------------------------------------------

function  MessageSenderBrag:new( msgTpl, dest, callObj, successFunc, failureFunc  )

   local o = Base.new(self, MOAITangoMessage.MESSAGE_BRAG, msgTpl, dest, callObj,  successFunc, failureFunc);

   return o;

end

----------------------------------------------------------------------

function MessageSenderBrag:exec( )

   EventMgr:postEvent({type = "brag" }, "tango.message.attempt");

   Base.exec(self);

end

----------------------------------------------------------------------

function MessageSenderBrag:_onDone( success  )

   if success then

      local batch = self._batchSize or 0;

      App.data:setValue("brag-count",  (App.data:getValue("brag-count") or 0 ) + batch );

      EventMgr:postEvent({
                           type           = "brag",
                           count          = App.data:getValue("brag-count", 0),
                           batch          = self._batchSize or 0,
                           recipientList  = self._dest

                         },
                         "tango.message.success"                              );


   else

      EventMgr:postEvent({
                           type  = "brag"
                         },
                         "tango.message.failure"                              );

   end

   Base._onDone( self, success );

end

----------------------------------------------------------------------
