--
require('app/server/tango')

----------------------------------------------------------------------

local FAILURE = 0;
local SUCCESS = 1;

----------------------------------------------------------------------

local Base                 = TangoServer;
MessageSenderConsumedGift  = Base:new();

----------------------------------------------------------------------

function  MessageSenderConsumedGift:new( type, giftList, callObj,  successFunc, failureFunc  )

   local o           = Base.new(self);
   o.callObj         = callObj;
   o.successFunc     = successFunc;
   o.failureFunc     = failureFunc;
   o.giftList        = giftList;
   o.type            = type;
   o.amount          = amount;

   return o;

end

----------------------------------------------------------------------

function MessageSenderConsumedGift:exec( )

   local requestSuccessFunc = function( )

      self:callCallback( self.callObj, self.successFunc );

   end

   local requestFailureFunc = function(code, message)

      self:callCallback( self.callObj, self.failureFunc );

   end

   local requestList = {};

   for i = 1, #self.giftList do

      local gift     = self.giftList[i];
      local from     = gift.tangoId;
      local metricId = MessageMgr:createGiftConsumedId(self.type,from);
      local amount   = gift.amount;

      table.insert( requestList,
                    {
                       metric   = metricId,
                       value    = amount,
                       rollups  = {
                          MOAITangoMetrics.SUM,
                       }
                    }
      );

   end

   local requestOptions = {
      requestClass = MOAITangoSetRawMetricsRequest,
      requestData = { requestList },
      successFunc = requestSuccessFunc,
      failureFunc = requestFailureFunc,
   }

   NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

end


----------------------------------------------------------------------
