--
require('app/message/server/sender')

----------------------------------------------------------------------

local Base           = MessageSender;
MessageSenderInvite  = Base:new();

----------------------------------------------------------------------

function  MessageSenderInvite:new( msgTpl, dest, batchReward, callObj,  successFunc, failureFunc  )

   local o = Base.new(self, MOAITangoMessage.MESSAGE_INVITE, msgTpl, dest, callObj,  successFunc, failureFunc);

   o.batchReward = batchReward;

   return o;

end

----------------------------------------------------------------------

function MessageSenderInvite:exec( )

   EventMgr:postEvent({type = "invite" }, "tango.message.attempt");

   Base.exec(self);

end

----------------------------------------------------------------------

function MessageSenderInvite:_onDone( success  )

   if success then

      App.data:setValue("invite-count",  (App.data:getValue("invite-count") or 0 ) + 1 );

      EventMgr:postEvent({
                           type           = "invite",
                           count          = App.data:getValue("brag-count", 0),
                           batch          = self._batchSize or 0,
                           recipientList  = self._dest
                         },
                           "tango.message.success"                              );

   else

      EventMgr:postEvent({
                           type  = "invite"
                         },
                           "tango.message.failure"                              );

   end

   Base._onDone( self, success );

end

----------------------------------------------------------------------
