require('app/server/tango')


local Base = TangoServer;
MigrationManager = Base:new();


-- PRIVATE
function MigrationManager:new()
   return Base.new(self);
end


function MigrationManager:_makeSuccessCallback(callObj, callSuccess, result, successMessage)
   return function(result)
      local response;
      if result then
         response = MOAIJsonParser.decode ( result )
      end
      print(successMessage);
      self:callCallback(callObj, callSuccess, response);
   end
end


function MigrationManager:_makeFailureCallback(callObj, callFailure, code, text, failureMessage)
   return function(code, text)
      print('MigrationManager failure callback: code: ' .. code .. ',text: ' .. ',msg: ' .. failureMessage);
      self:callCallback(callObj, callFailure, code, text);
   end
end


-- PUBLIC
function MigrationManager:migrateUser(callObj, fromUserId, overwriteOption, callSuccess, callFailure)

   local requestData = {}
   requestData["FromUserId"] = fromUserId
   requestData["ForceOverwrite"] =  overwriteOption
   dataString = MOAIJsonParser.encode(requestData)

   local requestOptions = {
      requestClass = MOAITangoMigrateUserRequest,
      requestData = dataString,
      successFunc = self:_makeSuccessCallback(callObj, callSuccess, result, "migration succeeded, response is:\n"),
      failureFunc = self:_makeFailureCallback(callObj, callFailure, code, text, "migration failed:\n"),
   }

   NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

end
