
MonkeyTester = {}

local TIME_BETWEEN_TAPS = 0.3;

local DISALLOWED_STATES = {
   ["state/state-coin.lua"] = true,
   ["state/state-gem.lua"] = true,
   ["state/state-key.lua"] = true,
   ["state/state-need-gem.lua"] = true,
   ["state/state-promo-popup-movie.lua"] = true,
   ["state/state-auto-purchase-popup-maz.lua"] = true,
   ["state/state-invite.lua"] = true,
}

----------------------------------------------------------------

function MonkeyTester:init()

   self.tapTimer = 0;
   self.enabled = false;

end

----------------------------------------------------------------

function MonkeyTester:update(dt)

   if not self.enabled then
	  return;
   end

   Debug.assert( StateMgr, "Missing state manager!" );
   Debug.assert( InputMgr, "Missing input manager!" );

   if App.data:getKeyCount() == 0 then
	  App.data:addKey(1);
   end

   self.tapTimer = self.tapTimer + dt;

   if self.tapTimer >= TIME_BETWEEN_TAPS then
	  self.tapTimer = self.tapTimer - TIME_BETWEEN_TAPS

	  if StateMgr.curState then

		 if DISALLOWED_STATES[StateMgr.curState.stateFilename] then
			StateMgr:pop();
		 elseif StateMgr.curState.stateFilename == "state/state-game.lua" then
			self:_playGame(dt);
		 else
			print("in state: " .. StateMgr.curState.stateFilename);

			-- Tap the screen randomly
			local x = math.random(1, App.viewWidth);
			local y = math.random(1, App.viewHeight);

			InputMgr:generateTouch(x, y);
		 end

	  end
   end

end

----------------------------------------------------------------

function MonkeyTester:setEnabled(enabled)
   self.enabled = enabled;
end

----------------------------------------------------------------

function MonkeyTester:_playGame(dt)
   -- TODO Generate touches to play the game
   --InputMgr:generateTouch(App.viewWidth * .5, App.viewHeight * .8, 5);

   local height = App.viewHeight * .80;
   local MIN_SWIPE_TIME = .1;
   local MAX_SWIPE_TIME = 4;

   if not InputMgr:isTouchDown() then
      InputMgr:generateSwipe(math.random(1, App.viewWidth), height, math.random(1, App.viewWidth), height,
                             math.max(MIN_SWIPE_TIME, math.random() * MAX_SWIPE_TIME));
   end
end
