require('app/possession/task/possession-task')

----------------------------------------------------------------------

local Base              = PossessionTask;
PossessionTaskDownload  = Base:new();

----------------------------------------------------------------------

function PossessionTaskDownload:new( callObj, callSuccess, callFailure, params )

   local task = Base.new(self, callObj, callSuccess, callFailure, params );

   task.type = "download";

   return task;

end

----------------------------------------------------------------------

function PossessionTaskDownload:exec()

   print("PossessionTaskDownload:exec");

   assert( LoginMgr:isTango() );

   MOAIFlurry:eventStart("PossessionTaskDownload", "result", "unkown");

   if OnlineMgr:isOnline() then

      local requestSuccessFunc = function(success, possessions)
         print("Possessions get success");
         MOAIFlurry:eventStop("PossessionTaskDownload", "result", "success");
         PossessionMgr:onDownloadSuccess( self, possessions );
      end

      local requestFailureFunc = function(success, code, message)
         print("Possessions get failure");
         MOAIFlurry:eventStop("PossessionTaskDownload", "result", "failure");
         PossessionMgr:onDownloadFailure( self, code, message );
      end

      local requestOptions = {
         requestClass = MOAITangoGetPossessionsRequest,
         requestData = { },
         successFunc = requestSuccessFunc,
         failureFunc = requestFailureFunc,
      }

      NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));

   else

      -- Use a timer to create be more consistent with the authenticate mode
      self.timer = MOAITimer.new();
      self.timer:setSpan( 0.1 );
      self.timer:setListener( MOAITimer.EVENT_TIMER_END_SPAN,
            function ()
               self.timer:stop( );
               self.timer = nil;
               MOAIFlurry:eventStop("PossessionTaskDownload", "result", "offline");

               PossessionMgr:onDownloadFailure(self, -1, "You are offline"  );

            end   );
      self.timer:start();



   end

end
----------------------------------------------------------------------
