require('app/server/june')
require('app/cloud/june-api-manager')

---------------
local Base = JuneServer;
ValidatePurchasedItem = Base:new();
------------------

function ValidatePurchasedItem:new(productId, itemId, receipt, publicKey, callObj, successFunc, failFunc)


    local o = Base.new(self);

print("ValidatePurchasedItem:new-1 ", type(itemId),    itemId);
print("ValidatePurchasedItem:new-2 ", type(receipt),   receipt);
print("ValidatePurchasedItem:new-3 ", type(publicKey), publicKey);

    o.purchasedItem = MOAITangoPurchasedItem.new();
    o.purchasedItem:setItemId(itemId);
    o.purchasedItem:setReceipt(receipt);
    o.purchasedItem:setPublicKey(publicKey);

    o.itemId = itemId;
    o.productId = productId;
    o.receipt = receipt;
    o.publicKey = publicKey;

    o.callObj = callObj;
    o.successCall = successFunc;
    o.failCall = failFunc;
    assert(type(failFunc) == "function");
    return o;
end

--[[
  result is a json object looks like:
  { "Valid" : [true|false] }
]]--
function ValidatePurchasedItem:exec()

   local requestSuccessFunc = function(result)
      print("server validation success\n");
      self:callCallback(self.callObj, self.successCall, result);
   end

   local requestFailureFunc = function(code, message)
      print("Server validation failed");
      self:callCallback(self.callObj, self.failCall, code, message);
   end

   local requestOptions = {
      requestData = {},
      successFunc = requestSuccessFunc,
      failureFunc = requestFailureFunc,
   }

    local itemId = self.itemId;
    local receipt = self.receipt;
    local publicKey = self.publicKey;
    local productId = self.productId;

    print("ValidatePurchasedItem:exec : Item = ", itemId, " receipt = ", receipt , " public key = ", publicKey );

    requestOptions.requestData.itemId = itemId;
    requestOptions.requestData.productId = productId;
    requestOptions.requestData.receipt = receipt;
    requestOptions.requestData.publicKey = publicKey;

    JuneApi:ValidatePurchase(requestOptions);

--[[

   local requestOptions = {
      requestClass = MOAITangoValidatePurchasedItemRequest,
      requestData = {self.purchasedItem},
      successFunc = requestSuccessFunc,
      failureFunc = requestFailureFunc,
   }

   NetworkMgr:sendTangoRequest(TangoRequest.newFromBase(requestOptions));
]]--

end

