require('game/entity/barricade/barricade')
require('app/template/explosions/barricade_explosion')

TEMPLATE_BARRICADE_03 =
{

   factory           = Barricade, 
   
   freewayV1 =
   {
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (533)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,0,1.00},
         },
         {
            delta          =  { 0 , (533)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,0,1.00},
         },
         {
            delta          =  { 0 , (533)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,0,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 3 , (533)*6/2 + (415)*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV2_Barricade.png",
            width          = 110,
            height         = 415,
            collisionWidth = 100,
            collisionHeight= 405,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.freeway,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },
         {
            delta          =  { 0 , (533)*6/2 + (415)*2/2 - 206*1/4 + 10    },
            blend          = "add",
            spin           = 360,
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_SpinningLight.png",
            width          = 300,
            height         = 300,
            collisionWidth = 0,
            collisionHeight= 0,
         },
         {
            delta          =  { 0 , (533)*6/2 + 206*1/4 + 5    },
            blend          = "add",
            spin           = 360,
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_SpinningLight.png",
            width          = 300,
            height         = 300,
            collisionWidth = 0,
            collisionHeight= 0,
         },
      },
   },

   iceV1 =
   {
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (533)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (533)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (533)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,1,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 0 , (533)*6/2 + 427*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV1_Barricade.png",
            width          = 102,
            height         = 398,
            collisionWidth = 090,
            collisionHeight= 380,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.ice,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },

      },
   },

   sandV1 =
   {      
   
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (480)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV1_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV1_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV1_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 0 , (480)*6/2 + 400*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV1_Barricade.png",
            width          = 100,
            height         = 400,
            collisionWidth = 090,
            collisionHeight= 390,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.desert,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },

      },
   },

   freewayV2 =
   {
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (533)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,0,1.00},
         },
         {
            delta          =  { 0 , (533)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,0,1.00},
         },
         {
            delta          =  { 0 , (533)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_Decal.png",
            width          = 88,
            height         = 533,
            color          = {1,1,0,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 3 , (533)*6/2 + 415*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV2_Barricade.png",
            width          = 110,
            height         = 415,
            collisionWidth = 100,
            collisionHeight= 405,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.freeway,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },
         {
            delta          =  { 0 , (533)*6/2 + 415*2/2 - 206*1/4 + 10  },
            blend          = "add",
            spin           = 360,
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_SpinningLight.png",
            width          = 300,
            height         = 300,
            collisionWidth = 0,
            collisionHeight= 0,
         },
         {
            delta          =  { 0 , (533)*6/2 + 206*1/4 + 5  },
            blend          = "add",
            spin           = 360,
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_FreewayV1_Barricade_SpinningLight.png",
            width          = 300,
            height         = 300,
            collisionWidth = 0,
            collisionHeight= 0,
         },

      },
   },

   iceV2 =
   {
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (480)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 0 , (480)*6/2 + 400*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_IceV2_Barricade.png",
            width          = 100,
            height         = 400,
            collisionWidth = 090,
            collisionHeight= 390,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.ice,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },

      },
   },

   sandV2 =
   {      
   
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (480)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 0 , (480)*6/2 + 400*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_DesertV2_Barricade.png",
            width          = 110,
            height         = 400,
            collisionWidth = 100,
            collisionHeight= 390,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.desert,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },

      },
   },
   
   dirtV2 =
   {      
   
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (480)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_CountryV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_CountryV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_CountryV2_Barricade_Decal.png",
            width          = 86,
            height         = 480,
            color          = {1,1,1,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 0 , (480)*6/2 + 400*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_CountryV2_Barricade.png",
            width          = 110,
            height         = 400,
            collisionWidth = 100,
            collisionHeight= 390,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.desert,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },

      },
   },
   
   snowV2 =
   {
      waitLaneClear  = true;

      decals          =
      {
         {
            delta          =  { 0 , (480)*1/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_SnowV2_Barricade_Decal.png",
            width          = 90,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*3/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_SnowV2_Barricade_Decal.png",
            width          = 90,
            height         = 480,
            color          = {1,1,1,1.00},
         },
         {
            delta          =  { 0 , (480)*5/2      },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_SnowV2_Barricade_Decal.png",
            width          = 90,
            height         = 480,
            color          = {1,1,1,1.00},
         },
      },
      
      obstacles          =
      {
         {
            delta          =  { 0 , (480)*6/2 + 400*1/2     },
            avatarSpeedK   =  1.0,
            avatarSpeedKRnd=  0.0,
            texture        = "resources/Hazard/Road_SnowV2_Barricade.png",
            width          = 100,
            height         = 400,
            collisionWidth = 090,
            collisionHeight= 390,
            damageToAvatar = { 25, 100000 },
            explosion      = TEMPLATE_BARRICADE_EXPLOSION.ice,
            barricade		= true,
            specialDropList      = {PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX, PICKUP_COIN_10_INDEX, PICKUP_COIN_INDEX },
            specialDropSpeedK    = {4.0,6.0},
         },

      },
   },
};