require('app/template/boss-vehicles/gunship/boss_gunship_common')

-- Templates are stored when requested
local barrelTemplates = {}

-- Utility functions
local function getDimensionsFromGunshipSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 24*BOSS_GUNSHIP_SIZE_WIDTH_K, 53*BOSS_GUNSHIP_SIZE_HEIGHT_K
   end
end

-- MAIN factory function
function getGunshipBarrelTemplate(size)
   local key = size
   
   if not barrelTemplates[key] then
      local w, h = getDimensionsFromGunshipSizeEnum(size)
      barrelTemplates[key] = {
	 {
	    priority = 9,
	    width    = w,
	    height   = h,
	    texture  = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Nosegun_Barrel.png",
	    offset   = {12*BOSS_GUNSHIP_SIZE_WIDTH_K, 51*BOSS_GUNSHIP_SIZE_HEIGHT_K}
	 },
	 {
	    priority = 9,
	    width    = w,
	    height   = h,
	    texture  = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Nosegun_Barrel.png",
	    offset   = {-12*BOSS_GUNSHIP_SIZE_WIDTH_K, 51*BOSS_GUNSHIP_SIZE_HEIGHT_K}
	 },
      }
   end
   
   return barrelTemplates[key]
end
