require('app/template/boss-vehicles/gunship/boss_gunship_common')

-- Templates are stored when requested 
local barrelShadowTemplates = {}

-- Utility functions
local function getDimensionsFromGunshipSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 50*BOSS_GUNSHIP_SIZE_WIDTH_K, 90*BOSS_GUNSHIP_SIZE_HEIGHT_K
   end
end

-- MAIN factory function
function getGunshipBarrelShadowTemplate(size)
   local key = size

   if not barrelShadowTemplates[key] then
      local w, h = getDimensionsFromGunshipSizeEnum(size)
      barrelShadowTemplates[key] = {
	 {
	    layer = 1,
	    priority = 0,
	    width = w,
	    height = h,
	    texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Shadow_Nosegun_Barrel.png",
	    offset = {12*BOSS_GUNSHIP_SIZE_WIDTH_K, 68*BOSS_GUNSHIP_SIZE_HEIGHT_K},
	    color = {1,1,1,0.35},
	 },
	 {
	    layer = 1,
	    priority = 0,
	    width = w,
	    height = h,
	    texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Shadow_Nosegun_Barrel.png",
	    offset = {-12*BOSS_GUNSHIP_SIZE_WIDTH_K, 68*BOSS_GUNSHIP_SIZE_HEIGHT_K},
	    color = {1,1,1,0.35},
	 }
      }
   end

   return barrelShadowTemplates[key]
end
