require('app/template/boss-vehicles/boss_shared_common')

local TEMPLATE_DEATH_SFX_A =
{
	start	=	{
		"GunshipDeath",
	},
};

local TEMPLATE_DEATH_SFX_B =
{
	start	=	{
		"Debris1",
		"Debris2",
	},
};

local TEMPLATE_DEATH_SFX_C =
{
	start	=	{
		"BossDeathExplosion1",
	},
};

local TEMPLATE_DEATH_SFX_D =
{
	start	=	{
      "BossDeathExplosion1",
	},
};

local TEMPLATE_DEATH_SFX_E =
{
	start	=	{
		"Debris1",
		"Debris2",
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_HITMARKER =
{
	texture        = 'resources/Explosion/Explosion_04.png',
	width          = 64,
	height         = 64,
	growth         = { 10, 10 };
	duration       = 0.5,
	spin           = 360,
	avatarSpeedK   =  0.00,
	sounds			= TEMPLATE_DEATH_SFX_B,
	noParent			= true,
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_DEATHVFX =
{
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Flare.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 15, 15 },
		duration       = 0.75,
		spin           = 180,
		spinRnd        = 180,
		blend				= "add",
		x					= 0,
		y					= 0,
		trigTime			= 0.00,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_A,
		postEvent		= "gunship-splosion-left",
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 0,
		y					= -100,
		trigTime			= 0.00,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_B,
	},
	{
		texture			= 'resources/Explosion/Effect_ExplosionGray.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 10, 10 },
		duration       = 1.0,
		spin           = 180,
		spinRnd        = 90,
		color          = { 1.00, 1.00, 1.00, 1.0 },
		colorRnd       = { 1.00, 1.00, 1.00, 0.5 },
		x					= 0,
		y					= 100,
		trigTime			= 0.25,
		endTime			= 0.00,
		postEvent		= "gunship-splosion-right",
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 12, 12 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		x					= 0,
		y					= 100,
		trigTime			= 0.25,
		endTime			= 0.00,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= -98,
		y					= -15,
		trigTime			= 0.45,
		endTime			= 0.00,
		postEvent		= "gunship-splosion-left",
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 75,
		y					= 85,
		trigTime			= 0.75,
		endTime			= 0.00,
		postEvent		= "gunship-splosion-right",
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= -98,
		y					= -15,
		trigTime			= 1.10,
		endTime			= 0.00,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 98,
		y					= -15,
		trigTime			= 1.10,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_B,
	},
	{
		texture			= 'resources/Vehicle/Gunship_Boss/Boss_Gunship_Green_Chunk01.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = -0.10,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= -98,
		y					= -15,
		impulseVector	= { x=-1500,	y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Vehicle/Gunship_Boss/Boss_Gunship_Green_Chunk02.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = 0.10,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= -98,
		y					= -15,
		impulseVector	= { x=1500,		y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Vehicle/Gunship_Boss/Boss_Gunship_Green_Chunk01.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = -1.00,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= 98,
		y					= -15,
		impulseVector	= { x=-400,	y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Vehicle/Gunship_Boss/Boss_Gunship_Green_Chunk03.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = 1.00,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= 98,
		y					= -15,
		impulseVector	= { x=400,		y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 0,
		y					= 0,
		trigTime			= 1.10,
		endTime			= 0.00,
		postEvent		= "gunship-wing-hide",
      sounds         = TEMPLATE_DEATH_SFX_D,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= -40,
		y					= -115,
		trigTime			= 1.45,
		endTime			= 0.00,
      sounds         = TEMPLATE_DEATH_SFX_D,
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 12, 12 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		x					= 75,
		y					= 85,
		trigTime			= 1.65,
		endTime			= 2.00,
		postEvent		= "enable-distance-counter",
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_IDLE_ANIM =
{
--[[
	timeRot			=
	{
		1.0,
		1.0,
		1.0,
		1.0,
	},
	angle				=
	{
		-1.5,
		-0.25,
		1.3,
		0,
	},
]]
	timeOffset		=
	{
		35/30,
		25/30,
		35/30,
		25/30,
	},
	offset			=
	{
		{-11,		-5.5	},
		{-1.25,	-12	},
		{10,		-6.5	},
		{0,		0		},
	},
	timeScale		=
	{
		20/30,
		45/30,
		45/30,
		10/30,
	},
	scale				=
	{
		{1.0,		1.0	},
		{0.98,	0.98	},
		{1.0,		1.0	},
		{1.0,		1.0	},
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_STRAFE_LEFT_ANIM =
{
	--[[
	timeRot			=
	{
		13/30,
		47/30,
	},
	angle				=
	{
		3.0,
		7.4,
	},
	timeScale		=
	{
		13/30,
		47/30,
	},
	]]
	scale				=
	{
		{1.0,		1.0	},
		{0.98,	0.98	},
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_STRAFE_LEFT_EASE_ANIM =
{
--[[
	timeRot			=
	{
		34/30,
		26/30,
	},
	angle				=
	{
		-1.25*2,
		0.0,
	},
]]
	timeScale		=
	{
		18/30,
		16/30,
		26/30,
	},
	scale				=
	{
		{1.0,		1.0	},
		{0.98,	0.98	},
		{1.0,		1.0	},
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_STRAFE_RIGHT_ANIM =
{
--[[
	timeRot			=
	{
		13/30,
		47/30,
	},
	angle				=
	{
		-3.0,
		-7.4,
	},
]]
	timeScale		=
	{
		13/30,
		47/30,
	},
	scale				=
	{
		{1.0,		1.0	},
		{0.98,	0.98	},
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_STRAFE_RIGHT_EASE_ANIM =
{
--[[
	timeRot			=
	{

		34/30,
		26/30,
	},
	angle				=
	{

		1.25*2,
		0.0,
	},
]]
	timeScale		=
	{
		18/30,
		16/30,
		26/30,
	},
	scale				=
	{
		{1.0,		1.0	},
		{0.98,	0.98	},
		{1.0,		1.0	},
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_SHADOW =
{
	layer          = 1,
	priority			= 5;
	width          = 512,
	height         = 512,
	avatarSpeedK   = 0,
	texture        = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Shadow.png",
	offset         = {60,-75},
	color          = {1,1,1,0.5},
	noParent			= true,
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_HEALTHBAR =
{
	template    =
	{
		layer          = 2,
		priority			= 5,
		texture        = "resources/square.png",
		width          = 144,
		height         = 18,
		colorFull      = { 0, 0.75, 0, 1.00 },
		colorHalf      = { 0.75, 0.75, 0, 1.00 },
		colorEmpty     = { 0.75, 0, 0, 1.00 },

		frame				=
		{
			texture        = "resources/UI/Boss/Boss_HP_Frame.png",
			width          = 179,
			height         = 53,
		},

		background		=
		{
			texture        = "resources/square.png",
			width          = 148,
			height         = 22,
			color          = {0,0,0, 1.0},
		},
	},
	offset      = { 0, -220 },
};

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_BODY_FACE_SHOOT		= true;
TEMPLATE_BOSS_GUNSHIP_TURN_RATE				= 1.75;
TEMPLATE_BOSS_GUNSHIP_TURN_RATE_SCALE		= 3.5;
TEMPLATE_BOSS_GUNSHIP_TURN_LIMIT				= {-7.5,7.5};
TEMPLATE_BOSS_GUNSHIP_TURN_ANGLE_DELTA		= 2.5;
TEMPLATE_BOSS_GUNSHIP_TARGET_FACE_CONE		= 2.0;

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_COLLISION_OBJECTS =
{
   {
      delta = { 000, 000 },
      size  = { 120, 360 }
   },
   {
      delta = { 120, 050 },
      size  = { 134, 254 }
   },
   {
      delta = {-120, 050 },
      size  = { 134, 254 }
   },
}

----------------------------------------------------------------------

-- Boss Spawn
TEMPLATE_BOSS_GUNSHIP_SPAWN_LANE_LIMIT		= {3,		3};
TEMPLATE_BOSS_GUNSHIP_SPAWN_DELAY			= 2.4;
TEMPLATE_BOSS_GUNSHIP_WARNING_EXIT_DELAY	= 1.0;
TEMPLATE_BOSS_GUNSHIP_TARGET_GAME_SPEEDK	= 1.00;
TEMPLATE_BOSS_GUNSHIP_INIT_SHOOT_DELAY		= 2.25;
TEMPLATE_BOSS_GUNSHIP_LEVEL_TEXT_OFFSET_Y = 25;
TEMPLATE_BOSS_GUNSHIP_WARNING_LOGO			=
{
	texture			= "resources/UI/Boss/RR_Boss_Gunship_Logo.png",
	width				= 432,
	height			= 328,
};

-- Boss Barricade
TEMPLATE_BOSS_GUNSHIP_BARR_START_TIME		= {8, 8};
TEMPLATE_BOSS_GUNSHIP_BARR_REPEAT_DELAY	= {8, 8};
TEMPLATE_BOSS_GUNSHIP_BARR_SPAWN_DELAY		= {1.00, 1.75};
TEMPLATE_BOSS_GUNSHIP_BARR_COUNT_LIMIT		= {0, 0};
TEMPLATE_BOSS_GUNSHIP_BARR_LANE_LIMIT		= {true, true, true, true, true};
TEMPLATE_BOSS_GUNSHIP_BARR_LANE_BLOCK		= false;
TEMPLATE_BOSS_GUNSHIP_BARR_PROGRESS_TIME	= 8.0;

-- Boss Missiles
TEMPLATE_BOSS_GUNSHIP_MISS_START_TIME		= {100000, 100000};
TEMPLATE_BOSS_GUNSHIP_MISS_REPEAT_DELAY	= {150000, 150000};
TEMPLATE_BOSS_GUNSHIP_MISS_SPAWN_DELAY		= {0.25, 0.75};
TEMPLATE_BOSS_GUNSHIP_MISS_COUNT_LIMIT		= {1, 1};
TEMPLATE_BOSS_GUNSHIP_MISS_LANE_LIMIT		= {true, true, true, true, true};
TEMPLATE_BOSS_GUNSHIP_MISS_PROGRESS_TIME	= 1000.0;

----------------------------------------------------------------------

TEMPLATE_BOSS_GUNSHIP_PROJECTILE_TEXTURE = {
   3,
   3,
   1,
   1,
   4,
   4,
   2,
   2,
   5,
   5, -- 10
   3,
   3,
   1,
   1,
   4,
   4,
   2,
   2,
   5,
   5, -- 20
   3,
   3,
   1,
   1,
   4,
   4,
   2,
   2,
   5,
   5, -- 30
   3,
   3,
   1,
   1,
   4,
   4,
   2,
   2,
   5,
   5, -- 40
   3,
   3,
   1,
   1,
   4,
   4,
   2,
   2,
   5,
   5, -- 50
   3,
   1,
   4,
   2,
   5, -- 55
   3,
   1,
   4,
   2,
   5, -- 60
   3,
   1,
   4,
   2,
   5, -- 65
   3,
   1,
   4,
   2,
   5, -- 70
   3,
   1,
   4,
   2,
   5, -- 75
}

----------------------------------------------------------------------

require('app/template/barricade/barricade_01')
require('app/template/explosions/vehicle_explosion')
require('app/template/boss-vehicles/stats_template_boss')

BOSS_GUNSHIP_SIZE_WIDTH_K = 0.75
BOSS_GUNSHIP_SIZE_HEIGHT_K = 0.75

TEMPLATE_BOSS_GUNSHIP_BASE_TEMPLATE = {

   layer             = 3,
   useLevelSpeed     = true,
   speedMax          = {	10000 ,   1000	},
   speedMaxRnd       = {	0 ,   0	},
   avatarSpeedK      =  0.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,

   splitProp = false,
   width = 299*BOSS_GUNSHIP_SIZE_WIDTH_K,
   height = 410*BOSS_GUNSHIP_SIZE_HEIGHT_K,
   collisionWidth = 160*BOSS_GUNSHIP_SIZE_WIDTH_K,
   collisionHeight = 410*BOSS_GUNSHIP_SIZE_HEIGHT_K,

   screenClearance = 275*BOSS_GUNSHIP_SIZE_HEIGHT_K,
   widthClearance = 226*BOSS_GUNSHIP_SIZE_WIDTH_K,
   mass = 500*1000,

   flyoutMult = MULTIPLIER_FLYOUT_BOSS_TEMPLATES,
   flyoutScore = SCORE_FLYOUT_BOSS_TEMPLATES,

   avatarHitDamage   = { 1/12, 2/12, 3/12, 4/12, 5/12, 6/12, 7/12, 8/12, 9/12, 10/12, 11/12, 12/12 },

   drop = TEMPLATE_BASE_BOSS_DROP,
   dropSpeedK = TEMPLATE_BASE_BOSS_DROPSPEEDK,
   specialDropKillMin = TEMPLATE_BASE_BOSS_SPECIAL_DROP_KILL_MINMAX.min,
   specialDropKillMin = TEMPLATE_BASE_BOSS_SPECIAL_DROP_KILL_MINMAX.max,
   specialDrop = TEMPLATE_BASE_BOSS_SPECIAL_DROP,
   specialDropOdds = TEMPLATE_BASE_BOSS_SPECIAL_DROP_ODDS,
   specialDropIndex = TEMPLATE_BASE_BOSS_SPECIAL_DROP_INDEX,
   specialAdditive = TEMPLATE_BASE_BOSS_SPECIAL_DROP_ADDITIVE,
   damageTypeSound = {
      {start={
	  "AutoSkid1",},
      },
      {start={
	  "HTTCollision1",},
      },
      {},},
   explosion = TEMPLATE_VEHICLE_EXPLOSION.fuelTruck,

   playDeathAnim = true,

   -- Boss Spawn
   spawnLaneLimit = TEMPLATE_BOSS_GUNSHIP_SPAWN_LANE_LIMIT,
   spawnDelay = TEMPLATE_BOSS_GUNSHIP_SPAWN_DELAY,
   warningExitDelay = TEMPLATE_BOSS_GUNSHIP_WARNING_EXIT_DELAY,
   targetGameSpeedK = TEMPLATE_BOSS_GUNSHIP_TARGET_GAME_SPEEDK,
   initShootDelay = TEMPLATE_BOSS_GUNSHIP_INIT_SHOOT_DELAY,
   warningLogo = TEMPLATE_BOSS_GUNSHIP_WARNING_LOGO,
   levelTxtOffsetY = TEMPLATE_BOSS_GUNSHIP_LEVEL_TEXT_OFFSET_Y,

   -- Boss Strafe
   strafeLaneLimit = {1, 5},
   strafeDelayLimit = {3.00, 4.00},
   strafeSpeedMax = {-128, 128},
   strafeAccel = 128,
   strafeDeccel = 192,
   strafeMinToMax = true,

   -- Boss Barricade
   barrStartTime = TEMPLATE_BOSS_GUNSHIP_BARR_START_TIME,
   barrRepeatDelay = TEMPLATE_BOSS_GUNSHIP_BARR_REPEAT_DELAY,
   barrSpawnDelay = TEMPLATE_BOSS_GUNSHIP_BARR_SPAWN_DELAY,
   barrCountLimit = TEMPLATE_BOSS_GUNSHIP_BARR_COUNT_LIMIT,
   barrLaneLimit = TEMPLATE_BOSS_GUNSHIP_BARR_LANE_LIMIT,
   barrProgressTime  = TEMPLATE_BOSS_GUNSHIP_BARR_PROGRESS_TIME,
   barrTemplate = TEMPLATE_BARRICADE_01,
   barrBossLaneBlock = TEMPLATE_BOSS_GUNSHIP_BARR_LANE_BLOCK,

   -- Boss Missiles
   missStartTime = TEMPLATE_BOSS_GUNSHIP_MISS_START_TIME,
   missRepeatDelay = TEMPLATE_BOSS_GUNSHIP_MISS_REPEAT_DELAY,
   missSpawnDelay = TEMPLATE_BOSS_GUNSHIP_MISS_SPAWN_DELAY,
   missCountLimit = TEMPLATE_BOSS_GUNSHIP_MISS_COUNT_LIMIT,
   missLaneLimit = TEMPLATE_BOSS_GUNSHIP_MISS_LANE_LIMIT,
   missProgressTime = TEMPLATE_BOSS_GUNSHIP_MISS_PROGRESS_TIME,
   missTemplate = TEMPLATE_BOSS_MISSILE_TEMPLATES[1],
}
