require('app/template/template')

require('app/template/boss-vehicles/gunship/boss_gunship_common')
require('app/template/boss-vehicles/stats_template_boss')

require('app/template/boss-vehicles/gunship/turret')
require('app/template/boss-vehicles/gunship/vis_element')
require('app/template/boss-vehicles/gunship/gunship_shadow')
require('app/template/boss-vehicles/gunship/gunship_healthbar')
require('app/template/boss-vehicles/gunship/gunship_death_vfx')
require('app/template/boss-vehicles/gunship/gunship_collision')
require('app/template/boss-vehicles/gunship/gunship_armor')

function createGunshipBossTemplate(level)
   local t = Template.extent(TEMPLATE_BOSS_GUNSHIP_BASE_TEMPLATE)

   local BOSS_SIZE  = BOSS_SIZE_MEDIUM
   local BOSS_COLOR = TEMPLATE_BASE_BOSS_COLOR["Gunship"][math.clamp(level, 1, #TEMPLATE_BASE_BOSS_COLOR["Gunship"])]
   local BOSS_PROJECTILE_COLOR = TEMPLATE_BASE_BOSS_PROJECTILE_COLOR["Gunship"][math.clamp(level, 1, #TEMPLATE_BASE_BOSS_PROJECTILE_COLOR["Gunship"])]
   
   local newData = {
      type = "boss_gunship_" .. level,
      score = TEMPLATE_BASE_BOSS_SCORE["Gunship"][level],
      turret = getGunshipTurretTemplate(BOSS_SIZE, BOSS_COLOR, BOSS_PROJECTILE_COLOR, level),
      hitPoints = TEMPLATE_BASE_BOSS_HP["Gunship"][level],
      visElement = getGunshipVisElementTemplate(BOSS_SIZE, BOSS_COLOR),
      shadow = getGunshipShadowTemplate(BOSS_SIZE),
      texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_" .. getStringFromBossColor(BOSS_COLOR) .. ".png",
      healthBar = getGunshipHealthbarTemplate(BOSS_SIZE),
      deathVFX = getGunshipVFXTemplate(BOSS_SIZE, BOSS_COLOR),
      damageToAvatar = TEMPLATE_BASE_BOSS_RAM_DMG["Gunship"][level],
		dropIndex = TEMPLATE_BASE_BOSS_DROPINDEX[math.clamp(level, 1, #TEMPLATE_BASE_BOSS_DROPINDEX)],
      collisionObjects = getGunshipCollisionObjectTemplate(BOSS_SIZE),
      armor = getGunshipArmorTemplate(level)
   }

   Template.addDataFromMap(t, newData)

   return t
end

local function createGunshipBosses()
   for i = 1, #TEMPLATE_BASE_BOSS_HP["Gunship"] do
      -- Prepend a 0 when less than 10
      local digits = tostring(i)
      if i < 10 then
         digits = "0" .. digits
      end

      local templateName = "TEMPLATE_BOSS_GUNSHIP_" .. digits
      _G[templateName] = createGunshipBossTemplate(i)
   end
end

createGunshipBosses()
