require('app/template/boss-vehicles/gunship/boss_gunship_common')

-- Templates are stored when requested
local glowEffectTemplates = {}
local muzzleEffectTemplates = {}

local baseMuzzleVFX = {
   {
      layer = 4,
      width = 64,
      height = 64,
      blend = "add",
      offset = {14*BOSS_GUNSHIP_SIZE_WIDTH_K, 75*BOSS_GUNSHIP_SIZE_HEIGHT_K},
   },
   {
      layer = 4,
      width = 64,
      height = 64,
      blend = "add",
      offset = {-14*BOSS_GUNSHIP_SIZE_WIDTH_K, 75*BOSS_GUNSHIP_SIZE_HEIGHT_K},
   },
}

-- Utility functions
local function getDimensionsFromGunshipSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 54, 33
   end
end

-- MAIN factory function
function getGunshipGlowEffectTemplate(size, color)

   local key = size .. "-" .. color;
   
   if not glowEffectTemplates[key] then

      local w, h = getDimensionsFromGunshipSizeEnum(size)

      glowEffectTemplates[key] = {
	 layer = 4,
         texture = 'resources/Vehicle/PlayerVehicle_BlastCar/NovaGlow_' .. getStringFromBossColor(color) .. '.png',
         width = w,
         height = h,
         blend = "add",
      }
   end
   
   return glowEffectTemplates[key]
end

function getGunshipMuzzleVFXTemplate(size, color)
   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   local key = size .. "-" .. color

   if not muzzleEffectTemplates[key] then
      muzzleEffectTemplates[key] = Template.clone(baseMuzzleVFX)

      for i = 1, 2 do
	 muzzleEffectTemplates[key][i].texture = "resources/Vehicle/PlayerVehicle_BlastCar/NovaGlow_" .. getStringFromBossColor(color) .. ".png"
      end
   end

   return muzzleEffectTemplates[key]
end
