require('app/template/boss-vehicles/gunship/boss_gunship_common')

local armorTemplates = {}

function getGunshipArmorTemplate(level)

   if not armorTemplates[level] then

      local gunshipArmorLevel = nil

      if level <= 10 then
	 -- No armor
	 return nil
      elseif level <= 20 then
	 gunshipArmorLevel = "02"
      elseif level <= 30 then
	 gunshipArmorLevel = "03"
      elseif level <= 40 then
	 gunshipArmorLevel = "04"
      else
	 gunshipArmorLevel = "05"
      end

      Debug.assert(gunshipArmorLevel)

      armorTemplates[level] = {
	 layer				= 3,
	 priority			= 13,
	 width          = 512*BOSS_GUNSHIP_SIZE_WIDTH_K,
	 height         = 512*BOSS_GUNSHIP_SIZE_HEIGHT_K,
	 texture        = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Armor_Level" .. gunshipArmorLevel .. ".png",
	 offset         = {0*BOSS_GUNSHIP_SIZE_WIDTH_K, -42*BOSS_GUNSHIP_SIZE_HEIGHT_K},
      }
   end

   return armorTemplates[level]
end
