require('app/template/boss-vehicles/gunship/boss_gunship_common')

local vfxTemplates = {}

-- MAIN factory function
function getGunshipVFXTemplate(size, color)

   local key = size .. "-" .. color

   if not vfxTemplates[key] then

      -- NOTE: Size doesn't actually do anything for now.

      local DEATH_VFX		= Template.clone(TEMPLATE_BOSS_GUNSHIP_DEATHVFX)

      for i=1,#DEATH_VFX do
	 DEATH_VFX[i].x = TEMPLATE_BOSS_GUNSHIP_DEATHVFX[i].x * BOSS_GUNSHIP_SIZE_WIDTH_K
	 DEATH_VFX[i].y = TEMPLATE_BOSS_GUNSHIP_DEATHVFX[i].y * BOSS_GUNSHIP_SIZE_HEIGHT_K
      end

      -- Give the effect appropriately colored textures
      local colorStr = getStringFromBossColor(color)
      DEATH_VFX[8].texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_" .. colorStr .. "_Chunk01.png"
      DEATH_VFX[9].texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_" .. colorStr .. "_Chunk02.png"
      DEATH_VFX[10].texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_" .. colorStr .. "_Chunk01.png"
      DEATH_VFX[11].texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_" .. colorStr .. "_Chunk03.png"

      vfxTemplates[key] = DEATH_VFX
   end

   return vfxTemplates[key]
end
