require('app/template/boss-vehicles/gunship/boss_gunship_common')

-- Templates are stored when requested
local turretShadowTemplates = {}

-- Utility functions
local function getDimensionsFromGunshipSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 89*BOSS_GUNSHIP_SIZE_WIDTH_K, 96*BOSS_GUNSHIP_SIZE_HEIGHT_K
   end
end

local function getOffsetFromGunshipSizeEnum(size)
   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return {0*BOSS_GUNSHIP_SIZE_WIDTH_K, -152*BOSS_GUNSHIP_SIZE_HEIGHT_K}
   end
end

-- MAIN factory function
function getGunshipTurretShadowTemplate(size)
   local key = size
   
   if not turretShadowTemplates[key] then
      local w, h = getDimensionsFromGunshipSizeEnum(size)
      turretShadowTemplates[key] = {
	 layer = 1;
	 priority = 3;
	 width = w,
         height = h,
	 texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Shadow_Nosegun_Body.png",
         offset = getOffsetFromGunshipSizeEnum(size),
         color = {1,1,1,0.0},
      }
   end
   
   return turretShadowTemplates[key]
end
