require('app/template/boss-vehicles/gunship/boss_gunship_common')
require('app/template/boss-vehicles/stats_template_boss')

local visElementTemplates = {}

local visElementBase = {
   layer       = 3,
   priority    = 12,
   width       = 385*BOSS_GUNSHIP_SIZE_WIDTH_K,
   height      = 132*BOSS_GUNSHIP_SIZE_HEIGHT_K,
   --texture     = "resources/Vehicle/Gunship_Boss/Boss_Gunship_Orange_Rotors.png",
   offset      = {0*BOSS_GUNSHIP_SIZE_WIDTH_K, -12*BOSS_GUNSHIP_SIZE_HEIGHT_K},
}

-- MAIN factory function
function getGunshipVisElementTemplate(size, color)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   local key = size .. "-" .. color

   if not visElementTemplates[key] then

      visElementTemplates[key] = {}
      visElementTemplates[key][1] = Template.extent(visElementBase)
      visElementTemplates[key][1].texture = "resources/Vehicle/Gunship_Boss/Boss_Gunship_" .. getStringFromBossColor(color) .."_Rotors.png"
   end

   return visElementTemplates[key]

end
