require('app/template/boss-vehicles/tank/boss_tank_common')

-- Templates are stored when requested
local barrelTemplates = {}

-- Utility functions
local function getDimensionsFromTankSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 34*BOSS_TANK_SIZE_WIDTH_K, 93*BOSS_TANK_SIZE_HEIGHT_K
   end
end

local function getOffsetFromTankSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return {0, 125.5*BOSS_TANK_SIZE_HEIGHT_K}
   end

end

-- MAIN factory function
function getBarrelTemplate(size, color)
   local key = size .. "-" .. color;
   
   if not barrelTemplates[key] then
      local w, h = getDimensionsFromTankSizeEnum(size)
      barrelTemplates[key] = 
      {
         width = w,
         height = h,
         texture = "resources/Vehicle/Tank_Boss/Boss_Tank_" .. getStringFromBossColor(color) .. "_Turret_Tip.png",
         offset = getOffsetFromTankSizeEnum(size)
      }
   end
   
   return barrelTemplates[key]
end
