require('app/template/boss-vehicles/tank/boss_tank_common')

-- Templates are stored when requested 
local barrelShadowTemplates = {}

-- Utility functions
local function getDimensionsFromTankSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 34*BOSS_TANK_SIZE_WIDTH_K, 93*BOSS_TANK_SIZE_HEIGHT_K
   end
end

local function getOffsetFromTankSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return {-30*BOSS_TANK_SIZE_WIDTH_K, 30*BOSS_TANK_SIZE_HEIGHT_K}
   end

end

-- MAIN factory function
function getBarrelShadowTemplate(size)
   local key = size

   if not barrelShadowTemplates[key] then
      local w, h = getDimensionsFromTankSizeEnum(size)
      barrelShadowTemplates[key] = 
	 {
	    width = w,
	    height = h,
	    texture = "resources/Vehicle/Tank_Boss/Boss_Tank_Turret_Tip_Shadow.png",
	    offset = getOffsetFromTankSizeEnum(size),
	    color = {1,1,1,0.5},
	 }
   end

   return barrelShadowTemplates[key]
end
