require('app/template/boss-vehicles/boss_shared_common')

local TEMPLATE_DEATH_SFX_A =
{
	start	=	{
		"Explosion1",
		"Explosion2",
		"Explosion3",
	},
};

local TEMPLATE_DEATH_SFX_B =
{
	start	=	{
		"Debris1",
		"Debris2",
	},
};

local TEMPLATE_DEATH_SFX_C =
{
	start	=	{
		"BossDeathExplosion1",
	},
};

local TEMPLATE_DEATH_SFX_D =
{
	start	=	{
      "BossDeathExplosion1",
	},
};

local TEMPLATE_DEATH_SFX_E =
{
	start	=	{
		"Debris1",
		"Debris2",
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_TANK_HITMARKER =
{
	texture        = 'resources/Explosion/Explosion_04.png',
	width          = 64,
	height         = 64,
	growth         = { 10, 10 };
	duration       = 0.5,
	spin           = 360,
	avatarSpeedK   =  0.00,
	sounds			= TEMPLATE_DEATH_SFX_B,
	noParent			= true,
};

----------------------------------------------------------------------

TEMPLATE_BOSS_TANK_DEATHVFX =
{
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Flare.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 15, 15 },
		duration       = 0.75,
		spin           = 180,
		spinRnd        = 180,
		blend				= "add",
		x					= 0,
		y					= 0,
		trigTime			= 0.00,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_C,
	},
	{
		texture			= 'resources/Explosion/Effect_ExplosionGray.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 10, 10 },
		duration       = 1.0,
		spin           = 180,
		spinRnd        = 90,
		color          = { 1.00, 1.00, 1.00, 1.0 },
		colorRnd       = { 1.00, 1.00, 1.00, 0.5 },
		x					= 0,
		y					= -130,
		trigTime			= 0.00,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_A,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 0,
		y					= -130,
		trigTime			= 0.00,
		endTime			= 0.00,
	},
	{
		texture			= 'resources/Explosion/Effect_ExplosionGray.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 10, 10 },
		duration       = 1.0,
		spin           = 180,
		spinRnd        = 90,
		color          = { 1.00, 1.00, 1.00, 1.0 },
		colorRnd       = { 1.00, 1.00, 1.00, 0.5 },
		x					= 0,
		y					= 130,
		trigTime			= 0.25,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_A,
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 12, 12 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		x					= 0,
		y					= 130,
		trigTime			= 0.25,
		endTime			= 0.00,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= -30,
		y					= -120,
		trigTime			= 0.45,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_E,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 30,
		y					= 120,
		trigTime			= 0.75,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_A,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= 0,
		y					= 0,
		trigTime			= 1.10,
		endTime			= 0.00,
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 48,
		height			= 48,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 1.35,
		spin           = 180,
		spinRnd        = 90,
		x					= 0,
		y					= 0,
		trigTime			= 1.10,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_B,
	},
	{
		texture			= 'resources/Vehicle/Tank_Boss/Boss_Tank_Green_Chunk01.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = -0.10,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= 64,
		y					= -64,
		impulseVector	= { x=-1500,	y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Vehicle/Tank_Boss/Boss_Tank_Green_Chunk02.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = 0.10,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= -64,
		y					= 64,
		impulseVector	= { x=1500,		y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Vehicle/Tank_Boss/Boss_Tank_Green_Chunk01.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = -1.00,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= 64,
		y					= 64,
		impulseVector	= { x=-400,	y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Vehicle/Tank_Boss/Boss_Tank_Green_Chunk03.png',
		width				= 128,
		height			= 128,
		avatarSpeedK   = 1.00,
		angleRnd       = 360,
		growth         = { 1, 1 },
		duration       = 1.00,
		spin           = 180,
		spinRnd        = 90,
		x					= -64,
		y					= 64,
		impulseVector	= { x=400,		y=0 },
		trigTime			= 1.10,
		endTime			= 0.00,
		disableParent	= true,
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 96,
		height			= 96,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 16, 16 },
		duration       = 1.35,
		spin           = 180,
		spinRnd        = 90,
		x					= 0,
		y					= 0,
		trigTime			= 1.10,
		endTime			= 0.00,
		postEvent		= "vehicle-turret-hide",
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= -64,
		y					= -160,
		trigTime			= 1.45,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_D,
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 12, 12 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		x					= 64,
		y					= 160,
		trigTime			= 1.65,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_E,
	},
	{
		texture			= 'resources/Explosion/Boss/RR_Effect_Corona.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		x					= 64,
		y					= -160,
		trigTime			= 1.90,
		endTime			= 0.00,
		sounds			= TEMPLATE_DEATH_SFX_A,
	},
	{
		texture			= 'resources/Explosion/Explosion_04.png',
		width				= 64,
		height			= 64,
		avatarSpeedK   = 0.00,
		angleRnd       = 360,
		growth         = { 8, 8 },
		duration       = 0.5,
		spin           = 180,
		spinRnd        = 90,
		color          = { 0.90, 0.75, 0.00, 1.0 },
		colorRnd       = { 0.10, 0.25, 0.00, 0.5 },
		x					= -64,
		y					= 160,
		trigTime			= 2.10,
		endTime			= 2.50,
		sounds			= TEMPLATE_DEATH_SFX_E,
		postEvent		= "enable-distance-counter",
	},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_TANK_SHADOW =
{
	layer          = 1,
	width          = 256,
	height         = 512,
	avatarSpeedK   = 0,
	texture        = "resources/Vehicle/Tank_Boss/Boss_Tank_Shadow.png",
	offset         = {30, -30},
	color          = {1,1,1,0.5},
};

----------------------------------------------------------------------

TEMPLATE_BOSS_TANK_HEALTHBAR =
{
	template    =
	{
		layer          = 4,
		texture        = "resources/square.png",
		width          = 144,
		height         = 18,
		colorFull      = { 0, 0.75, 0, 1.00 },
		colorHalf      = { 0.75, 0.75, 0, 1.00 },
		colorEmpty     = { 0.75, 0, 0, 1.00 },
		
		frame				=
		{
			texture        = "resources/UI/Boss/Boss_HP_Frame.png",
			width          = 179,
			height         = 53,
		},
		
		background		=
		{
			texture        = "resources/square.png",
			width          = 148,
			height         = 22,
			color          = {0,0,0, 1.0},
		},
	},
	offset      = { 0, -211 },
};

----------------------------------------------------------------------

TEMPLATE_BOSS_TANK_TURN_STRAFE			= true;
TEMPLATE_BOSS_TANK_TURN_RATE				= 3;
TEMPLATE_BOSS_TANK_TURN_LIMIT				= {-3, 3};

----------------------------------------------------------------------

-- Boss Spawn
TEMPLATE_BOSS_TANK_SPAWN_LANE_LIMIT		= {3,	3};
TEMPLATE_BOSS_TANK_SPAWN_DELAY			= 2.4;
TEMPLATE_BOSS_TANK_WARNING_EXIT_DELAY	= 1.0;
TEMPLATE_BOSS_TANK_TARGET_GAME_SPEEDK	= 1.00;
TEMPLATE_BOSS_TANK_INIT_SHOOT_DELAY		= 2.25;
TEMPLATE_BOSS_TANK_WARNING_LOGO			=
{
	texture			= "resources/UI/Boss/RR_Boss_TankLogo.png",
	width				= 384,
	height			= 315,
};

-- Boss Barricade
TEMPLATE_BOSS_TANK_BARR_START_TIME		= {10, 10};
TEMPLATE_BOSS_TANK_BARR_REPEAT_DELAY	= {10, 10};
TEMPLATE_BOSS_TANK_BARR_SPAWN_DELAY		= {0, 0};
TEMPLATE_BOSS_TANK_BARR_COUNT_LIMIT		= {0, 0};
TEMPLATE_BOSS_TANK_BARR_LANE_LIMIT		= {true, true, true, true, true};
TEMPLATE_BOSS_TANK_BARR_LANE_BLOCK		= true;

-- Boss Missiles
TEMPLATE_BOSS_TANK_MISS_START_TIME		= {8, 8};
TEMPLATE_BOSS_TANK_MISS_REPEAT_DELAY	= {8, 8};
TEMPLATE_BOSS_TANK_MISS_SPAWN_DELAY		= {1.00, 1.75};
TEMPLATE_BOSS_TANK_MISS_COUNT_LIMIT		= {0, 0};
TEMPLATE_BOSS_TANK_MISS_LANE_LIMIT		= {true, true, true, true, true};
TEMPLATE_BOSS_TANK_MISS_PROGRESS_TIME	= 8.0;

----------------------------------------------------------------------

require('app/template/barricade/barricade_01')
require('app/template/explosions/vehicle_explosion')
require('app/template/boss-vehicles/stats_template_boss')

BOSS_TANK_SIZE_WIDTH_K = 0.85;
BOSS_TANK_SIZE_HEIGHT_K = 0.85;

TEMPLATE_BOSS_TANK_BASE_TEMPLATE = {
   layer             =  3,
   useLevelSpeed     = true,   
   speedMax          = { 10000, 0 },
   speedMaxRnd       = { 0, 0 },      
   avatarSpeedK      =  0.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   splitProp = false,   

   width             = 256*BOSS_TANK_SIZE_WIDTH_K,
   height            = 512*BOSS_TANK_SIZE_HEIGHT_K,
   collisionWidth    = 192*BOSS_TANK_SIZE_WIDTH_K,
   collisionHeight   = 354*BOSS_TANK_SIZE_HEIGHT_K,
   screenClearance   = 225*BOSS_TANK_SIZE_HEIGHT_K,

   mass = 500*1000,
   flyoutMult = MULTIPLIER_FLYOUT_BOSS_TEMPLATES,
   flyoutScore = SCORE_FLYOUT_BOSS_TEMPLATES,
   avatarHitDamage = { 1/12, 2/12, 3/12, 4/12, 5/12, 6/12, 7/12, 8/12, 9./12, 10/12, 11/12, 12/12 },
   
   drop = TEMPLATE_BASE_BOSS_DROP,
   dropSpeedK = TEMPLATE_BASE_BOSS_DROPSPEEDK,
   specialDropKillMin = TEMPLATE_BASE_BOSS_SPECIAL_DROP_KILL_MINMAX.min,
   specialDropKillMax = TEMPLATE_BASE_BOSS_SPECIAL_DROP_KILL_MINMAX.max,    
   specialDrop = TEMPLATE_BASE_BOSS_SPECIAL_DROP,
   specialDropOdds = TEMPLATE_BASE_BOSS_SPECIAL_DROP_ODDS,
   specialDropIndex = TEMPLATE_BASE_BOSS_SPECIAL_DROP_INDEX,
   specialAdditive = TEMPLATE_BASE_BOSS_SPECIAL_DROP_ADDITIVE, 

   onHitSound = {start={"BulletImpact2",},};
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},},
   explosion = TEMPLATE_VEHICLE_EXPLOSION.fuelTruck, 
   
   spawnLaneLimit = TEMPLATE_BOSS_TANK_SPAWN_LANE_LIMIT,
   spawnDelay = TEMPLATE_BOSS_TANK_SPAWN_DELAY,
   warningExitDelay = TEMPLATE_BOSS_TANK_WARNING_EXIT_DELAY,
   targetGameSpeedK = TEMPLATE_BOSS_TANK_TARGET_GAME_SPEEDK,
   initShootDelay = TEMPLATE_BOSS_TANK_INIT_SHOOT_DELAY,
   warningLogo = TEMPLATE_BOSS_TANK_WARNING_LOGO,
   
   strafeLaneLimit = {1, 5},
   strafeMinToMax = false,   

   -- Boss Death Splosions
   playDeathAnim = true,
   
   -- Boss Barricade
   barrStartTime = TEMPLATE_BOSS_TANK_BARR_START_TIME,
   barrRepeatDelay = TEMPLATE_BOSS_TANK_BARR_REPEAT_DELAY,
   barrSpawnDelay = TEMPLATE_BOSS_TANK_BARR_SPAWN_DELAY,
   barrCountLimit = TEMPLATE_BOSS_TANK_BARR_COUNT_LIMIT,
   barrLaneLimit = TEMPLATE_BOSS_TANK_BARR_LANE_LIMIT,
   barrTemplate = TEMPLATE_BARRICADE_01,
   barrBossLaneBlock = TEMPLATE_BOSS_TANK_BARR_LANE_BLOCK,   
   
   -- Boss Missiles
   missStartTime = TEMPLATE_BOSS_TANK_MISS_START_TIME,
   missRepeatDelay = TEMPLATE_BOSS_TANK_MISS_REPEAT_DELAY,
   missSpawnDelay = TEMPLATE_BOSS_TANK_MISS_SPAWN_DELAY,
   missCountLimit = TEMPLATE_BOSS_TANK_MISS_COUNT_LIMIT,
   missLaneLimit = TEMPLATE_BOSS_TANK_MISS_LANE_LIMIT,
   missProgressTime = TEMPLATE_BOSS_TANK_MISS_PROGRESS_TIME,
}
