require('app/template/boss-vehicles/tank/boss_tank_common')

-- Templates are stored when requested
local glowEffectTemplates = {}

-- Utility functions
local function getDimensionsFromTankSizeEnum(size)

   Debug.assert(size == BOSS_SIZE_MEDIUM, "Invalid size.");

   if size == BOSS_SIZE_MEDIUM then
      return 54/2, 33/2
   end
end

-- MAIN factory function
function getGlowEffectTemplate(size, color)

   local key = size .. "-" .. color;
   
   if not glowEffectTemplates[key] then

      local w, h = getDimensionsFromTankSizeEnum(size)

      glowEffectTemplates[key] =
      {
         texture = 'resources/Vehicle/PlayerVehicle_BlastCar/NovaGlow_' .. getStringFromBossColor(color) .. '.png',
         width = w,
         height = h,
         blend = "add",
      }
   end
   
   return glowEffectTemplates[key]
end
