require('app/template/boss-vehicles/tank/boss_tank_common')

local armorTemplates = {}
local turretArmorTemplates = {}

function getTankArmorTemplate(level)

   if not armorTemplates[level] then

      local tankArmorLevel = nil

      if level <= 10 then
	 -- No armor
	 return nil
      elseif level <= 20 then
	 tankArmorLevel = "02"
      elseif level <= 40 then
	 tankArmorLevel = "03"
      else
	 tankArmorLevel = "05"
      end

      Debug.assert(tankArmorLevel)

      armorTemplates[level] = {
	 width          = 256*BOSS_TANK_SIZE_WIDTH_K,
	 height         = 512*BOSS_TANK_SIZE_HEIGHT_K,
	 texture        = "resources/Vehicle/Tank_Boss/Boss_Tank_Armor_Level" .. tankArmorLevel .. ".png",
	 offset         = {0, 0},
      }
   end

   return armorTemplates[level]
end

function getTankTurretArmorTemplate(level)
   if not turretArmorTemplates[level] then
      local turretArmorLevel = nil

      if level <= 30 then
	 -- No turret armor
	 return nil
      else
	 turretArmorLevel = "04"
      end

      turretArmorTemplates[level] = {
	 width          = 256*BOSS_TANK_SIZE_WIDTH_K,
	 height         = 512*BOSS_TANK_SIZE_HEIGHT_K,
	 texture        = "resources/Vehicle/Tank_Boss/Boss_Tank_Armor_Level" .. turretArmorLevel .. ".png",
	 offset         = {1*BOSS_TANK_SIZE_WIDTH_K, -100*BOSS_TANK_SIZE_HEIGHT_K},
      }
   end

   return turretArmorTemplates[level]
end
