require('app/template/boss-vehicles/tank/boss_tank_common')

local vfxTemplates = {}

-- MAIN factory function
function getTankVFXTemplate(size, color)

   local key = size .. "-" .. color

   if not vfxTemplates[key] then

      -- NOTE: Size doesn't actually do anything for now.

      local DEATH_VFX		= Template.clone(TEMPLATE_BOSS_TANK_DEATHVFX)

      for i=1,#DEATH_VFX do
	 DEATH_VFX[i].x = TEMPLATE_BOSS_TANK_DEATHVFX[i].x * BOSS_TANK_SIZE_WIDTH_K
	 DEATH_VFX[i].y = TEMPLATE_BOSS_TANK_DEATHVFX[i].y * BOSS_TANK_SIZE_HEIGHT_K
      end

      -- Give the effect appropriately colored textures
      local colorStr = getStringFromBossColor(color)
      DEATH_VFX[10].texture = "resources/Vehicle/Tank_Boss/Boss_Tank_" .. colorStr .. "_Chunk01.png"
      DEATH_VFX[11].texture = "resources/Vehicle/Tank_Boss/Boss_Tank_" .. colorStr .. "_Chunk02.png"
      DEATH_VFX[12].texture = "resources/Vehicle/Tank_Boss/Boss_Tank_" .. colorStr .. "_Chunk01.png"
      DEATH_VFX[13].texture = "resources/Vehicle/Tank_Boss/Boss_Tank_" .. colorStr .. "_Chunk03.png"

      vfxTemplates[key] = DEATH_VFX
   end

   return vfxTemplates[key]
end
