local DMG_DIV	= 3;		-- main weapon max dps is ~300% the min weapon damage for a player vehicle
local HP_DIV	= 1.5;	-- player vehicle max hp is ~450% the min hp of that vehicle

local drone_default_tbls =
{
	enable						= true,
	droneMinLevel				= 4,
	droneDupeResolve			= "hybrid", --"auto-merge", "evolve"
	droneMaxGarageSpace		= 12, --ATTENTION: MAX SPACE MUST BE GREATER THEN NUMBER OF DRONE TYPES
	
	--progressive drone mount unlock cost left/right
	droneMountUnlockCost		=
	{
		{gold=nil, gem=0},
		{gold=nil, gem=50},
	},
	
	--progressive drone build cost
	droneBuildCost				=
	{
      {gold=nil, gem=0,   },
      {gold=nil, gem=25,  },
      {gold=nil, gem=50,  },
      {gold=nil, gem=75,  },
      {gold=nil, gem=100, },
      {gold=nil, gem=125, },
      {gold=nil, gem=150, },
      {gold=nil, gem=175, },
      {gold=nil, gem=200, },
	},
	
	-- progressive drone upgrade cost based on rarity
	droneUpgradeCost			=
	{
		--common
		{
			{gold=100,		gem=nil},
			{gold=200,		gem=nil},
			{gold=300,		gem=nil},
			{gold=400,		gem=nil},
			{gold=500,		gem=nil},
			{gold=600,		gem=nil},
			{gold=700,		gem=nil},
			{gold=800,		gem=nil},
			{gold=900,		gem=nil},
			{gold=1000,		gem=nil},
			{gold=1100,		gem=nil},
			{gold=1200,		gem=nil},
			{gold=1300,		gem=nil},
			{gold=1400,		gem=nil},
			{gold=1500,		gem=nil},
		},
		--uncommon
		{
			{gold=2000,		gem=nil},
			{gold=2250,		gem=nil},
			{gold=2500,		gem=nil},
			{gold=2750,		gem=nil},
			{gold=3000,		gem=nil},
			{gold=3250,		gem=nil},
			{gold=3500,		gem=nil},
			{gold=3750,		gem=nil},
			{gold=4000,		gem=nil},
			{gold=4250,		gem=nil},
			{gold=4500,		gem=nil},
			{gold=4750,		gem=nil},
			{gold=5000,		gem=nil},
			{gold=5250,		gem=nil},
			{gold=5500,		gem=nil},
		},
		--rare
		{
			{gold=6000,		gem=nil},
			{gold=7000,		gem=nil},
			{gold=8000,		gem=nil},
			{gold=9000,		gem=nil},
			{gold=10000,	gem=nil},
			{gold=12500,	gem=nil},
			{gold=15000,	gem=nil},
			{gold=17500,	gem=nil},
			{gold=20000,	gem=nil},
			{gold=22500,	gem=nil},
			{gold=25000,	gem=nil},
			{gold=27500,	gem=nil},
			{gold=30000,	gem=nil},
			{gold=32500,	gem=nil},
			{gold=35000,	gem=nil},
		},
		--epic
		{
			{gold=37500,	gem=nil},
			{gold=40000,	gem=nil},
			{gold=42500,	gem=nil},
			{gold=45000,	gem=nil},
			{gold=47500,	gem=nil},
			{gold=50000,	gem=nil},
			{gold=52500,	gem=nil},
			{gold=55000,	gem=nil},
			{gold=57500,	gem=nil},
			{gold=60000,	gem=nil},
			{gold=62500,	gem=nil},
			{gold=65000,	gem=nil},
			{gold=67500,	gem=nil},
			{gold=70000,	gem=nil},
			{gold=72500,	gem=nil},
		},
		--legendary
		{
			{gold=75000,	gem=nil},
			{gold=80000,	gem=nil},
			{gold=85000,	gem=nil},
			{gold=90000,	gem=nil},
			{gold=95000,	gem=nil},
			{gold=100000,	gem=nil},
			{gold=105000,	gem=nil},
			{gold=110000,	gem=nil},
			{gold=115000,	gem=nil},
			{gold=120000,	gem=nil},
			{gold=125000,	gem=nil},
			{gold=130000,	gem=nil},
			{gold=135000,	gem=nil},
			{gold=140000,	gem=nil},
			{gold=145000,	gem=nil},
		},
	},
	
	--progressive drone rarity evolve cost for current drone level
	droneEvolveCost			=
	{
		{gold=nil, gem=100},
		{gold=nil, gem=250},
		{gold=nil, gem=500},
		{gold=nil, gem=1000},
		{gold=nil, gem=1000},
	},
	
	--rarity based sell				--common							--uncommon						--rare								--epic								--legendary
	droneSell					= {	{gold=500, gem=nil},			{gold=1000, gem=nil},		{gold=2500, gem=nil},			{gold=5000, gem=nil},			{gold=10000, gem=nil}	},
	
	--maps to ability templates in drone manager CAUTION: ODER IS THE INDEX ID OF THE DRONE
											--gun			--laser		--boost		--missile	--rocket		--repair		--shield    --barricade
	--droneAbilityOdds			= {	1.0,			1.0,			0.6,			1.0,			1.0,			1.0,			1.0,     1.0,  },
	droneAbilityOdds			= {	1.0,			1.0,			0.6,			1.0,			1.0,			1.0,	},

	--scalar mod to ability based on existing rarity or collected drone
                                 --common		--uncommon	--rare		--epic		--legendary
	droneAbilityOddsK			= {	0.2,			0.1,			0.05,			0.001,		0	},
	
	--maps to ability templates in drone order for left and right side
	droneBuildOrder			=
	{
		left =
		{
			1,	--gun
         --7,	--shield
         --8, --barricade
		},
		right =
		{
		},
	},
	
	--progressive odds table based on total drones built
	droneRarityOdds		=
	{
		--length of array sets max rarity
		--common		--uncommon	--rare		--epic		--legendary
		{	1.0,			0.0,			0.0,			0.0,			0.0	},
	},
	
	droneStats	=
	{
		gun =
		{
			--damage divisor based on car main weapon max dmg
			rarity =
			{
				3.6*DMG_DIV, 3.1*DMG_DIV, 2.6*DMG_DIV, 2.1*DMG_DIV, 1.5*DMG_DIV,
			},
			--subtractive damage divisor mod
			level	=
			{
				0.03*DMG_DIV, 0.06*DMG_DIV, 0.1*DMG_DIV, 0.13*DMG_DIV, 0.16*DMG_DIV, 0.20*DMG_DIV, 0.23*DMG_DIV, 0.26*DMG_DIV, 0.30*DMG_DIV, 0.33*DMG_DIV, 0.36*DMG_DIV, 0.40*DMG_DIV, 0.43*DMG_DIV, 0.46*DMG_DIV, 0.50*DMG_DIV,
			},
			--name
			name =
			{
				"Gun",
				"Gun",
				"Gun",
				"Gun",
				"Gun",
			},
			--description text
			desc =
			{
				"Rapid fire machine guns",
				"• Stars increase damage",
				"• Levels increase firing rate",
			},
		},
		laser =
		{
			--damage divisor based on car main weapon max dmg
			rarity =
			{
				3.6*32*DMG_DIV, 3.1*32*DMG_DIV, 2.6*32*DMG_DIV, 2.1*32*DMG_DIV, 1.5*32*DMG_DIV,
			},
			--subtractive damage divisor mod
			level	=
			{
				0.03*32*DMG_DIV, 0.06*32*DMG_DIV, 0.1*32*DMG_DIV, 0.13*32*DMG_DIV, 0.16*32*DMG_DIV, 0.20*32*DMG_DIV, 0.23*32*DMG_DIV, 0.26*32*DMG_DIV, 0.30*32*DMG_DIV, 0.33*32*DMG_DIV, 0.36*32*DMG_DIV, 0.40*32*DMG_DIV, 0.43*32*DMG_DIV, 0.46*32*DMG_DIV, 0.50*32*DMG_DIV,
			},
			--name
			name =
			{
				"Laser",
				"Laser",
				"Laser",
				"Laser",
				"Laser",
			},
			--description text
			desc =
			{
				"High powered laser cannon",
				"• Stars increase beams",
				"• Levels increase beam duration",
			},
		},
		rocket =
		{
			--damage divisor based on car main weapon max dmg
			rarity =
			{
				3.6*DMG_DIV, 3.1*DMG_DIV, 2.6*DMG_DIV, 2.1*DMG_DIV, 1.5*DMG_DIV,
			},
			--subtractive damage divisor mod
			level	=
			{
				0.03*DMG_DIV, 0.06*DMG_DIV, 0.1*DMG_DIV, 0.13*DMG_DIV, 0.16*DMG_DIV, 0.20*DMG_DIV, 0.23*DMG_DIV, 0.26*DMG_DIV, 0.30*DMG_DIV, 0.33*DMG_DIV, 0.36*DMG_DIV, 0.40*DMG_DIV, 0.43*DMG_DIV, 0.46*DMG_DIV, 0.50*DMG_DIV,
			},
			--name
			name =
			{
				"Rocket",
				"Rocket",
				"Rocket",
				"Rocket",
				"Rocket",
			},
			--description text
			desc =
			{
				"Multi-direction rocket salvo",
				"• Stars increase rockets per salvo",
				"• Levels increase damage",
			},
		},
		magnet =
		{
			--radius base indexed by rarity
			rarity =
			{
				50, 120, 190, 260, 340,
			},
			--additive radius mod by level
			level	=
			{
				4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60,
			},
			--name
			name =
			{
				"Magnet",
				"Magnet",
				"Magnet",
				"Magnet",
				"Magnet",
			},
			--description text
			desc =
			{
				"Auto collects loot drops in range",
				"• Stars increase range",
				"• Levels increase pulse frequency",
			},
		},
		scoreMult =
		{
			--additive scoreK base indexed by rarity
			rarity =
			{
				0.20, 0.40, 0.60, 0.80, 1.00,
			},

			level	=
			{
				chargeThreshold =
				{
					39, 38, 37, 36, 35, 34, 33, 32, 31, 30, 29, 28, 27, 26, 25,
				},
				duration =
				{
					5.0, 5.5, 6.0, 6.5, 7.0, 7.5, 8.0, 8.5, 9.0, 9.5, 10.0, 10.5, 11.0, 11.5, 12.0,
				},
			},
			--name
			name =
			{
				"Bonus",
				"Bonus",
				"Bonus",
				"Bonus",
				"Bonus",
			},
			--description text
			desc =
			{
				"Auto increase enemy kill value when charged",
				"• Stars increase enemy point value",
				"• Levels increase duration",
				"• Collect coins in game to charge",
			},
		},
		missile =
		{
			--damage divisor based on car main weapon max dmg
			rarity =
			{
				3.6*DMG_DIV, 3.1*DMG_DIV, 2.6*DMG_DIV, 2.1*DMG_DIV, 1.5*DMG_DIV,
			},
			--subtractive damage divisor mod
			level	=
			{
				0.03*DMG_DIV, 0.06*DMG_DIV, 0.1*DMG_DIV, 0.13*DMG_DIV, 0.16*DMG_DIV, 0.20*DMG_DIV, 0.23*DMG_DIV, 0.26*DMG_DIV, 0.30*DMG_DIV, 0.33*DMG_DIV, 0.36*DMG_DIV, 0.40*DMG_DIV, 0.43*DMG_DIV, 0.46*DMG_DIV, 0.50*DMG_DIV,
			},
			--name
			name =
			{
				"Hunter",
				"Hunter",
				"Hunter",
				"Hunter",
				"Hunter",
			},
			--description text
			desc =
			{
				"Auto targeted heatseeking warhead",
				"• Stars increase number of drones",
				"• Levels increase explosive damage",
			},
		},
		repair =
		{
			--charge threshold
			rarity =
			{
				30, 25, 20, 15, 10,
			},
			
			level	=
			{
				-- heal percent per tick
				heal		=
				{
					5, 6, 7, 8, 9, 11, 12, 13, 14, 15, 17, 18, 19, 20, 22,
				},
				--	heal tick rate time
				delay		=
				{
					29/30, 28/30, 27/30, 26/30, 25/30, 24/30, 23/30, 22/30, 21/30, 20/30, 19/30, 18/30, 17/30, 16/30, 15/30
				},
			},
			--name
			name =
			{
				"Repair",
				"Repair",
				"Repair",
				"Repair",
				"Repair",
			},
			--description text
			desc =
			{
				"Autorepair armor damage when charged",
				"• Stars charge faster",
				"• Levels increase repair rate",
				"• Autocharges over time",
			},
		},
		shield =
		{
         --shield recharge time
         rarity =
         {
            30, 25, 20, 15, 10,
         },
         --base shield hp based on current vehicle hp Min
         level	=
         {
            1.5, 1.75, 2.0, 2.25, 2.5, 3.0, 3.25, 3.5, 3.75, 4.0, 4.5, 4.25, 4.5, 4.75, 5.5,
         },
			--name
			name =
			{
				"Shield",
				"Shield",
				"Shield",
				"Shield",
				"Shield",
			},
			--description text
			desc =
			{
				"Absorbs limited damage when charged",
				"• Stars charge faster",
				"• Levels increase shield strength",
				"• Autocharges over time",
			},
		},
		boost =
		{
			--boost length
			rarity =
			{
				3.0, 3.25, 3.5, 3.75, 4.0,
			},
			--charge threshold
			level	=
			{
				29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15,
			},
			--name
			name =
			{
				"Boost",
				"Boost",
				"Boost",
				"Boost",
				"Boost",
			},
			--description text
			desc =
			{
				"Auto boosts your car when charged",
				"• Stars increase duration",
				"• Levels charge faster",
				"• Kill enemies in game to charge",
			},
		},
      barricade =
      {
			--damage divisor based on car main weapon max dmg
			rarity =
			{
				3.6*DMG_DIV, 3.1*DMG_DIV, 2.6*DMG_DIV, 2.1*DMG_DIV, 1.5*DMG_DIV,
			},
			--subtractive damage divisor mod
			level	=
			{
				0.03*DMG_DIV, 0.06*DMG_DIV, 0.1*DMG_DIV, 0.13*DMG_DIV, 0.16*DMG_DIV, 0.20*DMG_DIV, 0.23*DMG_DIV, 0.26*DMG_DIV, 0.30*DMG_DIV, 0.33*DMG_DIV, 0.36*DMG_DIV, 0.40*DMG_DIV, 0.43*DMG_DIV, 0.46*DMG_DIV, 0.50*DMG_DIV,
			},
         --name
         name =
         {
            "Barricade",
            "Barricade",
            "Barricade",
            "Barricade",
            "Barricade",
         },
         --description text
         desc =
         {
            "Destroy barricdes",
            "• Stars increase blast size",
            "• Levels charge faster",
            "• Autocharges over time",
         },
      },
	},
};

return drone_default_tbls;
