require("app/template/template");
require("app/template/explosions/vehicle_explosion");
require("game/entity/drone/drone-gun");

local SIZE_WIDTH_K	= 1.0;
local SIZE_HEIGHT_K	= 1.0;
local SHDW_WIDTH_K	= 0.75;
local SHDW_HEIGHT_K	= 0.75;
local PROJ_WIDTH_K	= 0.75;
local PROJ_HEIGHT_K	= 0.75;
local PROJ_DMG_K		= 1.0;

local drone_gun_base =
{
	factory				= DroneGun,
	layer					= 5,
	priority				= 0,
	texture				= "resources/square.png", --data overwritten by DroneMgr on creation
	width					= 100*SIZE_WIDTH_K,
	height				= 100*SIZE_HEIGHT_K,
	splitProp			= true;
--	pivot					= { 0, 0 },
	collisionWidth		= 0,
	collisionHeight	= 0,
	offset				= { -128, 32 }, --default x offset to left mount point
	hitPoints         = 100, --data overwritten by DroneMgr on creation
	speedMin				= { 256,	142 }, --x,y pixels per sec
	speedMax				= { 960,	1138 }, --x,y pixels per sec
	shootDelay			= 0.0, --data overwritten by DroneMgr on creation
	bulletCount			= 6, --data overwritten by DroneMgr on creation
	bulletDelay			= 5/30,
	bulletDelta			= { { x=0, y=0} },
	explosion			= TEMPLATE_VEHICLE_EXPLOSION.small,
	respawnCDRange		= { 0, 0.25 },

	shadow				=
	 {
		 layer			= 3,
		 priority		= 100,
		 width			= 100*SHDW_WIDTH_K,
		 height			= 100*SHDW_HEIGHT_K,
		 avatarSpeedK	= 0,
		 texture			= "resources/Vehicle/Drones/DroneGun/DroneGun_Shadow.png",
		 offset			= {22,-42},
		 color			= {1,1,1,0.40},
	 },

	projectile			=
	{
		speed					= { 0, 1000 },
		width					= 64*PROJ_WIDTH_K,
		height				= 128*PROJ_HEIGHT_K,
		collisionWidth		= 15*PROJ_WIDTH_K,
		collisionHeight	= 70*PROJ_HEIGHT_K,
		damage				= PROJ_DMG_K, --data overwritten by DroneMgr on creation
		texture				= "resources/square.png", --data overwritten by DroneMgr on creation
	},
};

return drone_gun_base;
