require("app/template/template");
require("app/template/explosions/vehicle_explosion");
require("game/entity/drone/drone-magnet");
require("game/entity/powerup/powerup-magnet");

local SIZE_WIDTH_K	= 1.0;
local SIZE_HEIGHT_K	= 1.0;
local SHDW_WIDTH_K	= 0.75;
local SHDW_HEIGHT_K	= 0.75;

local drone_magnet_base =
{
	factory				= DroneMagnet,
	layer					= 5,
	priority				= 0,
	texture				= "resources/square.png", --data overwritten by DroneMgr on creation
	width					= 80*SIZE_WIDTH_K,
	height				= 80*SIZE_HEIGHT_K,
--	pivot					= { 0, 0 },
	collisionWidth		= 0,
	collisionHeight	= 0,
	offset				= { -128, 32 }, --default x offset to left mount point
	hitPoints         = 100, --data overwritten by DroneMgr on creation
	speedMin				= { 256,	142 }, --x,y pixels per sec
	speedMax				= { 960,	1138 }, --x,y pixels per sec
	explosion			= TEMPLATE_VEHICLE_EXPLOSION.small,
	respawnCDRange		= { 0, 0.25 },

	shadow				=
	 {
		 layer			= 3,
		 priority		= 100,
		 width			= 80*SHDW_WIDTH_K,
		 height			= 80*SHDW_HEIGHT_K,
		 avatarSpeedK	= 0,
		 texture			= "resources/Vehicle/Drones/DroneMagnet/DroneMagnet_Shadow.png",
		 offset			= {22,-42},
		 color			= {1,1,1,0.40},
	 },

	type					= "magnet",
	tplPowerup			=
	{
	   factory        = PowerupMagnet,
		layer          = 1,
		duration       = 50000000,
		texture        = "resources/Powerup/Effect_Magnet.png",
		radius			= 175, --data overwritten by DroneMgr on creation
		width				= 120, --data overwritten by DroneMgr on creation
		height			= 120, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 0.65 }, --data overwritten by DroneMgr on creation
		blend          = "add",
		spin           = 0,
		pulseTime		= 1, --data overwritten by DroneMgr on creation
	},
};

return drone_magnet_base;
