require("app/template/template");
require("app/template/explosions/vehicle_explosion");
require("game/entity/drone/drone-scoreMult");

local SIZE_WIDTH_K	= 1.0;
local SIZE_HEIGHT_K	= 1.0;
local SHDW_WIDTH_K	= 0.75;
local SHDW_HEIGHT_K	= 0.75;

local drone_scoreMult_base =
{
	factory				= DroneScoreMult,
	layer					= 5,
	priority				= 1,
	texture				= "resources/square.png", --data overwritten by DroneMgr on creation
	width					= 100*SIZE_WIDTH_K,
	height				= 100*SIZE_HEIGHT_K,
	splitProp			= true;
--	pivot					= { 0, 0 },
	collisionWidth		= 0,
	collisionHeight	= 0,
	offset				= { -128, 32 }, --default x offset to left mount point
	hitPoints         = 100, --data overwritten by DroneMgr on creation
	speedMin				= { 256,	142 }, --x,y pixels per sec
	speedMax				= { 960,	1138 }, --x,y pixels per sec
	explosion			= TEMPLATE_VEHICLE_EXPLOSION.small,
	respawnCDRange		= { 0, 0.25 },
	chargeThreshold	= 40, --data overwritten by DroneMgr on creation
	scoreK				= 0, --data overwritten by DroneMgr on creation
	duration				= 1, --data overwritten by DroneMgr on creation

	shadow				=
	 {
		 layer			= 3,
		 priority		= 100,
		 width			= 100*SHDW_WIDTH_K,
		 height			= 100*SHDW_HEIGHT_K,
		 avatarSpeedK	= 0,
		 texture			= "resources/Vehicle/Drones/DroneScoreMult/DroneScoreMult_Shadow.png",
		 offset			= {22,-42},
		 color			= {1,1,1,0.40},
	 },

	vfx					=
	{
		layer				= 5,
		priority			= 10,
		texture        =
		{
			"resources/Vehicle/Drones/DroneScoreMult/scorechevron1.png",
			"resources/Vehicle/Drones/DroneScoreMult/scorechevron2.png",
			"resources/Vehicle/Drones/DroneScoreMult/scorechevron3.png",
		},
		width          = 50*SIZE_WIDTH_K,
		height         = 100*SIZE_HEIGHT_K,
		scale				= { 1, 1 }, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 1 }, --data overwritten by DroneMgr on creation
		offset			=
		{
			{ -25*SIZE_WIDTH_K, 0*SIZE_HEIGHT_K },
			{ -25*SIZE_WIDTH_K, 0*SIZE_HEIGHT_K },
			{ -25*SIZE_WIDTH_K, 0*SIZE_HEIGHT_K },
		},
	},

	pip_on				=
	{
		layer				= 5,
		priority			= 10,
		texture        = "resources/UI/Drone_UI/dronepip_on.png",
		width          = 24*SIZE_WIDTH_K,
		height         = 24*SIZE_HEIGHT_K,
		scale				= { 1, 1 }, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 1 }, --data overwritten by DroneMgr on creation
		offset			=
		{
			{ -30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
			{ 0*SIZE_WIDTH_K,		-60*SIZE_HEIGHT_K },
			{ 30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
		},
	},

	pip_off				=
	{
		layer				= 5,
		priority			= 10,
		texture        = "resources/UI/Drone_UI/dronepip_off.png",
		width          = 24*SIZE_WIDTH_K,
		height         = 24*SIZE_HEIGHT_K,
		scale				= { 1, 1 }, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 1 }, --data overwritten by DroneMgr on creation
		offset			=
		{
			{ -30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
			{ 0*SIZE_WIDTH_K,		-60*SIZE_HEIGHT_K },
			{ 30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
		},
	},

	readyvfx				=
	{
		layer				= 5,
		priority			= 0,
		texture        = "resources/Powerup/Effect_ScoreMult.png", --data overwritten by DroneMgr on creation
		width          = 256*SIZE_WIDTH_K,
		height         = 256*SIZE_HEIGHT_K,
		color          = { 0, 1, 0, 0.25 }, --data overwritten by DroneMgr on creation
		spin           = 180,
		offset			= { 0*SIZE_WIDTH_K, 0*SIZE_HEIGHT_K },
		blend          = "add",
	},
};

return drone_scoreMult_base;
