require("app/template/template");
require("app/template/explosions/vehicle_explosion");
require("game/entity/drone/drone-shield");

local SIZE_WIDTH_K	= 1.0;
local SIZE_HEIGHT_K	= 1.0;
local SHDW_WIDTH_K	= 0.75;
local SHDW_HEIGHT_K	= 0.75;

local drone_shield_base =
{
	factory				= DroneShield,
	layer					= 5,
	priority				= 0,
	texture				= "resources/square.png", --data overwritten by DroneMgr on creation
	width					= 100*SIZE_WIDTH_K,
	height				= 100*SIZE_HEIGHT_K,
	splitProp			= true;
--	pivot					= { 0, 0 },
	collisionWidth		= 0,
	collisionHeight	= 0,
	offset				= { -128, 32 }, --default x offset to left mount point
	modOffset			= { 0, 128 },
	hitPoints         = 100, --data overwritten by DroneMgr on creation
	speedMin				= { 256,	142 }, --x,y pixels per sec
	speedMax				= { 960,	1138 }, --x,y pixels per sec
	explosion			= TEMPLATE_VEHICLE_EXPLOSION.small,
	respawnCDRange		= { 0, 0.25 },
	initTime				= 1,

	chargeThreshold	= 40, --data overwritten by DroneMgr on creation
	shieldHP				= 0, --data overwritten by DroneMgr on creation

	shadow				=
	 {
		 layer			= 3,
		 priority		= 100,
		 width			= 100*SHDW_WIDTH_K,
		 height			= 100*SHDW_HEIGHT_K,
		 avatarSpeedK	= 0,
		 texture			= "resources/Vehicle/Drones/DroneShield/DroneShield_Shadow.png",
		 offset			= {22,-42},
		 color			= {1,1,1,0.40},
	 },

	readyvfx				=
	{
		layer				= 4,
		priority			= 10,
		texture        = "resources/Powerup/Effect_Shield_Yellow.png", --data overwritten by DroneMgr on creation,
		width          = 512*SIZE_WIDTH_K,
		height         = 512*SIZE_HEIGHT_K,
		scale				= { 1, 1 }, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 1 },
		offset			= { 0*SIZE_WIDTH_K, 0*SIZE_HEIGHT_K },
		blend          = "add",
	},
	
	pip_on				=
	{
		layer				= 5,
		priority			= 10,
		texture        = "resources/UI/Drone_UI/dronepip_on.png",
		width          = 24*SIZE_WIDTH_K,
		height         = 24*SIZE_HEIGHT_K,
		scale				= { 1, 1 }, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 1 }, --data overwritten by DroneMgr on creation
		offset			=
		{
			{ -30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
			{ 0*SIZE_WIDTH_K,		-60*SIZE_HEIGHT_K },
			{ 30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
		},
	},

	pip_off				=
	{
		layer				= 5,
		priority			= 10,
		texture        = "resources/UI/Drone_UI/dronepip_off.png",
		width          = 24*SIZE_WIDTH_K,
		height         = 24*SIZE_HEIGHT_K,
		scale				= { 1, 1 }, --data overwritten by DroneMgr on creation
		color          = { 1, 1, 1, 1 }, --data overwritten by DroneMgr on creation
		offset			=
		{
			{ -30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
			{ 0*SIZE_WIDTH_K,		-60*SIZE_HEIGHT_K },
			{ 30*SIZE_WIDTH_K,	-60*SIZE_HEIGHT_K },
		},
	},
	
	hitMarker			=
	{
		texture        = "resources/square.png", --data overwritten by DroneMgr on creation,
		width          = 32,
		height         = 32,
		growth         = { 30, 30 };
		duration       = 0.5,
		fadeStart		= 0.2,
		spin           = 360,
		avatarSpeedK   = 0.00,
		--blend          = "add",
	},
};

return drone_shield_base;
