require('game/entity/vehicle/vehicle-chopper')
require('app/template/explosions/vehicle_explosion')


TEMPLATE_DAILY_CHOPPER =
{
   factory              = VehicleChopper,
   layer                = 10,
   type                 = "daily_chopper",
   speed                =  { 0 , 000      },
   speedRnd             =  { 0 , 000      },
   avatarSpeedK         =  0.0,
   avatarSpeedKRnd      =  0.0,
   texture              = "resources/Vehicle/Chopper_Enemy/Daily_Chopper.png",
	splitProp				= true;
   width                = 128,
   height               = 359,
   collisionWidth       = 250,
   collisionHeight      = 250,
   collideWithAvatar    = false,
   collideWithVehicle   = false,
   dropIndex            = { PICKUP_DAILY_INDEX },
   drop                 = { 1, 1 },
   mass                 = 3000,
   score                =  10,
   hitPoints            = 100,
   explosion            = TEMPLATE_VEHICLE_EXPLOSION.medium,
   blade                =
   {
      layer          = 10,
      texture        = "resources/Vehicle/Chopper_Enemy/Daily_Chopper_Prop.png",
      delta          = { 0, 50 },
      spin           = 1200,
      width          = 385,
      height         = 385,
   },
   shadowBlade         =
   {
      layer          = 9,
      width          = 385*1.2,
      height         = 385*1.2,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Chopper_Enemy/Daily_Chopper_Prop_Shadow.png",
      delta          = { 0, 50 },
      color          = {1,1,1,0.35},
   },
   shadow         =
   {
      layer          = 9,
      width          = 128*1.2,
      height         = 377*1.2,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Chopper_Enemy/Daily_Chopper_Shadow.png",
      offset         = {150,-150},
      color          = {1,1,1,0.35},
		noParent			= true;
   },
   healthBar      =
   {
      template    =
      {
         layer          = 10,
         texture        = "resources/square.png",
         width          = 100,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.75 },
         colorHalf      = { 1, 1, 0, 0.75 },
         colorEmpty     = { 1, 0, 0, 0.75 },
      },
      offset      = { 0, -135 },
   },
};