require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")
 
local SIZE_WIDTH_K	= 1.0;
local SIZE_HEIGHT_K	= 1.0;

TEMPLATE_ENEMY_MUSCLE_A =
{
   type              = "muscle_a",
   layer             = 3,
   useLevelSpeed     = true,
   --speed is needed only for tutrorial
   speed             = {   0 ,   1000     },
   speedMax          = { 300 ,   -125     },
   speedMaxRnd       = {   0 ,    025     },
   avatarSpeedK      =  1.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/Muscle_Enemy/Orange_MuscleCar_FullArmor.png",
	splitProp			= true;
   width             = 128*SIZE_WIDTH_K,
   height            = 256*SIZE_HEIGHT_K,
   collisionWidth    = 90*SIZE_WIDTH_K,
   collisionHeight   = 210*SIZE_HEIGHT_K,
   mass              = 150*1000,
   score             = TEMPLATE_BASE_SCORE["Muscle"]["A"],
   hitPoints         = TEMPLATE_BASE_HP["Muscle"]["A"],
   avatarHitDamage   = { 0.25, 0.50, 0.75, 1.0 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_1"]["A"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.00,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.small,
   shadow         =
   {
      layer          = 1,
      width          = 128,
      height         = 256,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Muscle_Enemy/MuscleCar_Shadow.png",
      offset         = {15,-15},
      color          = {1,1,1,0.60},
   },
   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -127*SIZE_HEIGHT_K },
   },
};