require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")

local SIZE_WIDTH_K	= 1.0;
local SIZE_HEIGHT_K	= 1.0;

TEMPLATE_ENEMY_BUS_A =
{
   type              = "bus_a",
   layer             = 3,
   useLevelSpeed     = true,
   speedMax          = { 300 ,   -125     },
   speedMaxRnd       = {   0 ,    025     },
   avatarSpeedK      =  1.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/Bus_Enemy/Bus_LightBlue_FullArmor.png",
	splitProp			= true;
   width             = 128*SIZE_WIDTH_K,
   height            = 368*SIZE_HEIGHT_K,
   collisionWidth    = 94*SIZE_WIDTH_K,
   collisionHeight   = 360*SIZE_HEIGHT_K,
   mass              = 1000*1000,
   score             = TEMPLATE_BASE_SCORE["Bus"]["A"],
   hitPoints         = TEMPLATE_BASE_HP["Bus"]["A"],
   avatarHitDamage   = { 1/12, 2/12, 3/12, 4/12, 5/12, 6/12, 7/12, 8/12, 9./12, 10/12, 11/12, 12/12 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_1"]["A"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.00,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.bus,
   shadow         =
   {
      layer          = 1,
      width          = 128,
      height         = 368,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Bus_Enemy/Bus_Shadow.png",
      offset         = {19,-19},
      color          = {1,1,1,0.5},
   },
   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -195*SIZE_HEIGHT_K },
   },
};