require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")

local SIZE_WIDTH_K	= 1.05;
local SIZE_HEIGHT_K	= 1.05;

TEMPLATE_ENEMY_MUSCLE_B =
{
   type           = "muscle_b",
   layer             = 3,
   useLevelSpeed     = true,
   speedMax          = { 300 ,   -125     },
   speedMaxRnd       = {   0 ,    025     },
   avatarSpeedK      =  1.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/Muscle_Enemy/Red_MuscleCar_FullArmor.png",
	splitProp			= true;
   width             = 128*SIZE_WIDTH_K,
   height            = 256*SIZE_HEIGHT_K,
   collisionWidth    = 90*SIZE_WIDTH_K,
   collisionHeight   = 210*SIZE_HEIGHT_K,
   mass              = 300*1000,
   score             = TEMPLATE_BASE_SCORE["Muscle"]["B"],
   hitPoints         = TEMPLATE_BASE_HP["Muscle"]["B"],
   avatarHitDamage   = { 1/16, 2/16, 3/16, 4/16, 5/16, 6/16, 7/16, 8/16, 9./16, 10/16, 11/16, 12/16, 13/16, 14/16, 15/16 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_1"]["B"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.00,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound= {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.small,
   shadow         =
   {
      layer          = 1,
      width          = 128*1.05,
      height         = 256*1.05,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Muscle_Enemy/MuscleCar_Shadow.png",
      offset         = {16,-16},
      color          = {1,1,1,0.5},
   },
   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -127*SIZE_HEIGHT_K },
   },
};