require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")

local SIZE_WIDTH_K	= 1.1;
local SIZE_HEIGHT_K	= 1.1;

TEMPLATE_ENEMY_FULLSIZE_C =
{
   type              = "fullsize_c",
   layer             = 3,
   useLevelSpeed     = true,
   speedMax          = { 300 ,   -125     },
   speedMaxRnd       = {   0 ,    025     },
   avatarSpeedK      =  1.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/Fullsize_Enemy/Fullsize_Purle_FullArmor.png",
	splitProp			= true;
	width             = 128*SIZE_WIDTH_K,
   height            = 256*SIZE_HEIGHT_K,
   collisionWidth    = 96*SIZE_WIDTH_K,
   collisionHeight   = 240*SIZE_HEIGHT_K,
   mass              = 450*1000,
   score             = TEMPLATE_BASE_SCORE["Fullsize"]["C"],
   hitPoints         = TEMPLATE_BASE_HP["Fullsize"]["C"],
   avatarHitDamage   = { 1/20,2/20,3/20,4/20,5/20,6/20,7/20,8/20,9/20,10/20,11/20,12/20,13/20,14/20,15/20 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_2"]["C"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.15,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.small,
   shadow         =
   {
      layer          = 1,
      width          = 128*1.1,
      height         = 256*1.1,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Fullsize_Enemy/Fullsize_Shadow.png",
      offset         = {17,-17},
      color          = {1,1,1,0.5},
   },
   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -137*SIZE_HEIGHT_K },
   },
};