require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")

local SIZE_WIDTH_K	= 1.1;
local SIZE_HEIGHT_K	= 1.1;

TEMPLATE_ENEMY_TOWTRUCK_C =
{
   type             	= "towtruck_c",
   layer             = 3,
   useLevelSpeed     = true,
   speedMax          = { 300 ,   -125     },
   speedMaxRnd       = {   0 ,    025     },
   avatarSpeedK      =  1.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/TowTruck_Enemy/TowTruck_Red_FullArmor.png",
	splitProp			= true;
   width             = 128*SIZE_WIDTH_K,
   height            = 368*SIZE_HEIGHT_K,
   collisionWidth    = 94*SIZE_WIDTH_K,
   collisionHeight   = 360*SIZE_HEIGHT_K,
   mass              = 3000*1000,
   score             = TEMPLATE_BASE_SCORE["TowTruck"]["C"],
   hitPoints         = TEMPLATE_BASE_HP["TowTruck"]["C"],
   avatarHitDamage   = { 1/24,2/24,3/24,4/24,5/24,6/24,7/24,8/24,9/24,10/24,11/24,12/24,13/24,14/24,15/24 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_2"]["C"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.16,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.bus,
   shadow         =
   {
      layer          = 1,
      width          = 128*1.1,
      height         = 368*1.1,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/TowTruck_Enemy/TowTruck_Shadow.png",
      offset         = {25,-25},
      color          = {1,1,1,0.5},
   },

   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -195*SIZE_HEIGHT_K, },
   },
};