require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")

local SIZE_WIDTH_K	= 1.00;
local SIZE_HEIGHT_K	= 1.00;

TEMPLATE_ENEMY_WAGON_V2_B =
{
   type              = "wagon_b",
   layer             = 3,
   useLevelSpeed     = true,
   speedMax          = { 300 ,   -125     },
   speedMaxRnd       = {   0 ,    025     },
   avatarSpeedK      =  1.0,
   avatarSpeedKRnd   =  0.0,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/Wagon_Enemy_V2/LightBlue_Wagon_Armor2.png",
	splitProp			= true;
   width             = 122*SIZE_WIDTH_K,
   height            = 256*SIZE_HEIGHT_K,
   collisionWidth    = 96*SIZE_WIDTH_K,
   collisionHeight   = 240*SIZE_HEIGHT_K,
   mass              = 300*1000,
   score             = TEMPLATE_BASE_SCORE["Wagon_V2"]["B"],
   hitPoints         = TEMPLATE_BASE_HP["Wagon_V2"]["B"],
   avatarHitDamage   = { 1/20,2/20,3/20,4/20,5/20,6/20,7/20,8/20,9/20,10/20,11/20,12/20,13/20,14/20,15/20 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_4"]["B"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.00,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.small,
   shadow         =
   {
      layer          = 1,
      width          = 128*1.05,
      height         = 256*1.05,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Wagon_Enemy_V2/Wagon_Shadow_V2.png",
      offset         = {16,-16},
      color          = {1,1,1,0.5},
   },
   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -136*SIZE_HEIGHT_K },
   },
};