require('app/template/explosions/vehicle_explosion')
require("app/template/enemy-vehicles/stats_template")

local SIZE_WIDTH_K	= 1.00;
local SIZE_HEIGHT_K	= 1.00;
local PROJ_SIZE_K    = 1.20;

TEMPLATE_PICKUP_SHOOTER_V2_C =
{
   type              = "pickup_c",
   layer             = 3,
   useAvatarStartSpeed        = true,
   useAvatarStartSpeedDelta   = -400,
   -- We want to to start fast than slow down to avoid being too easy to shoot down before it can shoot
   --speed             = { 0,      0                 },
   accel             = { 0,      4*100             },
   speedMin          = { -999,   -600              },
   speedMax          = {  300 ,  -150              },
   speedMaxRnd       = {   0 ,    025              },
   avatarSpeedK      =  0.75,
   avatarSpeedKRnd   =  0.00,
   avatarImpulseMinY =  200,
   avatarImpulseMaxY =  300,
   texture           = "resources/Vehicle/Pickup_Enemy_V2/Red_PickupTruck_Armor3.png",
	splitProp			= true;
   width             = 122*SIZE_WIDTH_K,
   height            = 258*SIZE_HEIGHT_K,
   collisionWidth    = 96*SIZE_WIDTH_K,
   collisionHeight   = 234*SIZE_HEIGHT_K,
   mass              = 450*1000,
   score             = TEMPLATE_BASE_SCORE["Pickup_V2"]["C"],
   hitPoints         = TEMPLATE_BASE_HP["Pickup_V2"]["C"],
   avatarHitDamage   = { 1/12, 2/12, 3/12, 4/12, 5/12, 6/12, 7/12, 8/12, 9./12, 10/12, 11/12, 12/12 },
   damageToAvatar    = TEMPLATE_BASE_RAM_DMG["Group_4"]["A"],
   drop              = { 1, 1 },
   specialDrop       = { 1, 1 },
   specialDropOdds   = 0.05,
   specialDropIndex  = { PICKUP_COIN_10_INDEX },
   damageTypeSound   = {
                     {start={
                              "AutoSkid1",},
                              },
                     {start={
                              "HTTCollision1",},
                              },
                     {},};
   explosion      = TEMPLATE_VEHICLE_EXPLOSION.medium,
   shadow         =
   {
      layer          = 1,
      width          = 128*1.10,
      height         = 256*1.10,
      avatarSpeedK   = 0,
      texture        = "resources/Vehicle/Pickup_Enemy_V2/PickupTruck_ShadowV2.png",
      offset         = {17,-17},
      color          = {1,1,1,0.5},
   },
   healthBar      =
   {
      template    =
      {
         layer          = 2,
         texture        = "resources/square.png",
         width          = 72,
         height         = 12 ,
         colorFull      = { 0, 1, 0, 0.35 },
         colorHalf      = { 1, 1, 0, 0.35 },
         colorEmpty     = { 1, 0, 0, 0.35 },
      },
      offset      = { 0, -140*SIZE_HEIGHT_K },
   },
   turret  =
   {
      template    =
      {
         layer          = 4,
         texture        = "resources/Vehicle/Vehicle05_APCTurret.png",
         width          = 70*1.10,
         height         = 140*1.10,
         collisionWidth = 0,
         collisionHeight= 0,
         shootAngleMax  = 5,
         angleLimit     = { min=120, max=240 },
         maxTurnRate    = 720,
         faceAndShoot   = false,
         shootDelay     = 1.50,
         shootPosMax    = 350,
         bulletCount    = 5,
         bulletDelay    = 0.1,
         projectile =
         {
            speed            = { 0, 1000 },
            width            = PROJ_SIZE_K*64,
            height           = PROJ_SIZE_K*128,
            collisionWidth   = 35,
            collisionHeight  = 75,
            damageAvatar     = TEMPLATE_BASE_SHOT_DMG["Group_4"]["C"],
            texture          = 'resources/Vehicle/BulletEffects/Bullet_Level33.png',
         }
      },
      offset      = { 0, -60*1.10 },
   }
};