require('app/template/enemy-vehicles/spawn_lists')
require('app/template/template')

----------------------------------------------------------------------

local GAME_DIR_VAR_01	= 
{
--	Lvl 0 - 5
	{
		GAME_SPEED_START				=	{	0.70,			0.70		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	0,				0			},
		
		VEHICLE_CHART_CATCHUP		=	{	1.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.50,			0.50		},
		VEHICLE_CHART_TARGET			=	{ 50.00,       400.00	},
		VEHICLE_CHART_MAX				=	{999.00,       999.00	},
		
		SCENARIO_CHART					=	{	0.75,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	30,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	15,			10			},
		SCENARIO_INTERVAL_MAX		=	{	20,			15			},
	},

--	Lvl 6 - 10
	{
		GAME_SPEED_START				=	{	0.72,			0.72		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -05,        -05			},
		
		VEHICLE_CHART_CATCHUP		=	{	1.10,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.55,			0.55		},
		VEHICLE_CHART_TARGET			=	{   60.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	0.80,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	31,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	15,			10			},
		SCENARIO_INTERVAL_MAX		=	{	20,			15			},
	},

--	Lvl 11 - 15
	{
		GAME_SPEED_START				=	{	0.74,			0.74		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -10,		   -10		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.20,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.60,			0.60		},
		VEHICLE_CHART_TARGET			=	{   70.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	0.85,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	32,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	14,			10			},
		SCENARIO_INTERVAL_MAX		=	{	19,			15			},
	},

--	Lvl 16 - 20
	{
		GAME_SPEED_START				=	{	0.76,			0.76		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-15,			-15		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.30,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.65,			0.65		},
		VEHICLE_CHART_TARGET			=	{   80.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	0.90,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	33,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	14,			10			},
		SCENARIO_INTERVAL_MAX		=	{	19,			15			},
	},

--	Lvl 21 - 25
	{
		GAME_SPEED_START				=	{	0.78,			0.78		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -20,			-20		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.40,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.70,			0.70		},
		VEHICLE_CHART_TARGET			=	{   90.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	0.95,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	34,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	13,			10			},
		SCENARIO_INTERVAL_MAX		=	{	18,			15			},
	},

--	Lvl 26 - 30
	{
		GAME_SPEED_START				=	{	0.80,			0.80		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -25,		   -25		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.50,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.75,			0.75		},
		VEHICLE_CHART_TARGET			=	{  100.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.00,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	35,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	13,			10			},
		SCENARIO_INTERVAL_MAX		=	{	18,			15			},
	},

--	Lvl 31 - 35
	{
		GAME_SPEED_START				=	{	0.82,			0.82		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -30,			-30		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.60,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.80,			0.80		},
		VEHICLE_CHART_TARGET			=	{  110.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.05,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	36,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	12,			10			},
		SCENARIO_INTERVAL_MAX		=	{	17,			15			},
	},

--	Lvl 36 - 40
	{
		GAME_SPEED_START				=	{	0.84,			0.84		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -35,			-35		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.70,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.85,			0.85		},
		VEHICLE_CHART_TARGET			=	{  120.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.10,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	37,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	12,			10			},
		SCENARIO_INTERVAL_MAX		=	{	17,			15			},
	},

--	Lvl 41 - 45
	{
		GAME_SPEED_START				=	{	0.86,			0.86		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{ -40,			-40		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.80,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.90,			0.90		},
		VEHICLE_CHART_TARGET			=	{  130.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.15,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	38,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	11,			10			},
		SCENARIO_INTERVAL_MAX		=	{	16,			15			},
	},

--	Lvl 46 - 50
	{
		GAME_SPEED_START				=	{	0.88,			0.88		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-45,			-45		},
		
		VEHICLE_CHART_CATCHUP		=	{	1.90,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	0.95,			0.95		},
		VEHICLE_CHART_TARGET			=	{  140.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.20,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	39,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	11,			10			},
		SCENARIO_INTERVAL_MAX		=	{	16,			15			},
	},

--	Lvl 51 - 55
	{
		GAME_SPEED_START				=	{	0.90,			0.90		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-50,		   -50		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  150.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.25,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	40,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
		SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
		SCENARIO_INTERVAL_MIN		=	{	10,			10			},
		SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 56 - 60
	{
		GAME_SPEED_START				=	{	0.92,			0.92		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-55,			-55		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  160.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.30,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	41,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 61 - 65
	{
		GAME_SPEED_START				=	{	0.94,			0.94		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-60,			-60		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  170.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.35,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	42,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 66 - 70
	{
		GAME_SPEED_START				=	{	0.96,			0.96		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-65,			-65      },
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  180.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.40,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	43,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 71 - 75
	{
		GAME_SPEED_START				=	{	0.98,			0.98		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-70,			-70			},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  190.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.45,			3.00		},
		
      MIN_DAILY_INTERVAL			=	{	44,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 76 - 80
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-75,			-75      },
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.50,			3.00		},
		
		MIN_DAILY_INTERVAL			=	{	45,			45			},
		MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 81 - 85
	{
		GAME_SPEED_START				=	{	1.00,			1.00     },
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-80,			-80      },
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.55,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 86 - 90
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-85,			-85     },
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.60,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 91 - 95
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-90,			-90     },
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.65,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 96 - 100
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-95,			-95     },
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.70,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 101 - 105
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.75,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 106 - 110
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.80,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 111 - 115
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.85,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 116 - 120
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.90,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 121 - 125
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	1.95,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 126 - 130
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
		
		SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 131 - 135
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 136 - 140
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 141 - 145
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 146 - 150
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 151 - 155
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 156 - 160
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 161 - 165
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 166 - 170
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 171 - 175
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 176 - 180
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 181 - 185
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 186 - 190
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},

--	Lvl 191 - 195
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
      VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
      VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
	
--	Lvl 196 - 200
	{
		GAME_SPEED_START				=	{	1.00,			1.00		},
		GAME_SPEED_ACCEL				=	{	1/75,			1/75		},
		GAME_SPEED_MAX					=	{	5.00,			5.00		},
		
		VEHICLE_SPEED_DROP			=	{	-100,			-100		},
		
		VEHICLE_CHART_CATCHUP		=	{	2.00,		   6.00		},
		VEHICLE_CHART_SLOW			=	{	1.00,			1.00		},
		VEHICLE_CHART_TARGET			=	{  200.00,		400.00	},
		VEHICLE_CHART_MAX				=	{	999.00,     999.00	},
      
      SCENARIO_CHART					=	{	2.00,			3.00		},
      
      MIN_DAILY_INTERVAL			=	{	45,			45			},
      MIN_BOSS_INTERVAL				=	{	999,			999		},
		
      SCENARIO_HAZARD_TIMER_MIN	=	{	05,			01			},
      SCENARIO_INTERVAL_MIN		=	{	10,			10			},
      SCENARIO_INTERVAL_MAX		=	{	15,			15			},
	},
};

local GAME_DIR_VAR_02		= Template.extent(GAME_DIR_VAR_01);
local GAME_DIR_VAR_03		= Template.extent(GAME_DIR_VAR_02);
local GAME_DIR_VAR_04		= Template.extent(GAME_DIR_VAR_03);
local GAME_DIR_VAR_05		= Template.extent(GAME_DIR_VAR_04);
local GAME_DIR_VAR_06		= Template.extent(GAME_DIR_VAR_05);
local GAME_DIR_VAR_07		= Template.extent(GAME_DIR_VAR_06);
local GAME_DIR_VAR_08		= Template.extent(GAME_DIR_VAR_07);
local GAME_DIR_VAR_09		= Template.extent(GAME_DIR_VAR_08);
local GAME_DIR_VAR_10		= Template.extent(GAME_DIR_VAR_09);

----------------------------------------------------------------------

TEMPLATE_GAME_DIRECTOR_SETTINGS	=
{
	GAME_DIR_VAR_01,
	GAME_DIR_VAR_02,
	GAME_DIR_VAR_03,
	GAME_DIR_VAR_04,
	GAME_DIR_VAR_05,
	GAME_DIR_VAR_06,
	GAME_DIR_VAR_07,
	GAME_DIR_VAR_08,
	GAME_DIR_VAR_09,
	GAME_DIR_VAR_10,
};

----------------------------------------------------------------------
----------------------------------------------------------------------

local DISTANCE_SCORE_01 =
{
--	Lvl 0 - 5
	{
		GAME_DISTANCE_SCORE			=	{	0.015,		0.045		},
	},

--	Lvl 6 - 10
	{
		GAME_DISTANCE_SCORE			=	{	0.016,		0.048		},
	},

--	Lvl 11 - 15
	{
		GAME_DISTANCE_SCORE			=	{	0.017,		0.051		},
	},

--	Lvl 16 - 20
	{
		GAME_DISTANCE_SCORE			=	{	0.018,		0.054		},
	},

--	Lvl 21 - 25
	{
		GAME_DISTANCE_SCORE			=	{	0.019,		0.057		},
	},

--	Lvl 26 - 30
	{
		GAME_DISTANCE_SCORE			=	{	0.020,		0.060		},
	},

--	Lvl 31 - 35
	{
		GAME_DISTANCE_SCORE			=	{	0.021,		0.063		},
	},

--	Lvl 36 - 40
	{
		GAME_DISTANCE_SCORE			=	{	0.022,		0.066		},
	},

--	Lvl 41 - 45
	{
		GAME_DISTANCE_SCORE			=	{	0.023,		0.069		},
	},

--	Lvl 46 - 50
	{
		GAME_DISTANCE_SCORE			=	{	0.024,		0.072		},
	},

--	Lvl 51 - 55
	{
		GAME_DISTANCE_SCORE			=	{	0.025,		0.075		},
	},

--	Lvl 56 - 60
	{
		GAME_DISTANCE_SCORE			=	{	0.026,		0.078		},
	},

--	Lvl 61 - 65
	{
		GAME_DISTANCE_SCORE			=	{	0.027,		0.081		},
	},
	
--	Lvl 66 - 70
	{
		GAME_DISTANCE_SCORE			=	{	0.028,		0.084		},
	},

--	Lvl 71 - 75
	{
		GAME_DISTANCE_SCORE			=	{	0.029,		0.087		},
	},

--	Lvl 76 - 80
	{
		GAME_DISTANCE_SCORE			=	{	0.030,		0.090		},
	},

--	Lvl 81 - 85
	{
		GAME_DISTANCE_SCORE			=	{	0.031,		0.093 	},
	},

--	Lvl 86 - 90
	{
		GAME_DISTANCE_SCORE			=	{	0.032,		0.096		},
	},
	
--	Lvl 91 - 95
	{
		GAME_DISTANCE_SCORE			=	{	0.033,		0.099		},
	},
	
--	Lvl 96 - 100
	{
		GAME_DISTANCE_SCORE			=	{	0.034,		0.102		},
	},

--	Lvl 101 - 105
   {
      GAME_DISTANCE_SCORE			=	{	0.035,		0.105		},
	},
	
--	Lvl 106 - 110
   {
      GAME_DISTANCE_SCORE			=	{	0.036,		0.108		},
	},
	
--	Lvl 111 - 115
	{
		GAME_DISTANCE_SCORE			=	{	0.037,		0.111		},
	},

--	Lvl 116 - 120
	{
		GAME_DISTANCE_SCORE			=	{	0.038,		0.114		},
	},
	
--	Lvl 121 - 125
	{
		GAME_DISTANCE_SCORE			=	{	0.039,		0.117		},
	},

--	Lvl 126 - 130
	{
		GAME_DISTANCE_SCORE			=	{	0.040,		0.120		},
	},
	
--	Lvl 131 - 135
	{
		GAME_DISTANCE_SCORE			=	{	0.041,		0.123		},
	},
	
--	Lvl 136 - 140
	{
		GAME_DISTANCE_SCORE			=	{	0.042,		0.126		},
	},

--	Lvl 141 - 145
	{
		GAME_DISTANCE_SCORE			=	{	0.043,		0.129		},
	},
	
--	Lvl 146 - 150
	{
		GAME_DISTANCE_SCORE			=	{	0.044,		0.132		},
	},

--	Lvl 151 - 155
	{
		GAME_DISTANCE_SCORE			=	{	0.045,		0.135		},
	},
	
--	Lvl 156 - 160
	{
		GAME_DISTANCE_SCORE			=	{	0.046,		0.138		},
	},
	
--	Lvl 161 - 165
	{
		GAME_DISTANCE_SCORE			=	{	0.047,		0.141		},
	},

--	Lvl 166 - 170
	{
		GAME_DISTANCE_SCORE			=	{	0.048,		0.144		},
	},
	
--	Lvl 171 - 175
	{
		GAME_DISTANCE_SCORE			=	{	0.049,		0.147		},
	},

--	Lvl 176 - 180
	{
		GAME_DISTANCE_SCORE			=	{	0.050,		0.150		},
	},
	
--	Lvl 181 - 185
	{
		GAME_DISTANCE_SCORE			=	{	0.051,		0.153		},
	},
	
--	Lvl 186 - 190
	{
		GAME_DISTANCE_SCORE			=	{	0.052,		0.156		},
	},

--	Lvl 191 - 195
	{
		GAME_DISTANCE_SCORE			=	{	0.053,		0.159		},
	},
	
--	Lvl 196 - 200
	{
		GAME_DISTANCE_SCORE			=	{	0.054,		0.162		},
	},
};

local DISTANCE_SCORE_02		= {};
local DISTANCE_SCORE_03		= {};
local DISTANCE_SCORE_04		= {};
local DISTANCE_SCORE_05		= {};
local DISTANCE_SCORE_06		= {};
local DISTANCE_SCORE_07		= {};
local DISTANCE_SCORE_08		= {};
local DISTANCE_SCORE_09		= {};
local DISTANCE_SCORE_10		= {};

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_01 do
   DISTANCE_SCORE_02[i]                            = {};
   DISTANCE_SCORE_02[i]["GAME_DISTANCE_SCORE"]     = {};
	DISTANCE_SCORE_02[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_01[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
	DISTANCE_SCORE_02[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_01[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_02 do
   DISTANCE_SCORE_03[i]                            = {};
   DISTANCE_SCORE_03[i]["GAME_DISTANCE_SCORE"]     = {};
	DISTANCE_SCORE_03[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_02[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
	DISTANCE_SCORE_03[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_02[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_03 do
   DISTANCE_SCORE_04[i]                            = {};
   DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_03[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_03[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_04 do
   DISTANCE_SCORE_05[i]                            = {};
   DISTANCE_SCORE_05[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_05[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_05[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_05 do
   DISTANCE_SCORE_06[i]                            = {};
   DISTANCE_SCORE_06[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_06[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_06[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_06 do
   DISTANCE_SCORE_07[i]                            = {};
   DISTANCE_SCORE_07[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_07[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_07[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_07 do
   DISTANCE_SCORE_08[i]                            = {};
   DISTANCE_SCORE_08[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_08[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_08[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_08 do
   DISTANCE_SCORE_09[i]                            = {};
   DISTANCE_SCORE_09[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_09[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_09[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

for i=1,#DISTANCE_SCORE_09 do
   DISTANCE_SCORE_10[i]                            = {};
   DISTANCE_SCORE_10[i]["GAME_DISTANCE_SCORE"]     = {};
   DISTANCE_SCORE_10[i]["GAME_DISTANCE_SCORE"][1]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][1] * 1.25;
   DISTANCE_SCORE_10[i]["GAME_DISTANCE_SCORE"][2]  = DISTANCE_SCORE_04[i]["GAME_DISTANCE_SCORE"][2] * 1.25;
end

----------------------------------------------------------------------

TEMPLATE_DISTANCE_SCORE =
{
	DISTANCE_SCORE_01,
	DISTANCE_SCORE_02,
	DISTANCE_SCORE_03,
	DISTANCE_SCORE_04,
	DISTANCE_SCORE_05,
	DISTANCE_SCORE_06,
	DISTANCE_SCORE_07,
	DISTANCE_SCORE_08,
	DISTANCE_SCORE_09,
	DISTANCE_SCORE_10,
};

----------------------------------------------------------------------
----------------------------------------------------------------------


local TEMPLATE_SPAWN_LIST_01		= {};
local TEMPLATE_SPAWN_LIST_02		= {};
local TEMPLATE_SPAWN_LIST_03		= {};
local TEMPLATE_SPAWN_LIST_04		= {};
local TEMPLATE_SPAWN_LIST_05		= {};
local TEMPLATE_SPAWN_LIST_06		= {};
local TEMPLATE_SPAWN_LIST_07		= {};
local TEMPLATE_SPAWN_LIST_08		= {};
local TEMPLATE_SPAWN_LIST_09		= {};
local TEMPLATE_SPAWN_LIST_10		= {};

----------------------------------------------------------------------

TEMPLATE_SPAWN_LIST_01[1]	= { MAP01_VEHC_TMPLT01 };
TEMPLATE_SPAWN_LIST_01[2]	= { MAP01_VEHC_TMPLT02 };
TEMPLATE_SPAWN_LIST_01[3]	= { MAP01_VEHC_TMPLT02 };
TEMPLATE_SPAWN_LIST_01[4]	= { MAP01_VEHC_TMPLT03 };
TEMPLATE_SPAWN_LIST_01[5]	= { MAP01_VEHC_TMPLT03 };
TEMPLATE_SPAWN_LIST_01[6]	= { MAP01_VEHC_TMPLT03 };
TEMPLATE_SPAWN_LIST_01[7]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_01[8]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_01[9]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_01[10]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_01[11]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_01[12]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_01[13]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_01[14]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_01[15]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_01[16]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_01[17]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_01[18]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_01[19]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_01[20]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_01[21]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_01[22]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[23]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[24]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[25]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[26]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[27]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[28]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[29]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[30]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[31]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[32]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[33]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[34]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[35]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[36]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[37]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[38]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[39]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_01[40]	= { MAP01_VEHC_TMPLT07 };

----------------------------------------------------------------------

TEMPLATE_SPAWN_LIST_02[1]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_02[2]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_02[3]	= { MAP01_VEHC_TMPLT04 };
TEMPLATE_SPAWN_LIST_02[4]	= { MAP01_VEHC_TMPLT04 };  --Unlocked here
TEMPLATE_SPAWN_LIST_02[5]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_02[6]	= { MAP01_VEHC_TMPLT05 };
TEMPLATE_SPAWN_LIST_02[7]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_02[8]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_02[9]	= { MAP01_VEHC_TMPLT06 };
TEMPLATE_SPAWN_LIST_02[10]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_02[11]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_02[12]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_02[13]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_02[14]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_02[15]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_02[16]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_02[17]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_02[18]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_02[19]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_02[20]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_02[21]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_02[22]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_02[23]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_02[24]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_02[25]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[26]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[27]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[28]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[29]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[30]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[31]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[32]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[33]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[34]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[35]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[36]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[37]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[38]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[39]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_02[40]	= { MAP01_VEHC_TMPLT10 };

----------------------------------------------------------------------

TEMPLATE_SPAWN_LIST_03[1]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_03[2]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_03[3]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_03[4]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_03[5]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_03[6]	= { MAP01_VEHC_TMPLT07 };
TEMPLATE_SPAWN_LIST_03[7]	= { MAP01_VEHC_TMPLT07 };  --Unlocked here
TEMPLATE_SPAWN_LIST_03[8]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_03[9]	= { MAP01_VEHC_TMPLT08 };
TEMPLATE_SPAWN_LIST_03[10]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_03[11]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_03[12]	= { MAP01_VEHC_TMPLT09 };
TEMPLATE_SPAWN_LIST_03[13]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_03[14]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_03[15]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_03[16]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_03[17]	= { MAP01_VEHC_TMPLT11 };
TEMPLATE_SPAWN_LIST_03[18]	= { MAP01_VEHC_TMPLT11 };
TEMPLATE_SPAWN_LIST_03[19]	= { MAP01_VEHC_TMPLT11 };
TEMPLATE_SPAWN_LIST_03[20]	= { MAP01_VEHC_TMPLT11 };
TEMPLATE_SPAWN_LIST_03[21]	= { MAP01_VEHC_TMPLT11 };
TEMPLATE_SPAWN_LIST_03[22]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_03[23]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_03[24]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_03[25]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_03[26]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_03[27]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_03[28]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[29]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[30]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[31]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[32]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[33]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[34]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[35]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[36]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[37]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[38]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[39]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_03[40]	= { MAP01_VEHC_TMPLT13 };

----------------------------------------------------------------------

TEMPLATE_SPAWN_LIST_04[1]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[2]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[3]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[4]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[5]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[6]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[7]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[8]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[9]	= { MAP01_VEHC_TMPLT10 };
TEMPLATE_SPAWN_LIST_04[10]	= { MAP01_VEHC_TMPLT10 };	--Unlocked here
TEMPLATE_SPAWN_LIST_04[11]	= { MAP01_VEHC_TMPLT11 };  
TEMPLATE_SPAWN_LIST_04[12]	= { MAP01_VEHC_TMPLT11 };
TEMPLATE_SPAWN_LIST_04[13]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_04[14]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_04[15]	= { MAP01_VEHC_TMPLT12 };
TEMPLATE_SPAWN_LIST_04[16]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_04[17]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_04[18]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_04[19]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_04[20]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_04[21]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_04[22]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_04[23]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_04[24]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_04[25]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_04[26]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_04[27]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_04[28]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_04[29]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_04[30]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_04[31]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[32]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[33]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[34]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[35]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[36]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[37]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[38]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[39]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_04[40]	= { MAP01_VEHC_TMPLT16 };

----------------------------------------------------------------------

TEMPLATE_SPAWN_LIST_05[1]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[2]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[3]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[4]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[5]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[6]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[7]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[8]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[9]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[10]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[11]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[12]	= { MAP01_VEHC_TMPLT13 };
TEMPLATE_SPAWN_LIST_05[13]	= { MAP01_VEHC_TMPLT13 };	--Unlocked here
TEMPLATE_SPAWN_LIST_05[14]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_05[15]	= { MAP01_VEHC_TMPLT14 };
TEMPLATE_SPAWN_LIST_05[16]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_05[17]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_05[18]	= { MAP01_VEHC_TMPLT15 };
TEMPLATE_SPAWN_LIST_05[19]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_05[20]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_05[21]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_05[22]	= { MAP01_VEHC_TMPLT16 };
TEMPLATE_SPAWN_LIST_05[23]	= { MAP01_VEHC_TMPLT17 };
TEMPLATE_SPAWN_LIST_05[24]	= { MAP01_VEHC_TMPLT17 };
TEMPLATE_SPAWN_LIST_05[25]	= { MAP01_VEHC_TMPLT17 };
TEMPLATE_SPAWN_LIST_05[26]	= { MAP01_VEHC_TMPLT17 };
TEMPLATE_SPAWN_LIST_05[27]	= { MAP01_VEHC_TMPLT17 };
TEMPLATE_SPAWN_LIST_05[28]	= { MAP01_VEHC_TMPLT18 };
TEMPLATE_SPAWN_LIST_05[29]	= { MAP01_VEHC_TMPLT18 };
TEMPLATE_SPAWN_LIST_05[30]	= { MAP01_VEHC_TMPLT18 };
TEMPLATE_SPAWN_LIST_05[31]	= { MAP01_VEHC_TMPLT18 };
TEMPLATE_SPAWN_LIST_05[32]	= { MAP01_VEHC_TMPLT18 };
TEMPLATE_SPAWN_LIST_05[33]	= { MAP01_VEHC_TMPLT18 };
TEMPLATE_SPAWN_LIST_05[34]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_05[35]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_05[36]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_05[37]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_05[38]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_05[39]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_05[40]	= { MAP01_VEHC_TMPLT19 };

----------------------------------------------------------------------

--[[
TEMPLATE_SPAWN_LIST_06[1]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[2]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[3]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[4]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[5]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[6]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[7]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[8]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[9]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[10]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[11]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[12]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[13]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[14]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[15]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[16]	= { MAP01_VEHC_TMPLT19 };--Unlocked here
TEMPLATE_SPAWN_LIST_06[17]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[18]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[19]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[20]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[21]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[22]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[23]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[24]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[25]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[26]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[27]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[28]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[29]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[30]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[31]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[32]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[33]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[34]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[35]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[36]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[37]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[38]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[39]	= { MAP01_VEHC_TMPLT19 };
TEMPLATE_SPAWN_LIST_06[40]	= { MAP01_VEHC_TMPLT19 };
]]

TEMPLATE_SPAWN_LIST_06[1]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[2]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[3]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[4]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[5]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[6]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[7]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[8]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[9]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[10]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[11]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[12]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[13]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[14]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[15]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[16]	= { MAP01_VEHC_TMPLT20 };--Unlocked here
TEMPLATE_SPAWN_LIST_06[17]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[18]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[19]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[20]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[21]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[22]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[23]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[24]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[25]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[26]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[27]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[28]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[29]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[30]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[31]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[32]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[33]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[34]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[35]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[36]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[37]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[38]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[39]	= { MAP01_VEHC_TMPLT20 };
TEMPLATE_SPAWN_LIST_06[40]	= { MAP01_VEHC_TMPLT20 };

----------------------------------------------------------------------

TEMPLATE_SPAWN_LIST_MATRIX		=
{
	TEMPLATE_SPAWN_LIST_01,
	TEMPLATE_SPAWN_LIST_02,
	TEMPLATE_SPAWN_LIST_03,
	TEMPLATE_SPAWN_LIST_04,
	TEMPLATE_SPAWN_LIST_05,
	TEMPLATE_SPAWN_LIST_06,
	TEMPLATE_SPAWN_LIST_06,
	TEMPLATE_SPAWN_LIST_06,
	TEMPLATE_SPAWN_LIST_06,
	TEMPLATE_SPAWN_LIST_06,
};

----------------------------------------------------------------------