require('game/entity/hazard/hazard-airStrike');

local TEMPLATE_AIR_STRIKE_EXPLOSION =
{
   {
      texture        = "resources/Explosion/Explosion_04.png",
      width          = 50,
      height         = 50,
      avatarSpeedK   = 0.00,
      growth         = { 10.0, 10.0 },
      growthRnd      = { 0 ,0 },
      maxDamageRadius= 20,
      duration       = 0.30,
      fadeStart      = 0.20,
      spin           = -180,
      spinRnd        =  360,
      color          = { 1, 0.8, 0.8, 1.0 },
      colorRnd       = { 0, 0.2, 0.2, 0.0 },
      damage         =
      {
         start       = 0,
         stop        = 0.10,
         vehicleVal  = 1000,
         avatarVal   = 1000,
      }
   }
}

TEMPLATE_AIR_STRIKE_TEMPLATES =
{
   {
      factory           = AirStrike, 
      trackTargetK      = 1.5,
      trackTargetTime   = 2.5,
      
      delayWarning      = 0.00,
      delayBomber       = 1.20,
      delayTarget       = 1.50,
      
      warning =
      {
         delay                = 0,
         duration             = 2.0,
         texture              = "resources/Hazard/Bomber Warning.png",
         --sounds               = {start={"resources/sounds/Rocket_Warning.ogg"},},
         width                = 60,
         height               = 42,
         changeStateTime      = 0.75,
         changeStateTimeMin   = 0.30,
         changeStateTimeAccelK= 0.75,
      },
      bomber =
      {
         delay                = 0.0,
         texture              = "resources/Hazard/Bomber Shadow.png",
         width                = 100,
         height               = 112,
         speed                =  { 0, -650 },
      },
      targets =
      {
         {
            texture        = "resources/Hazard/Bomber Crosshair.png",
            width          = 60,
            height         = 60,
            spin           = 180,
            startScale     = 10.0,
            delay          = 0.00,
            readyTime      = 0.30,
            timeToExplode  = 1.45,
            explosionTpl   = TEMPLATE_AIR_STRIKE_EXPLOSION[1],
         },
         {
            texture        = "resources/Hazard/Bomber Crosshair.png",
            width          = 60,
            height         = 60,
            spin           = 180,
            startScale     = 10.0,
            delay          = 0.20,
            readyTime      = 0.50,
            timeToExplode  = 1.59,
            explosionTpl   = TEMPLATE_AIR_STRIKE_EXPLOSION[1],
         },
         {
            texture        = "resources/Hazard/Bomber Crosshair.png",
            width          = 60,
            height         = 60,
            spin           = 180,
            startScale     = 10.0,
            delay          = 0.40,
            readyTime      = 0.70,
            timeToExplode  = 1.72,
            explosionTpl   = TEMPLATE_AIR_STRIKE_EXPLOSION[1],
         },
         {
            texture        = "resources/Hazard/Bomber Crosshair.png",
            width          = 60,
            height         = 60,
            spin           = 180,
            startScale     = 10.0,
            delay          = 0.60,
            readyTime      = 0.90,
            timeToExplode  = 1.84,
            explosionTpl   = TEMPLATE_AIR_STRIKE_EXPLOSION[1],
         },
         {
            texture        = "resources/Hazard/Bomber Crosshair.png",
            width          = 60,
            height         = 60,
            spin           = 180,
            startScale     = 10.0,
            delay          = 0.80,
            readyTime      = 1.10,
            timeToExplode  = 1.95,
            explosionTpl   = TEMPLATE_AIR_STRIKE_EXPLOSION[1],
         },
         {
            texture        = "resources/Hazard/Bomber Crosshair.png",
            width          = 60,
            height         = 60,
            spin           = 180,
            startScale     = 10.0,
            delay          = 1.00,
            readyTime      = 1.30,
            timeToExplode  = 2.05,
            explosionTpl   = TEMPLATE_AIR_STRIKE_EXPLOSION[1],
         },
      },
   },
};
