require('game/entity/hazard/hazard-missile');

local TEMPLATE_MISSILE_EXPLOSION =
{
   {
      texture        = "resources/Explosion/Explosion_04.png",
      sounds       = {start={
                           "Explosion1",
                           "Explosion2",
                           "Explosion3",
                           },
                        },
      width          = 300,
      height         = 300,
      avatarSpeedK   = 0.00,
      maxDamageRadius= 300,
      growth         = { 8, 8 },
      growthRnd      = { 0 ,0 },
      duration       = 0.35,
      fadeStart      = 0.20,
      spin           = -360,
      spinRnd        =  720,
      color          = { 1, 0.5, 0, 1.0 },
      colorRnd       = { 0, 0.5, 1, 0.0 },
      damage         =
      {
         start       = 0,
         stop        = 0.20,
         vehicleVal  = 1000,
         avatarVal   = 0,     --The missile itself kill the player... not the explosion
                              -- this is because of when coming out of speed_burst
      }   }
}

TEMPLATE_BOSS_MISSILE_TEMPLATES =
{
   {
      factory           = HazardMissile,
      layer             = 5,
      trackTargetK      = 2.50,
      trackTargetTime   = 1.50,
      
      delayWarning      = 0.00,
      delayLine         = 2.00,
		delaySound			= 0.00,
      delayObject       = 2.30,
      
      warning =
      {
         layer                = 10,
         delay                = 0,
         duration             = 2.5,
         texture              = "resources/Hazard/Bomber Warning.png",
         width                = 120,
         height               = 84,
         changeStateTime      = 0.30,
         changeStateTimeMin   = 0.10,
         changeStateTimeAccelK= 0.825,
         scaleUp              = 1.25,
         scaleDown            = 0.65,
         colorUp              = {1,1,1,1},
         colorDown            = {1,0,0,1},
         targetColorUp        = {1,0,0,1},
         targetColorDown      = {1,1,1,1},
      },
      line = 
      {
         layer          = 8,
         texture        = "resources/Hazard/Hazard-Missile-Line.png",
         width          = 18,
         height         = 1500,
         spin           = 0000,
         startScale     = 30.0,
         delay          = 0.00,
         readyTime      = 0.30,
         fadeoutTime    = 0.80,
         overTime       = 4.20,
         color          = {1,0.4,0.4,1},
      },
      object =
      {
         layer                = 9,
         delay                = 0.0,
         texture              = "resources/Hazard/Hazard_Missile.png",
         width                = 128,
         height               = 256,
         collisionWidth       =  48,
         collisionHeight      = 212,
         speed                =  { 0, -100 },
         avatarSpeedK         = 1,
         explosion            = TEMPLATE_MISSILE_EXPLOSION[1],
         fire                 =
         {
            layer             = 5,
            texture           = "resources/Hazard/Hazard-Missile-Flame.png",
            offset            = { 0, 110+107/2 },
            width             = 44,
            height            = 107,
       --     loop              = true,
         },
         shadow         =
         {
            layer          = 4,
            width          = 97*0.90,
            height         = 285*0.90,
            avatarSpeedK   = 0,
            texture        = "resources/Hazard/Missile_Shadow.png",
            offset         = {45,-45},
            color          = {1,1,1,0.15},
         },
      },
      
   },
};
