require("app/template/store/cost");
require("game/entity/powerup/powerup");

----------------------------------------------------------------------

local    COST_K   = 5;

----------------------------------------------------------------------

local TEMPLATE_POWERUP_LVL_0 =
{
   type           = "powerup_double",
   moreTimeScalar = 1.50,
   duration       = 4,
   layer          = 3,
   factory        = Powerup,
   sounds         = {start={"DoubleFirePickup",},loop={"DoubleGunLoop",},},
   type           = "powerup_double",
};

----------------------------------------------------------------------

local TEMPLATE_POWERUP_LVL_1    = Template.extent(TEMPLATE_POWERUP_LVL_0);
local TEMPLATE_POWERUP_LVL_2    = Template.extent(TEMPLATE_POWERUP_LVL_1);
local TEMPLATE_POWERUP_LVL_3    = Template.extent(TEMPLATE_POWERUP_LVL_2);
local TEMPLATE_POWERUP_LVL_4    = Template.extent(TEMPLATE_POWERUP_LVL_3);
local TEMPLATE_POWERUP_LVL_5    = Template.extent(TEMPLATE_POWERUP_LVL_4);
local TEMPLATE_POWERUP_LVL_6    = Template.extent(TEMPLATE_POWERUP_LVL_5);
local TEMPLATE_POWERUP_LVL_7    = Template.extent(TEMPLATE_POWERUP_LVL_6);
local TEMPLATE_POWERUP_LVL_8    = Template.extent(TEMPLATE_POWERUP_LVL_7);
local TEMPLATE_POWERUP_LVL_9    = Template.extent(TEMPLATE_POWERUP_LVL_8);
local TEMPLATE_POWERUP_LVL_10   = Template.extent(TEMPLATE_POWERUP_LVL_9);
local TEMPLATE_POWERUP_LVL_11   = Template.extent(TEMPLATE_POWERUP_LVL_10);
local TEMPLATE_POWERUP_LVL_12   = Template.extent(TEMPLATE_POWERUP_LVL_11);
local TEMPLATE_POWERUP_LVL_13   = Template.extent(TEMPLATE_POWERUP_LVL_12);
local TEMPLATE_POWERUP_LVL_14   = Template.extent(TEMPLATE_POWERUP_LVL_13);
local TEMPLATE_POWERUP_LVL_15   = Template.extent(TEMPLATE_POWERUP_LVL_14);

local TEMPLATE_PICKUP_1_LVL_0=
{
   type              = "powerup_double",
   pickableDelay     = 0.25,
   speed             =  { -250,    100      },
   speedRnd          =  {  500,    200      },
   accel             =  {   0,    -1500     },
   texture           = "resources/Pickup/Pickup_DoubleWeapon.png",
   width             = 158/2*1.1,
   height            = 161/2*1.1,
   
};

local TEMPLATE_PICKUP_1_LVL_1    = Template.extent(TEMPLATE_PICKUP_1_LVL_0);
local TEMPLATE_PICKUP_1_LVL_2    = Template.extent(TEMPLATE_PICKUP_1_LVL_1);
local TEMPLATE_PICKUP_1_LVL_3    = Template.extent(TEMPLATE_PICKUP_1_LVL_2);
local TEMPLATE_PICKUP_1_LVL_4    = Template.extent(TEMPLATE_PICKUP_1_LVL_3);
local TEMPLATE_PICKUP_1_LVL_5    = Template.extent(TEMPLATE_PICKUP_1_LVL_4);
local TEMPLATE_PICKUP_1_LVL_6    = Template.extent(TEMPLATE_PICKUP_1_LVL_5);
local TEMPLATE_PICKUP_1_LVL_7    = Template.extent(TEMPLATE_PICKUP_1_LVL_6);
local TEMPLATE_PICKUP_1_LVL_8    = Template.extent(TEMPLATE_PICKUP_1_LVL_7);
local TEMPLATE_PICKUP_1_LVL_9    = Template.extent(TEMPLATE_PICKUP_1_LVL_8);
local TEMPLATE_PICKUP_1_LVL_10   = Template.extent(TEMPLATE_PICKUP_1_LVL_9);
local TEMPLATE_PICKUP_1_LVL_11   = Template.extent(TEMPLATE_PICKUP_1_LVL_10);
local TEMPLATE_PICKUP_1_LVL_12   = Template.extent(TEMPLATE_PICKUP_1_LVL_11);
local TEMPLATE_PICKUP_1_LVL_13   = Template.extent(TEMPLATE_PICKUP_1_LVL_12);
local TEMPLATE_PICKUP_1_LVL_14   = Template.extent(TEMPLATE_PICKUP_1_LVL_13);
local TEMPLATE_PICKUP_1_LVL_15   = Template.extent(TEMPLATE_PICKUP_1_LVL_14);

TEMPLATE_PICKUP_1_LVL_1["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_01  };
TEMPLATE_PICKUP_1_LVL_1["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_1;
TEMPLATE_PICKUP_1_LVL_1["tplPowerup"]["duration"]     = 4.00;

TEMPLATE_PICKUP_1_LVL_2["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_02  };
TEMPLATE_PICKUP_1_LVL_2["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_2;
TEMPLATE_PICKUP_1_LVL_2["tplPowerup"]["duration"]     = 4.25;

TEMPLATE_PICKUP_1_LVL_3["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_03  };
TEMPLATE_PICKUP_1_LVL_3["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_3;
TEMPLATE_PICKUP_1_LVL_3["tplPowerup"]["duration"]     = 4.50;

TEMPLATE_PICKUP_1_LVL_4["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_04  };
TEMPLATE_PICKUP_1_LVL_4["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_4;
TEMPLATE_PICKUP_1_LVL_4["tplPowerup"]["duration"]     = 4.75;

TEMPLATE_PICKUP_1_LVL_5["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_05  };
TEMPLATE_PICKUP_1_LVL_5["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_5;
TEMPLATE_PICKUP_1_LVL_5["tplPowerup"]["duration"]     = 5.00;

TEMPLATE_PICKUP_1_LVL_6["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_06  };
TEMPLATE_PICKUP_1_LVL_6["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_6;
TEMPLATE_PICKUP_1_LVL_6["tplPowerup"]["duration"]     = 5.25;

TEMPLATE_PICKUP_1_LVL_7["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_07  };
TEMPLATE_PICKUP_1_LVL_7["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_7;
TEMPLATE_PICKUP_1_LVL_7["tplPowerup"]["duration"]     = 5.50;

TEMPLATE_PICKUP_1_LVL_8["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_08  };
TEMPLATE_PICKUP_1_LVL_8["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_8;
TEMPLATE_PICKUP_1_LVL_8["tplPowerup"]["duration"]     = 5.75;

TEMPLATE_PICKUP_1_LVL_9["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_09  };
TEMPLATE_PICKUP_1_LVL_9["tplPowerup"]                 = TEMPLATE_POWERUP_LVL_9;
TEMPLATE_PICKUP_1_LVL_9["tplPowerup"]["duration"]     = 6.00;

TEMPLATE_PICKUP_1_LVL_10["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_10  };
TEMPLATE_PICKUP_1_LVL_10["tplPowerup"]                = TEMPLATE_POWERUP_LVL_10;
TEMPLATE_PICKUP_1_LVL_10["tplPowerup"]["duration"]    = 6.25;

TEMPLATE_PICKUP_1_LVL_11["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_11  };
TEMPLATE_PICKUP_1_LVL_11["tplPowerup"]                = TEMPLATE_POWERUP_LVL_11;
TEMPLATE_PICKUP_1_LVL_11["tplPowerup"]["duration"]    = 6.50;

TEMPLATE_PICKUP_1_LVL_12["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_12  };
TEMPLATE_PICKUP_1_LVL_12["tplPowerup"]                = TEMPLATE_POWERUP_LVL_12;
TEMPLATE_PICKUP_1_LVL_12["tplPowerup"]["duration"]    = 6.75;

TEMPLATE_PICKUP_1_LVL_13["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_13  };
TEMPLATE_PICKUP_1_LVL_13["tplPowerup"]                = TEMPLATE_POWERUP_LVL_13;
TEMPLATE_PICKUP_1_LVL_13["tplPowerup"]["duration"]    = 7.00;

TEMPLATE_PICKUP_1_LVL_14["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_14  };
TEMPLATE_PICKUP_1_LVL_14["tplPowerup"]                = TEMPLATE_POWERUP_LVL_14;
TEMPLATE_PICKUP_1_LVL_14["tplPowerup"]["duration"]    = 7.25;

TEMPLATE_PICKUP_1_LVL_15["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_15  };
TEMPLATE_PICKUP_1_LVL_15["tplPowerup"]                = TEMPLATE_POWERUP_LVL_15;
TEMPLATE_PICKUP_1_LVL_15["tplPowerup"]["duration"]    = 7.50;

TEMPLATE_PICKUP_DOUBLE_SHOT_1 =
{
   version = 30,
   
   level   =
   {
      TEMPLATE_PICKUP_1_LVL_1,
      TEMPLATE_PICKUP_1_LVL_2,
      TEMPLATE_PICKUP_1_LVL_3,
      TEMPLATE_PICKUP_1_LVL_4,
      TEMPLATE_PICKUP_1_LVL_5,
      TEMPLATE_PICKUP_1_LVL_6,
      TEMPLATE_PICKUP_1_LVL_7,
      TEMPLATE_PICKUP_1_LVL_8,
      TEMPLATE_PICKUP_1_LVL_9,
      TEMPLATE_PICKUP_1_LVL_10,
      TEMPLATE_PICKUP_1_LVL_11,
      TEMPLATE_PICKUP_1_LVL_12,
      TEMPLATE_PICKUP_1_LVL_13,
      TEMPLATE_PICKUP_1_LVL_14,
      TEMPLATE_PICKUP_1_LVL_15,
   }
};