require("app/template/store/cost");
require("app/template/template");
require("game/entity/powerup/powerupDash");

local    COST_K   = 5;

local TEMPLATE_POWERUP_REVIVE_LVL_0 =
{
   type           = "powerup_speed_burst",
   warningDuration= 1,
   warningCount   = 2,
   warningColor   = { 1, 1, 0, 1.00 },
   warningScale   = 2.00,
   texture        = "resources/Powerup/Effect_Boost.png",
   offset         = { 0, -10 },
   width          = 382/1.25,
   height         = 613/1.25,
	--color          = { 0.8, 0.68, 0, 1.00 },
   massBurst      = 5000,
   speedBurst     = 6000,
   layer          = 1,
   invicible      = true;
   factory        = PowerupDash;
   sounds         = {start={
                           "BoostPickup1",
                           },},
   tplProjectile  =
   {
      speedBurst        = true,
      damage            = 100000,
      invicible         = true,
      speed             =  { 0, 2000 },
      width             = 382/1.25*2,
      height            = 613/1.25*2,
      color					= { 1, 1, 0, 1.00 },
      texture           = "resources/Powerup/Effect_Boost.png",
   }
};

----------------------------------------------------------------------

local TEMPLATE_POWERUP_REVIVE_LVL_1    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_0);
local TEMPLATE_POWERUP_REVIVE_LVL_2    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_1);
local TEMPLATE_POWERUP_REVIVE_LVL_3    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_2);
local TEMPLATE_POWERUP_REVIVE_LVL_4    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_3);
local TEMPLATE_POWERUP_REVIVE_LVL_5    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_4);
local TEMPLATE_POWERUP_REVIVE_LVL_6    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_5);
local TEMPLATE_POWERUP_REVIVE_LVL_7    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_6);
local TEMPLATE_POWERUP_REVIVE_LVL_8    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_7);
local TEMPLATE_POWERUP_REVIVE_LVL_9    = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_8);
local TEMPLATE_POWERUP_REVIVE_LVL_10   = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_9);
local TEMPLATE_POWERUP_REVIVE_LVL_11   = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_10);
local TEMPLATE_POWERUP_REVIVE_LVL_12   = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_11);
local TEMPLATE_POWERUP_REVIVE_LVL_13   = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_12);
local TEMPLATE_POWERUP_REVIVE_LVL_14   = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_13);
local TEMPLATE_POWERUP_REVIVE_LVL_15   = Template.extent(TEMPLATE_POWERUP_REVIVE_LVL_14);

----------------------------------------------------------------------

local TEMPLATE_PICKUP_LVL_0 =
{
   type              = "powerup_speed_burst",
   pickableDelay     = 0.25,
   speed             =  { -250,    100      },
   speedRnd          =  {  500,    200      },
   accel             =  {   0,    -1500     },
   texture           = "resources/Pickup/Pickup_Boost.png",
   width             = 142/2*1.15,
   height            = 146/2*1.15,
	color					= { 0.8, 0.68, 0, 1.00 },
   tplPowerup        = TEMPLATE_POWERUP_REVIVE_LVL_0,
}

local TEMPLATE_PICKUP_LVL_1    = Template.extent(TEMPLATE_PICKUP_LVL_0);
local TEMPLATE_PICKUP_LVL_2    = Template.extent(TEMPLATE_PICKUP_LVL_1);
local TEMPLATE_PICKUP_LVL_3    = Template.extent(TEMPLATE_PICKUP_LVL_2);
local TEMPLATE_PICKUP_LVL_4    = Template.extent(TEMPLATE_PICKUP_LVL_3);
local TEMPLATE_PICKUP_LVL_5    = Template.extent(TEMPLATE_PICKUP_LVL_4);
local TEMPLATE_PICKUP_LVL_6    = Template.extent(TEMPLATE_PICKUP_LVL_5);
local TEMPLATE_PICKUP_LVL_7    = Template.extent(TEMPLATE_PICKUP_LVL_6);
local TEMPLATE_PICKUP_LVL_8    = Template.extent(TEMPLATE_PICKUP_LVL_7);
local TEMPLATE_PICKUP_LVL_9    = Template.extent(TEMPLATE_PICKUP_LVL_8);
local TEMPLATE_PICKUP_LVL_10   = Template.extent(TEMPLATE_PICKUP_LVL_9);
local TEMPLATE_PICKUP_LVL_11   = Template.extent(TEMPLATE_PICKUP_LVL_10);
local TEMPLATE_PICKUP_LVL_12   = Template.extent(TEMPLATE_PICKUP_LVL_11);
local TEMPLATE_PICKUP_LVL_13   = Template.extent(TEMPLATE_PICKUP_LVL_12);
local TEMPLATE_PICKUP_LVL_14   = Template.extent(TEMPLATE_PICKUP_LVL_13);
local TEMPLATE_PICKUP_LVL_15   = Template.extent(TEMPLATE_PICKUP_LVL_14);

TEMPLATE_PICKUP_LVL_1["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_01  };
TEMPLATE_PICKUP_LVL_1["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_1;
TEMPLATE_PICKUP_LVL_1["tplPowerup"]["duration"]     = 3.00;

TEMPLATE_PICKUP_LVL_2["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_02  };
TEMPLATE_PICKUP_LVL_2["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_2;
TEMPLATE_PICKUP_LVL_2["tplPowerup"]["duration"]     = 3.25;

TEMPLATE_PICKUP_LVL_3["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_03  };
TEMPLATE_PICKUP_LVL_3["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_3;
TEMPLATE_PICKUP_LVL_3["tplPowerup"]["duration"]     = 3.50;

TEMPLATE_PICKUP_LVL_4["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_04  };
TEMPLATE_PICKUP_LVL_4["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_4;
TEMPLATE_PICKUP_LVL_4["tplPowerup"]["duration"]     = 3.75;

TEMPLATE_PICKUP_LVL_5["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_05  };
TEMPLATE_PICKUP_LVL_5["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_5;
TEMPLATE_PICKUP_LVL_5["tplPowerup"]["duration"]     = 4.00;

TEMPLATE_PICKUP_LVL_6["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_06  };
TEMPLATE_PICKUP_LVL_6["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_6;
TEMPLATE_PICKUP_LVL_6["tplPowerup"]["duration"]     = 4.25;

TEMPLATE_PICKUP_LVL_7["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_07  };
TEMPLATE_PICKUP_LVL_7["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_7;
TEMPLATE_PICKUP_LVL_7["tplPowerup"]["duration"]     = 4.50;

TEMPLATE_PICKUP_LVL_8["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_08  };
TEMPLATE_PICKUP_LVL_8["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_8;
TEMPLATE_PICKUP_LVL_8["tplPowerup"]["duration"]     = 4.75;

TEMPLATE_PICKUP_LVL_9["cost"]                       = { gold = COST_K*TEMPLATE_BASE_COST_09  };
TEMPLATE_PICKUP_LVL_9["tplPowerup"]                 = TEMPLATE_POWERUP_REVIVE_LVL_9;
TEMPLATE_PICKUP_LVL_9["tplPowerup"]["duration"]     = 5.00;

TEMPLATE_PICKUP_LVL_10["cost"]                      = { gold =COST_K*TEMPLATE_BASE_COST_10  };
TEMPLATE_PICKUP_LVL_10["tplPowerup"]                = TEMPLATE_POWERUP_REVIVE_LVL_10;
TEMPLATE_PICKUP_LVL_10["tplPowerup"]["duration"]    = 5.25;

TEMPLATE_PICKUP_LVL_11["cost"]                      = { gold =COST_K*TEMPLATE_BASE_COST_11  };
TEMPLATE_PICKUP_LVL_11["tplPowerup"]                = TEMPLATE_POWERUP_REVIVE_LVL_11;
TEMPLATE_PICKUP_LVL_11["tplPowerup"]["duration"]    = 5.50;

TEMPLATE_PICKUP_LVL_12["cost"]                      = { gold =COST_K*TEMPLATE_BASE_COST_12  };
TEMPLATE_PICKUP_LVL_12["tplPowerup"]                = TEMPLATE_POWERUP_REVIVE_LVL_12;
TEMPLATE_PICKUP_LVL_12["tplPowerup"]["duration"]    = 5.75;

TEMPLATE_PICKUP_LVL_13["cost"]                      = { gold =COST_K*TEMPLATE_BASE_COST_13  };
TEMPLATE_PICKUP_LVL_13["tplPowerup"]                = TEMPLATE_POWERUP_REVIVE_LVL_13;
TEMPLATE_PICKUP_LVL_13["tplPowerup"]["duration"]    = 6.00;

TEMPLATE_PICKUP_LVL_14["cost"]                      = { gold =COST_K*TEMPLATE_BASE_COST_14 };
TEMPLATE_PICKUP_LVL_14["tplPowerup"]                = TEMPLATE_POWERUP_REVIVE_LVL_14;
TEMPLATE_PICKUP_LVL_14["tplPowerup"]["duration"]    = 6.25;

TEMPLATE_PICKUP_LVL_15["cost"]                      = { gold =COST_K*TEMPLATE_BASE_COST_15  };
TEMPLATE_PICKUP_LVL_15["tplPowerup"]                = TEMPLATE_POWERUP_REVIVE_LVL_15;
TEMPLATE_PICKUP_LVL_15["tplPowerup"]["duration"]    = 6.50;

TEMPLATE_PICKUP_REVIVE_1 =
{
   version = 30,
   
   level   =
   {
      TEMPLATE_PICKUP_LVL_1,
      TEMPLATE_PICKUP_LVL_2,
      TEMPLATE_PICKUP_LVL_3,
      TEMPLATE_PICKUP_LVL_4,
      TEMPLATE_PICKUP_LVL_5,
      TEMPLATE_PICKUP_LVL_6,
      TEMPLATE_PICKUP_LVL_7,
      TEMPLATE_PICKUP_LVL_8,
      TEMPLATE_PICKUP_LVL_9,
      TEMPLATE_PICKUP_LVL_10,
      TEMPLATE_PICKUP_LVL_11,
      TEMPLATE_PICKUP_LVL_12,
      TEMPLATE_PICKUP_LVL_13,
      TEMPLATE_PICKUP_LVL_14,
      TEMPLATE_PICKUP_LVL_15,
   }
};