require("app/template/store/cost");
require("game/entity/powerup/powerup");

----------------------------------------------------------------------

local    COST_K   = 5;

----------------------------------------------------------------------

local TEMPLATE_POWERUP_SCORE_2X_LVL_0 =
{
   factory        = Powerup,
   type           = "powerup_scoreK",
   moreTimeScalar = 1.33,
   duration       = 8,
   scoreK         = 2,
   blend          = "add",
   texture        = "resources/Powerup/Effect_ScoreMult.png",
   color          = { 0, 1, 0, 0.25 },
   offsetX        =   0,
   offsetY        =   0,
   width          = 300,
   height         = 300,
   spin           = 180,
   layer          = 2,
   sounds         = {
							start={"DoublePointsPickup",},
							loop={"2xScoreLoop",},
						  }, 
};

----------------------------------------------------------------------

local TEMPLATE_POWERUP_SCORE_2X_LVL_1    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_0);
local TEMPLATE_POWERUP_SCORE_2X_LVL_2    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_1);
local TEMPLATE_POWERUP_SCORE_2X_LVL_3    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_2);
local TEMPLATE_POWERUP_SCORE_2X_LVL_4    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_3);
local TEMPLATE_POWERUP_SCORE_2X_LVL_5    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_4);
local TEMPLATE_POWERUP_SCORE_2X_LVL_6    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_5);
local TEMPLATE_POWERUP_SCORE_2X_LVL_7    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_6);
local TEMPLATE_POWERUP_SCORE_2X_LVL_8    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_7);
local TEMPLATE_POWERUP_SCORE_2X_LVL_9    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_8);
local TEMPLATE_POWERUP_SCORE_2X_LVL_10   = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_9);
local TEMPLATE_POWERUP_SCORE_2X_LVL_11   = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_10);
local TEMPLATE_POWERUP_SCORE_2X_LVL_12   = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_11);
local TEMPLATE_POWERUP_SCORE_2X_LVL_13   = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_12);
local TEMPLATE_POWERUP_SCORE_2X_LVL_14   = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_13);
local TEMPLATE_POWERUP_SCORE_2X_LVL_15   = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_14);

local TEMPLATE_POWERUP_SCORE_3X_LVL_1    = Template.extent(TEMPLATE_POWERUP_SCORE_2X_LVL_1);
local TEMPLATE_POWERUP_SCORE_3X_LVL_2    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_1);
local TEMPLATE_POWERUP_SCORE_3X_LVL_3    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_2);
local TEMPLATE_POWERUP_SCORE_3X_LVL_4    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_3);
local TEMPLATE_POWERUP_SCORE_3X_LVL_5    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_4);
local TEMPLATE_POWERUP_SCORE_3X_LVL_6    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_5);
local TEMPLATE_POWERUP_SCORE_3X_LVL_7    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_6);
local TEMPLATE_POWERUP_SCORE_3X_LVL_8    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_7);
local TEMPLATE_POWERUP_SCORE_3X_LVL_9    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_8);
local TEMPLATE_POWERUP_SCORE_3X_LVL_10   = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_9);
local TEMPLATE_POWERUP_SCORE_3X_LVL_11   = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_10);
local TEMPLATE_POWERUP_SCORE_3X_LVL_12   = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_11);
local TEMPLATE_POWERUP_SCORE_3X_LVL_13   = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_12);
local TEMPLATE_POWERUP_SCORE_3X_LVL_14   = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_13);
local TEMPLATE_POWERUP_SCORE_3X_LVL_15   = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_14);

local TEMPLATE_POWERUP_SCORE_4X_LVL_1    = Template.extent(TEMPLATE_POWERUP_SCORE_3X_LVL_1);
local TEMPLATE_POWERUP_SCORE_4X_LVL_2    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_1);
local TEMPLATE_POWERUP_SCORE_4X_LVL_3    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_2);
local TEMPLATE_POWERUP_SCORE_4X_LVL_4    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_3);
local TEMPLATE_POWERUP_SCORE_4X_LVL_5    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_4);
local TEMPLATE_POWERUP_SCORE_4X_LVL_6    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_5);
local TEMPLATE_POWERUP_SCORE_4X_LVL_7    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_6);
local TEMPLATE_POWERUP_SCORE_4X_LVL_8    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_7);
local TEMPLATE_POWERUP_SCORE_4X_LVL_9    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_8);
local TEMPLATE_POWERUP_SCORE_4X_LVL_10   = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_9);
local TEMPLATE_POWERUP_SCORE_4X_LVL_11   = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_10);
local TEMPLATE_POWERUP_SCORE_4X_LVL_12   = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_11);
local TEMPLATE_POWERUP_SCORE_4X_LVL_13   = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_12);
local TEMPLATE_POWERUP_SCORE_4X_LVL_14   = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_13);
local TEMPLATE_POWERUP_SCORE_4X_LVL_15   = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_14);

local TEMPLATE_POWERUP_SCORE_5X_LVL_1    = Template.extent(TEMPLATE_POWERUP_SCORE_4X_LVL_1);
local TEMPLATE_POWERUP_SCORE_5X_LVL_2    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_1);
local TEMPLATE_POWERUP_SCORE_5X_LVL_3    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_2);
local TEMPLATE_POWERUP_SCORE_5X_LVL_4    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_3);
local TEMPLATE_POWERUP_SCORE_5X_LVL_5    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_4);
local TEMPLATE_POWERUP_SCORE_5X_LVL_6    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_5);
local TEMPLATE_POWERUP_SCORE_5X_LVL_7    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_6);
local TEMPLATE_POWERUP_SCORE_5X_LVL_8    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_7);
local TEMPLATE_POWERUP_SCORE_5X_LVL_9    = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_8);
local TEMPLATE_POWERUP_SCORE_5X_LVL_10   = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_9);
local TEMPLATE_POWERUP_SCORE_5X_LVL_11   = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_10);
local TEMPLATE_POWERUP_SCORE_5X_LVL_12   = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_11);
local TEMPLATE_POWERUP_SCORE_5X_LVL_13   = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_12);
local TEMPLATE_POWERUP_SCORE_5X_LVL_14   = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_13);
local TEMPLATE_POWERUP_SCORE_5X_LVL_15   = Template.extent(TEMPLATE_POWERUP_SCORE_5X_LVL_14);

TEMPLATE_POWERUP_SCORE_2X_LVL_1["scoreK"] = 2;
TEMPLATE_POWERUP_SCORE_3X_LVL_1["scoreK"] = 3;
TEMPLATE_POWERUP_SCORE_4X_LVL_1["scoreK"] = 4;
TEMPLATE_POWERUP_SCORE_5X_LVL_1["scoreK"] = 5;

local TEMPLATE_PICKUP_2X_LVL_0=
{
   type              = "powerup_scoreK",
   pickableDelay     = 0.25,
   speed             =  { -250,    100      },
   speedRnd          =  {  500,    200      },
   accel             =  {   0,    -1500     },
   texture           = "resources/Pickup/Pickup_2x.png",
   width             = 180/2*1.15,
   height            = 160/2*1.15,
};

local TEMPLATE_PICKUP_2X_LVL_1    = Template.extent(TEMPLATE_PICKUP_2X_LVL_0);
local TEMPLATE_PICKUP_2X_LVL_2    = Template.extent(TEMPLATE_PICKUP_2X_LVL_1);
local TEMPLATE_PICKUP_2X_LVL_3    = Template.extent(TEMPLATE_PICKUP_2X_LVL_2);
local TEMPLATE_PICKUP_2X_LVL_4    = Template.extent(TEMPLATE_PICKUP_2X_LVL_3);
local TEMPLATE_PICKUP_2X_LVL_5    = Template.extent(TEMPLATE_PICKUP_2X_LVL_4);
local TEMPLATE_PICKUP_2X_LVL_6    = Template.extent(TEMPLATE_PICKUP_2X_LVL_5);
local TEMPLATE_PICKUP_2X_LVL_7    = Template.extent(TEMPLATE_PICKUP_2X_LVL_6);
local TEMPLATE_PICKUP_2X_LVL_8    = Template.extent(TEMPLATE_PICKUP_2X_LVL_7);
local TEMPLATE_PICKUP_2X_LVL_9    = Template.extent(TEMPLATE_PICKUP_2X_LVL_8);
local TEMPLATE_PICKUP_2X_LVL_10   = Template.extent(TEMPLATE_PICKUP_2X_LVL_9);
local TEMPLATE_PICKUP_2X_LVL_11   = Template.extent(TEMPLATE_PICKUP_2X_LVL_10);
local TEMPLATE_PICKUP_2X_LVL_12   = Template.extent(TEMPLATE_PICKUP_2X_LVL_11);
local TEMPLATE_PICKUP_2X_LVL_13   = Template.extent(TEMPLATE_PICKUP_2X_LVL_12);
local TEMPLATE_PICKUP_2X_LVL_14   = Template.extent(TEMPLATE_PICKUP_2X_LVL_13);
local TEMPLATE_PICKUP_2X_LVL_15   = Template.extent(TEMPLATE_PICKUP_2X_LVL_14);


local TEMPLATE_PICKUP_3X_LVL_0=
{
   type              = "powerup_scoreK",
   pickableDelay     = 0.15,
   speed             =  { -250,    000      },
   speedRnd          =  {  500,    300      },
   accel             =  {   0,    -1500     },
   texture           = "resources/Pickup/Pickup_3x.png",
   width             = 158/2*1.15,
   height            = 160/2*1.15,
};

local TEMPLATE_PICKUP_3X_LVL_1    = Template.extent(TEMPLATE_PICKUP_3X_LVL_0);
local TEMPLATE_PICKUP_3X_LVL_2    = Template.extent(TEMPLATE_PICKUP_3X_LVL_1);
local TEMPLATE_PICKUP_3X_LVL_3    = Template.extent(TEMPLATE_PICKUP_3X_LVL_2);
local TEMPLATE_PICKUP_3X_LVL_4    = Template.extent(TEMPLATE_PICKUP_3X_LVL_3);
local TEMPLATE_PICKUP_3X_LVL_5    = Template.extent(TEMPLATE_PICKUP_3X_LVL_4);
local TEMPLATE_PICKUP_3X_LVL_6    = Template.extent(TEMPLATE_PICKUP_3X_LVL_5);
local TEMPLATE_PICKUP_3X_LVL_7    = Template.extent(TEMPLATE_PICKUP_3X_LVL_6);
local TEMPLATE_PICKUP_3X_LVL_8    = Template.extent(TEMPLATE_PICKUP_3X_LVL_7);
local TEMPLATE_PICKUP_3X_LVL_9    = Template.extent(TEMPLATE_PICKUP_3X_LVL_8);
local TEMPLATE_PICKUP_3X_LVL_10   = Template.extent(TEMPLATE_PICKUP_3X_LVL_9);
local TEMPLATE_PICKUP_3X_LVL_11   = Template.extent(TEMPLATE_PICKUP_3X_LVL_10);
local TEMPLATE_PICKUP_3X_LVL_12   = Template.extent(TEMPLATE_PICKUP_3X_LVL_11);
local TEMPLATE_PICKUP_3X_LVL_13   = Template.extent(TEMPLATE_PICKUP_3X_LVL_12);
local TEMPLATE_PICKUP_3X_LVL_14   = Template.extent(TEMPLATE_PICKUP_3X_LVL_13);
local TEMPLATE_PICKUP_3X_LVL_15   = Template.extent(TEMPLATE_PICKUP_3X_LVL_14);



local TEMPLATE_PICKUP_4X_LVL_0=
{
   type              = "powerup_scoreK",
   pickableDelay     = 0.15,
   speed             =  { -250,    000      },
   speedRnd          =  {  500,    300      },
   accel             =  {   0,    -1500     },
   texture           = "resources/Pickup/Pickup_4x.png",
   width             = 158/2*1.15,
   height            = 160/2*1.15,
};

local TEMPLATE_PICKUP_4X_LVL_1    = Template.extent(TEMPLATE_PICKUP_4X_LVL_0);
local TEMPLATE_PICKUP_4X_LVL_2    = Template.extent(TEMPLATE_PICKUP_4X_LVL_1);
local TEMPLATE_PICKUP_4X_LVL_3    = Template.extent(TEMPLATE_PICKUP_4X_LVL_2);
local TEMPLATE_PICKUP_4X_LVL_4    = Template.extent(TEMPLATE_PICKUP_4X_LVL_3);
local TEMPLATE_PICKUP_4X_LVL_5    = Template.extent(TEMPLATE_PICKUP_4X_LVL_4);
local TEMPLATE_PICKUP_4X_LVL_6    = Template.extent(TEMPLATE_PICKUP_4X_LVL_5);
local TEMPLATE_PICKUP_4X_LVL_7    = Template.extent(TEMPLATE_PICKUP_4X_LVL_6);
local TEMPLATE_PICKUP_4X_LVL_8    = Template.extent(TEMPLATE_PICKUP_4X_LVL_7);
local TEMPLATE_PICKUP_4X_LVL_9    = Template.extent(TEMPLATE_PICKUP_4X_LVL_8);
local TEMPLATE_PICKUP_4X_LVL_10   = Template.extent(TEMPLATE_PICKUP_4X_LVL_9);
local TEMPLATE_PICKUP_4X_LVL_11   = Template.extent(TEMPLATE_PICKUP_4X_LVL_10);
local TEMPLATE_PICKUP_4X_LVL_12   = Template.extent(TEMPLATE_PICKUP_4X_LVL_11);
local TEMPLATE_PICKUP_4X_LVL_13   = Template.extent(TEMPLATE_PICKUP_4X_LVL_12);
local TEMPLATE_PICKUP_4X_LVL_14   = Template.extent(TEMPLATE_PICKUP_4X_LVL_13);
local TEMPLATE_PICKUP_4X_LVL_15   = Template.extent(TEMPLATE_PICKUP_4X_LVL_14);


local TEMPLATE_PICKUP_5X_LVL_0=
{
   type              = "powerup_scoreK",
   pickableDelay     = 0.15,
   speed             =  { -250,    000      },
   speedRnd          =  {  500,    300      },
   accel             =  {   0,    -1500     },
   texture           = "resources/Pickup/Pickup_5x.png",
   width             = 158/2*1.15,
   height            = 160/2*1.15,
};

local TEMPLATE_PICKUP_5X_LVL_1    = Template.extent(TEMPLATE_PICKUP_5X_LVL_0);
local TEMPLATE_PICKUP_5X_LVL_2    = Template.extent(TEMPLATE_PICKUP_5X_LVL_1);
local TEMPLATE_PICKUP_5X_LVL_3    = Template.extent(TEMPLATE_PICKUP_5X_LVL_2);
local TEMPLATE_PICKUP_5X_LVL_4    = Template.extent(TEMPLATE_PICKUP_5X_LVL_3);
local TEMPLATE_PICKUP_5X_LVL_5    = Template.extent(TEMPLATE_PICKUP_5X_LVL_4);
local TEMPLATE_PICKUP_5X_LVL_6    = Template.extent(TEMPLATE_PICKUP_5X_LVL_5);
local TEMPLATE_PICKUP_5X_LVL_7    = Template.extent(TEMPLATE_PICKUP_5X_LVL_6);
local TEMPLATE_PICKUP_5X_LVL_8    = Template.extent(TEMPLATE_PICKUP_5X_LVL_7);
local TEMPLATE_PICKUP_5X_LVL_9    = Template.extent(TEMPLATE_PICKUP_5X_LVL_8);
local TEMPLATE_PICKUP_5X_LVL_10   = Template.extent(TEMPLATE_PICKUP_5X_LVL_9);
local TEMPLATE_PICKUP_5X_LVL_11   = Template.extent(TEMPLATE_PICKUP_5X_LVL_10);
local TEMPLATE_PICKUP_5X_LVL_12   = Template.extent(TEMPLATE_PICKUP_5X_LVL_11);
local TEMPLATE_PICKUP_5X_LVL_13   = Template.extent(TEMPLATE_PICKUP_5X_LVL_12);
local TEMPLATE_PICKUP_5X_LVL_14   = Template.extent(TEMPLATE_PICKUP_5X_LVL_13);
local TEMPLATE_PICKUP_5X_LVL_15   = Template.extent(TEMPLATE_PICKUP_5X_LVL_14);

TEMPLATE_PICKUP_2X_LVL_1["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_1;
TEMPLATE_PICKUP_2X_LVL_1["tplPowerup"]["duration"]     = 6.00;
TEMPLATE_PICKUP_3X_LVL_1["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_1;
TEMPLATE_PICKUP_3X_LVL_1["tplPowerup"]["duration"]     = 6.00;
TEMPLATE_PICKUP_4X_LVL_1["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_1;
TEMPLATE_PICKUP_4X_LVL_1["tplPowerup"]["duration"]     = 6.00;
TEMPLATE_PICKUP_5X_LVL_1["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_1;
TEMPLATE_PICKUP_5X_LVL_1["tplPowerup"]["duration"]     = 6.00;

TEMPLATE_PICKUP_2X_LVL_2["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_2;
TEMPLATE_PICKUP_2X_LVL_2["tplPowerup"]["duration"]     = 6.25;
TEMPLATE_PICKUP_3X_LVL_2["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_2;
TEMPLATE_PICKUP_3X_LVL_2["tplPowerup"]["duration"]     = 6.25;
TEMPLATE_PICKUP_4X_LVL_2["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_2;
TEMPLATE_PICKUP_4X_LVL_2["tplPowerup"]["duration"]     = 6.25;
TEMPLATE_PICKUP_5X_LVL_2["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_2;
TEMPLATE_PICKUP_5X_LVL_2["tplPowerup"]["duration"]     = 6.25;

TEMPLATE_PICKUP_2X_LVL_3["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_3;
TEMPLATE_PICKUP_2X_LVL_3["tplPowerup"]["duration"]     = 6.50;
TEMPLATE_PICKUP_3X_LVL_3["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_3;
TEMPLATE_PICKUP_3X_LVL_3["tplPowerup"]["duration"]     = 6.50;
TEMPLATE_PICKUP_4X_LVL_3["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_3;
TEMPLATE_PICKUP_4X_LVL_3["tplPowerup"]["duration"]     = 6.50;
TEMPLATE_PICKUP_5X_LVL_3["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_3;
TEMPLATE_PICKUP_5X_LVL_3["tplPowerup"]["duration"]     = 6.50;

TEMPLATE_PICKUP_2X_LVL_4["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_4;
TEMPLATE_PICKUP_2X_LVL_4["tplPowerup"]["duration"]     = 6.75;
TEMPLATE_PICKUP_3X_LVL_4["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_4;
TEMPLATE_PICKUP_3X_LVL_4["tplPowerup"]["duration"]     = 6.75;
TEMPLATE_PICKUP_4X_LVL_4["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_4;
TEMPLATE_PICKUP_4X_LVL_4["tplPowerup"]["duration"]     = 6.75;
TEMPLATE_PICKUP_5X_LVL_4["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_4;
TEMPLATE_PICKUP_5X_LVL_4["tplPowerup"]["duration"]     = 6.75;

TEMPLATE_PICKUP_2X_LVL_5["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_5;
TEMPLATE_PICKUP_2X_LVL_5["tplPowerup"]["duration"]     = 7.00;
TEMPLATE_PICKUP_3X_LVL_5["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_5;
TEMPLATE_PICKUP_3X_LVL_5["tplPowerup"]["duration"]     = 7.00;
TEMPLATE_PICKUP_4X_LVL_5["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_5;
TEMPLATE_PICKUP_4X_LVL_5["tplPowerup"]["duration"]     = 7.00;
TEMPLATE_PICKUP_5X_LVL_5["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_5;
TEMPLATE_PICKUP_5X_LVL_5["tplPowerup"]["duration"]     = 7.00;

TEMPLATE_PICKUP_2X_LVL_6["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_6;
TEMPLATE_PICKUP_2X_LVL_6["tplPowerup"]["duration"]     = 7.25;
TEMPLATE_PICKUP_3X_LVL_6["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_6;
TEMPLATE_PICKUP_3X_LVL_6["tplPowerup"]["duration"]     = 7.25;
TEMPLATE_PICKUP_4X_LVL_6["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_6;
TEMPLATE_PICKUP_4X_LVL_6["tplPowerup"]["duration"]     = 7.25;
TEMPLATE_PICKUP_5X_LVL_6["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_6;
TEMPLATE_PICKUP_5X_LVL_6["tplPowerup"]["duration"]     = 7.25;

TEMPLATE_PICKUP_2X_LVL_7["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_7;
TEMPLATE_PICKUP_2X_LVL_7["tplPowerup"]["duration"]     = 7.50;
TEMPLATE_PICKUP_3X_LVL_7["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_7;
TEMPLATE_PICKUP_3X_LVL_7["tplPowerup"]["duration"]     = 7.50;
TEMPLATE_PICKUP_4X_LVL_7["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_7;
TEMPLATE_PICKUP_4X_LVL_7["tplPowerup"]["duration"]     = 7.50;
TEMPLATE_PICKUP_5X_LVL_7["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_7;
TEMPLATE_PICKUP_5X_LVL_7["tplPowerup"]["duration"]     = 7.50;

TEMPLATE_PICKUP_2X_LVL_8["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_8;
TEMPLATE_PICKUP_2X_LVL_8["tplPowerup"]["duration"]     = 7.75;
TEMPLATE_PICKUP_3X_LVL_8["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_8;
TEMPLATE_PICKUP_3X_LVL_8["tplPowerup"]["duration"]     = 7.75;
TEMPLATE_PICKUP_4X_LVL_8["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_8;
TEMPLATE_PICKUP_4X_LVL_8["tplPowerup"]["duration"]     = 7.75;
TEMPLATE_PICKUP_5X_LVL_8["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_8;
TEMPLATE_PICKUP_5X_LVL_8["tplPowerup"]["duration"]     = 7.75;

TEMPLATE_PICKUP_2X_LVL_9["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_2X_LVL_9;
TEMPLATE_PICKUP_2X_LVL_9["tplPowerup"]["duration"]     = 8.00;
TEMPLATE_PICKUP_3X_LVL_9["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_3X_LVL_9;
TEMPLATE_PICKUP_3X_LVL_9["tplPowerup"]["duration"]     = 8.00;
TEMPLATE_PICKUP_4X_LVL_9["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_4X_LVL_9;
TEMPLATE_PICKUP_4X_LVL_9["tplPowerup"]["duration"]     = 8.00;
TEMPLATE_PICKUP_5X_LVL_9["tplPowerup"]                 = TEMPLATE_POWERUP_SCORE_5X_LVL_9;
TEMPLATE_PICKUP_5X_LVL_9["tplPowerup"]["duration"]     = 8.00;

TEMPLATE_PICKUP_2X_LVL_10["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_2X_LVL_10;
TEMPLATE_PICKUP_2X_LVL_10["tplPowerup"]["duration"]    = 8.25;
TEMPLATE_PICKUP_3X_LVL_10["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_3X_LVL_10;
TEMPLATE_PICKUP_3X_LVL_10["tplPowerup"]["duration"]    = 8.25;
TEMPLATE_PICKUP_4X_LVL_10["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_4X_LVL_10;
TEMPLATE_PICKUP_4X_LVL_10["tplPowerup"]["duration"]    = 8.25;
TEMPLATE_PICKUP_5X_LVL_10["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_5X_LVL_10;
TEMPLATE_PICKUP_5X_LVL_10["tplPowerup"]["duration"]    = 8.25;

TEMPLATE_PICKUP_2X_LVL_11["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_2X_LVL_11;
TEMPLATE_PICKUP_2X_LVL_11["tplPowerup"]["duration"]    = 8.50;
TEMPLATE_PICKUP_3X_LVL_11["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_3X_LVL_11;
TEMPLATE_PICKUP_3X_LVL_11["tplPowerup"]["duration"]    = 8.50;
TEMPLATE_PICKUP_4X_LVL_11["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_4X_LVL_11;
TEMPLATE_PICKUP_4X_LVL_11["tplPowerup"]["duration"]    = 8.50;
TEMPLATE_PICKUP_5X_LVL_11["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_5X_LVL_11;
TEMPLATE_PICKUP_5X_LVL_11["tplPowerup"]["duration"]    = 8.50;

TEMPLATE_PICKUP_2X_LVL_12["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_2X_LVL_12;
TEMPLATE_PICKUP_2X_LVL_12["tplPowerup"]["duration"]    = 8.75;
TEMPLATE_PICKUP_3X_LVL_12["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_3X_LVL_12;
TEMPLATE_PICKUP_3X_LVL_12["tplPowerup"]["duration"]    = 8.75;
TEMPLATE_PICKUP_4X_LVL_12["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_4X_LVL_12;
TEMPLATE_PICKUP_4X_LVL_12["tplPowerup"]["duration"]    = 8.75;
TEMPLATE_PICKUP_5X_LVL_12["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_5X_LVL_12;
TEMPLATE_PICKUP_5X_LVL_12["tplPowerup"]["duration"]    = 8.75;

TEMPLATE_PICKUP_2X_LVL_13["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_2X_LVL_13;
TEMPLATE_PICKUP_2X_LVL_13["tplPowerup"]["duration"]    = 9.00;
TEMPLATE_PICKUP_3X_LVL_13["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_3X_LVL_13;
TEMPLATE_PICKUP_3X_LVL_13["tplPowerup"]["duration"]    = 9.00;
TEMPLATE_PICKUP_4X_LVL_13["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_4X_LVL_13;
TEMPLATE_PICKUP_4X_LVL_13["tplPowerup"]["duration"]    = 9.00;
TEMPLATE_PICKUP_5X_LVL_13["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_5X_LVL_13;
TEMPLATE_PICKUP_5X_LVL_13["tplPowerup"]["duration"]    = 9.00;

TEMPLATE_PICKUP_2X_LVL_14["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_2X_LVL_14;
TEMPLATE_PICKUP_2X_LVL_14["tplPowerup"]["duration"]    = 9.25;
TEMPLATE_PICKUP_3X_LVL_14["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_3X_LVL_14;
TEMPLATE_PICKUP_3X_LVL_14["tplPowerup"]["duration"]    = 9.25;
TEMPLATE_PICKUP_4X_LVL_14["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_4X_LVL_14;
TEMPLATE_PICKUP_4X_LVL_14["tplPowerup"]["duration"]    = 9.25;
TEMPLATE_PICKUP_5X_LVL_14["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_5X_LVL_14;
TEMPLATE_PICKUP_5X_LVL_14["tplPowerup"]["duration"]    = 9.25;

TEMPLATE_PICKUP_2X_LVL_15["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_2X_LVL_15;
TEMPLATE_PICKUP_2X_LVL_15["tplPowerup"]["duration"]    = 9.50;
TEMPLATE_PICKUP_3X_LVL_15["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_3X_LVL_15;
TEMPLATE_PICKUP_3X_LVL_15["tplPowerup"]["duration"]    = 9.50;
TEMPLATE_PICKUP_4X_LVL_15["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_4X_LVL_15;
TEMPLATE_PICKUP_4X_LVL_15["tplPowerup"]["duration"]    = 9.50;
TEMPLATE_PICKUP_5X_LVL_15["tplPowerup"]                = TEMPLATE_POWERUP_SCORE_5X_LVL_15;
TEMPLATE_PICKUP_5X_LVL_15["tplPowerup"]["duration"]    = 9.50;

TEMPLATE_PICKUP_SCORE_K_1 =
{
   version = 30,
   
   level   =
   {
      { TEMPLATE_PICKUP_2X_LVL_1,   TEMPLATE_PICKUP_3X_LVL_1,   TEMPLATE_PICKUP_4X_LVL_1,   TEMPLATE_PICKUP_5X_LVL_1,  cost = { gold = COST_K*TEMPLATE_BASE_COST_01  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
      { TEMPLATE_PICKUP_2X_LVL_2,   TEMPLATE_PICKUP_3X_LVL_2,   TEMPLATE_PICKUP_4X_LVL_2,   TEMPLATE_PICKUP_5X_LVL_2,  cost = { gold = COST_K*TEMPLATE_BASE_COST_02  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_3,   TEMPLATE_PICKUP_3X_LVL_3,   TEMPLATE_PICKUP_4X_LVL_3,   TEMPLATE_PICKUP_5X_LVL_3,  cost = { gold = COST_K*TEMPLATE_BASE_COST_03  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_4,   TEMPLATE_PICKUP_3X_LVL_4,   TEMPLATE_PICKUP_4X_LVL_4,   TEMPLATE_PICKUP_5X_LVL_4,  cost = { gold = COST_K*TEMPLATE_BASE_COST_04  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_5,   TEMPLATE_PICKUP_3X_LVL_5,   TEMPLATE_PICKUP_4X_LVL_5,   TEMPLATE_PICKUP_5X_LVL_5,  cost = { gold = COST_K*TEMPLATE_BASE_COST_05  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_6,   TEMPLATE_PICKUP_3X_LVL_6,   TEMPLATE_PICKUP_4X_LVL_6,   TEMPLATE_PICKUP_5X_LVL_6,  cost = { gold = COST_K*TEMPLATE_BASE_COST_06  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_7,   TEMPLATE_PICKUP_3X_LVL_7,   TEMPLATE_PICKUP_4X_LVL_7,   TEMPLATE_PICKUP_5X_LVL_7,  cost = { gold = COST_K*TEMPLATE_BASE_COST_07  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_8,   TEMPLATE_PICKUP_3X_LVL_8,   TEMPLATE_PICKUP_4X_LVL_8,   TEMPLATE_PICKUP_5X_LVL_8,  cost = { gold = COST_K*TEMPLATE_BASE_COST_08  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_9,   TEMPLATE_PICKUP_3X_LVL_9,   TEMPLATE_PICKUP_4X_LVL_9,   TEMPLATE_PICKUP_5X_LVL_9,  cost = { gold = COST_K*TEMPLATE_BASE_COST_09  },  type = TEMPLATE_PICKUP_2X_LVL_1.type  },
      { TEMPLATE_PICKUP_2X_LVL_10,  TEMPLATE_PICKUP_3X_LVL_10,  TEMPLATE_PICKUP_4X_LVL_10,  TEMPLATE_PICKUP_5X_LVL_10, cost = { gold = COST_K*TEMPLATE_BASE_COST_10  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
      { TEMPLATE_PICKUP_2X_LVL_11,  TEMPLATE_PICKUP_3X_LVL_11,  TEMPLATE_PICKUP_4X_LVL_11,  TEMPLATE_PICKUP_5X_LVL_11, cost = { gold = COST_K*TEMPLATE_BASE_COST_11  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
      { TEMPLATE_PICKUP_2X_LVL_12,  TEMPLATE_PICKUP_3X_LVL_12,  TEMPLATE_PICKUP_4X_LVL_12,  TEMPLATE_PICKUP_5X_LVL_12, cost = { gold = COST_K*TEMPLATE_BASE_COST_12  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
      { TEMPLATE_PICKUP_2X_LVL_13,  TEMPLATE_PICKUP_3X_LVL_13,  TEMPLATE_PICKUP_4X_LVL_13,  TEMPLATE_PICKUP_5X_LVL_13, cost = { gold = COST_K*TEMPLATE_BASE_COST_13  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
      { TEMPLATE_PICKUP_2X_LVL_14,  TEMPLATE_PICKUP_3X_LVL_14,  TEMPLATE_PICKUP_4X_LVL_14,  TEMPLATE_PICKUP_5X_LVL_14, cost = { gold = COST_K*TEMPLATE_BASE_COST_14  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
      { TEMPLATE_PICKUP_2X_LVL_15,  TEMPLATE_PICKUP_3X_LVL_15,  TEMPLATE_PICKUP_4X_LVL_15,  TEMPLATE_PICKUP_5X_LVL_15, cost = { gold = COST_K*TEMPLATE_BASE_COST_15  },  type = TEMPLATE_PICKUP_2X_LVL_1.type },
   }
};