require("app/template/store/cost");
require("app/template/template");
require("game/entity/turret/turret-laser");
require("app/template/player-levels/stats_template");

local DAMAGE_K          = 0.75;
local SIZE_K            = 1.00;
local COST_K            = 12.0*1.5;

-------------

local TEMPLATE_HIT_MARKER_BASE =
{
	texture        = 'resources/Explosion/Lazer_Explosions/LazerCar_Explosion_Yellow.png',
	width          = 32,
	height         = 32,
	growth         = { 10, 10 };
	duration       = 0.5,
	spin           = 360,
	avatarSpeedK   =  0.00,
	blend          = "add",
	--sounds			= {start={"PlayerDeath",},},
}

local TEMPLATE_HIT_MARKER_YELLOW         = Template.extent(TEMPLATE_HIT_MARKER_BASE);
local TEMPLATE_HIT_MARKER_ORANGE         = Template.extent(TEMPLATE_HIT_MARKER_YELLOW);
local TEMPLATE_HIT_MARKER_GREEN          = Template.extent(TEMPLATE_HIT_MARKER_ORANGE);
local TEMPLATE_HIT_MARKER_BLUE           = Template.extent(TEMPLATE_HIT_MARKER_GREEN);
local TEMPLATE_HIT_MARKER_PINK           = Template.extent(TEMPLATE_HIT_MARKER_BLUE);


TEMPLATE_HIT_MARKER_YELLOW["texture"]	= 'resources/Explosion/Lazer_Explosions/LazerCar_Explosion_Yellow.png';
TEMPLATE_HIT_MARKER_ORANGE["texture"]	= 'resources/Explosion/Lazer_Explosions/LazerCar_Explosion_Orange.png';
TEMPLATE_HIT_MARKER_GREEN["texture"]	= 'resources/Explosion/Lazer_Explosions/LazerCar_Explosion_Green.png';
TEMPLATE_HIT_MARKER_BLUE["texture"]		= 'resources/Explosion/Lazer_Explosions/LazerCar_Explosion_Blue.png';
TEMPLATE_HIT_MARKER_PINK["texture"]		= 'resources/Explosion/Lazer_Explosions/LazerCar_Explosion_Pink.png';

-------------

local TEMPLATE_PROJECTILE_LVL_0 =
{
      speed					= { 0, 1250 },
      width             = 84,
      height            = 99,
      collisionWidth    = 40,
      collisionHeight   = 100,
		blend					= "add",
      damage				= DAMAGE_K,
		invicible			= true,
		noHitRepeat			= true,
		--color					= {1,1,1,0},
		hitMarker			= TEMPLATE_HIT_MARKER_LVL_0,
};

local TEMPLATE_PROJECTILE_LVL_1           = Template.extent(TEMPLATE_PROJECTILE_LVL_0);
local TEMPLATE_PROJECTILE_LVL_2           = Template.extent(TEMPLATE_PROJECTILE_LVL_1);
local TEMPLATE_PROJECTILE_LVL_3           = Template.extent(TEMPLATE_PROJECTILE_LVL_2);
local TEMPLATE_PROJECTILE_LVL_4           = Template.extent(TEMPLATE_PROJECTILE_LVL_3);
local TEMPLATE_PROJECTILE_LVL_5           = Template.extent(TEMPLATE_PROJECTILE_LVL_4);
local TEMPLATE_PROJECTILE_LVL_6           = Template.extent(TEMPLATE_PROJECTILE_LVL_5);
local TEMPLATE_PROJECTILE_LVL_7           = Template.extent(TEMPLATE_PROJECTILE_LVL_6);
local TEMPLATE_PROJECTILE_LVL_8           = Template.extent(TEMPLATE_PROJECTILE_LVL_7);
local TEMPLATE_PROJECTILE_LVL_9           = Template.extent(TEMPLATE_PROJECTILE_LVL_8);
local TEMPLATE_PROJECTILE_LVL_10          = Template.extent(TEMPLATE_PROJECTILE_LVL_9);
local TEMPLATE_PROJECTILE_LVL_11          = Template.extent(TEMPLATE_PROJECTILE_LVL_10);
local TEMPLATE_PROJECTILE_LVL_12          = Template.extent(TEMPLATE_PROJECTILE_LVL_11);
local TEMPLATE_PROJECTILE_LVL_13          = Template.extent(TEMPLATE_PROJECTILE_LVL_12);
local TEMPLATE_PROJECTILE_LVL_14          = Template.extent(TEMPLATE_PROJECTILE_LVL_13);
local TEMPLATE_PROJECTILE_LVL_15          = Template.extent(TEMPLATE_PROJECTILE_LVL_14);

TEMPLATE_PROJECTILE_LVL_1["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][1];
TEMPLATE_PROJECTILE_LVL_1["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level01.png';
TEMPLATE_PROJECTILE_LVL_1["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_1["height"]             = SIZE_K*99;
TEMPLATE_PROJECTILE_LVL_1["speed"]              = { 0, 3000 };
TEMPLATE_PROJECTILE_LVL_1["hitMarker"]				= TEMPLATE_HIT_MARKER_YELLOW;
TEMPLATE_PROJECTILE_LVL_2["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][2];
TEMPLATE_PROJECTILE_LVL_2["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level02.png';
TEMPLATE_PROJECTILE_LVL_2["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_2["height"]             = SIZE_K*99;
TEMPLATE_PROJECTILE_LVL_2["hitMarker"]				= TEMPLATE_HIT_MARKER_ORANGE;
TEMPLATE_PROJECTILE_LVL_3["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][3];
TEMPLATE_PROJECTILE_LVL_3["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level03.png';
TEMPLATE_PROJECTILE_LVL_3["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_3["height"]             = SIZE_K*99;
TEMPLATE_PROJECTILE_LVL_3["hitMarker"]				= TEMPLATE_HIT_MARKER_GREEN;
TEMPLATE_PROJECTILE_LVL_4["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][4];
TEMPLATE_PROJECTILE_LVL_4["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level04.png';
TEMPLATE_PROJECTILE_LVL_4["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_4["height"]             = SIZE_K*99;
TEMPLATE_PROJECTILE_LVL_4["speed"]              = { 0, 3000 };
TEMPLATE_PROJECTILE_LVL_4["hitMarker"]				= TEMPLATE_HIT_MARKER_BLUE;
TEMPLATE_PROJECTILE_LVL_5["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][5];
TEMPLATE_PROJECTILE_LVL_5["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level05.png';
TEMPLATE_PROJECTILE_LVL_5["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_5["height"]             = SIZE_K*99;
TEMPLATE_PROJECTILE_LVL_5["hitMarker"]				= TEMPLATE_HIT_MARKER_PINK;
TEMPLATE_PROJECTILE_LVL_6["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][6];
TEMPLATE_PROJECTILE_LVL_6["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level06.png';
TEMPLATE_PROJECTILE_LVL_6["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_6["height"]             = SIZE_K*113;
TEMPLATE_PROJECTILE_LVL_6["hitMarker"]				= TEMPLATE_HIT_MARKER_YELLOW;
TEMPLATE_PROJECTILE_LVL_7["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][7];
TEMPLATE_PROJECTILE_LVL_7["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level07.png';
TEMPLATE_PROJECTILE_LVL_7["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_7["height"]             = SIZE_K*113;
TEMPLATE_PROJECTILE_LVL_7["speed"]              = { 0, 3000 };
TEMPLATE_PROJECTILE_LVL_7["hitMarker"]				= TEMPLATE_HIT_MARKER_ORANGE;
TEMPLATE_PROJECTILE_LVL_8["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][8];
TEMPLATE_PROJECTILE_LVL_8["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level08.png';
TEMPLATE_PROJECTILE_LVL_8["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_8["height"]             = SIZE_K*113;
TEMPLATE_PROJECTILE_LVL_8["hitMarker"]				= TEMPLATE_HIT_MARKER_GREEN;
TEMPLATE_PROJECTILE_LVL_9["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][9];
TEMPLATE_PROJECTILE_LVL_9["texture"]            = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level09.png';
TEMPLATE_PROJECTILE_LVL_9["width"]              = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_9["height"]             = SIZE_K*113;
TEMPLATE_PROJECTILE_LVL_9["hitMarker"]				= TEMPLATE_HIT_MARKER_BLUE;
TEMPLATE_PROJECTILE_LVL_10["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][10];
TEMPLATE_PROJECTILE_LVL_10["texture"]           = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level10.png';
TEMPLATE_PROJECTILE_LVL_10["width"]             = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_10["height"]            = SIZE_K*113;
TEMPLATE_PROJECTILE_LVL_10["speed"]             = { 0, 3000 };
TEMPLATE_PROJECTILE_LVL_10["hitMarker"]			= TEMPLATE_HIT_MARKER_PINK;
TEMPLATE_PROJECTILE_LVL_11["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][11];
TEMPLATE_PROJECTILE_LVL_11["texture"]           = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level11.png';
TEMPLATE_PROJECTILE_LVL_11["width"]             = SIZE_K*93;
TEMPLATE_PROJECTILE_LVL_11["height"]            = SIZE_K*119;
TEMPLATE_PROJECTILE_LVL_11["hitMarker"]			= TEMPLATE_HIT_MARKER_YELLOW;
TEMPLATE_PROJECTILE_LVL_12["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][12];
TEMPLATE_PROJECTILE_LVL_12["texture"]           = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level12.png';
TEMPLATE_PROJECTILE_LVL_12["width"]             = SIZE_K*93;
TEMPLATE_PROJECTILE_LVL_12["height"]            = SIZE_K*119;
TEMPLATE_PROJECTILE_LVL_12["hitMarker"]			= TEMPLATE_HIT_MARKER_ORANGE;
TEMPLATE_PROJECTILE_LVL_13["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][13];
TEMPLATE_PROJECTILE_LVL_13["texture"]           = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level13.png';
TEMPLATE_PROJECTILE_LVL_13["width"]             = SIZE_K*93;
TEMPLATE_PROJECTILE_LVL_13["height"]            = SIZE_K*119;
TEMPLATE_PROJECTILE_LVL_13["speed"]             = { 0, 3000 };
TEMPLATE_PROJECTILE_LVL_13["hitMarker"]			= TEMPLATE_HIT_MARKER_GREEN;
TEMPLATE_PROJECTILE_LVL_14["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][14];
TEMPLATE_PROJECTILE_LVL_14["texture"]           = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level14.png';
TEMPLATE_PROJECTILE_LVL_14["width"]             = SIZE_K*93;
TEMPLATE_PROJECTILE_LVL_14["height"]            = SIZE_K*119;
TEMPLATE_PROJECTILE_LVL_14["hitMarker"]			= TEMPLATE_HIT_MARKER_BLUE;
TEMPLATE_PROJECTILE_LVL_15["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["lasercar_2"][15];
TEMPLATE_PROJECTILE_LVL_15["texture"]           = 'resources/Vehicle/BulletEffects/Lazer_Bolts/LazerCar_Bolt_Level15.png';
TEMPLATE_PROJECTILE_LVL_15["width"]             = SIZE_K*93;
TEMPLATE_PROJECTILE_LVL_15["height"]            = SIZE_K*119;
TEMPLATE_PROJECTILE_LVL_15["hitMarker"]			= TEMPLATE_HIT_MARKER_PINK;

-------------

local TEMPLATE_BEAM_BASE =
{
	layer			= 4,
	texture		= "resources/Vehicle/PlayerVehicle_LazerCarV2/Lazercar_Beam_Yellow.png",
	width			= 16,
	height		= 1136*2,
	--blend       = "add",
}

local TEMPLATE_BEAM_YELLOW         = Template.extent(TEMPLATE_BEAM_BASE);
local TEMPLATE_BEAM_ORANGE         = Template.extent(TEMPLATE_BEAM_YELLOW);
local TEMPLATE_BEAM_GREEN          = Template.extent(TEMPLATE_BEAM_ORANGE);
local TEMPLATE_BEAM_BLUE           = Template.extent(TEMPLATE_BEAM_GREEN);
local TEMPLATE_BEAM_VIOLET         = Template.extent(TEMPLATE_BEAM_BLUE);


TEMPLATE_BEAM_YELLOW["texture"]	= 'resources/Vehicle/PlayerVehicle_LazerCarV2/Lazercar_Beam_Yellow.png';
TEMPLATE_BEAM_ORANGE["texture"]	= 'resources/Vehicle/PlayerVehicle_LazerCarV2/Lazercar_Beam_Orange.png';
TEMPLATE_BEAM_GREEN["texture"]	= 'resources/Vehicle/PlayerVehicle_LazerCarV2/Lazercar_Beam_Green.png';
TEMPLATE_BEAM_BLUE["texture"]		= 'resources/Vehicle/PlayerVehicle_LazerCarV2/Lazercar_Beam_Blue.png';
TEMPLATE_BEAM_VIOLET["texture"]	= 'resources/Vehicle/PlayerVehicle_LazerCarV2/Lazercar_Beam_Violet.png';

-------------

local TEMPLATE_PLAYER_TURRET_1_LVL_0 =
{
   factory        = TurretLaser;
	layer				= 4;
   texture        = "resources/Vehicle/Turret_Weapons/Turret_Lazer.png",
   width          = 128,
   height         = 128,
   pivot          = { 0, 68/2-44 },
	maxTurnRate		= 21,
   collisionWidth = 0,
   collisionHeight= 0,
	alwaysShoot		= true;
   shootDelay     = 0,
   bulletCount    = 10,
   bulletDelay    = 3/30,
   projectile     = TEMPLATE_PLAYER_TURRET_1_BULLET_LVL_0,
	parentProj		= true;
	projOffset		= {x=0,	y=48,	angle=0},
	sweepTime		= 2.0;
	sweepArc			= 60;
	type				= "bullet",
	
	beamCooldown	= 1.0;
	beamPulseFreq	= 1.0;
	beamPulseWidth = 0.4;
	beamPulseAlpha	= 0.6;
	
	beamVFX			= TEMPLATE_BEAM_YELLOW,
};

local TEMPLATE_PLAYER_TURRET_1_LVL_1    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_0);
local TEMPLATE_PLAYER_TURRET_1_LVL_2    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_1);
local TEMPLATE_PLAYER_TURRET_1_LVL_3    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_2);
local TEMPLATE_PLAYER_TURRET_1_LVL_4    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_3);
local TEMPLATE_PLAYER_TURRET_1_LVL_5    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_4);
local TEMPLATE_PLAYER_TURRET_1_LVL_6    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_5);
local TEMPLATE_PLAYER_TURRET_1_LVL_7    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_6);
local TEMPLATE_PLAYER_TURRET_1_LVL_8    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_7);
local TEMPLATE_PLAYER_TURRET_1_LVL_9    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_8);
local TEMPLATE_PLAYER_TURRET_1_LVL_10   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_9);
local TEMPLATE_PLAYER_TURRET_1_LVL_11   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_10);
local TEMPLATE_PLAYER_TURRET_1_LVL_12   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_11);
local TEMPLATE_PLAYER_TURRET_1_LVL_13   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_12);
local TEMPLATE_PLAYER_TURRET_1_LVL_14   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_13);
local TEMPLATE_PLAYER_TURRET_1_LVL_15   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_14);

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_1["cost"]                     = LASERCAR_MK2_UNLOCK_TURRET_COST;
TEMPLATE_PLAYER_TURRET_1_LVL_1["beamVFX"]						  = TEMPLATE_BEAM_YELLOW;
TEMPLATE_PLAYER_TURRET_1_LVL_1["projectile"]               = TEMPLATE_PROJECTILE_LVL_1;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_2["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_02 };
TEMPLATE_PLAYER_TURRET_1_LVL_2["beamVFX"]						  = TEMPLATE_BEAM_ORANGE;
TEMPLATE_PLAYER_TURRET_1_LVL_2["projectile"]               = TEMPLATE_PROJECTILE_LVL_2;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_3["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_03 };
TEMPLATE_PLAYER_TURRET_1_LVL_3["beamVFX"]						  = TEMPLATE_BEAM_GREEN;
TEMPLATE_PLAYER_TURRET_1_LVL_3["projectile"]               = TEMPLATE_PROJECTILE_LVL_3;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_4["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_04 };
TEMPLATE_PLAYER_TURRET_1_LVL_4["beamVFX"]						  = TEMPLATE_BEAM_BLUE;
TEMPLATE_PLAYER_TURRET_1_LVL_4["projectile"]               = TEMPLATE_PROJECTILE_LVL_4;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_5["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_05 };
TEMPLATE_PLAYER_TURRET_1_LVL_5["beamVFX"]						  = TEMPLATE_BEAM_VIOLET;
TEMPLATE_PLAYER_TURRET_1_LVL_5["projectile"]               = TEMPLATE_PROJECTILE_LVL_5;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_6["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_06 };
TEMPLATE_PLAYER_TURRET_1_LVL_6["beamVFX"]						  = TEMPLATE_BEAM_YELLOW;
TEMPLATE_PLAYER_TURRET_1_LVL_6["projectile"]               = TEMPLATE_PROJECTILE_LVL_6;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_7["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_07 };
TEMPLATE_PLAYER_TURRET_1_LVL_7["beamVFX"]						  = TEMPLATE_BEAM_ORANGE;
TEMPLATE_PLAYER_TURRET_1_LVL_7["projectile"]               = TEMPLATE_PROJECTILE_LVL_7;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_8["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_08 };
TEMPLATE_PLAYER_TURRET_1_LVL_8["beamVFX"]						  = TEMPLATE_BEAM_GREEN;
TEMPLATE_PLAYER_TURRET_1_LVL_8["projectile"]               = TEMPLATE_PROJECTILE_LVL_8;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_9["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_09 };
TEMPLATE_PLAYER_TURRET_1_LVL_9["beamVFX"]						  = TEMPLATE_BEAM_BLUE;
TEMPLATE_PLAYER_TURRET_1_LVL_9["projectile"]               = TEMPLATE_PROJECTILE_LVL_9;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_10["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_10 };
TEMPLATE_PLAYER_TURRET_1_LVL_10["beamVFX"]						= TEMPLATE_BEAM_VIOLET;
TEMPLATE_PLAYER_TURRET_1_LVL_10["projectile"]               = TEMPLATE_PROJECTILE_LVL_10;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_11["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_11 };
TEMPLATE_PLAYER_TURRET_1_LVL_11["beamVFX"]						= TEMPLATE_BEAM_YELLOW;
TEMPLATE_PLAYER_TURRET_1_LVL_11["projectile"]               = TEMPLATE_PROJECTILE_LVL_11;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_12["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_12 };
TEMPLATE_PLAYER_TURRET_1_LVL_12["beamVFX"]						= TEMPLATE_BEAM_ORANGE;
TEMPLATE_PLAYER_TURRET_1_LVL_12["projectile"]               = TEMPLATE_PROJECTILE_LVL_12;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_13["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_13 };
TEMPLATE_PLAYER_TURRET_1_LVL_13["beamVFX"]						= TEMPLATE_BEAM_GREEN;
TEMPLATE_PLAYER_TURRET_1_LVL_13["projectile"]               = TEMPLATE_PROJECTILE_LVL_13;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_14["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_14 };
TEMPLATE_PLAYER_TURRET_1_LVL_14["beamVFX"]						= TEMPLATE_BEAM_BLUE;
TEMPLATE_PLAYER_TURRET_1_LVL_14["projectile"]               = TEMPLATE_PROJECTILE_LVL_14;

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_15["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_15 };
TEMPLATE_PLAYER_TURRET_1_LVL_15["beamVFX"]						= TEMPLATE_BEAM_VIOLET;
TEMPLATE_PLAYER_TURRET_1_LVL_15["projectile"]               = TEMPLATE_PROJECTILE_LVL_15;

-------------


TEMPLATE_PLAYER_VEHICLE_LASERCAR_MK2_TURRET =
{
   version = 3;

   level =
   {
      TEMPLATE_PLAYER_TURRET_1_LVL_1,
      TEMPLATE_PLAYER_TURRET_1_LVL_2,
      TEMPLATE_PLAYER_TURRET_1_LVL_3,
      TEMPLATE_PLAYER_TURRET_1_LVL_4,
      TEMPLATE_PLAYER_TURRET_1_LVL_5,
      TEMPLATE_PLAYER_TURRET_1_LVL_6,
      TEMPLATE_PLAYER_TURRET_1_LVL_7,
      TEMPLATE_PLAYER_TURRET_1_LVL_8,
      TEMPLATE_PLAYER_TURRET_1_LVL_9,
      TEMPLATE_PLAYER_TURRET_1_LVL_10,
      TEMPLATE_PLAYER_TURRET_1_LVL_11,
      TEMPLATE_PLAYER_TURRET_1_LVL_12,
      TEMPLATE_PLAYER_TURRET_1_LVL_13,
      TEMPLATE_PLAYER_TURRET_1_LVL_14,
      TEMPLATE_PLAYER_TURRET_1_LVL_15,
   }
};