require("app/template/store/cost");
require("app/template/template");
require("game/entity/projectile/rocket");
require("game/entity/turret/turret-shoot");
require("app/template/player-levels/stats_template");

local DAMAGE_K          = 6;
local SIZE_K            = 0.85;
local COST_K            = 10.0*1.5;

local TEMPLATE_PROJECTILE_LVL_0 =
{
   factory           = Rocket,
   layer             = 6,
   accel             = { 0, 3000 },
   speed             = { 0, 300  },
   homing            = true,
   overrideTarget    = true,
   width             = 60,
   height            = 120,
   collisionWidth    = SIZE_K*64,
   collisionHeight   = SIZE_K*128,
   damage            = DAMAGE_K*1,
   maxTurnRate       =  90,
   turnDelay         = 0.00,
   accelDelay        = 0.10,
   fire                 =
   {
      layer             = 5,
      texture           = "resources/Vehicle/MissileEffects/MissileCar_Fire.png",
      offset            = { 0, -60 },
      width             = 10*1.25,
      height            = 28*1.25,
      --     loop              = true,
   },
   explosion         =
   {
      texture        = "resources/Explosion/Explosion_04.png",
      width          = 50,
      height         = 50,
      avatarSpeedK   = 0.00,
      growth         = { 15.0, 15.0 },
      growthRnd      = { 0 ,0 },
      maxDamageRadius= 2000,
      duration       = 0.30,
      fadeStart      = 0.20,
      spin           = -180,
      spinRnd        =  360,
      color          = { 1, 0.8, 0.8, 0.85 },
      colorRnd       = { 0, 0.2, 0.2, 0.0 },
      damage         =
      {
         start       = 0,
         stop        = 0.10,
         vehicleVal  = 0,
         avatarVal   = 0,
      }
   },
};



local TEMPLATE_PROJECTILE_LVL_1           = Template.extent(TEMPLATE_PROJECTILE_LVL_0);
local TEMPLATE_PROJECTILE_LVL_2           = Template.extent(TEMPLATE_PROJECTILE_LVL_1);
local TEMPLATE_PROJECTILE_LVL_3           = Template.extent(TEMPLATE_PROJECTILE_LVL_2);
local TEMPLATE_PROJECTILE_LVL_4           = Template.extent(TEMPLATE_PROJECTILE_LVL_3);
local TEMPLATE_PROJECTILE_LVL_5           = Template.extent(TEMPLATE_PROJECTILE_LVL_4);
local TEMPLATE_PROJECTILE_LVL_6           = Template.extent(TEMPLATE_PROJECTILE_LVL_5);
local TEMPLATE_PROJECTILE_LVL_7           = Template.extent(TEMPLATE_PROJECTILE_LVL_6);
local TEMPLATE_PROJECTILE_LVL_8           = Template.extent(TEMPLATE_PROJECTILE_LVL_7);
local TEMPLATE_PROJECTILE_LVL_9           = Template.extent(TEMPLATE_PROJECTILE_LVL_8);
local TEMPLATE_PROJECTILE_LVL_10          = Template.extent(TEMPLATE_PROJECTILE_LVL_9);
local TEMPLATE_PROJECTILE_LVL_11          = Template.extent(TEMPLATE_PROJECTILE_LVL_10);
local TEMPLATE_PROJECTILE_LVL_12          = Template.extent(TEMPLATE_PROJECTILE_LVL_11);
local TEMPLATE_PROJECTILE_LVL_13          = Template.extent(TEMPLATE_PROJECTILE_LVL_12);
local TEMPLATE_PROJECTILE_LVL_14          = Template.extent(TEMPLATE_PROJECTILE_LVL_13);
local TEMPLATE_PROJECTILE_LVL_15          = Template.extent(TEMPLATE_PROJECTILE_LVL_14);

TEMPLATE_PROJECTILE_LVL_1["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][1];
TEMPLATE_PROJECTILE_LVL_1["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level01.png';
TEMPLATE_PROJECTILE_LVL_1["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_1["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_2["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][2];
TEMPLATE_PROJECTILE_LVL_2["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level02.png';
TEMPLATE_PROJECTILE_LVL_2["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_2["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_3["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][3];
TEMPLATE_PROJECTILE_LVL_3["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level03.png';
TEMPLATE_PROJECTILE_LVL_3["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_3["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_4["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][4];
TEMPLATE_PROJECTILE_LVL_4["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level04.png';
TEMPLATE_PROJECTILE_LVL_4["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_4["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_5["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][5];
TEMPLATE_PROJECTILE_LVL_5["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level05.png';
TEMPLATE_PROJECTILE_LVL_5["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_5["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_6["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][6];
TEMPLATE_PROJECTILE_LVL_6["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level06.png';
TEMPLATE_PROJECTILE_LVL_6["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_6["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_7["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][7];
TEMPLATE_PROJECTILE_LVL_7["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level07.png';
TEMPLATE_PROJECTILE_LVL_7["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_7["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_8["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][8];
TEMPLATE_PROJECTILE_LVL_8["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level08.png';
TEMPLATE_PROJECTILE_LVL_8["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_8["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_9["damage"]       = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][9];
TEMPLATE_PROJECTILE_LVL_9["texture"]      = 'resources/Vehicle/MissileEffects/Missile_Level09.png';
TEMPLATE_PROJECTILE_LVL_9["width"]        = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_9["height"]       = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_10["damage"]      = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][10];
TEMPLATE_PROJECTILE_LVL_10["texture"]     = 'resources/Vehicle/MissileEffects/Missile_Level10.png';
TEMPLATE_PROJECTILE_LVL_10["width"]       = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_10["height"]      = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_11["damage"]      = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][11];
TEMPLATE_PROJECTILE_LVL_11["texture"]     = 'resources/Vehicle/MissileEffects/Missile_Level11.png';
TEMPLATE_PROJECTILE_LVL_11["width"]       = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_11["height"]      = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_12["damage"]      = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][12];
TEMPLATE_PROJECTILE_LVL_12["texture"]     = 'resources/Vehicle/MissileEffects/Missile_Level12.png';
TEMPLATE_PROJECTILE_LVL_12["width"]       = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_12["height"]      = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_13["damage"]      = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][13];
TEMPLATE_PROJECTILE_LVL_13["texture"]     = 'resources/Vehicle/MissileEffects/Missile_Level13.png';
TEMPLATE_PROJECTILE_LVL_13["width"]       = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_13["height"]      = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_14["damage"]      = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][14];
TEMPLATE_PROJECTILE_LVL_14["texture"]     = 'resources/Vehicle/MissileEffects/Missile_Level14.png';
TEMPLATE_PROJECTILE_LVL_14["width"]       = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_14["height"]      = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_15["damage"]      = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["missilecar_2"][15];
TEMPLATE_PROJECTILE_LVL_15["texture"]     = 'resources/Vehicle/MissileEffects/Missile_Level15.png';
TEMPLATE_PROJECTILE_LVL_15["width"]       = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_15["height"]      = SIZE_K*128;


local TEMPLATE_PLAYER_TURRET_1_LVL_0 =
{
   factory        = TurretShoot;
   texture        = "resources/Vehicle/Turret_Weapons/Turret_Missiles.png",
   width          = 80,
   height         = 86,
   pivot          = { 0, 68/2-44 },
   collisionWidth = 0,
   collisionHeight= 0,
   maxTurnRate    = 0,
   shootDelay     = 0.75,
   bulletCount    = 2,
   bulletDelay    = 0/30,
   bulletDelta    = { { x=-30, y=-40}, {x=30, y=-40} },
   projectile     = TEMPLATE_PLAYER_TURRET_1_BULLET_LVL_0,
	type				= "bullet",
};

local TEMPLATE_PLAYER_TURRET_1_LVL_1    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_0);
local TEMPLATE_PLAYER_TURRET_1_LVL_2    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_1);
local TEMPLATE_PLAYER_TURRET_1_LVL_3    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_2);
local TEMPLATE_PLAYER_TURRET_1_LVL_4    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_3);
local TEMPLATE_PLAYER_TURRET_1_LVL_5    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_4);
local TEMPLATE_PLAYER_TURRET_1_LVL_6    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_5);
local TEMPLATE_PLAYER_TURRET_1_LVL_7    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_6);
local TEMPLATE_PLAYER_TURRET_1_LVL_8    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_7);
local TEMPLATE_PLAYER_TURRET_1_LVL_9    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_8);
local TEMPLATE_PLAYER_TURRET_1_LVL_10   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_9);
local TEMPLATE_PLAYER_TURRET_1_LVL_11   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_10);
local TEMPLATE_PLAYER_TURRET_1_LVL_12   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_11);
local TEMPLATE_PLAYER_TURRET_1_LVL_13   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_12);
local TEMPLATE_PLAYER_TURRET_1_LVL_14   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_13);
local TEMPLATE_PLAYER_TURRET_1_LVL_15   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_14);

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_1["cost"]                     = MISSILECAR_MK2_UNLOCK_TURRET_COST;
TEMPLATE_PLAYER_TURRET_1_LVL_1["projectile"]               = TEMPLATE_PROJECTILE_LVL_1;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_2["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_02 };
TEMPLATE_PLAYER_TURRET_1_LVL_2["projectile"]               = TEMPLATE_PROJECTILE_LVL_2;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_3["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_03 };
TEMPLATE_PLAYER_TURRET_1_LVL_3["projectile"]               = TEMPLATE_PROJECTILE_LVL_3;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_4["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_04 };
TEMPLATE_PLAYER_TURRET_1_LVL_4["projectile"]               = TEMPLATE_PROJECTILE_LVL_4;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_5["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_05 };
TEMPLATE_PLAYER_TURRET_1_LVL_5["projectile"]               = TEMPLATE_PROJECTILE_LVL_5;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_6["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_06 };
TEMPLATE_PLAYER_TURRET_1_LVL_6["projectile"]               = TEMPLATE_PROJECTILE_LVL_6;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_7["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_07 };
TEMPLATE_PLAYER_TURRET_1_LVL_7["projectile"]               = TEMPLATE_PROJECTILE_LVL_7;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_8["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_08 };
TEMPLATE_PLAYER_TURRET_1_LVL_8["projectile"]               = TEMPLATE_PROJECTILE_LVL_8;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_9["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_09 };
TEMPLATE_PLAYER_TURRET_1_LVL_9["projectile"]               = TEMPLATE_PROJECTILE_LVL_9;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_10["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_10 };
TEMPLATE_PLAYER_TURRET_1_LVL_10["projectile"]               = TEMPLATE_PROJECTILE_LVL_10;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_11["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_11 };
TEMPLATE_PLAYER_TURRET_1_LVL_11["projectile"]               = TEMPLATE_PROJECTILE_LVL_11;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_12["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_12 };
TEMPLATE_PLAYER_TURRET_1_LVL_12["projectile"]               = TEMPLATE_PROJECTILE_LVL_12;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_13["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_13 };
TEMPLATE_PLAYER_TURRET_1_LVL_13["projectile"]               = TEMPLATE_PROJECTILE_LVL_13;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_14["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_14 };
TEMPLATE_PLAYER_TURRET_1_LVL_14["projectile"]               = TEMPLATE_PROJECTILE_LVL_14;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_15["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_15 };
TEMPLATE_PLAYER_TURRET_1_LVL_15["projectile"]               = TEMPLATE_PROJECTILE_LVL_15;
-------------



TEMPLATE_PLAYER_VEHICLE_MISSILECAR_MK2_TURRET =
{
   version = 3;
   
   level =
   {
      TEMPLATE_PLAYER_TURRET_1_LVL_1,
      TEMPLATE_PLAYER_TURRET_1_LVL_2,
      TEMPLATE_PLAYER_TURRET_1_LVL_3,
      TEMPLATE_PLAYER_TURRET_1_LVL_4,
      TEMPLATE_PLAYER_TURRET_1_LVL_5,
      TEMPLATE_PLAYER_TURRET_1_LVL_6,
      TEMPLATE_PLAYER_TURRET_1_LVL_7,
      TEMPLATE_PLAYER_TURRET_1_LVL_8,
      TEMPLATE_PLAYER_TURRET_1_LVL_9,
      TEMPLATE_PLAYER_TURRET_1_LVL_10,
      TEMPLATE_PLAYER_TURRET_1_LVL_11,
      TEMPLATE_PLAYER_TURRET_1_LVL_12,
      TEMPLATE_PLAYER_TURRET_1_LVL_13,
      TEMPLATE_PLAYER_TURRET_1_LVL_14,
      TEMPLATE_PLAYER_TURRET_1_LVL_15,
   }
};