require("app/template/store/cost");
require("app/template/template");
require("game/entity/turret/turret-nova");
require("app/template/player-levels/stats_template");

local DAMAGE_K          = 15.00;
local SIZE_K            = 2.00;
local COST_K            = 15.0*1.5;

local TEMPLATE_PROJECTILE_LVL_0 = 
{
      layer = 7,
      speed             = { 0, 1500 },
      width             = 40,
      height            = 60,
      collisionWidth    = 40,
      collisionHeight   = 60,
		scaleRate         = { 10, 10 },
		blend             = "add",
      damage            = DAMAGE_K*1,
		invicible         = true,
		noHitRepeat       = true,
		--blend           = "add",
};

local TEMPLATE_PROJECTILE_LVL_1           = Template.extent(TEMPLATE_PROJECTILE_LVL_0);
local TEMPLATE_PROJECTILE_LVL_2           = Template.extent(TEMPLATE_PROJECTILE_LVL_1);
local TEMPLATE_PROJECTILE_LVL_3           = Template.extent(TEMPLATE_PROJECTILE_LVL_2);
local TEMPLATE_PROJECTILE_LVL_4           = Template.extent(TEMPLATE_PROJECTILE_LVL_3);
local TEMPLATE_PROJECTILE_LVL_5           = Template.extent(TEMPLATE_PROJECTILE_LVL_4);
local TEMPLATE_PROJECTILE_LVL_6           = Template.extent(TEMPLATE_PROJECTILE_LVL_5);
local TEMPLATE_PROJECTILE_LVL_7           = Template.extent(TEMPLATE_PROJECTILE_LVL_6);
local TEMPLATE_PROJECTILE_LVL_8           = Template.extent(TEMPLATE_PROJECTILE_LVL_7);
local TEMPLATE_PROJECTILE_LVL_9           = Template.extent(TEMPLATE_PROJECTILE_LVL_8);
local TEMPLATE_PROJECTILE_LVL_10          = Template.extent(TEMPLATE_PROJECTILE_LVL_9);
local TEMPLATE_PROJECTILE_LVL_11          = Template.extent(TEMPLATE_PROJECTILE_LVL_10);
local TEMPLATE_PROJECTILE_LVL_12          = Template.extent(TEMPLATE_PROJECTILE_LVL_11);
local TEMPLATE_PROJECTILE_LVL_13          = Template.extent(TEMPLATE_PROJECTILE_LVL_12);
local TEMPLATE_PROJECTILE_LVL_14          = Template.extent(TEMPLATE_PROJECTILE_LVL_13);
local TEMPLATE_PROJECTILE_LVL_15          = Template.extent(TEMPLATE_PROJECTILE_LVL_14);

TEMPLATE_PROJECTILE_LVL_1["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][1];
TEMPLATE_PROJECTILE_LVL_1["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level01.png';
TEMPLATE_PROJECTILE_LVL_1["width"]              = SIZE_K*36;
TEMPLATE_PROJECTILE_LVL_1["height"]             = SIZE_K*60;
TEMPLATE_PROJECTILE_LVL_1["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_1["collisionWidth"]     = SIZE_K*18;
TEMPLATE_PROJECTILE_LVL_1["collisionHeight"]    = SIZE_K*60;
-------------
TEMPLATE_PROJECTILE_LVL_2["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][2];
TEMPLATE_PROJECTILE_LVL_2["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level02.png';
TEMPLATE_PROJECTILE_LVL_2["width"]              = SIZE_K*38;
TEMPLATE_PROJECTILE_LVL_2["height"]             = SIZE_K*61;
TEMPLATE_PROJECTILE_LVL_2["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_2["collisionWidth"]     = SIZE_K*19;
TEMPLATE_PROJECTILE_LVL_2["collisionHeight"]    = SIZE_K*61;
-------------
TEMPLATE_PROJECTILE_LVL_3["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][3];
TEMPLATE_PROJECTILE_LVL_3["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level03.png';
TEMPLATE_PROJECTILE_LVL_3["width"]              = SIZE_K*40;
TEMPLATE_PROJECTILE_LVL_3["height"]             = SIZE_K*62;
TEMPLATE_PROJECTILE_LVL_3["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_3["collisionWidth"]     = SIZE_K*20;
TEMPLATE_PROJECTILE_LVL_3["collisionHeight"]    = SIZE_K*62;
-------------
TEMPLATE_PROJECTILE_LVL_4["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][4];
TEMPLATE_PROJECTILE_LVL_4["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level04.png';
TEMPLATE_PROJECTILE_LVL_4["width"]              = SIZE_K*42;
TEMPLATE_PROJECTILE_LVL_4["height"]             = SIZE_K*63;
TEMPLATE_PROJECTILE_LVL_4["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_4["collisionWidth"]     = SIZE_K*21;
TEMPLATE_PROJECTILE_LVL_4["collisionHeight"]    = SIZE_K*63;
-------------
TEMPLATE_PROJECTILE_LVL_5["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][5];
TEMPLATE_PROJECTILE_LVL_5["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level05.png';
TEMPLATE_PROJECTILE_LVL_5["width"]              = SIZE_K*44;
TEMPLATE_PROJECTILE_LVL_5["height"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_5["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_5["collisionWidth"]     = SIZE_K*22;
TEMPLATE_PROJECTILE_LVL_5["collisionHeight"]    = SIZE_K*64;
-------------
TEMPLATE_PROJECTILE_LVL_6["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][6];
TEMPLATE_PROJECTILE_LVL_6["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level06.png';
TEMPLATE_PROJECTILE_LVL_6["width"]              = SIZE_K*46;
TEMPLATE_PROJECTILE_LVL_6["height"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_6["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_6["collisionWidth"]     = SIZE_K*30;
TEMPLATE_PROJECTILE_LVL_6["collisionHeight"]    = SIZE_K*64;
-------------
TEMPLATE_PROJECTILE_LVL_7["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][7];
TEMPLATE_PROJECTILE_LVL_7["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level07.png';
TEMPLATE_PROJECTILE_LVL_7["width"]              = SIZE_K*49;
TEMPLATE_PROJECTILE_LVL_7["height"]             = SIZE_K*66;
TEMPLATE_PROJECTILE_LVL_7["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_7["collisionWidth"]     = SIZE_K*32;
TEMPLATE_PROJECTILE_LVL_7["collisionHeight"]    = SIZE_K*66;
-------------
TEMPLATE_PROJECTILE_LVL_8["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][8];
TEMPLATE_PROJECTILE_LVL_8["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level08.png';
TEMPLATE_PROJECTILE_LVL_8["width"]              = SIZE_K*52;
TEMPLATE_PROJECTILE_LVL_8["height"]             = SIZE_K*68;
TEMPLATE_PROJECTILE_LVL_8["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_8["collisionWidth"]     = SIZE_K*34;
TEMPLATE_PROJECTILE_LVL_8["collisionHeight"]    = SIZE_K*68;
-------------
TEMPLATE_PROJECTILE_LVL_9["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][9];
TEMPLATE_PROJECTILE_LVL_9["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level09.png';
TEMPLATE_PROJECTILE_LVL_9["width"]              = SIZE_K*55;
TEMPLATE_PROJECTILE_LVL_9["height"]             = SIZE_K*70;
TEMPLATE_PROJECTILE_LVL_9["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_9["collisionWidth"]     = SIZE_K*36;
TEMPLATE_PROJECTILE_LVL_9["collisionHeight"]    = SIZE_K*70;
-------------
TEMPLATE_PROJECTILE_LVL_10["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][10];
TEMPLATE_PROJECTILE_LVL_10["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level10.png';
TEMPLATE_PROJECTILE_LVL_10["width"]              = SIZE_K*58;
TEMPLATE_PROJECTILE_LVL_10["height"]             = SIZE_K*72;
TEMPLATE_PROJECTILE_LVL_10["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_10["collisionWidth"]     = SIZE_K*38;
TEMPLATE_PROJECTILE_LVL_10["collisionHeight"]    = SIZE_K*72;
-------------
TEMPLATE_PROJECTILE_LVL_11["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][11];
TEMPLATE_PROJECTILE_LVL_11["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level11.png';
TEMPLATE_PROJECTILE_LVL_11["width"]              = SIZE_K*61;
TEMPLATE_PROJECTILE_LVL_11["height"]             = SIZE_K*72;
TEMPLATE_PROJECTILE_LVL_11["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_11["collisionWidth"]     = SIZE_K*45;
TEMPLATE_PROJECTILE_LVL_11["collisionHeight"]    = SIZE_K*72;
-------------
TEMPLATE_PROJECTILE_LVL_12["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][12];
TEMPLATE_PROJECTILE_LVL_12["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level12.png';
TEMPLATE_PROJECTILE_LVL_12["width"]              = SIZE_K*65;
TEMPLATE_PROJECTILE_LVL_12["height"]             = SIZE_K*75;
TEMPLATE_PROJECTILE_LVL_12["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_12["collisionWidth"]     = SIZE_K*48;
TEMPLATE_PROJECTILE_LVL_12["collisionHeight"]    = SIZE_K*75;
-------------
TEMPLATE_PROJECTILE_LVL_13["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][13];
TEMPLATE_PROJECTILE_LVL_13["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level13.png';
TEMPLATE_PROJECTILE_LVL_13["width"]              = SIZE_K*69;
TEMPLATE_PROJECTILE_LVL_13["height"]             = SIZE_K*78;
TEMPLATE_PROJECTILE_LVL_13["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_13["collisionWidth"]     = SIZE_K*51;
TEMPLATE_PROJECTILE_LVL_13["collisionHeight"]    = SIZE_K*78;
-------------
TEMPLATE_PROJECTILE_LVL_14["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][14];
TEMPLATE_PROJECTILE_LVL_14["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level14.png';
TEMPLATE_PROJECTILE_LVL_14["width"]              = SIZE_K*73;
TEMPLATE_PROJECTILE_LVL_14["height"]             = SIZE_K*81;
TEMPLATE_PROJECTILE_LVL_14["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_14["collisionWidth"]     = SIZE_K*54;
TEMPLATE_PROJECTILE_LVL_14["collisionHeight"]    = SIZE_K*81;
-------------
TEMPLATE_PROJECTILE_LVL_15["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar_2"][15];
TEMPLATE_PROJECTILE_LVL_15["texture"]            = 'resources/Vehicle/BulletEffects/Blast_Bolts/Blastcar_Arc_Level15.png';
TEMPLATE_PROJECTILE_LVL_15["width"]              = SIZE_K*77;
TEMPLATE_PROJECTILE_LVL_15["height"]             = SIZE_K*84;
TEMPLATE_PROJECTILE_LVL_15["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_15["collisionWidth"]     = SIZE_K*57;
TEMPLATE_PROJECTILE_LVL_15["collisionHeight"]    = SIZE_K*84;


local TEMPLATE_CANNON_GLOW_YELLOW =
{
	texture           = 'resources/Vehicle/PlayerVehicle_BlastCarV2/NovaGlow_Yellow.png',
	width             = 54,
	height            = 33,
	blend             = "add",
};

local TEMPLATE_CANNON_GLOW_ORANGE					= Template.extent(TEMPLATE_CANNON_GLOW_YELLOW);
local TEMPLATE_CANNON_GLOW_BLUE						= Template.extent(TEMPLATE_CANNON_GLOW_ORANGE);
local TEMPLATE_CANNON_GLOW_VIOLET					= Template.extent(TEMPLATE_CANNON_GLOW_BLUE);
local TEMPLATE_CANNON_GLOW_GREEN                = Template.extent(TEMPLATE_CANNON_GLOW_VIOLET);

TEMPLATE_CANNON_GLOW_ORANGE["texture"]				= 'resources/Vehicle/PlayerVehicle_BlastCarV2/NovaGlow_Orange.png';
TEMPLATE_CANNON_GLOW_BLUE["texture"]				= 'resources/Vehicle/PlayerVehicle_BlastCarV2/NovaGlow_Blue.png';
TEMPLATE_CANNON_GLOW_VIOLET["texture"]				= 'resources/Vehicle/PlayerVehicle_BlastCarV2/NovaGlow_Violet.png';
TEMPLATE_CANNON_GLOW_GREEN["texture"]				= 'resources/Vehicle/PlayerVehicle_BlastCarV2/NovaGlow_Green.png';

local TEMPLATE_PLAYER_TURRET_LVL_0 =
{
    factory                = TurretNova;
	layer                   = 3;
    texture                = "resources/square.png",
    width                  = 1,
    height                 = 1,
    pivot                  = { 0, 68/2-44 },
    collisionWidth         = 0,
    collisionHeight        = 0,
	maxTurnRate             = 0,
	alwaysShoot             = true;
    shootDelay             = 0.0,
    bulletCount            = 1,
    bulletDelay            = 1.0,
	bulletDelta             = { { x=0, y= -24}	},
    projectile             = TEMPLATE_PLAYER_TURRET_BULLET_LVL_0,
	glowVFX                 = TEMPLATE_CANNON_GLOW_YELLOW,
	glowTime                = 1.0;
	glowOffset              = {x=0,	y=48},
	glowScale               = {w=1.5,	h=1.5},
	type                    = "bullet",
};

local TEMPLATE_PLAYER_TURRET_LVL_1    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_0);
local TEMPLATE_PLAYER_TURRET_LVL_2    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_1);
local TEMPLATE_PLAYER_TURRET_LVL_3    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_2);
local TEMPLATE_PLAYER_TURRET_LVL_4    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_3);
local TEMPLATE_PLAYER_TURRET_LVL_5    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_4);

local TEMPLATE_PLAYER_TURRET_LVL_6 =
{
    factory                = TurretNova;
	layer                   = 3;
    texture                = "resources/square.png",
    width                  = 1,
    height                 = 1,
    pivot                  = { 0, 68/2-44 },
    collisionWidth         = 0,
    collisionHeight        = 0,
	maxTurnRate             = 0,
	alwaysShoot             = true;
    shootDelay             = 0.0,
    bulletCount            = 1,
    bulletDelay            = 1.0,
	bulletDelta             = { { x=0, y= -24}	},
    projectile             = TEMPLATE_PLAYER_TURRET_BULLET_LVL_6,
	glowVFX                 = TEMPLATE_CANNON_GLOW_YELLOW,
	glowTime                = 1.0;
	glowOffset              = {x=0,	y=48},
	glowScale               = {w=2.5,	h=2.5},
	type                    = "bullet",
};

local TEMPLATE_PLAYER_TURRET_LVL_7    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_6);
local TEMPLATE_PLAYER_TURRET_LVL_8    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_7);
local TEMPLATE_PLAYER_TURRET_LVL_9    = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_8);
local TEMPLATE_PLAYER_TURRET_LVL_10   = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_9);

local TEMPLATE_PLAYER_TURRET_LVL_11 =
{
    factory                = TurretNova;
	layer                   = 3;
    texture                = "resources/square.png",
    width                  = 1,
    height                 = 1,
    pivot                  = { 0, 68/2-44 },
    collisionWidth         = 0,
    collisionHeight        = 0,
	maxTurnRate             = 0,
	alwaysShoot             = true;
    shootDelay             = 0.0,
    bulletCount            = 1,
    bulletDelay            = 1.0,
	bulletDelta             = { { x=0, y= -24}	},
    projectile             = TEMPLATE_PLAYER_TURRET_BULLET_LVL_11,
	glowVFX                 = TEMPLATE_CANNON_GLOW_YELLOW,
	glowTime                = 1.0;
	glowOffset              = {x=0,	y=48},
	glowScale               = {w=4,	h=4},
	type                    = "bullet",
};

local TEMPLATE_PLAYER_TURRET_LVL_12   = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_11);
local TEMPLATE_PLAYER_TURRET_LVL_13   = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_12);
local TEMPLATE_PLAYER_TURRET_LVL_14   = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_13);
local TEMPLATE_PLAYER_TURRET_LVL_15   = Template.extent(TEMPLATE_PLAYER_TURRET_LVL_14);

-------------
TEMPLATE_PLAYER_TURRET_LVL_1["cost"]                     = NOVACAR_MK2_UNLOCK_TURRET_COST;
TEMPLATE_PLAYER_TURRET_LVL_1["projectile"]               = TEMPLATE_PROJECTILE_LVL_1;
TEMPLATE_PLAYER_TURRET_LVL_1["glowVFX"]						= TEMPLATE_CANNON_GLOW_YELLOW;
-------------
TEMPLATE_PLAYER_TURRET_LVL_2["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_02 };
TEMPLATE_PLAYER_TURRET_LVL_2["projectile"]               = TEMPLATE_PROJECTILE_LVL_2;
TEMPLATE_PLAYER_TURRET_LVL_2["glowVFX"]						= TEMPLATE_CANNON_GLOW_ORANGE;
-------------
TEMPLATE_PLAYER_TURRET_LVL_3["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_03 };
TEMPLATE_PLAYER_TURRET_LVL_3["projectile"]               = TEMPLATE_PROJECTILE_LVL_3;
TEMPLATE_PLAYER_TURRET_LVL_3["glowVFX"]						= TEMPLATE_CANNON_GLOW_GREEN;
-------------
TEMPLATE_PLAYER_TURRET_LVL_4["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_04 };
TEMPLATE_PLAYER_TURRET_LVL_4["projectile"]               = TEMPLATE_PROJECTILE_LVL_4;
TEMPLATE_PLAYER_TURRET_LVL_4["glowVFX"]						= TEMPLATE_CANNON_GLOW_BLUE;
-------------
TEMPLATE_PLAYER_TURRET_LVL_5["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_05 };
TEMPLATE_PLAYER_TURRET_LVL_5["projectile"]               = TEMPLATE_PROJECTILE_LVL_5;
TEMPLATE_PLAYER_TURRET_LVL_5["glowVFX"]						= TEMPLATE_CANNON_GLOW_VIOLET;
-------------
TEMPLATE_PLAYER_TURRET_LVL_6["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_06 };
TEMPLATE_PLAYER_TURRET_LVL_6["projectile"]               = TEMPLATE_PROJECTILE_LVL_6;
TEMPLATE_PLAYER_TURRET_LVL_6["glowVFX"]						= TEMPLATE_CANNON_GLOW_YELLOW;
-------------
TEMPLATE_PLAYER_TURRET_LVL_7["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_07 };
TEMPLATE_PLAYER_TURRET_LVL_7["projectile"]               = TEMPLATE_PROJECTILE_LVL_7;
TEMPLATE_PLAYER_TURRET_LVL_7["glowVFX"]						= TEMPLATE_CANNON_GLOW_ORANGE;
-------------
TEMPLATE_PLAYER_TURRET_LVL_8["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_08 };
TEMPLATE_PLAYER_TURRET_LVL_8["projectile"]               = TEMPLATE_PROJECTILE_LVL_8;
TEMPLATE_PLAYER_TURRET_LVL_8["glowVFX"]						= TEMPLATE_CANNON_GLOW_GREEN;
-------------
TEMPLATE_PLAYER_TURRET_LVL_9["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_09 };
TEMPLATE_PLAYER_TURRET_LVL_9["projectile"]               = TEMPLATE_PROJECTILE_LVL_9;
TEMPLATE_PLAYER_TURRET_LVL_9["glowVFX"]						= TEMPLATE_CANNON_GLOW_BLUE;
-------------
TEMPLATE_PLAYER_TURRET_LVL_10["cost"]                    = { gold = COST_K*TEMPLATE_BASE_COST_10 };
TEMPLATE_PLAYER_TURRET_LVL_10["projectile"]              = TEMPLATE_PROJECTILE_LVL_10;
TEMPLATE_PLAYER_TURRET_LVL_10["glowVFX"]						= TEMPLATE_CANNON_GLOW_VIOLET;
-------------
TEMPLATE_PLAYER_TURRET_LVL_11["cost"]                    = { gold = COST_K*TEMPLATE_BASE_COST_11 };
TEMPLATE_PLAYER_TURRET_LVL_11["projectile"]              = TEMPLATE_PROJECTILE_LVL_11;
TEMPLATE_PLAYER_TURRET_LVL_11["glowVFX"]						= TEMPLATE_CANNON_GLOW_YELLOW;
-------------
TEMPLATE_PLAYER_TURRET_LVL_12["cost"]                    = { gold = COST_K*TEMPLATE_BASE_COST_12 };
TEMPLATE_PLAYER_TURRET_LVL_12["projectile"]              = TEMPLATE_PROJECTILE_LVL_12;
TEMPLATE_PLAYER_TURRET_LVL_12["glowVFX"]						= TEMPLATE_CANNON_GLOW_ORANGE;
-------------
TEMPLATE_PLAYER_TURRET_LVL_13["cost"]                    = { gold = COST_K*TEMPLATE_BASE_COST_13 };
TEMPLATE_PLAYER_TURRET_LVL_13["projectile"]              = TEMPLATE_PROJECTILE_LVL_13;
TEMPLATE_PLAYER_TURRET_LVL_13["glowVFX"]						= TEMPLATE_CANNON_GLOW_GREEN;
-------------
TEMPLATE_PLAYER_TURRET_LVL_14["cost"]                    = { gold = COST_K*TEMPLATE_BASE_COST_14 };
TEMPLATE_PLAYER_TURRET_LVL_14["projectile"]              = TEMPLATE_PROJECTILE_LVL_14;
TEMPLATE_PLAYER_TURRET_LVL_14["glowVFX"]						= TEMPLATE_CANNON_GLOW_BLUE;
-------------
TEMPLATE_PLAYER_TURRET_LVL_15["cost"]                    = { gold = COST_K*TEMPLATE_BASE_COST_15 };
TEMPLATE_PLAYER_TURRET_LVL_15["projectile"]              = TEMPLATE_PROJECTILE_LVL_15;
TEMPLATE_PLAYER_TURRET_LVL_15["glowVFX"]						= TEMPLATE_CANNON_GLOW_VIOLET;
-------------


TEMPLATE_PLAYER_VEHICLE_NOVACAR_MK2_TURRET =
{
   version = 3;

   level =
   {
      TEMPLATE_PLAYER_TURRET_LVL_1,
      TEMPLATE_PLAYER_TURRET_LVL_2,
      TEMPLATE_PLAYER_TURRET_LVL_3,
      TEMPLATE_PLAYER_TURRET_LVL_4,
      TEMPLATE_PLAYER_TURRET_LVL_5,
      TEMPLATE_PLAYER_TURRET_LVL_6,
      TEMPLATE_PLAYER_TURRET_LVL_7,
      TEMPLATE_PLAYER_TURRET_LVL_8,
      TEMPLATE_PLAYER_TURRET_LVL_9,
      TEMPLATE_PLAYER_TURRET_LVL_10,
      TEMPLATE_PLAYER_TURRET_LVL_11,
      TEMPLATE_PLAYER_TURRET_LVL_12,
      TEMPLATE_PLAYER_TURRET_LVL_13,
      TEMPLATE_PLAYER_TURRET_LVL_14,
      TEMPLATE_PLAYER_TURRET_LVL_15,
   }
};