require("app/template/store/cost");
require('app/template/template');
require("app/template/player-levels/stats_template");

local DAMAGE_K             = 1.20;

local COST_K               = 8.0;
local PROJECTILE_SIZE_K    = 1.00;

local TEMPLATE_PROJECTILE_LVL_0 =
{
   speed             =  { 0, 2000 },
   spin              = 0, 
   width             = 60,
   height            = 120, 
   collisionWidth    = 40,
   collisionHeight   = 100,
};

local TEMPLATE_PROJECTILE_LVL_1    = Template.extent(TEMPLATE_PROJECTILE_LVL_0);
local TEMPLATE_PROJECTILE_LVL_2    = Template.extent(TEMPLATE_PROJECTILE_LVL_1);
local TEMPLATE_PROJECTILE_LVL_3    = Template.extent(TEMPLATE_PROJECTILE_LVL_2);
local TEMPLATE_PROJECTILE_LVL_4    = Template.extent(TEMPLATE_PROJECTILE_LVL_3);
local TEMPLATE_PROJECTILE_LVL_5    = Template.extent(TEMPLATE_PROJECTILE_LVL_4);
local TEMPLATE_PROJECTILE_LVL_6    = Template.extent(TEMPLATE_PROJECTILE_LVL_5);
local TEMPLATE_PROJECTILE_LVL_7    = Template.extent(TEMPLATE_PROJECTILE_LVL_6);
local TEMPLATE_PROJECTILE_LVL_8    = Template.extent(TEMPLATE_PROJECTILE_LVL_7);
local TEMPLATE_PROJECTILE_LVL_9    = Template.extent(TEMPLATE_PROJECTILE_LVL_8);
local TEMPLATE_PROJECTILE_LVL_10   = Template.extent(TEMPLATE_PROJECTILE_LVL_9);
local TEMPLATE_PROJECTILE_LVL_11   = Template.extent(TEMPLATE_PROJECTILE_LVL_10);
local TEMPLATE_PROJECTILE_LVL_12   = Template.extent(TEMPLATE_PROJECTILE_LVL_11);
local TEMPLATE_PROJECTILE_LVL_13   = Template.extent(TEMPLATE_PROJECTILE_LVL_12);
local TEMPLATE_PROJECTILE_LVL_14   = Template.extent(TEMPLATE_PROJECTILE_LVL_13);
local TEMPLATE_PROJECTILE_LVL_15   = Template.extent(TEMPLATE_PROJECTILE_LVL_14);

TEMPLATE_PROJECTILE_LVL_1["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][1];
TEMPLATE_PROJECTILE_LVL_1["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level16.png';
TEMPLATE_PROJECTILE_LVL_1["width"]              = PROJECTILE_SIZE_K*1.12*64;
TEMPLATE_PROJECTILE_LVL_1["height"]             = PROJECTILE_SIZE_K*1.12*128;
TEMPLATE_PROJECTILE_LVL_1["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_2["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][2];
TEMPLATE_PROJECTILE_LVL_2["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level17.png';
TEMPLATE_PROJECTILE_LVL_2["width"]              = PROJECTILE_SIZE_K*1.12*64;
TEMPLATE_PROJECTILE_LVL_2["height"]             = PROJECTILE_SIZE_K*1.12*128;
TEMPLATE_PROJECTILE_LVL_3["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][3];
TEMPLATE_PROJECTILE_LVL_3["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level18.png';
TEMPLATE_PROJECTILE_LVL_3["width"]              = PROJECTILE_SIZE_K*1.12*64;
TEMPLATE_PROJECTILE_LVL_3["height"]             = PROJECTILE_SIZE_K*1.12*128;
TEMPLATE_PROJECTILE_LVL_4["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][4];
TEMPLATE_PROJECTILE_LVL_4["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level19.png';
TEMPLATE_PROJECTILE_LVL_4["width"]              = PROJECTILE_SIZE_K*1.09*64;
TEMPLATE_PROJECTILE_LVL_4["height"]             = PROJECTILE_SIZE_K*1.09*128;
TEMPLATE_PROJECTILE_LVL_4["speed"]              = { 0, 1600 };
TEMPLATE_PROJECTILE_LVL_5["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][5];
TEMPLATE_PROJECTILE_LVL_5["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level20.png';
TEMPLATE_PROJECTILE_LVL_5["width"]              = PROJECTILE_SIZE_K*1.09*64;
TEMPLATE_PROJECTILE_LVL_5["height"]             = PROJECTILE_SIZE_K*1.09*128;
TEMPLATE_PROJECTILE_LVL_6["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][6];
TEMPLATE_PROJECTILE_LVL_6["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level21.png';
TEMPLATE_PROJECTILE_LVL_6["width"]              = PROJECTILE_SIZE_K*1.09*64;
TEMPLATE_PROJECTILE_LVL_6["height"]             = PROJECTILE_SIZE_K*1.09*128;
TEMPLATE_PROJECTILE_LVL_7["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][7];
TEMPLATE_PROJECTILE_LVL_7["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level22.png';
TEMPLATE_PROJECTILE_LVL_7["width"]              = PROJECTILE_SIZE_K*1.06*64;
TEMPLATE_PROJECTILE_LVL_7["height"]             = PROJECTILE_SIZE_K*1.06*128;
TEMPLATE_PROJECTILE_LVL_7["speed"]              = { 0, 1750 };
TEMPLATE_PROJECTILE_LVL_8["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][8];
TEMPLATE_PROJECTILE_LVL_8["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level23.png';
TEMPLATE_PROJECTILE_LVL_8["width"]              = PROJECTILE_SIZE_K*1.06*64;
TEMPLATE_PROJECTILE_LVL_8["height"]             = PROJECTILE_SIZE_K*1.06*128;
TEMPLATE_PROJECTILE_LVL_9["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][9];
TEMPLATE_PROJECTILE_LVL_9["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level24.png';
TEMPLATE_PROJECTILE_LVL_9["width"]              = PROJECTILE_SIZE_K*1.06*64;
TEMPLATE_PROJECTILE_LVL_9["height"]             = PROJECTILE_SIZE_K*1.06*128;
TEMPLATE_PROJECTILE_LVL_10["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][10];
TEMPLATE_PROJECTILE_LVL_10["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level25.png';
TEMPLATE_PROJECTILE_LVL_10["width"]             = PROJECTILE_SIZE_K*0.93*64;
TEMPLATE_PROJECTILE_LVL_10["height"]            = PROJECTILE_SIZE_K*0.93*128;
TEMPLATE_PROJECTILE_LVL_10["speed"]             = { 0, 1950 };
TEMPLATE_PROJECTILE_LVL_11["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][11];
TEMPLATE_PROJECTILE_LVL_11["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level26.png';
TEMPLATE_PROJECTILE_LVL_11["width"]             = PROJECTILE_SIZE_K*0.93*64;
TEMPLATE_PROJECTILE_LVL_11["height"]            = PROJECTILE_SIZE_K*0.93*128;
TEMPLATE_PROJECTILE_LVL_12["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][12];
TEMPLATE_PROJECTILE_LVL_12["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level27.png';
TEMPLATE_PROJECTILE_LVL_12["width"]             = PROJECTILE_SIZE_K*0.93*64;
TEMPLATE_PROJECTILE_LVL_12["height"]            = PROJECTILE_SIZE_K*0.93*128;
TEMPLATE_PROJECTILE_LVL_13["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][13];
TEMPLATE_PROJECTILE_LVL_13["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level28.png';
TEMPLATE_PROJECTILE_LVL_13["width"]             = PROJECTILE_SIZE_K*0.93*64;
TEMPLATE_PROJECTILE_LVL_13["height"]            = PROJECTILE_SIZE_K*0.93*128;
TEMPLATE_PROJECTILE_LVL_13["speed"]             = { 0, 2200 };
TEMPLATE_PROJECTILE_LVL_14["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][14];
TEMPLATE_PROJECTILE_LVL_14["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level29.png';
TEMPLATE_PROJECTILE_LVL_14["width"]             = PROJECTILE_SIZE_K*0.93*64;
TEMPLATE_PROJECTILE_LVL_14["height"]            = PROJECTILE_SIZE_K*0.93*128;
TEMPLATE_PROJECTILE_LVL_15["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sandrail_2"][15];
TEMPLATE_PROJECTILE_LVL_15["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level30.png';
TEMPLATE_PROJECTILE_LVL_15["width"]             = PROJECTILE_SIZE_K*0.93*64;
TEMPLATE_PROJECTILE_LVL_15["height"]            = PROJECTILE_SIZE_K*0.93*128;


local TEMPLATE_WEAPON_LVL_LVL_0 =
{ 
   delay             = 3/30,
   speed             =  { 0, 2000 }, 
   spin              = 0, 
   width             = 60,
   height            = 120, 
   collisionWidth    = 40,
   collisionHeight   = 100,  
   doubleDelta       = { -20, 20 },
};

local TEMPLATE_WEAPON_LVL_LVL_1    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_0);
local TEMPLATE_WEAPON_LVL_LVL_2    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_1);
local TEMPLATE_WEAPON_LVL_LVL_3    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_2);
local TEMPLATE_WEAPON_LVL_LVL_4    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_3);
local TEMPLATE_WEAPON_LVL_LVL_5    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_4);
local TEMPLATE_WEAPON_LVL_LVL_6    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_5);
local TEMPLATE_WEAPON_LVL_LVL_7    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_6);
local TEMPLATE_WEAPON_LVL_LVL_8    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_7);
local TEMPLATE_WEAPON_LVL_LVL_9    = Template.extent(TEMPLATE_WEAPON_LVL_LVL_8);
local TEMPLATE_WEAPON_LVL_LVL_10   = Template.extent(TEMPLATE_WEAPON_LVL_LVL_9);
local TEMPLATE_WEAPON_LVL_LVL_11   = Template.extent(TEMPLATE_WEAPON_LVL_LVL_10);
local TEMPLATE_WEAPON_LVL_LVL_12   = Template.extent(TEMPLATE_WEAPON_LVL_LVL_11);
local TEMPLATE_WEAPON_LVL_LVL_13   = Template.extent(TEMPLATE_WEAPON_LVL_LVL_12);
local TEMPLATE_WEAPON_LVL_LVL_14   = Template.extent(TEMPLATE_WEAPON_LVL_LVL_13);
local TEMPLATE_WEAPON_LVL_LVL_15   = Template.extent(TEMPLATE_WEAPON_LVL_LVL_14);


TEMPLATE_WEAPON_LVL_LVL_1["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_01  };
TEMPLATE_WEAPON_LVL_LVL_1["sounds"]      = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_1["projectile"]  = TEMPLATE_PROJECTILE_LVL_1;
TEMPLATE_WEAPON_LVL_LVL_2["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_02  };
TEMPLATE_WEAPON_LVL_LVL_2["sounds"]      = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_2["projectile"]  = TEMPLATE_PROJECTILE_LVL_2;
TEMPLATE_WEAPON_LVL_LVL_3["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_03  };
TEMPLATE_WEAPON_LVL_LVL_3["sounds"]      = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_3["projectile"]  = TEMPLATE_PROJECTILE_LVL_3;
TEMPLATE_WEAPON_LVL_LVL_4["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_04  };
TEMPLATE_WEAPON_LVL_LVL_4["sounds"]      = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_4["projectile"]  = TEMPLATE_PROJECTILE_LVL_4;
TEMPLATE_WEAPON_LVL_LVL_5["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_05  };
TEMPLATE_WEAPON_LVL_LVL_5["sounds"]      = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_5["projectile"]  = TEMPLATE_PROJECTILE_LVL_5;
TEMPLATE_WEAPON_LVL_LVL_6["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_06  };
TEMPLATE_WEAPON_LVL_LVL_6["sounds"]      = {loop={"GunLoop2",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_6["projectile"]  = TEMPLATE_PROJECTILE_LVL_6;
TEMPLATE_WEAPON_LVL_LVL_7["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_07  };
TEMPLATE_WEAPON_LVL_LVL_7["sounds"]      = {loop={"GunLoop2",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_7["projectile"]  = TEMPLATE_PROJECTILE_LVL_7;
TEMPLATE_WEAPON_LVL_LVL_8["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_08  };
TEMPLATE_WEAPON_LVL_LVL_8["sounds"]      = {loop={"GunLoop2",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_8["projectile"]  = TEMPLATE_PROJECTILE_LVL_8;
TEMPLATE_WEAPON_LVL_LVL_9["cost"]        = { gold = COST_K*TEMPLATE_BASE_COST_09  };
TEMPLATE_WEAPON_LVL_LVL_9["sounds"]      = {loop={"GunLoop2",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_9["projectile"]  = TEMPLATE_PROJECTILE_LVL_9;
TEMPLATE_WEAPON_LVL_LVL_10["cost"]       = { gold = COST_K*TEMPLATE_BASE_COST_10  };
TEMPLATE_WEAPON_LVL_LVL_10["sounds"]     = {loop={"GunLoop2",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_10["projectile"] = TEMPLATE_PROJECTILE_LVL_10;
TEMPLATE_WEAPON_LVL_LVL_11["cost"]       = { gold = COST_K*TEMPLATE_BASE_COST_11  };
TEMPLATE_WEAPON_LVL_LVL_11["sounds"]     = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_11["projectile"] = TEMPLATE_PROJECTILE_LVL_11;
TEMPLATE_WEAPON_LVL_LVL_12["cost"]       = { gold = COST_K*TEMPLATE_BASE_COST_12  };
TEMPLATE_WEAPON_LVL_LVL_12["sounds"]     = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_12["projectile"] = TEMPLATE_PROJECTILE_LVL_12;
TEMPLATE_WEAPON_LVL_LVL_13["cost"]       = { gold = COST_K*TEMPLATE_BASE_COST_13  };
TEMPLATE_WEAPON_LVL_LVL_13["sounds"]     = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_13["projectile"] = TEMPLATE_PROJECTILE_LVL_13;
TEMPLATE_WEAPON_LVL_LVL_14["cost"]       = { gold = COST_K*TEMPLATE_BASE_COST_14  };
TEMPLATE_WEAPON_LVL_LVL_14["sounds"]     = {loop={"GunLoop1",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_14["projectile"] = TEMPLATE_PROJECTILE_LVL_14;
TEMPLATE_WEAPON_LVL_LVL_15["cost"]       = { gold = COST_K*TEMPLATE_BASE_COST_15  };
TEMPLATE_WEAPON_LVL_LVL_15["sounds"]     = {loop={"GunLoop2",},alt={"DoubleGunLoop",},};
TEMPLATE_WEAPON_LVL_LVL_15["projectile"] = TEMPLATE_PROJECTILE_LVL_15;


TEMPLATE_PLAYER_VEHICLE_SANDRAIL_MK2_MAIN_WEAPON =
{
   version = 21,
   
   level   =
   {
      TEMPLATE_WEAPON_LVL_LVL_1,
      TEMPLATE_WEAPON_LVL_LVL_2,
      TEMPLATE_WEAPON_LVL_LVL_3,
      TEMPLATE_WEAPON_LVL_LVL_4,
      TEMPLATE_WEAPON_LVL_LVL_5,
      TEMPLATE_WEAPON_LVL_LVL_6,
      TEMPLATE_WEAPON_LVL_LVL_7,
      TEMPLATE_WEAPON_LVL_LVL_8,
      TEMPLATE_WEAPON_LVL_LVL_9,
      TEMPLATE_WEAPON_LVL_LVL_10,
      TEMPLATE_WEAPON_LVL_LVL_11,
      TEMPLATE_WEAPON_LVL_LVL_12,
      TEMPLATE_WEAPON_LVL_LVL_13,
      TEMPLATE_WEAPON_LVL_LVL_14,
      TEMPLATE_WEAPON_LVL_LVL_15,
   }
};
-------------------------------------------------------------------------------------
