require("app/template/template");
require("game/entity/powerup/powerup-magnet");
require("game/entity/turret/turret-magnet");

----------------------------------------------------------------------

local COST_K            = 8.0*1.5;

local TEMPLATE_POWER_UP_LVL_0 =
{
   factory        = PowerupMagnet,
   duration       = 50000000,
   texture        = "resources/Powerup/Effect_Magnet.png",
   blend          = "add",
   color          = { 1, 1, 1, 0.150 },
   spin           = 90,
   layer          = 7,
	pulseTime		= 24/30,
}; 


local TEMPLATE_POWER_UP_LVL_1    = Template.extent(TEMPLATE_POWER_UP_LVL_0);
local TEMPLATE_POWER_UP_LVL_2    = Template.extent(TEMPLATE_POWER_UP_LVL_1);
local TEMPLATE_POWER_UP_LVL_3    = Template.extent(TEMPLATE_POWER_UP_LVL_2);
local TEMPLATE_POWER_UP_LVL_4    = Template.extent(TEMPLATE_POWER_UP_LVL_3);
local TEMPLATE_POWER_UP_LVL_5    = Template.extent(TEMPLATE_POWER_UP_LVL_4);
local TEMPLATE_POWER_UP_LVL_6    = Template.extent(TEMPLATE_POWER_UP_LVL_5);
local TEMPLATE_POWER_UP_LVL_7    = Template.extent(TEMPLATE_POWER_UP_LVL_6);
local TEMPLATE_POWER_UP_LVL_8    = Template.extent(TEMPLATE_POWER_UP_LVL_7);
local TEMPLATE_POWER_UP_LVL_9    = Template.extent(TEMPLATE_POWER_UP_LVL_8);
local TEMPLATE_POWER_UP_LVL_10   = Template.extent(TEMPLATE_POWER_UP_LVL_9);
local TEMPLATE_POWER_UP_LVL_11   = Template.extent(TEMPLATE_POWER_UP_LVL_10);
local TEMPLATE_POWER_UP_LVL_12   = Template.extent(TEMPLATE_POWER_UP_LVL_11);
local TEMPLATE_POWER_UP_LVL_13   = Template.extent(TEMPLATE_POWER_UP_LVL_12);
local TEMPLATE_POWER_UP_LVL_14   = Template.extent(TEMPLATE_POWER_UP_LVL_13);
local TEMPLATE_POWER_UP_LVL_15   = Template.extent(TEMPLATE_POWER_UP_LVL_14);

----------------------------------------------------------------------

local TEMPLATE_PLAYER_TURRET_3_LVL_0 =
{
   factory        = TurretMagnet,
   texture        = "resources/Vehicle/Turret_Weapons/Turret_Magnet.png",
   width          = 60,
   height         = 60,
   pivot          = { 0, 0 },
   tplPowerup     = TEMPLATE_POWER_UP,
	type				= "magnet",
};

local TEMPLATE_PLAYER_TURRET_3_LVL_1    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_0);
local TEMPLATE_PLAYER_TURRET_3_LVL_2    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_1);
local TEMPLATE_PLAYER_TURRET_3_LVL_3    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_2);
local TEMPLATE_PLAYER_TURRET_3_LVL_4    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_3);
local TEMPLATE_PLAYER_TURRET_3_LVL_5    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_4);
local TEMPLATE_PLAYER_TURRET_3_LVL_6    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_5);
local TEMPLATE_PLAYER_TURRET_3_LVL_7    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_6);
local TEMPLATE_PLAYER_TURRET_3_LVL_8    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_7);
local TEMPLATE_PLAYER_TURRET_3_LVL_9    = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_8);
local TEMPLATE_PLAYER_TURRET_3_LVL_10   = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_9);
local TEMPLATE_PLAYER_TURRET_3_LVL_11   = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_10);
local TEMPLATE_PLAYER_TURRET_3_LVL_12   = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_11);
local TEMPLATE_PLAYER_TURRET_3_LVL_13   = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_12);
local TEMPLATE_PLAYER_TURRET_3_LVL_14   = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_13);
local TEMPLATE_PLAYER_TURRET_3_LVL_15   = Template.extent(TEMPLATE_PLAYER_TURRET_3_LVL_14);

-------------
TEMPLATE_PLAYER_TURRET_3_LVL_1["cost"]                      = SANDRAIL_MK2_UNLOCK_TURRET_COST;
TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_1;
TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]["radius"]      = 175;
TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_1["tplPowerup"]["color"]       = { 1, 1, 1, 0.510 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_2["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_02 };
TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_2;
TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]["radius"]      = 186;
TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_2["tplPowerup"]["color"]       = { 1, 1, 1, 0.520 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_3["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_03 };
TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_3;
TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]["radius"]      = 197;
TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_3["tplPowerup"]["color"]       = { 1, 1, 1, 0.530 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_4["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_04 };
TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_4;
TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["radius"]      = 208;
TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["color"]       = { 1, 1, 1, 0.540 };
TEMPLATE_PLAYER_TURRET_3_LVL_4["tplPowerup"]["pulseTime"]   = 28/30;
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_5["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_05 };
TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_5;
TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]["radius"]      = 221;
TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_5["tplPowerup"]["color"]       = { 1, 1, 1, 0.550 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_6["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_06 };
TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_6;
TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]["radius"]      = 234;
TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_6["tplPowerup"]["color"]       = { 1, 1, 1, 0.560 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_7["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_07 };
TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_7;
TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["radius"]      = 248;
TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["color"]       = { 1, 1, 1, 0.570 };
TEMPLATE_PLAYER_TURRET_3_LVL_7["tplPowerup"]["pulseTime"]   = 32/30;
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_8["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_08 };
TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_8;
TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]["radius"]      = 263;
TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_8["tplPowerup"]["color"]       = { 1, 1, 1, 0.580 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_9["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_09 };
TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_9;
TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]["radius"]      = 279;
TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_9["tplPowerup"]["color"]       = { 1, 1, 1, 0.590 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_10["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_10 };
TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_10;
TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["radius"]      = 300;
TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["color"]       = { 1, 1, 1, 0.600 };
TEMPLATE_PLAYER_TURRET_3_LVL_10["tplPowerup"]["pulseTime"]   = 36/30;
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_11["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_11 };
TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_11;
TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]["radius"]      = 325;
TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_11["tplPowerup"]["color"]       = { 1, 1, 1, 0.610 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_12["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_12 };
TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_12;
TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]["radius"]      = 350;
TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_12["tplPowerup"]["color"]       = { 1, 1, 1, 0.620 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_13["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_13 };
TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_13;
TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]["radius"]      = 375;
TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_13["tplPowerup"]["color"]       = { 1, 1, 1, 0.630 };
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_14["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_14 };
TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_14;
TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["radius"]      = 400;
TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["color"]       = { 1, 1, 1, 0.640 };
TEMPLATE_PLAYER_TURRET_3_LVL_14["tplPowerup"]["pulseTime"]   = 36/30;
-------------
TEMPLATE_PLAYER_TURRET_3_LVL_15["cost"]                      = { gold = COST_K*TEMPLATE_BASE_COST_15 };
TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]                = TEMPLATE_POWER_UP_LVL_15;
TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["radius"]      = 500;
TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["width"]       = TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["radius"]*2.0;
TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["height"]      = TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["width"];
TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["color"]       = { 1, 1, 1, 0.650 };
TEMPLATE_PLAYER_TURRET_3_LVL_15["tplPowerup"]["pulseTime"]   = 40/30;

            
-------------

TEMPLATE_PLAYER_VEHICLE_SANDRAIL_MK2_TURRET =
{
   version = 3;

   level =
   {
      TEMPLATE_PLAYER_TURRET_3_LVL_1,
      TEMPLATE_PLAYER_TURRET_3_LVL_2,
      TEMPLATE_PLAYER_TURRET_3_LVL_3,
      TEMPLATE_PLAYER_TURRET_3_LVL_4,
      TEMPLATE_PLAYER_TURRET_3_LVL_5,
      TEMPLATE_PLAYER_TURRET_3_LVL_6,
      TEMPLATE_PLAYER_TURRET_3_LVL_7,
      TEMPLATE_PLAYER_TURRET_3_LVL_8,
      TEMPLATE_PLAYER_TURRET_3_LVL_9,
      TEMPLATE_PLAYER_TURRET_3_LVL_10,
      TEMPLATE_PLAYER_TURRET_3_LVL_11,
      TEMPLATE_PLAYER_TURRET_3_LVL_12,
      TEMPLATE_PLAYER_TURRET_3_LVL_13,
      TEMPLATE_PLAYER_TURRET_3_LVL_14,
      TEMPLATE_PLAYER_TURRET_3_LVL_15,
   }
};