require("app/template/store/cost");
require("app/template/template");
require("game/entity/turret/turret-shoot");
require("app/template/player-levels/stats_template");

local DAMAGE_K          = 1.00;
local SIZE_K            = 1.20;
local COST_K            = 6.0*1.5;

local TEMPLATE_PROJECTILE_LVL_0 = 
{
      speed            = { 0, 1250 },
      width             = 60,
      height            = 120, 
      collisionWidth    = 40,
      collisionHeight   = 100,
      damage           = DAMAGE_K*1,
};



local TEMPLATE_PROJECTILE_LVL_1           = Template.extent(TEMPLATE_PROJECTILE_LVL_0);
local TEMPLATE_PROJECTILE_LVL_2           = Template.extent(TEMPLATE_PROJECTILE_LVL_1);
local TEMPLATE_PROJECTILE_LVL_3           = Template.extent(TEMPLATE_PROJECTILE_LVL_2);
local TEMPLATE_PROJECTILE_LVL_4           = Template.extent(TEMPLATE_PROJECTILE_LVL_3);
local TEMPLATE_PROJECTILE_LVL_5           = Template.extent(TEMPLATE_PROJECTILE_LVL_4);
local TEMPLATE_PROJECTILE_LVL_6           = Template.extent(TEMPLATE_PROJECTILE_LVL_5);
local TEMPLATE_PROJECTILE_LVL_7           = Template.extent(TEMPLATE_PROJECTILE_LVL_6);
local TEMPLATE_PROJECTILE_LVL_8           = Template.extent(TEMPLATE_PROJECTILE_LVL_7);
local TEMPLATE_PROJECTILE_LVL_9           = Template.extent(TEMPLATE_PROJECTILE_LVL_8);
local TEMPLATE_PROJECTILE_LVL_10          = Template.extent(TEMPLATE_PROJECTILE_LVL_9);
local TEMPLATE_PROJECTILE_LVL_11          = Template.extent(TEMPLATE_PROJECTILE_LVL_10);
local TEMPLATE_PROJECTILE_LVL_12          = Template.extent(TEMPLATE_PROJECTILE_LVL_11);
local TEMPLATE_PROJECTILE_LVL_13          = Template.extent(TEMPLATE_PROJECTILE_LVL_12);
local TEMPLATE_PROJECTILE_LVL_14          = Template.extent(TEMPLATE_PROJECTILE_LVL_13);
local TEMPLATE_PROJECTILE_LVL_15          = Template.extent(TEMPLATE_PROJECTILE_LVL_14);

TEMPLATE_PROJECTILE_LVL_1["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][1];
TEMPLATE_PROJECTILE_LVL_1["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level01.png';
TEMPLATE_PROJECTILE_LVL_1["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_1["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_1["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_2["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][2];
TEMPLATE_PROJECTILE_LVL_2["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level02.png';
TEMPLATE_PROJECTILE_LVL_2["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_2["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_3["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][3];
TEMPLATE_PROJECTILE_LVL_3["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level03.png';
TEMPLATE_PROJECTILE_LVL_3["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_3["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_4["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][4];
TEMPLATE_PROJECTILE_LVL_4["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level04.png';
TEMPLATE_PROJECTILE_LVL_4["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_4["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_4["speed"]              = { 0, 1600 };
TEMPLATE_PROJECTILE_LVL_5["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][5];
TEMPLATE_PROJECTILE_LVL_5["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level05.png';
TEMPLATE_PROJECTILE_LVL_5["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_5["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_6["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][6];
TEMPLATE_PROJECTILE_LVL_6["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level06.png';
TEMPLATE_PROJECTILE_LVL_6["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_6["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_7["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][7];
TEMPLATE_PROJECTILE_LVL_7["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level07.png';
TEMPLATE_PROJECTILE_LVL_7["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_7["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_7["speed"]              = { 0, 1750 };
TEMPLATE_PROJECTILE_LVL_8["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][8];
TEMPLATE_PROJECTILE_LVL_8["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level08.png';
TEMPLATE_PROJECTILE_LVL_8["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_8["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_9["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][9];
TEMPLATE_PROJECTILE_LVL_9["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level09.png';
TEMPLATE_PROJECTILE_LVL_9["width"]              = SIZE_K*0.95*64;
TEMPLATE_PROJECTILE_LVL_9["height"]             = SIZE_K*0.95*128;
TEMPLATE_PROJECTILE_LVL_10["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][10];
TEMPLATE_PROJECTILE_LVL_10["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level10.png';
TEMPLATE_PROJECTILE_LVL_10["width"]             = SIZE_K*0.90*64;
TEMPLATE_PROJECTILE_LVL_10["height"]            = SIZE_K*0.90*128;
TEMPLATE_PROJECTILE_LVL_10["speed"]              = { 0, 1950 };
TEMPLATE_PROJECTILE_LVL_11["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][11];
TEMPLATE_PROJECTILE_LVL_11["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level11.png';
TEMPLATE_PROJECTILE_LVL_11["width"]             = SIZE_K*0.90*64;
TEMPLATE_PROJECTILE_LVL_11["height"]            = SIZE_K*0.90*128;
TEMPLATE_PROJECTILE_LVL_12["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][12];
TEMPLATE_PROJECTILE_LVL_12["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level12.png';
TEMPLATE_PROJECTILE_LVL_12["width"]             = SIZE_K*0.90*64;
TEMPLATE_PROJECTILE_LVL_12["height"]            = SIZE_K*0.90*128;
TEMPLATE_PROJECTILE_LVL_13["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][13];
TEMPLATE_PROJECTILE_LVL_13["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level13.png';
TEMPLATE_PROJECTILE_LVL_13["width"]             = SIZE_K*0.90*64;
TEMPLATE_PROJECTILE_LVL_13["height"]            = SIZE_K*0.90*128;
TEMPLATE_PROJECTILE_LVL_13["speed"]              = { 0, 2200 };
TEMPLATE_PROJECTILE_LVL_14["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][14];
TEMPLATE_PROJECTILE_LVL_14["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level14.png';
TEMPLATE_PROJECTILE_LVL_14["width"]             = SIZE_K*0.90*64;
TEMPLATE_PROJECTILE_LVL_14["height"]            = SIZE_K*0.90*128;
TEMPLATE_PROJECTILE_LVL_15["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["sportscar_2"][15];
TEMPLATE_PROJECTILE_LVL_15["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level15.png';
TEMPLATE_PROJECTILE_LVL_15["width"]             = SIZE_K*0.90*64;
TEMPLATE_PROJECTILE_LVL_15["height"]            = SIZE_K*0.90*128;


local TEMPLATE_PLAYER_TURRET_1_LVL_0 =
{
   factory        = TurretShoot;
   texture        = "resources/Vehicle/Turret_Weapons/Turret_Cannon.png",
   width          = 50,
   height         = 68,
   pivot          = { 0, 68/2-44 },
   collisionWidth = 0,
   collisionHeight= 0,
   shootDelay     = 0.0,
   bulletCount    = 10,
   bulletDelay    = 3/30,
   projectile     = TEMPLATE_PLAYER_TURRET_1_BULLET_LVL_0,
	type				= "bullet",
};

local TEMPLATE_PLAYER_TURRET_1_LVL_1    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_0);
local TEMPLATE_PLAYER_TURRET_1_LVL_2    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_1);
local TEMPLATE_PLAYER_TURRET_1_LVL_3    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_2);
local TEMPLATE_PLAYER_TURRET_1_LVL_4    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_3);
local TEMPLATE_PLAYER_TURRET_1_LVL_5    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_4);
local TEMPLATE_PLAYER_TURRET_1_LVL_6    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_5);
local TEMPLATE_PLAYER_TURRET_1_LVL_7    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_6);
local TEMPLATE_PLAYER_TURRET_1_LVL_8    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_7);
local TEMPLATE_PLAYER_TURRET_1_LVL_9    = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_8);
local TEMPLATE_PLAYER_TURRET_1_LVL_10   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_9);
local TEMPLATE_PLAYER_TURRET_1_LVL_11   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_10);
local TEMPLATE_PLAYER_TURRET_1_LVL_12   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_11);
local TEMPLATE_PLAYER_TURRET_1_LVL_13   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_12);
local TEMPLATE_PLAYER_TURRET_1_LVL_14   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_13);
local TEMPLATE_PLAYER_TURRET_1_LVL_15   = Template.extent(TEMPLATE_PLAYER_TURRET_1_LVL_14);

-------------
TEMPLATE_PLAYER_TURRET_1_LVL_1["cost"]                     = SPORTS_MK2_UNLOCK_TURRET_COST;
TEMPLATE_PLAYER_TURRET_1_LVL_1["projectile"]               = TEMPLATE_PROJECTILE_LVL_1;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_2["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_02 };
TEMPLATE_PLAYER_TURRET_1_LVL_2["projectile"]               = TEMPLATE_PROJECTILE_LVL_2;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_3["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_03 };
TEMPLATE_PLAYER_TURRET_1_LVL_3["projectile"]               = TEMPLATE_PROJECTILE_LVL_3;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_4["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_04 };
TEMPLATE_PLAYER_TURRET_1_LVL_4["projectile"]               = TEMPLATE_PROJECTILE_LVL_4;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_5["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_05 };
TEMPLATE_PLAYER_TURRET_1_LVL_5["projectile"]               = TEMPLATE_PROJECTILE_LVL_5;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_6["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_06 };
TEMPLATE_PLAYER_TURRET_1_LVL_6["projectile"]               = TEMPLATE_PROJECTILE_LVL_6;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_7["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_07 };
TEMPLATE_PLAYER_TURRET_1_LVL_7["projectile"]               = TEMPLATE_PROJECTILE_LVL_7;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_8["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_08 };
TEMPLATE_PLAYER_TURRET_1_LVL_8["projectile"]               = TEMPLATE_PROJECTILE_LVL_8;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_9["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_09 };
TEMPLATE_PLAYER_TURRET_1_LVL_9["projectile"]               = TEMPLATE_PROJECTILE_LVL_9;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_10["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_10 };
TEMPLATE_PLAYER_TURRET_1_LVL_10["projectile"]               = TEMPLATE_PROJECTILE_LVL_10;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_11["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_11 };
TEMPLATE_PLAYER_TURRET_1_LVL_11["projectile"]               = TEMPLATE_PROJECTILE_LVL_11;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_12["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_12 };
TEMPLATE_PLAYER_TURRET_1_LVL_12["projectile"]               = TEMPLATE_PROJECTILE_LVL_12;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_13["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_13 };
TEMPLATE_PLAYER_TURRET_1_LVL_13["projectile"]               = TEMPLATE_PROJECTILE_LVL_13;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_14["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_14 };
TEMPLATE_PLAYER_TURRET_1_LVL_14["projectile"]               = TEMPLATE_PROJECTILE_LVL_14;
-------------
TEMPLATE_PLAYER_TURRET_1_LVL_15["cost"]                     = { gold = COST_K*TEMPLATE_BASE_COST_15 };
TEMPLATE_PLAYER_TURRET_1_LVL_15["projectile"]               = TEMPLATE_PROJECTILE_LVL_15;
-------------


TEMPLATE_PLAYER_VEHICLE_SPORTS_MK2_TURRET =
{
   version = 3;

   level =
   {
      TEMPLATE_PLAYER_TURRET_1_LVL_1,
      TEMPLATE_PLAYER_TURRET_1_LVL_2,
      TEMPLATE_PLAYER_TURRET_1_LVL_3,
      TEMPLATE_PLAYER_TURRET_1_LVL_4,
      TEMPLATE_PLAYER_TURRET_1_LVL_5,
      TEMPLATE_PLAYER_TURRET_1_LVL_6,
      TEMPLATE_PLAYER_TURRET_1_LVL_7,
      TEMPLATE_PLAYER_TURRET_1_LVL_8,
      TEMPLATE_PLAYER_TURRET_1_LVL_9,
      TEMPLATE_PLAYER_TURRET_1_LVL_10,
      TEMPLATE_PLAYER_TURRET_1_LVL_11,
      TEMPLATE_PLAYER_TURRET_1_LVL_12,
      TEMPLATE_PLAYER_TURRET_1_LVL_13,
      TEMPLATE_PLAYER_TURRET_1_LVL_14,
      TEMPLATE_PLAYER_TURRET_1_LVL_15,
   }
};