require("app/template/store/cost");
require('app/template/template');
require("app/template/player-levels/stats_template");

local DAMAGE_K       = 0.50;
local SIZE_K         = 0.85;
local COST_K         = 5.0*1.5;

local TEMPLATE_PROJECTILE_LVL_0 =
{
   speed             =  { 0, 2000 }, 
   spin              = 0, 
   width             = 40,
   height            = 80,  
   collisionWidth    = 40,
   collisionHeight   = 100,
};

local TEMPLATE_PROJECTILE_LVL_1    = Template.extent(TEMPLATE_PROJECTILE_LVL_0);
local TEMPLATE_PROJECTILE_LVL_2    = Template.extent(TEMPLATE_PROJECTILE_LVL_1);
local TEMPLATE_PROJECTILE_LVL_3    = Template.extent(TEMPLATE_PROJECTILE_LVL_2);
local TEMPLATE_PROJECTILE_LVL_4    = Template.extent(TEMPLATE_PROJECTILE_LVL_3);
local TEMPLATE_PROJECTILE_LVL_5    = Template.extent(TEMPLATE_PROJECTILE_LVL_4);
local TEMPLATE_PROJECTILE_LVL_6    = Template.extent(TEMPLATE_PROJECTILE_LVL_5);
local TEMPLATE_PROJECTILE_LVL_7    = Template.extent(TEMPLATE_PROJECTILE_LVL_6);
local TEMPLATE_PROJECTILE_LVL_8    = Template.extent(TEMPLATE_PROJECTILE_LVL_7);
local TEMPLATE_PROJECTILE_LVL_9    = Template.extent(TEMPLATE_PROJECTILE_LVL_8);
local TEMPLATE_PROJECTILE_LVL_10   = Template.extent(TEMPLATE_PROJECTILE_LVL_9);
local TEMPLATE_PROJECTILE_LVL_11   = Template.extent(TEMPLATE_PROJECTILE_LVL_10);
local TEMPLATE_PROJECTILE_LVL_12   = Template.extent(TEMPLATE_PROJECTILE_LVL_11);
local TEMPLATE_PROJECTILE_LVL_13   = Template.extent(TEMPLATE_PROJECTILE_LVL_12);
local TEMPLATE_PROJECTILE_LVL_14   = Template.extent(TEMPLATE_PROJECTILE_LVL_13);
local TEMPLATE_PROJECTILE_LVL_15   = Template.extent(TEMPLATE_PROJECTILE_LVL_14);

TEMPLATE_PROJECTILE_LVL_1["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][1];
TEMPLATE_PROJECTILE_LVL_1["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level61.png';
TEMPLATE_PROJECTILE_LVL_1["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_1["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_1["speed"]              = { 0, 1500 };
TEMPLATE_PROJECTILE_LVL_2["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][2];
TEMPLATE_PROJECTILE_LVL_2["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level62.png';
TEMPLATE_PROJECTILE_LVL_2["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_2["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_3["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][3];
TEMPLATE_PROJECTILE_LVL_3["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level63.png';
TEMPLATE_PROJECTILE_LVL_3["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_3["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_4["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][4];
TEMPLATE_PROJECTILE_LVL_4["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level64.png';
TEMPLATE_PROJECTILE_LVL_4["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_4["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_4["speed"]              = { 0, 1600 };
TEMPLATE_PROJECTILE_LVL_5["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][5];
TEMPLATE_PROJECTILE_LVL_5["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level65.png';
TEMPLATE_PROJECTILE_LVL_5["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_5["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_6["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][6];
TEMPLATE_PROJECTILE_LVL_6["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level66.png';
TEMPLATE_PROJECTILE_LVL_6["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_6["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_7["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][7];
TEMPLATE_PROJECTILE_LVL_7["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level67.png';
TEMPLATE_PROJECTILE_LVL_7["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_7["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_7["speed"]              = { 0, 1750 };
TEMPLATE_PROJECTILE_LVL_8["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][8];
TEMPLATE_PROJECTILE_LVL_8["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level68.png';
TEMPLATE_PROJECTILE_LVL_8["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_8["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_9["damage"]             = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][9];
TEMPLATE_PROJECTILE_LVL_9["texture"]            = 'resources/Vehicle/BulletEffects/Bullet_Level69.png';
TEMPLATE_PROJECTILE_LVL_9["width"]              = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_9["height"]             = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_10["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][10];
TEMPLATE_PROJECTILE_LVL_10["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level70.png';
TEMPLATE_PROJECTILE_LVL_10["width"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_10["height"]            = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_10["speed"]              = { 0, 1950 };
TEMPLATE_PROJECTILE_LVL_11["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][11];
TEMPLATE_PROJECTILE_LVL_11["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level71.png';
TEMPLATE_PROJECTILE_LVL_11["width"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_11["height"]            = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_12["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][12];
TEMPLATE_PROJECTILE_LVL_12["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level72.png';
TEMPLATE_PROJECTILE_LVL_12["width"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_12["height"]            = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_13["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][13];
TEMPLATE_PROJECTILE_LVL_13["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level73.png';
TEMPLATE_PROJECTILE_LVL_13["width"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_13["height"]            = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_13["speed"]              = { 0, 2200 };
TEMPLATE_PROJECTILE_LVL_14["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][14];
TEMPLATE_PROJECTILE_LVL_14["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level74.png';
TEMPLATE_PROJECTILE_LVL_14["width"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_14["height"]            = SIZE_K*128;
TEMPLATE_PROJECTILE_LVL_15["damage"]            = DAMAGE_K*TEMPLATE_PLAYER_BASE_DMG["novacar"][15];
TEMPLATE_PROJECTILE_LVL_15["texture"]           = 'resources/Vehicle/BulletEffects/Bullet_Level75.png';
TEMPLATE_PROJECTILE_LVL_15["width"]             = SIZE_K*64;
TEMPLATE_PROJECTILE_LVL_15["height"]            = SIZE_K*128;


local TEMPLATE_WEAPON_LVL_0 =
{ 
   delay             = 3/30,
   shootDelta        = { { -50, -20 }, { 50, -20 } },
   shootAngle        = { 12.5, -12.5},
   width             = 124,
   height            = 040,
   texture           = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Sideweapon.png";

};

local TEMPLATE_WEAPON_LVL_1    = Template.extent(TEMPLATE_WEAPON_LVL_0);
local TEMPLATE_WEAPON_LVL_2    = Template.extent(TEMPLATE_WEAPON_LVL_1);
local TEMPLATE_WEAPON_LVL_3    = Template.extent(TEMPLATE_WEAPON_LVL_2);
local TEMPLATE_WEAPON_LVL_4    = Template.extent(TEMPLATE_WEAPON_LVL_3);
local TEMPLATE_WEAPON_LVL_5    = Template.extent(TEMPLATE_WEAPON_LVL_4);
local TEMPLATE_WEAPON_LVL_6    = Template.extent(TEMPLATE_WEAPON_LVL_5);
local TEMPLATE_WEAPON_LVL_7    = Template.extent(TEMPLATE_WEAPON_LVL_6);
local TEMPLATE_WEAPON_LVL_8    = Template.extent(TEMPLATE_WEAPON_LVL_7);
local TEMPLATE_WEAPON_LVL_9    = Template.extent(TEMPLATE_WEAPON_LVL_8);
local TEMPLATE_WEAPON_LVL_10   = Template.extent(TEMPLATE_WEAPON_LVL_9);
local TEMPLATE_WEAPON_LVL_11   = Template.extent(TEMPLATE_WEAPON_LVL_10);
local TEMPLATE_WEAPON_LVL_12   = Template.extent(TEMPLATE_WEAPON_LVL_11);
local TEMPLATE_WEAPON_LVL_13   = Template.extent(TEMPLATE_WEAPON_LVL_12);
local TEMPLATE_WEAPON_LVL_14   = Template.extent(TEMPLATE_WEAPON_LVL_13);
local TEMPLATE_WEAPON_LVL_15   = Template.extent(TEMPLATE_WEAPON_LVL_14);


TEMPLATE_WEAPON_LVL_1["cost"]      = NOVACAR_UNLOCK_SIDE_WEAPON_COST;
TEMPLATE_WEAPON_LVL_1["projectile"]= TEMPLATE_PROJECTILE_LVL_1;
TEMPLATE_WEAPON_LVL_2["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_02  };
TEMPLATE_WEAPON_LVL_2["projectile"]= TEMPLATE_PROJECTILE_LVL_2;
TEMPLATE_WEAPON_LVL_3["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_03  };
TEMPLATE_WEAPON_LVL_3["projectile"]= TEMPLATE_PROJECTILE_LVL_3;
TEMPLATE_WEAPON_LVL_4["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_04  };
TEMPLATE_WEAPON_LVL_4["projectile"]= TEMPLATE_PROJECTILE_LVL_4;
TEMPLATE_WEAPON_LVL_5["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_05  };
TEMPLATE_WEAPON_LVL_5["projectile"]= TEMPLATE_PROJECTILE_LVL_5;
TEMPLATE_WEAPON_LVL_6["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_06  };
TEMPLATE_WEAPON_LVL_6["projectile"]= TEMPLATE_PROJECTILE_LVL_6;
TEMPLATE_WEAPON_LVL_7["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_07  };
TEMPLATE_WEAPON_LVL_7["projectile"]= TEMPLATE_PROJECTILE_LVL_7;
TEMPLATE_WEAPON_LVL_8["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_08  };
TEMPLATE_WEAPON_LVL_8["projectile"]= TEMPLATE_PROJECTILE_LVL_8;
TEMPLATE_WEAPON_LVL_9["cost"]      = { gold = COST_K*TEMPLATE_BASE_COST_09  };
TEMPLATE_WEAPON_LVL_9["projectile"]= TEMPLATE_PROJECTILE_LVL_9;
TEMPLATE_WEAPON_LVL_10["cost"]     = { gold = COST_K*TEMPLATE_BASE_COST_10  };
TEMPLATE_WEAPON_LVL_10["projectile"]= TEMPLATE_PROJECTILE_LVL_10;
TEMPLATE_WEAPON_LVL_11["cost"]     = { gold = COST_K*TEMPLATE_BASE_COST_11  };
TEMPLATE_WEAPON_LVL_11["projectile"]= TEMPLATE_PROJECTILE_LVL_11;
TEMPLATE_WEAPON_LVL_12["cost"]     = { gold = COST_K*TEMPLATE_BASE_COST_12  };
TEMPLATE_WEAPON_LVL_12["projectile"]= TEMPLATE_PROJECTILE_LVL_12;
TEMPLATE_WEAPON_LVL_13["cost"]     = { gold = COST_K*TEMPLATE_BASE_COST_13  };
TEMPLATE_WEAPON_LVL_13["projectile"]= TEMPLATE_PROJECTILE_LVL_13;
TEMPLATE_WEAPON_LVL_14["cost"]     = { gold = COST_K*TEMPLATE_BASE_COST_14  };
TEMPLATE_WEAPON_LVL_14["projectile"]= TEMPLATE_PROJECTILE_LVL_14;
TEMPLATE_WEAPON_LVL_15["cost"]     = { gold = COST_K*TEMPLATE_BASE_COST_15  };
TEMPLATE_WEAPON_LVL_15["projectile"]= TEMPLATE_PROJECTILE_LVL_15;




-- print("SIDE");
-- print("TEMPLATE_PROJECTILE_LVL_1['damage']",TEMPLATE_PROJECTILE_LVL_1["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_2['damage']",TEMPLATE_PROJECTILE_LVL_2["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_3['damage']",TEMPLATE_PROJECTILE_LVL_3["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_4['damage']",TEMPLATE_PROJECTILE_LVL_4["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_5['damage']",TEMPLATE_PROJECTILE_LVL_5["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_6['damage']",TEMPLATE_PROJECTILE_LVL_6["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_7['damage']",TEMPLATE_PROJECTILE_LVL_7["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_8['damage']",TEMPLATE_PROJECTILE_LVL_8["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_9['damage']",TEMPLATE_PROJECTILE_LVL_9["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_10['damage']",TEMPLATE_PROJECTILE_LVL_10["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_11['damage']",TEMPLATE_PROJECTILE_LVL_11["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_12['damage']",TEMPLATE_PROJECTILE_LVL_12["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_13['damage']",TEMPLATE_PROJECTILE_LVL_13["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_14['damage']",TEMPLATE_PROJECTILE_LVL_14["damage"]);
-- print("TEMPLATE_PROJECTILE_LVL_15['damage']",TEMPLATE_PROJECTILE_LVL_15["damage"]);




TEMPLATE_PLAYER_VEHICLE_NOVACAR_SIDE_WEAPON =
{
   version = 21,
   
   level   =
   {
      TEMPLATE_WEAPON_LVL_1,
      TEMPLATE_WEAPON_LVL_2,
      TEMPLATE_WEAPON_LVL_3,
      TEMPLATE_WEAPON_LVL_4,
      TEMPLATE_WEAPON_LVL_5,
      TEMPLATE_WEAPON_LVL_6,
      TEMPLATE_WEAPON_LVL_7,
      TEMPLATE_WEAPON_LVL_8,
      TEMPLATE_WEAPON_LVL_9,
      TEMPLATE_WEAPON_LVL_10,
      TEMPLATE_WEAPON_LVL_11,
      TEMPLATE_WEAPON_LVL_12,
      TEMPLATE_WEAPON_LVL_13,
      TEMPLATE_WEAPON_LVL_14,
      TEMPLATE_WEAPON_LVL_15,
   }
};
-------------------------------------------------------------------------------------
