----------------------------------------------------------------------

Template = {};

----------------------------------------------------------------------

function Template.extent( base )

   local tpl2            = {};
   tpl2.__index          = base;
   tpl2.__fixupMetatable = tpl2;
   setmetatable( tpl2, tpl2 );
   return tpl2;
   
end

----------------------------------------------------------------------

function Template.fixup( tpl )

   if tpl.__fixupMetatable then   
      setmetatable( tpl, tpl.__fixupMetatable);
   end
   
   for k,v in pairs(tpl) do
      --make sure it is not us, a table and it was not fixedup yet
      if v ~= tpl and type(v) == 'table' and getmetatable(tpl) == nil then
         Template.fixup(v);
      end
   end

end

----------------------------------------------------------------------

function Template.clone( tpl )

	local t = {}

	for k,v in pairs(tpl) do
		if type(v) == "table" then
			t[k] = Template.clone(v);
		else
			t[k] = v;
		end
	end

	return t;

end

----------------------------------------------------------------------

function Template.addDataFromMap( template, tbl )
   for k, v in pairs(tbl) do
      template[k] = v;
   end
end
