require('engine/event/event-manager')
require('engine/object/object')

----------------------------------------------------------------------

local Base  = Object;
MissionGoal = Base:new();

----------------------------------------------------------------------

function MissionGoal:new( mission, index, template  )

   local goal     = Base.new( self );

   goal.template  = template;
   goal.mission   = mission;
   goal.index     = index;
   goal.active    = false;
   goal.completed = false;
   goal.cumulativeScore     = 0;

   return goal;

end

----------------------------------------------------------------------

function MissionGoal:delete()

end

----------------------------------------------------------------------

function MissionGoal:activate()

   if not App.data:isCurrentMissionGoalCompleted( self.index ) then

      self.active = true;
      self.cumulativeScore  = App.data:getCurrentMissionGoalProgress(self.index);


      EventMgr:addListener( self, self.onGameStart , "game-start" );
   else
      self.cumulativeScore = -1;
      self.completed = true;
   end
end

----------------------------------------------------------------------

function MissionGoal:deactivate()

   self.active = false;

   EventMgr:rmvListener( self );

end

----------------------------------------------------------------------

function MissionGoal:markAsCompleted()

   self.cumulativeScore = -1;
   self.completed = true;

end

----------------------------------------------------------------------

function MissionGoal:onGameStart()

print("MissionGoal:onGameStart");


end

----------------------------------------------------------------------

function MissionGoal:isActive()

   return self.active;

end

----------------------------------------------------------------------

function MissionGoal:isCompleted()

   return self.completed;

end

----------------------------------------------------------------------

function MissionGoal:_OnCompleted()

print("MissionGoal:_OnCompleted");

   self.completed = true;

   local curMis = App.data:getMissionIndex();

   App.data:updateMissionGoal(  curMis, self.index, -1 );

   EventMgr:rmvListener( self );


   self.mission:onGoalCompleted( self );

end

----------------------------------------------------------------------