require("engine/network/request")
require("engine/utility/stringUtils");


function newFunc(self, options)

   Debug.assertType(options, {"table", "userdata"}, "PushWebRequest.new -> options");

   Debug.assertType(options.url,            "string",           "PushWebRequest.new -> options.url");
   Debug.assertType(options.retryCount,     "number",           "PushWebRequest.new -> options.retryCount");
--   Debug.assertType(options.data,           {"nil", "table"},   "PushWebRequest.new -> options.data");
   Debug.assertType(options.timeoutTime,    {"nil", "number"},  "PushWebRequest.new -> options.timeoutTime");
   Debug.assertType(options.ignoreResponse, {"nil", "boolean"}, "PushWebRequest.new -> options.ignoreResponse");
    -- print("PushWebRequest_new data string: ",tostring(options.data));

   self.typeName = PushWebRequest.typeName;
   self.url = options.url;


if options.data ~= nil then
   local data = getHashForPayload(options.data);
   self.data = data;
end

   self.retryCount = options.retryCount;
   self.timeoutTime = options.timeoutTime;

   if options.ignoreResponse ~= nil then
      self.ignoreResponse = options.ignoreResponse
   else
      self.ignoreResponse = false;
   end

end

function getHashForPayload(data)

    local secret = "QV@ruNkqM,$]q?8HgB_b~ALv1";
    print("PushWebRequest_new data string: ",data, " secret = ", secret);
    local encodedDataString = data;-- StringUtils.urlEncode(data);
--    print("PushWebRequest_new URL Encoded data string: *"..encodedDataString.."*");
    print("PushWebRequest_new URL Encoded data string: \n");

    local len = encodedDataString:len();
    local reps = math.ceil(len / 100);
    for i = 0, (reps - 1) do
        local m = (100 * i + 1);
        local l = 99;
        if i == 0  then l = 100; end
        print(string.sub(encodedDataString, m,m+l));
    end
    print("\n");

    local plainText = encodedDataString .. "&".. secret;
    print("PushWebRequest_new plain text send for SHA1 encryption: *"..plainText.."*");

    local hashWriter = MOAIHashWriter.new();
    hashWriter:openSHA1(hashWriter);
    hashWriter:write(plainText);
    local keyValue = hashWriter:getHashHex();
    print("PushWebRequest_new key (SHA1) = ", keyValue );

    local hashedPayload = { key = keyValue,payload = encodedDataString };

    return hashedPayload;

end

PushWebRequest = createClass(newFunc, Request);
PushWebRequest.typeName = "PushWebRequest";

