----------------------------------------------------------------------

Object =
{
};

----------------------------------------------------------------------

function Object:new( o  )

   o            =  o or  {};
   self.__index = self;
   setmetatable(o, self);

   return o;

end

----------------------------------------------------------------------

function createClass(constructor, baseClass)

   Debug.assertType(constructor, "function", "createClass -> constructor");
   Debug.assertType(baseClass, {"nil", "table"}, "createClass -> baseClass");

   local newClass = {};
   local newClass_mt = { __index = newClass };

   function newClass.new(...)

      local obj = {};

      setmetatable(obj, newClass);

      constructor(obj, ...);

      return obj;

   end

   if baseClass then

      -- This function calls the base constructor first, then applies the newClass constructor.
      -- TODO This function won't work for inheritance chains deeper than 2.
      function newClass.newFromBase(...)

         local obj = baseClass.new(...);

         setmetatable(obj, newClass);

         constructor(obj, ...);

         return obj;

      end

      setmetatable(newClass, { __index = baseClass });

   end

   return newClass;

end
