require('engine/utility/math');
require('engine/utility/tableUtil');

-------------------------------------------------------------------------------------

random = {};

-------------------------------------------------------------------------------------

random.pickWeighted = function ( weightTable, objTable, filterFunc, ... )

	Debug.assert(weightTable and type(weightTable) == "table");

	if objTable then
		if type(objTable) ~= "table" then
			Debug.error("random.pickWeighted objTable type not table");
		elseif not areTblKeysMatch(weightTable, objTable) then
			Debug.error("random.pickWeighted weightTable and objTable key mismatch");
		end
	end

   local pick = nil;
   local sum = 0;

   for k,weight in pairs(weightTable) do

      if weight and weight > 0 then

			local shouldFilter = false;

			if filterFunc and objTable then
				shouldFilter = not filterFunc(objTable[k], ...);
			end

			if not shouldFilter then
				local rand = math.random();

				sum = sum + weight;

				if (sum * rand) <= weight then
					pick = k
				end
			end
      end
   end

	if objTable then
		pick = objTable[k];
	end

   return pick;

end

-------------------------------------------------------------------------------------

random.mapClamped = function ( min, max )

	Debug.assert(min and type(min) == "number")
	Debug.assert(max and type(max) == "number")

	return math.mapClamped( 0, min, 1, max, math.random() );

end

-------------------------------------------------------------------------------------
