
-- Concatenate parameters from a table onto a base URL
function NativeAdRetriever:_buildURLWithParameters(baseURL, paramTable)

   Debug.assert(type(paramTable) == "table");

   local concatTable = {}

   table.insert(concatTable, baseURL);

   local paramSymbol = "?"

   for k, v in pairs(paramTable) do
      -- TODO Escape parameter strings

      if v ~= "" then
         table.insert(concatTable, paramSymbol .. k .. "=" .. v);
         paramSymbol = "&"
      end
   end

   -- Defer final string creation until here; this is faster than recreating many strings
   return table.concat(concatTable);

end
