-------------------------------------------------------------------------------------
require('engine/utility/math');
-------------------------------------------------------------------------------------

Collision = {};

-------------------------------------------------------------------------------------

function Collision:_new( c )

   c            =  c or  {};
   setmetatable(c, self);
   self.__index = self;

   return c;

end

-------------------------------------------------------------------------------------

function Collision:checkCollision( e1, e2 )

   if e1.austin:isCollideEntity( e2.austin ) then
      
      local codeCollision = MoaiRoadRiotCollision:new();
      
      codeCollision:setEntity(     e1.austin, e2.austin              );
      codeCollision:setEntityLoc(  e1.austin, e1:getLoc()            );
      codeCollision:setEntitySize( e1.austin, e1:getCollisionSize()  );
      codeCollision:setEntityMass( e1.austin, e1:getMass()           );
      codeCollision:setEntitySpeed(e1.austin, e1:getSpeed(true)      );
      codeCollision:setEntityLoc(  e2.austin, e2:getLoc()            );
      codeCollision:setEntitySize( e2.austin, e2:getCollisionSize()  );
      codeCollision:setEntityMass( e2.austin, e2:getMass()           );
      codeCollision:setEntitySpeed(e2.austin, e2:getSpeed(true)      );

      local colide2 = codeCollision:checkCollision(true);

      --should always be true (we checked before)
      if colide2 then

         local c     = Collision:_new();
         c._internal = codeCollision;
         c.e1        = e1;
         c.e2        = e2;
         
         if codeCollision:getType() == MoaiRoadRiotCollision.X then
            c.type = X;
         else
            c.type = Y;
         end
         
         return c;
         
      else
      
         print("COLLISION ERROR... collide2 is false");
         
      end
   end
end

----------------------------------------------------------------------

function Collision:getOther( e )

   if e == self.e1 then
      return self.e2;
   else
      return self.e1;
   end
end

----------------------------------------------------------------------

function Collision:getImpactLoc()

   return self._internal:getImpactLoc();

end

----------------------------------------------------------------------

function Collision:getEntityLoc( e )

   return self._internal:getEntityLoc(e.austin);
end

----------------------------------------------------------------------

function Collision:getNewLoc( e )

   return self._internal:getEntityNewLoc(e.austin);

end

----------------------------------------------------------------------

function Collision:getImpulse( e )

   return self._internal:getEntityImpulse(e.austin);

end

----------------------------------------------------------------------

function Collision:getDelta( e )

   return self._internal:getEntityDelta(e.austin);

end

----------------------------------------------------------------------

function Collision:getExpel( e )

   return self._internal:getEntityExpel(e.austin);

end

-------------------------------------------------------------------------------------
