require('game/entity/entity');

----------------------------------------------------------------------

local PROJECTILE_SPAWN_DELTA_Y   =  40;

----------------------------------------------------------------------

AvatarMainWeapon = Entity:new();

----------------------------------------------------------------------

function AvatarMainWeapon:new( game, layer, template, x, y, owner )

   local ap = Entity.new( self, game, layer, template, x, y, 0, avatar );
   ap.sounds = template.sounds;

print("AvatarMainWeapon:new( game, layer, template, x, y, owner )", game, layer, template, x, y, owner );

   return ap;

end

----------------------------------------------------------------------

function AvatarMainWeapon:reset(  x, y, a, owner )

   Entity:reset(  x, y, a );

   self.owner = owner;
   
   self.shootDelay         = 0;

   if owner then
      self.prop:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.owner.prop, MOAIProp2D.TRANSFORM_TRAIT );
   end
   
end

----------------------------------------------------------------------

function AvatarMainWeapon:update( dt, burstOn )

   self.shootDelay = self.shootDelay - dt;

   if self.shootDelay <= 0.001 then

      local x, y  = self:getLoc(true);

      if self.owner.powerups["powerup_double"] then
      
         if not self.owner.firingLoop then
            self.owner.firingLoop = true;
            EventMgr:postEvent( {sounds=self.owner.mainWeapon.sounds, name="avatarmainweapon update",useAlt=true}, "add-sfx" );
         end
      
         for i=1,2 do

            local p = self.game.entityMgr:spawnProjectile(  self.template.projectile,
                                                            self.template.doubleDelta[i]+x,
                                                            PROJECTILE_SPAWN_DELTA_Y+y,
                                                            0,
                                                            self.owner                                   );

            p.speedBurst = burstOn;
         end
      else
      
         if not self.owner.firingLoop and HACK_GUN_OR_IMPACT == 0 then
            self.owner.firingLoop = true;
            EventMgr:postEvent( {sounds=self.owner.mainWeapon.sounds, name="avatarmainweapon update",}, "add-sfx" );
         end

         local p = self.game.entityMgr:spawnProjectile(  self.template.projectile,
                                                         x,
                                                         y+PROJECTILE_SPAWN_DELTA_Y,
                                                         0,
                                                         self.owner                                      );

         p.speedBurst = burstOn;


      end

      self.shootDelay  = self.template.delay;

   end
   
end

----------------------------------------------------------------------