require('game/entity/entity');

----------------------------------------------------------------------

local PROJECTILE_SPAWN_DELTA_Y   =  40;

----------------------------------------------------------------------

AvatarSideWeapon = Entity:new();

----------------------------------------------------------------------

function AvatarSideWeapon:new( game, layer, template, x, y, owner, offset )

   local ap = Entity.new( self, game, layer, template, x, y, 0, avatar, offset );

print("AvatarSideWeapon:new( game, layer, template, x, y, owner, offset )", game, layer, template, x, y, owner, offset );

   return ap;

end

----------------------------------------------------------------------

function AvatarSideWeapon:reset(  x, y, a, owner, offset )

   Entity:reset(  x, y, a );

   self.owner				= owner;
	self.parentOffset		= offset;
   
   self.shootDelay         = 0;

   if owner then
      self.prop:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.owner.prop, MOAIProp2D.TRANSFORM_TRAIT );
		self:setLoc( self.parentOffset[1], self.parentOffset[2] );
   end
   
end

----------------------------------------------------------------------

function AvatarSideWeapon:update( dt, burstOn )

   self.shootDelay = self.shootDelay - dt;

   if self.shootDelay <= 0.001 then

      local x, y  = self:getLoc(true);

      for i=1,2 do

         local p = self.game.entityMgr:spawnProjectile(  self.template.projectile,
                                                         x+self.template.shootDelta[i][1],
                                                         y+self.template.shootDelta[i][2],
                                                         self.template.shootAngle[i],
                                                         self.owner                                      );

         p.speedBurst = burstOn;
                                                
      end
      
      self.shootDelay  = self.template.delay;

   end
   
end

----------------------------------------------------------------------