require('game/entity/entity');

----------------------------------------------------------------------

local Base = Entity;

BarricadeDecal = Base:new();

----------------------------------------------------------------------

function BarricadeDecal:new( game, layer, template,  x, y, a, owner )

   local e = Base.new(self, game, layer, template, x, y, a, owner );
   return e;

end

----------------------------------------------------------------------

function BarricadeDecal:reset( x, y, angle, owner )

   Base.reset( self, x, y, angle );

   self.owner = owner;
   self.done = false;

   local x,y = self:getLoc();

   x = x + self.template.delta[1];
   y = y + self.template.delta[2];

   self:setLoc(x,y);

end

----------------------------------------------------------------------

function BarricadeDecal:update( dt, avatarSpeedY )

   Base.update( self, dt, avatarSpeedY );

   self.done = (self:getLocY() + self:getHeight()/2) < self.game.boundary.min.y;

end

----------------------------------------------------------------------

function BarricadeDecal:isDone()
   return self.done;
end

----------------------------------------------------------------------