require('game/entity/flyout/flyout');

----------------------------------------------------------------------

FlyoutText = Flyout:new();

----------------------------------------------------------------------

function FlyoutText:new( game, layer, template,  x, y, a, text )

   local e = Flyout.new( self, game, layer, template, x, y, a, text );

	e.textBox:setPriority(10);

	if template.dropShadow then
		e.dropShadow = Flyout.new( self, game, layer, template, 2, 2, a, text);
		e.dropShadow.textBox:setScl(1, -1);
		e.dropShadow.textBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, e.textBox, MOAIProp2D.TRANSFORM_TRAIT );
	end

   return e;

end

----------------------------------------------------------------------

function FlyoutText:reset( x, y, angle, text )

   Flyout.reset( self, x, y, angle );

   if text then
      self.textBox:setString(text);

		if self.dropShadow then
			self.dropShadow.textBox:setString(text);
		end
   else
      self.textBox:setString("");

		if self.dropShadow then
			self.dropShadow.textBox:setString("");
		end
   end
end

----------------------------------------------------------------------

function FlyoutText:delete()

	Flyout.delete(self);

	if self.dropShadow then
		self.dropShadow:delete();
	end

end

----------------------------------------------------------------------

function FlyoutText:hide()

	Flyout.hide(self);

	if self.dropShadow then
		self.dropShadow:hide();
	end

end

----------------------------------------------------------------------

function FlyoutText:show()

	Flyout.show(self);

	if self.dropShadow then
		self.dropShadow:show();
	end

end

----------------------------------------------------------------------