require('game/entity/entity');

----------------------------------------------------------------------

local AIR_STRIKE_BOMBER_STATE_WAIT     = 1;
local AIR_STRIKE_BOMBER_STATE_GOING    = 2;
local AIR_STRIKE_BOMBER_STATE_DONE     = 3;

----------------------------------------------------------------------

AirStrikeBomber = Entity:new();

----------------------------------------------------------------------

function AirStrikeBomber:new( game, layer, template, x, y, a, owner )

   local e = Entity.new( self, game, layer, template, x, y, a, owner );

   e.delay = template.delay;

   return e;
   
end

----------------------------------------------------------------------

function AirStrikeBomber:reset( x, y, angle, owner )

   Entity.reset( self, x, y, angle , owner );

   self.age             = 0;
   self.state           = AIR_STRIKE_BOMBER_STATE_WAIT;
   self.owner           = owner;
   self:setSpeedY( 0 );

   self:hide();

end

----------------------------------------------------------------------

function AirStrikeBomber:update ( dt )

   Entity.update(self, dt);

   if self.state == AIR_STRIKE_BOMBER_STATE_WAIT then

      self:setLocX(self.owner:getLocX());

      if self.age > self.delay then
         self:show();
         self:setSpeedY( self.template.speed[2]);
         self.state    = AIR_STRIKE_BOMBER_STATE_GOING;
      end

   elseif self.state == AIR_STRIKE_BOMBER_STATE_GOING then

      if self:getLocY() < (self.game.boundary.min.y-self:getHeight()) then
         self:hide();
         self.state = AIR_STRIKE_BOMBER_STATE_DONE;
      end
   end

   return self.state == AIR_STRIKE_BOMBER_STATE_DONE;

end

----------------------------------------------------------------------

function AirStrikeBomber:isDone (  )

   return self.state == AIR_STRIKE_BOMBER_STATE_DONE;

end