require('game/entity/powerup/powerup');

----------------------------------------------------------------------

local Base     = Powerup;
PowerupMagnet  = Base:new();

----------------------------------------------------------------------

function PowerupMagnet:new( game, layer, template,  x, y, a, owner )

   return Base.new( self,  game, layer, template,  x, y, a, owner);

end

----------------------------------------------------------------------

function PowerupMagnet:reset( x, y, angle, owner )

   Base.reset( self, x, y, angle, owner );

	self._pulseTimer	= 0;

	if self.prop and self.template then
		self.prop:setScl(1, 1);
		self.prop:setColor(self.template.color[1], self.template.color[2], self.template.color[3], self.template.color[4]);
		self.prop:setVisible(false);
	end

end

----------------------------------------------------------------------

function PowerupMagnet:update( dt )

	Base.update( self, dt );

	if self.game and self.game.avatar and not self.game.avatar:isDead() then
		self._pulseTimer = self._pulseTimer + dt;

		if self._pulseTimer >= self.template.pulseTime then
			self._pulseTimer = 0;
		end

		local k	= math.mapClamped( 0, 1, self.template.pulseTime, 0, self._pulseTimer );
		local a	= math.mapClamped( 0, self.template.color[4] or 1, self.template.pulseTime, 0,  self._pulseTimer );

		if a <= 0 then
			self.prop:setVisible(false);
		else
			self.prop:setVisible(true);

			self.prop:setScl(k, k);
			self.prop:setColor(self.template.color[1], self.template.color[2], self.template.color[3], a);
		end
	else
		self.prop:setScl(1, 1);
		self.prop:setColor(self.template.color[1], self.template.color[2], self.template.color[3], self.template.color[4]);
		self.prop:setVisible(false);

		self._pulseTimer = 0;
	end

end

----------------------------------------------------------------------

function PowerupMagnet:isDone()

	if self.template.duration < 0 then
		return false;
	else
		return Base.isDone(self);
	end

end


----------------------------------------------------------------------
