require('game/entity/entity');

----------------------------------------------------------------------

Powerup = Entity:new();

----------------------------------------------------------------------

function Powerup:new( game, layer, template,  x, y, a, owner )

   local e = Entity.new( self,  game, layer, template,  x, y, a, owner);
   
   if e.template then
      e.sounds = template.sounds;
      e.type = template.type;
   end

   return e;
end

----------------------------------------------------------------------

function Powerup:reset( x, y, angle, owner )

   Entity.reset( self, x, y, angle );

   self.owner     = owner;
   self.invicible = self.template.invicible;
   
   if       (self.owner and self.owner.powerups and self.owner.powerups["powerup_powertime"])
        and (self.template and self.template.moreTimeScalar)                                        then
      self.duration  = self.template.duration * self.template.moreTimeScalar;
   else
      self.duration  = self.template.duration;
   end
   
   if self.prop  and owner and owner.prop then
   
      self.prop:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, owner.prop, MOAIProp2D.TRANSFORM_TRAIT )

   end
   
   if self.template.offset then
      self:setLoc(self.template.offset[1],self.template.offset[2])
   else
      self:setLoc(0,0)
   end
   
end

----------------------------------------------------------------------

function Powerup:isDone()

   return self:getAge() > self.duration;

end

----------------------------------------------------------------------

function Powerup:isInvicible()

   return self.invicible;

end

----------------------------------------------------------------------
