require('game/entity/turret/turret');

----------------------------------------------------------------------

local TURRET_DISABLED                     = 1;
local TURRET_SLEEP                        = 2;
local TURRET_AIM                          = 3;
local TURRET_SHOOT                        = 4;
local TURRET_ON_SCREEN_DELTA              = 25;
local TURRET_TARGET_AVATER_VALID_OFFSET   = 50;
local TURRET_TARGET_AI                    = 1;
local TURRET_TARGET_AVATAR                = 2;

----------------------------------------------------------------------

local Base     = Turret;
TurretMagnet   = Base:new();

----------------------------------------------------------------------

function TurretMagnet:new(  game, layer, template, x, y, angle, parent, offset )

print("TurretMagnet:new", template, template.texture );

   local e = Base.new( self, game, layer, template, x, y, angle, parent, offset );

   --call here because avatar doesnt get called yet
   e:reset( x, y, angle, parent, offset  );

print("game.entityMgr:spawnPowerup", template.tplPowerup.factory, template.tplPowerup, x, y, 0, self);
   e.powerup = game.entityMgr:spawnPowerup( template.tplPowerup.factory, template.tplPowerup, x, y, 0, self );

   return e;

end

----------------------------------------------------------------------

function TurretMagnet:reset( x, y, angle, parent, offset )

   print("TurretMagnet:reset");

   Base.reset( self, x, y, angle, parent, offset );

   if self.powerup then

      self.powerup:reset(  x, y, angle, self );

      if self.game then
         self.game:disablePickup( PICKUP_MAGNET_INDEX );
      end
   end

end

----------------------------------------------------------------------

function TurretMagnet:update( dt, avatarSpeedY )

   Base.update( self, dt, avatarSpeedY );

   if self.powerup then
      self.powerup:update(  dt );
   end

end

----------------------------------------------------------------------

function TurretMagnet:getMagnetRadius()

   return self.powerup.template.radius;

end

----------------------------------------------------------------------

function TurretMagnet:onPickup( p )

end


----------------------------------------------------------------------