require('game/entity/entity');

----------------------------------------------------------------------

Turret = Entity:new();

----------------------------------------------------------------------

function Turret:new(  game, layer, template,  x, y, angle, parent, offset )

   local e = Entity.new( self, game, layer, template, x, y, angle, parent, offset );

   if template then

      --call here because avatar doesnt get called yet
      e:reset( x, y, angle, parent, offset  );

   end

   return e;

end

----------------------------------------------------------------------

function Turret:reset( x, y, angle, parent, offset )

   Entity.reset( self, x, y, angle );

   self.state         = TURRET_SLEEP;
   self.angle         = angle;
   self.parent        = parent;
   self.parentOffset  = offset;
   self.maxTurnRate   = self.template.maxTurnRate   or 360;

   if self.template.angleLimit then
      self.angleLimit  = { min=self.template.angleLimit.min, max=self.template.angleLimit.max };
   else
      self.angleLimit = nil;
   end

   if self.template.pivot then
      self.prop:setPiv(self.template.pivot[1],self.template.pivot[2]);
   end

	if parent then
		self.prop:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, parent.prop, MOAIProp2D.TRANSFORM_TRAIT );
		self:setLoc( self.parentOffset[1], self.parentOffset[2] );
	end

end

----------------------------------------------------------------------

function Turret:update( dt, avatarSpeedY )

   --Entity.update( self, dt, avatarSpeedY );

end

----------------------------------------------------------------------

function Turret:onPickup( p )

end

----------------------------------------------------------------------

function Turret:getMagnetRadius()

   return 0;

end

----------------------------------------------------------------------