----------------------------------------------------------------------
require('game/game-scenario/game-scenario');
----------------------------------------------------------------------

local Base = GameScenario;
GameScenarioAirStrike = Base:new();

----------------------------------------------------------------------

function GameScenarioAirStrike:new( director, game, template )

   local gs = GameScenario.new( self, director,game, template );

   gs.airStrikes = {};

   for i = 1, #template.airStrikes do

      local tpl = template.airStrikes[i];

      gs.airStrikes[i] = { template =  tpl };

      if  tpl.delayRnd  then
         gs.airStrikes[i].delay = tpl.delay + math.random()*tpl.delayRnd;
      else
         gs.airStrikes[i].delay = tpl.delay;
      end
   end


   gs.spawner:disableSpawn();

   return gs;

end

----------------------------------------------------------------------

function GameScenarioAirStrike:update( dt )

   Base.update( self, dt );

 --  if self.started
   for i=#self.airStrikes,1,-1 do

      local as = self.airStrikes[i];

      as.delay = as.delay-dt;

      if as.delay <= 0 then

         self.game.gameSpawner:spawnHazard(  as.template.airStrikeTpl,
                                             self.game:getLaneLocX(as.template.lane)
                                             , 0
                                             , nil );

         table.remove(self.airStrikes,i);

      end
   end
end

----------------------------------------------------------------------

function GameScenarioAirStrike:isDone()

   return #self.airStrikes== 0 and #self.game.entityMgr.hazards == 0 ;

end

----------------------------------------------------------------------

function GameScenarioAirStrike:onDeactivate()

end

----------------------------------------------------------------------

function GameScenarioAirStrike:onDone()

	self:onDeactivate();

   Base.onDone( self );

   self.spawner:enableSpawn();

end

----------------------------------------------------------------------
