----------------------------------------------------------------------
require('game/game-scenario/game-scenario');
----------------------------------------------------------------------
require('app/template/enemy-vehicles/daily-chopper')
----------------------------------------------------------------------

local Base        = GameScenario;
GameScenarioDaily = Base:new();

----------------------------------------------------------------------

function GameScenarioDaily:new( director, game, template )

print("game",game);

   local gs = GameScenario.new( self, director, game, template );

   gs.spawner:disableHazard();

   gs.chopper = gs.game.entityMgr:spawnChopper( TEMPLATE_DAILY_CHOPPER, 0, 0, 0, template.rail );
   
   gs.sounds = { start={ "DailyWarning" } };
   
   gs.warningSound = false;


   return gs;

end

----------------------------------------------------------------------

function GameScenarioDaily:update( dt )

   Base.update( self, dt );
   
   if not self.warningSound then
      EventMgr:postEvent( { sounds=self.sounds, name="daily update", }, "add-sfx" );
      self.warningSound = true;
   end


end

----------------------------------------------------------------------

function GameScenarioDaily:isDone()

   return self.chopper == nil or self.chopper:isDead() or self.chopper.deleteMe == true;

end

----------------------------------------------------------------------

function GameScenarioDaily:onDeactivate()

end

----------------------------------------------------------------------

function GameScenarioDaily:onDone()

	self:onDeactivate();

   local cSounds = { loop={"HeliLoop",},};
   
   EventMgr:postEvent( {sounds=cSounds, name="daily done",}, "loop-stop" );

   Base.onDone( self );
   
   self.warningSound = false;

   self.spawner:enableHazard();

end

----------------------------------------------------------------------
