require('app/template/enemy-vehicles/spawn_matrix')

----------------------------------------------------------------------

MAP01_VEHICLE_SPAWN_CHART =
{  
   
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   { 
      duration          = 5,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 1.00,   3.00, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 1,
      max               = { 0,      1,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0        },
      timeMin           = { 5.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    0.0      },
      timeMax           = {10.000,  0.100,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    1.0      },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 10,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.95,   2.95, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 2,
      max               = { 0,      2,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   { 
      duration          = 15,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.90,   2.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 3,
      max               = { 0,      2,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 20,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.85,   2.85, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 4,
      max               = { 1,      3,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 25,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.80,   2.80, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 5,
      max               = { 1,      3,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 30,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.75,   2.75, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 6,
      max               = { 1,      4,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.100,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 35,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.70,   2.70, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 7,
      max               = { 1,      4,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 40,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.65,   2.65, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 8,
      max               = { 1,      5,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.300,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 45,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.60,   2.60, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 9,
      max               = { 1,      5,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {10.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 50,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.55,   2.55, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      5,       1,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.500,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {11.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 55,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.50,   2.50, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      5,       1,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {11.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 60,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.45,   2.45, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      5,       2,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.700,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,    0.000,  0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {11.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 65,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.40,   2.40, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      5,       2,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,    0.000,  0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {11.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,    0.00,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 70,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.35,   2.35, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      4,       3,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 5.900,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   10.000,  0.000,   0.000,   0.00,    00.0,    00.0,    30.0     },
      timeMax           = {11.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,    0.00,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 75,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.30,   2.30, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      4,       3,       0,       0,       0,       0,       0,       0,       0,        0,       0,      0,       1        },
      timeMin           = { 6.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,    9.500,  0.000,   0.000,   10.00,    00.0,   00.0,    30.0     },
      timeMax           = {12.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,    0.00,    0.000,   0.000,   0.00,    00.0,   00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 80,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.25,   2.25, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      4,       4,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.100,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   9.75,    00.0,    00.0,    30.0     },
      timeMax           = {12.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 85,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.20,   2.20, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      4,       4,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   9.50,    00.0,    00.0,    30.0     },
      timeMax           = {12.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 90,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.15,   2.15, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      3,       5,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.300,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   9.25,   00.0,    00.0,    30.0     },
      timeMax           = {12.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 95,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.10,   2.10, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      3,       5,       0,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   9.00,    00.0,    00.0,    30.0     },
      timeMax           = {12.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 100,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.05,   2.05, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010    },
      maxTotal          = 10,
      max               = { 1,      3,       5,       1,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.500,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   8.75,    00.0,    00.0,    30.0     },
      timeMax           = {13.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0     },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 105,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   2.00, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      3,       5,       1,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   8.50,    00.0,    00.0,    30.0      },
      timeMax           = {13.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 110,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.95, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      2,       5,       2,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.700,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,  0.000,   0.000,   0.000,    8.25,    00.0,    00.0,    30.0      },
      timeMax           = {13.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,  0.000,   0.000,   0.000,    0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 115,   
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,     0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      2,       5,       2,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   8.00,    00.0,    00.0,    30.0      },
      timeMax           = {13.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   { 
      duration          = 120,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.85, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.05,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,   0.20,     0.010 },
      maxTotal          = 10,
      max               = { 1,      2,       4,       3,       0,       0,       0,       0,       0,       0,       0,       0,       0,       1        },
      timeMin           = { 6.900,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.75,    00.0,    00.0,    30.0      },
      timeMax           = {13.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 125,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.80, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,   0.20,     0.010 },
      maxTotal          = 10,
      max               = { 1,      2,       4,       3,       0,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.50,    00.0,    00.0,    30.0      },
      timeMax           = {14.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 130,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.75, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      1,       4,       4,       0,       0,       0,       0,       0,       0,       1,       0,       0,       1       },
      timeMin           = { 7.100,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.25,    00.0,    00.0,    30.0      },
      timeMax           = {14.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 135,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.70, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      1,       4,       4,       0,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.00,    00.0,    00.0,    30.0      },
      timeMax           = {14.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 140,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.65, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      1,       3,       5,       0,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.300,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.75,    00.0,    00.0,    30.0      },
      timeMax           = {14.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 145,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.60, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      1,       3,       5,       0,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.50,    00.0,    00.0,    30.0      },
      timeMax           = {14.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 150,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.55, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          =   10,
      max               = { 1,      0,       3,       5,       1,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.500,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.25,    0.000,    00.0,    30.0      },
      timeMax           = {15.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 155,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.50, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       3,       5,       1,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.00,    0.000,    00.0,    30.0      },
      timeMax           = {15.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 160,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.45, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       2,       5,       2,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.700,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.75,    0.000,    00.0,    30.0      },
      timeMax           = {15.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 165,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.40, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       2,       5,       2,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.50,    0.000,    00.0,    30.0      },
      timeMax           = {15.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 170,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.35, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       2,       4,       3,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 7.900,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.25,    0.000,    00.0,    30.0      },
      timeMax           = {15.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 175,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.30, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,     0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       2,       4,       3,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.00,    0.000,    00.0,    30.0      },
      timeMax           = {16.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 180,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.25, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       1,       4,       4,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.100,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.75,    0.000,    00.0,    30.0      },
      timeMax           = {16.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 185,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.20, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       1,       4,       4,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.50,   0.000,    00.0,    30.0      },
      timeMax           = {16.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 190,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.15, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       1,       3,       5,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.300,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.25,   0.000,    00.0,    30.0      },
      timeMax           = {16.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 195,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.10, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       1,       3,       5,       0,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.00,   0.000,    00.0,    30.0      },
      timeMax           = {16.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 200,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.05, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       3,       5,       1,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.500,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.75,    0.000,    00.0,    30.0      },
      timeMax           = {17.000,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 205,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   1.00, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,   0.20,     0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       3,       5,       1,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.50,   0.000,    00.0,    30.0      },
      timeMax           = {17.200,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    0.000,   00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 210,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.95, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       2,       5,       2,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.700,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.00,   0.000,    00.0,    30.0      },
      timeMax           = {17.400,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 215,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       2,       5,       2,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   2.75,   0.000,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 220,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       2,       4,       3,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   2.50,   0.000,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 225,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       2,       4,       3,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   2.250,  10.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 230,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       1,       4,       4,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   2.000,   9.75,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 235,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       1,       4,       4,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.750,   9.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 240,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       1,       3,       5,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.500,   9.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 245,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       1,       3,       5,       0,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.250,   9.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 250,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       3,       5,       1,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.000,   8.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },

   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 255,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       3,       5,       1,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.000,   8.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 260,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.20,    0.20,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       2,       5,       2,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.000,   8.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 265,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       2,       5,       2,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.000,   8.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 270,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       2,       4,       3,       0,       0,       0,       1,       0,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   1.000,   7.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 275,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       2,       4,       3,       0,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 280,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       1,       4,       4,       0,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 285,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       1,       4,       4,       0,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   7.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 290,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       1,       3,       5,       0,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 295,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       1,       3,       5,       0,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 300,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       3,       5,       1,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 305,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       3,       5,       1,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   6.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 310,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       2,       5,       2,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 315,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       2,       5,       2,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 320,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       2,       4,       3,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 325,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       2,       4,       3,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   5.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 330,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       1,       4,       4,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 335,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       1,       4,       4,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 340,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       1,       3,       5,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 345,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       1,       3,       5,       0,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   4.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 350,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       3,       5,       1,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 355,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       3,       5,       1,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.50,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 360,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       2,       5,       2,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.25,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 365,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       2,       5,       2,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   3.00,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 370,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.20,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       2,       4,       3,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   2.75,    00.0,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 375,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       2,       4,       3,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   02.5,   10.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 380,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       1,       4,       4,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   02.25,   9.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 385,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       1,       4,       4,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   02.0,    8.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 390,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       1,       3,       5,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.75,   7.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 395,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       1,       3,       5,       0,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.5,    6.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 400,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       3,       5,       1,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.25,   5.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 405,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,   0.20,    0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       3,       5,       1,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.0,    4.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 410,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       2,       5,       2,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.0,    3.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 415,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       2,       5,       2,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.0,    2.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 420,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       2,       4,       3,       0,       1,       0,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   01.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 425,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       2,       4,       3,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 430,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       1,       4,       4,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 440,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       1,       4,       4,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 445,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       1,       3,       5,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 450,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       1,       3,       5,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 455,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       3,       5,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 460,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       3,       5,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 465,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       2,       5,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    1.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 470,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       2,       5,       0,       0,       1,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 475,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       2,       5,       0,       0,       2,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 480,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       2,       5,       0,       0,       2,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 485,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       1,       5,       0,       0,       2,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 490,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       1,       5,       0,       0,       2,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 495,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       1,       5,       0,       0,       3,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
   --                   Propane     M-A      W-A      B-A      M-B     W-B       B-B       M-C      W-C      B-C      P-A     P-B      P-C      Armor
   {
      duration          = 50000000,
      spawnDelay        = { 1.00,   2.00, speedBurstMode=0.50 },
      spawnDelay2       = { 0.00,   0.90, speedBurstMode=0.00 },
      odds              = { 0.010,  0.200,   0.200,    0.20,   0.20,    0.20,    0.20,   0.20,    0.20,    0.20,    0.05,    0.05,    0.05,    0.010 },
      maxTotal          = 10,
      max               = { 1,      0,       0,       0,       0,       0,       0,       0,       1,       5,       0,       0,       3,       1        },
      timeMin           = { 8.800,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   00.0,    0.00,    30.0      },
      timeMax           = {17.600,  0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.000,   0.00,    00.0,    00.0,    45.0    },
   },
};