require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalAvoidDamage = Base:new();

----------------------------------------------------------------------

function MissionGoalAvoidDamage:new( mission, index, template  )

print("MissionGoalAvoidDamage:new");

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalAvoidDamage:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   EventMgr:addListener( self, self.onAvatarDamaged , "avatar-damaged" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalAvoidDamage:onGameStart()

   Base.onGameStart( self);

   self.cumulativeScore  = 0;
   self.failed = false;


end

----------------------------------------------------------------------

function MissionGoalAvoidDamage:onAvatarScore( event, type )

   if not self.completed and not self.failed then
      
      self.cumulativeScore = event.distance;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      end
   end

end
----------------------------------------------------------------------

function MissionGoalAvoidDamage:onAvatarDamaged( event, type )

   if not self.failed then
      self.failed = true;
   end
end
----------------------------------------------------------------------

function MissionGoalAvoidDamage:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.completed then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
