require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalAvoidPickups = Base:new();

----------------------------------------------------------------------

function MissionGoalAvoidPickups:new( mission, index, template  )

print("MissionGoalAvoidPickups:new");

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalAvoidPickups:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   EventMgr:addListener( self, self.onAvatarPickup , "avatar-pickup" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalAvoidPickups:onGameStart()

   Base.onGameStart( self);

   self.cumulativeScore  = 0;
   self.failed = false;


end

----------------------------------------------------------------------

function MissionGoalAvoidPickups:onAvatarScore( event, type )

   if not self.completed and not self.failed then
		
		if self.template.score then
			self.cumulativeScore = event.score;
		else
			self.cumulativeScore = event.distance;
		end

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      end
   end

end
----------------------------------------------------------------------

function MissionGoalAvoidPickups:onAvatarPickup( event, type )

   if not self.failed then
      if self.template.pickups then
   
         for i,v in ipairs(self.template.pickups) do
            if event.pickup.pickupType == v then
               self.failed = true;
            end
         end
      
      else
         self.failed = true;
      end
   end
end
----------------------------------------------------------------------

function MissionGoalAvoidPickups:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.completed then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
