require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalBrag = Base:new();

----------------------------------------------------------------------

function MissionGoalBrag:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );
   goal.cumulativeScore  = 0;
   return goal;

end

----------------------------------------------------------------------

function MissionGoalBrag:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onBrag , "brag-friend-success" );

end

----------------------------------------------------------------------

function MissionGoalBrag:onBrag( event, type )

   if not self.completed then
      self.cumulativeScore = self.cumulativeScore + ( event.bragCount or 1);

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      
      else
      
         local curMis = App.data:getMissionIndex();
         App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      end
   end
end