require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalChangeLanes = Base:new();

----------------------------------------------------------------------

function MissionGoalChangeLanes:new( mission, index, template  )

print("MissionGoalChangeLanes:new");

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalChangeLanes:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onAvatarScore, "avatar-score" );
   EventMgr:addListener( self, self.onGameOver, "game-over" );

end

----------------------------------------------------------------------

function MissionGoalChangeLanes:onGameStart()

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
end

----------------------------------------------------------------------
--JOE: only getting 3 lanes per swipe?  Check, fix.
function MissionGoalChangeLanes:onAvatarScore( event, type )

   if event.game and event.game.avatar then

      if self.lastLaneX == nil then
         self.lastX = event.xLoc;
         self.laneWidth = event.game:getLaneLocX(4);
         --print("laneWidth=",self.laneWidth);
      
         local closest = 10000;
         local lane = nil;
         local laneX = nil;
         local deltaX = nil;
         
         for i=1,5 do
            laneX = event.game:getLaneLocX(i);
            deltaX = event.xLoc - laneX;
            if deltaX < 0 then
               deltaX = deltaX * -1;
            end
            if deltaX < closest then
               closest = deltaX;
               lane = i;
            end
         end
         
         self.lastLaneX = event.game:getLaneLocX(lane);
         self.lastLane = lane;
         
         --print("lastLaneX =", self.lastLaneX, "lastLane=", self.lastLane);
      else
      
         local deltaX = event.xLoc - self.lastX;
         if deltaX < 0  then
         --avatar moved left
            if event.xLoc < self.lastLaneX - self.laneWidth then
               self.cumulativeScore = self.cumulativeScore + 1;
               --print("Changed from", self.lastLane, "to", self.lastLane-1);
               self.lastLane = self.lastLane - 1;
               self.lastLaneX = event.game:getLaneLocX(self.lastLane)
               
            end
         else
            --avatar moved right
            if event.xLoc > self.lastLaneX + self.laneWidth then
               self.cumulativeScore = self.cumulativeScore + 1;
               --print("Changed from", self.lastLane, "to", self.lastLane+1);
               self.lastLane = self.lastLane + 1;
               self.lastLaneX = event.game:getLaneLocX(self.lastLane)
            end
         end
         self.lastX = event.xLoc;
      end
         

      if not self.completed then

         if self.cumulativeScore >= self.template.objective then

            self:_OnCompleted();
            self.cumulativeScore = -1;
         end
      end
      
   end

end

----------------------------------------------------------------------

function MissionGoalChangeLanes:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.completed then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
