require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalCollectPickups = Base:new();

----------------------------------------------------------------------

function MissionGoalCollectPickups:new( mission, index, template  )

print("MissionGoalCollectPickups:new");

   local goal  = Base.new( self, mission, index, template );
   
   goal.screenWidth = App.viewportWidth;

   return goal;

end

----------------------------------------------------------------------

function MissionGoalCollectPickups:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   EventMgr:addListener( self, self.onPickupMissed , "pickup-missed" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalCollectPickups:onGameStart()

   Base.onGameStart( self);

   self.cumulativeScore  = 0;
   self.failed = false;


end

----------------------------------------------------------------------

function MissionGoalCollectPickups:onAvatarScore( event, type )

   if not self.completed and not self.failed then
      
      self.cumulativeScore = event.distance;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      end
   end

end
----------------------------------------------------------------------

function MissionGoalCollectPickups:onPickupMissed( event, type )

   if not self.failed then
      if math.abs(event.x) < self.screenWidth/2 then
         if self.template.pickups then
   
            for i,v in ipairs(self.template.pickups) do
               if event.pickup.pickupType == v then
                  self.failed = true;
                  print("Collect all", v, "failed!");
               end
            end
      
         else
            self.failed = true;
         end
      end
   end
end
----------------------------------------------------------------------

function MissionGoalCollectPickups:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.completed then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
