require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalDaily = Base:new();

----------------------------------------------------------------------

function MissionGoalDaily:new( mission, index, template  )

print("MissionGoalDaily:new");

   local goal  = Base.new( self, mission, index,  template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalDaily:activate()

   Base.activate( self );
   
   if self.template.streak then
   
      local streak = App.data:getDailyChallengeStreak();
      if streak >= self.template.objective then
         self.cumulativeScore = -1;
         self:_OnCompleted();
         return;
      end
   end
   
   EventMgr:addListener( self, self.onDailyCompleted , "daily-success" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalDaily:onDailyCompleted( event, type )

print("MissionGoalDaily:onDailyCompleted");

   if event.currentStreak >= self.template.objective then
      self.cumulativeScore = -1;

      self:_OnCompleted();
   end

end

----------------------------------------------------------------------

function MissionGoalDaily:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
   end

end