require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalDestroyBarricade = Base:new();

----------------------------------------------------------------------

function MissionGoalDestroyBarricade:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );
   return goal;

end

----------------------------------------------------------------------

function MissionGoalDestroyBarricade:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onBarricadeDestroyed, "barricade-destroyed" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end


----------------------------------------------------------------------

function MissionGoalDestroyBarricade:onGameStart()

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
end

----------------------------------------------------------------------

function MissionGoalDestroyBarricade:onBarricadeDestroyed( event, type )

   if not self.completed then
   
      self.cumulativeScore = self.cumulativeScore + 1;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      
      end
   end
end

----------------------------------------------------------------------

function MissionGoalDestroyBarricade:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end