require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalDie = Base:new();

----------------------------------------------------------------------

function MissionGoalDie:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalDie:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onDeath, "avatar-death" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalDie:onGameStart()

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
end

----------------------------------------------------------------------

function MissionGoalDie:onDeath( event, type )

   if self.template.timeLimit then
	
		if event.time then
   
			if event.time <= self.template.timeLimit then
				self.cumulativeScore = self.cumulativeScore + 1;
			end
		end

   else
      self.cumulativeScore = self.cumulativeScore + 1;
   end
   
   if self.cumulativeScore >= self.template.objective then

      self:_OnCompleted();
      self.cumulativeScore = -1;
   end

end

----------------------------------------------------------------------

function MissionGoalDie:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end