require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalDistance = Base:new();

----------------------------------------------------------------------

function MissionGoalDistance:new( mission, index, template  )

print("MissionGoalDistance:new");

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalDistance:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalDistance:onGameStart()

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
end

----------------------------------------------------------------------

function MissionGoalDistance:onAvatarScore( event, type )

   if not self.completed then
      
      self.cumulativeScore = event.distance;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      end
   end

end

----------------------------------------------------------------------

function MissionGoalDistance:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.completed then
      
      local curMis = App.data:getMissionIndex();
      self.cumulativeScore = event.distance;

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
