require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalGift = Base:new();

----------------------------------------------------------------------

function MissionGoalGift:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );
   goal.cumulativeScore  = 0;
   return goal;

end

----------------------------------------------------------------------

function MissionGoalGift:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onGift, "gift-friend-success" );

end

----------------------------------------------------------------------

function MissionGoalGift:onGift( event, type )

   if not self.completed then
   
      self.cumulativeScore = self.cumulativeScore + 1;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      
      else
      
         local curMis = App.data:getMissionIndex();
         App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      end
   end
end