require('engine/mission/mission-goal')
require('ui/ui-text-box')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalGold = Base:new();

----------------------------------------------------------------------

function MissionGoalGold:new( mission, index, template  )

print("MissionGoalGold:new");

   local goal  = Base.new( self, mission, index, template );
   return goal;

end

----------------------------------------------------------------------

function MissionGoalGold:activate()

   Base.activate( self );

   EventMgr:addListener( self, self.onAvatarPickup, "avatar-pickup" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );


end

----------------------------------------------------------------------

function MissionGoalGold:onGameStart()

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore = 0;

   end
end

----------------------------------------------------------------------

function MissionGoalGold:onAvatarPickup( event, type )

   if not self.completed then

      if event.pickup.pickupType == "currency" then
   
         if self.template.magnet then
            if event.pickup.magnetized then
               self.cumulativeScore = self.cumulativeScore + event.pickup.value;
            end
         else
            self.cumulativeScore = self.cumulativeScore + event.pickup.value;
         end

         if self.cumulativeScore >= self.template.objective then

            self:_OnCompleted();
            self.cumulativeScore = -1;

         end
      end
   end
end

----------------------------------------------------------------------

function MissionGoalGold:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end