require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalKillAll = Base:new();

----------------------------------------------------------------------

function MissionGoalKillAll:new( mission, index, template  )

print("MissionGoalKillAll:new");

   local goal  = Base.new( self, mission, index, template );
   
   goal.screenWidth = App.viewportWidth;

   return goal;

end

----------------------------------------------------------------------

function MissionGoalKillAll:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   EventMgr:addListener( self, self.onEnemyMissed , "enemy-missed" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalKillAll:onGameStart()

   Base.onGameStart( self);

   self.cumulativeScore  = 0;
   self.failed = false;


end

----------------------------------------------------------------------

function MissionGoalKillAll:onAvatarScore( event, type )

   if not self.completed and not self.failed then
      
      self.cumulativeScore = event.distance;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      end
   end

end
----------------------------------------------------------------------

function MissionGoalKillAll:onEnemyMissed( event, type )

   if not self.failed then
      if math.abs(event.x) < self.screenWidth/2 then
         if self.template.enemies then
   
            for i,v in ipairs(self.template.enemies) do
               if event.enemy.template.type == v then
                  self.failed = true;
                  print("Kill all", v, "failed!");
               end
            end
      
         else
            self.failed = true;
         end
      end
   end
end
----------------------------------------------------------------------

function MissionGoalKillAll:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.completed then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
