require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalKill = Base:new();

----------------------------------------------------------------------

function MissionGoalKill:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalKill:activate()

   Base.activate( self );

   EventMgr:addListener( self, self.onAvatarKill , "avatar-kill" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalKill:onGameStart()

print( "MissionGoalKill:onGameStart" );

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
end

----------------------------------------------------------------------

function MissionGoalKill:onAvatarKill( event, type )

   if not self.completed then

      local ti = #self.template.vicTypes;
   
      local killMatch = false;
      local pristine = true;
      
      if self.template.pristine then
         if event.time >= event.lastDmgTime then
            pristine = false;
            return;
         end
      end
   
      if self.template.deathType then
   
         if event.death then
			
				for i,v in ipairs(event.death) do
   
					if v == self.template.deathType then
   
						for j=1,ti do
    
   
							if event.monster.template.type == self.template.vicTypes[j] then
               
								killMatch = true;
								break;
								
							end
      
                  end
               end
            end
				
         end
			
			if self.template.deathType == "area" and event.monster.template.type == "fuel_truck_a" then
				killMatch = true;
			end
			
      else
   
         for i=1,ti do
    
   
               if event.monster.template.type == self.template.vicTypes[i] then
   
                  killMatch = true;
                  break;
      
               end
            end
      end
   
      if killMatch and pristine then
         self.cumulativeScore = self.cumulativeScore + 1;
      end

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;

      end
   end
end

----------------------------------------------------------------------

function MissionGoalKill:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end