require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalLeaderBoard = Base:new();

----------------------------------------------------------------------

function MissionGoalLeaderBoard:new( mission, index, template  )

print("MissionGoalLeaderBoard:new");

   local goal  = Base.new( self, mission, index,  template );
   
   goal.cumulativeScore = 0;

   return goal;

end

----------------------------------------------------------------------

function MissionGoalLeaderBoard:activate()

   Base.activate( self );
	
	local rank = RankingMgr:getPlayerRank();
	
	if rank then
		self.cumulativeScore = rank;
			
		if self.cumulativeScore <= self.template.objective then
         
			self.cumulativeScore = -1;

			self:_OnCompleted();
				
			return;
               
		end
	end
		

   EventMgr:addListener( self, self.onPlayerRank, "player-rank" );

end

----------------------------------------------------------------------

function MissionGoalLeaderBoard:onPlayerRank( event, type )

	self.cumulativeScore = event.playerRank;
            
	if self.cumulativeScore <= self.template.objective then
            
		self.cumulativeScore = -1;

		self:_OnCompleted();
               
	else
		local curMis = App.data:getMissionIndex();
		App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
	end
end

----------------------------------------------------------------------