require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalPickupStack = Base:new();

----------------------------------------------------------------------

function MissionGoalPickupStack:new( mission, index, template  )

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalPickupStack:activate()

   Base.activate( self );

   EventMgr:addListener( self, self.onAvatarPickup , "avatar-pickup" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalPickupStack:onGameStart()

print( "MissionGoalPickupStack:onGameStart" );

   Base.onGameStart( self);
   
   if not self.template.cumulative then
   
      self.cumulativeScore = 0;
      
   end

end

----------------------------------------------------------------------

function MissionGoalPickupStack:onAvatarPickup( event, type )

   if not self.completed then
   
      local count = 0

      for i=1,#self.template.powerups do

         if event.avatar.powerups then
            if event.avatar.powerups[self.template.powerups[i]] then
               count = count + 1;
            end
         end
      end
      
      if count >= #self.template.powerups then
      
         self.cumulativeScore = self.cumulativeScore + 1;
         
         if self.cumulativeScore >= self.template.objective then
            self:_OnCompleted();
            self.cumulativeScore = -1;
         end
      end
   end
end

----------------------------------------------------------------------

function MissionGoalPickupStack:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end