require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalPickupTimed = Base:new();

----------------------------------------------------------------------

function MissionGoalPickupTimed:new( mission, index, template  )

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalPickupTimed:activate()

   Base.activate( self );

   EventMgr:addListener( self, self.onAvatarPickup , "avatar-pickup" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalPickupTimed:onGameStart()

print( "MissionGoalPickupTimed:onGameStart" );

   Base.onGameStart( self);
   
   self.cumulativeScore = 0; 
   self.earliestScore = 0;

end

----------------------------------------------------------------------

function MissionGoalPickupTimed:onAvatarPickup( event, type )

   if not self.completed then
   
      if event.pickup.pickupType == self.template.type then
         
         if event.duration - self.earliestScore > self.template.timer then
            self.cumulativeScore = 0; 
            self.earliestScore = event.duration;
            print("Timer over, resetting pickup count");
         else
            self.cumulativeScore = self.cumulativeScore + 1;
            print("pickups within timer:", self.cumulativeScore);
         end

         if self.cumulativeScore >= self.template.objective then

            self:_OnCompleted();
            self.cumulativeScore = -1;

         end
      end
   end
end

----------------------------------------------------------------------

function MissionGoalPickupTimed:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end