require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalPickup = Base:new();

----------------------------------------------------------------------

function MissionGoalPickup:new( mission, index, template  )

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalPickup:activate()

   Base.activate( self );

   EventMgr:addListener( self, self.onAvatarPickup , "avatar-pickup" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalPickup:onGameStart()

print( "MissionGoalPickup:onGameStart" );

   Base.onGameStart( self);
   
   if not self.template.cumulative then
   
      self.cumulativeScore = 0;
      
   end

end

----------------------------------------------------------------------

function MissionGoalPickup:onAvatarPickup( event, type )

   if not self.completed then

      if event.pickup.pickupType == self.template.type then

         self.cumulativeScore = self.cumulativeScore + 1;
         print("Pickup! Type:", event.pickup.pickupType, "Cumulative Score:", self.cumulativeScore);

         if self.cumulativeScore >= self.template.objective then

            self:_OnCompleted();
            self.cumulativeScore = -1;

         end
      end
   end
end

----------------------------------------------------------------------

function MissionGoalPickup:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end