require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalScore = Base:new();

----------------------------------------------------------------------

function MissionGoalScore:new( mission, index, template  )

   local goal  = Base.new( self, mission, index, template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalScore:activate()

   Base.activate( self );

   EventMgr:addListener( self, self.onAvatarScore , "avatar-score" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end

----------------------------------------------------------------------

function MissionGoalScore:onGameStart()

   Base.onGameStart( self );

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
   
   if self.template.highScore then
      self.objective = RankingMgr:getPlayerHiScore();
   else
      self.objective = self.template.objective;
   end

   EventMgr:postEvent( {objective=self.template.objective} , "mission-score-objective" );

end

----------------------------------------------------------------------

function MissionGoalScore:onAvatarScore( event, type )

   if not self.completed then
   
      self.cumulativeScore = event.score;

      if self.cumulativeScore >= self.objective then
   
         self.cumulativeScore = -1;
         self:_OnCompleted();

      end
   end
end

----------------------------------------------------------------------

function MissionGoalScore:onGameOver(event)

   if not App.data:isCurrentMissionGoalCompleted( self.index ) and not self.template.highScore then
      
      local curMis = App.data:getMissionIndex();
      self.cumulativeScore = event.score;

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end
end
