require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalSideswipe = Base:new();

----------------------------------------------------------------------

function MissionGoalSideswipe:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );
   return goal;

end

----------------------------------------------------------------------

function MissionGoalSideswipe:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onSideswipe , "avatar-sideswipe" );
   EventMgr:addListener( self, self.onGameOver , "game-over" );

end


----------------------------------------------------------------------

function MissionGoalSideswipe:onGameStart()

   Base.onGameStart( self);

   if not self.template.cumulative then

      self.cumulativeScore  = 0;

   end
end

----------------------------------------------------------------------

function MissionGoalSideswipe:onSideswipe( event, type )

   if not self.completed then

   
      if self.template.barricade then
         if event.vehicle == "barricade" then
				self.cumulativeScore = self.cumulativeScore + 1;
         end
      else
			self.cumulativeScore = self.cumulativeScore + 1;
		end

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      
      end
   end
end

----------------------------------------------------------------------

function MissionGoalSideswipe:onGameOver(event)
   
   if not App.data:isCurrentMissionGoalCompleted( self.index ) then
      
      local curMis = App.data:getMissionIndex();

      App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      
   end

end