require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalSpendKeys = Base:new();

----------------------------------------------------------------------

function MissionGoalSpendKeys:new( mission, index, template  )

print("MissionGoalSpendKeys:new");

   local goal  = Base.new( self, mission, index,  template );

   return goal;

end

----------------------------------------------------------------------

function MissionGoalSpendKeys:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onUseKey, "consume-key-success" );
	
	self.curMis = App.data:getMissionIndex();
	
	self.timer = self.template.timer;
	
	self.cumulativeScore = App.data:getCurrentMissionGoalProgress( self.index );
	if not self.cumulativeScore then
		self.cumulativeScore = 0;
	end
	local timeStamp = App.data:getValue( "goalTimer"..self.index.."Start" );
	
	self.timerRunning = false;
	
	if self.cumulativeScore > 0 and timeStamp then
		if (timeStamp + self.timer) > os.time() then
			self.timerRunning = true;
		else
			self.cumulativeScore = 0;
			App.data:updateMissionGoal(  self.curMis, self.index, self.cumulativeScore );
		end
			
	elseif self.cumulativeScore > 0 and not timeStamp then

		self.cumulativeScore = 0;
		App.data:updateMissionGoal(  self.curMis, self.index, self.cumulativeScore );
	end

end

----------------------------------------------------------------------

function MissionGoalSpendKeys:onUseKey( event, type )

	if self.timerRunning then

		local timeStamp = App.data:getValue( "goalTimer"..self.index.."Start" );
	
		if os.time() < timeStamp then
			--cheater! =)
			App.data:setValue( "goalTimer"..self.index.."Start", timeStamp );
			self.cumulativeScore = 0;
			App.data:updateMissionGoal(  self.curMis, self.index, self.cumulativeScore );
		else
			
			self.cumulativeScore = self.cumulativeScore + 1;
            
			if self.cumulativeScore >= self.template.objective then
            
				self.cumulativeScore = -1;
				self.timerRunning = false;
				App.data:setValue( "goalTimer"..self.index.."Start", nil );
				self:_OnCompleted();
               
			else
				
				App.data:updateMissionGoal(  self.curMis, self.index, self.cumulativeScore );
			end
		end
	elseif self.timer then
	
		self.timerRunning = true;
		self.cumulativeScore = 0;
		local timeStamp = os.time();
		App.data:setValue( "goalTimer"..self.index.."Start", timeStamp );
		self.cumulativeScore = self.cumulativeScore + 1;
		App.data:updateMissionGoal(  self.curMis, self.index, self.cumulativeScore );
	
	else
	-- not a timed quest. just collect keys
		self.cumulativeScore = self.cumulativeScore + 1;
            
		if self.cumulativeScore >= self.template.objective then
            
			self.cumulativeScore = -1;
			self.timerRunning = false;
			App.data:setValue( "goalTimer"..self.index.."Start", nil );
			self:_OnCompleted();
               
		else
			App.data:updateMissionGoal(  self.curMis, self.index, self.cumulativeScore );
		end
	end
end
