require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalUnlock = Base:new();

----------------------------------------------------------------------

function MissionGoalUnlock:new( mission, index, template  )

print("MissionGoalUnlock:new");

   local goal  = Base.new( self, mission, index,  template );
   
   goal.cumulativeScore = 0;

   return goal;

end

----------------------------------------------------------------------

function MissionGoalUnlock:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onUnlock, "unlock-success" );

end

----------------------------------------------------------------------

function MissionGoalUnlock:onUnlock( event, type )


   if event.item == self.template.item or not self.template.item then
   
      if event.vehicle == self.template.vehicle or not self.template.vehicle then
         
         self.cumulativeScore = self.cumulativeScore + 1;
            
         if self.cumulativeScore >= self.template.objective then
            
            self.cumulativeScore = -1;

            self:_OnCompleted();
               
         else
            local curMis = App.data:getMissionIndex();
            App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
         end
      end
   end
end

----------------------------------------------------------------------