require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalUpgrade = Base:new();

----------------------------------------------------------------------

function MissionGoalUpgrade:new( mission, index, template  )

print("MissionGoalUpgrade:new");

   local goal  = Base.new( self, mission, index,  template );
   
   goal.cumulativeScore = 0;

   return goal;

end

----------------------------------------------------------------------

function MissionGoalUpgrade:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onUpgrade, "upgrade-success" );
	
	local type = self.template.item;
	local veh = App.data:getCurrentPlayerVehicle();
	local currentLvl = 0;
		
	if type == "armor" then
		currentLvl = App.data:getCurrentArmorLevel();
		local maxArmor = App.data:getPlayerArmorMaxLevel( veh );
		if currentLvl >= maxArmor then
			self.cumulativeScore = -1;
			self:_OnCompleted();
		elseif self.template.threshold then
			self.cumulativeScore = currentLvl;
			print("Setting current armor level",currentLvl);
		end
	elseif type == "main-weapon" then
		currentLvl = App.data:getCurrentMainWeaponLevel();
		local maxWeapon = App.data:getPlayerMainWeaponMaxLevel( veh )
		if currentLvl >= maxWeapon then
			self.cumulativeScore = -1;
			self:_OnCompleted();
		elseif self.template.threshold then
			self.cumulativeScore = currentLvl;
		end
	elseif type == "side-weapon" then
		currentLvl = App.data:getCurrentSideWeaponLevel();
		local maxSide = App.data:getPlayerSideWeaponMaxLevel( veh );
		if currentLvl >= maxSide then
			self.cumulativeScore = -1;
			self:_OnCompleted();
		elseif self.template.threshold then
			self.cumulativeScore = currentLvl;
		end
	elseif type == "turret" then
		currentLvl = App.data:getCurrentPlayerTurretWeaponLevel();
		local maxTurret = App.data:getPlayerTurretMaxLevel( veh );
		if currentLvl >= maxTurret then
			self.cumulativeScore = -1;
			self:_OnCompleted();
		elseif self.template.threshold then
			self.cumulativeScore = currentLvl;
		end
	elseif type == "pickup" then
		-- this only works for "get any pickup to x level" right now.  Specific will be added as needed.
		local pLvl=0;
		local pMax=1000;
		local old = 0; 
		for i=1,6 do
			pLvl = App.data:getPickupLevel(i);
			pMax = App.data:getPickupMaxLevel(i);
			if self.template.threshold then
				if pLvl > old then
					old = pLvl
					self.cumulativeScore = pLvl;
				end
			elseif pLvl >= pMax then
				self.cumulativeScore = self.cumulativeScore + 1;
			end
		end
	end
   
	if self.cumulativeScore >= self.template.objective then
         
		self.cumulativeScore = -1;

		self:_OnCompleted();
               
	else
		local curMis = App.data:getMissionIndex();
		App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
	end

end

----------------------------------------------------------------------

function MissionGoalUpgrade:onUpgrade( event, type )


   if event.item == self.template.item or not self.template.item then
   
      if event.vehicle == self.template.vehicle or not self.template.vehicle then
      
         if self.template.threshold then
				
				--joe: not sure why this is returning one less than the upgraded level on everything but items, 
				--but it is.
				--print("event lvl,item",event.level,event.item);
				local check = event.level + 1
				if event.item == "pickup" then
					check = event.level;
				end
   
            if check >= self.template.objective then
         
               self.cumulativeScore = -1;

               self:_OnCompleted();
               
            else
					self.cumulativeScore = event.level + 1
					local curMis = App.data:getMissionIndex();
               App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
				end
         else
         
            self.cumulativeScore = self.cumulativeScore + 1;
            
            if self.cumulativeScore >= self.template.objective then
            
               self.cumulativeScore = -1;

               self:_OnCompleted();
               
            else
               local curMis = App.data:getMissionIndex();
               App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
            end

         end
      end
   end
end

----------------------------------------------------------------------