require('engine/mission/mission-goal')

----------------------------------------------------------------------

local Base = MissionGoal;

MissionGoalWeekly = Base:new();

----------------------------------------------------------------------

function MissionGoalWeekly:new( mission, index, template  )

   local goal  = Base.new( self, mission, index,  template );
   goal.cumulativeScore  = 0;
   return goal;

end

----------------------------------------------------------------------

function MissionGoalWeekly:activate()

   Base.activate( self );
   
   EventMgr:addListener( self, self.onWeekly, "leaderboard-reward" );

end

----------------------------------------------------------------------

function MissionGoalWeekly:onWeekly( event, type )

   if not self.completed then
   
      self.cumulativeScore = event.rank;

      if self.cumulativeScore >= self.template.objective then

         self:_OnCompleted();
         self.cumulativeScore = -1;
      
      else
      
         local curMis = App.data:getMissionIndex();
         App.data:updateMissionGoal(  curMis, self.index, self.cumulativeScore );
      end
   end
end