require("app/moai")

BUILD_DEBUG = false;

-- This has to happen first, because it changes how the require below will work.
table.insert(package.loaders, 1, loader_encrypted)

function dofile (filename)

   local f = dofile_encrypted(filename);
   if f then
      if type(f) == "function" then
         return f()
      else
         MOAIFlurry:event("Error-dofile", "filename", filename, "type", type(f), "tostring", tostring(f) );
      end
   end
end

-------------------------------------------------------------------------------------

--Use very CAUTIOUSLY to avoid spaming release print and affect perform (and expose important information to user)
printRelease = print;

if not BUILD_DEBUG then

   --disable print for release version
   print = function(...)
   end

end

-------------------------------------------------------------------------------------

MOAIFlurry:setPrintEnable( BUILD_DEBUG );

-------------------------------------------------------------------------------------

require "app/debug"

-------------------------------------------------------------------------------------

if not MOAITangoSdk then
   print("Adding dummy MOAITangoSDK functions.")

   MOAI_TANGO_MISSING = true

   require "app/tango-sdk-dummy"

end

-------------------------------------------------------------------------------------

--TODO : Move to "global" file

DEFAULT_GLOBAL_SOUND_VOLUME = 1.0;
DEFAULT_GLOBAL_MUSIC_VOLUME = 1.0;

-------------------------------------------------------------------------------------

require "app/app"

-------------------------------------------------------------------------------------

--Use by MOAI
DEVICE = true;

-------------------------------------------------------------------------------------

App:init();

App:start();

-------------------------------------------------------------------------------------
