require('state/marker/marker')
----------------------------------------------------------------

MarkerMgr = {};

----------------------------------------------------------------

local MarkerTpl = 
{
   freewayV1 =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/FreewayV1/Road_FreewayV1_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {1,1,1,1},
      }
   },
   iceV1  =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/IceV1/Road_IceV1_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {0.0, 0.30, 0.70, 0.70},
      }
   },
   sandV1  =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/DesertRoadV1/Road_DesertV1_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {1.0,1.0,1.0,0.75},
      }
   },
   freewayV2 =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/FreewayV2/Road_FreewayV2_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {1,1,1,1},
      }
   },
   iceV2  =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/IceV2/Road_IceV2_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {0.0, 0.30, 0.70, 0.70},
      }
   },
   sandV2  =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/DesertRoadV2/Road_DesertV2_Day_Distance.png",
         width    = 640, 
         height   = 463,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {1.0,1.0,1.0,0.75},
      }
   },
   dirtV2  =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/CountryRoadV2/Road_CountryV2_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {1.0,1.0,1.0,0.75},
      }
   },
   snowV2  =
   {
      image = 
      {
         layer    = 10,
         texture  = "resources/Background/SnowV2/Road_SnowV2_Day_Distance.png",
         width    = 640, 
         height   = 348,
      },
      text =
      {
         layer    = 2,
         fontName = "resources/font/TangoLatin.otf",
         fontSize = 16,
         color    = {1.0,1.0,1.0,0.75},
      }
   },
};

----------------------------------------------------------------


function MarkerMgr:init( state, game )
     
   self.state  = state;
   self.markers = {};

   self.markers[1] = Marker:new( state, game, MarkerTpl[game.backgroundType] );
   self.markers[1]:reset(1000);
   self.markers[2] = Marker:new( state, game, MarkerTpl[game.backgroundType] );
   self.markers[2]:reset(2500);

end

----------------------------------------------------------------

function MarkerMgr:free()
   self.markers = nil;
end

----------------------------------------------------------------

function MarkerMgr:update( dt )

   if self.markers then

      for i=1, #self.markers do

         local marker = self.markers[i];
         marker:update( dt );
   
         if marker.done then
            if marker.distance == 1000 then
               marker:reset(5000);
            elseif marker.distance == 2500 then
               marker:reset(7500);
            elseif marker.distance == 5000 then
               marker:reset(10000);
            elseif marker.distance == 7500 then
               marker:reset(15000);
            else
               marker:reset(marker.distance+10000);
            end
         end
      end

   end
end

----------------------------------------------------------------