----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local BUY_ICON_X = 0
local BUY_ICON_Y = -120;

local PRIORTY_0  = 10;
local PRIORTY_1  = 20;
local PRIORTY_2  = 30;
local PRIORTY_3  = 40;
local PRIORTY_4  = 50;
local PRIORTY_5  = 60;
local PRIORTY_6  = 70;
local PRIORTY_7  = 80;
local PRIORTY_8  = 90;
local PRIORTY_9  = 100;
local PRIORTY_10 = 110;

----------------------------------------------------------------

local Base                 = State;
local StateAutoBuyPopupMaz = Base:new();

----------------------------------------------------------------

function StateAutoBuyPopupMaz:onLoad()

   State.onLoad( self );

   local textureSheet = FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";

   self.IS_POPUP  = true;

   -- background and icon
   self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "SmallBackGround", textureSheet);

   -- currency Icon
   self.BuyIconCoin = self:addWidget(Anim, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 0,0, "CoinB", textureSheet);
   self.BuyIconCoin:setPriority(PRIORTY_1);
   self.BuyIconGem = self:addWidget(Anim, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 0,0, "GemB", textureSheet);
   self.BuyIconGem:setPriority(PRIORTY_1);

   -- push/pop state buttons
   self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 151, 0,0, "CloseButton", textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
   self.BackButton:setPriority(PRIORTY_0);
   self.ConfirmButtonG = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, 0, 0,0, "SmallBuyButton", textureSheet, nil, self.goConfirm, nil, nil);
   self.ConfirmButtonG:setPriority(PRIORTY_0);
   self.ConfirmButtonB = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, 0, 0,0, "SmallBuyButton", textureSheet, nil, self.goConfirm, nil, nil);
   self.ConfirmButtonB:setPriority(PRIORTY_0);

   -- text message
   self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 122, 540, 70, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.TitleText:setScale(1.5, 1.5);
   self.TitleText:setPriority(PRIORTY_0);
   self.TitleTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, 122-2, 540, 70, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.TitleTextShdw:setScale(1.5, 1.5);
   self.TitleTextShdw:setPriority(PRIORTY_0-1);
   self.MessageText = self:addWidget(TextBox, self.mainLayer, 0, 5, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.MessageText:setPriority(PRIORTY_0);
   self.MessageTextShdw = self:addWidget(TextBox, self.mainLayer, 0-2, 5+2, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.MessageTextShdw:setPriority(PRIORTY_0-1);
   self.BuyButtonText = self:addWidget(TextBox, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 500, 100, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.BuyButtonText:setPriority(PRIORTY_1);
   self.BuyButtonShdw = self:addWidget(TextBox, self.mainLayer, BUY_ICON_X+2, BUY_ICON_Y-2, 500, 100, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.BuyButtonShdw:setPriority(PRIORTY_1-1);

   --  self.resourceBar = ResourceBar:new( self, 0, self:_calcHeaderLocY(), self.mainLayer, self.mainPartition  );

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:onActivate()

   State.onActivate(self);

   self.BuyIconCoin:setVisible(false);
   self.BuyIconGem:setVisible(false);
   self.ConfirmButtonG:setVisible(false);
   self.ConfirmButtonB:setVisible(false);

   self.ConfirmButtonG:disable();
   self.ConfirmButtonB:disable();

   self:setMessage();

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:onFocus()

   State.onFocus(self);

   MOAIFlurry:eventStart("auto-buy", "ending", "unknown", "type", AUTO_PURCHASE_DATA.currency);

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:onLoseFocus( )

   State.onLoseFocus( self );

   --it shouldnt be needed but we dont want to risk it
   enableButtonInput();

   StateMgr:setSyncBusyDelay( );

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:setMessage()

	local currency			= AUTO_PURCHASE_DATA.currency;
	local tempTable		= self:getFinalCost();
	local offsetIndex		= 0;
	local offsetBuy		= 0;
	local offsetNegX		= 0;
	local title				= 'You Need Keys';

	if tempTable.gem then
		offsetIndex = tempTable.gem;
		self.ConfirmButtonB:enable();
		self.ConfirmButtonB:setVisible(true);
	else
		offsetIndex = tempTable.cost;
		self.ConfirmButtonG:enable();
		self.ConfirmButtonG:setVisible(true);
	end

	if offsetIndex then

		if offsetIndex > 9999 then
			offsetBuy = 40;
			offsetNegX = 10;
		elseif offsetIndex > 999 then
			offsetBuy = 35;
			offsetNegX = 13;
		elseif offsetIndex > 99 then
			offsetBuy = 30;
			offsetNegX = 8;
		elseif offsetIndex > 9 then
			offsetBuy = 25;
			offsetNegX = 3;
		else
			offsetBuy = 20;
			offsetNegX = -2;
		end
	end

	if currency == 'Key' then

		title = 'You Need Keys';

		self.BuyIconGem:setVisible(true);

		if tempTable.req > 1 then

			if tempTable.gem then
				self.MessageText:setText('<c:1b3043>Buy '..getFormattedNumber(tempTable.gem)..' Gems to get '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.MessageTextShdw:setText('<c:8fb5cd>Buy '..getFormattedNumber(tempTable.gem)..' Gems to get '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.BuyButtonText:setText(tempTable.cost..'');
				self.BuyButtonShdw:setText('<c:000000>'..tempTable.cost);

				self.BuyIconGem:setVisible(false);
				self.BuyButtonText:setLoc(BUY_ICON_X, BUY_ICON_Y);
				self.BuyButtonShdw:setLoc(BUY_ICON_X+2, BUY_ICON_Y-2);
			else
				self.MessageText:setText('<c:1b3043>Buy '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.MessageTextShdw:setText('<c:8fb5cd>Buy '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.BuyButtonText:setText(tempTable.cost..'');
				self.BuyButtonShdw:setText('<c:000000>'..tempTable.cost);

				self.BuyIconGem:setLoc(BUY_ICON_X-offsetBuy-offsetNegX, BUY_ICON_Y);
				self.BuyButtonText:setLoc(BUY_ICON_X+offsetBuy-offsetNegX, BUY_ICON_Y);
				self.BuyButtonShdw:setLoc(BUY_ICON_X+offsetBuy-offsetNegX+2, BUY_ICON_Y-2);
			end
		else

			if tempTable.gem then
				self.MessageText:setText('<c:1b3043>Buy '..getFormattedNumber(tempTable.gem)..' Gems to get '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.MessageTextShdw:setText('<c:8fb5cd>Buy '..getFormattedNumber(tempTable.gem)..' Gems to get '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.BuyButtonText:setText(tempTable.cost..'');
				self.BuyButtonShdw:setText('<c:000000>'..tempTable.cost);

				self.BuyIconGem:setVisible(false);
				self.BuyButtonText:setLoc(BUY_ICON_X, BUY_ICON_Y);
				self.BuyButtonShdw:setLoc(BUY_ICON_X+2, BUY_ICON_Y-2);
			else
				self.MessageText:setText('<c:1b3043>Buy '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.MessageTextShdw:setText('<c:8fb5cd>Buy '..getFormattedNumber(tempTable.package)..' Keys?<c>');
				self.BuyButtonText:setText(tempTable.cost..'');
				self.BuyButtonShdw:setText('<c:000000>'..tempTable.cost);

				self.BuyIconGem:setLoc(BUY_ICON_X-offsetBuy-offsetNegX, BUY_ICON_Y);
				self.BuyButtonText:setLoc(BUY_ICON_X+offsetBuy-offsetNegX, BUY_ICON_Y);
				self.BuyButtonShdw:setLoc(BUY_ICON_X+offsetBuy-offsetNegX+2, BUY_ICON_Y-2);
			end
		end

	elseif currency == 'Coin' then

		title = 'You Need Coins';

		self.BuyIconGem:setVisible(true);

		if tempTable.gem then
			self.MessageText:setText('<c:1b3043>Buy '..getFormattedNumber(tempTable.gem)..' Gems to get '..getFormattedNumber(tempTable.package)..' Coins?<c>');
			self.MessageTextShdw:setText('<c:8fb5cd>Buy '..getFormattedNumber(tempTable.gem)..' Gems to get '..getFormattedNumber(tempTable.package)..' Coins?<c>');
			self.BuyButtonText:setText(tempTable.cost..'');
			self.BuyButtonShdw:setText('<c:000000>'..tempTable.cost);

			self.BuyIconGem:setVisible(false);
			self.BuyButtonText:setLoc(BUY_ICON_X, BUY_ICON_Y);
			self.BuyButtonShdw:setLoc(BUY_ICON_X+2, BUY_ICON_Y-2);
		else
			self.MessageText:setText('<c:1b3043>Buy '..getFormattedNumber(tempTable.package)..' Coins?<c>');
			self.MessageTextShdw:setText('<c:8fb5cd>Buy '..getFormattedNumber(tempTable.package)..' Coins?<c>');
			self.BuyButtonText:setText(tempTable.cost..'');
			self.BuyButtonShdw:setText('<c:000000>'..tempTable.cost);

			self.BuyIconGem:setLoc(BUY_ICON_X-offsetBuy-offsetNegX, BUY_ICON_Y);
			self.BuyButtonText:setLoc(BUY_ICON_X+offsetBuy-offsetNegX, BUY_ICON_Y);
			self.BuyButtonShdw:setLoc(BUY_ICON_X+offsetBuy-offsetNegX+2, BUY_ICON_Y-2);
		end

	else

		local text		= 'Buy '..tempTable.package..' Gems?';

		title = 'You Need Gems';

		self.ConfirmButtonG:setVisible(false);
		self.ConfirmButtonB:setVisible(true);
		self.ConfirmButtonG:disable();
		self.ConfirmButtonB:enable();
		self.TitleText:setText(title);
		self.TitleTextShdw:setText(title);

		self.MessageText:setText('<c:1b3043>'..text..'<c>');
		self.MessageTextShdw:setText('<c:8fb5cd>'..text..'<c>');
		self.BuyButtonText:setText(tempTable.cash..'');
		self.BuyButtonShdw:setText('<c:000000>'..tempTable.cash);

		self.BuyButtonText:setLoc(BUY_ICON_X, BUY_ICON_Y);
		self.BuyButtonShdw:setLoc(BUY_ICON_X+2, BUY_ICON_Y-2);
	end

   self.TitleText:setText('<c:fefcfc>'..title..'<c>');
   self.TitleTextShdw:setText('<c:0b141d>'..title..'<c>');

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:getFinalCost()

   local currency = AUTO_PURCHASE_DATA.currency;
   local tempTable = nil;

   if currency == 'Key' then
      tempTable = self.getFinalCostKey();
   elseif currency == 'Coin' then
      tempTable = self.getFinalCostCoin();
   else
      tempTable = self.getFinalCostGem();
   end

   return tempTable;

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:getFinalCostKey()

   print("StateAutoBuyPopupMaz:getFinalCostKey-1");

   local reqAmount = AUTO_PURCHASE_DATA.price;
   local keyIndex  = App.data:getAutoKeyBuyIndex(reqAmount);
   local cost      = App.data:getStoreKeyCost(keyIndex);
   local tempTable = {};

   tempTable.req     = reqAmount - App.data:getKeyCount();
   tempTable.package = App.data:getStoreKeyAmount(keyIndex);
   tempTable.cost    = cost.gem;

   if not App.data:canBuyStoreKey(keyIndex) then

      local productId = StoreMgr:getGemAutoBuyId(cost.gem);
      tempTable.gem   = StoreMgr:getProductAmount(productId).gem;
      tempTable.cost  = StoreMgr:getGemCostDisplay(productId);

      print("StateAutoBuyPopupMaz:getFinalCostKey-2", productId, tempTable.gem, tempTable.cost  );

   end

   return tempTable;

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:getFinalCostCoin()

   local reqAmount = AUTO_PURCHASE_DATA.price;
   local coinIndex = App.data:getAutoCoinBuyIndex(reqAmount);
   local cost      = App.data:getStoreGoldCost(coinIndex);
   local tempTable = {};

   tempTable.req     = reqAmount - App.data:getGoldCount();
   tempTable.package = App.data:getStoreGoldAmount(coinIndex);
   tempTable.cost    = cost.gem;

   if not App.data:canBuyStoreGold(coinIndex) then

      local productId = StoreMgr:getGemAutoBuyId(cost.gem);
      tempTable.gem   = StoreMgr:getProductAmount(productId).gem;
      tempTable.cost  = StoreMgr:getGemCostDisplay(productId);

   end

   return tempTable;

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:getFinalCostGem()

   local reqAmount = AUTO_PURCHASE_DATA.price;
   local productId = StoreMgr:getGemAutoBuyId(reqAmount);
   local cost      = StoreMgr:getProductCost(productId) or {};
   local tempTable = {};

   tempTable.req     = reqAmount - App.data:getGoldCount();
   tempTable.package = StoreMgr:getProductAmount(productId).gem;
   tempTable.cost    = cost.gem or 0;
   tempTable.cash    = StoreMgr:getGemCostDisplay(productId);

   return tempTable;

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:goConfirm()

   local currency = AUTO_PURCHASE_DATA.currency;

   if currency == 'Key' then
      self:buyKey();
   elseif currency == 'Coin' then
      self:buyCoin();
   else
      self:buyGem();
   end


end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:done(ending)

   MOAIFlurry:eventStop("auto-buy", "ending", ending);

   if ending == "success" and AUTO_PURCHASE_FUNC then

      MOAIFlurry:event(   "auto-buy-success"
                          , "type",                     AUTO_PURCHASE_DATA.currency  or "unknown"
                          , "state",                    AUTO_PURCHASE_DATA.state     or "unknown"
                          , "reason1",                  AUTO_PURCHASE_DATA.reason1   or "unknown"
                          , "reason2",                  AUTO_PURCHASE_DATA.reason2   or "unknown"
                          , "carIndex",                 AUTO_PURCHASE_DATA.carIndex  or "-1"
      );

      EventMgr:postEvent({
                              type     =  AUTO_PURCHASE_DATA.currency  or "unknown"
                           ,  state    =  AUTO_PURCHASE_DATA.state     or "unknown"
                           , reason1   =  AUTO_PURCHASE_DATA.reason1   or "unknown"
                           , reason2   =  AUTO_PURCHASE_DATA.reason2   or "unknown"
                           , carIndex  =  AUTO_PURCHASE_DATA.carIndex  or "-1"
                           },
                           "auto-buy-success"      );


      AUTO_PURCHASE_FUNC();
   end

   AUTO_PURCHASE_FUNC          = nil;
   AUTO_PURCHASE_DATA.currency = {};
   StateMgr:pop();

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:buyKey()

   local reqAmount	= AUTO_PURCHASE_DATA.price;
   local keyIndex		= App.data:getAutoKeyBuyIndex(reqAmount);
   local cost			= App.data:getStoreKeyCost(keyIndex);

   if App.data:canBuyStoreKey(keyIndex) then

      if App.data:buyStoreKey(keyIndex) then

         local bKeys = App.data:getStoreKeyAmount(keyIndex);

         EventMgr:postEvent( {  index=keyIndex, keys=bKeys }, "keys-bought" );

         self:done("success");

      else

         self:showErrorPopup();

         self:done("failure");

      end

   else

      if not StoreMgr:canMakePayments() then

         self:showErrorPopup( LocalizationMgr:getString( "NATIVE_PURCH_DISABLED" ) );

         self:done("failure");

         return false;

      end

      local productId = StoreMgr:getGemAutoBuyId(cost.gem);

      print("StateAutoBuyPopupMaz:buyKey", reqAmount, keyIndex, productId, cost.gem );

      disableButtonInput();

      self._waitAppStore = true;
      StateMgr:setSyncBusyDelay( 0 );

      delay(1,
            function()
               local success = StoreMgr:buyProduct(   productId,
                                                      self,
                                                      function ()
                                                         local bGems = StoreMgr:getProductAmount(productId).gem;

                                                         EventMgr:postEvent( {  gem=bGems, productId=productId, source="auto-buy" }, "gems-bought" );

                                                         MOAIFlurry:event(   "auto-buy-gem-success"
                                                                             , "type",                     AUTO_PURCHASE_DATA.currency
                                                                             ,  "productId",               tostring(productId)
                                                                             ,  "amount",                  tostring(bGems)
                                                                             , "reason1",                  AUTO_PURCHASE_DATA.reason1    or "unknown"
                                                                             , "reason2",                  AUTO_PURCHASE_DATA.reason2    or "unknown"
                                                                             , "carIndex",                 AUTO_PURCHASE_DATA.carIndex   or "-1"
                                                                             , "state",                    AUTO_PURCHASE_DATA.state      or "unknown"
                                                         );


                                                         enableButtonInput();
                                                         self._waitAppStore = false;
                                                         self:	buyKey();
                                                      end,
                                                      function ()
                                                         enableButtonInput();
                                                         self._waitAppStore = false;
                                                         self:showErrorPopup();
                                                      end
               );
               if not success then
                  enableButtonInput();
                  self._waitAppStore = false;
                  self:showErrorPopup();
               end
            end
      );

   end

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:buyCoin()

   local reqAmount	= AUTO_PURCHASE_DATA.price;
   local coinIndex	= App.data:getAutoCoinBuyIndex(reqAmount);
   local cost			= App.data:getStoreGoldCost(coinIndex);

   if App.data:canBuyStoreGold(coinIndex) then

      if App.data:buyStoreGold(coinIndex) then

         local bCoins = App.data:getStoreGoldAmount(coinIndex);

         EventMgr:postEvent( { index=coinIndex, gold=bCoins }, "gold-bought" );

         self:done("success");

      else

         self:showErrorPopup();

         self:done("failure");

      end


   else

      if not StoreMgr:canMakePayments() then

         self:showErrorPopup( LocalizationMgr:getString( "NATIVE_PURCH_DISABLED" ) );

         self:done("failure");

         return false;

      end

      local productId = StoreMgr:getGemAutoBuyId(cost.gem);

      print("StateAutoBuyPopupMaz:buyCoin", productId );

      disableButtonInput();

      self._waitAppStore = true;
      StateMgr:setSyncBusyDelay( 0 );

      delay(1,

            function()

               local success = StoreMgr:buyProduct( productId,
                                                    self,
                                                    function ()
                                                       local bGems = StoreMgr:getProductAmount(productId).gem;

                                                       EventMgr:postEvent( {  gem=bGems, productId=productId, source="auto-buy" }, "gems-bought" );

                                                       MOAIFlurry:event(   "auto-buy-gem-success"
                                                                           , "type",                     AUTO_PURCHASE_DATA.currency
                                                                           ,  "productId",               ""..productId
                                                                           ,  "amount",                  ""..bGems
                                                                           , "reason1",                  AUTO_PURCHASE_DATA.reason1    or "unknown"
                                                                           , "reason2",                  AUTO_PURCHASE_DATA.reason2    or "unknown"
                                                                           , "carIndex",                 AUTO_PURCHASE_DATA.carIndex   or "-1"
                                                                           , "state",                    AUTO_PURCHASE_DATA.state      or "unknown"
                                                       );

                                                       enableButtonInput();
                                                       self._waitAppStore = false;
                                                       self:buyCoin();
                                                    end,
                                                    function ()

                                                       enableButtonInput();
                                                       self._waitAppStore = false;
                                                       self:showErrorPopup();

                                                    end
               );

               if not success then
                  enableButtonInput();
                  self._waitAppStore = false;
                  self:showErrorPopup();
               end
            end
      );


   end

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:buyGem()

   print("StateAutoBuyPopupMaz:buyGem");

   if not StoreMgr:canMakePayments() then

      self:showErrorPopup( LocalizationMgr:getString( "NATIVE_PURCH_DISABLED" ) );

      self:done("failure");

      return false;

   end

   local reqAmount	= AUTO_PURCHASE_DATA.price;
   local productId = StoreMgr:getGemAutoBuyId(reqAmount);

   disableButtonInput();

   self._waitAppStore = true;
   StateMgr:setSyncBusyDelay( 0 );

   print("StateAutoBuyPopupMaz:buyGem-2");

   delay(1,
         function()
            local success = StoreMgr:buyProduct( productId,
                                                 self,
                                                 function ()

                                                    local bGems = StoreMgr:getProductAmount(productId).gem;

                                                    EventMgr:postEvent( {  gem=bGems, productId=productId, source="auto-buy" }, "gems-bought" );

                                                    MOAIFlurry:event(   "auto-buy-gem-success"
                                                                        , "type",                     AUTO_PURCHASE_DATA.currency
                                                                        ,  "productId",               ""..productId
                                                                        ,  "amount",                  ""..bGems
                                                                        , "reason1",                  AUTO_PURCHASE_DATA.reason1    or "unknown"
                                                                        , "reason2",                  AUTO_PURCHASE_DATA.reason2    or "unknown"
                                                                        , "carIndex",                 AUTO_PURCHASE_DATA.carIndex   or "-1"
                                                                        , "state",                    AUTO_PURCHASE_DATA.state      or "unknown"
                                                    );

                                                    enableButtonInput();
                                                    self._waitAppStore = false;
                                                    self:done("success");
                                                 end,
                                                 function ()

                                                    enableButtonInput();
                                                    self._waitAppStore = false;
                                                    self:showErrorPopup();
                                                 end
            );
            if not success then
               enableButtonInput();
               self._waitAppStore = false;
               self:showErrorPopup();
            end
         end
   );

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:showErrorPopup( message )

   local text = message or LocalizationMgr:getString( "NATIVE_TRY_AGAIN" );

   MOAIDialogIOS.showDialog( LocalizationMgr:getString( "NATIVE_TRANS_FAIL" )
                             , text
                             ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                             ,  nil
                             ,  nil
                             ,  false
                             ,  function()
                                end
   );

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:goBack()

   print("Go Back");
   if AUTO_PURCHASE_CLOSE_FUNC then
      AUTO_PURCHASE_CLOSE_FUNC();
      AUTO_PURCHASE_CLOSE_FUNC = nil;
   end

   AUTO_PURCHASE_DATA = {};
   AUTO_PURCHASE_FUNC = nil;

   MOAIFlurry:eventStop("auto-buy", "ending", "canceled");

   StateMgr:pop();

end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:isBusy()
   return self._waitAppStore;
end

----------------------------------------------------------------------

function StateAutoBuyPopupMaz:getBusyName()
   return "Waiting for Store";
end

----------------------------------------------------------------

function StateAutoBuyPopupMaz:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

return StateAutoBuyPopupMaz;

----------------------------------------------------------------
