----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

----------------------------------------------------------------

local Base						= State;
local StateBragMsg			= Base:new();
local MessageIndex			= 1;

----------------------------------------------------------------

function StateBragMsg:onLoad()

   State.onLoad( self );

   local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
	
   self.defaultFontName = "resources/font/TangoLatin.otf"

	self.IS_POPUP  = true;

	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.7});

	-- background and icon
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IBScreenTopBackGround", textureSheet);
	
	-- change msg button
	self.NextMsgButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBNextBragButton", textureSheet, nil, self.advanceMsg, nil, nil, nil);

	-- push/pop state buttons
	self.ConfirmButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBSelectButton", textureSheet, nil, self.goBack, nil, nil, nil);
	self.ConfirmButton:setPriority(PRIORTY_0);
	
	-- text message
	self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 160, 560, 115, '', self.defaultFontName, 18.9, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleText:setPriority(PRIORTY_0);
	self.MessageText = self:addWidget(TextBox, self.mainLayer, 0, 47, 560, 115, '', self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
	self.MessageText:setPriority(PRIORTY_0);

end

----------------------------------------------------------------

function StateBragMsg:onFocus()
   
   Base.onFocus(self);

	MessageIndex = App.data:getValue('BragMsgIndex2');

   self:createMsgTable();

	self:setMessage();
   
end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateBragMsg:createMsgTable()


   self.Message_Title_List = {};
   self.Message_List       = {};

	local score;
	
	if not App.lastGameScore then
		score = 0;
	else
		score = App.lastGameScore;
	end

   local bragMessageTemplates = MessageMgr:getBragTemplateList();
   for i=1, #bragMessageTemplates do

      self.Message_Title_List[i] = string.gsub( bragMessageTemplates[i].title, "@MYSCORE", score  );
      self.Message_List[i]       = string.gsub( bragMessageTemplates[i].body,  "@MYSCORE", score  );

   end

end

----------------------------------------------------------------

function StateBragMsg:setMessage()

	self.TitleText:setText(self.Message_Title_List[MessageIndex]);
	self.MessageText:setText(self.Message_List[MessageIndex]);

end

----------------------------------------------------------------

function StateBragMsg:advanceMsg()

	MessageIndex = MessageIndex + 1;
	
	if MessageIndex > #self.Message_List then
		MessageIndex = 1;
	end
	
	self:setMessage();

end

----------------------------------------------------------------

function StateBragMsg:goBack()

	print("Go Back");
	
	App.data:setValue('BragMsgIndex2', MessageIndex);
	StateMgr:pop();

end

----------------------------------------------------------------

return StateBragMsg;

----------------------------------------------------------------
