----------------------------------------------------------------

require('flash/flash-manager')
require('state/state')
require('engine/texture/texture-manager')
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SHOP_TRAY_HOME_X		= 0;
local SHOP_TRAY_HOME_Y		= 0;
local SHOP_TRAY_SHIFT		= 300;
local COIN_COUNT_X			= -143;
local COIN_COUNT_Y			= 437;
local GEM_COUNT_X				= 163;
local GEM_COUNT_Y				= 437;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;

local MAX_MISSION          = 110;

----------------------------------------------------------------

local Base              = State;
local StateCheat     = Base:new();

local FPS = 30;

local textLoc = {
                           { text1={x=60,y=151}, text2={x=60,y=111}, textcenter={x=60,y=131} },
                           { text1={x=60,y=21}, text2={x=60,y=-19}, textcenter={x=60,y=1} },
                           { text1={x=60,y=-109}, text2={x=60,y=-149}, textcenter={x=60,y=-129} },
                        };

local animLength = 100.8/FPS;
local maxMissions = #TEMPLATE_MISSION_LIST_01;
local screenWidth = App.viewportWidth;
local screenHeight = App.viewportHeight;
local textOffsetX = 60;
local textOffsetY = 230;
local bannerDeltaY = -130;


----------------------------------------------------------------

function  StateCheat:onLoad(  )

   State.onLoad( self );
	localSelf      = self;
	
	local textureSheet      = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

	self.textureSheet      = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", FPS);

   self.defaultFontName = "resources/font/TangoLatin.otf";

	-- keys, coins, gems and shop buttons
	self.ShopBarBackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IPhone4BackDrop", textureSheet);
	self:setShopTrayHeight();
	self.ShopBarPivot = MOAITransform2D.new();
	self.ShopBarPivot:setLoc(SHOP_TRAY_HOME_X, SHOP_TRAY_HOME_Y);
	self.ShopBarBackDrop:setPriority(PRIORTY_5);
	self.ShopBarBackDrop:setParent(self.ShopBarPivot);
	self.CoinButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, COIN_COUNT_Y, 0,0, "CoinsBuy", textureSheet, nil, self.missionMinus, nil, nil, nil, nil, 10);
	self.CoinButton:setPriority(PRIORTY_5);
	self.CoinButton:setParent(self.ShopBarPivot);
	self.CoinCounter = self:addWidget(TextBox, self.mainLayer, COIN_COUNT_X, COIN_COUNT_Y, 180, 81, "-", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.CoinCounter.moaiTextBox:setPriority(PRIORTY_5);
	self.CoinCounter:setParent(self.ShopBarPivot);
	self.GemButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, GEM_COUNT_Y, 0,0, "GemsBuy", textureSheet, nil, self.missionPlus, nil, nil, nil, nil, 10);
	self.GemButton:setPriority(PRIORTY_5);
	self.GemButton:setParent(self.ShopBarPivot);
	self.GemCounter = self:addWidget(TextBox, self.mainLayer, GEM_COUNT_X, GEM_COUNT_Y, 180, 81, "+", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.GemCounter.moaiTextBox:setPriority(PRIORTY_5);
	self.GemCounter:setParent(self.ShopBarPivot);

	self:createProps();
	
end

----------------------------------------------------------------

function StateCheat:missionHack()
	
	if self.missionNumber then
		if self.missionNumber > 0 and self.missionNumber <= MAX_MISSION then
			App.data:updateMission(self.missionNumber, false );
			print("Setting mission to:",self.missionNumber);
			App.data:setValue( "hack-mission-number", self.missionNumber );
			self:hackSucceed();
		else
			print("Mission num is invalid:",self.missionNumber);
		end
	else
		print("Mission num is invalid:",self.missionNumber);
	end

	
end

----------------------------------------------------------------

function StateCheat:hackSucceed()

	local tpl = App.data:getCurrentMissionTemplate();
   if tpl then
      if App.mission then
         App.mission:deactivate();
      end
      App.mission = Mission:new( tpl );
      App.mission:activate();
   end
   
   for i=1,3 do
      App.data:setValue( "curGoal".. i, 0 );
   end
	
	self:close();

end


----------------------------------------------------------------

function  StateCheat:missionPlus(  )

	self.missionNumber = self.missionNumber+1;
	if self.missionNumber > MAX_MISSION then
		self.missionNumber = 1;
	end
	self:updateProps();

end

----------------------------------------------------------------

function  StateCheat:missionMinus(  )


	self.missionNumber = self.missionNumber-1;
	if self.missionNumber <= 0 then
		self.missionNumber = MAX_MISSION;
	end
	self:updateProps();
	
end


----------------------------------------------------------------

function  StateCheat:onActivate(  )

   Base.onActivate( self );
	
	self.missionNumber = App.data:getValue("hack-mission-number");
	if not self.missionNumber then
		self.missionNumber = 1;
	end
	
	self:updateProps();

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateCheat:setShopTrayHeight()

	local aspect = App.viewportHeight/App.viewportWidth;
	
	if aspect > 1.76 then
		
		COIN_COUNT_Y	= 525;
		GEM_COUNT_Y		= 525;
		
		self.ShopBarBackDrop:setVisible(false);
		
	end

end


----------------------------------------------------------------

function  StateCheat:createProps(  )

	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.75});
	
   self.background = self:addWidget(Anim, self.mainLayer, 0, 0, 0, 0, "M_MissionPopUpBackDrop", self.textureSheet);
   self.background:setPriority(PRIORTY_0);
	
   self.bluebox = self:addWidget(Anim, self.mainLayer, 0, 0, 0, 0, "M_BlueBox", self.textureSheet);
   self.bluebox:setPriority(PRIORTY_0);
	
	self.Title = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "M_TitleMission", self.textureSheet, nil, nil, true);
	self.Title:setPriority(PRIORTY_2);
	
   self.backButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "M_ReadyButton", self.textureSheet, nil, self.missionHack, nil, nil);
   self.backButton:setPriority(PRIORTY_3);
   
   self.missionNumberImage = self:addWidget( TextBox, self.mainLayer,
                                          -232.7, 288.95, 140, 100, 
                                          "", self.defaultFontName, 26, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {0,0,0,1}
                                          );
   self.missionNumberImage:setPriority(PRIORTY_3);


											         
   self.skipButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "M_SkipButton", self.textureSheet, nil, self.hackReset, nil, nil);
	self.skipButton:setPriority(PRIORTY_3);
	
	



end


----------------------------------------------------------------

function  StateCheat:hackReset(  )

--[[
   
   --joe: removing since _hackReset doesn't exist anymore

	if LoginMgr:isTango() and OnlineMgr:isOnline() then

      App.data:_hackReset( 100000,100000,100000 )
		self:close();
	else
	
		App.data:addKey( 100, "Cheat" );
		App.data:addGold( 1000, "Cheat" );
		App.data:addGem( 10, "Cheat" );
	end
   
]]

self:close();
		
										
end
----------------------------------------------------------------

function  StateCheat:resetProps(  )

	self.missionNumberImage:setText("");
	self.missionNumberImage:setColor(0,0,0,1);

end


----------------------------------------------------------------

function  StateCheat:updateProps( )

	
	self:resetProps();
	
	--set mission # text
	self.missionNumberImage:setText(tostring(self.missionNumber));

end


----------------------------------------------------------------

function  StateCheat:onFocus(  )

   Base.onFocus( self );

   --Make sure we are not flag as thief
   App.data:setValue("iap-verified", 1 );
   App.data:addGem(1000);
  -- App.data:giveFreebie("head-start", 1, "cheat");
  -- App.data:giveFreebie("double-score", 1, "cheat");
  -- App.data:giveFreebie("power-time", 1, "cheat");
  -- App.data:giveFreebie("revive", 1, "cheat");
	--App.data:giveFreebie("mystery", 5, "cheat");
	--BountyMgr:_resetBountyList();
	--EventMgr:postEvent({}, "test-guest-friend-reset");

end


----------------------------------------------------------------

function StateCheat:onLoseFocus()

   State.onLoseFocus(self);

end

----------------------------------------------------------------

function onLoaderDone( loader )


end

----------------------------------------------------------------

function  StateCheat:onUpdate( dt )

   Base.onUpdate(self,dt);

end


----------------------------------------------------------------

function  StateCheat:reload()

	
   
end

----------------------------------------------------------------

function  StateCheat:close()

   StateMgr:pop();
   
end

----------------------------------------------------------------

return StateCheat