----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local Base                    = State;
local StateConsumableOverlay  = Base:new();

local GEM_ICON				=
{
	{x=28,		y=94},--{x=-162, y=325},
	{x=28,		y=94},--{x=28, y=325},
	{x=28,		y=94},--{x=222, y=325},
};

local GEM_ICON_OFFSET_1  = 0;
local GEM_ICON_OFFSET_10 = 4;

local GEM_TEXT				=
{
	{x=55,		y=94},--{x=-132, y=325},
   {x=52,		y=94},--{x=58, y=325},
	{x=55,		y=94},--{x=252, y=325},
};
local FREE_TEXT			=
{
	{x=75,		y=106},
   {x=76,		y=106},
	{x=73,		y=106},
};
local INFO_TEXT         =
{
   start =     {x=0, y=-200},
	boost =     {x=0, y= 400},
	double =    {x=0, y= 400},
	time =      {x=0, y= 400},
};

local FLYOVER_TIME = 2;

----------------------------------------------------------------

function  StateConsumableOverlay:onLoad(  )

   Base.onLoad(self);

   self.defaultFontName = "resources/font/TangoLatin.otf";

   self.IS_POPUP  = true;
   self.DidShowAd = false;

   local textureSheet  = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group3.lua", "resources/flash-resource-bundle/Group3.png", 30);
   local textureSheet2 = FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);
   local textureSheet3 = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);


   --We need a gap to dispay some of the help text for consumable
   --On shorter screen (i.e. iPhone 4) there would not be any room... so push it down
   local buttonDeltaY      = math.min((App.viewHeight - 1136 )/4,0);
   local helpTextDeltaY    = buttonDeltaY;
   local tapToStartDeltaY  = -buttonDeltaY;

   --consumable buttons

   --head start

   self.headStartGreenIntro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConBoost_Green_In", textureSheet);
   self.headStartGreenIntro:setPriority(10);
   self.headStartGreenIntro:setVisible(false);

	self.headStartButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,buttonDeltaY,0,0, "ConBoost_Check", textureSheet, self.headStartPressed, self.headStartTap, self.headStartCancel, nil );
   self.headStartButton:setPriority(10);
   self.headStartButton:setVisible(false);
   self.headStartButton:disable();

   self.hsAlert = self:addWidget(Anim, self.mainLayer, 90, 30,0,0, "NotificationIconMystery_Counter", textureSheet3);
   self.hsAlert:setPriority(12);
   self.hsAlert:setScale(0.9,0.9);
   self.hsAlert:setSpan(1.0);
   self.hsAlert:setMode(MOAITimer.LOOP);
   self.hsAlert:setVisible(false);

   self.hsAlertSparkle = self:addWidget(Anim, self.mainLayer, 20, BUY_Y,0,0, "NotificationSparkle", textureSheet3);
   self.hsAlertSparkle:setPriority(11);
   self.hsAlertSparkle:setScale(0.9,0.9);
   self.hsAlertSparkle:setSpan(29/30);
   self.hsAlertSparkle:setMode(MOAITimer.LOOP);
   self.hsAlertSparkle:setVisible(false);

   self.headStartGreenExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConBoost_Green_Out", textureSheet);
   self.headStartGreenExtro:setPriority(10);
   self.headStartGreenExtro:setVisible(false);

   self.headStartCheckExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConBoost_Check_Out", textureSheet);
   self.headStartCheckExtro:setPriority(10);
   self.headStartCheckExtro:setVisible(false);

   self.headStartBlueIntro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConBoost_Blue_In", textureSheet);
   self.headStartBlueIntro:setPriority(10);
   self.headStartBlueIntro:setVisible(false);

	self.headStartBlue = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,buttonDeltaY,0,0, "ConBoost_Blue_Clicked", textureSheet, nil, self.headStartBlueTap, nil, nil);
   self.headStartBlue:setPriority(15);
   self.headStartBlue:setVisible(false);
   self.headStartBlue:disable();

   self.headStartBlueExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConBoost_Blue_Out", textureSheet);
   self.headStartBlueExtro:setPriority(10);
   self.headStartBlueExtro:setVisible(false);

   -- double score

   self.doubleScoreGreenIntro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "Con2x_Green_In", textureSheet);
   self.doubleScoreGreenIntro:setPriority(10);
   self.doubleScoreGreenIntro:setVisible(false);

	self.doubleScoreButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,buttonDeltaY,0,0, "Con2x_Check", textureSheet, self.doubleScorePressed, self.doubleScoreTap, self.doubleScoreCancel, nil);
   self.doubleScoreButton:setPriority(10);
   self.doubleScoreButton:setVisible(false);
   self.doubleScoreButton:disable();

   self.dsAlert = self:addWidget(Anim, self.mainLayer, 90, 30,0,0, "NotificationIconMystery_Counter", textureSheet3);
   self.dsAlert:setPriority(12);
   self.dsAlert:setScale(0.9,0.9);
   self.dsAlert:setSpan(1.0);
   self.dsAlert:setMode(MOAITimer.LOOP);
   self.dsAlert:setVisible(false);

   self.dsAlertSparkle = self:addWidget(Anim, self.mainLayer, 20, BUY_Y,0,0, "NotificationSparkle", textureSheet3);
   self.dsAlertSparkle:setPriority(11);
   self.dsAlertSparkle:setScale(0.9,0.9);
   self.dsAlertSparkle:setSpan(29/30);
   self.dsAlertSparkle:setMode(MOAITimer.LOOP);
   self.dsAlertSparkle:setVisible(false);

   self.doubleScoreGreenExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "Con2x_Green_Out", textureSheet);
   self.doubleScoreGreenExtro:setPriority(10);
   self.doubleScoreGreenExtro:setVisible(false);

   self.doubleScoreCheckExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "Con2x_Check_Out", textureSheet);
   self.doubleScoreCheckExtro:setPriority(10);
   self.doubleScoreCheckExtro:setVisible(false);

   self.doubleScoreBlueIntro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "Con2x_Blue_In", textureSheet);
   self.doubleScoreBlueIntro:setPriority(10);
   self.doubleScoreBlueIntro:setVisible(false);

	self.doubleScoreBlue = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,buttonDeltaY,0,0, "Con2x_Blue_Clicked", textureSheet, nil, self.doubleScoreBlueTap, nil, nil );
   self.doubleScoreBlue:setPriority(15);
   self.doubleScoreBlue:disable();
   self.doubleScoreBlue:setVisible(false);

   self.doubleScoreBlueExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "Con2x_Blue_Out", textureSheet);
   self.doubleScoreBlueExtro:setPriority(10);
   self.doubleScoreBlueExtro:setVisible(false);

   --power time

   self.powerTimeGreenIntro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConTime_Green_In", textureSheet);
   self.powerTimeGreenIntro:setPriority(10);
   self.powerTimeGreenIntro:setVisible(false);

	self.powerTimeButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,buttonDeltaY,0,0, "ConTime_Check", textureSheet, self.powerTimePressed, self.powerTimeTap, self.powerTimeCancel, nil, nil);
   self.powerTimeButton:setPriority(10);
   self.powerTimeButton:setVisible(false);
   self.powerTimeButton:disable();

   self.ptAlert = self:addWidget(Anim, self.mainLayer, 90, 30,0,0, "NotificationIconMystery_Counter", textureSheet3);
   self.ptAlert:setPriority(12);
   self.ptAlert:setScale(0.9,0.9);
   self.ptAlert:setSpan(1.0);
   self.ptAlert:setMode(MOAITimer.LOOP);
   self.ptAlert:setVisible(false);

   self.ptAlertSparkle = self:addWidget(Anim, self.mainLayer, 20, BUY_Y,0,0, "NotificationSparkle", textureSheet3);
   self.ptAlertSparkle:setPriority(11);
   self.ptAlertSparkle:setScale(0.9,0.9);
   self.ptAlertSparkle:setSpan(29/30);
   self.ptAlertSparkle:setMode(MOAITimer.LOOP);
   self.ptAlertSparkle:setVisible(false);

   self.powerTimeGreenExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConTime_Green_out", textureSheet);
   self.powerTimeGreenExtro:setPriority(10);
   self.powerTimeGreenExtro:setVisible(false);

   self.powerTimeCheckExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConTime_Check_Out", textureSheet);
   self.powerTimeCheckExtro:setPriority(10);
   self.powerTimeCheckExtro:setVisible(false);

   self.powerTimeBlueIntro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConTime_Blue_In", textureSheet);
   self.powerTimeBlueIntro:setPriority(10);
   self.powerTimeBlueIntro:setVisible(false);

	self.powerTimeBlue = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,buttonDeltaY,0,0, "ConTime_Blue_Clicked", textureSheet, nil, self.powerTimeBlueTap, nil, nil );
   self.powerTimeBlue:setPriority(15);
   self.powerTimeBlue:disable();
   self.powerTimeBlue:setVisible(false);

   self.powerTimeBlueExtro = self:addWidget(Anim, self.mainLayer, 0,buttonDeltaY,0,0, "ConTime_Blue_Out", textureSheet);
   self.powerTimeBlueExtro:setPriority(10);
   self.powerTimeBlueExtro:setVisible(false);

   --consumable prices

   self.headStartCostTxt = self:addWidget(TextBox, self.mainLayer, GEM_TEXT[1].x, GEM_TEXT[1].y, 200, 200, "", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.headStartCostTxt:setPriority(1000);
   self.headStartCostTxt:setText("");
   self.headStartCostTxt:setVisible(false);
   self.headStartCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );

   self.headStartGemIcon = self:addWidget(Anim, self.mainLayer, GEM_ICON[1].x - GEM_ICON_OFFSET_1, GEM_ICON[1].y, 0,0, "SmallGemsIcon", textureSheet, nil, nil, true);
   self.headStartGemIcon:setPriority(1000);
	self.headStartGemIcon:setScale(0.5, 0.5);
   self.headStartGemIcon.anim:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
   self.headStartGemIcon:setVisible(false);

   self.doubleScoreCostTxt = self:addWidget(TextBox, self.mainLayer, GEM_TEXT[3].x, GEM_TEXT[3].y, 200, 200, "", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.doubleScoreCostTxt:setPriority(1000);
   self.doubleScoreCostTxt:setText("");
   self.doubleScoreCostTxt:setVisible(false);
   self.doubleScoreCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );

   self.doubleScoreGemIcon = self:addWidget(Anim, self.mainLayer, GEM_ICON[3].x - GEM_ICON_OFFSET_1, GEM_ICON[3].y, 0,0, "SmallGemsIcon", textureSheet, nil, nil, true);
   self.doubleScoreGemIcon:setPriority(1000);
	self.doubleScoreGemIcon:setScale(0.5, 0.5);
   self.doubleScoreGemIcon.anim:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
   self.doubleScoreGemIcon:setVisible(false);

   self.powerTimeCostTxt = self:addWidget(TextBox, self.mainLayer, GEM_TEXT[2].x, GEM_TEXT[2].y, 200, 200, "", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.powerTimeCostTxt:setPriority(1000);
   self.powerTimeCostTxt:setText("");
   self.powerTimeCostTxt:setVisible(false);
   self.powerTimeCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );

   self.powerTimeGemIcon = self:addWidget(Anim, self.mainLayer, GEM_ICON[2].x - GEM_ICON_OFFSET_1, GEM_ICON[2].y, 0,0, "SmallGemsIcon", textureSheet, nil, nil, true);
   self.powerTimeGemIcon:setPriority(1000);
	self.powerTimeGemIcon:setScale(0.5, 0.5);

   self.powerTimeGemIcon.anim:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
   self.powerTimeGemIcon:setVisible(false);

   --display text

   self.tapToStartText = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.start.x, INFO_TEXT.start.y+tapToStartDeltaY, 400, 400, "", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.tapToStartText:setPriority(1000);
   self.tapToStartText:setText("TAP TO START");

   self.tapToStartShadow = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.start.x+2, INFO_TEXT.start.y-2+tapToStartDeltaY, 400, 400, "", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.tapToStartShadow:setColor(0, 0, 0, 1);
   self.tapToStartShadow:setPriority(999);
   self.tapToStartShadow:setText("TAP TO START");

   self.headStartText = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.boost.x, INFO_TEXT.boost.y+helpTextDeltaY, 600, 400, "", self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.headStartText:setPriority(1000);
   self.headStartText:setText("Start with a Boost!");
   self.headStartText:setVisible(false);

   self.headStartTextShadow = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.boost.x+2, INFO_TEXT.boost.y-2+helpTextDeltaY, 600, 400, "", self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.headStartTextShadow:setPriority(999);
   self.headStartTextShadow:setColor(0, 0, 0, 1);
   self.headStartTextShadow:setText("Start with a Boost!");
   self.headStartTextShadow:setVisible(false);

   self.doubleScoreText = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.boost.x, INFO_TEXT.boost.y+helpTextDeltaY, 600, 400, "", self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.doubleScoreText:setPriority(1000);
   self.doubleScoreText:setText("Double points from kills!");
   self.doubleScoreText:setVisible(false);

   self.doubleScoreTextShadow = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.boost.x+2, INFO_TEXT.boost.y-2+helpTextDeltaY, 600, 400, "", self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.doubleScoreTextShadow:setPriority(999);
   self.doubleScoreTextShadow:setColor(0, 0, 0, 1);
   self.doubleScoreTextShadow:setText("Double points from kills!");
   self.doubleScoreTextShadow:setVisible(false);

   self.powerTimeText = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.boost.x, INFO_TEXT.boost.y+helpTextDeltaY, 600, 400, "", self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.powerTimeText:setPriority(1000);
   self.powerTimeText:setText("Power-Ups last longer!");
   self.powerTimeText:setVisible(false);

   self.powerTimeTextShadow = self:addWidget(TextBox, self.mainLayer, INFO_TEXT.boost.x+2, INFO_TEXT.boost.y-2+helpTextDeltaY, 600, 400, "", self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.powerTimeTextShadow:setPriority(999);
   self.powerTimeTextShadow:setColor(0, 0, 0, 1);
   self.powerTimeTextShadow:setText("Power-Ups last longer!");
   self.powerTimeTextShadow:setVisible(false);

    self.ShouldShowRandomBoosterButton = false;

if self.ShouldShowRandomBoosterButton then
--video for random boost
  self.randomBoosterButton = self:addWidget(ButtonImage, self.mainLayer, 0,INFO_TEXT.boost.y - 360,256,128, "resources/UI/Consumable/Consumable_GreenButton.png", nil, self.randomBoosterUsed, nil, nil);
  self.randomBoosterButton:setPriority(PRIORTY_2);
  self.randomBoosterButton:setVisible(true);

  self.randomBoosterIcon = self:addWidget(ButtonImage, self.mainLayer, -60,INFO_TEXT.boost.y - 360, 61, 61, "resources/videoIcon.png", nil, nil)
  self.randomBoosterIcon:setPriority(PRIORTY_5);
  self.randomBoosterIcon:setVisible(true);

  self.randomBoosterText = self:addWidget(TextBox, self.mainLayer, 40, INFO_TEXT.boost.y - 360, 150, 150, "", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.randomBoosterText:setText("RANDOM");
  self.randomBoosterText:setPriority(1000);
  self.randomBoosterText:setVisible(true);

  self.randomBoosterTextShadow = self:addWidget(TextBox, self.mainLayer, 40+2, INFO_TEXT.boost.y - 360 - 2, 150, 150, "", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
  self.randomBoosterTextShadow:setPriority(999);
   self.randomBoosterTextShadow:setText("RANDOM");
   self.randomBoosterTextShadow:setColor(0, 0, 0, 1);
  self.randomBoosterTextShadow:setVisible(true);
end

   self:_setupBasicResourceBar( true );

   self.selectedCost = 0;

end

----------------------------------------------------------------

function  StateConsumableOverlay:onActivate(  )

   Base.onActivate(self);

   self.introRunning       = false;
   self.extroRunning       = false;

   self.headStartEnabled = false;
   self.powerTimeEnabled = false;
   self.doubleScoreEnabled = false;

   self.selectedCost = 0;

   local hsCost = ConsumableMgr:getCost(CONSUMABLE_HEADSTART_INDEX) or {};
   Debug.assert( hsCost and hsCost.gem );
   self.headStartCost = hsCost.gem or 1;
   self.headStartFreebies = App.data:getFreebieCount("head-start");
   self.powerTimeFreebies = App.data:getFreebieCount("power-time");
   self.doubleScoreFreebies = App.data:getFreebieCount("double-score");

   local ptCost = ConsumableMgr:getCost(CONSUMABLE_POWERTIME_INDEX) or {};
   Debug.assert( ptCost and ptCost.gem );
   self.powerTimeCost = ptCost.gem or 5;

   local dsCost = ConsumableMgr:getCost(CONSUMABLE_DOUBLESCORE_INDEX) or {};
   Debug.assert( dsCost and dsCost.gem );
   self.doubleScoreCost = dsCost.gem or 10;



   if self.headStartFreebies > 0 then
      if self.headStartFreebies > 99 then
         self.headStartCostTxt:setText("99");
      else
         self.headStartCostTxt:setText(""..self.headStartFreebies);
      end
   else
      self.headStartCostTxt:setText(""..self.headStartCost);
   end

   if self.powerTimeFreebies > 0 then
      if self.powerTimeFreebies > 99 then
         self.powerTimeCostTxt:setText("99");
      else
         self.powerTimeCostTxt:setText(""..self.powerTimeFreebies);
      end
   else
      self.powerTimeCostTxt:setText(""..self.powerTimeCost);
   end

   if self.doubleScoreFreebies > 0 then
      self.doubleScoreCostTxt:setText(""..self.doubleScoreFreebies);
   else
      self.doubleScoreCostTxt:setText(""..self.doubleScoreCost);
   end

   self.tapToStartTextTime = 0;
   self.tapToStartAlpha    = 1;


end

----------------------------------------------------------------

function  StateConsumableOverlay:onFocus( data )

   Base.onFocus(self);

   --Dont cache game because we want  to be garage collected amd we do not want to keep a reference for it
   Debug.assert( App.game ~= nil , "StateConsumableOverlay:onLoad -> App.game"  );

	if data and data.game then
		self.game = data.game;
	end

   --intro animation
   if not self.introHack then
      self.introHack = true;
      self:startIntro();
   end

if self.ShouldShowRandomBoosterButton then

       if AdMgr:isVideoAvailable()  then
          self.randomBoosterButton:setVisible(true);
          self.randomBoosterIcon:setVisible(true);
          self.randomBoosterText:setVisible(true);
          self.randomBoosterTextShadow:setVisible(true);
            self.randomBoosterButton:enable();
       else
          self.randomBoosterButton:disable();
          self.randomBoosterButton:setVisible(false);
          self.randomBoosterIcon:setVisible(false);
          self.randomBoosterText:setVisible(false);
          self.randomBoosterTextShadow:setVisible(false);
       end



        if self.DidShowAd then
            math.randomseed( os.time() );
            local r = math.random(1,100);
            if r <= 94 then
                App.data:giveFreebie("head-start", 1, "game start video");
                self.headStartFreebies = App.data:getFreebieCount("head-start");
                self.headStartEnabled = true;
            end

            if r > 94 and r <= 98 then
                App.data:giveFreebie("power-time", 1, "game start video");
                self.powerTimeFreebies = App.data:getFreebieCount("power-time");
                self.powerTimeEnabled = true;
            end

            if r > 98 then
                App.data:giveFreebie("double-score", 1, "game start video");
                self.doubleScoreFreebies = App.data:getFreebieCount("double-score");
                self.doubleScoreEnabled = true;
            end



            self.DidShowAd = false;
            self.randomBoosterButton:disable();
            self.randomBoosterButton:setVisible(false);
            self.randomBoosterIcon:setVisible(false);
            self.randomBoosterText:setVisible(false);
            self.randomBoosterTextShadow:setVisible(false);
            self.ready = true;

        end
end
   self:buttonCheck();


end

----------------------------------------------------------------

function  StateConsumableOverlay:startIntro()

   self.hsIntro = true;
   self.ptIntro = true;
   self.dsIntro = true;

   local gems = App.data:getGemCount();
   local gemsAfterStart = gems - self.selectedCost;

   if gemsAfterStart < self.headStartCost then

      self.headStartBlueIntro:apply(0);
      self.headStartBlueIntro:setVisible(true);
      self.hsIntroAnim = self.headStartBlueIntro:start();

   else

      if self.headStartEnabled then
         --need "check in" anims for this. not currently possible
      else

         self.headStartGreenIntro:apply(0);
         self.headStartGreenIntro:setVisible(true);
         self.hsIntroAnim = self.headStartGreenIntro:start();

      end
   end

   if gemsAfterStart < self.powerTimeCost then

      self.powerTimeBlueIntro:apply(0);
      self.powerTimeBlueIntro:setVisible(true);
      self.ptIntroAnim = self.powerTimeBlueIntro:start();
   else
      if self.powerTimeEnabled then
         --need "check in" anims for this. not currently possible
      else

         self.powerTimeBlueIntro:apply(0);
         self.powerTimeGreenIntro:apply(0);
         self.powerTimeGreenIntro:setVisible(true);
         self.ptIntroAnim = self.powerTimeGreenIntro:start();
      end
   end

   if gemsAfterStart < self.doubleScoreCost then

      self.doubleScoreBlueIntro:apply(0);
      self.doubleScoreBlueIntro:setVisible(true);
      self.dsIntroAnim = self.doubleScoreBlueIntro:start();
   else
      if self.doubleScoreEnabled then
         --need "check in" anims for this. not currently possible
      else

         self.doubleScoreGreenIntro:apply(0);
         self.doubleScoreGreenIntro:setVisible(true);
         self.dsIntroAnim = self.doubleScoreGreenIntro:start();
      end
   end


   self.introRunning = true;

end

----------------------------------------------------------------

function  StateConsumableOverlay:startExtro()

   self.hsExtro = true;
   self.ptExtro = true;
   self.dsExtro = true;

   self.headStartCostTxt:setVisible(false);
   self.headStartGemIcon:setVisible(false);
   self.hsAlert:setVisible(false);
   self.hsAlert:stop();
   self.hsAlertSparkle:setVisible(false);
   self.hsAlertSparkle:stop();

   self.powerTimeCostTxt:setVisible(false);
   self.powerTimeGemIcon:setVisible(false);
   self.ptAlert:setVisible(false);
   self.ptAlert:stop();
   self.ptAlertSparkle:setVisible(false);
   self.ptAlertSparkle:stop();

   self.doubleScoreCostTxt:setVisible(false);
   self.doubleScoreGemIcon:setVisible(false);
   self.dsAlert:setVisible(false);
   self.dsAlert:stop();
   self.dsAlertSparkle:setVisible(false);
   self.dsAlertSparkle:stop();

   self.extroRunning = true;

   if self.headStartEnabled then

      self.hsSoundDelay = 0.001;
      self.headStartButton:setVisible(false);
      self.headStartButton:disable();

      self.headStartCheckExtro:apply(0);
      self.headStartCheckExtro:setVisible(true);
      self.hsExtroAnim = self.headStartCheckExtro:start();

   else

      if self.headStartButton:isEnabled() then

         self.headStartButton:setVisible(false);
         self.headStartButton:disable();

         self.headStartGreenExtro:apply(0);
         self.headStartGreenExtro:setVisible(true);
         self.hsExtroAnim = self.headStartGreenExtro:start();

      else

         self.headStartButton:setVisible(false);

         self.headStartBlue:setVisible(false);
         self.headStartBlue:disable();

         self.headStartBlueExtro:apply(0);
         self.headStartBlueExtro:setVisible(true);
         self.hsExtroAnim = self.headStartBlueExtro:start();

      end
   end

   if self.powerTimeEnabled then

      self.ptSoundDelay = 0.333;

      self.powerTimeButton:setVisible(false);
      self.powerTimeButton:disable();

      self.powerTimeCheckExtro:apply(0);
      self.powerTimeCheckExtro:setVisible(true);
      self.ptExtroAnim = self.powerTimeCheckExtro:start();
   else

      if self.powerTimeButton:isEnabled() then

         self.powerTimeButton:setVisible(false);
         self.powerTimeButton:disable();

         self.powerTimeGreenExtro:apply(0);
         self.powerTimeGreenExtro:setVisible(true);
         self.ptExtroAnim = self.powerTimeGreenExtro:start();
      else

         self.powerTimeButton:setVisible(false);

         self.powerTimeBlue:setVisible(false);
         self.powerTimeBlue:disable();

         self.powerTimeBlueExtro:apply(0);
         self.powerTimeBlueExtro:setVisible(true);
         self.ptExtroAnim = self.powerTimeBlueExtro:start();
      end
   end

   if self.doubleScoreEnabled then

      self.dsSoundDelay = 0.166;

      self.doubleScoreButton:setVisible(false);
      self.doubleScoreButton:disable();

      self.doubleScoreCheckExtro:apply(0);
      self.doubleScoreCheckExtro:setVisible(true);
      self.dsExtroAnim = self.doubleScoreCheckExtro:start();
   else

      if self.doubleScoreButton:isEnabled() then

         self.doubleScoreButton:setVisible(false);
         self.doubleScoreButton:disable();

         self.doubleScoreGreenExtro:apply(0);
         self.doubleScoreGreenExtro:setVisible(true);
         self.dsExtroAnim = self.doubleScoreGreenExtro:start();
      else

         self.doubleScoreButton:setVisible(false);

         self.doubleScoreBlue:setVisible(false);
         self.doubleScoreBlue:disable();

         self.doubleScoreBlueExtro:apply(0);
         self.doubleScoreBlueExtro:setVisible(true);
         self.dsExtroAnim = self.doubleScoreBlueExtro:start();
      end
   end

end

----------------------------------------------------------------

function  StateConsumableOverlay:onDeactivate(  )

   Base.onDeactivate(  self );

end

----------------------------------------------------------------

function StateConsumableOverlay:onLoseFocus( )

   Base.onLoseFocus(self);

end

----------------------------------------------------------------

function StateConsumableOverlay:onUpdate( dt )

   if App.game then
      App.game:onUpdate( dt );
   end

   self:updateFlyover( dt );

	self:_suppressDroneCharge();

   if self.introRunning then
      self:updateIntro(dt);
   end

   if self.extroRunning then
      self:updateExtro(dt);
   end

   if self.ready then
      self.ready = false;
      self:readyCheck();
      self:goBack();
   end

   if self.extroRunning then
      self.tapToStartAlpha = self.tapToStartAlpha*0.50;
   else
      self.tapToStartAlpha = math.lerp(0.70, 1.0, (math.cos( self.tapToStartTextTime ) + 1 ) / 2);
      self.tapToStartTextTime = self.tapToStartTextTime + 5*dt;
   end

   self.tapToStartText:setAlpha(self.tapToStartAlpha);
   self.tapToStartShadow:setAlpha(self.tapToStartAlpha);

end

----------------------------------------------------------------

function StateConsumableOverlay:_suppressDroneCharge()

	if self.game and self.game.avatar then
		self.game.avatar:setDroneChargeLeft(0);
		self.game.avatar:setDroneChargeRight(0);
	end

end

----------------------------------------------------------------

function StateConsumableOverlay:setFlyover( f, fs )

   if self.flyoverText then

      if self.flyoverText ~= f then
         self.flyoverText:setVisible(false);
         self.flyoverTextS:setVisible(false);
         self.flyoverText = f;
         self.flyoverTextS = fs;
      end

   else

      self.flyoverText = f;
      self.flyoverTextS = fs;

   end

   self.flyoverText:setVisible(true);
   self.flyoverTextS:setVisible(true);
   self.flyoverTime = FLYOVER_TIME;


end

----------------------------------------------------------------

function StateConsumableOverlay:hideFlyover( f )

   if self.flyoverText then

      if self.flyoverText == f then

         self.flyoverText:setVisible(false);
         self.flyoverTextS:setVisible(false);
         self.flyoverText = nil;
         self.flyoverTextS = nil;
         self.flyoverTime = 0;

      end
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:updateFlyover( dt )

   if self.flyoverTime and self.flyoverTime > 0 then
      self.flyoverTime = self.flyoverTime - dt;

      if self.flyoverTime <= 0 then
         self.flyoverTime = 0;
         if self.flyoverText and self.flyoverTextS then
            self.flyoverText:setVisible(false);
            self.flyoverTextS:setVisible(false);
            self.flyoverText = nil;
            self.flyoverTextS = nil;
         end
      end
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:updateIntro( dt )

   if self.hsIntroAnim then
      if not self.hsIntroAnim:isBusy() then
         self.hsIntro = false;
         self.hsIntroAnim = nil;
      end
   end

   if self.ptIntroAnim then
      if not self.ptIntroAnim:isBusy() then
         self.ptIntro = false;
         self.ptIntroAnim = nil;
      end
   end

   if self.dsIntroAnim then
      if not self.dsIntroAnim:isBusy() then
         self.dsIntro = false;
         self.dsIntroAnim = nil;
      end
   end

   if not self.hsIntro and not self.ptIntro and not self.dsIntro then
      self.introRunning = false;
      self:buttonCheck();
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:updateExtro( dt )

   if self.hsSoundDelay and self.hsSoundDelay > 0 then
      self.hsSoundDelay = self.hsSoundDelay - dt;
      if self.hsSoundDelay <= 0 then
         local cSounds = {start={"ConsumableHeadStart",},};
         EventMgr:postEvent( { sounds=cSounds, name="con hs extro",}, "add-sfx" );
         self.hsSoundDelay = 0;
      end
   end

   if self.ptSoundDelay and self.ptSoundDelay > 0 then
      self.ptSoundDelay = self.ptSoundDelay - dt;
      if self.ptSoundDelay <= 0 then
         local cSounds = {start={"ConsumableHeadStart",},};
         EventMgr:postEvent( { sounds=cSounds, name="con pt extro",}, "add-sfx" );
         self.ptSoundDelay = 0;
      end
   end

   if self.dsSoundDelay and self.dsSoundDelay > 0 then
      self.dsSoundDelay = self.dsSoundDelay - dt;
      if self.dsSoundDelay <= 0 then
         local cSounds = {start={"ConsumableHeadStart",},};
         EventMgr:postEvent( { sounds=cSounds, name="con ds extro",}, "add-sfx" );
         self.dsSoundDelay = 0;
      end
   end

   if self.hsExtroAnim then
      if self.hsExtroAnim:isBusy() then
      else
         self.hsExtro = false;
         self.hsExtroAnim = nil;
      end
   end

   if self.ptExtroAnim then
      if self.ptExtroAnim:isBusy() then
      else
         self.ptExtro = false;
         self.ptExtroAnim = nil;
      end
   end

   if self.dsExtroAnim then
      if self.dsExtroAnim:isBusy() then
      else
         self.dsExtro = false;
         self.dsExtroAnim = nil;
      end
   end

   if not self.hsExtro and not self.ptExtro and not self.dsExtro then
      self.ready = true;
      self.hsSoundDelay = 0;
      self.ptSoundDelay = 0;
      self.dsSoundDelay = 0;
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:onInput(  )

   Base.onInput( self );

   if  InputMgr:wasTouchPressed() and not self.introRunning then

      local x, y = self:wndToWorld (  InputMgr:getTouchLoc() );

      if y < -20 and not self.extroRunning then
         self:startExtro();
      end

   end

   if self.extroRunning and App.game then
      App.game:onInput();
   end

end


----------------------------------------------------------------

function StateConsumableOverlay:goBack()

   self.introHack = nil;
   self:resetButtons();
   self.selectedCost = 0;
   StateMgr:pop();

end

----------------------------------------------------------------

function StateConsumableOverlay:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

function StateConsumableOverlay:buttonCheck()

   if not self.introRunning and not self.extroRunning
      and not self.headStartBlueFlag
      and not self.powerTimeBlueFlag
      and not self.doubleScoreBlueFlag then

      local gems = App.data:getGemCount();
      self.selectedCost = self:getSelectedGemCost();
      local gemsAfterStart = gems - self.selectedCost;

      self.headStartBlueIntro:setVisible(false);
      self.headStartGreenIntro:setVisible(false);

      if gemsAfterStart >= self.headStartCost or (self.headStartFreebies and self.headStartFreebies > 0) then

         if self.headStartBlue:isEnabled() then
            self.headStartBlue:disable();
            self.headStartBlue:setVisible(false);
         end
         if not self.headStartEnabled then

            self.headStartButton:apply(0);
            self.headStartButton:setVisible(true);
            self.headStartButton:enable();

            self.headStartCostTxt:setVisible(true);
            self:headStartIconVis(true);

         end

      else

         if self.headStartEnabled then

            if self.headStartBlue:isEnabled() then
               self.headStartBlue:disable();
               self.headStartBlue:setVisible(false);
            end

         else

            self.headStartBlue:setVisible(true);
            self.headStartBlue:enable();

            self.headStartButton:setVisible(false);
            self.headStartButton:disable();

            self.headStartCostTxt:setVisible(true);
            self:headStartIconVis(true);

         end


      end

      self.powerTimeBlueIntro:setVisible(false);
      self.powerTimeGreenIntro:setVisible(false);

      if gemsAfterStart >= self.powerTimeCost or (self.powerTimeFreebies and self.powerTimeFreebies > 0) then

         if self.powerTimeBlue:isEnabled() then
            self.powerTimeBlue:disable();
            self.powerTimeBlue:setVisible(false);
         end

         if not self.powerTimeEnabled then

            self.powerTimeButton:apply(0);
            self.powerTimeButton:setVisible(true);
            self.powerTimeButton:enable();

            self.powerTimeCostTxt:setVisible(true);
            self:powerTimeIconVis(true);

         end

      else

         if self.powerTimeEnabled then

            if self.powerTimeBlue:isEnabled() then
               self.powerTimeBlue:disable();
               self.powerTimeBlue:setVisible(false);
            end

         else

            self.powerTimeBlue:setVisible(true);
            self.powerTimeBlue:enable();

            self.powerTimeButton:setVisible(false);
            self.powerTimeButton:disable();

            self.powerTimeCostTxt:setVisible(true);
            self:powerTimeIconVis(true);

         end
      end

      self.doubleScoreBlueIntro:setVisible(false);
      self.doubleScoreGreenIntro:setVisible(false);

      if gemsAfterStart >= self.doubleScoreCost or (self.doubleScoreFreebies and self.doubleScoreFreebies > 0) then

         if self.doubleScoreBlue:isEnabled() then
            self.doubleScoreBlue:disable();
            self.doubleScoreBlue:setVisible(false);
         end

         if not self.doubleScoreEnabled then

            self.doubleScoreButton:apply(0);
            self.doubleScoreButton:setVisible(true);
            self.doubleScoreButton:enable();

            self.doubleScoreCostTxt:setVisible(true);
            self:doubleScoreIconVis(true);

         end

      else

         if self.doubleScoreEnabled then

            if self.doubleScoreBlue:isEnabled() then
               self.doubleScoreBlue:disable();
               self.doubleScoreBlue:setVisible(false);
            end

         else

            self.doubleScoreBlue:setVisible(true);
            self.doubleScoreBlue:enable();

            self.doubleScoreButton:setVisible(false);
            self.doubleScoreButton:disable();

            self.doubleScoreCostTxt:setVisible(true);
            self:doubleScoreIconVis(true);

         end
      end

      local displayGems = math.max(0, gemsAfterStart);
      self:_updateGemCount( displayGems );

   end

end

----------------------------------------------------------------

function StateConsumableOverlay:readyCheck()

   if App.game and App.game.avatar then

      if self.doubleScoreEnabled then

         if self.doubleScoreFreebies and self.doubleScoreFreebies > 0 then

            self.doubleScoreFreebies = nil;
            App.data:spendFreebie("double-score", 1, "double-score freebie consumed");
         else

            local cost = ConsumableMgr:getCost(CONSUMABLE_DOUBLESCORE_INDEX);

            if cost and cost.gem then
               self.doubleScoreEnabled = false;
               ConsumableMgr:buy(CONSUMABLE_DOUBLESCORE_INDEX, true);
            end
         end
      end

      if self.powerTimeEnabled then

         if self.powerTimeFreebies and self.powerTimeFreebies > 0 then

            self.powerTimeFreebies = nil;
            App.data:spendFreebie("power-time", 1, "power-time freebie consumed");
         else

            local cost = ConsumableMgr:getCost(CONSUMABLE_POWERTIME_INDEX);

            if cost and cost.gem then
               self.powerTimeEnabled = false;
               ConsumableMgr:buy(CONSUMABLE_POWERTIME_INDEX, true);
            end
         end
      end

      --Made it last in case the powerTime is enable... we want to get the extra time
      if self.headStartEnabled then

         if self.headStartFreebies and self.headStartFreebies > 0 then

            self.headStartFreebies = nil;
            App.data:spendFreebie("head-start", 1, "head-start freebie consumed");
         else

            local cost = ConsumableMgr:getCost(CONSUMABLE_HEADSTART_INDEX);

            if cost and cost.gem then
               self.headStartEnabled = false;
               ConsumableMgr:buy(CONSUMABLE_HEADSTART_INDEX, true);
            end
         end
      end

   else
   	Debug.assert( App.game and App.game.avatar, "StateConsumableOverlay:readyCheck -> App.game and App.game.avatar");
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:headStartIconVis( v )

   if self.headStartFreebies > 0 then

      self.headStartButton:swapAnim("ConBoost_Check_Free");
      self.headStartCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.headStartCostTxt:setLoc(FREE_TEXT[1].x, FREE_TEXT[1].y);

      self.hsAlert:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.hsAlert:setLoc(FREE_TEXT[1].x, FREE_TEXT[1].y);
      self.hsAlert:setVisible( true);
      self.hsAlert:start();

      self.hsAlertSparkle:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.hsAlertSparkle:setLoc(FREE_TEXT[1].x, FREE_TEXT[1].y);
      self.hsAlertSparkle:setVisible( true);
      self.hsAlertSparkle:start();

   else

      self.hsAlert:setVisible(false);
      self.hsAlert:stop();
      self.hsAlertSparkle:setVisible(false);
      self.hsAlertSparkle:stop();

      --swap back
      self.headStartGemIcon:setVisible(v);



      local swapped = self.headStartButton:swapAnim("ConBoost_Check");

      if swapped == false then
         self.headStartButton:apply(0);
      end

      self.headStartCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.headStartCostTxt:setLoc(GEM_TEXT[1].x, GEM_TEXT[1].y);

      self.headStartGemIcon.anim:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.headStartButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );

      if self.headStartCost > 9 then
         self.headStartGemIcon:setLoc( GEM_ICON[1].x - GEM_ICON_OFFSET_10, GEM_ICON[1].y );
      else
         self.headStartGemIcon:setLoc( GEM_ICON[1].x - GEM_ICON_OFFSET_1, GEM_ICON[1].y );
      end
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:doubleScoreIconVis( v )

   if self.doubleScoreFreebies > 0 then

      self.doubleScoreButton:swapAnim("Con2x_Check_Free");
      self.doubleScoreCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.doubleScoreCostTxt:setLoc(FREE_TEXT[3].x, FREE_TEXT[3].y);

      self.dsAlert:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.dsAlert:setLoc(FREE_TEXT[3].x, FREE_TEXT[3].y);
      self.dsAlert:setVisible( true);
      self.dsAlert:start();

      self.dsAlertSparkle:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.dsAlertSparkle:setLoc(FREE_TEXT[3].x, FREE_TEXT[3].y);
      self.dsAlertSparkle:setVisible( true);
      self.dsAlertSparkle:start();

   else

      self.dsAlert:setVisible(false);
      self.dsAlert:stop()
      self.dsAlertSparkle:setVisible(false);
      self.dsAlertSparkle:stop()

      --swap back
      self.doubleScoreGemIcon:setVisible(v);

      local swapped = self.doubleScoreButton:swapAnim("Con2x_Check");

      if swapped == false then
         self.doubleScoreButton:apply(0);
      end


      self.doubleScoreCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.doubleScoreCostTxt:setLoc(GEM_TEXT[3].x, GEM_TEXT[3].y);

      self.doubleScoreGemIcon.anim:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.doubleScoreButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      if self.doubleScoreCost > 9 then
         self.doubleScoreGemIcon:setLoc( GEM_ICON[3].x - GEM_ICON_OFFSET_10, GEM_ICON[3].y );
      else
         self.doubleScoreGemIcon:setLoc( GEM_ICON[3].x - GEM_ICON_OFFSET_1, GEM_ICON[3].y );
      end
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:powerTimeIconVis( v )

   if self.powerTimeFreebies > 0 then

      self.powerTimeButton:swapAnim("ConTime_Check_Free");
      self.powerTimeCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.powerTimeCostTxt:setLoc(FREE_TEXT[2].x, FREE_TEXT[2].y)

      self.ptAlert:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.ptAlert:setLoc(FREE_TEXT[2].x, FREE_TEXT[2].y);
      self.ptAlert:setVisible( true);
      self.ptAlert:start();

      self.ptAlertSparkle:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.ptAlertSparkle:setLoc(FREE_TEXT[2].x, FREE_TEXT[2].y);
      self.ptAlertSparkle:setVisible( true);
      self.ptAlertSparkle:start();

   else

      self.ptAlert:setVisible(false);
      self.ptAlert:stop();
      self.ptAlertSparkle:setVisible(false);
      self.ptAlertSparkle:stop();

      --swap back
      self.powerTimeGemIcon:setVisible(v);

      local swapped = self.powerTimeButton:swapAnim("ConTime_Check");

      if swapped == false then
         self.powerTimeButton:apply(0);
      end

      self.powerTimeCostTxt.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.powerTimeCostTxt:setLoc(GEM_TEXT[2].x, GEM_TEXT[2].y);

      self.powerTimeGemIcon.anim:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.powerTimeButton.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      if self.powerTimeCost > 9 then
         self.powerTimeGemIcon:setLoc( GEM_ICON[2].x - GEM_ICON_OFFSET_10, GEM_ICON[2].y );
      else
         self.powerTimeGemIcon:setLoc( GEM_ICON[2].x - GEM_ICON_OFFSET_1, GEM_ICON[2].y );
      end
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:headStartPressed()

   if not self.headStartEnabled then
      self.headStartCostTxt:setVisible(false);
      self:headStartIconVis( false );
      self.hsAlert:setVisible(false);
      self.hsAlert:stop();
      self.hsAlertSparkle:setVisible(false);
      self.hsAlertSparkle:stop();
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:headStartTap()

   if self.headStartEnabled then

      self.headStartButton:apply(0);
      self.headStartEnabled = false;
      self:buttonCheck();
      print("Head start off");

      self.headStartCostTxt:setVisible(true);
      self:headStartIconVis( true );

      self:hideFlyover( self.headStartText );

   else

      self.headStartEnabled = true;
      self:buttonCheck();
      print("head start on");

      self:setFlyover( self.headStartText, self.headStartTextShadow );

   end

end

----------------------------------------------------------------

function StateConsumableOverlay:headStartCancel()


   if not self.headStartEnabled then
      self.headStartCostTxt:setVisible(true);
      self:headStartIconVis( true );

      self:hideFlyover( self.headStartText );
   else

      self.headStartButton:setAnimLastFrame();

   end

end

----------------------------------------------------------------

function StateConsumableOverlay:doubleScorePressed()

   if not self.doubleScoreEnabled then
      self.doubleScoreCostTxt:setVisible(false);
      self:doubleScoreIconVis(false);
      self.dsAlert:setVisible(false);
      self.dsAlert:stop();
      self.dsAlertSparkle:setVisible(false);
      self.dsAlertSparkle:stop();
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:doubleScoreTap()

   if self.doubleScoreEnabled then

      self.doubleScoreButton:apply(0);
      self.doubleScoreEnabled = false;
      self:buttonCheck();
      print("double score off");

      self.doubleScoreCostTxt:setVisible(true);
      self:doubleScoreIconVis(true);

      self:hideFlyover( self.doubleScoreText );

   else

      self.doubleScoreEnabled = true;
      self:buttonCheck();
      print("double score on");

      self:setFlyover( self.doubleScoreText, self.doubleScoreTextShadow );

   end


end

----------------------------------------------------------------

function StateConsumableOverlay:doubleScoreCancel()

   if not self.doubleScoreEnabled then

      self.doubleScoreCostTxt:setVisible(true);
      self:doubleScoreIconVis(true);

      self:hideFlyover( self.doubleScoreText );

   else

      self.doubleScoreButton:setAnimLastFrame();

   end

end

----------------------------------------------------------------

function StateConsumableOverlay:powerTimePressed()

   if not self.powerTimeEnabled then
      self.powerTimeCostTxt:setVisible(false);
      self:powerTimeIconVis(false);
      self.ptAlert:setVisible(false);
      self.ptAlert:stop();
      self.ptAlertSparkle:setVisible(false);
      self.ptAlertSparkle:stop();
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:powerTimeTap()

   if self.powerTimeEnabled then

      self.powerTimeButton:apply(0);
      self.powerTimeEnabled = false;
      self:buttonCheck();
      print("power time off");

      self.powerTimeCostTxt:setVisible(true);
      self:powerTimeIconVis(true);

      self:hideFlyover( self.powerTimeText );

   else

      self.powerTimeEnabled = true;
      self:buttonCheck();
      print("power time on");

      self:setFlyover( self.powerTimeText, self.powerTimeTextShadow );

   end

end

----------------------------------------------------------------

function StateConsumableOverlay:powerTimeCancel()

   if not self.powerTimeEnabled then

      self.powerTimeCostTxt:setVisible(true);
      self:powerTimeIconVis(true);

      self:hideFlyover( self.powerTimeText );

   else

      self.powerTimeButton:setAnimLastFrame();

   end

end

----------------------------------------------------------------

function StateConsumableOverlay:headStartBlueTap()

   self.headStartBlueFlag = true;
   self.powerTimeBlueFlag = false;
   self.doubleScoreBlueFlag = false;

   self:needGems("head-start");

end

----------------------------------------------------------------

function StateConsumableOverlay:powerTimeBlueTap()

   self.headStartBlueFlag = false;
   self.powerTimeBlueFlag = true;
   self.doubleScoreBlueFlag = false;
   self:needGems("power-time");

end

----------------------------------------------------------------

function StateConsumableOverlay:doubleScoreBlueTap()

   self.headStartBlueFlag = false;
   self.powerTimeBlueFlag = false;
   self.doubleScoreBlueFlag = true;
   self:needGems("double-score");

end

----------------------------------------------------------------

function StateConsumableOverlay:randomBoosterUsed()
  if self.ShouldShowRandomBoosterButton then

    self.DidShowAd      = true;
    if AdMgr:isVideoAvailable() then
        StateMgr:push("state/state-video-play.lua", {rewardType="gold", rewardAmount=0} );
    else
       self.randomBoosterButton:setVisible(false);
       self.randomBoosterIcon:setVisible(false);
       self.randomBoosterText:setVisible(false);
       self.randomBoosterTextShadow:setVisible(false);
       self.randomBoosterButton:disable();
    end
  end
end

----------------------------------------------------------------

function StateConsumableOverlay:needGems( reason  )

   local gems = App.data:getGemCount() - self.selectedCost;


   AUTO_PURCHASE_DATA.currency	= 'Gem';
   AUTO_PURCHASE_DATA.price		= gems;
   AUTO_PURCHASE_DATA.reason1    = 'Consumable';
   AUTO_PURCHASE_DATA.reason2    = 'Consumable-'.. (reason or "unknown" );
   AUTO_PURCHASE_FUNC				=	function()
													self:backFromGems();
												end
   AUTO_PURCHASE_CLOSE_FUNC		=	function()
													self:autoBuyCanceled();
												end

	StateMgr:push("state/state-auto-purchase-popup-maz.lua");

end

----------------------------------------------------------------

function StateConsumableOverlay:backFromGems()

   if self.headStartBlueFlag then

      self.headStartEnabled = true;
      self.headStartButton:setVisible(true);
      self.headStartButton:enable();
      self.headStartButton:apply(0);
      self.headStartButton:start();

      self.headStartCostTxt:setVisible(false);
      self:headStartIconVis( false );

      self.headStartBlueFlag = false;

   end

   if self.powerTimeBlueFlag then

      self.powerTimeEnabled = true;
      self.powerTimeButton:setVisible(true);
      self.powerTimeButton:enable();
      self.powerTimeButton:apply(0);
      self.powerTimeButton:start();


      self.powerTimeCostTxt:setVisible(false);
      self:powerTimeIconVis(false);

      self.powerTimeBlueFlag = false;

   end

   if self.doubleScoreBlueFlag then

      self.doubleScoreEnabled = true;
      self.doubleScoreButton:setVisible(true);
      self.doubleScoreButton:enable();
      self.doubleScoreButton:apply(0);
      self.doubleScoreButton:start();

      self.doubleScoreCostTxt:setVisible(false);
      self:doubleScoreIconVis(false);

      self.doubleScoreBlueFlag = false;
   end

   self:buttonCheck();

end

----------------------------------------------------------------

function StateConsumableOverlay:autoBuyCanceled()

   print("auto buy canceled");

   self.headStartBlueFlag = false;
   self.powerTimeBlueFlag = false;
   self.doubleScoreBlueFlag = false;

end

----------------------------------------------------------------

function StateConsumableOverlay:getSelectedGemCost()

   local total = 0

   if (self.headStartEnabled) and (( self.headStartFreebies or 0 ) == 0) then
      total = total + self.headStartCost;
   end
   if (self.powerTimeEnabled) and (( self.powerTimeFreebies or 0 ) == 0)  then
      total = total + self.powerTimeCost;
   end
   if (self.doubleScoreEnabled) and (( self.doubleScoreFreebies or 0 ) == 0)   then
      total = total + self.doubleScoreCost;
   end

   return total;

end


----------------------------------------------------------------

function StateConsumableOverlay:_updateGemCount( gem )

   if (not self.resourceBar) or (not self.resourceBar.GemCounter) then
      return;
   end

   if gem > 99999 then
      gem = 99999;
      self.resourceBar.GemCounter:setGlyphScale(0.80);
   elseif gem >= 10000 then
      self.resourceBar.GemCounter:setGlyphScale(0.80);
   else
      self.resourceBar.GemCounter:setGlyphScale(1.00);
   end

   self.resourceBar.GemCounter:setText("<c:d4e7f9>" .. getFormattedNumber(gem) .. "</>");
end

----------------------------------------------------------------

function StateConsumableOverlay:resetButtons()

   --headstart

   self.headStartGreenIntro:setVisible(false);

   self.headStartButton:setVisible(false);
   self.headStartButton:disable();

   self.headStartGreenExtro:setVisible(false);

   self.headStartCheckExtro:setVisible(false);

   self.headStartBlueIntro:setVisible(false);

   self.headStartBlue:setVisible(false);
   self.headStartBlue:disable();

   self.headStartBlueExtro:setVisible(false);

   self.headStartCostTxt:setVisible(false);
   self.headStartGemIcon:setVisible(false);

   self.hsAlert:setVisible(false);
   self.hsAlert:stop();
   self.hsAlertSparkle:setVisible(false);
   self.hsAlertSparkle:stop();

   self.headStartBlueFlag = false;

   --power time

   self.powerTimeGreenIntro:setVisible(false);

   self.powerTimeButton:setVisible(false);
   self.powerTimeButton:disable();

   self.powerTimeGreenExtro:setVisible(false);

   self.powerTimeCheckExtro:setVisible(false);

   self.powerTimeBlueIntro:setVisible(false);

   self.powerTimeBlue:setVisible(false);
   self.powerTimeBlue:disable();

   self.powerTimeBlueExtro:setVisible(false);

   self.powerTimeCostTxt:setVisible(false);
   self.powerTimeGemIcon:setVisible(false);

   self.ptAlert:setVisible(false);
   self.ptAlert:stop();
   self.ptAlertSparkle:setVisible(false);
   self.ptAlertSparkle:stop();

   self.powerTimeBlueFlag = false;

   --double score

   self.doubleScoreGreenIntro:setVisible(false);

   self.doubleScoreButton:setVisible(false);
   self.doubleScoreButton:disable();

   self.doubleScoreGreenExtro:setVisible(false);

   self.doubleScoreCheckExtro:setVisible(false);

   self.doubleScoreBlueIntro:setVisible(false);

   self.doubleScoreBlue:setVisible(false);
   self.doubleScoreBlue:disable();

   self.doubleScoreBlueExtro:setVisible(false);

   self.doubleScoreCostTxt:setVisible(false);
   self.doubleScoreGemIcon:setVisible(false);

   self.dsAlert:setVisible(false);
   self.dsAlert:stop();
   self.dsAlertSparkle:setVisible(false);
   self.dsAlertSparkle:stop();

   self.doubleScoreBlueFlag = false;

end

----------------------------------------------------------------

function StateConsumableOverlay:startFade( )

   --joe: this is unused.  but if you ever decide to bring it back, make sure to add the "free" icons to the list


   self.fadeTable =  {
                        {obj=self.headStartBlue,      fade=0.2, totalTime=0.2},

                        {obj=self.powerTimeBlue,      fade=0.2, totalTime=0.2},

                        {obj=self.doubleScoreBlue,    fade=0.2, totalTime=0.2},

                        --{obj=self.background,         fade=0.2, totalTime=0.2},

                     };

   if self.headStartEnabled then
      table.insert(self.fadeTable, {obj=self.headStartButton,   fade=1, totalTime=1} );
      table.insert(self.fadeTable, {obj=self.headStartCostTxt,  fade=1, totalTime=1} );
      table.insert(self.fadeTable, {obj=self.headStartGemIcon,     fade=1, totalTime=1} );
   else
      table.insert(self.fadeTable, {obj=self.headStartButton,   fade=0.2, totalTime=0.2} );
      table.insert(self.fadeTable, {obj=self.headStartCostTxt,  fade=0.2, totalTime=0.2} );
      table.insert(self.fadeTable, {obj=self.headStartGemIcon,     fade=0.2, totalTime=0.2} );
   end

   if self.powerTimeEnabled then
      table.insert(self.fadeTable, {obj=self.powerTimeButton,   fade=1, totalTime=1} );
      table.insert(self.fadeTable, {obj=self.powerTimeCostTxt,  fade=1, totalTime=1} );
      table.insert(self.fadeTable, {obj=self.powerTimeGemIcon,     fade=1, totalTime=1} );
   else
      table.insert(self.fadeTable, {obj=self.powerTimeButton,   fade=0.2, totalTime=0.2} );
      table.insert(self.fadeTable, {obj=self.powerTimeCostTxt,  fade=0.2, totalTime=0.2} );
      table.insert(self.fadeTable, {obj=self.powerTimeGemIcon,     fade=0.2, totalTime=0.2} );
   end

   if self.doubleScoreEnabled then
      table.insert(self.fadeTable, {obj=self.doubleScoreButton,   fade=1, totalTime=1} );
      table.insert(self.fadeTable, {obj=self.doubleScoreCostTxt,  fade=1, totalTime=1} );
      table.insert(self.fadeTable, {obj=self.doubleScoreGemIcon,     fade=1, totalTime=1} );
   else
      table.insert(self.fadeTable, {obj=self.doubleScoreButton,   fade=0.2, totalTime=0.2} );
      table.insert(self.fadeTable, {obj=self.doubleScoreCostTxt,  fade=0.2, totalTime=0.2} );
      table.insert(self.fadeTable, {obj=self.doubleScoreGemIcon,     fade=0.2, totalTime=0.2} );
   end


end

----------------------------------------------------------------

function StateConsumableOverlay:updateFade( dt )

   if self.fadeTable and #self.fadeTable > 0 then

      for i,v in ipairs(self.fadeTable) do
         v.fade = v.fade - dt;
         if v.fade <= 0 then
            v.obj:setColor(1,1,1,1);
            v.obj:setVisible(false);
            table.remove(self.fadeTable, i);
            if #self.fadeTable <= 0 then
               self.fadeTable = nil;
               self.ready = true;
            end
         else
            if v.obj:isVisible() then
               local percent = v.fade/v.totalTime;
               local frame = 1;
               if v.frame then
                  frame = v.frame;
               end

               v.obj:setColor(1,1,1,percent,frame);
            end
         end
      end
   end

end

----------------------------------------------------------------

function StateConsumableOverlay:setParent( child, parent, layer )

	if child and parent then
		if parent.anim then
         if layer then
            child:setParent(parent.anim.props[layer])
         else
            child:setParent(parent.anim.root);
         end
		elseif parent.prop then
			child:setParent(parent.prop);
		elseif parent.moaiTextBox then
			child:setParent(parent.moaiTextBox);
		elseif parent.root then
			child:setParent(parent.root);
		end
	end

end

----------------------------------------------------------------------

function StateConsumableOverlay:onDataServerError()

   print("StateConsumableOverlay:onDataServerError()");

   if not StateMgr._showErrorDialog then

      --Give back the key

      Base.onDataServerError(self);

      App.data:addKey(1, "Data Server Error");

   end

end

----------------------------------------------------------------

return StateConsumableOverlay;
