----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local TITLESTART_X			= 0 			
local TITLESTART_Y			= -4800;
local SCROLL_TIME				= 25;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;

local URL_CHECK_APPLE      = "https://roadriot-cdn.tango.me/apple-review/special-promo-hack-01.png";

----------------------------------------------------------------

local Base						= State;
local StateCredits			= Base:new();
local localApp					= nil;
local localSelf				= nil;

----------------------------------------------------------------

local Titles =
{
    "Currently Developed\nby\nJune Gaming\nand\nTitan Mobile",
	"Developed\nby\nTango Austin",
	"Special Thanks",
	"Sounds\nand\nMusic",
};

local Names =
{
    {
        "Dyuman Bhatt",
        "Eric Rahman",
        "Adam Hoffield",
        "Roby John",
        "Prathamesh Bhide",
        "Kaveri Fuge",
        "Shantesh Patil",
        "Ankush Madad",
        "Sreejit J",
    },
	{
		"Michel Mailhot",
		"Michael S. Maza",
		"Joe Graves",
		"Michael Q. Lin",
		"Katie Azbill",
		"Herb Ellwood",
		"Caitlin Marie",
		"Philip Wanardi",
		"Nick Caplinger",
      "Alan Defibaugh",
      "Edgar Arellano",
      "Kay Gilmore",
      "Mark Tait",
	},
	{

		"Anthony Yol",
		"Avi Goshen",
		"Dave DePaulis",
		"Elena Migunova",
		"Eric Setton",
		"Erik Krogh-Jespersen",
		"Jim Ying",
		"Oded Pelled",
		"Richard Rabbat",
		"Todd Arnold",
		"Shu Chen",
		"Uri Raz",
		"Tango.me",
	},
	{
		"GL33k",
	},
};

----------------------------------------------------------------

function StateCredits:onLoad()

	State.onLoad( self );

   self.defaultFontName = "resources/font/TangoLatin.otf";

	local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
	
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "C_Background", textureSheet);
	
	self.FrameOverlay = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "C_CreditsScrollFrame", textureSheet);
	self.FrameOverlay:setPriority(PRIORTY_5);

	self.Title = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "C_TitleCredits", textureSheet, nil, nil, true);
	self.Title:setPriority(PRIORTY_6);
--	self.Logo = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "C_tangologo", textureSheet, nil, nil, true);
--	self.Logo:setPriority(PRIORTY_6);

	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "C_ReadyButton", textureSheet, nil, self.goBack, nil, nil);
	self.BackButton:setPriority(PRIORTY_6);
	
	self.Movie = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "C_Chase", textureSheet);
	self.Movie:setPriority(PRIORTY_7);
	self.Movie:setMode(MOAITimer.LOOP);
	
	local titleTxt = self:createTitleText();

	self.CreditText = self:addWidget(TextBox, self.mainLayer, TITLESTART_X, (TITLESTART_Y/2)-100, 640, math.abs(TITLESTART_Y), titleTxt, self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
	self.CreditText:setPriority(PRIORTY_3);

	self.moaiLogo = self:addWidget(Anim, self.mainLayer, 0, (-TITLESTART_Y/2)+320, 0,0, "C_MoaiLogo", textureSheet, nil, nil, true);
	self.moaiLogo:setScale(1, -1);
	self.moaiLogo:setParent(self.CreditText.moaiTextBox);

   self:_setupBasicResourceBar();

end


----------------------------------------------------------------

function StateCredits:onActivate()

   State.onActivate( self );

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

   --Only reset if we were done
--   if (self._hackAppleIAP or 0) >= 3 then
--      self._hackAppleIAP = nil;
--   end

end

----------------------------------------------------------------

function StateCredits:onFocus()

   State.onFocus( self );
	
	localSelf = self;

	self.Movie:stop();
	self.Movie:setTime(0);
	self.Movie:start();
	
	self.CreditText:setLoc(TITLESTART_X, (TITLESTART_Y/2)-100);
	
	self.thread = MOAICoroutine.new();
	self.thread:run(creditScroll);

end

----------------------------------------------------------------

function StateCredits:onLoseFocus()

   Base.onLoseFocus(self);

--   self:deleteAllWidgets();

	self.Movie:stop();

	if self.action then
		self.action:stop();
		self.action = nil;
	end

   self.thread:stop();
   self.thread = nil;

end

----------------------------------------------------------------

function StateCredits:createTitleText()

	local text = '';

	for i=1,#Titles do

			text = text..'\n\n\n\n'..Titles[i]..'\n';

		for j=1,#Names[i] do

			text = text..'\n'..Names[i][j];

--			for k=1,#Names[i][j] do
--				text = text..'\n'..Names[i][j][k];
--			end
		end
	end

	return text;

end

----------------------------------------------------------------

function creditScroll()

	while localSelf.CreditText do

		localSelf.action = localSelf.CreditText:moveLoc(0, math.abs(TITLESTART_Y)+960, SCROLL_TIME, MOAIEaseType.LINEAR);

		MOAICoroutine.blockOnAction(localSelf.action);

		if localSelf.CreditText then
			localSelf.CreditText:setLoc(TITLESTART_X, (TITLESTART_Y/2)-100);
		end
	end

end

----------------------------------------------------------------

function StateCredits:goBack()

	print("Go Back");

	StateMgr:pop();

end

----------------------------------------------------------------

return StateCredits;

----------------------------------------------------------------
