----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SHOP_TRAY_HOME_X		= 0;
local SHOP_TRAY_HOME_Y		= 0;
local SHOP_TRAY_SHIFT		= 300;
local COIN_COUNT_X			= -143;
local COIN_COUNT_Y			= 437;
local GEM_COUNT_X				= 163;
local GEM_COUNT_Y				= 437;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;

local DAILY_TIME_X         = 103;
local DAILY_TIME_Y         = 50.925;

local STAR_X					= 0;
local STAR_Y					= 242.65;
local STAR_SPACING			= 109;
local STAR_W					= 84;
local STAR_H					= 84;

local screenWidth          = App.viewportWidth;
local screenHeight         = App.viewportHeight;

----------------------------------------------------------------

local Base						= State;
local StateDaily				= Base:new();
local localApp					= nil;
local localSelf				= nil;

local white = {1,1,1,1};
local blue	= {0.133, 0.29, 0.408, 1};
local blue2	= {0.537, 0.871, 0.996, 1};

----------------------------------------------------------------

local screenText ={};

local dayText = {};

local dayGoldText ={};

local textTbl = {};

----------------------------------------------------------------

function StateDaily:onLoad()

   State.onLoad( self );
	localSelf      = self;

   self.fontName = "resources/font/TangoLatin.otf";

	self:createProps();

end

----------------------------------------------------------------

function StateDaily:onActivate()

	State.onActivate( self );

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

	self:updateProps();

end

----------------------------------------------------------------

function StateDaily:createProps()

	self.textureSheet          = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);

	dayGoldText =
	{
		{text="100",  x= -227.425, y=-190.75,  w=screenWidth,   h=144, font=self.fontName, fontSize=18.2, priority=PRIORTY_5, color=blue},
		{text="200",  x= -77.9,		y=-190.75,  w=screenWidth,   h=144, font=self.fontName, fontSize=18.2, priority=PRIORTY_5, color=blue},
		{text="300",  x= 74.475,   y=-190.75,  w=screenWidth,   h=144, font=self.fontName, fontSize=18.2, priority=PRIORTY_5, color=blue},
		{text="400",  x= 226.875,  y=-190.75,  w=screenWidth,   h=144, font=self.fontName, fontSize=18.2, priority=PRIORTY_5, color=blue},
		{text="",  x= 221.975,  y=-323.45,  w=screenWidth,   h=144, font=self.fontName, fontSize=18.2, priority=PRIORTY_5, color=blue},
	};
	dayText =
	{
		{text="Day 1",  x= -224.425, y=-60.025,  w=screenWidth,   h=144, font=self.fontName, fontSize=13.8, priority=PRIORTY_5, color=blue2},
		{text="Day 2",  x= -74.95,  y=-60.025,  w=screenWidth,   h=144, font=self.fontName, fontSize=13.8, priority=PRIORTY_5, color=blue2},
		{text="Day 3",  x= 73.275,    y=-60.025,  w=screenWidth,   h=144, font=self.fontName, fontSize=13.8, priority=PRIORTY_5, color=blue2},
		{text="Day 4",  x=226.025, y=-60.025,  w=screenWidth,   h=144, font=self.fontName, fontSize=13.8, priority=PRIORTY_5,	color=blue2},
		{text="Day 5+", x=-241.05, y=-249.875,  w=screenWidth,   h=144, font=self.fontName, fontSize=13.8, priority=PRIORTY_5, color=blue},
	};

	screenText =
	{
		{text="Collect",				x=-154,			y=310.55,	w=screenWidth,	h=144,	font=self.fontName, fontSize=17.3, priority=PRIORTY_5, color=white},
		--[[no reward/gold text
		{text="REWARD",				x=-59,		y=86.875,    w=screenWidth,	h=144,	font=self.fontName, fontSize=29.4, priority=PRIORTY_5,
		color=blue},
		{text="goldnum",				x=144,		y=53.025,   w=screenWidth,	h=144,	font=self.fontName, fontSize=23.4, priority=PRIORTY_5,
		color=white},--]]
	};

	textTbl = {screenText, dayText, dayGoldText};

   --create screen text
   self.textBoxes = {{},{},{}}

   for i=1,#textTbl do
      for j=1,#textTbl[i] do

			-- print("setting up text box",i,j);

			self.textBoxes[i][j] = self:addWidget(TextBox, self.mainLayer,
                                 textTbl[i][j].x, textTbl[i][j].y,
                                 textTbl[i][j].w, textTbl[i][j].h,
                                 textTbl[i][j].text, textTbl[i][j].font, textTbl[i][j].fontSize, nil,
                                 MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY,
											textTbl[i][j].color);
         self.textBoxes[i][j]:setPriority(textTbl[i][j].priority);
      end
   end

   self.dailyTimeText = self:addWidget(TextBox, self.mainLayer, DAILY_TIME_X, DAILY_TIME_Y, screenWidth-60, 144, "--:--:--", self.fontName, 21.6, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.dailyTimeText.moaiTextBox:setPriority(PRIORTY_5);

   self.dailyGemText = self:addWidget(TextBox, self.mainLayer, 195, -310, 80, 144, "x 2", self.fontName, 23.4, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.dailyGemText.moaiTextBox:setPriority(PRIORTY_5);
	self.dailyGemText:setColor(0.133, 0.29, 0.408, 1);

	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.75});

	self.background = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_DailyBackGround", self.textureSheet);
	self.background:setPriority(PRIORTY_0);

   self.title       = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "D_DailyTitle", self.textureSheet, nil, nil, true);

   self.title:setPriority(PRIORTY_8);

   self:_setupBasicResourceBar();

	self.bluebox = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_BlueBox", self.textureSheet);
	self.bluebox:setPriority(PRIORTY_0);

	self.reward = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_Reward", self.textureSheet, nil, nil, true);
	self.reward:setPriority(PRIORTY_0);
	self.reward:hide();

	self.reward2 = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_Reward2", self.textureSheet, nil, nil, true);
	self.reward2:setPriority(PRIORTY_0);
	self.reward2:hide();

	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "D_ReadyButton", self.textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
	self.BackButton:setPriority(PRIORTY_5);


   self.starOnAnims = {};
   self.starOffAnims = {};

	--daily stars
	for i=1,5 do
		self.starOnAnims[i] = self:addWidget(Anim, self.mainLayer, 0, 0, STAR_W, STAR_H,
		"P_StarOn", self.textureSheet, nil, nil, true);
		self.starOnAnims[i]:setPriority(PRIORTY_3);
		self.starOnAnims[i]:setVisible(false);
		self.starOffAnims[i] = self:addWidget(Anim, self.mainLayer, 0, 0, STAR_W, STAR_H,
		"P_StarOff", self.textureSheet, nil, nil, true);
		self.starOffAnims[i]:setPriority(PRIORTY_3);
		self.starOffAnims[i]:setVisible(false);
	end

	--days

	self.dayAnims = {};
	self.dayDoneAnims = {};
	self.dayActiveAnims = {};
	for i=1,5 do

		self.dayDoneAnims[i] = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_Day"..i.."Done", self.textureSheet);
		self.dayDoneAnims[i]:setPriority(PRIORTY_3);

		self.dayActiveAnims[i] = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_Day"..i.."Active", self.textureSheet);
		self.dayActiveAnims[i]:setPriority(PRIORTY_3);

		self.dayAnims[i] = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "D_Day"..i, self.textureSheet);
		self.dayAnims[i]:setPriority(PRIORTY_3);
	end

   -- tap screen Button
   self._guideScrnButton	= self:addWidget(ButtonImage, self.mainLayer, 0,0, 1400, 1200, "resources/square.png", nil, nil, nil, nil);
   self._guideScrnButton:setPriority(0);
   self._guideScrnButton:setColor(1,1,1,0);

end

----------------------------------------------------------------

function StateDaily:updateProps()

   self.delay = 0;

	self.active = App.data:isDailyActive();
	local seen = App.data:getValue( "hasSeenDaily" );

	self.goal = App.data:getDailyChallengeGoal();
	self.progress = App.data:getDailyChallengeProgress();
	self.streak = App.data:getDailyChallengeStreak();
	self.day = math.min(self.streak+1, 5);


   if not self.active then
      if not seen then
         App.data:setValue( "hasSeenDaily", true )
      end
   end

   --print("prog, streak, day, active, goal", self.progress, self.streak, self.day, self.active, self.goal);

   --set up reward and progress text

	for i=1,4 do
		local rewardTpl = App.data:getDailyChallengeReward(i);
		local rewardGold = rewardTpl.gold;
		local s = tostring(rewardGold);
		self.textBoxes[3][i]:setText(s);
		local c=dayGoldText[i].color;
		self.textBoxes[3][i]:setColor(c[1],c[2],c[3],c[4]);
	end

	local rewardTpl = App.data:getDailyChallengeReward(5);
	local rewardGem = rewardTpl.gem;
	local s = tostring(rewardGem);
	self.dailyGemText:setText("x "..s);

   if self.active then
      if self.day > 1 then
         self.textBoxes[1][1]:setText("Collect ".. self.goal.. " Stars");
      else
         self.textBoxes[1][1]:setText("Collect 1 Star");
      end

   else
		self.textBoxes[1][1]:setText("Day "..(self.streak).." Complete!");
		--failsafe for text
		if self.streak < 1 then
			self.textBoxes[1][1]:setText("");
		end
		self.dailyTimeText:setLoc(DAILY_TIME_X-25, DAILY_TIME_Y);

   end


	--daily stars setup

	self:starReset();

	if self.active then
		for i=1,self.goal do
			if i <= self.progress or i == -1 or not self.active then
				--place gold star
				self:starCalc(i, self.goal, "On");

			else
				--place grey star
				self:starCalc(i, self.goal, "Off");
			end
		end
	else
		if self.streak >= 5 then
			for i=1,5 do
				--place gold star
				self:starCalc(i, 5, "On");
			end

		else
			for i=1,self.day-1 do
				--place gold star
				self:starCalc(i, self.day-1, "On");
			end
		end
	end

	self:dayReset();

   for i=1,5 do
      if i < self.day then
         --create day Done
			self.dayDoneAnims[i]:setVisible(true);
      elseif i == self.day then
         if self.active then
            --create day active
            self.dayActiveAnims[i]:setVisible(true);
            --change day text
            self.textBoxes[2][i]:setText("TODAY");
				self.textBoxes[2][i]:setColor(1,1,1,1);
				self.textBoxes[2][i]:setMetaFont(self.fontName, 14.7);
				self.textBoxes[3][i]:setColor(1,1,1,1);

         else
            --create regular day
            self.dayAnims[i]:setVisible(true);
         end
      else
         --create regular day
         self.dayAnims[i]:setVisible(true);
      end
   end

	if self.streak >= 4 then
		self.reward2:show();
	else
		self.reward:show();
	end

	self.dailyRewards = App.data:getDailyChallengeRewardToCollect();
	if self.dailyRewards then
		if App.data:collectDailyReward() then

         --Dont brag about daily for the first 2 days
         if not GuideMgr:isActive() and self.streak >= 2 then
            FeedMgr:shareScreenshot( "DailyComplete", 0.05 );
         end

         EventMgr:postEvent( {rewards=self.dailyRewards, streak=self.streak}, "daily-reward" );

      end
	end
	--Michel, add in backend failsafes


end

----------------------------------------------------------------

function  StateDaily:dayReset()

	for i=1,5 do

		self.dayAnims[i]:setVisible( false );

		self.dayActiveAnims[i]:setVisible( false );

		self.dayDoneAnims[i]:setVisible( false );

		self.textBoxes[2][i]:setText(dayText[i].text);
		local c=dayText[i].color
		self.textBoxes[2][i]:setColor(c[1],c[2],c[3],c[4]);
		self.textBoxes[2][i]:setMetaFont(dayText[i].font, dayText[i].fontSize);

	end

	self.reward:hide();
	self.reward2:hide();

end

----------------------------------------------------------------

function StateDaily:collectRewardFail()

	print("collect reward failed");

end
----------------------------------------------------------------

function StateDaily:onFocus()

   State.onFocus( self );

   self:disableGuideScrnButton();

end

----------------------------------------------------------------

function StateDaily:onLoseFocus()

   State.onLoseFocus(self);

end

----------------------------------------------------------------

function  StateDaily:starCalc( i, stars, append )

	local startX = ((STAR_SPACING/2) * -1) * (stars - 1);
	local xOffset = startX + ((i-1) * STAR_SPACING);

	if append == "On" then
		self.starOnAnims[i]:setLoc(xOffset + STAR_X, STAR_Y );
		self.starOnAnims[i]:setVisible(true);
	else
		self.starOffAnims[i]:setLoc(xOffset + STAR_X, STAR_Y );
		self.starOffAnims[i]:setVisible(true);
	end
end

----------------------------------------------------------------

function  StateDaily:starReset()

	for i=1,5 do
		self.starOnAnims[i]:setVisible( false );
		self.starOnAnims[i]:setLoc(0,0);
		self.starOffAnims[i]:setVisible( false );
		self.starOffAnims[i]:setLoc(0,0);
	end
end

----------------------------------------------------------------

function  StateDaily:onUpdate( dt )

   Base.onUpdate( self, dt );

   self:updateTimer(dt);
end

----------------------------------------------------------------

function StateDaily:updateTimer( dt )

	local time = '--:--:--';
	local countdown = App.data:getDailyChallengeTimer();
   local hours;
   local min;
	local sec;

   if self.delay > 0 then

      self.delay = self.delay - dt;

      if self.delay <= 0 then
         self.delay = 0;
         self:updateProps();
      end

   elseif countdown then

      sec = math.floor(countdown%60);

      if sec < 10 then
         sec = "0".. sec;
      end

      min = math.floor((countdown%3600)/60);

      if min < 10 then
         min = "0".. min;
      end

      hours = math.floor(countdown/3600);

      if hours < 10 then
         hours = "0".. hours;
      end

      time = hours.. ":".. min.. ":".. sec;
   end

	if self.active then
		self.dailyTimeText:setText("Time left  "..time);
	else
		local s = tostring(self.streak+1);
		self.dailyTimeText:setText("Day "..s.." starts  "..time);
	end

   if (not countdown) or countdown <= 0 then
      self.delay = 2;
   end

end

----------------------------------------------------------------

function StateDaily:disableGuideScrnButton()
   self._guideScrnButton:disable();
end

----------------------------------------------------------------

function StateDaily:goCoinStore()

	print("Go To Coin Store");

	StateMgr:push("state/state-coin.lua");

end

----------------------------------------------------------------

function StateDaily:goGemStore()

	print("Go To Gem Store");

	StateMgr:push("state/state-gem.lua");

end

----------------------------------------------------------------

function StateDaily:goBack()

	StateMgr:pop();

end

----------------------------------------------------------------

return StateDaily;

----------------------------------------------------------------
