
----------------------------------------------------------------
require('state/state')
require('ui/ui-button/ui-button-image')
require('ui/ui-image')
require('ui/ui-text-box')
require('ui/ui-anim')
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');

----------------------------------------------------------------

local Base              = State;
local StateDataCrash    = Base:new();

----------------------------------------------------------------

function  StateDataCrash:onLoad( )

   Base.onLoad( self );

   self.background      = self:addWidget( Image,
                                          self.mainLayer,
                                          0,
                                          0,
                                          640,
                                          1136,
                                          "resources/UI/Splash.png" );

   self.tangoBubble      = self:addWidget(   Image,
                                             self.mainLayer,
                                             200,
                                             290,
                                             70,
                                             61,
                                             "resources/UI/Splash_Tango.png" );


end

----------------------------------------------------------------

function  StateDataCrash:onActivate( )

   Base.onActivate( self );

end

----------------------------------------------------------------

function StateDataCrash:onFocus( )

   Base.onFocus( self );

   MOAIGfxDevice.setClearColor( 0, 0, 0 );

   self:disableAds();

   self._dialogShowingCount = 5;

   EventMgr:postEvent( {} , "Fraud.Data.Crash");


end

----------------------------------------------------------------

function StateDataCrash:onDataServerError()
   StateMgr:clearDataServerError();
end

----------------------------------------------------------------------

function StateDataCrash:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

function  StateDataCrash:onUpdate( dt )

   Base.onUpdate( self, dt );

   self._dialogShowingCount = self._dialogShowingCount - 1;

   if self._dialogShowingCount == 0 then


      MOAIDialogIOS.showDialog(  LocalizationMgr:getString( "NATIVE_FILE_ERROR_TITLE" )
                              ,  LocalizationMgr:getString( "NATIVE_LOAD_ERROR_TITLE" )
                              ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                              ,  nil
                              ,  nil
                              ,  false
                              ,  function()
                                 if BUILD_DEBUG then
                                    StateMgr:clear( "state/state-ranking.lua" );
                                 else
                                    MOAIRoadRiot:exit();
                                 end
                              end
                              );
   end

end

----------------------------------------------------------------

return StateDataCrash
