----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('state/resourceBar/resourceBar');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SHOP_TRAY_HOME_X		= 0;
local SHOP_TRAY_HOME_Y		= 0;
local SHOP_TRAY_SHIFT		= 300;
local COIN_COUNT_X			= -143;
local COIN_COUNT_Y			= 437;
local GEM_COUNT_X				= 163;
local GEM_COUNT_Y				= 437;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

local DECISION_TIMER       = 3;
local DECISION_TIMER_ANIM  = 3;

local CLOCK_X             =  240;
local CLOCK_Y             =  150;

local  BUY_X               =   0;
local  BUY_Y               = -15;

local BUY_GEM_X            = -40;
local BUY_TEXT_SHD_X       = 20+2;
local BUY_TEXT_X           = 20;

local  TITLE_X             =   0;
local  TITLE_Y             =  50;

local AdDisplayCount       = 2;

local showAdButton = true;

----------------------------------------------------------------

local Base						= State;
local StateDeathSave			= Base:new();

----------------------------------------------------------------

function StateDeathSave:onLoad()

   State.onLoad( self );
   self.uiLayer               = self:addLayer();

   local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);
   local textureSheet2          = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";

   self.IS_POPUP              = true;
   self.SHOW_VIDEO_REVIVE     = true;
   self.FREE_REVIVE_USED      = false;
   App.VideoReviveCount      = 0;

   self.buyButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, BUY_X,BUY_Y,0,0, "BuyButton", textureSheet, self.confirmPressed, self.goConfirm, nil, nil);
   self.buyButton:setPriority(PRIORTY_2);

   self.buyButtonGem = self:addWidget(Anim, self.mainLayer, BUY_GEM_X, BUY_Y,0,0, "GemA", textureSheet);
   self.buyButtonGem:setPriority(PRIORTY_3);


   self.buyButtonTextShd = self:addWidget(TextBox, self.mainLayer, BUY_TEXT_SHD_X, BUY_Y-2, 360, 220, "", self.defaultFontName, 26, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.buyButtonTextShd:setPriority(PRIORTY_3);
   self.buyButtonTextShd:setColor(0,0,0);

   self.buyButtonText = self:addWidget(TextBox, self.mainLayer, BUY_TEXT_X , BUY_Y, 360, 220, "", self.defaultFontName, 26, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.buyButtonText:setPriority(PRIORTY_4);

   if self.SHOW_VIDEO_REVIVE then
   self.videoReviveButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, BUY_X + 130,BUY_Y,0,0, "BuyButton", textureSheet, self.confirmPressed, self.videoReviveUsed, nil, nil);
   self.videoReviveButton:setPriority(PRIORTY_2);
   self.videoReviveButton:setVisible(false);
   self.videoReviveButton:disable();

   self.videoButtonIcon = self:addWidget(ButtonImage, self.mainLayer, BUY_X + 130,BUY_Y, 61, 61, "resources/videoIcon.png", nil, nil)
   self.videoButtonIcon:setPriority(PRIORTY_5);
   self.videoButtonIcon:setVisible(false);
   end

   self.FreebieAlert = self:addWidget(Anim, self.mainLayer, 90, 30,0,0, "NotificationIconMystery_Counter", textureSheet2);
   self.FreebieAlert:setPriority(PRIORTY_4);
   self.FreebieAlert:setScale(0.9,0.9);
   self.FreebieAlert:setSpan(1.0);
   self.FreebieAlert:setMode(MOAITimer.LOOP);
   self.FreebieAlert:setVisible(false);

   self.FreebieAlertSparkle = self:addWidget(Anim, self.mainLayer, 20, BUY_Y,0,0, "NotificationSparkle", textureSheet2);
   self.FreebieAlertSparkle:setPriority(PRIORTY_4-1);
   self.FreebieAlertSparkle:setScale(0.9,0.9);
   self.FreebieAlertSparkle:setSpan(29/30);
   self.FreebieAlertSparkle:setMode(MOAITimer.LOOP);
   self.FreebieAlertSparkle:setVisible(false);


   self.freebieText = self:addWidget(TextBox, self.mainLayer, 20, BUY_Y, 360, 220, "", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.freebieText:setPriority(PRIORTY_5);

   self.clockBkgd = self:addWidget(Anim, self.mainLayer,  CLOCK_X, CLOCK_Y,0,0, "ClockBackGround", textureSheet);
   self.clockBkgd:setPriority(PRIORTY_3);

   self.clock = self:addWidget(Anim, self.mainLayer, CLOCK_X, CLOCK_Y ,0,0, "Clock", textureSheet);
   self.clock:setPriority(PRIORTY_4);


   -- push/pop state buttons
   -- Lower the button to no interfere with the resource bar
   self.BackButton = self:addWidget(ButtonImage, self.mainLayer, 0,0,App.viewportWidth,App.viewportHeight, "resources/UI/blackbox.png", nil, self.goClose);
   self.BackButton.prop:setPriority(PRIORTY_0);
   self.BackButton:setColor(1,1,1,0.5);

   -- background and icon
   self.BackDrop = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ReviveBackGround", textureSheet, self.panelPressed, self.panelReleased, nil, nil );
   self.BackDrop:setPriority(PRIORTY_1);


   self.TitleTextBkgd = self:addWidget(TextBox, self.mainLayer, TITLE_X+2, TITLE_Y-2, 360, 220, "", self.defaultFontName, 30, "SAVE ME!", MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
   self.TitleTextBkgd:setPriority(PRIORTY_2);
   self.TitleTextBkgd:setColor(0,0,0);
   self.TitleText    = self:addWidget(TextBox, self.mainLayer,  TITLE_X, TITLE_Y,     360, 220, "", self.defaultFontName, 30, "SAVE ME!", MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
   self.TitleText:setPriority(PRIORTY_3);

   self.resourceBar     = ResourceBar:new( self, 0, self:_calcHeaderLocY(), self.mainLayer, self.mainPartition  );

end

----------------------------------------------------------------

function StateDeathSave:onActivate()

    State.onActivate( self );

    App.reviveCount   = App.reviveCount or 0;

    self.showAdButton = false;
    self.saveTimer    = DECISION_TIMER;
    App.gameReviveIndex        = (App.gameReviveIndex or 0) + 1;

    self.gemCost      = App.data:getReviveCost( App.gameReviveIndex ).gem;


    self.showAdButton = App.gameReviveIndex < 3;

    if App.gameReviveIndex == 1 then
        self.gemCost = 1;
    end

    if App.gameReviveIndex == 2 then
        if not self.REVIVED_USING_AD then
            self.showAdButton = false;
            App.gameReviveIndex = 3;
            self.gemCost      = App.data:getReviveCost( App.gameReviveIndex ).gem;
        end
    end

    self.timerOff     = false;

    self.clock:setVisible(true);
    self.clock:resetAnim();
    self.clock:setLoc(CLOCK_X, CLOCK_Y);
    self.clock:setSpeed(  DECISION_TIMER_ANIM/ DECISION_TIMER  );

    if self.resourceBar then
    self.resourceBar:createConsumableButton();
    end

end

----------------------------------------------------------------

function StateDeathSave:onFocus( info )

   State.onFocus( self );


   if App.data:getFreebieCount( "revive" ) > 0 then
      self.gemCost = 0;
   end

   self:_formatDialogEnoughGem();


   self.confirmDown  = false;

   self.clock:start();

   if info and info.StateNeedGemResult == "success" then
      self:goConfirm();
   end

   if not self.timerSoundPlaying then
      self.timerSound = {start={"ReviveTimer",},};
      EventMgr:postEvent( { sounds=self.timerSound, name="deathsave onFocus",}, "add-sfx" );
      self.timerSoundPlaying = true;
   end

   if not App.data:getValue("App.settings.skip-revive-popup", true) then
      self.BackButton:disable();
      self.BackDrop:disable();
   end

end

----------------------------------------------------------------

function StateDeathSave:onLoseFocus( )

   Base.onLoseFocus( self );

   self.clock:pause();

end

----------------------------------------------------------------

function StateDeathSave:_formatDialogEnoughGem()
   local cost = self.gemCost;

   self.buyButton:enable();
   self.buyButton:show();
   self.buyButton:setColor(1,1,1,1);
   self.freebies = App.data:getFreebieCount( "revive" );

   if self.freebies and self.freebies > 0 then
      self.buyButton:swapAnim( "Button_Buy_Free");
   elseif self.gemCost <= App.data:getGemCount() then
      self.buyButton:swapAnim( "BuyButton");
   else
      self.buyButton:swapAnim( "LockButton");
   end

   self.TitleText:setText('<c:fefcfc>SAVE ME!</>');
   self.TitleTextBkgd:setText('<c:0b141d>SAVE ME!</>');

    local isFree = (self.freebies and self.freebies > 0);

   if isFree then

      App.gameReviveIndex = 0;
      self.buyButtonTextShd:setText("");
      self.buyButtonText:setText("");
      self.buyButtonGem:setVisible(false);

      --set freebie alert visible, start it
      self.FreebieAlert:setVisible(true);
      self.FreebieAlert:setLoc(83,12);
      self.FreebieAlert:start();

      self.FreebieAlertSparkle:setVisible(true);
      self.FreebieAlertSparkle:setLoc(83,12);
      self.FreebieAlertSparkle:start();

      self.freebieText:setText(""..self.freebies);
      self.freebieText.moaiTextBox:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.FreebieAlert.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT );
      self.freebieText:setLoc(-3,2);

   else

      --set freebie alert invis and stop

      self.buyButtonGem:setVisible(true);
      self.buyButtonGem:swapAnim('GemB');
      self.buyButtonGem:setScale(1,1);

      self.buyButtonTextShd:setText(""..cost);
      self.buyButtonText:setText(""..cost);

      self.freebieText:setText("");
      self.FreebieAlert:setVisible(false);
      self.FreebieAlertSparkle:setVisible(false);
      self.FreebieAlertSparkle:stop();
      self.FreebieAlert:stop();

      local buyGemX = BUY_GEM_X;
      local buyTextShdX = BUY_TEXT_SHD_X;
      local buyTextX = BUY_TEXT_X;

      if cost < 10 then
         buyGemX = -18;
         buyTextX = 22;
         buyTextShdX = 22+2;
         self.buyButtonGem:setLoc( -18, BUY_Y );
         self.buyButtonTextShd:setLocX(22+2);
         self.buyButtonText:setLocX(22);
      elseif cost < 100 then
         buyGemX = -40;
         buyTextX = 20;
         buyTextShdX = 20+2;
         self.buyButtonGem:setLoc( -40, BUY_Y );
         self.buyButtonTextShd:setLocX(20+2);
         self.buyButtonText:setLocX(20);
      else
         buyGemX = -50;
         buyTextX = 22;
         buyTextShdX = 22+2;
         self.buyButtonGem:setLoc( -50, BUY_Y );
         self.buyButtonTextShd:setLocX(22+2);
         self.buyButtonText:setLocX(22);
      end


    self.showAdButton = self.showAdButton and (AdMgr:isVideoAvailable() and isFree == false);

      if self.SHOW_VIDEO_REVIVE then
          if self.showAdButton then
            self.buyButton:setLocX(BUY_X-130);
            self.buyButtonGem:setLocX(buyGemX-130);
            self.buyButtonTextShd:setLocX(buyTextShdX-130);
            self.buyButtonText:setLocX(buyTextX-130);
            self.videoReviveButton:setVisible(true);
            self.videoButtonIcon:setVisible(true);
            self.videoReviveButton:enable();
          else
            self.videoReviveButton:setVisible(false);
            self.videoButtonIcon:setVisible(false);
            self.buyButton:setLocX(BUY_X);
            self.buyButtonGem:setLocX(buyGemX);
            self.buyButtonTextShd:setLocX(buyTextShdX);
            self.buyButtonText:setLocX(buyTextX);
            self.videoReviveButton:disable();
          end
      end

   self.REVIVED_USING_AD      = false;
   self.FREE_REVIVE_USED      = false;

   end

end

----------------------------------------------------------------

function StateDeathSave:onUpdate( dt )

   Base.onUpdate( self, dt );

   if not self.timerOff then

      self.saveTimer = self.saveTimer - dt;
      if self.saveTimer <= 0 then
         self.saveTimer = 0;
         self:goBack();
      end

   end

end

----------------------------------------------------------------

function StateDeathSave:goClose()

   if not self.confirmDown and App.data:getValue("App.settings.skip-revive-popup", true) then

      self:goBack();

      EventMgr:postEvent( {sounds=self.timerSound, name="deathsave close",}, "sfx-stop" );
      self.timerSoundPlaying = false;

   end

end

----------------------------------------------------------------

function StateDeathSave:panelPressed()

   self.confirmDown = true;

end

----------------------------------------------------------------

function StateDeathSave:panelReleased()

   self.confirmDown = false;

end

----------------------------------------------------------------

function StateDeathSave:confirmPressed()

   self.confirmDown = true;

end

----------------------------------------------------------------

function StateDeathSave:videoReviveUsed()
    self.REVIVED_USING_AD      = true;
    App.VideoReviveCount = App.VideoReviveCount + 1;
--    App.gameReviveIndex = 0;
   self.clock:stop();
   EventMgr:postEvent( {sounds=self.timerSound, name="deathsave close",}, "sfx-stop" );
   self.timerSoundPlaying = false;
    self:onSaveSuccess();
    if AdMgr:isVideoAvailable() then
        StateMgr:swap("state/state-video-play.lua", {rewardType="gold", rewardAmount=0} );
    else
         StateMgr:pop();
    end
end

----------------------------------------------------------------

function StateDeathSave:goConfirm()

   --spend gems according to cost table
   local cost     = self.gemCost;
   local missing = cost-App.data:getGemCount();

   print("StateDeathSave:goConfirm-1",cost,missing);

   self.clock:stop();
   EventMgr:postEvent( {sounds=self.timerSound, name="deathsave close",}, "sfx-stop" );
   self.timerSoundPlaying = false;

   if self.freebies and self.freebies > 0 then
         App.data:spendFreebie( "revive", 1, "revived" );

         EventMgr:postEvent( {cost={ gem=0, freebie=1} }, "revive-used" );
         self.FREE_REVIVE_USED = true;
         --App.gameReviveIndex = 0;
         self:onSaveSuccess();
         StateMgr:pop();

   elseif missing <= 0 then

      if App.data:spendGem( cost, "revive" ) then

         EventMgr:postEvent( {cost={ gem=cost, freebie=0} }, "revive-used" );

         self:onSaveSuccess();
         StateMgr:pop();
      else
         --Michel print error
      end

   else

      local title = "You Need Gems";

      local id       = StoreMgr:getGemAutoBuyId(cost);
      local gems     = StoreMgr:getProductAmount(id).gem;
      local message  = "Buy " .. tostring(gems) .." gems";

      StateMgr:push( "state/state-need-gem.lua", { title=title, message=message, missing=missing, cost=cost, productId=nil } );

   end

end

----------------------------------------------------------------

function StateDeathSave:onSaveSuccess()

    local total       = App.data:deltaValue("revive-total-count",1);
    local c = self.gemCost;
    local type = "gem";
    App.playerRevive  = "yes";
       App.reviveCount   = App.reviveCount + 1;

    if self.REVIVED_USING_AD then
        c = "video";
        type = "video"
    end

   MOAIFlurry:event("Revive"
                   , "index",          ""..math.min( App.reviveCount, App.data:getMaxRevive())
                   , "cost",           ""..c
                   , "sequence-count", ""..App.reviveCount
                   , "totalCount",     ""..total
                   , "freebie",        ""..App.data:getFreebieCount( "revive" )
                   , "boss",           tostring(App.game.gameDirector:isBossScenarioActive())             );

   MOAIFlurry:event(   "auto-buy-success"
                     , "type",                     type
                     , "state",                    "StateDeathSave"
                     , "reason1",                  "revive"
                     , "reason2",                  "revive-" .. tostring(self.gemCost)
                     , "carIndex",                 "-1"
                     );


end

----------------------------------------------------------------

function StateDeathSave:goBack()

    App.playerRevive  = "no";

    self.timerSoundPlaying = false;

    StateDeathSave:checkAdWhenPlayerNotRevived();

    StateMgr:pop();

end

----------------------------------------------------------------------

function StateDeathSave:checkAdWhenPlayerNotRevived()

    App.shouldShowAd  = "no";
    local lastAdSeenDateKey = "last-post-game-ad-seen-date";
    local lastAdSeenIndexKey = "last-post-game-ad-seen-index";

    if not App.data:getValue(lastAdSeenDateKey) then
        App.data:setValue(lastAdSeenDateKey,os.time( ));
    end

    local lastDate = App.data:getValue(lastAdSeenDateKey);
    local currentDate = os.time();

    local idx = App.data:getValue(lastAdSeenIndexKey) or 0;

    if (currentDate - lastDate) > (24 * 60 * 60) then
        idx = 0;
    end

    if idx == 2 or idx == 4 or idx == 7 then
        App.shouldShowAd = "yes";
        App.data:setValue(lastAdSeenDateKey,os.time( ));
    end

    idx = idx + 1;
    App.data:setValue(lastAdSeenIndexKey,idx);

end

----------------------------------------------------------------------

function StateDeathSave:onDataServerError()

   print("StateDeathSave:onDataServerError()");

   if not StateMgr._showErrorDialog then

      --Give back the key

      Base.onDataServerError(self);

      App.data:addKey(1, "Data Server Error");

   end

end

----------------------------------------------------------------

function StateDeathSave:isUsingCameraHack()

   return false;

end

----------------------------------------------------------------

return StateDeathSave;

----------------------------------------------------------------
