----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORITY_0					= 10;
local PRIORITY_1					= 20;
local PRIORITY_2					= 30;
local PRIORITY_3					= 40;
local PRIORITY_4					= 50;
local PRIORITY_5					= 60;
local PRIORITY_6					= 70;
local PRIORITY_7					= 80;
local PRIORITY_8					= 90;
local PRIORITY_9					= 100;
local PRIORITY_10					= 110;

local SQUARE_TEXTURE				= "resources/square.png";

----------------------------------------------------------------

local Base						= State;
local StateDroneLocked		= Base:new();

----------------------------------------------------------------

function StateDroneLocked:onLoad()

   State.onLoad( self );

	local textureSheet	= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";
	self.IS_POPUP  = true;

	-- Background
	self.Background = self:addWidget(Image, self.mainLayer, 0,0, 1400, 1200, SQUARE_TEXTURE, {0,0,0, 0.75});
	self.Background:setPriority(0);

	-- Frame
	self.Frame = self:addWidget(Anim, self.mainLayer, 0, 10, 0,0, "SmallBackGround", textureSheet);
	self.Frame:setPriority(1);

	-- text message
	self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 131, 540, 70, "<c:fefcfc>Drone Garage<c>", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleText:setScale(1.5, 1.5);
	self.TitleText:setPriority(PRIORITY_1);
	self.TitleTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, 131-2, 540, 70, "<c:0b141d>Drone Garage<c>", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleTextShdw:setScale(1.5, 1.5);
	self.TitleTextShdw:setPriority(PRIORITY_1-1);
	self.LockedText = self:addWidget(TextBox, self.mainLayer, 0, -47, 500, 270, "Lock Text", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.LockedText:setLineSpacing(25);
	self.LockedText:setScale(1.2, 1.2);
	self.LockedText:setPriority(PRIORITY_3);
	self.LockedTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, -47-2, 500, 270, "Lock Text", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.LockedTextShdw:setLineSpacing(25);
	self.LockedTextShdw:setScale(1.2, 1.2);
	self.LockedTextShdw:setPriority(PRIORITY_3-1);

	-- Exit Button
	self.BackButton	= self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 161, 0,0, "CloseButton", textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
	self.BackButton:setPriority(PRIORITY_2);

end

----------------------------------------------------------------

function StateDroneLocked:onActivate()

   State.onActivate(self);

end

----------------------------------------------------------------

function StateDroneLocked:onFocus( data )

   State.onFocus(self);

	local unlockLevel	= DroneMgr:getDroneLevelUnlock();
	local text			= "Drones unlock at\nLevel "..unlockLevel.."!";

	self.LockedText:setText("<c:1b3043>"..text.."<c>");
	self.LockedTextShdw:setText("<c:8fb5cd>"..text.."<c>");

end

----------------------------------------------------------------

function StateDroneLocked:onUpdate( dt )

	Base.onUpdate(self, dt);

end


------------------------------------------------------------------------------------
-- Util
------------------------------------------------------------------------------------


function StateDroneLocked:isUsingCameraHack()
   return false;
end


------------------------------------------------------------------------------------
-- Exit State
------------------------------------------------------------------------------------


function StateDroneLocked:goBack()
	StateMgr:pop();
end


------------------------------------------------------------------------------------
-- End State
------------------------------------------------------------------------------------


return StateDroneLocked;


