
----------------------------------------------------------------
require('state/state')
require('ui/ui-button/ui-button-image')
require('ui/ui-image')
require('ui/ui-text-box')
require('ui/ui-anim')
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');

----------------------------------------------------------------

----------------------------------------------------------------

local Base                    = State;
local StateGCLeaderboard      = Base:new();

----------------------------------------------------------------

function StateGCLeaderboard:onFocus( param )

   Debug.assert( MOAIGameCenterIOS, "StateGCLeaderboard:onFocus -> MOAIGameCenterIOS");

   Base.onFocus( self );


   StateMgr:setSyncBusyDelay(0);

   disableButtonInput();


   self.authenticating = true;

   --Handle any situation
   MOAIGameCenterIOS:authenticate();

   print("MOAIGameCenterIOS.STATE_NOT_AUTHENTICATED", MOAIGameCenterIOS.STATE_NOT_AUTHENTICATED);

   EventMgr:postEvent({}, "game-center-show-leaderboard-attempt");

   MOAIGameCenterIOS:setListener(   MOAIGameCenterIOS.UI_DONE_SUCCESS,
                                    function()
                                       delay( 0.1, function()
                                                      StateMgr:pop();
                                                   end );
                                    end );


   MOAIGameCenterIOS:setListener(   MOAIGameCenterIOS.UI_DONE_FAILURE,
                                    function()
                                       delay( 0.1, function()
                                                      --TODO: Use Error Box
                                                      StateMgr:pop();
                                                   end  );
                                    end );

end

----------------------------------------------------------------

function StateGCLeaderboard:onLoseFocus( )

   Base.onLoseFocus(self);

   StateMgr:setSyncBusyDelay(nil);

   enableButtonInput();

end

----------------------------------------------------------------------

function StateGCLeaderboard:shouldReportBusy()

   return false;

end

----------------------------------------------------------------------

function StateGCLeaderboard:onUpdate( dt )

   Base.onUpdate( self, dt );

   if self.authenticating then

      if MOAIGameCenterIOS:getState() == MOAIGameCenterIOS.STATE_NOT_AUTHENTICATED then

         Debug.assert( false, "StateGCLeaderboard:onUpdate -> MOAIGameCenterIOS:getState() == MOAIGameCenterIOS:STATE_NOT_AUTHENTICATED");

      elseif MOAIGameCenterIOS:getState() == MOAIGameCenterIOS.STATE_AUTHENTICATING then

      elseif MOAIGameCenterIOS:getState() == MOAIGameCenterIOS.STATE_AUTHENTICATED then

         local leaderboardId = AbTestMgr:getGameCenterShowLeaderboardId() or "RR_Leaderboard_Score";
         local timeScope     = AbTestMgr:getGameCenterGcUiTimeScope() or MOAIGameCenterIOS.TIME_SCOPE_ALL_TIME;

         local success, errorMsg = MOAIGameCenterIOS:showLeaderboard( leaderboardId, timeScope );

         if success then

            self.authenticating = false;
            EventMgr:postEvent({}, "game-center-show-leaderboard-success");

         else
            print("show leaderboard error", error);
            EventMgr:postEvent({error=errorMsg}, "game-center-show-leaderboard-failure");
            StateMgr:pop();
         end

      else

         Debug.assert( MOAIGameCenterIOS:getState() == MOAIGameCenterIOS.STATE_AUTHENTICATED_FAILED, "StateGCLeaderboard:onUpdate -> else : ".. tostring(MOAIGameCenterIOS:getState()) );

         self.authenticating = false;
         StateMgr:pop();

      end

   end

end

----------------------------------------------------------------------

function StateGCLeaderboard:isBusy()

   return true;

end

----------------------------------------------------------------------

function StateGCLeaderboard:getBusyName()

   if MOAIGameCenterIOS:getState() == MOAIGameCenterIOS.STATE_AUTHENTICATING then
      return "Authenticating...";
   else
      return "Loading...";
   end
end

----------------------------------------------------------------

return StateGCLeaderboard
