----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SHOP_TRAY_HOME_X = 0;
local SHOP_TRAY_HOME_Y = 0;
local SHOP_TRAY_SHIFT  = 300;
local COIN_COUNT_X     = -143;
local COIN_COUNT_Y     = 437;
local GEM_COUNT_X      = 163;
local GEM_COUNT_Y      = 437;
local PRIORTY_0        = 10;
local PRIORTY_1        = 20;
local PRIORTY_2        = 30;
local PRIORTY_3        = 40;
local PRIORTY_4        = 50;
local PRIORTY_5        = 60;
local PRIORTY_6        = 70;
local PRIORTY_7        = 80;
local PRIORTY_8        = 90;
local PRIORTY_9        = 100;
local PRIORTY_10       = 110;

local HACK_ALWAYS_SHOW_HOLIDAY = false;

local SALE_TEXT =
{
   '<c:ffffff><c>',
   '<c:ffffff>Save 5%<c>',
   '<c:ffffff>Save 15%<c>',
   '<c:ffffff>Save 25%<c>',
   '<c:ffffff>Save 35%<c>',
   '<c:ffffff>Save 50%<c>',
};

local HOLIDAY_SALE_TEXT =
{
   '<c:ffffff>Save 5%<c>',
   '<c:ffffff>Save 15%<c>',
   '<c:ffffff>Save 25%<c>',
   '<c:ffffff>Save 35%<c>',
   '<c:ffffff>Save 45%<c>',
   '<c:ffffff>Save 55%<c>',
};


-- This is the order in which the products will be displayed in the UI.

local GEM_PRODUCT_LIST = {
   "gem1",
   "gem2",
   "gem3",
   "gem4",
   "gem5",
   "gem6",
};

local GEM_PRODUCT_LIST_HOLIDAY = {
   "gemHoliday1",
   "gemHoliday2",
   "gemHoliday3",
   "gemHoliday4",
   "gemHoliday5",
   "gemHoliday6",
};

----------------------------------------------------------------

local Base     = State;
local StateGem = Base:new();

----------------------------------------------------------------

function StateGem:onLoad()

   State.onLoad( self );

   self.textureSheet = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
   self.textureMain  = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";

   -- background and title
   self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "S_Background", self.textureSheet);

   self.Image = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "S_TitleBuyGem", self.textureSheet, nil, nil, nil);
   self.Image:setPriority(PRIORTY_1);

   if StateMgr.headerAvailable then
      self.Title = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "TitleBuyGem", self.textureSheet, nil, nil, true);
      self.Title:setPriority(PRIORTY_2);
   end

   self:_setupResourceBar();

   -- Deal sticker
   self.GreatBuy = self:addWidget(Anim, self.mainLayer, -120, -40, 0,0, "S_GreatBuy", self.textureSheet, nil, nil, true);
   self.GreatBuy:setPriority(PRIORTY_2);

   -- push/pop state buttons
   self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "S_ReadyButton", self.textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
   self.BackButton:setPriority(PRIORTY_0);

   -- purchase buttons and text
   self.ValueButton  = {};
   self.OfferText    = {};
   self.OfferTextSdw = {};
   self.PriceText    = {};
   self.PriceTextSdw = {};
   self.CornerBanner = {};
   self.CornerText   = {};

   self:_createBuyButtons();

end

----------------------------------------------------------------
----------------------------------------------------------------

function StateGem:_createHolidayStore()

--MQL: Disable holiday button
--[[
   if StateMgr.headerAvailable then
      self.Title:setVisible(false);
      self.WinterTitle = self:addWidget(Image, self.mainLayer, 0, 425, 521, 73, "resources/holiday/S_HolidayGemSale.png", {1,1,1,1});
      self.WinterTitle:setPriority(PRIORTY_3);
   end

   self.WinterSnow = self:addWidget(Image, self.mainLayer, 0, 236, App.viewportWidth, (App.viewportWidth*0.2), "resources/holiday/S_Snow.png", {1,1,1,1});
   self.WinterSnow2 = self:addWidget(Image, self.mainLayer, 0, -460, App.viewportWidth, (App.viewportWidth*0.2), "resources/holiday/S_Snow.png", {1,1,1,1});
   self.Snowflake1 = self:addWidget(Image, self.mainLayer, -95, 495, 75, 75, "resources/holiday/S_Snowflake1.png", {1,1,1,0.75});
   self.Snowflake1:setRot(73);
   self.Snowflake1:setPriority(PRIORTY_2);
   self.Snowflake2 = self:addWidget(Image, self.mainLayer, -190, 260, 80, 80, "resources/holiday/S_Snowflake2.png", {1,1,1,0.75});
   self.Snowflake2:setPriority(PRIORTY_2);
   self.Snowflake3 = self:addWidget(Image, self.mainLayer, 90, 375, 95, 95, "resources/holiday/S_Snowflake1.png", {1,1,1,0.75});
   self.Snowflake3:setPriority(PRIORTY_2);
   self.Snowflake4 = self:addWidget(Image, self.mainLayer, 210, 280, 80, 80, "resources/holiday/S_Snowflake2.png", {1,1,1,0.75});
   self.Snowflake4:setPriority(PRIORTY_2);

   self.timerBox  = self:addWidget( Anim, self.mainLayer, 0,0,0,0, "TimerFrame_Holiday", self.textureMain);
   self.timerBox:setPriority(PRIORTY_3);

   self.timerPreText = self:addWidget( TextBox, self.mainLayer, 0, 0, 280, 130, "Sale ends in:", self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.timerPreText:setPriority(PRIORTY_5);
   self.timerPreTextShadow = self:addWidget( TextBox, self.mainLayer, 0, 0, 280, 130, "Sale ends in:", self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   self.timerPreText:setPriority(PRIORTY_4);

   self.timerText = self:addWidget( TextBox, self.mainLayer, 0, 0, 120, 130, "", self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.timerText:setPriority(PRIORTY_5);
   self.timerTextShadow = self:addWidget( TextBox, self.mainLayer, 0, 0, 120, 130, "", self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   self.timerTextShadow:setPriority(PRIORTY_4);

   self.timerPreText:setLoc(-150,-380);
   self.timerPreTextShadow:setLoc(-148,-382);
   self.timerText:setLoc(-150,-440);
   self.timerTextShadow:setLoc(-148,-442);
   self.timerBox:setLoc(-150,-440);


   self.holidayAssets = true;
]]

end

----------------------------------------------------------------

function StateGem:_updateHolidayButtons()

   for i = 1, 6 do

      local button = "S_Slot" .. i;
      local x      = 134+92;
      local y      = -21;
      local tx     = 134;
      local layer  = 3;

      if i == 4 then
         button = 'S_Slot4Green';
         x      = 92;
         y      = -24;
         tx     = 0;
         layer  = 1;
      end

      local offerText, priceText, offerColor, priceColor = self:createButtonText(i);

      self.OfferText[i]:setText(offerText);
      self.OfferTextSdw[i]:setText(offerText);
      self.PriceText[i]:setText(priceText);
      self.PriceTextSdw[i]:setText(priceText);

      self.OfferText[i]:setColor(offerColor[1], offerColor[2], offerColor[3], offerColor[4]);
      self.PriceText[i]:setColor(priceColor[1], priceColor[2], priceColor[3], priceColor[4]);

      self.OfferText[i]:preloadTextGlyphs();
      self.OfferTextSdw[i]:preloadTextGlyphs();
      self.PriceText[i]:preloadTextGlyphs();
      self.PriceTextSdw[i]:preloadTextGlyphs();

      self.ValueButton[i]:swapAnim(button);

      self.CornerText[i]:setText(HOLIDAY_SALE_TEXT[i]);

      self.OfferText[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.OfferTextSdw[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.PriceText[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.PriceTextSdw[i]:setParent(self.ValueButton[i].anim.props[layer]);

      self.CornerBanner[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.CornerText[i]:setParent(self.CornerBanner[i].anim);

      if i == 4 then
         self.GreatBuy:setParent(self.ValueButton[i].anim.props[1]);
      end

      self.ValueButton[i]:setPriority(PRIORTY_0);
      self.OfferText[i]:setPriority(PRIORTY_1);
      self.OfferTextSdw[i]:setPriority(PRIORTY_1-1);
      self.PriceText[i]:setPriority(PRIORTY_1);
      self.PriceTextSdw[i]:setPriority(PRIORTY_1-1);
      self.CornerBanner[i]:setPriority(PRIORTY_2);
      self.CornerText[i]:setPriority(PRIORTY_3);

      self.CornerBanner[1]:setVisible(true);
      self.CornerBanner[1]:setPriority(PRIORTY_2);

	end

end

----------------------------------------------------------------

function StateGem:removeHolidayStore()

   if StateMgr.headerAvailable then
      self.Title:setVisible(true);
      self.WinterTitle:setVisible(false);
   end

   self.WinterSnow:setVisible(false);
   self.WinterSnow2:setVisible(false);
   self.Snowflake1:setVisible(false);
   self.Snowflake2:setVisible(false);
   self.Snowflake3:setVisible(false);
   self.Snowflake4:setVisible(false);

   self.timerPreText:setVisible(false);
   self.timerPreTextShadow:setVisible(false);
   self.timerText:setVisible(false);
   self.timerTextShadow:setVisible(false);
   self.timerBox:setVisible(false);

   self.holidayAssets = false;

end

----------------------------------------------------------------
----------------------------------------------------------------

function StateGem:_setupResourceBar()

   self.resourceBar = ResourceBar:new( self, 0, self:_calcHeaderLocY() , self.mainLayer, self.mainPartition  );
   self.resourceBar:setGemCallback(
         nil
      ,
         function()
         end
      );

   self.resourceBar:setGoldCallback(
         nil
      ,
         function()
            StateMgr:swap("state/state-coin.lua");
         end
   );

   self.resourceBar:setKeyCallback(
         nil
      ,
         function()
            StateMgr:swap("state/state-key.lua");
         end
   );

end

----------------------------------------------------------------
----------------------------------------------------------------

function StateGem:_createBuyButtons()

   for i = 1, 6 do

      local button = "S_Slot" .. i;
      local x      = 134+92;
      local y      = -21;
      local tx     = 134;
      local layer  = 3;

      if i == 4 then
         button = 'S_Slot4Green';
         x      = 92;
         y      = -24;
         tx     = 0;
         layer  = 1;
      end

      self.ValueButton[i]  = self:addWidget ( ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, button, self.textureSheet, nil,
                                              function ()
                                                 self:goPurchase(i);
                                              end,
                                              nil, nil );
      self.CornerBanner[i] = self:addWidget( Anim, self.mainLayer, x, y, 0,0, "S_CornerBanner", self.textureSheet, nil, nil, true);

      self.OfferText[i]    = self:addWidget( TextBox, self.mainLayer, tx, 20, 260, 130, "", self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
      self.OfferTextSdw[i] = self:addWidget( TextBox, self.mainLayer, tx+2, 20-2, 260, 130, "", self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0, 0, 0, 1});

      self.PriceText[i]    = self:addWidget( TextBox, self.mainLayer, tx, -25, 260, 130, "", self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0.7, .9, .99});
      self.PriceTextSdw[i] = self:addWidget( TextBox, self.mainLayer, tx+2, -25-2, 260, 130, "", self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0, 0, 0, 1});

      self.CornerText[i]   = self:addWidget( TextBox, self.mainLayer, 14, -12, 260, 260, "", self.defaultFontName, 9, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);

      self.CornerText[i]:setRot(0, 0, 40);

      self.OfferText[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.OfferTextSdw[i]:setParent(self.ValueButton[i].anim.props[layer]);

      self.PriceText[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.PriceTextSdw[i]:setParent(self.ValueButton[i].anim.props[layer]);

      self.CornerBanner[i]:setParent(self.ValueButton[i].anim.props[layer]);
      self.CornerText[i]:setParent(self.CornerBanner[i].anim);
      if i == 4 then
         self.GreatBuy:setParent(self.ValueButton[i].anim.props[layer]);
      end

      self.ValueButton[i]:setPriority(PRIORTY_0);

      self.OfferText[i]:setPriority(PRIORTY_1);
      self.OfferTextSdw[i]:setPriority(PRIORTY_1-1);

      self.PriceText[i]:setPriority(PRIORTY_1);
      self.PriceTextSdw[i]:setPriority(PRIORTY_1-1);

      self.CornerBanner[i]:setPriority(PRIORTY_2);
      self.CornerText[i]:setPriority(PRIORTY_3);

   end

end

----------------------------------------------------------------

-- Returns two pieces of text and two text colors
function StateGem:createButtonText( i )

   if not Debug.assertType(i, "number", "StateGem:createButtonText -> i") then
      return;
   end

   local priceColor = {0.7, .9, .99};
   if i == 4 then
      priceColor = {1, 1, 1, 1}
   end

   local productId = self:_getGemProductIdFromIndex(i);

   print( "StateGem:createButtonText", productId );

   return StoreMgr:getGemTitle(productId), StoreMgr:getGemCostDisplay(productId), {1, 1, 1, 1}, priceColor;
end

----------------------------------------------------------------

function StateGem:_getGemProductIdFromIndex(index)

   local productList = GEM_PRODUCT_LIST;

   if PromoMgr:getCurrentSales("holiday") then
      productList = GEM_PRODUCT_LIST_HOLIDAY;
   end

   return StoreMgr:getProductIdFromName(productList[index]);

end

----------------------------------------------------------------

function StateGem:onActivate()

   State.onActivate(self);

   self:_updateHolidayStoreDisplay();

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
      self.resourceBar:setConsumableCallback(   nil,
                                                function()
                                                   StateMgr:swap("state/state-consumable.lua");
                                                end
                                             );
   end

end

----------------------------------------------------------------

function StateGem:_updateHolidayStoreDisplay()

   -- MQL: Disable holiday button
   -- local sale = PromoMgr:getCurrentSales("holiday");
   local sale = false;

   if sale or HACK_ALWAYS_SHOW_HOLIDAY then

      if not self.holidayAssets then
         self:_createHolidayStore();
         self:_updateHolidayButtons();
      end

   else

      if self.holidayAssets then
         self:removeHolidayStore();
      end

      self:_updateButtons();
   end


end

----------------------------------------------------------------

function StateGem:_updateButtons()

   Debug.assert( StoreMgr:getGemProductsCount() >= 6, "StateGem:_updateButtons -> StoreMgr:getGemProductsCount()" );

   for i = 1, 6 do
      local offerText, priceText, offerColor, priceColor = self:createButtonText(i);

      self.OfferText[i]:setText(offerText);
      self.OfferTextSdw[i]:setText(offerText);
      self.PriceText[i]:setText(priceText);
      self.PriceTextSdw[i]:setText(priceText);

      self.OfferText[i]:setColor(offerColor[1], offerColor[2], offerColor[3], offerColor[4]);
      self.PriceText[i]:setColor(priceColor[1], priceColor[2], priceColor[3], priceColor[4]);

      self.OfferText[i]:preloadTextGlyphs();
      self.OfferTextSdw[i]:preloadTextGlyphs();
      self.PriceText[i]:preloadTextGlyphs();
      self.PriceTextSdw[i]:preloadTextGlyphs();

      self.CornerText[i]:setText(SALE_TEXT[i]);
   end

   self.CornerBanner[1]:setVisible(false);
   self.CornerBanner[1]:setPriority(PRIORTY_0-1);

end

----------------------------------------------------------------

function StateGem:onFocus()

   State.onFocus( self );

   self:resetAllButtons();

   StateMgr:setSyncBusyDelay(0);

   self:_updateHolidayStoreDisplay();

end

----------------------------------------------------------------

function StateGem:onLoseFocus( )

   Base.onLoseFocus(self);

   StateMgr:setSyncBusyDelay(nil);

end

----------------------------------------------------------------

function  StateGem:onEnterForeground( )

   Base:onEnterForeground( );

   self:_updateHolidayStoreDisplay();

end

----------------------------------------------------------------

function StateGem:onUpdate( dt )

   Base.onUpdate( self, dt );

   if self.holidayAssets then
      self:updateCountdownTimer( dt );
   end

end

----------------------------------------------------------------

function  StateGem:updateCountdownTimer( dt )

   if self.timerText then

      if not self.holidayEndTime then
         self.holidayEndTime = -1;
         local sale = PromoMgr:getCurrentSales("holiday");
         if sale then
            self.holidayEndTime = sale[1].to;
         end
      end

      if not self.timeTillEnd and self.holidayEndTime and self.holidayEndTime > 0 then
         local time = TimeMgr:getTimeGMT();
         if time then
            self.timeTillEnd = self.holidayEndTime - time;
         end
      end

      if self.timeTillEnd and self.timeTillEnd > 0 then
         self.timeTillEnd = self.timeTillEnd - dt;
         local text = self:convertTime( self.timeTillEnd )
         self.timerText:setText(text);
         self.timerTextShadow:setText(text);
      else
         self:removeHolidayStore();
      end
   end

end

----------------------------------------------------------------

function StateGem:convertTime( time )

   local description = "";
   local days = math.ceil(time/86400);
   local hours = math.floor(time/3600);
   local min = math.floor((time%3600)/60);
   local sec = math.floor((time%60));
   if days and hours and min and sec then
      if days > 1 then
         if not self.timerJustifiedCenter then
            self.timerText:setAlignment ( MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY );
            self.timerTextShadow:setAlignment ( MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY );
            self.timerText:setLoc(-150,-440);
            self.timerTextShadow:setLoc(-148,-442);
            self.timerJustifiedCenter = true;
            self.timerJustifiedLeft = false;
         end
         description = days.." days!";
      else

         if not self.timerJustifiedLeft then
            self.timerText:setAlignment ( MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY );
            self.timerTextShadow:setAlignment ( MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY );
            self.timerText:setLoc(-142,-440);
            self.timerTextShadow:setLoc(-140,-442);
            self.timerJustifiedLeft = true;
            self.timerJustifiedCenter = false;
         end

         if hours < 10 then
            description = "0"..hours;
         else
            description = ""..hours;
         end

         if min < 10 then
            description = description..":0"..min;
         else
            description = description..":"..min;
         end

         if sec < 10 then
            description = description..":0"..sec;
         else
            description = description..":"..sec;
         end

      end
   end

   return description;

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGem:setShopTrayHeight()

   local aspect = App.viewportHeight/App.viewportWidth;

   if aspect > 1.76 then

      COIN_COUNT_Y	= 525;
      GEM_COUNT_Y		= 525;

      self.ShopBarBackDrop:setVisible(false);

   end

end

----------------------------------------------------------------

function StateGem:resetAllButtons()

   for i=1,6 do
      self.ValueButton[i]:setAnimFrame();
      self.ValueButton[i]:enable();
   end

end

----------------------------------------------------------------

function StateGem:goPurchase( index )

   local buyIndex = index;

   if buyIndex and StoreMgr:canMakePayments() then

      disableButtonInput();

print("Go To Purchase-2", buyIndex );

      local productId = self:_getGemProductIdFromIndex(buyIndex);

      local buySuccess = StoreMgr:buyProduct( productId,
                                              self,
                                              function()
                                                 self:onBuySuccess(productId);
                                              end,
                                              function()
                                                 self:onBuyFail(productId);
                                              end )

      if not buySuccess then
         self:onBuyFail();
      end

   else

      self:showErrorMessage(LocalizationMgr:getString( "NATIVE_PURCH_DISABLED" ) );

   end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGem:showErrorMessage( message )

   MOAIDialogIOS.showDialog(	LocalizationMgr:getString( "NATIVE_TRANS_FAIL" )
                              , message
                              ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                              ,  nil
                              ,  nil
                              ,  false
                              ,  function()
                                 end
                           );

end

----------------------------------------------------------------

function StateGem:onBuySuccess( productId )

   Debug.assert( productId );

   local bGems = StoreMgr:getProductAmount(productId).gem;

   print( "StateGem:onBuySuccess", productId, bGems );

   EventMgr:postEvent( {  gem=bGems, source="store-page", productId=productId }, "gems-bought" );

   self:resetAllButtons();

   enableButtonInput();

end

----------------------------------------------------------------

function StateGem:onBuyFail()

   print("StateGem:onBuyFail");

   enableButtonInput();

   self:resetAllButtons();

   self:showErrorMessage( LocalizationMgr:getString( "NATIVE_TRY_AGAIN" ) );

end

----------------------------------------------------------------

function StateGem:goBack()

   print("Go Back");

   StateMgr:pop();

end


----------------------------------------------------------------------

function StateGem:isBusy()

   return StoreMgr:isBusy();

end

----------------------------------------------------------------

return StateGem;

----------------------------------------------------------------
