----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;

----------------------------------------------------------------

local Base						= State;
local StateGuest			= Base:new();
local localApp					= nil;
local localSelf				= nil;

local screenWidth          = App.viewportWidth;
local screenHeight         = App.viewportHeight;

local guestText1				= "Get the Full Game"
local guestText2				= "Upgrade your Weapons, Armor, and Powerups"
local guestText3				= "WEEKLY and DAILY Challenges"
local guestText4				= "BRAG to your friends on the Leaderboard"

----------------------------------------------------------------

function StateGuest:onLoad( loader )

   Base.onLoad( self );
	
	localSelf = self;

	self:createProps();
	
end

----------------------------------------------------------------

function StateGuest:createProps()

   self.defaultFontName = "resources/font/TangoLatin.otf";

	self.textureSheet      = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
	
	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.75});
	self.Overlay:setPriority(PRIORTY_0);
	
	-- background
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "M_MissionPopUpBackDrop", self.textureSheet);
	self.BackDrop:setPriority(PRIORTY_0);

	-- guest bluebox
	self.GuestBlueBox = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "P_GuestBlueBox", self.textureSheet);
	self.GuestBlueBox:setPriority(PRIORTY_7);
	
	-- guest checkboxes
	self.GuestCheck1 = self:addWidget(Anim, self.mainLayer, -205,185,99,104, "P_Checkmark", self.textureSheet);
	self.GuestCheck2 = self:addWidget(Anim, self.mainLayer, -205,30,129,104, "P_Checkmark", self.textureSheet);
	self.GuestCheck3 = self:addWidget(Anim, self.mainLayer, -205,-125,99,104, "P_Checkmark", self.textureSheet);
	self.GuestCheck1:setPriority(PRIORTY_7);
	self.GuestCheck2:setPriority(PRIORTY_7);
	self.GuestCheck3:setPriority(PRIORTY_7);

	
	self.guestText1 = self:addWidget( TextBox, self.mainLayer,
                                          0, 313, 600, 150, 
                                          guestText1, self.defaultFontName, 26, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText2 = self:addWidget( TextBox, self.mainLayer,
                                          55, 185, 378, 200, 
                                          guestText2, self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText3 = self:addWidget( TextBox, self.mainLayer,
                                          55, 30, 378, 200, 
                                          guestText3, self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText4 = self:addWidget( TextBox, self.mainLayer,
                                          55, -125, 378, 200, 
                                          guestText4, self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText1:setPriority(PRIORTY_8);
	self.guestText2:setPriority(PRIORTY_8);
	self.guestText3:setPriority(PRIORTY_8);
	self.guestText4:setPriority(PRIORTY_8);
	
   -- push/pop state buttons
   self.BackButton      =  self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "P_QuitGameButton", self.textureSheet, nil, self.goBack, nil, nil);
   self.BackButton:setPriority(PRIORTY_7);

end

----------------------------------------------------------------

function StateGuest:goBack()

	StateMgr:swap("state/state-splash.lua");

end

----------------------------------------------------------------

return StateGuest;

----------------------------------------------------------------
