
----------------------------------------------------------------
require('state/state')
require('ui/ui-button/ui-button-image')
require('ui/ui-image')
require('ui/ui-text-box')
require('ui/ui-anim')
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');

----------------------------------------------------------------

----------------------------------------------------------------

local Base              = State;
local StateInterstitial = Base:new();

----------------------------------------------------------------

function StateInterstitial:onFocus( param )

   Base.onFocus( self );

   StateMgr:setSyncBusyDelay(0);

   disableButtonInput();

   self.location   =  ((param or {}).location)   or "";

   local success = AdMgr:showInterstitial(   self.location
                                          ,
                                             self
                                          ,
                                             function()
                                                self:_onSuccess();
                                             end
                                          ,
                                             function()
                                                self:_onFail();
                                             end
                                          );

print("StateInterstitial:onFocus", success );
   if not success then
      self:_onFail();
   end

end

----------------------------------------------------------------

function StateInterstitial:onLoseFocus( )

   Base.onLoseFocus(self);

   StateMgr:setSyncBusyDelay(nil);

   enableButtonInput();

end

----------------------------------------------------------------

function StateInterstitial:_onSuccess()

   StateMgr:pop();

end

----------------------------------------------------------------

function StateInterstitial:_onFail()

   App.AfterGameInterstitialFailed = true;

   StateMgr:pop();

end

----------------------------------------------------------------------

function StateInterstitial:shouldReportBusy()
   return false;
end

----------------------------------------------------------------------

function StateInterstitial:isBusy()
   return true;
end


----------------------------------------------------------------------

function StateInterstitial:getBusyName()

   return "Loading...";

end


----------------------------------------------------------------

return StateInterstitial
