----------------------------------------------------------------

require('flash/flash-manager')
require('app/contact/contact-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-scroll-list');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

InviteData = nil;

----------------------------------------------------------------

local SLIDE_MIN         = -App.viewportHeight/2;
local SLIDE_MAX         = App.viewportHeight/2;
local SWIPE_WIN_MIN_X   = -App.viewportWidth/2;
local SWIPE_WIN_MAX_X   = App.viewportWidth/2;
local SWIPE_WIN_MIN_Y   = -245;
local SWIPE_WIN_MAX_Y   = 285;
local ROLLOUT_X         = 0;
local ROLLOUT_Y         = 0;
local ROLLOUT_SHIFT     = 570;
local RANK_LiST_HOME_X  = 0;
local RANK_LiST_HOME_Y  = 230;
local RANK_LiST_SPACING = 105;
local REWARD_COUNT_X    = -180;
local REWARD_COUNT_Y    = 324;
local PRIORTY_0         = 10;
local PRIORTY_1         = 20;
local PRIORTY_2         = 30;
local PRIORTY_3         = 40;
local PRIORTY_4         = 50;
local PRIORTY_5         = 60;
local PRIORTY_6         = 70;
local PRIORTY_7         = 80;

----------------------------------------------------------------

local Base         = State;
local StateInvite  = Base:new();
local localApp     = nil;
local localSelf    = nil;
local textureSheet = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

----------------------------------------------------------------

local MessageIndex = nil;

----------------------------------------------------------------

function  StateInvite:onLoad()

   State.onLoad( self );

   self.defaultFontName = "resources/font/TangoLatin.otf";

   -- background and frames
   self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IBBackDrop", textureSheet);
   self.BackDrop:setPriority(1);
   self.BackOverlay = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IBBackDrop", textureSheet);
   self.BackOverlay:setPriority(2);
   self.Frame = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IBScrollFrame", textureSheet);
   self.Frame:setPriority(PRIORTY_4);
   self.Title = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "TitleInvite", textureSheet, nil, nil, true);
   self.Title:setPriority(PRIORTY_5);

   -- rollout tray
   self.IconTry = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IconTryOut", textureSheet);
   self.IconTry:setPriority(PRIORTY_6);
   self.IconTryIn = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IconTryInButton", textureSheet, nil, self.showRollOut, nil, nil, nil, nil, 20);
   self.IconTryIn:setPriority(PRIORTY_7);
   self.IconTryOut = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IconTryOutButton", textureSheet, nil, self.hideRollOut, nil, nil, nil, nil, 20);
   self.IconTryOut:setPriority(PRIORTY_7);
   if MOAIEnvironment.osBrand == "Android" then
      self.InviteSMSButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBRolloutShareButton", textureSheet, nil, self.sendInviteSMSTango, nil, nil, nil, nil, 20);
   else
      self.InviteSMSButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBRolloutSMSButton", textureSheet, nil, self.sendInviteSMSTango, nil, nil, nil, nil, 20);
   end
   self.InviteSMSButton:setPriority(PRIORTY_7);
   self.InviteMailButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBRolloutEMailButton", textureSheet, nil, self.sendInviteMailTango, nil, nil, nil, nil, 20);
   self.InviteMailButton:setPriority(PRIORTY_7);

   -- Select All/Send buttons
   self.SelectAllTitle = self:addWidget(TextBox, self.mainLayer, 110, 324, 540, 140, '<c:1b354f>Select All<c>', self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.SelectAllTitle:setPriority(PRIORTY_6);
   self.SelectAllButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBChackAllBoxButton", textureSheet, nil, self.addAllSelection, nil, nil, nil, nil, 20);
   self.SelectAllButton:setPriority(PRIORTY_6);

   self.SendButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBSendButton", textureSheet, nil, self.sendInviteTango, nil, nil);
   self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "IBBackButton", textureSheet, nil, self.goBack, nil, nil);

   self.SendButton:setPriority(PRIORTY_6);

   -- push/pop state buttons
   self.BackButton:setPriority(PRIORTY_6);
   self.rollPivot = MOAITransform2D.new();

   -- reward counter
   self.RewardTitle = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IBReward", textureSheet, nil, nil, true);
   self.RewardTitle:setPriority(PRIORTY_6);
   self.RewardIcon = self:addWidget(Anim, self.mainLayer, REWARD_COUNT_X, REWARD_COUNT_Y, 0,0, "IBCoinReward", textureSheet, nil, nil, true);
   self.RewardIcon:setPriority(PRIORTY_6);
   self.RewardText = self:addWidget(TextBox, self.mainLayer, REWARD_COUNT_X+10, REWARD_COUNT_Y, 540, 140, ' ', self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.RewardText:setPriority(PRIORTY_7);

   self:_setupBasicResourceBar();

   -- create entry cache
   self:createRollOut();

   -- scrolling list
   self.ScrollList         = self:addWidget(       ScrollList,
                                                   self.mainLayer,
                                                   RANK_LiST_HOME_X, RANK_LiST_HOME_Y,
                                                   { {SWIPE_WIN_MIN_X, SWIPE_WIN_MAX_X},   {SWIPE_WIN_MIN_Y, SWIPE_WIN_MAX_Y} },
                                                   nil,
                                                   nil,
                                                   { 0, (1/40)*RANK_LiST_SPACING },
                                                   { nil, RANK_LiST_SPACING },
                                                   { 0, 1 },
                                                   nil,
                                                   { 100, 50 },
                                                   {0, RANK_LiST_SPACING},
                                                   nil,
                                                   { {-320, 200},  {SLIDE_MIN, SLIDE_MAX} },
                                                   nil, nil, nil, nil, nil, nil,
                                                   "ScrollBarButton", textureSheet, 12, 0, 145, PRIORTY_5 );
   self:createEntryCache();

end

----------------------------------------------------------------

function  StateInvite:onActivate()

   State.onActivate( self );

   localSelf = self;

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

end

----------------------------------------------------------------

function  StateInvite:onDeactivate()

   Base.onDeactivate(self);

end

----------------------------------------------------------------

function StateInvite:onFocus()

   Base.onFocus(self);

   self:createEntryList();
   self:createTangoMessage();
   self.ScrollList:setEntryCount(nil, #self.EntryList);
   self.ScrollList:setEntryData(self.EntryList);
   self.ScrollList:goToEntry(1);

   self.SelectAllMode = 'off';

   if not LoginMgr:isTango() or self.ListSize < 1 then
      self.RollOutActive = true;

      self.IconTryIn:disable()
      self.IconTryIn:setVisible(false);
      self.IconTryOut:enable();
      self.IconTryOut:setVisible(true);
      self.InviteSMSButton:enable();
      self.InviteMailButton:disable();
      self.rollPivot:setLoc(ROLLOUT_X, ROLLOUT_Y);
   else
      self.RollOutActive = false;

      self.IconTryIn:enable()
      self.IconTryIn:setVisible(true);
      self.IconTryOut:disable();
      self.IconTryOut:setVisible(false);
      self.rollPivot:setLoc(ROLLOUT_X-ROLLOUT_SHIFT, ROLLOUT_Y);
      self.InviteSMSButton:disable();
      self.InviteMailButton:disable();
   end

   if self:isValidFriendAvailable() then
      self.SelectAllButton:setAnimFrame();

      self:enableSelectAll(true);

      if LoginMgr:isTango() then

         if AbTestMgr:getInviteAutoSelectAll() == true then
            self:enableSend(true);
            self:addAllSelection();
         elseif     AbTestMgr:getInviteAutoSelectAll() == nil
                and string.lower(App.data:getValue("App.settings.invite-select-all", "auto")) == "auto" then

            self:enableSend(true);
            self:addAllSelection();
         else
            self:enableSend(false);
            self:updateRewardCount();
         end
      else
         self:enableSend(false);
         self:updateRewardCount();
      end
   else
      self:enableSelectAll(false);
      self:enableSend(false);
   end

   EventMgr:addListener( self, self.onNewPofilePicture, "new-profile-picture");

end

----------------------------------------------------------------

function StateInvite:onLoseFocus( )

   Base.onLoseFocus(self);

   EventMgr:rmvListener( self );

   self:hideRollOut();

end

----------------------------------------------------------------

function StateInvite:onUpdate( dt )

   Base.onUpdate( self, dt );

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateInvite:enableSelectAll( mode )

   if mode then
      self.SelectAllTitle:setVisible(true);
      self.SelectAllButton:setVisible(true);

      self.SelectAllButton:enable();
   else
      self.SelectAllTitle:setVisible(false);
      self.SelectAllButton:setVisible(false);

      self.SelectAllButton:disable();
   end

end

----------------------------------------------------------------

function StateInvite:enableSend( mode )

   if mode then
      self.SendButton:enable();
      self.SendButton:setColor(1.0, 1.0, 1.0, 1.0);
   else
      self.SendButton:disable();
      self.SendButton:setColor(0.2, 0.2, 0.2, 1.0);
   end

end

----------------------------------------------------------------

function StateInvite:isValidFriendAvailable()

   if ContactMgr:getFriendsCount() < 1 then
      return false;
   end

   if not self.EntryList then
      return false;
   else
      for i=1,#self.EntryList do
         if self.EntryList[i].used == 'Selected' or self.EntryList[i].used == false then
            return true;
         end
      end
   end

   return false;

end

----------------------------------------------------------------

function StateInvite:createTangoMessage()

   if (not LoginMgr:isTango() and ( MOAITangoSdk:tangoHasSdkSupport() or MOAIEnvironment.osBrand == "Android" ) ) or HACK_NO_AUTHENTICATION then

      if not self.EntryList then
         self.EntryList = {};
      end

      local t = {};

      t.tangoID       = "ConnectToTango";
      t.portrait      = "resources/UI/PlayerPortrait.png";
      t.name          = "";
      t.used          = true;

      table.insert(self.EntryList, t);
   end

end

----------------------------------------------------------------

function StateInvite:goTangoConnect()

   if MOAITangoSdk:tangoHasSdkSupport() then
      StateMgr:push("state/state-authenticate-confirm.lua");
   else
      installTango();
   end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateInvite:createRollOut()

   self.IconTry:setParent(self.rollPivot);
   self.IconTryIn:setParent(self.rollPivot);
   self.IconTryOut:setParent(self.rollPivot);
   self.InviteSMSButton:setParent(self.rollPivot);
   self.InviteMailButton:setParent(self.rollPivot);

   if not MOAIAppIOS.canSendText() then
      self.InviteSMSButton:setVisible(false);
   end

   --  if MOAIEnvironment.osBrand == "Android" then
   if true then
      self.InviteMailButton:setVisible(false);
   end

end

----------------------------------------------------------------

function StateInvite:hideRollOut()

   if self.RollOutActive then
      self.IconTryOut:disable();
      self.InviteSMSButton:disable();
      self.InviteMailButton:disable();

      self:waitHideRollOut();
   end

end

----------------------------------------------------------------

function StateInvite:waitHideRollOut()

   local action = self.rollPivot:moveLoc(-ROLLOUT_SHIFT, 0, 0.2, MOAIEaseType.EASE_IN);

   action:setListener(  MOAIAction.EVENT_STOP,
                        function()

                           self.rollPivot:setLoc(ROLLOUT_X-ROLLOUT_SHIFT, ROLLOUT_Y);

                           self.IconTryIn:enable();
                           self.IconTryIn:setVisible(true);
                           self.IconTryOut:setVisible(false);

                           self.RollOutActive = false;
                        end
   );
end

----------------------------------------------------------------

function StateInvite:showRollOut()

   if not self.RollOutActive then
      self.IconTryIn:disable();

      if MOAIAppIOS.canSendText() then
         self.InviteSMSButton:setVisible(true);
      end

      self:waitShowRollOut();
   end

end

----------------------------------------------------------------

function StateInvite:waitShowRollOut()

   local action = self.rollPivot:moveLoc(ROLLOUT_SHIFT, 0, 0.2, MOAIEaseType.EASE_IN);

   action:setListener(  MOAIAction.EVENT_STOP,
                        function()
                           self.rollPivot:setLoc(ROLLOUT_X, ROLLOUT_Y);

                           self.IconTryIn:setVisible(false);
                           self.IconTryOut:enable();
                           self.IconTryOut:setVisible(true);

                           if MOAIAppIOS.canSendText() then
                              self.InviteSMSButton:enable();
                           end

                           --  if MOAIEnvironment.osBrand ~= "Android" then
                           if false then
                              self.InviteMailButton:enable();
                           end

                           self.RollOutActive = true;
                        end
   );

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateInvite:updateRewardCount()

   local count  = 0;
   local reward = 0;

   for i=1,#self.EntryList do
      if self.EntryList[i].used == 'Selected' then
         count = count + 1;
      end
   end

   reward = count * App.data:getInviteRewardGold();

   if reward > 999999 then
      reward = 999999;
   end

   self.RewardText:setText('<c:f1f4f7>'..reward..'<c>');

end

----------------------------------------------------------------

function StateInvite:getMessageIndex()

   if MessageIndex == nil then

      local  inviteTemplates  = MessageMgr:getInviteTemplateList();

      if inviteTemplates then
         MessageIndex  = math.random( 1, #inviteTemplates );
      else
         MessageIndex  = nil;
      end
   end

   return MessageIndex;

end

----------------------------------------------------------------

function StateInvite:setPlayerName(  )

   self:createMsgTable();
   self:getMessageIndex();

end

----------------------------------------------------------------

function StateInvite:createMsgTable()

   self.Message_List = MessageMgr:getInviteTemplateList(  );

end

----------------------------------------------------------------

function StateInvite:createEntryCache()

   local connectText = '<c:6abffd>Play with your Tango\nfriends and get<c>';
   local bonus = App.data:getTangoBonus() or 5;

   self.ScrollList:setEntryObjectDataUpdateFunction(   function( data, object )

         object.banner:setVisible(true);
         object.picFrame:setVisible(true);
         object.portrait:setVisible(true);
         object.userName:setVisible(true);

         object.userName:setMetaFont("resources/font/Tango.otf", 16, data.name);
         object.userName:setText(data.name);

         if object.portrait:getImageName() ~= data.portrait then
            object.portrait:swapImage(data.portrait);
            object.portrait:setParent(object.banner.anim.root);
            object.portrait:setLoc(-240, 0);
            object.portrait:setPriority(PRIORTY_1);
         end

         if data.used then
            if data.used == 'Selected' then
               object.clock:setVisible(false);
               object.inputEmpty:setVisible(false);
               object.inputCheck:setVisible(true);
               object.inputEmpty:disable();
               object.inputCheck:enable();
            else
               object.clock:setVisible(true);
               object.inputEmpty:setVisible(false);
               object.inputCheck:setVisible(false);
               object.inputEmpty:disable();
               object.inputCheck:disable();
            end
         else
            object.clock:setVisible(false);
            object.inputEmpty:setVisible(true);
            object.inputCheck:setVisible(false);
            object.inputEmpty:enable();
            object.inputCheck:disable();
         end

         object.inputEmpty.onReleasedFunc =
            function ()
               self:addSelection(data, object)
            end;

         object.inputCheck.onReleasedFunc =
            function ()
               self:addSelection(data, object)
            end;

         if data.tangoID == "ConnectToTango" then
            object.picFrame:setVisible(false);
            object.portrait:setVisible(false);
            object.clock:setVisible(false);
            object.inputEmpty:setVisible(false);
            object.inputCheck:setVisible(false);
            object.tangoConnectText:setVisible(true);
            object.tangoGemIcon:setVisible(true);
            object.tangoConnectButton:setVisible(true);

            object.inputEmpty:disable();
            object.inputCheck:disable();
            object.tangoConnectButton:enable();
         else
            object.picFrame:setVisible(true);
            object.portrait:setVisible(true);
            object.tangoConnectText:setVisible(false);
            object.tangoGemIcon:setVisible(false);
            object.tangoConnectButton:setVisible(false);

            object.tangoConnectButton:disable();
         end

                                                       end
   );

   self.ScrollList:setEntryObjectLocUpdateFunction(    function( x, y, object )
         object.banner:setLoc(x,y);
                                                       end
   );

   self.ScrollList:setEntryObjectParentUpdateFunction(     function( target, object )
         object.banner:setParent(target);
                                                           end
   );

   self.ScrollList:setEntryCacheObjects(   nil,
                                           40,
                                           function()
                                              local tempTable = {};

                                              tempTable.banner        = self:addWidget(Anim, self.mainLayer, 0,0, 0,0, "Ranking", textureSheet);
                                              tempTable.picFrame  = self:addWidget(Image, self.mainLayer, -240, 0, PORTRAIT_FRAME_WIDTH, PORTRAIT_FRAME_HEIGHT, "resources/UI/PlayerPortraitRing.png");
                                              tempTable.portrait  = self:addWidget(Image, self.mainLayer, -240, 0, PORTRAIT_WIDTH, PORTRAIT_HEIGHT, "resources/UI/PlayerPortrait.png");
                                              tempTable.userName  = self:addWidget(TextBox, self.mainLayer, 10,0, 390, 96, '', self.defaultFontName, 20, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
                                              tempTable.clock         = self:addWidget(Anim, self.mainLayer, 0,0, 0,0, "BragClockButton", textureSheet);
                                              tempTable.inputEmpty    = self:addWidget(ButtonImage, self.mainLayer, 240, 0, 72, 68, "resources/UI/CheckBoxEmpty.png");
                                              tempTable.inputCheck    = self:addWidget(ButtonImage, self.mainLayer, 240, 0, 72, 68, "resources/UI/CheckBoxFilled.png");

                                              tempTable.tangoConnectText      = self:addWidget(   TextBox,
                                                                                                  self.mainLayer,
                                                                                                  0,
                                                                                                  0,
                                                                                                  540,
                                                                                                  140,
                                                                                                  connectText..'         '..bonus,
                                                                                                  self.defaultFontName, 16, nil,
                                                                                                  MOAITextBox.LEFT_JUSTIFY,
                                                                                                  MOAITextBox.CENTER_JUSTIFY
                                              );
                                              tempTable.tangoGemIcon          = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "BuyButtonGem", textureSheet, nil, nil, true);
                                              tempTable.tangoConnectButton    = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "TangoButton", textureSheet, nil, self.goTangoConnect, nil, nil);

                                              tempTable.tangoGemIcon:setScale(0.6, 0.6)
                                              tempTable.inputEmpty:setInputXtra(20, 10);
                                              tempTable.inputCheck:setInputXtra(20, 10);
															tempTable.inputEmpty:disable();
															tempTable.inputCheck:disable();

                                              tempTable.inputEmpty:setInViewTest(     function()
                                                    return self.ScrollList:isEntryCacheObjInView(tempTable.inputEmpty.prop);
                                                                                      end
                                              );
                                              tempTable.inputCheck:setInViewTest(     function()
                                                    return self.ScrollList:isEntryCacheObjInView(tempTable.inputCheck.prop);
                                                                                      end
                                              );

                                              tempTable.picFrame:setParent(tempTable.banner.anim.root);
                                              tempTable.portrait:setParent(tempTable.banner.anim.root);
                                              tempTable.userName:setParent(tempTable.banner.anim.root);
                                              tempTable.clock:setParent(tempTable.banner.anim.root);
                                              tempTable.inputEmpty:setParent(tempTable.banner.anim.root);
                                              tempTable.inputCheck:setParent(tempTable.banner.anim.root);
                                              tempTable.tangoConnectText:setParent(tempTable.banner.anim.root);
                                              tempTable.tangoGemIcon:setParent(tempTable.banner.anim.root);
                                              tempTable.tangoConnectButton:setParent(tempTable.banner.anim.root);

                                              tempTable.picFrame:setLoc(-240, 0);
                                              tempTable.portrait:setLoc(-240, 0);
                                              tempTable.userName:setLoc(10, 0);
                                              tempTable.clock:setLoc(240, 0);
                                              tempTable.inputEmpty:setLoc(240, 0);
                                              tempTable.inputCheck:setLoc(240, 0);
                                              tempTable.tangoConnectText:setLoc(0, 0);
                                              tempTable.tangoGemIcon:setLoc(-20, -20);
                                              tempTable.tangoConnectButton:setLoc(240, 0);

                                              tempTable.banner:setPriority(PRIORTY_0);
                                              tempTable.picFrame:setPriority(PRIORTY_1+1);
                                              tempTable.portrait:setPriority(PRIORTY_1);
                                              tempTable.userName:setPriority(PRIORTY_1);
                                              tempTable.clock:setPriority(PRIORTY_1);
                                              tempTable.inputEmpty:setPriority(PRIORTY_1);
                                              tempTable.inputCheck:setPriority(PRIORTY_1);
                                              tempTable.tangoConnectText:setPriority(PRIORTY_1);
                                              tempTable.tangoGemIcon:setPriority(PRIORTY_1);
                                              tempTable.tangoConnectButton:setPriority(PRIORTY_1);

                                              return tempTable;
                                           end
   );

end

----------------------------------------------------------------

function StateInvite:onNewPofilePicture()

   self:updatePortait();
   self.ScrollList:forceUpdateCacheToMap();

end

----------------------------------------------------------------

function StateInvite:updatePortait()

   if self.EntryList then
      for i,entry in ipairs(self.EntryList) do

         local profile = ContactMgr:findContact(entry.tangoID);
         if profile then
            local before   = entry.portrait;
            entry.portrait  =  ContactMgr:getContactPicture(profile)
               or "resources/UI/PlayerPortrait.png";

            if before ~= entry.portrait then

            end
         end
      end
   end

end

----------------------------------------------------------------

function StateInvite:createEntryList()

   Debug.assert( TimeMgr:getTimeGMT(), "StateInvite:createEntryList -> TimeMgr:getTimeGMT()" );

   self.EntryList = {};

   local list     = {};

   for i=1,ContactMgr:getFriendsCount() do

      local contact = ContactMgr:getFriend(i);

      if contact and not contact:isAppInstalled() then

         table.insert(list, contact);

      end
   end

   local ladderSize = #list;

   self.ListSize = ladderSize;
   self:setPlayerName();

   local timeTbl = App.data:getValue("App.settings.invite-cooldown") or {INVITE_TIME_LIMIT, INVITE_TIME_LIMIT, INVITE_TIME_LIMIT};
   local invCount;

   for i=1,ladderSize do

      local tempTable = {};

      if i <= #list then
         tempTable.tangoID      = list[i]:getAccountId();
         local profile        = ContactMgr:findContact(tempTable.tangoID);
         tempTable.portrait     =  ContactMgr:getContactPicture(profile)
            or "resources/UI/PlayerPortrait.png";
         tempTable.name          = '<c:d4e7f9>'..createUserNameDisplay(list[i]:getFirstName(), list[i]:getLastName(), true, "Friend", 19)..'<c>';
      else
         tempTable.tangoID       = nil;
         tempTable.portrait  = "resources/UI/PlayerPortrait.png";
         tempTable.name          = i..'';
      end

      if tempTable.tangoID then
         invCount = math.clamp(getCoolDownCount("Invite2Tracker", tempTable.tangoID) or 1, 1, #timeTbl);

         if isTimeInLim('Invite2', tempTable.tangoID, timeTbl[invCount], TimeMgr:getTimeGMT()) then
            tempTable.used = true;
         else
            tempTable.used = false;
         end
      else
         tempTable.used = false;
      end

      self.EntryList[i] = tempTable;
   end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateInvite:addSelection( data, object )

   if data.used == 'Selected' then
      data.used               = false;
      self.SelectAllMode  = 'off';

      object.inputEmpty:setVisible(true);
      object.inputCheck:setVisible(false);
      object.inputEmpty:enable();
      object.inputCheck:disable();
      self.SelectAllButton:setAnimFrame();
   else
      data.used               = 'Selected';

      object.inputEmpty:setVisible(false);
      object.inputCheck:setVisible(true);
      object.inputEmpty:disable();
      object.inputCheck:enable();
   end

   self:updateRewardCount();
   self:_updateSendSelectAllButton();

end

----------------------------------------------------------------

function StateInvite:addAllSelection( )

   local count = 0;

   if not self.EntryList then
      return false;
   end

   if self.SelectAllMode == 'off' then
      for i=1,#self.EntryList do
         if self.EntryList[i].used == false then
            self.EntryList[i].used = 'Selected';
            count = count + 1;
         end
      end

      self.SelectAllButton:setAnimLastFrame();
      self.SelectAllMode = 'on';
   else
      for i=1,#self.EntryList do
         if self.EntryList[i].used == 'Selected' then
            self.EntryList[i].used = false;
         end
      end

      self.SelectAllButton:setAnimFrame();
      self.SelectAllMode = 'off'
   end

   self:updateRewardCount();
   self:_updateSendSelectAllButton();

end

----------------------------------------------------------------

function StateInvite:_updateSendSelectAllButton()

   local validSelections = false;

   for k,v in ipairs(self.EntryList) do
      if v.used == false then
         self.SelectAllButton:setAnimFrame();
         self.SelectAllMode = "off";
      elseif v.used == "Selected" then
         validSelections = true;
      end
   end

   if validSelections and self.SelectAllMode ~= "off" then
      self.SelectAllButton:setAnimLastFrame();
      self.SelectAllMode = 'on';
   end

   if validSelections then
      self:enableSend(true);
   else
      self:enableSend(false);
   end

   if not self:isValidFriendAvailable() then
      self:enableSelectAll(false);
      self:enableSend(false);
   end

   self.ScrollList:forceUpdateCacheToMap();

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateInvite:sendInviteTango( )

   Debug.assert( TimeMgr:getTimeGMT(), "StateInvite:sendInviteTango() -> TimeMgr:getTimeGMT()" );

   local time              = TimeMgr:getTimeGMT();
   local inviteTemplates    = MessageMgr:getInviteTemplateList();

   if (not OnlineMgr:isOnline()) or ( not time )  or (not inviteTemplates) then

      MOAIDialogIOS.showDialog(     LocalizationMgr:getString( "NATIVE_CONNECT_ERROR" )
                                    ,  LocalizationMgr:getString( "DEFAULT_ERROR_NETWORK_MESSAGE" )
                                    ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                                    ,  nil
                                    ,  nil
                                    ,  false
                                    ,  function()
                                       end
      );

   else

      local reward          = App.data:getInviteRewardGold();
      local totalReward         = 0;
      local destList            = {};
      local invCount;

      self.SelectAllMode    = 'off'

      for i=1,#self.EntryList do
         if self.EntryList[i].used == 'Selected' then
            App.data:setValue("Invite2-"..self.EntryList[i].tangoID, time);
            App.data:inviteReward(self.EntryList[i].tangoID, reward, 0);

            self.EntryList[i].used  = true;
            totalReward                     = totalReward + reward;
            invCount                        = getCoolDownCount("Invite2Tracker", self.EntryList[i].tangoID);

            if not invCount then
               setCoolDownCount("Invite2Tracker", self.EntryList[i].tangoID, 1);
            else
               setCoolDownCount("Invite2Tracker", self.EntryList[i].tangoID, invCount+1);
            end

            table.insert( destList, ContactMgr:findContact(self.EntryList[i].tangoID) );
         end
      end

      if destList and #destList > 0 then

         local idx = self:getMessageIndex();

         if idx and idx >= 1 and idx <= #inviteTemplates then
            MessageMgr:sendInvite(  inviteTemplates[idx], destList, totalReward );
            EventMgr:postEvent( {  gold = totalReward, count=#destList }, "invite-tango-friend-success" );
         else
            Debug.assert(idx and idx >= 1 and idx <=  #inviteTemplates , "StateInvite:sendInviteTango -> idx : " .. tostring(idx) );
         end

      end

      self:updateRewardCount();
      self:_updateSendSelectAllButton();

      if self:isValidFriendAvailable() then
         self.SelectAllButton:setAnimFrame();

         self:enableSelectAll(true);
         self:enableSend(true);
      else
         self:enableSelectAll(false);
         self:enableSend(false);
      end
   end

end

----------------------------------------------------------------

function StateInvite:sendInviteSMSTango()

   local  inviteTemplates  = MessageMgr:getInviteTemplateList();

   if  (not inviteTemplates) then

      MOAIDialogIOS.showDialog(     LocalizationMgr:getString( "NATIVE_CONNECT_ERROR" )
                                    ,  LocalizationMgr:getString( "DEFAULT_ERROR_NETWORK_MESSAGE" )
                                    ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                                    ,  nil
                                    ,  nil
                                    ,  false
                                    ,  function()
                                       end
      );

   else

      local idx = self:getMessageIndex();

      if idx and idx >= 1 and idx <= #inviteTemplates then

         local msg = self.Message_List[idx].body         .. "\n\nApp Store:\n"   .. App.info.appStoreUrl
            .. "\n\nGoogle Play:\n" .. App.info.googlePlayUrl
            .. "\n\nAmazon:\n"      .. App.info.amazonStoreUrl;

         --Amazon doesnt like having other links
         if AmazonBillingProvider == true then
            msg = self.Message_List[idx].body         .. "\n\nAmazon:\n"      .. App.info.amazonStoreUrl;
         end

         if MOAIEnvironment.osBrand == "Android" then

            MOAIFlurry:event(  "Tango-Message", "ending", "unknown", "type",  "share" );
            MOAIFlurry:event(  "Tango-Share" );

            MOAIAppAndroid.share("Tell a friend","Enjoy playing Road Riot", msg);
         else

            MOAIFlurry:event(  "Tango-Message", "ending", "unknown", "type",  "sms" );
            MOAIFlurry:event(  "Tango-Sms" );

            MOAIAppIOS.sendText( msg );
         end

      else
         Debug.assert(idx and idx >= 1 and idx <=  #inviteTemplates , "StateInvite:sendInviteTango -> idx : " .. tostring(idx) );
      end

   end
end

----------------------------------------------------------------

function StateInvite:sendInviteMailTango()

   --[[ crashing
   local msg = self.Message_List[MessageIndex]  .. "\n\nApp Store:\n"   .. App.info.appStoreUrl
      .. "\n\nGoogle Play:\n" .. App.info.googlePlayUrl
      .. "\n\nAmazon:\n"      .. App.info.amazonStoreUrl;

   MOAIFlurry:event(  "Tango-Message", "ending", "unknown", "type",  "email" );
   MOAIFlurry:event(  "Tango-Email" );

   MOAIAppIOS.sendMail( msg );
   ]]

end

----------------------------------------------------------------

function StateInvite:goBack()

   InviteData  = false;
   GamePaused  = false;
   EventMgr:postEvent( {state="state/state-invite.lua"}, "game-unpaused" );
   StateMgr:pop();

end

----------------------------------------------------------------

return StateInvite;

----------------------------------------------------------------
