----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local BUTTON_X =
{
	-155,    155,
	-155,    155,
	-155,    155,
};

local BUTTON_Y =
{
	72,		72,
   -82,		-82,
   -240,		-240,
};

local SHOP_TRAY_HOME_X		= 0;
local SHOP_TRAY_HOME_Y		= 0;
local SHOP_TRAY_SHIFT		= 300;
local COIN_COUNT_X			= -143;
local COIN_COUNT_Y			= 437;
local GEM_COUNT_X				= 163;
local GEM_COUNT_Y				= 437;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

----------------------------------------------------------------

local Base						= State;
local StateKey					= Base:new();

----------------------------------------------------------------

function StateKey:onLoad()

   State.onLoad( self );

   self.defaultFontName      = "resources/font/TangoLatin.otf";
	local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
	local textureMain				= FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
    local popupTextureSheet = FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);

	-- background and icon
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "S_Background", textureSheet);

   self.Image = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "S_TitleBuyKey", textureSheet, nil, nil, true);
   self.Image:setPriority(PRIORTY_1);

   if StateMgr.headerAvailable then
      self.Title = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "TitleBuyKey", textureSheet, nil, nil, true);
      self.Title:setPriority(PRIORTY_2);
   end

   self:_setupResourceBar();

	-- push/pop state buttons
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "S_ReadyButton", textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
	self.BackButton:setPriority(PRIORTY_0);
   
   	-- earn keys button
--[[
    self.VideoButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "EarnKeys", textureMain, nil, self.goVideo, nil, nil );
	self.VideoButton:setPriority(PRIORTY_0);
]]--

   self.VideoButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, -151.05,-422.95,294,120, "BuyButton", popupTextureSheet, nil, self.goVideo, nil, nil);
    self.VideoButton:setScale(1.20,1.05);
    self.VideoButton:setPriority(PRIORTY_0);

   self.videoButtonTextShd = self:addWidget(TextBox, self.mainLayer, -190.05-2, -422.95-2, 360, 220, "FREE", self.defaultFontName, 26, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.videoButtonTextShd:setPriority(PRIORTY_3);
   self.videoButtonTextShd:setColor(0,0,0);

   self.videoButtonText = self:addWidget(TextBox, self.mainLayer, -190.05, -422.95, 360, 220, "FREE", self.defaultFontName, 26, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.videoButtonText:setPriority(PRIORTY_4);

   self.videoButtonIcon = self:addWidget(ButtonImage, self.mainLayer, -85,-422.95, 61, 61, "resources/videoIcon.png", nil, nil)
   self.videoButtonIcon:setPriority(PRIORTY_0);
   self.videoButtonIcon:setVisible(true);

	-- purchase buttons and text
	self.ValueButton	= {};
	self.OfferText		= {};
	self.OfferTextSdw	= {};
	self.PriceText		= {};
	self.PriceTextSdw	= {};
	self.ValueIndex	= nil;

	for i=1,6 do
		
		local amount	= App.data:getStoreKeyAmount(i);
		local cost		= App.data:getStoreKeyCost(i);
		local offerText;
      local priceText;

      offerText = getFormattedNumber(amount) .. " Keys";
      priceText = cost.gem .. " Gem"; -- s is appended below if plural
      
      if cost.gem > 1 then
         priceText = priceText .. "s";
      end

		self.ValueButton[i]	= self:addWidget	(		ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "S_Slot"..i, textureSheet, nil,
																	function ()
																		self:goPurchase(i);
																	end,
																	nil, nil
															);

		self.OfferText[i]		= self:addWidget(		TextBox, self.mainLayer, 134+0, 20, 300, 130, offerText, self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
		self.OfferTextSdw[i]	= self:addWidget(		TextBox, self.mainLayer, 134+2, 20-2, 300, 130, offerText, self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0, 0, 0, 1} );
      
		self.OfferText[i]:setParent(self.ValueButton[i].anim.props[3]);
		self.OfferTextSdw[i]:setParent(self.ValueButton[i].anim.props[3]);
      
		self.PriceText[i]		= self:addWidget(		TextBox, self.mainLayer, 134+0, -25, 300, 130, priceText, self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0.7, .9, .99} );
		self.PriceTextSdw[i]	= self:addWidget(		TextBox, self.mainLayer, 134+2, -25-2, 300, 130, priceText, self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0, 0, 0, 1} );
		
		self.PriceText[i]:setParent(self.ValueButton[i].anim.props[3]);
		self.PriceTextSdw[i]:setParent(self.ValueButton[i].anim.props[3]);

		self.ValueButton[i]:setPriority(PRIORTY_0);
		self.OfferText[i]:setPriority(PRIORTY_1);
		self.OfferTextSdw[i]:setPriority(PRIORTY_1-1);
		self.PriceText[i]:setPriority(PRIORTY_1);
		self.PriceTextSdw[i]:setPriority(PRIORTY_1-1);
	end

end

----------------------------------------------------------------

function StateKey:onActivate()

	State.onActivate(self);

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
      self.resourceBar:setConsumableCallback(   nil,
                                                function()
                                                   StateMgr:swap("state/state-consumable.lua");
                                                end
                                             );
   end

end

----------------------------------------------------------------

function StateKey:onFocus()

   State.onFocus( self );
	  
	self:resetAllButtons();
   
   self:videoButtonSetup();
   
   if self.VideoButton and not self.videoEnabled then
      self.VideoButton:setVisible(false);
      self.VideoButton:disable();
   else
      self.VideoButton:setVisible(true);
      self.VideoButton:enable();
   end

end

----------------------------------------------------------------

function StateKey:onLoseFocus( )

   Base.onLoseFocus(self);
   
end

------------------------------------------------------------------------------------

function StateKey:videoButtonSetup()

   self.videoEnabled = false;

   if App:isVideoRewardEnabled() then
      local limit = AbTestMgr:getVideoMapLimit( );
      if limit then
         if limit > 0 then
            local reward = AbTestMgr:getVideoMapKeys();

            self.videoEnabled = (reward) and (reward > 0);
         end
      end
   end

end

----------------------------------------------------------------

function StateKey:_setupResourceBar(  )

   self.resourceBar = ResourceBar:new( self, 0, self:_calcHeaderLocY(), self.mainLayer, self.mainPartition  );

   self.resourceBar:setGoldCallback(
      nil
   ,
      function()
         StateMgr:swap("state/state-coin.lua");
      end
   );

   self.resourceBar:setGemCallback(
      nil
   ,
      function()
         StateMgr:swap("state/state-gem.lua");
      end
   );

   self.resourceBar:setKeyCallback(
         nil
      ,
         function()
         end
   );

end


----------------------------------------------------------------

function StateKey:resetAllButtons()

	for i=1,6 do
		self.ValueButton[i]:setAnimFrame();
		self.ValueButton[i]:enable();
	end

end

----------------------------------------------------------------

function StateKey:goPurchase( index )

	
	local gemCount		= App.data:getGemCount();
	local cost			= App.data:getStoreKeyCost(index);

	if cost.gem > gemCount then

      AUTO_PURCHASE_DATA.state      = 'StateKey';
      AUTO_PURCHASE_DATA.carIndex   = ""..-1;
      AUTO_PURCHASE_DATA.reason1		= 'Key-Store';
      AUTO_PURCHASE_DATA.reason2		= 'Key-Store-'..index;
      AUTO_PURCHASE_DATA.currency	= 'Key';
      AUTO_PURCHASE_DATA.price		= App.data:getStoreKeyAmount(index) + App.data:getKeyCount();
		AUTO_PURCHASE_FUNC				=	function()
													end
		StateMgr:push("state/state-auto-purchase-popup-maz.lua");
	else

		STORE_PURCHASE_DATA.currency	= 'Key';
		STORE_PURCHASE_DATA.index		= index;
	
		StateMgr:push("state/state-storebuy-confirm.lua");
	end

end

----------------------------------------------------------------

function StateKey:goCoinStore()

	print("Go To Coin Store");
	
	StateMgr:push("state/state-coin.lua");

end

----------------------------------------------------------------

function StateKey:goGemStore()

	print("Go To Gem Store");
	
	StateMgr:push("state/state-gem.lua");

end

----------------------------------------------------------------

function StateKey:goVideo()

   if self:isVideoRewardReady() then
      StateMgr:swap("state/state-video-play.lua", {rewardType="key", rewardAmount=AbTestMgr:getVideoMapKeys( ) or 1} );
   else
      PromoMgr:createPopup( "keyPageStore" );
      self:goBack();
   end

end

----------------------------------------------------------------

function StateKey:goBack()

	StateMgr:pop();

end

----------------------------------------------------------------

return StateKey;

----------------------------------------------------------------
