----------------------------------------------------------------

require('flash/flash-manager')
require('state/state')
require('engine/texture/texture-manager')
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SHOP_TRAY_HOME_X		= 0;
local SHOP_TRAY_HOME_Y		= 0;
local SHOP_TRAY_SHIFT		= 300;
local COIN_COUNT_X			= -143;
local COIN_COUNT_Y			= 437;
local GEM_COUNT_X				= 163;
local GEM_COUNT_Y				= 437;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;

----------------------------------------------------------------

local Base              = State;
local StateMissionPopup     = Base:new();

local FPS = 30;

local textLoc = {
                           { text1={x=60,y=151}, text2={x=60,y=111}, textcenter={x=60,y=131} },
                           { text1={x=60,y=21}, text2={x=60,y=-19}, textcenter={x=60,y=1} },
                           { text1={x=60,y=-109}, text2={x=60,y=-149}, textcenter={x=60,y=-129} },
                        };

local animLength = 100.8/FPS;
local maxMissions = #TEMPLATE_MISSION_LIST_01;
local screenWidth = App.viewportWidth;
local screenHeight = App.viewportHeight;
local textOffsetX = 60;
local textOffsetY = 230;
local bannerDeltaY = -130;


----------------------------------------------------------------

function  StateMissionPopup:onLoad(  )

   State.onLoad( self );
	localSelf      = self;
	
   self.defaultFontName = "resources/font/TangoLatin.otf";
	local textureSheet      = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

	self.textureSheet      = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", FPS);

   self.title              = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "M_TitleMission", self.textureSheet, nil, nil, true);
   self.title:setPriority(PRIORTY_8);

   self:_setupBasicResourceBar();

	self:createProps();
	self:createSecondaryProps();
	
end


----------------------------------------------------------------

function  StateMissionPopup:onActivate(  )

   Base.onActivate( self );
   
   LoaderMgr:addTask(  nil, self, function () StateMgr:loadState ( "state/state-missionskip-confirm.lua" ) end );
	
	self:updateProps();
	self:updateSecondaryProps();

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

end

----------------------------------------------------------------

function  StateMissionPopup:onDeactivate(  )

   Base.onDeactivate( self );

   if self.missionData then

      EventMgr:postEvent( {  gem=self.missionReward.gem }, "mission-reward" );

      self.missionData = false;

   end

end


------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateMissionPopup:setShopTrayHeight()

	local aspect = App.viewportHeight/App.viewportWidth;
	
	if aspect > 1.76 then
		
		COIN_COUNT_Y	= 525;
		GEM_COUNT_Y		= 525;
		
		self.ShopBarBackDrop:setVisible(false);
		
	end

end
----------------------------------------------------------------

function  StateMissionPopup:createProps(  )

	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.75});
	
   self.background = self:addWidget(Anim, self.mainLayer, 0, 0, 0, 0, "M_MissionPopUpBackDrop", self.textureSheet);
   self.background:setPriority(PRIORTY_0);
	
   self.bluebox = self:addWidget(Anim, self.mainLayer, 0, 0, 0, 0, "M_BlueBox", self.textureSheet);
   self.bluebox:setPriority(PRIORTY_0);
	
   self.backButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "M_ReadyButton", self.textureSheet, nil, self.goBack, nil, nil);
   self.backButton:setPriority(PRIORTY_3);
	
	self.rubyIcon = self:addWidget(Anim, self.mainLayer, 0, 0, 0, 0, "M_GemReward", self.textureSheet, nil, nil, true);
	self.rubyIcon:setPriority(PRIORTY_3);
   
   self.missionNumber = self:addWidget( TextBox, self.mainLayer,
                                          -232.7, 288.95, 140, 100, 
                                          "", self.defaultFontName, 26, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {0,0,0,1}
                                          );
   self.missionNumber:setPriority(PRIORTY_3);

	self.rewardText = self:addWidget( TextBox, self.mainLayer,
                                          5, 255.55, 350, 100, 
                                          "REWARD:", self.defaultFontName, 20, nil,
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.rewardText:setPriority(PRIORTY_4);
	
	self.rubyText = self:addWidget( TextBox, self.mainLayer,
                                          73, 255.55, 150, 100, 
                                          "", self.defaultFontName, 26, nil,
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.rubyText:setPriority(PRIORTY_4);

											         
   self.skipButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "M_SkipButton", self.textureSheet, nil, self.skipMissionConfirm, nil, nil);
   self.skipButton:setColor( 0.25, 0.25, 0.25, 1  )
   self.skipButton:disable();
	self.skipButton:setPriority(PRIORTY_3);
	
   self.goal = {};
	
	for i=1,3 do
	
		self.goal[i] = {};
		self.goal[i].box = {};
      self.goal[i].bar = {};
		
		
      self.goal[i].box.anim = self:addWidget( Anim, self.mainLayer, 0, 0, 0, 0, "M_MissionBanner0".. i, self.textureSheet );
      self.goal[i].box.anim:setPriority(PRIORTY_3);
		
      self.goal[i].bar.anim = self:addWidget( Anim, self.mainLayer, 0, 0, 0, 0, "M_MissionProgressBar0".. i, self.textureSheet );
      self.goal[i].bar.anim:setPriority(PRIORTY_5);
		self.goal[i].bar.anim:setSpeed(5);
		
      local glText1, glText2, textX, textY, boxW, boxH;
		
		textX = textLoc[i].text1.x;
		textY = textLoc[i].text1.y;
		boxW = 365;
		boxH = 60;
		
		self.goal[i].text1 = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
		self.goal[i].text1:setPriority(PRIORTY_4);
		
		textX = textLoc[i].text2.x;
		textY = textLoc[i].text2.y;
		
		self.goal[i].text2 = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
                                          

		self.goal[i].text2:setPriority(PRIORTY_4);

		
		self.goal[i].text2Timer = self:addWidget( TextBox, self.mainLayer,
                                          textX+50, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
                                          

		self.goal[i].text2Timer:setPriority(PRIORTY_4);
		

		
		textX = textLoc[i].textcenter.x;
		textY = textLoc[i].textcenter.y; 
		boxW = 365;
		boxH = 80;
		
		self.goal[i].text = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
                                          
		self.goal[i].text:setPriority(PRIORTY_4);
		
	end
	
	--mission over screen

   self.missionOverText = self:addWidget(  TextBox, self.mainLayer,
                                       0, 0,
                                       640, 960,
                                       "All Missions Complete!", self.defaultFontName, 36, nil,
                                       MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                       {1,1,1,1}
                                    );
   self.missionOverText:setPriority(70);

   -- tap screen Button
   self._guideScrnButton	= self:addWidget(ButtonImage, self.mainLayer, 0,0, 1400, 1200, "resources/square.png", nil, nil, nil, nil);
   self._guideScrnButton:setPriority(0);
   self._guideScrnButton:setColor(1,1,1,0);

end

----------------------------------------------------------------

function  StateMissionPopup:createSecondaryProps(  )
	
   self.goal2 = {};
	
	for i=1,3 do
	
		self.goal2[i] = {};
		self.goal2[i].box = {};
      self.goal2[i].bar = {};
		
		
      self.goal2[i].box.anim = self:addWidget( Anim, self.mainLayer, 0, 0, 0, 0, "M_MissionBanner0".. i, self.textureSheet );
      self.goal2[i].box.anim:setPriority(PRIORTY_3);
		
      self.goal2[i].bar.anim = self:addWidget( Anim, self.mainLayer, 0, 0, 0, 0, "M_MissionProgressBar0".. i, self.textureSheet );
      self.goal2[i].bar.anim:setPriority(PRIORTY_5);
		
      local glText1, glText2, textX, textY, boxW, boxH;
		
		textX = textLoc[i].text1.x;
		textY = textLoc[i].text1.y;
		boxW = 365;
		boxH = 60;
		
		self.goal2[i].text1 = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
		self.goal2[i].text1:setPriority(PRIORTY_4);
		
		textX = textLoc[i].text2.x;
		textY = textLoc[i].text2.y;
		
		self.goal2[i].text2 = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
                                          

		self.goal2[i].text2:setPriority(PRIORTY_4);
		
		textX = textLoc[i].textcenter.x;
		textY = textLoc[i].textcenter.y; 
		boxW = 365;
		boxH = 80;
		
		self.goal2[i].text = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil,
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
                                          
		self.goal2[i].text:setPriority(PRIORTY_4);
		
	end
	
	--mission over screen

   self.missionOverText2 = self:addWidget(  TextBox, self.mainLayer,
                                       0, 0,
                                       640, 960,
                                       "All Missions Complete!", self.defaultFontName, 36, nil,
                                       MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                       {1,1,1,1}
                                    );
   self.missionOverText2:setPriority(70);


end

----------------------------------------------------------------

function  StateMissionPopup:resetProps(  )

	self.barAnimList = {};
   self.boxAnimList = {};
	
	
	for i=1,3 do
		self.goal[i].bar.anim:setAnimFrame(0);
		self.goal[i].bar.anim:setVisible(true);
		self.goal[i].bar.anim:setPriority(PRIORTY_5);
		self.goal[i].bar.anim:setLoc(0,0);
		self.goal[i].box.anim:setAnimFrame(0);
		self.goal[i].box.anim:setPriority(PRIORTY_4);
		self.goal[i].box.anim:setLoc(0,0);
		self.goal[i].box.anim:setVisible(true);
		self.goal[i].text:setText("");
		self.goal[i].text:setLoc(textLoc[i].textcenter.x,textLoc[i].textcenter.y);
		self.goal[i].text1:setText("");
		self.goal[i].text1:setLoc(textLoc[i].text1.x,textLoc[i].text1.y);
		self.goal[i].text2:setText("");
		self.goal[i].text2:setLoc(textLoc[i].text2.x,textLoc[i].text2.y);
		self.goal[i].text2Timer:setText("");
		self.goal[i].text2Timer:setLoc(textLoc[i].text2.x+50,textLoc[i].text2.y);
	end
	

	
	self.rubyText:setText("");
	self.missionNumber:setText("");
	
	
	if self.fadingIn then
		self.rubyText:setColor(1,1,1,0);
		self.missionNumber:setColor(0,0,0,0);
	else
		self.rubyText:setColor(1,1,1,1);
		self.missionNumber:setColor(0,0,0,1);
	end

	if not self.missionTpl.final then
		self.rubyIcon:setVisible(true);
		self.rubyIcon:setColor(1,1,1,1);
		self.rewardText:setVisible(true);
		self.rewardText:setColor(1,1,1,1);
	end
	


	


end

----------------------------------------------------------------

function  StateMissionPopup:resetSecondaryProps(  )
	
	for i=1,3 do
	
		self.goal2[i].box.anim:setLoc( (screenWidth * -1), 0 );
		self.goal2[i].bar.anim:setLoc( (screenWidth * -1), 0 );
		
		self.goal2[i].text:setText("");
		self.goal2[i].text:setLoc( textLoc[i].textcenter.x - screenWidth, textLoc[i].textcenter.y );
		self.goal2[i].text1:setText("");
		self.goal2[i].text1:setLoc( textLoc[i].text1.x - screenWidth, textLoc[i].text1.y );
		self.goal2[i].text2:setText("");
		self.goal2[i].text2:setLoc( textLoc[i].text2.x - screenWidth, textLoc[i].text2.y );
		self.missionOverText2:setLoc(-screenWidth,0);
	end


end
----------------------------------------------------------------

function  StateMissionPopup:updateProps( )
	
	self.curMI = App.data:getMissionIndex();

   self.missionTpl    = App.data:getCurrentMissionTemplate( );
   self.missionReward = App.data:getCurrentMissionReward();
	
	self:resetProps();

   self.animCount = 0;
   self.barsDone = false;
   self.boxesDone = false;
   self.aBoxes = 0;
   self.delay = 0;
   self.missionComplete = false;
   self.missionGraphics = false;
   self.waitForReload = false;
   self.missionsMaxed = false;
   self.skipBackDone = false;
   self.animsCalled = false;
	self.missionData = false;
	self.skipData = false;
	self.timerTable = {};
	self.goalsMoving = false;
	self.moving = { 0, 0.5, 1.0 };
	self.soundStarted = {false,false,false};
	self.boxSoundStarted = {true,true,true};
	self.missionFadeTime = 0.5;
	self.missionFadeTimer = self.missionFadeTime;
	self.missionFadeInTime = 0.5;
	self.missionFadeInTimer = self.missionFadeInTime;
	
	self.doneMoving = { false, false, false, false, false, false, false, false };

	
   if self.missionTpl.final then
      self.missionsMaxed = true;
		self.rubyIcon:setVisible(false);
		self.rewardText:setVisible(false);
      self.missionNumber:setGlyphScale(1);
		self.missionNumber:setText("--");
		self.missionOverText:setVisible(true);
		for i=1,3 do
			self.goal[i].bar.anim:setPriority(0);
			self.goal[i].box.anim:setPriority(0);
		end
      self:missionOverScreen();
      return;
   else
		self.missionOverText:setVisible(false);
	end
	
	--set mission # text
   if tostring(self.missionTpl.name) and tonumber(self.missionTpl.name) then
      self.missionNumber:setText(tostring(self.missionTpl.name));
      if tonumber(self.missionTpl.name) < 100 then
         self.missionNumber:setGlyphScale(1);
      elseif tonumber(self.missionTpl.name) < 1000 then
         self.missionNumber:setGlyphScale(0.85);
      elseif tonumber(self.missionTpl.name) < 10000 then
         self.missionNumber:setGlyphScale(0.65);
      end
   end

	--set ruby text
	self.rubyText:setText(tostring(self.missionReward.gem).." x");

	
   for i=1,3 do
	
      self.goal[i].cumulativeScore = App.data:getCurrentMissionGoalProgress( i )
      if self.goal[i].cumulativeScore == nil then
         self.goal[i].cumulativeScore = 0;
      end
         
      self.goal[i].lastSeen = App.data:getValue( "curGoal".. i );
      if self.goal[i].lastSeen == nil then
         self.goal[i].lastSeen = 0;
		end
		
      self.goal[i].objective = self.missionTpl.goals[i].objective;
      self.goal[i].cumulative = self.missionTpl.goals[i].cumulative;
		
		if self.goal[i].lastSeen == -1 and self.goal[i].cumulativeScore == 0 then
			self.goal[i].lastSeen = 0;
			App.data:setValue( "curGoal".. i, 0 );
		end

      if not self.goal[i].cumulative then
         if self.goal[i].lastSeen > 0 then
				self.goal[i].lastSeen = 0;
         end
      end

		self.goal[i].displayScore = math.floor(App.mission.goals[i].cumulativeScore);
		
		if self.goal[i].displayScore == nil or not self.goal[i].cumulative then
			self.goal[i].displayScore = 0;
		end
		
		if self.goal[i].displayScore > 0 then
			--set up the goal text
			local pText1, pText2;
      
			if self.missionTpl.goals[i].hideNum then
				pText1 = "";
			else
				pText1 = tostring(self.goal[i].displayScore).."/"..tostring(self.goal[i].objective);
			end
		
			if self.missionTpl.goals[i].twoLinePause then
         
				pText1 = pText1.. " ".. self.missionTpl.goals[i].pauseText1;
				pText2 = self.missionTpl.goals[i].pauseText2;
			
				self.goal[i].text1:setText(pText1);

				self.goal[i].text2:setText(pText2);
			
			else
			
				pText1 = pText1.. " ".. self.missionTpl.goals[i].pauseText;
			
				self.goal[i].text:setText(pText1);
		
			end
		else
		
			local glText1, glText2;
		
			if self.missionTpl.goals[i].twoLine then
		
				glText1 = self.missionTpl.goals[i].text1
				glText2 = self.missionTpl.goals[i].text2
			
				--set text for textbox 1
				self.goal[i].text1:setText(glText1);
			
				--set text for textbox 2
				self.goal[i].text2:setText(glText2);
			else
				glText = self.missionTpl.goals[i].text
			
				--set text for textbox
				self.goal[i].text:setText(glText);
			end
		end
		
		
		-- timed quest text setup
		self:timerCheck(i);
		
		
      if self.goal[i].lastSeen > 0 then
         self.goal[i].bar.startSpan = animLength * ( self.goal[i].lastSeen/self.goal[i].objective );
      else
         self.goal[i].bar.startSpan = 0;
      end
      
      if self.goal[i].cumulativeScore > 0 then
         self.goal[i].bar.endSpan = animLength * ( self.goal[i].cumulativeScore/self.goal[i].objective );
      else
         self.goal[i].bar.endSpan = animLength;
      end
		
      self.goal[i].bar.anim:setSpan( self.goal[i].bar.startSpan, self.goal[i].bar.endSpan ); 
      
      if self.goal[i].lastSeen == -1 then
      
      --they've completed the goal, and already seen it animate.
         
         self.goal[i].bar.anim:setVisible(false);
			self.goal[i].bar.anim:setPriority(0);
         self.goal[i].box.anim:setAnimFrame(2);
			
      elseif self.goal[i].cumulativeScore == -1 and self.goal[i].lastSeen ~= -1 then
      
      --check the boxes off and animate the bar if they've completed a quest
         self.barAnimList[i] = self.goal[i].bar.anim;
         self.boxAnimList[i] = self.goal[i].box.anim;
         self.animCount = self.animCount + 1;
         self.aBoxes    = self.aBoxes + 1;
         self.goal[i].bar.anim:setSpan( self.goal[i].bar.startSpan, self.goal[i].bar.startSpan );
         self.goal[i].bar.anim:start();
			self.boxSoundStarted[i] = false;
			
      elseif self.goal[i].lastSeen < self.goal[i].cumulativeScore and self.goal[i].cumulative then
      --per maz, no movement on bars if mission is not cumulative
      -- goal isn't complete and they've made progress since last opening the screen, add to anim list
         
         self.barAnimList[i] = self.goal[i].bar.anim;
         self.animCount = self.animCount + 1;
         self.goal[i].bar.anim:setSpan( self.goal[i].bar.startSpan, self.goal[i].bar.startSpan );
         self.goal[i].bar.anim:start();
         
      else
      
      --nothing has changed since last time. set it to it's start position, and leave it
         self.goal[i].bar.anim:setSpan( self.goal[i].bar.startSpan, self.goal[i].bar.startSpan );
         self.goal[i].bar.anim:setTime( self.goal[i].bar.startSpan );
         self.goal[i].bar.anim:start();
         
      end
      
   end
   
   if self.animCount == 0 then
      self.barsDone = true;
      self:skipReadyCheck();
   end
   

	if App.data:isCurrentMissionCompleted() then
		self.missionComplete = true;
   end
   
   self.missionGraphics = true;

end

----------------------------------------------------------------

function  StateMissionPopup:updateSecondaryProps( )

   self.missionTpl2 = App.data:getMissionTemplate( (self.curMI + 1) )
	
	self:resetSecondaryProps();

   if self.missionTpl2 and self.missionTpl2.final then

		self.missionOverText2:setVisible(true);
		for i=1,3 do
			self.goal2[i].bar.anim:setPriority(0);
			self.goal2[i].box.anim:setPriority(0);
		end
      return;
   else
		self.missionOverText2:setVisible(false);
	end
	
	
	local glText1, glText2;
	
   for i=1,3 do

      if self.missionTpl2 then
         if self.missionTpl2.goals[i].twoLine then
         
            glText1 = self.missionTpl2.goals[i].text1
            glText2 = self.missionTpl2.goals[i].text2
            
            --set text for textbox 1
            self.goal2[i].text1:setText(glText1);
            
            --set text for textbox 2
            self.goal2[i].text2:setText(glText2);
         else
            glText = self.missionTpl2.goals[i].text
            
            --set text for textbox
            self.goal2[i].text:setText(glText);
         end
		else
         self.goal2[i].text:setText("");
      end

	end
		


end

----------------------------------------------------------------

function  StateMissionPopup:transitionGoals( dt  )
									
	self:fadeMission(dt);	
		
--move goal bars

	for i=1,3 do
		if self.moving[i] <= 0 then
		
			local x,y = self.goal[i].box.anim:getLoc();
			
			if x < screenWidth then
				self:slideOver( self.goal[i].box.anim, dt );
				self:slideOver( self.goal[i].text, dt );
				self:slideOver( self.goal[i].text1, dt );
				self:slideOver( self.goal[i].text2, dt );
				self:slideOver( self.goal[i].text2Timer, dt );
			else
				self.doneMoving[i] = true;
				if not self.soundStarted[i] then
					self.soundStarted[i] = true;
					local sSound = {start={"NewGoalSlide",},};
					EventMgr:postEvent( { sounds=sSound, name="missionpopup transitionGoals",}, "add-sfx" );
				end
			end
			
			local x2,y2 = self.goal2[i].box.anim:getLoc();

			if x2 < 0 then
				self:slideOver( self.goal2[i].box.anim, dt );
				self:slideOver( self.goal2[i].bar.anim, dt );
				self:slideOver( self.goal2[i].text, dt );
				self:slideOver( self.goal2[i].text1, dt );
				self:slideOver( self.goal2[i].text2, dt );
				if i==3 then
					self:slideOver( self.missionOverText2, dt );
				end
			else
				self.goal2[i].box.anim:setLoc( 0, 0);
				self.goal2[i].bar.anim:setLoc( 0, 0);
				self.goal2[i].text:setLoc( textLoc[i].textcenter.x, textLoc[i].textcenter.y);
				self.goal2[i].text1:setLoc( textLoc[i].text1.x, textLoc[i].text1.y );
				self.goal2[i].text2:setLoc( textLoc[i].text2.x, textLoc[i].text2.y);
				if i==3 then
					self.missionOverText2:setLoc(0,0);
				end
				self.doneMoving[i+3] = true;
			end
			
		else
			self.moving[i] = self.moving[i] - dt;
		end
	end

--check for all sections moved

	local doneCount = 0;
			
	for j=1,6 do
		if self.doneMoving[j] then
			doneCount = doneCount + 1;
			if doneCount >= 6 then
				self.goalsMoving = false;
				self.fadingIn = true;
				self:updateProps( );
				self:updateSecondaryProps( );
				for s=1,3 do
					self.soundStarted[s] = false;
				end
			end
		end
	end
	
end

----------------------------------------------------------------

function  StateMissionPopup:slideOver( obj, dt )

	local moveRate = screenWidth/0.2;
	
	local x,y = obj:getLoc();
	obj:setLoc( x+(moveRate*dt), y );

end

----------------------------------------------------------------

function  StateMissionPopup:fadeMission( dt )

	if self.missionFadeTimer > 0 then
		self.missionFadeTimer = self.missionFadeTimer-dt;
		local perc = self.missionFadeTimer/self.missionFadeTime;
		if self.missionFadeTimer < 0 or perc < 0 then
			perc = 0;
		end
		
		self.missionNumber:setAlpha(perc);
		self.rubyText:setAlpha(perc);
		if self.missionTpl2.final then
			self.rewardText:setAlpha(perc);
			self.rubyIcon:setColor( 1, 1, 1, perc )
		end
	end
	
end

----------------------------------------------------------------

function  StateMissionPopup:fadeInMission( dt )

	if self.missionFadeInTimer > 0 then
		self.missionFadeInTimer = self.missionFadeInTimer-dt;
		local perc = 1 - (self.missionFadeInTimer/self.missionFadeInTime);
		if self.missionFadeInTimer > 1 or perc > 1 then
			perc = 1;
		end
		
		self.missionNumber:setAlpha(perc);
		self.rubyText:setAlpha(perc);

	else
		self.fadingIn = false;
	end
	
end

----------------------------------------------------------------

function  StateMissionPopup:onFocus(  )

   Base.onFocus( self );

   self:disableGuideScrnButton();

end


----------------------------------------------------------------

function StateMissionPopup:onLoseFocus()

   State.onLoseFocus(self);

end

----------------------------------------------------------------

function onLoaderDone( loader )


end

----------------------------------------------------------------

function  StateMissionPopup:onUpdate( dt )

   Base.onUpdate(self,dt);

	if #self.timerTable > 0 then
		self:missionTimer(dt);
	end
	
	if self.goalsMoving then
		self:transitionGoals(dt);
	end
	
	if self.fadingIn then
		self:fadeInMission( dt )
	end

   if self.delay > 0 then

      self.delay = self.delay - dt;
      if self.delay <= 0 then
         self.delay = 0;
      end
		
   elseif self.missionComplete then
	
		self.missionComplete = false;
      self.waitForData = true;
   
      App.data:nextMission(false )
      
      self:nextMissionSuccess();

      
   elseif self.animCount > 0 and not self.animsCalled then
      for i,v in pairs (self.barAnimList) do
         v:setSpan( self.goal[i].bar.startSpan, self.goal[i].bar.endSpan );
         v:setListener(MOAIAction.EVENT_STOP,
				function ()
               if self.boxAnimList[i] then
                  self.boxAnimList[i]:setListener(MOAIAction.EVENT_STOP, 
                     function () 
                        self.aBoxes = self.aBoxes - 1;
								if not self.boxSoundStarted[i] then
									self.boxSoundStarted[i] = true;
									local sSound = {start={"CheckBox",},};
									EventMgr:postEvent( { sounds=sSound, name="missionpopup transitionGoals",}, "add-sfx" );
								end
								
                     end
                     );
						self.boxAnimList[i]:setAnimFrame(2)
                  self.boxAnimList[i]:start();

                  v:setVisible(false);
                  v:setPriority(0);
                  self.animCount = self.animCount - 1;
               end
               if not self.barsDone then
                  self.barsDone = true;
                  if not self.waitForData then
                     self:skipReadyCheck();
                  end
                  self.delay = 0.25;
               end
				end
            );
         v:start();
      end
      self.animsCalled = true;
      
   elseif not self.barsDone or self.aBoxes > 0 then
   
   
   elseif self.missionSkipBack then
      
      self.missionSkipBack = false;
      self:skipMission();
      self.skipBackDone = true;
   
   elseif self.skipBackDone then
   
      self.skipBackDone = nil;
      self:skipSuccess();
      
   elseif self.waitForData then
   
      if self.missionData or self.skipData then
		
			
			if self.missionData then

            --Make sure no guide or too early mission (again to prevent vs guide)
            if not GuideMgr:isActive() and App.data:getMissionIndex() > 2 then
               FeedMgr:shareScreenshot( "MissionComplete", 0.05 );
            end

				EventMgr:postEvent( {  gem=self.missionReward.gem }, "mission-reward" );
				
				self.missionData = false;
				self.delay = 3;
				
			end
         self.waitForData = false;
         self.waitForReload = true;
			
      else
         self.delay = 0.25;
      end
      
   elseif self.waitForReload then
      
      if self.barsDone then
			self.goalsMoving = true;
			self.waitForReload = false;
      else
         self.delay = 0.25;
      end
   end
      
end


----------------------------------------------------------------

function  StateMissionPopup:timerCheck(i)

	if App.mission.goals[i].timerRunning then
	
		self.goal[i].text2:setText("");
		local s = App.data:getValue( "goalTimer"..i.."Start" );
		local t = App.mission.goals[i].timer;
		if s == nil then
			App.mission.goals[i].timerRunning = false;
			App.mission.goals[i].cumulativeScore = 0;
			self.goal[i].cumulativeScore = 0;
			self.goal[i].lastSeen = 0;
			return;
		end
			
		self.timerTable[i] = {start=s, time=t};
		
	end

end

----------------------------------------------------------------

function  StateMissionPopup:missionTimer(dt)

	local cur = os.time();
	local display;
	local text;
	
	for i=1,3 do
		if self.timerTable[i] then
		
			display = (self.timerTable[i].start + self.timerTable[i].time) - cur;
			
			if display <= 0 then
			
				self.goal[i].text2:setText(self.missionTpl.goals[i].text2);
				self.goal[i].text2Timer:setText("");
				App.mission.goals[i].timerRunning = false;
				App.mission.goals[i].cumulativeScore = 0;
				self.goal[i].cumulativeScore = 0;
				self.goal[i].lastSeen = 0;
				self.goal[i].bar.anim:setSpan( 0 );
				self.goal[i].bar.anim:setTime( 0 );
				self.goal[i].bar.anim:start();
				self.timerTable[i] = nil;
				App.data:updateMissionGoal(  self.curMI, i, 0 );
				
			else
				
				text = self:convertTime( display );
				self.goal[i].text2Timer:setText("Time left: "..text);
			end
		end
	end

end

----------------------------------------------------------------

function StateMissionPopup:convertTime( display )

	local time = '--:--:--';
	local countdown = display
   local hours;
   local min;
	local sec;
      
	sec = math.floor(countdown%60);

	if sec < 10 then
		sec = "0".. sec;
	end
      
	min = math.floor((countdown%3600)/60);

	if min < 10 then
		min = "0"..min..":";
	else
		min = min..":";
	end
      
	hours = math.floor(countdown/3600);
      
	if hours < 10 then
		hours = "0"..hours..":";
	else
		hours = hours..":";
	end
      
	time = hours.. min .. sec;
	
	return time;

end

----------------------------------------------------------------

function  StateMissionPopup:reload()

	
   
end

----------------------------------------------------------------

function  StateMissionPopup:nextMissionSuccess()

   self.missionData = true;
   
   for i=1,3 do
		self.goal[i].cumulativeScore = 0;
      App.data:setValue( "curGoal".. i, 0 )
   end
   
   local tpl = App.data:getCurrentMissionTemplate();
   if tpl then
               
      App.mission = Mission:new( tpl );
      App.mission:activate();
   end
   self.delay = 0.5;

end

----------------------------------------------------------------

function  StateMissionPopup:nextMissionFail()

	self:goBack();

end

----------------------------------------------------------------

function  StateMissionPopup:skipMissionConfirm()

   if not self.missionsMaxed then
      for i,v in ipairs(self.goal) do
         App.data:setValue( "curGoal".. i, self.goal[i].cumulativeScore );
      end
		
		StateMgr:push("state/state-missionskip-confirm.lua");
   end

  

end

----------------------------------------------------------------

function  StateMissionPopup:skipMission()

   self.skipButton:setColor( 0.25, 0.25, 0.25, 1  )
   self.skipButton:disable();
   self.barsDone = true;
   self.waitForData = true;
   self.delay = 0.75;
   
   
   for i=1,3 do
   
      self.goal[i].bar.anim:setVisible(false);
		self.goal[i].bar.anim:setPriority(0);
		self.goal[i].box.anim:setAnimFrame(2);
   
   end


end

----------------------------------------------------------------

function  StateMissionPopup:skipSuccess()
   
   self.skipData = true;
   
   for i,v in ipairs(self.goal) do
      App.data:setValue( "curGoal".. i, 0 )
      App.mission.goals[i]:deactivate();
   end
   
   local tpl = App.data:getCurrentMissionTemplate();
   if tpl then
      App.mission = Mission:new( tpl );
      App.mission:activate();
   end
	
	

end

----------------------------------------------------------------

function  StateMissionPopup:skipFail()



end

----------------------------------------------------------------

function  StateMissionPopup:skipReadyCheck()

	if not self.missionsMaxed then
		self.skipButton:setColor( 1, 1, 1, 1 );
		self.skipButton:enable();
	else
		self.skipButton:disable();
		self.skipButton:setColor( 0.25, 0.25, 0.25, 1 );
	end

end

----------------------------------------------------------------

function  StateMissionPopup:goBack()

   if not self.missionsMaxed then
      for i,v in ipairs(self.goal) do
         App.data:setValue( "curGoal".. i, self.goal[i].cumulativeScore );
      end
   end

   StateMgr:pop();
   

end

----------------------------------------------------------------

function  StateMissionPopup:missionOverScreen()

   if self.missionGraphics then
      for i=1,3 do
         self.goal[i].box.anim:setVisible(false);
         self.goal[i].bar.anim:setVisible(false);
         if self.goal[i].text1 then
            self.goal[i].text1:setVisible(false);
            self.goal[i].text2:setVisible(false);
         else
            self.goal[i].text:setVisible(false);
         end
      end
      --self.background:setVisible(false);
      --self.backButton:setVisible(false);
   end

end

----------------------------------------------------------------

function StateMissionPopup:disableGuideScrnButton()
   self._guideScrnButton:disable();
end


----------------------------------------------------------------

function StateMissionPopup:goCoinStore()
	
	StateMgr:push("state/state-coin.lua");

end

----------------------------------------------------------------

function StateMissionPopup:goGemStore()
	
	StateMgr:push("state/state-gem.lua");

end

----------------------------------------------------------------

return StateMissionPopup