----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local BUY_ICON_X				= 0
local BUY_ICON_Y				= -120;

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

----------------------------------------------------------------

local Base						= State;
local StateMsnSkpConfirm	= Base:new();
local Message_Text			= 'Skip this mission?';
local Message_Text2			= 'This will cost ';
local Message_Text_Fail		= 'Not enough coins.';
local Message_Text_Fail2	= 'You need ';

----------------------------------------------------------------

function StateMsnSkpConfirm:onLoad()

   State.onLoad( self );

   local textureSheet	= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);
	local group2Sheet		= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";

	self.IS_POPUP        = true;

	-- background and icon
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "SmallBackGround", textureSheet);

	-- currency Icon
	self.BuyIconCoin = self:addWidget(Anim, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 0,0, "CoinB", textureSheet);
	self.BuyIconCoin:setPriority(PRIORTY_1);

	-- push/pop state buttons
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 151, 0,0, "CloseButton", textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
	self.BackButton:setPriority(PRIORTY_0);
	self.ConfirmButtonG = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, 0, 0,0, "SmallBuyButton", textureSheet, nil, self.goConfirm, nil, nil);
	self.ConfirmButtonG:setPriority(PRIORTY_0);
	self.ConfirmButtonB = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, 0, 0,0, "SmallLockButton", textureSheet, nil, self.goConfirm, nil, nil);
	self.ConfirmButtonB:setPriority(PRIORTY_0);

	-- text message
	self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 122, 540, 70, '<c:fefcfc>Skip Mission<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleText:setScale(1.5, 1.5);
	self.TitleText:setPriority(PRIORTY_0);
	self.TitleTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, 122-2, 540, 70, '<c:0b141d>Skip Mission<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.TitleTextShdw:setScale(1.5, 1.5);
	self.TitleTextShdw:setPriority(PRIORTY_0-1);
	self.MessageText = self:addWidget(TextBox, self.mainLayer, 0, 5, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageText:setPriority(PRIORTY_0);
	self.MessageTextShdw = self:addWidget(TextBox, self.mainLayer, 0-2, 5+2, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageTextShdw:setPriority(PRIORTY_0-1);
	self.BuyButtonText = self:addWidget(TextBox, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 500, 100, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.BuyButtonText:setPriority(PRIORTY_1);

   self.resourceBar     = ResourceBar:new( self, 0, self:_calcHeaderLocY(), self.mainLayer, self.mainPartition  );


end

----------------------------------------------------------------

function StateMsnSkpConfirm:onActivate()

   State.onActivate(self);

	self.ConfirmButtonG:setVisible(false);
	self.ConfirmButtonB:setVisible(false);

	self.ConfirmButtonG:disable();
	self.ConfirmButtonB:disable();

   self._hackConfirmedSkip = nil;

	self:setMessage();

end

----------------------------------------------------------------

function StateMsnSkpConfirm:onFocus()

   State.onFocus(self);

   if self._hackConfirmedSkip then

      self._hackConfirmedSkip = nil;
      self:goConfirm();

   end

end

----------------------------------------------------------------

function StateMsnSkpConfirm:setMessage()

   local missionTpl		= App.data:getCurrentMissionTemplate( );
   local skipCost			= missionTpl.skipCost.gold;
	local message			= 'Do you want to skip this mission and not receive the mission reward?';

	if App.data:canSkipCurrentMission() then

		self.ConfirmButtonG:setVisible(true);
		self.ConfirmButtonG:enable();
	else

		self.ConfirmButtonB:setVisible(true);
		self.ConfirmButtonB:enable();
	end

	self.MessageText:setText('<c:1b3043>'..message..'<c>');
	self.MessageTextShdw:setText('<c:8fb5cd>'..message..'<c>');
	self.BuyButtonText:setText(getFormattedNumber(skipCost)..'');

	local offsetBuy = 0;
	local offsetNegX = 0;

	if skipCost > 9999 then
		offsetBuy = 36;
		offsetNegX = 10;
	elseif skipCost > 999 then
		offsetBuy = 35;
		offsetNegX = 13;
	elseif skipCost > 99 then
		offsetBuy = 30;
		offsetNegX = 8;
	elseif skipCost > 9 then
		offsetBuy = 25;
		offsetNegX = 3;
	else
		offsetBuy = 20;
		offsetNegX = -2;
	end

	self.BuyIconCoin:setLoc(BUY_ICON_X-offsetBuy-offsetNegX, BUY_ICON_Y);
	self.BuyButtonText:setLoc(BUY_ICON_X+offsetBuy-offsetNegX, BUY_ICON_Y);

end

----------------------------------------------------------------

function StateMsnSkpConfirm:goConfirm()

	print("Go To Confirm");

	local missionTpl		= App.data:getCurrentMissionTemplate( );
	local skipCost			= missionTpl.skipCost.gold;

	if App.data:canSkipCurrentMission() then

		App.data:skipCurrentMission();

		local missionState = StateMgr.stateStack [ #StateMgr.stateStack-1 ]
		missionState.missionSkipBack = true;

		StateMgr:pop();
	else

      AUTO_PURCHASE_DATA.state      = 'StateMsnSkpConfirm';
      AUTO_PURCHASE_DATA.carIndex   = ""..-1;
      AUTO_PURCHASE_DATA.reason1		= 'Skip-Mission';
      AUTO_PURCHASE_DATA.reason2		= 'Skip-Mission-'..App.data:getMissionIndex();
		AUTO_PURCHASE_DATA.currency	= 'Coin';
		AUTO_PURCHASE_DATA.price		= skipCost;
		AUTO_PURCHASE_FUNC				=	function()
														self._hackConfirmedSkip = true;
													end

		StateMgr:push("state/state-auto-purchase-popup-maz.lua");
	end

end

----------------------------------------------------------------

function StateMsnSkpConfirm:onSkipSentFailure()

   MOAIDialogIOS.showDialog(	LocalizationMgr:getString( "NATIVE_CONNECT_ERROR" )
                              ,  LocalizationMgr:getString( "DEFAULT_ERROR_NETWORK_MESSAGE" )
                              ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                              ,  nil
                              ,  nil
                              ,  false
                              ,  function()
                                 end
                           );

end

----------------------------------------------------------------

function StateMsnSkpConfirm:goBack()

	print("Go Back");

	StateMgr:pop();

end

----------------------------------------------------------------

function StateMsnSkpConfirm:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

return StateMsnSkpConfirm;

----------------------------------------------------------------
