----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');
require('state/resourceBar/resourceBar');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

local OUTRO                =  {
                                 {  x=0, y=270, anim="MysteryBox_Button_TransitionOut_Jackpot",
                                 
                                    attach1  ={ x=0, y=-8, w=119, h=99, icon="GR_Icon_Gem", propNum=7, scale=1, },
                                    attach2  ={ x=0, y=-12, w=270, h=121, icon="GR_MysteryBoxPanel_Text_5000", propNum=8, scale=1, },
                                    reward   ={ type="gems", amount=5000, }, 
                                 },
                                 {  x=-130, y=94.75, anim="MysteryBox_Button_TransitionOut_Rare",

                                    attach1  ={ x=0, y=-10, w=252, h=110, icon="GR_Icon_KeyStack",propNum=3, scale=0.5, },
                                    attach2  ={ x=0, y=-10, w=77, h=66, icon="GR_MysteryBoxPanel_Text_50", propNum=4, scale=1, },
                                    reward   ={ type="keys", amount=50, }, 
                                 },
                                 {  x=19.85, y=94.75, anim="MysteryBox_Button_TransitionOut_Rare",

                                    attach1  ={ x=0, y=-10, w=300, h=120, icon="GR_Icon_CoinStack", propNum=3, scale=0.43, },
                                    attach2  ={ x=0, y=-10, w=132, h=66, icon="GR_MysteryBoxPanel_Text_1500", propNum=4, scale=1, },
                                    reward   ={ type="gold", amount=1500, },
                                 },
                                 {  x=169.35, y=94.75, anim="MysteryBox_Button_TransitionOut_Rare",

                                    attach1  ={ x=0, y=-10, w=260, h=109, icon="GR_Icon_GemStack", propNum=3, scale=0.6, },
                                    attach2  ={ x=0, y=-10, w=75, h=66, icon="GR_MysteryBoxPanel_Text_25", propNum=4, scale=1, },
                                    reward   ={ type="gems", amount=25, },
                                 },
                                 {  x=-130, y=-55, anim="MysteryBox_Button_TransitionOut_Uncommon",

                                    attach1  ={ x=0, y=10, w=118, h=94, icon="GR_Icon_Revive", propNum=3, scale=1, },
                                    attach2  ={ x=0, y=0, w=79, h=34, icon="GR_MysteryBoxPanel_Text_Revive", propNum=4, scale=1, },
                                    reward   ={ type="revive", amount=1, },
                                 },
                                 {  x=19.85, y=-55, anim="MysteryBox_Button_TransitionOut_Uncommon",

                                    attach1  ={ x=0, y=2, w=76, h=90, icon="GR_Icon_Time", propNum=3, scale=0.9, },
                                    attach2  ={ x=0, y=0, w=128, h=34, icon="GR_MysteryBoxPanel_Text_Powertme", propNum=4, scale=1, },
                                    reward   ={ type="power-time", amount=1, scale=1, },
                                 },
                                 {  x=169.35, y=-55, anim="MysteryBox_Button_TransitionOut_Uncommon",

                                    attach1  ={ x=0, y=0, w=87, h=89, icon="GR_Icon_2x", propNum=3, scale=0.95, },
                                    attach2  ={ x=0, y=0, w=98, h=34, icon="GR_MysteryBoxPanel_Text_2xScore", propNum=4, scale=1, },
                                    reward   ={ type="double-score", amount=1, },
                                 },
                                 {  x=-130, y=-205, anim="MysteryBox_Button_TransitionOut_Common",

                                    attach1  ={ x=0, y=0, w=91, h=89, icon="GR_Icon_Key", propNum=3, scale=1, },
                                    attach2  ={ x=0, y=0, w=78, h=36, icon="GR_MysteryBoxPanel_Text_2Keys", propNum=4, scale=1, },
                                    reward   ={ type="keys", amount=2, },
                                 },
                                 {  x=19.85, y=-205, anim="MysteryBox_Button_TransitionOut_Common",

                                    attach1  ={ x=0, y=0, w=92, h=91, icon="GR_Icon_Coin", propNum=3, scale=1, },
                                    attach2  ={ x=0, y=0, w=112, h=34, icon="GR_MysteryBoxPanel_Text_250Coins", propNum=4, scale=1, },
                                    reward={ type="gold", amount=250, },
                                 },
                                 {  x=169.35, y=-205, anim="MysteryBox_Button_TransitionOut_Common",

                                    attach1  ={ x=0, y=0, w=85, h=86, icon="GR_Icon_Boost", propNum=3, scale=0.9, },
                                    attach2  ={ x=0, y=0, w=117, h=34, icon="GR_MysteryBoxPanel_Text_Headstart", propNum=4, scale=1, },
                                    reward   ={ type="head-start", amount=1, },
                                 },
                              };
local OUTRO_WHITE          =  {
                                 {  x=0, y=270, anim="MysteryBox_Button_TransitionOut_JackpotWhiteFlash",},
                                 {  x=-130, y=94.75, anim="MysteryBox_Button_TransitionOut_RareWhiteFlash",},
                                 {  x=19.85, y=94.75, anim="MysteryBox_Button_TransitionOut_RareWhiteFlash",},
                                 {  x=169.35, y=94.75, anim="MysteryBox_Button_TransitionOut_RareWhiteFlash",},
                                 {  x=-130, y=-55, anim="MysteryBox_Button_TransitionOut_UncommonWhiteFlash",},
                                 {  x=19.85, y=-55, anim="MysteryBox_Button_TransitionOut_UncommonWhiteFlash",},
                                 {  x=169.35, y=-55, anim="MysteryBox_Button_TransitionOut_UncommonWhiteFlash",},
                                 {  x=-130, y=-205, anim="MysteryBox_Button_TransitionOut_CommonWhiteFlash",},
                                 {  x=19.85, y=-205, anim="MysteryBox_Button_TransitionOut_CommonWhiteFlash",},
                                 {  x=169.35, y=-205, anim="MysteryBox_Button_TransitionOut_CommonWhiteFlash",},
                              };
local LOOPS                =  {
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Jackpot",

                                    attach1  ={ x=0, y=0, w=119, h=99, icon="GR_Icon_Gem", propNum=8, scale=1, },
                                    attach2  ={ x=0, y=0, w=248, h=50, icon="GR_MysteryBoxPanel_RewardPanelText_5000Gems", propNum=10, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Rare",

                                    attach1  ={ x=0, y=-10, w=252, h=110, icon="GR_Icon_KeyStack",propNum=7, scale=0.8, },
                                    attach2  ={ x=0, y=0, w=172, h=48, icon="GR_MysteryBoxPanel_RewardPanelText_50Keys", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Rare",

                                    attach1  ={ x=0, y=-10, w=300, h=120, icon="GR_Icon_CoinStack", propNum=7, scale=0.67, },
                                    attach2  ={ x=0, y=-0, w=233, h=45, icon="GR_MysteryBoxPanel_RewardPanelText_1500Coins", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Rare",

                                    attach1  ={ x=0, y=-10, w=260, h=109, icon="GR_Icon_GemStack", propNum=7, scale=0.9, },
                                    attach2  ={ x=0, y=-0, w=186, h=45, icon="GR_MysteryBoxPanel_RewardPanelText_25Gems", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Uncommon",

                                    attach1  ={ x=0, y=8, w=118, h=94, icon="GR_Icon_Revive", propNum=7, scale=1.1, },
                                    attach2  ={ x=0, y=0, w=188, h=43, icon="GR_MysteryBoxPanel_RewardPanelText_Revive", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Uncommon",

                                    attach1  ={ x=0, y=0, w=76, h=90, icon="GR_Icon_Time", propNum=7, scale=1.1, },
                                    attach2  ={ x=0, y=0, w=286, h=43, icon="GR_MysteryBoxPanel_RewardPanelText_Powertime", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Uncommon",

                                    attach1  ={ x=0, y=0, w=87, h=89, icon="GR_Icon_2x", propNum=7, scale=1.1, },
                                    attach2  ={ x=0, y=0, w=227, h=45, icon="GR_MysteryBoxPanel_RewardPanelText_2xScore", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Common",

                                    attach1  ={ x=0, y=0, w=91, h=89, icon="GR_Icon_Key", propNum=7, scale=1.1, },
                                    attach2  ={ x=0, y=0, w=136, h=48, icon="GR_MysteryBoxPanel_RewardPanelText_2Keys", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Common",

                                    attach1  ={ x=0, y=0, w=92, h=91, icon="GR_Icon_Coin", propNum=7, scale=1.1, },
                                    attach2  ={ x=0, y=0, w=199, h=45, icon="GR_MysteryBoxPanel_RewardPanelText_250Coins", propNum=9, scale=1, },
                                 },
                                 {  x=0, y=0, anim="MysteryBox_Button_Out_Common",

                                    attach1  ={ x=0, y=0, w=85, h=86, icon="GR_Icon_Boost", propNum=7, scale=1.1, },
                                    attach2  ={ x=0, y=0, w=263, h=45, icon="GR_MysteryBoxPanel_RewardPanelText_Headstart", propNum=9, scale=1, },
                                 },
                              };
                              


----------------------------------------------------------------

local Base							= State;
local StateMysteryBoxReveal		= Base:new();

----------------------------------------------------------------

function StateMysteryBoxReveal:onLoad()

   State.onLoad( self );

	self.IS_POPUP  = true;
   
   self.mysteryTexture			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Mystery_Box_Centered.lua", "resources/flash-resource-bundle/Mystery_Box_Centered.png", 30);
   
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, -200, 245, 116, "resources/UI/GR_MysteryBoxPanel_Text_TapScreen.png", {1,1,1,1});
   self.Overlay:setPriority(PRIORTY_10);
   self.Overlay:setVisible(false);
   
   self:createOutros();
   
   self:createLoops();
   


end

----------------------------------------------------------------

function StateMysteryBoxReveal:onActivate()

   State.onActivate(self);

end

----------------------------------------------------------------

function StateMysteryBoxReveal:createOutros()
   
   self.outroList = {};
   self.outroListWhite = {};
   local prefix = "resources/UI/";
   local suffix = ".png";


   for i=1, #OUTRO do
   
      self.outroList[i] = {};
      self.outroList[i]["animation"] = self:addWidget(Anim, self.mainLayer, OUTRO[i].x,OUTRO[i].y,0,0, OUTRO[i].anim, self.mysteryTexture);
      self.outroList[i]["animation"]:setPriority(PRIORTY_5);
      
      local a1Name = prefix.. OUTRO[i].attach1.icon.. suffix;
      local a2Name = prefix.. OUTRO[i].attach2.icon.. suffix;
      
      --attach first image to anim prop
      self.outroList[i]["icon1"] = self:addWidget(Image, self.mainLayer, OUTRO[i].attach1.x, OUTRO[i].attach1.y, OUTRO[i].attach1.w, OUTRO[i].attach1.h, a1Name, {1,1,1,1});
      self.outroList[i]["icon1"]:setPriority(PRIORTY_6);
      self.outroList[i]["icon1"]:setParent(self.outroList[i]["animation"].anim.props[OUTRO[i].attach1.propNum]);
      if OUTRO[i].attach1.scale then
         self.outroList[i]["icon1"]:setScale(OUTRO[i].attach1.scale);
      end

      --attach second image to anim prop
      self.outroList[i]["icon2"] = self:addWidget(Image, self.mainLayer, OUTRO[i].attach2.x, OUTRO[i].attach2.y, OUTRO[i].attach2.w, OUTRO[i].attach2.h, a2Name, {1,1,1,1});
      self.outroList[i]["icon2"]:setPriority(PRIORTY_6);
      self.outroList[i]["icon2"]:setParent(self.outroList[i]["animation"].anim.props[OUTRO[i].attach2.propNum]);
      if OUTRO[i].attach2.scale then
         self.outroList[i]["icon2"]:setScale(OUTRO[i].attach2.scale);
      end
      
      self.outroList[i]["animation"]:setVisible(false);
      self.outroList[i]["icon1"]:setVisible(false);
      self.outroList[i]["icon2"]:setVisible(false);

   end
   
   for i=1, #OUTRO_WHITE do
   
      self.outroListWhite[i] = {};
      self.outroListWhite[i]["animation"] = self:addWidget(Anim, self.mainLayer, OUTRO_WHITE[i].x,OUTRO_WHITE[i].y,0,0, OUTRO_WHITE[i].anim, self.mysteryTexture);
      self.outroListWhite[i]["animation"]:setPriority(PRIORTY_7);
      self.outroListWhite[i]["animation"]:setVisible(false);

   end

end

----------------------------------------------------------------

function StateMysteryBoxReveal:createLoops()
   
   self.loopList = {};
   local prefix = "resources/UI/";
   local suffix = ".png";


   for i=1, #LOOPS do
   
      self.loopList[i] = {};
      self.loopList[i]["animation"] = self:addWidget(Anim, self.mainLayer, LOOPS[i].x,LOOPS[i].y,0,0, LOOPS[i].anim, self.mysteryTexture);
      self.loopList[i]["animation"]:setPriority(PRIORTY_7);
      
      local a1Name = prefix.. LOOPS[i].attach1.icon.. suffix;
      local a2Name = prefix.. LOOPS[i].attach2.icon.. suffix;
      
      --attach first image to anim prop
      self.loopList[i]["icon1"] = self:addWidget(Image, self.mainLayer, LOOPS[i].attach1.x, LOOPS[i].attach1.y, LOOPS[i].attach1.w, LOOPS[i].attach1.h, a1Name, {1,1,1,1});
      self.loopList[i]["icon1"]:setPriority(PRIORTY_8);
      self.loopList[i]["icon1"]:setParent(self.loopList[i]["animation"].anim.props[LOOPS[i].attach1.propNum]);
      if LOOPS[i].attach1.scale then
         self.loopList[i]["icon1"]:setScale(LOOPS[i].attach1.scale);
      end

      --attach second image to anim prop
      self.loopList[i]["icon2"] = self:addWidget(Image, self.mainLayer, LOOPS[i].attach2.x, LOOPS[i].attach2.y, LOOPS[i].attach2.w, LOOPS[i].attach2.h, a2Name, {1,1,1,1});
      self.loopList[i]["icon2"]:setPriority(PRIORTY_8);
      self.loopList[i]["icon2"]:setParent(self.loopList[i]["animation"].anim.props[LOOPS[i].attach2.propNum]);
      if LOOPS[i].attach2.scale then
         self.loopList[i]["icon2"]:setScale(LOOPS[i].attach2.scale);
      end
      
      self.loopList[i]["animation"]:setVisible(false);
      self.loopList[i]["icon1"]:setVisible(false);
      self.loopList[i]["icon2"]:setVisible(false);

   end

end

----------------------------------------------------------------

function StateMysteryBoxReveal:resetAnims()

   for i=1, #OUTRO do

      self.outroList[i]["animation"]:stop();
      self.outroList[i]["animation"]:resetAnim();
      self.outroList[i]["animation"]:apply(0);
      self.outroList[i]["animation"]:setLoc(OUTRO[i].x,OUTRO[i].y);
      self.outroList[i]["animation"]:setPriority(PRIORTY_5);
      self.outroList[i]["icon1"]:setPriority(PRIORTY_6);
      self.outroList[i]["icon2"]:setPriority(PRIORTY_6);

      self.outroList[i]["animation"]:setVisible(false);
      self.outroList[i]["icon1"]:setVisible(false);
      self.outroList[i]["icon2"]:setVisible(false);

   end
   
   for i=1, #OUTRO_WHITE do

      self.outroListWhite[i]["animation"]:stop();
      self.outroListWhite[i]["animation"]:resetAnim();
      self.outroListWhite[i]["animation"]:apply(0);
      self.outroListWhite[i]["animation"]:setLoc(OUTRO[i].x,OUTRO[i].y);
      self.outroListWhite[i]["animation"]:setPriority(PRIORTY_7);
      self.outroListWhite[i]["animation"]:setVisible(false);

   end

   for i=1, #LOOPS do

      self.loopList[i]["animation"]:stop();
      self.loopList[i]["animation"]:setSpan(0, 1);
      self.loopList[i]["animation"]:setMode(MOAITimer.NORMAL);
      self.loopList[i]["animation"]:resetAnim();
      self.loopList[i]["animation"]:apply(0);

      self.loopList[i]["animation"]:setPriority(PRIORTY_7);
      self.loopList[i]["icon1"]:setPriority(PRIORTY_8);
      self.loopList[i]["icon2"]:setPriority(PRIORTY_8);

      self.loopList[i]["animation"]:setVisible(false);
      self.loopList[i]["icon1"]:setVisible(false);
      self.loopList[i]["icon2"]:setVisible(false);


   end
   
   self.Overlay:setVisible(false);

end

----------------------------------------------------------------

function StateMysteryBoxReveal:giveReward()


   --give rewards, start banners
   print("reward:", self.reward.amount, self.reward.type );
   if self.reward.type and self.reward.amount then
      local freebieCountKey;
      local freebieCountVal;

      if self.reward.type == "gems" then
         App.data:addGem(self.reward.amount, "mystery box");
         EventMgr:postEvent({gems=self.reward.amount}, "mystery-reward");
      elseif self.reward.type == "gold" then
         App.data:addGold(self.reward.amount, "mystery box");
         EventMgr:postEvent({gold=self.reward.amount}, "mystery-reward");
      elseif self.reward.type == "keys" then
         App.data:addKey(self.reward.amount, "mystery box");
         EventMgr:postEvent({keys=self.reward.amount}, "mystery-reward");
      else
         App.data:giveFreebie(self.reward.type, self.reward.amount, "mystery box");
         EventMgr:postEvent({consumable=self.reward.type}, "mystery-reward");
         freebieCountVal = tostring(App.data:getFreebieCount(self.reward.type));
         freebieCountKey = "Free-"..self.reward.type;
      end

      if not GuideMgr:isActive() then
         FeedMgr:shareScreenshot("MysteryReward-"..self.reward.type..self.reward.amount, 0.01);
      end

      EventMgr:postEvent(  {  cost        =  self.paid,
                              costType    =  self.costType,
                              spinCount   =  App.data:getValue("mystery-spin-count")
                           },
                           "mystery-spin"       );

      MOAIFlurry:event( "Mystery-Reward",
                        "reward",            tostring(self.reward.type)..tostring(self.reward.amount),
                        "cost-type",         tostring(self.costType),
                        "cost",              tostring(self.paid),
                        "spin-count",        tostring(App.data:getValue("mystery-spin-count")),
                        freebieCountKey,     freebieCountVal                                          );

      if self.costType ~= "tokens" then

         MOAIFlurry:event( "Mystery-Spin-Paid",
                           "reward",            tostring(self.reward.type)..tostring(self.reward.amount),
                           "cost",              tostring(self.paid),
                           "spin-count",        tostring(App.data:getValue("mystery-spin-count")),
                           "spin-paid-count",   tostring(App.data:getValue("mystery-spin-paid-count")) );

      end

   end



end

----------------------------------------------------------------

function  StateMysteryBoxReveal:onInput()

   State.onInput(self);
   
   if not self.revealTransition then

      if not self.backCalled then
         if self.inputDown then
            self.backCalled = true;
            self:goBack();
         end
      end
   end

end

----------------------------------------------------------------

function StateMysteryBoxReveal:onFocus( params )
   
   State.onFocus(self);

   StateMgr:setSyncBusyDelay(0);
   
   self.revealTransition = true;
   self.backCalled = nil;
   self.winner = params.animNum;
   self.reward = OUTRO[self.winner]["reward"];
   
   if self.winner and self.reward then
   
      self.outroList[self.winner]["animation"]:setVisible(true);
      self.outroListWhite[self.winner]["animation"]:setVisible(true);
      self.outroList[self.winner]["icon1"]:setVisible(true);
      self.outroList[self.winner]["icon2"]:setVisible(true);
      
      if self.winner == 1 then
         self.totalSlide = 55/30;
      else
         self.totalSlide = 55/30;
      end
      self.slideTime = 0.3;
      self.slideTimer = self.totalSlide - self.slideTime;

      self.outroList[self.winner]["animation"]:setListener(MOAIAction.EVENT_STOP,
            function ()
               
               self.revealTransition = nil;

               self.loopList[self.winner]["animation"]:setVisible(true);
               self.loopList[self.winner]["icon1"]:setVisible(true);
               self.loopList[self.winner]["icon2"]:setVisible(true);

               self.outroList[self.winner]["animation"]:setVisible(false);
               self.outroListWhite[self.winner]["animation"]:setVisible(false);
               self.outroList[self.winner]["icon1"]:setVisible(false);
               self.outroList[self.winner]["icon2"]:setVisible(false);

               self:giveReward();
               self.Overlay:setVisible(true);
               --joe: this was originally to loop the end of the anim after it plays. it makes it impossible to reset though
               --[[
               self.loopList[self.winner]["animation"]:setListener(MOAIAction.EVENT_STOP,
                  function ()
                     self.loopList[self.winner]["animation"]:setSpan(8/15, 1);
                     self.loopList[self.winner]["animation"]:setMode(MOAITimer.LOOP);
                     self.loopList[self.winner]["animation"]:start();
                  end
               );
               ]]

               self.loopList[self.winner]["animation"]:start();
               
               local cSounds = {loop={"MysteryShimmer",},};
               EventMgr:postEvent( { sounds=cSounds, name="mystery shimmer",}, "add-sfx" );


            end
            );

      self.outroList[self.winner]["animation"]:start();
      self.outroListWhite[self.winner]["animation"]:start();
      local cSounds = {start={"MysteryReveal",},};
      EventMgr:postEvent( { sounds=cSounds, name="mystery reveal",}, "add-sfx" );

   else

      Debug.assert( self.winner, self.reward );
      
   end


end

----------------------------------------------------------------

function StateMysteryBoxReveal:onUpdate( dt )

   State.onUpdate(self);
   
   if self.slideTimer then
      self.slideTimer = self.slideTimer - dt;
      if self.slideTimer <= 0 then
         self.slideTimer = nil;
         self.slideToCenter = self.outroList[self.winner]["animation"]:seekLoc(0, 0, self.slideTime, MOAIEaseType.SOFT_SMOOTH);
         self.slideToCenter = self.outroListWhite[self.winner]["animation"]:seekLoc(0, 0, self.slideTime, MOAIEaseType.SOFT_SMOOTH);
      end
   end


end

----------------------------------------------------------------

function StateMysteryBoxReveal:onBackButton()

	self:goBack();

end

----------------------------------------------------------------

function StateMysteryBoxReveal:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

function StateMysteryBoxReveal:goBack()

   self:resetAnims();

   local cSounds = {loop={"MysteryShimmer",},};
   EventMgr:postEvent( {sounds=cSounds, name="mystery loop stop",}, "loop-stop" );

   StateMgr:pop();
	
end

----------------------------------------------------------------

return StateMysteryBoxReveal;

----------------------------------------------------------------
