----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');
require('state/resourceBar/resourceBar');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

local MB_GEM_COST          = 1;
local MB_TOKEN_COST        = 1;
local FLASH_ANIM_LENGTH    = 0.1;

local PANELS               =  {
                                 {  x=0, y=270, anim="MysteryBox_Button_Loop_Jackpot",

                                    attach1  ={ x=0, y=-8, w=119, h=99, icon="GR_Icon_Gem", propNum=10, scale=1, },
                                    attach2  ={ x=0, y=-12, w=270, h=121, icon="GR_MysteryBoxPanel_Text_5000", propNum=11, scale=1, },
                                 },
                                 {  x=-130, y=94.75, anim="MysteryBox_Button_Loop_Rare",

                                    attach1  ={ x=0, y=-10, w=252, h=110, icon="GR_Icon_KeyStack",propNum=3, scale=0.5, },
                                    attach2  ={ x=0, y=-10, w=77, h=66, icon="GR_MysteryBoxPanel_Text_50", propNum=4, scale=1, },
                                 },
                                 {  x=19.85, y=94.75, anim="MysteryBox_Button_Loop_Rare",

                                    attach1  ={ x=0, y=-10, w=300, h=120, icon="GR_Icon_CoinStack", propNum=3, scale=0.43, },
                                    attach2  ={ x=0, y=-10, w=132, h=66, icon="GR_MysteryBoxPanel_Text_1500", propNum=4, scale=1, },
                                 },
                                 {  x=169.35, y=94.75, anim="MysteryBox_Button_Loop_Rare",

                                    attach1  ={ x=0, y=-10, w=260, h=109, icon="GR_Icon_GemStack", propNum=3, scale=0.6, },
                                    attach2  ={ x=0, y=-10, w=75, h=66, icon="GR_MysteryBoxPanel_Text_25", propNum=4, scale=1, },
                                 },
                                 {  x=-130, y=-55, anim="MysteryBox_Button_Loop_Uncommon",

                                    attach1  ={ x=0, y=10, w=118, h=94, icon="GR_Icon_Revive", propNum=3, scale=1, },
                                    attach2  ={ x=0, y=0, w=79, h=34, icon="GR_MysteryBoxPanel_Text_Revive", propNum=4, scale=1, },
                                 },
                                 {  x=19.85, y=-55, anim="MysteryBox_Button_Loop_Uncommon",

                                    attach1  ={ x=0, y=2, w=76, h=90, icon="GR_Icon_Time", propNum=3, scale=0.9, },
                                    attach2  ={ x=0, y=0, w=128, h=34, icon="GR_MysteryBoxPanel_Text_Powertme", propNum=4, scale=1, },
                                 },
                                 {  x=169.35, y=-55, anim="MysteryBox_Button_Loop_Uncommon",

                                    attach1  ={ x=0, y=0, w=87, h=89, icon="GR_Icon_2x", propNum=3, scale=0.95, },
                                    attach2  ={ x=0, y=0, w=98, h=34, icon="GR_MysteryBoxPanel_Text_2xScore", propNum=4, scale=1, },
                                 },
                                 {  x=-130, y=-205, anim="MysteryBox_Button_Loop_Common",

                                    attach1  ={ x=0, y=0, w=91, h=89, icon="GR_Icon_Key", propNum=3, scale=1, },
                                    attach2  ={ x=0, y=0, w=78, h=36, icon="GR_MysteryBoxPanel_Text_2Keys", propNum=4, scale=1, },
                                 },
                                 {  x=19.85, y=-205, anim="MysteryBox_Button_Loop_Common",

                                    attach1  ={ x=0, y=0, w=92, h=91, icon="GR_Icon_Coin", propNum=3, scale=1, },
                                    attach2  ={ x=0, y=0, w=112, h=34, icon="GR_MysteryBoxPanel_Text_250Coins", propNum=4, scale=1, },
                                 },
                                 {  x=169.35, y=-205, anim="MysteryBox_Button_Loop_Common",

                                    attach1  ={ x=0, y=0, w=85, h=86, icon="GR_Icon_Boost", propNum=3, scale=0.9, },
                                    attach2  ={ x=0, y=0, w=117, h=34, icon="GR_MysteryBoxPanel_Text_Headstart", propNum=4, scale=1, },
                                 },
                              };

local NEAR_SQUARES        =  {   --jackpot
                                 {1,2,3,4,},
                                 --Rare 1
                                 {1,2,3,5,6,},
                                 --Rare 2
                                 {1,2,3,4,5,6,7},
                                 --Rare 3
                                 {1,3,4,6,7},
                                 --Uncommon 1
                                 {2,3,5,6,8,9,},
                                 --Uncommon 2
                                 {2,3,4,5,6,7,8,9,10,},
                                 --Uncommon 3
                                 {3,4,6,7,9,10,},
                                 --Common 1
                                 {5,6,8,9,},
                                 --Common 2
                                 {5,6,7,8,9,10,},
                                 --Common 3
                                 {6,7,9,10,},

                              };

----------------------------------------------------------------

local Base							= State;
local StateMysteryBox		= Base:new();

----------------------------------------------------------------

function StateMysteryBox:onLoad()

   State.onLoad( self );

   self.defaultFontName = "resources/font/TangoLatin.otf";
	self.IS_POPUP  = true;
   self.DidShowAd = false;

   self.mysteryTexture			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Mystery_Box_Centered.lua", "resources/flash-resource-bundle/Mystery_Box_Centered.png", 30);
   local textureSheet          = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.8});

   --background
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "MysteryBox_Screen_FrameBackground", self.mysteryTexture);
	self.BackDrop:setPriority(1);

   self:buildGrid()

	self.iconText    = self:addWidget(TextBox, self.mainLayer, 20, -358, 360, 220, "", self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.iconText:setPriority(PRIORTY_4);
   self.iconTextBkgd = self:addWidget(TextBox, self.mainLayer, 22,-360, 360, 220, "", self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.iconTextBkgd:setPriority(PRIORTY_3);
   self.iconTextBkgd:setColor(0,0,0,1);

   --buttons

	self.MysteryButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "Button_Buy_Gem", self.mysteryTexture, nil, self.onMysteryButton, nil);
   self.MysteryButton:setPriority(PRIORTY_2);

	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "Button_Close", self.mysteryTexture, nil, self.onBackButton, nil);
   self.BackButton:setPriority(PRIORTY_2);


   self.videoReviveButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 130,-350+350,0,0, "Green_Video_Button", self.mysteryTexture, nil, self.watchVideoForMysteryReward, nil, nil);
   self.videoReviveButton:setPriority(PRIORTY_2);
   self.videoReviveButton:setVisible(false);
   self.videoReviveButton:disable();


   self.videoButtonIcon = self:addWidget(ButtonImage, self.mainLayer, 130,-355, 61, 61, "resources/videoIcon.png", nil, nil)
   self.videoButtonIcon:setPriority(PRIORTY_5);
   self.videoButtonIcon:setVisible(false);

--watchVideoForMysteryReward

   --token count text

   self.MysteryAlert = self:addWidget(Anim, self.mainLayer, 90,-314,0,0, "NotificationIconMystery_Counter", textureSheet);
   self.MysteryAlert:setPriority(PRIORTY_3);
   self.MysteryAlert:setScale(0.9,0.9);
   self.MysteryAlert:setSpan(1.0);
   self.MysteryAlert:setMode(MOAITimer.LOOP);
   self.MysteryAlert:setVisible(false);

   self.MysteryAlertSparkle = self:addWidget(Anim, self.mainLayer, 90,-314,0,0, "NotificationSparkle", textureSheet);
   self.MysteryAlertSparkle:setPriority(PRIORTY_3-1);
   self.MysteryAlertSparkle:setScale(0.9,0.9);
   self.MysteryAlertSparkle:setSpan(29/30);
   self.MysteryAlertSparkle:setMode(MOAITimer.LOOP);
   self.MysteryAlertSparkle:setVisible(false);

	self.tokenCountText    = self:addWidget(TextBox, self.mainLayer, -3, 2, 360, 220, "", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.tokenCountText:setPriority(PRIORTY_4);
   self.tokenCountText:setParent(self.MysteryAlert.anim.props[1]);

   local blendHackTable = {};

   self:blendModeHack(blendHackTable);

   self:_setupBasicResourceBar();


end

----------------------------------------------------------------

function StateMysteryBox:buildGrid()

   self.panelGrid = {};
   local prefix = "resources/UI/";
   local suffix = ".png";


   for i=1, #PANELS do

      self.panelGrid[i] = {};
      self.panelGrid[i]["animation"] = self:addWidget(Anim, self.mainLayer, PANELS[i].x,PANELS[i].y,0,0, PANELS[i].anim, self.mysteryTexture);
      self.panelGrid[i]["animation"]:setPriority(PRIORTY_5);

      local a1Name = prefix.. PANELS[i].attach1.icon.. suffix;
      local a2Name = prefix.. PANELS[i].attach2.icon.. suffix;

      --attach first image to anim prop
      self.panelGrid[i]["icon1"] = self:addWidget(Image, self.mainLayer, PANELS[i].attach1.x, PANELS[i].attach1.y, PANELS[i].attach1.w, PANELS[i].attach1.h, a1Name, {1,1,1,1});
      self.panelGrid[i]["icon1"]:setPriority(PRIORTY_6);
      self.panelGrid[i]["icon1"]:setParent(self.panelGrid[i]["animation"].anim.props[PANELS[i].attach1.propNum]);
      if PANELS[i].attach1.scale then
         self.panelGrid[i]["icon1"]:setScale(PANELS[i].attach1.scale);
      end

      --attach first image to anim prop
      self.panelGrid[i]["icon2"] = self:addWidget(Image, self.mainLayer, PANELS[i].attach2.x, PANELS[i].attach2.y, PANELS[i].attach2.w, PANELS[i].attach2.h, a2Name, {1,1,1,1});
      self.panelGrid[i]["icon2"]:setPriority(PRIORTY_6);
      self.panelGrid[i]["icon2"]:setParent(self.panelGrid[i]["animation"].anim.props[PANELS[i].attach2.propNum]);
      if PANELS[i].attach2.scale then
         self.panelGrid[i]["icon2"]:setScale(PANELS[i].attach2.scale);
      end

   end

end

----------------------------------------------------------------

function StateMysteryBox:resetGrid()

   for i=1, #PANELS do

      self.panelGrid[i]["animation"]:setVisible(true);
      self.panelGrid[i]["icon1"]:setVisible(true);
      self.panelGrid[i]["icon2"]:setVisible(true);
      self.panelGrid[i]["animation"]:stop();
      self.panelGrid[i]["animation"]:setMode(MOAITimer.NORMAL);
      self.panelGrid[i]["animation"]:resetAnim();
      self.panelGrid[i]["animation"]:apply(0);
      self.panelGrid[i]["animation"]:setSpeed(1);
      self.panelGrid[i]["animation"]:setLoc(PANELS[i].x,PANELS[i].y);
      self.panelGrid[i]["animation"]:setPriority(PRIORTY_5);
      self.panelGrid[i]["icon1"]:setPriority(PRIORTY_6);
      self.panelGrid[i]["icon2"]:setPriority(PRIORTY_6);

   end

end

----------------------------------------------------------------

function StateMysteryBox:blendModeHack( table )

   --this solves some weird shadowing issues with the flash backgrounds
   for j,k in pairs(table) do

      if j == 1 and k.anim and k.anim.props and k.anim.props[53] then
         k.anim.props[53]:setBlendMode( MOAIProp2D.BLEND_NORMAL );
      end
      if k.anim and k.anim.props and k.anim.props[55] then
         k.anim.props[55]:setBlendMode( MOAIProp2D.BLEND_NORMAL );
      end
   end

end

----------------------------------------------------------------

function StateMysteryBox:onActivate()

   State.onActivate(self);

   self.paid = "unknown";

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

end

----------------------------------------------------------------

function StateMysteryBox:onFocus()

   State.onFocus(self);

   StateMgr:setSyncBusyDelay(0);

   local lastAdSeenDateKey = "last-mystery-box-ad-seen-date";

   if self.BackDrop then
      self.BackDrop:setVisible(true);
   end
        local shouldShowAdButton = false;

    if self.DidShowAd then
        self:startReward();
        self.DidShowAd = false;
        App.data:setValue(lastAdSeenDateKey,os.time( ));
        self.videoReviveButton:setVisible(false);
        self.videoButtonIcon:setVisible(false);
        self.videoReviveButton:disable();
        self.MysteryButton:setLocX(0);
        self.iconText:setLocX(20);
        self.iconTextBkgd:setLocX(22);
    else

       local gemCost = AbTestMgr:getMysteryGemCost();
       if gemCost and gemCost ~= MB_GEM_COST then
          MB_GEM_COST = gemCost;
       end

       self:costTypeCheck();

       self:updateTokenCount();

       self.spinning = nil;
       self:resetPage();
       local mGames = App.data:getValue("mystery-games-since-screen");
       if mGames and mGames > 0 then
          App.data:setValue("mystery-games-since-screen", 0);
       end

       if not App.data:getValue(lastAdSeenDateKey) then
            App.data:setValue(lastAdSeenDateKey,0);
       end

       local lastDate = App.data:getValue(lastAdSeenDateKey);
       local currentDate = os.time();
       if ((currentDate - lastDate) > (24 * 60 * 60)) and AdMgr:isVideoAvailable() then
           shouldShowAdButton = true;
       else
           shouldShowAdButton = false;
       end

       if shouldShowAdButton then
           self.MysteryButton:setLocX(-130);
           self.MysteryAlert:setLocX(-35);
           self.MysteryAlertSparkle:setLocX(-35);
           self.tokenCountText:setLocX(-5);
           self.iconText:setLocX(20-130);
           self.iconTextBkgd:setLocX(22-130);
           self.videoReviveButton:setVisible(true);
           self.videoButtonIcon:setVisible(true);
           self.videoReviveButton:enable();
       else
           self.videoReviveButton:setVisible(false);
           self.videoReviveButton:disable();
           self.videoButtonIcon:setVisible(false);
           self.MysteryButton:setLocX(0);
           self.MysteryAlert:setLocX(90);
           self.MysteryAlertSparkle:setLocX(90);
           self.tokenCountText:setLocX(-3);

           self.iconText:setLocX(20);
           self.iconTextBkgd:setLocX(22);
       end
    end
end

----------------------------------------------------------------

function StateMysteryBox:onUpdate( dt )

   State.onUpdate(self);

   self:mysteryLoopUpdate( dt );
   self:pulseTimerUpdate( dt );

end


------------------------------------------------------------------------------------

function StateMysteryBox:onLoseFocus()

   State.onLoseFocus(self);

   StateMgr:setSyncBusyDelay(nil);

end

----------------------------------------------------------------------

function StateMysteryBox:isBusy()

   return StoreMgr:isBusy();

end

----------------------------------------------------------------

function StateMysteryBox:onMysteryButton()

   if self.costType == "tokens" then
      self:goSpendTokens();
   elseif self.costType == "gems" then
      self:goSpendGems();
   elseif self.costType == "buygems" then
      self:goGetGems();
   end

end

----------------------------------------------------------------

function StateMysteryBox:updateTokenCount()


   local tokens = App.data:getFreebieCount("mystery");
   if tokens then
      if tokens > 99 then
         tokens = 99;
      end
      if tokens > 0 then
         self.tokenCountText:setText(""..tokens);
      elseif self.paid == "free" then
         self.tokenCountText:setText("0");
      else
         self.tokenCountText:setText("");
      end
   end

end

----------------------------------------------------------------

function StateMysteryBox:goSpendTokens()

   self.paid = "free";

   self.MysteryAlert:setVisible(false);
   self.MysteryAlert:stop();
   self.MysteryAlertSparkle:setVisible(false);
   self.MysteryAlertSparkle:stop();
   self.tokenCountText:setVisible(false);

   App.data:spendFreebie("mystery", MB_TOKEN_COST, "opened mystery box");

   self:updateTokenCount();
   self:startReward();

end

----------------------------------------------------------------

function StateMysteryBox:goSpendGems()

   self.iconTextBkgd:setColor(0,0,0,0.25);
   self.iconText:setColor(1,1,1,0.25);

   self.paid = ""..MB_GEM_COST;

   if App.data:spendGem( MB_GEM_COST, "mysterybox" ) then
      self:startReward();
   end

end

----------------------------------------------------------------

function StateMysteryBox:goGetGems()

   AUTO_PURCHASE_DATA.state		=  'StateMysteryBox';
   AUTO_PURCHASE_DATA.carIndex	=  ""..-1;
   AUTO_PURCHASE_DATA.reason1		=  'BuyMysteryReward';
   AUTO_PURCHASE_DATA.reason2		=  'BuyMysteryReward';
   AUTO_PURCHASE_DATA.price		=  MB_GEM_COST;
   AUTO_PURCHASE_DATA.currency	=  'Gem';
	AUTO_PURCHASE_FUNC				=	function()
													self:onFocus();
												end

	StateMgr:push("state/state-auto-purchase-popup-maz.lua");

end

----------------------------------------------------------------

function StateMysteryBox:startReward()

   self.MysteryButton:disable();
   self.BackButton:disable();

   if self.resourceBar then
      self.resourceBar.CoinButton:disable();
      self.resourceBar.KeyButton:disable();
      self.resourceBar.GemButton:disable();
   end

   self.MysteryButton:setColor(1,1,1,0.25);
   self.BackButton:setColor(1,1,1,0.25);

   self.spinning = true;

   App.data:deltaValue("mystery-spin-count",1);

   if self.costType ~= "tokens" then
      App.data:deltaValue("mystery-spin-paid-count",1);
   end

   local cSounds = {loop={"MysterySpin",},};
   EventMgr:postEvent( { sounds=cSounds, name="mystery loop",}, "add-sfx" );

   local outroAnim = nil;
   local outroLoop = nil;
   -- pick winner from table
   self.winner = self:pickWinner();
   self:mysteryLoopStart();

end

----------------------------------------------------------------

function StateMysteryBox:mysteryLoopStart()


   self.totalFlashes = 25;
   self.flashesRemaining = self.totalFlashes;

   self.flashAnim = self:getWeightedAnim()

   self.flashTimer = FLASH_ANIM_LENGTH;

   self.slowFlashStart = -1;
   self.slowIncrement = FLASH_ANIM_LENGTH/8;

   self.panelGrid[self.flashAnim]["animation"]:start();

end

----------------------------------------------------------------

function StateMysteryBox:mysteryLoopUpdate( dt )

   if self.flashTimer and self.flashesRemaining then

      self.flashTimer = self.flashTimer - dt;

      if self.flashTimer <= 0 then
         self.flashesRemaining = self.flashesRemaining - 1;
         if self.flashesRemaining <= 0 then
            self.flashesRemaining = nil;
            self.flashTimer = nil;
            self:mysteryLoopEnd();
         else
            local timerAdd = 0;
            if self.slowFlashStart > 0 and (self.totalFlashes - self.flashesRemaining) >= self.slowFlashStart then
               timerAdd = ((self.totalFlashes - self.flashesRemaining)-self.slowFlashStart) * self.slowIncrement;
            end

            self.flashTimer = FLASH_ANIM_LENGTH + timerAdd;

            self.flashAnim = self:getWeightedAnim();
            self.panelGrid[self.flashAnim]["animation"]:start();
         end
      end

   end

end

----------------------------------------------------------------

function StateMysteryBox:getWeightedAnim()

   local flash_percent_threshold = 20/100;
   local flash_percent_remaining = self.flashesRemaining/self.totalFlashes;

   local anim = math.random(1,10);

   if flash_percent_threshold >= flash_percent_remaining then

      anim = self:randomizeFromTable( true );

   else

      anim = self:randomizeFromTable( false );

   end

   return anim;

end

----------------------------------------------------------------

function StateMysteryBox:randomizeFromTable( useTable )

   local anim = 1;

   if useTable then

      if self.winner and NEAR_SQUARES[self.winner] then

         local choice = math.random(1,#NEAR_SQUARES[self.winner]);

         anim = NEAR_SQUARES[self.winner][choice];

      end

   else

      anim = math.random(1,10);

   end

   if self.lastRandom then
      if self.lastRandom == anim then
         self:randomizeFromTable( useTable );
      end
   end

   self.lastRandom = anim;

   return anim;

end

----------------------------------------------------------------

function StateMysteryBox:mysteryLoopEnd()

   local cSounds = {loop={"MysterySpin",},};
   EventMgr:postEvent( {sounds=cSounds, name="mystery loop stop",}, "loop-stop" );

   self:revealTransition();

end

----------------------------------------------------------------

function StateMysteryBox:pulseTimerStart()

   self.pulseTimer = 2.0;
   local cSounds = {start={"MysteryReveal",},};
   EventMgr:postEvent( { sounds=cSounds, name="mystery reveal",}, "add-sfx" );

end

----------------------------------------------------------------

function StateMysteryBox:pulseTimerUpdate( dt )

   if self.pulseTimer then
      self.pulseTimer = self.pulseTimer - dt;
      if self.pulseTimer <= 0 then
         self.pulseTimer = nil;
         self:revealTransition()
      end
   end

end

----------------------------------------------------------------

function StateMysteryBox:revealTransition()

   self.panelGrid[self.winner]["animation"]:stop();
   self.panelGrid[self.winner]["animation"]:setVisible(false);
   self.panelGrid[self.winner]["icon1"]:setVisible(false);
   self.panelGrid[self.winner]["icon2"]:setVisible(false);

   StateMgr:push("state/state-mystery-box-reveal.lua", {animNum=self.winner});

end

----------------------------------------------------------------

function StateMysteryBox:resetPage()

   self.MysteryButton:enable();
   self.BackButton:enable();

   if self.resourceBar then
   	self.resourceBar.CoinButton:enable();
   	self.resourceBar.KeyButton:enable();
   	self.resourceBar.GemButton:enable();
   end

   self:costTypeCheck();
   self.BackButton:setColor(1,1,1,1);
   self.MysteryButton:setColor(1,1,1,1);
   self.iconTextBkgd:setColor(0,0,0,1);
   self.iconText:setColor(1,1,1,1);

   self:resetGrid();

end


----------------------------------------------------------------

function StateMysteryBox:costTypeCheck()

   self.tokens = App.data:getFreebieCount("mystery");
   local oldCostType = self.costType;

   if self.tokens and self.tokens > 0 then

      self.costType = "tokens";

   --joe can getgemcount = nil?
   elseif App.data:getGemCount() >= MB_GEM_COST then

      self.costType = "gems";

   else

      self.costType = "buygems";

   end


   if self.costType == "tokens" then

      self.MysteryButton:swapAnim("Button_Buy_Free");
      self.MysteryAlert:setVisible(true);
      self.MysteryAlert:start();
      self.MysteryAlertSparkle:setVisible(true);
      self.MysteryAlertSparkle:start();
      self.tokenCountText:setVisible(true);

      self.iconTextBkgd:setText("");
      self.iconText:setText("");

   elseif self.costType == "gems" then

      self.tokenCountText:setText("");
      self.MysteryAlert:setVisible(false);
      self.MysteryAlert:stop();
      self.MysteryAlertSparkle:setVisible(false);
      self.MysteryAlertSparkle:stop();

      self.MysteryButton:swapAnim("Button_Buy_Gem");
      self.iconTextBkgd:setText(""..MB_GEM_COST);
      self.iconText:setText(""..MB_GEM_COST);

      if MB_GEM_COST > 9 then
         self.iconTextBkgd:setLoc(42,-360);
         self.iconText:setLoc(40, -358);
      else
         self.iconTextBkgd:setLoc(32,-360);
         self.iconText:setLoc(30, -358);
      end

   elseif self.costType == "buygems" then

      self.tokenCountText:setText("");
      self.MysteryAlert:setVisible(false);
      self.MysteryAlert:stop();
      self.MysteryAlertSparkle:setVisible(false);
      self.MysteryAlertSparkle:stop();

      self.MysteryButton:swapAnim("Button_NoBuy_Gem");
      self.iconTextBkgd:setText(""..MB_GEM_COST);
      self.iconText:setText(""..MB_GEM_COST);

      if MB_GEM_COST > 9 then
         self.iconTextBkgd:setLoc(42,-360);
         self.iconText:setLoc(40, -358);
      else
         self.iconTextBkgd:setLoc(32,-360);
         self.iconText:setLoc(30, -358);
      end

   end




end

----------------------------------------------------------------

function StateMysteryBox:moduloCheck()


   local played = App.data:getGamePlayed();
   if played and (played % 563) == 0 then
      print("returning mod true");
      return true
   end

   return false

end

----------------------------------------------------------------

function StateMysteryBox:pickWinner( )

	local choicesTbl = AbTestMgr:getMysteryOddsTable();

	if choicesTbl then

		local pick  = nil;
		local total = 0;

		for i,choice in ipairs(choicesTbl) do
			local value = i;
			local odd   = choice;

			if value and odd and odd > 0 then
				total = total + odd;

				if math.random() <= math.min(odd/total, 1) then
					pick = value;
				end
			end
		end

      if pick and pick == 1 then
         if self:moduloCheck() then
            return pick;
         else
            return self:pickWinner();
         end
      end

      return pick;

      --joehack for testing all anims
--[[
      if self.hackReturn then
         self.hackReturn = self.hackReturn + 1;
         if self.hackReturn > 10 then
            self.hackReturn = 1;
         end
      else
         self.hackReturn = 1;
      end
      return self.hackReturn;
]]

	end

end

----------------------------------------------------------------

function StateMysteryBox:watchVideoForMysteryReward()
    self.DidShowAd      = true;
    if AdMgr:isVideoAvailable() then
        StateMgr:push("state/state-video-play.lua", {rewardType="gold", rewardAmount=0} );
    else
       self.videoReviveButton:setVisible(false);
       self.videoButtonIcon:setVisible(false);
       self.videoReviveButton:disable();
    end
end

----------------------------------------------------------------

function StateMysteryBox:onBackButton()

	self:goBack();

end

----------------------------------------------------------------

function StateMysteryBox:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

function StateMysteryBox:goBack()

   if not self.spinning then
      StateMgr:pop();
   end

end

----------------------------------------------------------------

return StateMysteryBox;

----------------------------------------------------------------
