----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SHOP_TRAY_HOME_X		= 0;
local SHOP_TRAY_HOME_Y		= 0;
local SHOP_TRAY_SHIFT		= 300;
local COIN_COUNT_X			= -143;
local COIN_COUNT_Y			= 437;
local GEM_COUNT_X				= 163;
local GEM_COUNT_Y				= 437;
local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

local    CLOSE_X           = 265;
local    CLOSE_Y           = 151;
local    BUY_X             = 0;
local    BUY_Y             = -115;
local    TEXT_X            = 0;
local    TEXT_Y            = 0;
local    TITLE_X           = 0;
local    TITLE_Y           = 40;

----------------------------------------------------------------

local Base						= State;
local StateNeedGem			= Base:new();

----------------------------------------------------------------

function StateNeedGem:onLoad()

   State.onLoad( self );

   self.IS_POPUP              = true;
   self.defaultFontName = "resources/font/TangoLatin.otf";

   self.uiLayer               = self:addLayer();

   local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);


   self.buyButton             = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition,BUY_X,BUY_Y,0,0, "BuyButton", textureSheet, nil, self.goConfirm, nil, nil);
   self.buyButton:setPriority(PRIORTY_2);

   self.buyButtonTextShd      = self:addWidget(TextBox, self.mainLayer, 3, BUY_Y-3, 360, 220, "", self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.buyButtonTextShd:setPriority(PRIORTY_3);
   self.buyButtonTextShd:setColor(0,0,0);

   self.buyButtonText         = self:addWidget(TextBox, self.mainLayer, 0, BUY_Y, 360, 220, "", self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.buyButtonText:setPriority(PRIORTY_4);

   self.closeButton           = self:addWidget(ButtonAnim, self.mainLayer,  self.mainPartition,CLOSE_X, CLOSE_Y, 0, 0, "CloseButton", textureSheet, nil, self.goBack, nil, nil);
   self.closeButton:setPriority(PRIORTY_10);

   -- background and icon
   self.BackDrop              = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "SmallBackGround", textureSheet);
   self.BackDrop:setPriority(PRIORITY_0);

   self.TitleTextBkgd         = self:addWidget(TextBox, self.mainLayer, TITLE_X+2, TITLE_Y-2, 500, 220, "", self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
   self.TitleTextBkgd:setPriority(PRIORTY_2);
   self.TitleText             = self:addWidget(TextBox, self.mainLayer, TITLE_X,   TITLE_Y,     500, 220, "", self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
   self.TitleText:setPriority(PRIORTY_3);

   self.MessageTextBkgd       = self:addWidget(TextBox, self.mainLayer, TEXT_X-2, TEXT_Y+2, 500, 220, "", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.MessageTextBkgd:setPriority(PRIORTY_2);
   self.MessageTextBkgd:setLineSpacing(10);
   self.MessageText           = self:addWidget(TextBox, self.mainLayer, TEXT_X, TEXT_Y, 500, 220, "", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.MessageText:setPriority(PRIORTY_3);
   self.MessageText:setLineSpacing(10);


   self.index                 = 1;

end

----------------------------------------------------------------

function StateNeedGem:onActivate( )

   State.onActivate( self );

   self.info      = {};
   self.cost      = nil;
   self.index     = nil;
   self.productId = nil;

end

----------------------------------------------------------------

function StateNeedGem:onFocus( info  )

   State.onFocus( self );

   self.info      = info                  or  (self.info or {});
   self.cost      = self.info.cost        or  self.cost;
   self.productId = self.info.productId   or  self.productId;
   self.reason    = self.info.reason      or  "unknown";

   print("StateNeedGem:onFocus", self.info);

   if self.productId == nil and self.cost ~= nil then

      self.productId = StoreMgr:getGemAutoBuyId( self.cost );

   end

   self.buyButton:enable();
   self.buyButton:show();
   self.buyButton:swapAnim( "BuyButton");

   local title = self.info.title;

   if title == nil then
      title = "You Need Gems";
   end

   self.TitleText:setText(    "<c:fefcfc>"..title.."</>");
   self.TitleTextBkgd:setText("<c:0b141d>"..title.."</>");


   local text =   ( self.info.message )
      or ( "Buy " .. StoreMgr:getProductAmount(self.productId).gem .. " gems");

   self.MessageText:setText(     "<c:1b3043>"..text.."</>" );
   self.MessageTextBkgd:setText( "<c:8fb5cd>"..text.."</>" );

   local buttonText = StoreMgr:getGemCostDisplay(self.productId);

   print( "StateNeedGem:onFocus", self.productId, buttonText );

   self.buyButtonTextShd:setText(buttonText);
   self.buyButtonText:setText(buttonText);

   self._waitAppStore = false;

end

----------------------------------------------------------------

function StateNeedGem:onLoseFocus( )

   State.onLoseFocus( self );

   StateMgr:setSyncBusyDelay( );

end

----------------------------------------------------------------

function StateNeedGem:isBusy()

   return self._waitAppStore;

end

----------------------------------------------------------------------

function StateNeedGem:getBusyName()

   return "Waiting for Store";

end

----------------------------------------------------------------

function StateNeedGem:showErrorPopup()

   MOAIDialogIOS.showDialog( LocalizationMgr:getString( "NATIVE_TRANS_FAIL" )
                             ,  LocalizationMgr:getString( "NATIVE_TRY_AGAIN" )
                             ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                             ,  nil
                             ,  nil
                             ,  false
                             ,  function()
                                enableButtonInput();
                                self._waitAppStore = false;
                                end
   );

end

----------------------------------------------------------------

function StateNeedGem:goConfirm()

   print("StateNeedGem:goConfirm-1");

   --self.SaveButton:disable();

   disableButtonInput();

   self._waitAppStore = true;
   StateMgr:setSyncBusyDelay( 0 );

   delay(1,
         function()
            local success = StoreMgr:buyProduct( self.productId,
                                                 self,
                                                 function ()

                                                    print("StateNeedGem:goConfirm-2");

                                                    enableButtonInput();

                                                    local bGems = StoreMgr:getProductAmount(self.productId).gem;

                                                    EventMgr:postEvent( {  gem=bGems, productId=self.productId, source="auto-buy" }, "gems-bought" );

                                                    MOAIFlurry:event(   "auto-buy-gem-success"
                                                                        , "type",                     "Gem"
                                                                        ,  "productId",               ""..self.productId
                                                                        ,  "amount",                  ""..tostring(bGems)
                                                                        , "state",                    "StateNeedGem"
                                                                        , "reason1",                  "revive"
                                                                        , "reason2",                  "revive-".. (self.info.cost or "?")
                                                                        , "carIndex",                 "-1"
                                                    );

                                                    StateMgr:pop( nil, { StateNeedGemResult="success" } );
                                                 end
                                                 ,
                                                 function ()

                                                    print("StateNeedGem:goConfirm-3");
                                                    self._waitAppStore = false;
                                                    enableButtonInput();
                                                    self:showErrorPopup();
                                                 end
            );
            if not success then

               print("StateNeedGem:goConfirm-4");
               self._waitAppStore = false;
               enableButtonInput();
               self:showErrorPopup();
            end
         end
   );

end

----------------------------------------------------------------

function StateNeedGem:onSaveSuccess()

   local total = App.data:deltaValue("revive-total-count",1);

end

----------------------------------------------------------------

function StateNeedGem:goBack()

	print("Go Back");

   StateMgr:pop(  nil, { StateNeedGemResult="back" } );

end

----------------------------------------------------------------

function StateNeedGem:isUsingCameraHack()
   return false;
end


----------------------------------------------------------------

return StateNeedGem;

----------------------------------------------------------------
