----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;

----------------------------------------------------------------

local Base						= State;
local StatePause			= Base:new();
local localApp					= nil;
local localSelf				= nil;


local textLoc = {
                           { text1={x=60,y=87}, text2={x=60,y=47}, textcenter={x=60,y=67} },
                           { text1={x=60,y=-43}, text2={x=60,y=-83}, textcenter={x=60,y=-63} },
                           { text1={x=60,y=-173}, text2={x=60,y=-213}, textcenter={x=60,y=-193} },
                        };
								
local DAILY_TIME_X         = 103;
local DAILY_TIME_Y         = 50.925;

local STAR_X					= 0;
local STAR_Y					= 250.5;
local STAR_SPACING			= 109;
local STAR_W					= 84;
local STAR_H					= 84;

local screenWidth          = App.viewportWidth;
local screenHeight         = App.viewportHeight;

local guestText1				= "Get the Full Game"
local guestText2				= "Upgrade your Weapons, Armor, and Powerups"
local guestText3				= "WEEKLY and DAILY Challenges"
local guestText4				= "BRAG to your friends on the Leaderboard"

local missionOverText		= "All missions complete!";

local blue	= {0.514, 0.643, 0.773, 1};

local FPS = 30;

local animLength = 100.8/FPS;


----------------------------------------------------------------

function StatePause:onLoad()

   State.onLoad( self );
	localSelf      = self;

	self:createProps();
	
end

----------------------------------------------------------------

function StatePause:guestVis()

	self.GuestBlueBox:setVisible(true);
	self.guestText1:setVisible(true);
	self.guestText2:setVisible(true);
	self.guestText3:setVisible(true);
	self.guestText4:setVisible(true);
	self.GuestCheck1:setVisible(true);
	self.GuestCheck2:setVisible(true);
	self.GuestCheck3:setVisible(true);

end

----------------------------------------------------------------

function StatePause:normalVis()

	self.GuestBlueBox:setVisible(false);
	self.guestText1:setVisible(false);
	self.guestText2:setVisible(false);
	self.guestText3:setVisible(false);
	self.guestText4:setVisible(false);
	self.GuestCheck1:setVisible(false);
	self.GuestCheck2:setVisible(false);
	self.GuestCheck3:setVisible(false);
	
	self.missionOverText:setVisible(false);

end

----------------------------------------------------------------

function StatePause:missionOverVis()

	for i=1,3 do
		self.goal[i].box.anim:setPriority(0);
		self.goal[i].bar.anim:setPriority(0);
	end
	self.missionName:setText("");
	self.missionOverText:setVisible(true);

end

----------------------------------------------------------------

function StatePause:updateProps()

	print("update props started");
	
	self.curMI = App.data:getMissionIndex();
	self.missionTpl = App.data:getCurrentMissionTemplate( );

   self:normalVis();
   
	--set cover visible or not, based on daily unlocked / missions unlocked
	if not App.data:isDailyUnlocked() then
		self.dailyCover:setVisible(true);
	else	
		self.dailyCover:setVisible(false);
	end
	if not App.data:isMissionUnlocked() then
		self.missionCover:setVisible(true);
	else
		self.missionCover:setVisible(false);
	end


	--daily stars setup
	self.dailyactive = App.data:isDailyActive();
   self.dailygoal = App.data:getDailyChallengeGoal();
   self.dailyprogress = App.data:getDailyChallengeProgress();
   self.dailystreak = App.data:getDailyChallengeStreak();
   self.day = math.min(self.dailystreak, 5);
	
   print("App.data:isDailyActive()" ,  App.data:isDailyActive()
                                    ,  App.data:getDailyChallengeGoal()
                                    ,  App.data:getDailyChallengeProgress() 
                                    ,  App.data:getDailyChallengeStreak()     );
   
	self:starReset();
	self:boxReset();
	self.timerTable = {};
	
	if self.dailyactive then
		for i=1,self.dailygoal do
			if i <= self.dailyprogress or i == -1 or not self.dailyactive then
				--place gold star
				self:starCalc(i, self.dailygoal, "On");

			else
				--place grey star
				self:starCalc(i, self.dailygoal, "Off");
			end
		end
	else
		for i=1,self.day do
			--place gold star
			self:starCalc(i, self.day, "On");
		end
	end
   
   if self.missionTpl then

      -- If they're done with missions, hide all the regular stuff, and show the mission over stuff
      if self.missionTpl.final then
         self:missionOverVis();
         return;
      end
      
      self.missionName:setText("MISSION "..tostring(self.missionTpl.name));
      
      --self.gemReward:setText("REWARD: "..tostring(self.missionTpl.reward.gem.." x"))
      
      for i=1,3 do
      
         --get the current goal progress from the server
         if App.mission then

            self.goal[i].displayScore = App.mission.goals[i].cumulativeScore;
            
            if self.goal[i].displayScore == nil then
               self.goal[i].displayScore = 0;
            end
         
            self.goal[i].objective = self.missionTpl.goals[i].objective;
            --joe: is there a better way to make this exception?
            if self.missionTpl.goals[i].highScore then
               self.goal[i].objective = RankingMgr:getPlayerHiScore();
            end
            
            self.goal[i].cumulative = self.missionTpl.goals[i].cumulative; 
            
            --see if they're done
            local serverProg = App.data:getCurrentMissionGoalProgress( i )

            if serverProg == -1 then
               --they've completed the goal
               self.goal[i].box.anim:setAnimFrame(2);
               self.goal[i].bar.anim:setVisible(false);
               self.goal[i].bar.anim:setPriority(0);
            else
               self.goal[i].bar.anim:setVisible(true);
               self.goal[i].bar.anim:setPriority(PRIORTY_5);
               self.goal[i].displayScore = math.floor(self.goal[i].displayScore);
               self.goal[i].bar.startSpan = animLength * ( self.goal[i].displayScore/self.goal[i].objective );
               self.goal[i].bar.anim:setSpan( self.goal[i].bar.startSpan, self.goal[i].bar.startSpan );
               self.goal[i].bar.anim:setTime( self.goal[i].bar.startSpan );
               self.goal[i].bar.anim:start();
            end

            
            --set up the goal text
            local pText1, pText2, textX, textY, boxW, boxH;
            if math.floor(self.goal[i].displayScore) > 0 then
               if self.missionTpl.goals[i].hideNum then
                  pText1 = "";
               else
                  pText1 = tostring( math.floor(self.goal[i].displayScore) ).."/"..tostring(self.goal[i].objective);
               end
            
               if self.missionTpl.goals[i].twoLinePause then
               
                  pText1 = pText1.. " ".. self.missionTpl.goals[i].pauseText1;
                  pText2 = self.missionTpl.goals[i].pauseText2;
               
                  self.goal[i].text1Shadow:setText(pText1);
                  self.goal[i].text1:setText(pText1);

                  self.goal[i].text2Shadow:setText(pText2);
                  self.goal[i].text2:setText(pText2);
               
               else
               
                  pText1 = pText1.. " ".. self.missionTpl.goals[i].pauseText;
               
                  self.goal[i].textShadow:setText(pText1);
                  self.goal[i].text:setText(pText1);
            
               end
            
            else
            
               if self.missionTpl.goals[i].twoLine then
            
                  pText1 = self.missionTpl.goals[i].text1
                  pText2 = self.missionTpl.goals[i].text2
               
                  self.goal[i].text1Shadow:setText(pText1);
                  self.goal[i].text1:setText(pText1);

                  self.goal[i].text2Shadow:setText(pText2);
                  self.goal[i].text2:setText(pText2);
               else
                  pText1 = self.missionTpl.goals[i].text
                  self.goal[i].textShadow:setText(pText1);
                  self.goal[i].text:setText(pText1);
               end
            end
            
            -- timed quest text setup
            self:timerCheck(i);
            
         end
         
      end
   else
      -- there is no mission template, set the cover visible, to avoid buggy looking pause screen
      self.missionCover:setVisible(true);
   end

end
----------------------------------------------------------------

function StatePause:createProps()

   self.defaultFontName = "resources/font/TangoLatin.otf";

	self.textureSheet      = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
	

	
	-- black overlay
   self.Overlay = self:addWidget(Image, self.mainLayer, 0, 0, App.viewportWidth, App.viewportHeight, "resources/UI/blackbox.png", {1,1,1, 0.75});
	self.Overlay:setPriority(PRIORTY_0);
	
	-- background
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "P_MissionPopUpBackDrop", self.textureSheet);
	self.BackDrop:setPriority(PRIORTY_0);
	
	-- bluebox
	self.BlueBox = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "P_BlueBox", self.textureSheet);
	self.BlueBox:setPriority(PRIORTY_0);

	-- guest bluebox
	self.GuestBlueBox = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "P_GuestBlueBox", self.textureSheet);
	self.GuestBlueBox:setPriority(PRIORTY_7);
	self.GuestBlueBox:setVisible(false);
	
	--mission/daily locked covers
	self.missionCover = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "P_UnLockMission", self.textureSheet);
	self.missionCover:setVisible(false);
	self.missionCover:setPriority(PRIORTY_9);
	self.dailyCover = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "P_UnLockDaily", self.textureSheet);
	self.dailyCover:setVisible(false);
	self.dailyCover:setPriority(PRIORTY_9);

	-- guest checkboxes
	self.GuestCheck1 = self:addWidget(Anim, self.mainLayer, -205,185,99,104, "P_Checkmark", self.textureSheet);
	self.GuestCheck2 = self:addWidget(Anim, self.mainLayer, -205,30,129,104, "P_Checkmark", self.textureSheet);
	self.GuestCheck3 = self:addWidget(Anim, self.mainLayer, -205,-125,99,104, "P_Checkmark", self.textureSheet);
	self.GuestCheck1:setPriority(PRIORTY_7);
	self.GuestCheck2:setPriority(PRIORTY_7);
	self.GuestCheck3:setPriority(PRIORTY_7);
	self.GuestCheck1:setVisible(false);
	self.GuestCheck2:setVisible(false);
	self.GuestCheck3:setVisible(false);
	
	self.guestText1 = self:addWidget( TextBox, self.mainLayer,
                                          0, 313, 600, 150, 
                                          guestText1, self.defaultFontName, 26, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText2 = self:addWidget( TextBox, self.mainLayer,
                                          55, 185, 378, 200, 
                                          guestText2, self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText3 = self:addWidget( TextBox, self.mainLayer,
                                          55, 30, 378, 200, 
                                          guestText3, self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText4 = self:addWidget( TextBox, self.mainLayer,
                                          55, -125, 378, 200, 
                                          guestText4, self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.guestText1:setPriority(PRIORTY_8);
	self.guestText2:setPriority(PRIORTY_8);
	self.guestText3:setPriority(PRIORTY_8);
	self.guestText4:setPriority(PRIORTY_8);
	
	self.guestText1:setVisible(false);
	self.guestText2:setVisible(false);
	self.guestText3:setVisible(false);
	self.guestText4:setVisible(false);
	
	self.missionOverText = self:addWidget( TextBox, self.mainLayer,
                                          0, 0, 300, 300, 
                                          missionOverText, self.defaultFontName, 26, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
	self.missionOverText:setPriority(PRIORTY_8);
	self.missionOverText:setVisible(false);
	
	-- title
	self.TitleImage = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "P_TitlePaused", self.textureSheet, nil, nil, true);
	self.TitleImage:setPriority(PRIORTY_3);
	
	-- gem
	--self.gemReward = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "M_GemReward", self.textureSheet, nil, nil, true);
	
	-- state buttons
	
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "P_ReadyButton", self.textureSheet, nil, self.goBack, nil, nil, nil, nil);
	self.BackButton:setPriority(PRIORTY_3);
	
	self.QuitGameButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "P_QuitGameButton", self.textureSheet, nil, self.goQuit, nil, nil);
	self.QuitGameButton:setPriority(PRIORTY_3);
	
	self.OptionsButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "P_OptionsIcon", self.textureSheet, nil, self.goOptions, nil, nil, nil, nil);
	self.OptionsButton:setPriority(PRIORTY_3);

   self:_setupBasicResourceBar();

   self.starOnAnims = {};
   self.starOffAnims = {};
	--daily stars
	for i=1,5 do
		self.starOnAnims[i] = self:addWidget(Anim, self.mainLayer, 0, 0, STAR_W, STAR_H,
		"P_StarOn", self.textureSheet, nil, nil, true);
		self.starOnAnims[i]:setPriority(PRIORTY_3);	
		self.starOnAnims[i]:setVisible(false);
		self.starOffAnims[i] = self:addWidget(Anim, self.mainLayer, 0, 0, STAR_W, STAR_H,
		"P_StarOff", self.textureSheet, nil, nil, true);
		self.starOffAnims[i]:setPriority(PRIORTY_3);	
		self.starOffAnims[i]:setVisible(false);
	end
	
	self.missionName = self:addWidget( TextBox, self.mainLayer,
                                          -80.65, 165.5, 325, 110,
                                          "", self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
   self.missionName:setPriority(PRIORTY_3);

	self.dailyTitle = self:addWidget( TextBox, self.mainLayer,
                                          -140.65, 327.75, 205.65, 110, 
                                          "DAILY", self.defaultFontName, 18, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
   self.dailyTitle:setPriority(PRIORTY_3);
	
	self.dailyTimeText = self:addWidget( TextBox, self.mainLayer,
                                          65, 327.75, 370, 110, 
                                          "--:--:--", self.defaultFontName, 16, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          blue
                                          );
   self.dailyTimeText:setPriority(PRIORTY_3);
   
   --mission boxes
	
   self.goal = {};
   
   for i=1,3 do
   
      self.goal[i] = {};
                                           
      self.goal[i].box = {};

      self.goal[i].box.anim = self:addWidget( Anim, self.mainLayer, 0, 0, 0, 0, "P_MissionBanner0".. i, self.textureSheet );
      self.goal[i].box.anim:setPriority(PRIORTY_4);
		
		self.goal[i].bar = {};
      self.goal[i].bar.anim = self:addWidget( Anim, self.mainLayer, 0, 0, 0, 0, "P_MissionProgressBar0".. i, self.textureSheet );
      self.goal[i].bar.anim:setPriority(PRIORTY_5);
  
		textX = textLoc[i].text1.x;
		textY = textLoc[i].text1.y;
		boxW = 365;
		boxH = 60;
		pText1 = "";
		pText2 = "";

		self.goal[i].text1Shadow = self:addWidget( TextBox, self.mainLayer,
                                          textX+3, textY-3, boxW, boxH, 
                                          pText1, self.defaultFontName, 16, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {0,0,0,1}
                                          );
		
		self.goal[i].text1 = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          pText1, self.defaultFontName, 16, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );                                   
		textX = textLoc[i].text2.x;
		textY = textLoc[i].text2.y;
          
		self.goal[i].text2Shadow = self:addWidget( TextBox, self.mainLayer,
                                          textX+3, textY-3, boxW, boxH, 
                                          pText2, self.defaultFontName, 16, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {0,0,0,1}
                                          );
		self.goal[i].text2 = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          pText2, self.defaultFontName, 16, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
														
		textX = textX + 50;
		
		self.goal[i].text2TimerShadow = self:addWidget( TextBox, self.mainLayer,
                                          textX+3, textY-3, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {0,0,0,1}
                                          );
		self.goal[i].text2Timer = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          "", self.defaultFontName, 16, nil, 
                                          MOAITextBox.LEFT_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );
                                          
		self.goal[i].text2TimerShadow:setPriority(PRIORTY_5);
		self.goal[i].text2Timer:setPriority(PRIORTY_6);
		self.goal[i].text1:setPriority(PRIORTY_6);
		self.goal[i].text1Shadow:setPriority(PRIORTY_5);
		self.goal[i].text2:setPriority(PRIORTY_6);
		self.goal[i].text2Shadow:setPriority(PRIORTY_5);
         

      
		textX = textLoc[i].textcenter.x;
		textY = textLoc[i].textcenter.y; 
		boxW = 365;
		boxH = 80;
		pText1 = "";
      
		self.goal[i].textShadow = self:addWidget( TextBox, self.mainLayer,
                                          textX+3, textY-3, boxW, boxH, 
                                          pText1, self.defaultFontName, 16, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {0,0,0,0}
                                          );
		self.goal[i].text = self:addWidget( TextBox, self.mainLayer,
                                          textX, textY, boxW, boxH, 
                                          pText1, self.defaultFontName, 16, nil, 
                                          MOAITextBox.CENTER_JUSTIFY,   MOAITextBox.CENTER_JUSTIFY,
                                          {1,1,1,1}
                                          );                                   
		self.goal[i].text:setPriority(PRIORTY_6);
		self.goal[i].textShadow:setPriority(PRIORTY_5);
      
   end

end

----------------------------------------------------------------

function StatePause:onActivate()

	State.onActivate( self );

	GamePaused = true;
   EventMgr:postEvent( {state="state/state-options.lua"}, "game-paused" );
	
   self.gameState = StateMgr.stateStack [ #StateMgr.stateStack-1 ]

	self:updateProps();

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

end

----------------------------------------------------------------

function StatePause:onDeactivate( )

   Base.onDeactivate(self);

end

----------------------------------------------------------------

function  StatePause:starCalc( i, stars, append )

	local startX = ((STAR_SPACING/2) * -1) * (stars - 1);
	local xOffset = startX + ((i-1) * STAR_SPACING);
	
	if append == "On" then
		self.starOnAnims[i]:setLoc(xOffset + STAR_X, STAR_Y );
		self.starOnAnims[i]:setVisible(true);
	else
		self.starOffAnims[i]:setLoc(xOffset + STAR_X, STAR_Y );
		self.starOffAnims[i]:setVisible(true);
	end
end

----------------------------------------------------------------

function  StatePause:starReset()


	for i=1,5 do
		self.starOnAnims[i]:setVisible( false );
		self.starOnAnims[i]:setLoc(0,0);
		self.starOffAnims[i]:setVisible( false );
		self.starOffAnims[i]:setLoc(0,0);
	end
end

----------------------------------------------------------------

function  StatePause:boxReset()

	for i=1,3 do
		self.goal[i].box.anim:setAnimFrame(0);
		self.goal[i].box.anim:setVisible(true);
		self.goal[i].box.anim:setPriority(PRIORTY_4);
		self.goal[i].bar.anim:setAnimFrame(0);
		self.goal[i].bar.anim:setVisible(true);
		self.goal[i].bar.anim:setPriority(PRIORTY_5);
		self.goal[i].bar.anim:setAlpha(1);
		self.goal[i].text1:setText("");
		self.goal[i].text1Shadow:setText("");
		self.goal[i].text2:setText("");
		self.goal[i].text2Shadow:setText("");
		self.goal[i].text2Timer:setText("");
		self.goal[i].text2TimerShadow:setText("");
		self.goal[i].text:setText("");
		self.goal[i].textShadow:setText("");
	end


end
----------------------------------------------------------------

function StatePause:timerUpdate( dt )

	local time = '--:--:--';
	local countdown = App.data:getDailyChallengeTimer();
   local hours;
   local min;
	local sec;
   
	if countdown then
      
      sec = math.floor(countdown%60);

      if sec < 10 then
         sec = "0".. sec;
      end
      
      min = math.floor((countdown%3600)/60);

      if min < 10 then
         min = "0".. min;
      end
      
      hours = math.floor(countdown/3600);
      
      if hours < 10 then
         hours = "0".. hours;
      end
      
      time = hours.. ":".. min.. ":".. sec;
   end

	if self.dailyactive then
		self.dailyTimeText:setText("Time left "..time);
	else
		local s = tostring(self.dailystreak + 1);
		self.dailyTimeText:setText("Day "..s.." starts  "..time);
	end

end

----------------------------------------------------------------

function StatePause:onUpdate( dt )

	Base.onUpdate(self,dt);
	
   self:timerUpdate( dt );
   if #self.timerTable > 0 then
      self:missionTimer(dt);
   end

end

----------------------------------------------------------------

function  StatePause:timerCheck(i)

	if App.mission.goals[i].timerRunning then
	
		self.goal[i].text2:setText("");
		self.goal[i].text2Shadow:setText("");
		local s = App.data:getValue( "goalTimer"..i.."Start" );
		local t = App.mission.goals[i].timer;
		if s == nil then
			App.mission.goals[i].timerRunning = false;
			App.mission.goals[i].cumulativeScore = 0;
			self.goal[i].displayScore = 0;
			return;
		end
			
		self.timerTable[i] = {start=s, time=t};
		
	end

end

----------------------------------------------------------------

function  StatePause:missionTimer(dt)

	local cur = os.time();
	local display;
	local text;
	
	for i=1,3 do
		if self.timerTable[i] then
		
			display = (self.timerTable[i].start + self.timerTable[i].time) - cur;
			
			if display <= 0 then
			
				self.goal[i].text2:setText(self.missionTpl.goals[i].text2);
				self.goal[i].text2Shadow:setText(self.missionTpl.goals[i].text2);
				self.goal[i].text2Timer:setText("");
				self.goal[i].text2TimerShadow:setText("");
				App.mission.goals[i].timerRunning = false;
				App.mission.goals[i].cumulativeScore = 0;
				self.goal[i].displayScore = 0;
				self.goal[i].bar.anim:setSpan( 0 );
				self.goal[i].bar.anim:setTime( 0 );
				self.goal[i].bar.anim:start();
				self.timerTable[i] = nil;
				App.data:updateMissionGoal(  self.curMI, i, 0 );
				
			else
				
				text = self:convertTime( display );
				self.goal[i].text2Timer:setText("Time left: "..text);
				self.goal[i].text2TimerShadow:setText("Time left: "..text);
			end
		end
	end

end

----------------------------------------------------------------

function StatePause:convertTime( display )

	local time = '--:--:--';
	local countdown = display
   local hours;
   local min;
	local sec;
      
	sec = math.floor(countdown%60);

	if sec < 10 then
		sec = "0".. sec;
	end
      
	min = math.floor((countdown%3600)/60);

	if min < 10 then
		min = "0"..min..":";
	else
		min = min..":";
	end
      
	hours = math.floor(countdown/3600);
      
	if hours < 10 then
		hours = "0"..hours..":";
	else
		hours = hours..":";
	end
      
	time = hours.. min .. sec;
	
	return time;

end

----------------------------------------------------------------

function StatePause:goQuit()

	print("Quit");
	
   -- let the game state finish out all of it's game over actions when they get there.
   EventMgr:postEvent( {distance=0, score=0}, "game-over" );
   EventMgr:postEvent( {name="player died", time=nil}, "avatar-death" );

   local online = "offline";
   if OnlineMgr:isOnline() then
      online     = "online";
   end
   MOAIFlurry:eventStop("GamePlay", 
                        "ending",         "quit",
                        "online",         online   );
                        
   MOAIFlurry:event("GameQuit" );
   
   if self.gameState then
      self.gameState.game.gameOver = true;
		self.gameState.quitting = true;
   end

	GamePaused = false;
   EventMgr:postEvent( {state="state/state-pause.lua"}, "game-unpaused" );
   
   StateMgr:pop();


end

----------------------------------------------------------------

function StatePause:goOptions()

	print("Go To Options");
	
	StateMgr:push("state/state-options.lua");

end

----------------------------------------------------------------

function StatePause:onLoseFocus()

   print("StatePause:onLoseFocus");
   
   Base.onLoseFocus(self);

end

----------------------------------------------------------------------

function StatePause:onDataServerError()

   print("StatePause:onDataServerError()");

   if not StateMgr._showErrorDialog then

      --Give back the key

      Base.onDataServerError(self);

      App.data:addKey(1, "Data Server Error");

   end

end

----------------------------------------------------------------

function StatePause:goBack()

	print("Go Back");
	
	EventMgr:postEvent( {state="state/state-pause.lua"}, "pause-transition" );
	
	StateMgr:pop();

end

----------------------------------------------------------------

return StatePause;

----------------------------------------------------------------
