----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORITY_0				= 10;
local PRIORITY_1				= 20;
local PRIORITY_2				= 30;
local PRIORITY_3				= 40;
local PRIORITY_4				= 50;
local PRIORITY_5				= 60;
local PRIORITY_6				= 70;
local PRIORITY_7				= 80;
local PRIORITY_8				= 90;
local PRIORITY_9				= 100;
local PRIORITY_10				= 110;

----------------------------------------------------------------

local Base							= State;
local StateQuitDroneConfirm	= Base:new();

----------------------------------------------------------------

function StateQuitDroneConfirm:onLoad()

   State.onLoad( self );

   local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";
	self.IS_POPUP  = true;

	-- background
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0, 10, 0,0, "SmallBackGround", textureSheet);

	-- push/pop state buttons
	self.PlayOnButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0, -110, 0,0, "Q_PlayOnButton", textureSheet, nil, self.goConfirm, nil, nil, nil, nil);
	self.PlayOnButton:setPriority(PRIORITY_0);
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 161, 0,0, "CloseButton", textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
	self.BackButton:setPriority(PRIORITY_0);
	
	-- text message
	self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 132, 540, 70, '<c:fefcfc>Confirm Exit<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleText:setScale(1.5, 1.5);
	self.TitleText:setPriority(PRIORITY_0);
	self.TitleTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, 132-2, 540, 70, '<c:0b141d>Confirm Exit<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.TitleTextShdw:setScale(1.5, 1.5);
	self.TitleTextShdw:setPriority(PRIORITY_0-1);
	self.MessageText = self:addWidget(TextBox, self.mainLayer, 0, 15, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageText:setPriority(PRIORITY_0);
	self.MessageTextShdw = self:addWidget(TextBox, self.mainLayer, 0-2, 15+2, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageTextShdw:setPriority(PRIORITY_0-1);

end

----------------------------------------------------------------

function StateQuitDroneConfirm:onActivate()

   State.onActivate(self);

	self:setMessage();

end

----------------------------------------------------------------

function StateQuitDroneConfirm:onFocus()
   
   State.onFocus(self);
   
end

----------------------------------------------------------------

function StateQuitDroneConfirm:setMessage()
	
	local text = 'You are leaving with\nno drones equipped!';
	
	self.MessageText:setText('<c:1b3043>'..text..'<c>');
	self.MessageTextShdw:setText('<c:8fb5cd>'..text..'<c>');

end

----------------------------------------------------------------

function StateQuitDroneConfirm:goConfirm()
	StateMgr:swap("state/state-ranking.lua");
end

----------------------------------------------------------------

function StateQuitDroneConfirm:onBackButton()
	self:goBack();
end

----------------------------------------------------------------

function StateQuitDroneConfirm:isUsingCameraHack()
   return false;
end

----------------------------------------------------------------

function StateQuitDroneConfirm:goBack()
	StateMgr:pop();
end

----------------------------------------------------------------

return StateQuitDroneConfirm;

----------------------------------------------------------------
