----------------------------------------------------------------

require('flash/flash-manager')
require('app/contact/contact-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;
local PRIORITY_FORCE_ON_TOP= 10000; --to make sure we are on top of resource bar

local WIPE_ANIM_TIME			= 60/30;
local WIPE_ANIM_SCALE		= WIPE_ANIM_TIME/1.0;
local VEHC_TIME				= WIPE_ANIM_TIME/WIPE_ANIM_SCALE;

local TOTAL_SCORE          =
{
   label = { x=0, y=210 },
   text  = { x=0, y=310 },
};

local DISTANCE_SCORE       =
{
   label = { x=-160, y=85 },
   text  = { x=-160, y=135 },
};

local KILL_SCORE           =
{
   label = { x=160, y=85 },
   text  = { x=160, y=135 },
};

local COIN_COLLECT         =
{
   label = { x=40, y=15 },
   text  = { x=210, y=15 },
   button= { x=92, y=-35 },
};

local BONUS_SCORE          =
{
   label = { x=-160, y=-35 },
   text  = { x=-160, y=15 },
};

local LEVEL_PROGRESS       =
{
   label = { x=0, y=-110 },
   bar   = { x=80, y=-110 },
};

local HI_SCORE             =
{
   label = { x=0, y=-315 },
   text  = { x=0, y=-265 },
   badge = { x=0, y=-150 },
};

if not HACK_ALWAYS_LEVEL then
   HACK_ALWAYS_LEVEL		= false;
end

local SALE_REMINDER_TIME_REMAINING = 24*60*60;

----------------------------------------------------------------

local Base						= State;
local StateResults			= Base:new();

----------------------------------------------------------------

local Vehicle_Scale =
{
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
	{x= 0.65,		y=	0.65},
};

local Vehicle_Loc_X = -90;
local Vehicle_Loc_Y = -190;

local Vehicle_Angle =
{
	-135,
	-135,
	-135,
	-135,
	-135,
	-135,
	-135,
	-135,
	-135,
	-135,
};

local Wipe_Vehicle_Scale =
{
	x= 0.80,		y=	0.80,
};

local Wipe_Vehicle_Angle = -23;

local WipeAnim_X			= -400;
local WipeAnim_Y			= 375;

local Vehicle_Start =
{
	x = (150+WipeAnim_X)*0.80,		y = (-1050+WipeAnim_Y)*0.80,
};

local Vehicle_End =
{
	x = 400-Vehicle_Start.x,		y = 1070-Vehicle_Start.y,
};

local WIPE_VEHICLE_DIMENSIONS =
{
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
};

local WIPE_VEHICLE_OFFSET =
{
	{x=(WIPE_VEHICLE_DIMENSIONS[1].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[2].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[3].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[4].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[3].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[1].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[2].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[3].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[4].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
	{x=(WIPE_VEHICLE_DIMENSIONS[3].w/2)*Wipe_Vehicle_Scale.x,		y=0*Wipe_Vehicle_Scale.y,	},
};

local Vehicle_Paint =
{
	{
		"resources/Vehicle/Player_SportsCar/Sportscar_Blue_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar/Sportscar_Black_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar/Sportscar_Red_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar/Sportscar_Silver_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar/Sportscar_Pink_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar/Sportscar_Yellow_ArmorLevel01.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Black_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Blue_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Red_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Green_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Pink_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Teal_ArmorLevel01.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Red_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Black_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Blue_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Silver_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Purple_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Orange_ArmorLevel01.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Yellow.png",
		"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Black.png",
		"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Blue.png",
		"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Green.png",
		"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Pink.png",
		"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Red.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Silver.png",
		"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Black.png",
		"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Red.png",
		"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Green.png",
		"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Blue.png",
		"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Orange.png",
	},
	{
		"resources/Vehicle/Player_SportsCar_V2/Sportscar_Base_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar_V2/Sportscar_Black_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar_V2/Sportscar_Blue_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar_V2/Sportscar_Green_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar_V2/Sportscar_Orange_ArmorLevel01.png",
		"resources/Vehicle/Player_SportsCar_V2/Sportscar_Yellow_ArmorLevel01.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Base_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Black_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Red_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Yellow_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Purple_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Teal_ArmorLevel01.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Blue_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Black_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Red_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Silver_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Green_ArmorLevel01.png",
		"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Yellow_ArmorLevel01.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Silver.png",
		"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Black.png",
		"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Blue.png",
		"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Orange.png",
		"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Yellow.png",
		"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Red.png",
	},
	{
		"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Orange.png",
		"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Black.png",
		"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Red.png",
		"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Green.png",
		"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Blue.png",
		"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Silver.png",
	},
};

local Vehicle_Armor =
{
	{
		"Car_SportscarAmor02",
		"Car_SportscarAmor03",
		"Car_SportscarAmor04",
		"Car_SportscarAmor05",
		"Car_SportscarAmor06",
		"Car_SportscarAmor07",
		"Car_SportscarAmor08",
		"Car_SportscarAmor09",
		"Car_SportscarAmor10",
		"Car_SportscarAmor11",
		"Car_SportscarAmor12",
		"Car_SportscarAmor13",
		"Car_SportscarAmor14",
		"Car_SportscarAmor15",
	},
	{
		"Car_SandrailAmor02",
		"Car_SandrailAmor03",
		"Car_SandrailAmor04",
		"Car_SandrailAmor05",
		"Car_SandrailAmor06",
		"Car_SandrailAmor07",
		"Car_SandrailAmor08",
		"Car_SandrailAmor09",
		"Car_SandrailAmor10",
		"Car_SandrailAmor11",
		"Car_SandrailAmor12",
		"Car_SandrailAmor13",
		"Car_SandrailAmor14",
		"Car_SandrailAmor15",
	},
	{
		"Car_MissileCarAmor02",
		"Car_MissileCarAmor03",
		"Car_MissileCarAmor04",
		"Car_MissileCarAmor05",
		"Car_MissileCarAmor06",
		"Car_MissileCarAmor07",
		"Car_MissileCarAmor08",
		"Car_MissileCarAmor09",
		"Car_MissileCarAmor10",
		"Car_MissileCarAmor11",
		"Car_MissileCarAmor12",
		"Car_MissileCarAmor13",
		"Car_MissileCarAmor14",
		"Car_MissileCarAmor15",
	},
	{
		"Car_LazerAmor02",
		"Car_LazerAmor03",
		"Car_LazerAmor04",
		"Car_LazerAmor05",
		"Car_LazerAmor06",
		"Car_LazerAmor07",
		"Car_LazerAmor08",
		"Car_LazerAmor09",
		"Car_LazerAmor10",
		"Car_LazerAmor11",
		"Car_LazerAmor12",
		"Car_LazerAmor13",
		"Car_LazerAmor14",
		"Car_LazerAmor15",
	},
	{
		"Car_BlastAmor02",
		"Car_BlastAmor03",
		"Car_BlastAmor04",
		"Car_BlastAmor05",
		"Car_BlastAmor06",
		"Car_BlastAmor07",
		"Car_BlastAmor08",
		"Car_BlastAmor09",
		"Car_BlastAmor10",
		"Car_BlastAmor11",
		"Car_BlastAmor12",
		"Car_BlastAmor13",
		"Car_BlastAmor14",
		"Car_BlastAmor15",
	},
	{
		"Car_SportscarV2Amor02",
		"Car_SportscarV2Amor03",
		"Car_SportscarV2Amor04",
		"Car_SportscarV2Amor05",
		"Car_SportscarV2Amor06",
		"Car_SportscarV2Amor07",
		"Car_SportscarV2Amor08",
		"Car_SportscarV2Amor09",
		"Car_SportscarV2Amor10",
		"Car_SportscarV2Amor11",
		"Car_SportscarV2Amor12",
		"Car_SportscarV2Amor13",
		"Car_SportscarV2Amor14",
		"Car_SportscarV2Amor15",
	},
	{
		"Car_SandrailV2Amor02",
		"Car_SandrailV2Amor03",
		"Car_SandrailV2Amor04",
		"Car_SandrailV2Amor05",
		"Car_SandrailV2Amor06",
		"Car_SandrailV2Amor07",
		"Car_SandrailV2Amor08",
		"Car_SandrailV2Amor09",
		"Car_SandrailV2Amor10",
		"Car_SandrailV2Amor11",
		"Car_SandrailV2Amor12",
		"Car_SandrailV2Amor13",
		"Car_SandrailV2Amor14",
		"Car_SandrailV2Amor15",
	},
	{
		"Car_MissilecarV2Armor02",
		"Car_MissilecarV2Armor03",
		"Car_MissilecarV2Armor04",
		"Car_MissilecarV2Armor05",
		"Car_MissilecarV2Armor06",
		"Car_MissilecarV2Armor07",
		"Car_MissilecarV2Armor08",
		"Car_MissilecarV2Armor09",
		"Car_MissilecarV2Armor10",
		"Car_MissilecarV2Armor11",
		"Car_MissilecarV2Armor12",
		"Car_MissilecarV2Armor13",
		"Car_MissilecarV2Armor14",
		"Car_MissilecarV2Armor15",
	},
	{
		"Car_LazerV2Amor02",
		"Car_LazerV2Amor03",
		"Car_LazerV2Amor04",
		"Car_LazerV2Amor05",
		"Car_LazerV2Amor06",
		"Car_LazerV2Amor07",
		"Car_LazerV2Amor08",
		"Car_LazerV2Amor09",
		"Car_LazerV2Amor10",
		"Car_LazerV2Amor11",
		"Car_LazerV2Amor12",
		"Car_LazerV2Amor13",
		"Car_LazerV2Amor14",
		"Car_LazerV2Amor15",
	},
	{
		"Car_BlastV2Amor02",
		"Car_BlastV2Amor03",
		"Car_BlastV2Amor04",
		"Car_BlastV2Amor05",
		"Car_BlastV2Amor06",
		"Car_BlastV2Amor07",
		"Car_BlastV2Amor08",
		"Car_BlastV2Amor09",
		"Car_BlastV2Amor10",
		"Car_BlastV2Amor11",
		"Car_BlastV2Amor12",
		"Car_BlastV2Amor13",
		"Car_BlastV2Amor14",
		"Car_BlastV2Amor15",
	},
};

local ARMOR_PRIORITY =
{
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
	{
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--2
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--3
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--4
		PRIORTY_8+PRIORITY_FORCE_ON_TOP,		--5
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--6
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--7
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-2,	--8
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--9
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--10
		PRIORTY_8+PRIORITY_FORCE_ON_TOP+1,	--11
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--12
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--13
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--14
		PRIORTY_8+PRIORITY_FORCE_ON_TOP-1,	--15
	},
};

local Vehicle_Side =
{
	"Car_SportscarSideWeapon",
	"Car_SandrailSideWeapon",
	"Car_MissileCarSideWeapon",
	"Car_LazerSideWeapon",
	"Car_BlastSideWeapon",
	"Car_SportscarSideWeapon",
	"Car_SandrailSideWeapon",
	"Car_MissileCarSideWeapon",
	"Car_LazerSideWeapon",
	"Car_BlastSideWeapon",
};

local Vehicle_Turret =
{
	"Car_SportscarTurretCannon",
	"Car_SandrailTurretMagnet",
	"Car_MissilecarTurretTwinRocket",
	"Car_LazerTurret",
	"Car_BlastTurret",
	"Car_SportscarTurretCannon",
	"Car_SandrailTurretMagnet",
	"Car_MissilecarTurretTwinRocket",
	"Car_LazerTurret",
	"Car_BlastTurret",
};


------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:onLoad()

   State.onLoad( self );

	local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
	local wipeTexture				= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);

   self.defaultFontName = "resources/font/TangoLatin.otf";

	self.vehicletexture			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group3.lua", "resources/flash-resource-bundle/Group3.png", 30);

	-- background and frames
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "RFrameBackground", textureSheet);
	self.Title = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "TitleResults", textureSheet, nil, nil, true);
	self.Title:setPriority(PRIORTY_1);
	self.ScoreFrame = self:addWidget(Anim, self.mainLayer, TOTAL_SCORE.text.x, TOTAL_SCORE.text.y, 0,0, "RGradientBar", textureSheet);
	self.ScoreFrame:setPriority(PRIORTY_0);
	self.LevelFrame = self:addWidget(Anim, self.mainLayer, LEVEL_PROGRESS.label.x, LEVEL_PROGRESS.label.y, 0,0, "RGradientBar", textureSheet);
	self.LevelFrame:setPriority(PRIORTY_0);
   self.LevelFrame:setScale(1, 0.5);

	-- level bar
	self.LevelBar = self:addWidget(Anim, self.mainLayer, LEVEL_PROGRESS.bar.x, LEVEL_PROGRESS.bar.y, 0,0, "LevelBar", textureSheet);
	self.LevelBar:setPriority(PRIORTY_6);

	-- banner
	self.bestScoreBanner = self:addWidget(Anim, self.mainLayer, HI_SCORE.badge.x, HI_SCORE.badge.y, 0,0, "RBestBanner", textureSheet);
	self.bestScoreBanner:setPriority(PRIORTY_2);

	-- smoke wipe anim
	self.WipeVehiclePivot = MOAITransform2D.new();
	self.WipeVehiclePivot:setRot(Wipe_Vehicle_Angle, 0, 0);
	self.wipeActive = false;
	self.WipeAnim = self:addWidget(Anim, self.mainLayer, WipeAnim_X, WipeAnim_Y, 0,0, "Wipe", wipeTexture);
	self.WipeAnim:setPriority(PRIORTY_6+1);

	-- push/pop state buttons
	self.BragButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "RResultsBragButton", textureSheet, nil, self.goBrag, nil, nil);
	self.BragButton:setPriority(PRIORTY_6);
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ReadyButton", textureSheet, nil, self.goBack, nil, nil);
	self.BackButton:setPriority(PRIORTY_6);

   self.DoubleCoin = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, COIN_COLLECT.button.x, COIN_COLLECT.button.y, 0,0, "DubbleCoins", textureSheet, nil, self.goDoubleCoin, nil, nil, nil, nil, 20);
   self.DoubleCoin:setPriority(PRIORTY_6);
   self.DoubleCoin:setScale(0.70, 0.70);

   self:_setupBasicResourceBar();

	self:createResults();
	self:createWipeVehicle();

end

----------------------------------------------------------------

function StateResults:onActivate()

	Base.onActivate(self);

	self.vehicleTime		= 0;
	self.popupCount		= 0;
	self.exitPermission	= false;
	self.WipeVehiclePivot:setLoc(Vehicle_Start.x, Vehicle_Start.y);
	self:updateWipeVehicle();

	self:setExitStatePermission(false);
	self:updateXP();
	self:animInit();

	delay(	0.25,
					function ()
						self:startLevelUpAnim();
					end
				);

   App.data:setValue('BragTracker', {});

	self.bestScoreBanner:setVisible(false);

	self.distanceText:setText('0m');
	self.distanceTextShdw:setText('0m');
	self.killsText:setText('0');
	self.killsTextShdw:setText('0');
	self.bonusText:setText('0');
	self.bonusTextShdw:setText('0');
	self.finalScoreText:setText('0');
	self.finalScoreText:setColor(1,1,1,1);
	self.finalScoreTextShdw:setText('0');
	self.hiScore:setText(getFormattedNumber(self.startHighScore));
	self.hiScoreShdw:setText(getFormattedNumber(self.startHighScore));
	self.coinText:setText('<c:ffffff>'..App.lastGameGold);
	self.coinTextShdw:setText(App.lastGameGold..'');

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

   EventMgr:addListener(self, self.onBuyDoubleCoinBought,   "double-coin-bought" );

end

----------------------------------------------------------------

function StateResults:onDeactivate( )

   Base.onDeactivate(self);

   EventMgr:rmvListener(self );

   PromoMgr:attemptInterstitialDisplay( "roadriot_gameplay" );

end

------------------------------------------------------------------------------------

function StateResults:onFocus()

   Base.onFocus(self);

   StateMgr:setSyncBusyDelay(0);

	self.WipeAnim:setVisible(false);
	self:hideWipeVehicle(true);

   AdMgr:cacheInterstitial("roadriot_gameplay");

   ContactMgr:setAutoContactsMode( ContactMgr.AUTO_FRIENDS_ONCE );

   EventMgr:addListener( self, self.onAppDataUpdateSuccess,  "app-data-update-success"  );

   --There is a bug where people who played the game for a while
   -- wont see the brag button anymore
   if App.data:getCurrentPlayerLevel( ) > 2 then
      App.data:setValue("first-result-done",true);
   end

   --This is mainly for when you purchase the double coin and come back, we need to hide
   --setExitStatePermission won't get call
   if self.DoubleCoin then
      if App.data:canPickupBeUpgraded( PICKUP_COIN_INDEX )  and App.data:getCurrentPlayerLevel( ) > 3 then
      else
         self.DoubleCoin:hide();
         self.DoubleCoin:disable();
      end
   end

end

------------------------------------------------------------------------------------

function StateResults:onLoseFocus()

   Base.onLoseFocus( self );

   EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="anim update",}, "loop-stop" );

   --make sure we dont remove all event listener, we neen it for "double-coin-bought"
   EventMgr:rmvListener( self, "app-data-update-success" )

   StateMgr:setSyncBusyDelay(nil);

end

------------------------------------------------------------------------------------

function StateResults:onAppDataUpdateSuccess()

   print("StateResults:onAppDataUpdateSuccess");

   self:updateGoldCount();

end

------------------------------------------------------------------------------------

function StateResults:onUpdate( dt )

   Base.onUpdate( self, dt );

	if not self.rollOver and not self.tickPause then
		self:animUpdate(dt);

		if not self.rollLoopPlaying and self.totalScore > 0 then
			EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="start sparks",}, "add-sfx" );
			self.rollLoopPlaying = true;
		end
	end

	if self.levelPopUp and
		self.levelUpCount and
		self.levelUpCount > 0 then

		--to MQL: adding a bool here to check for the guide pop-over
		self.levelupStarted	= true;

		self.levelPopUp		= false;
		self.popupCount		= App.data:getCurrentPlayerLevel() - self.levelUpCount + 1;
		self.levelUpCount		= self.levelUpCount - 1;

		self:startWipeAnim();

	end

	if self.wipeActive then

		self.vehicleTime = self.vehicleTime + dt;

		local scale = math.clamp(self.vehicleTime/VEHC_TIME, 0, 1);

		self.WipeVehiclePivot:setLoc(Vehicle_Start.x + (Vehicle_End.x * scale), Vehicle_Start.y + (Vehicle_End.y * scale));
	end

	if self.bubbleDist then

		local scale = 0;

		self.bubbleDistTime = self.bubbleDistTime + dt;

		if self.bubbleDistTime < 0.21 then
			scale = 1.5;
		else
			scale = math.mapClamped(0.2, 1.5, 0.3, 1.0, self.bubbleDistTime);
		end

		self.distanceText:setGlyphScale(scale);
		self.distanceTextShdw:setGlyphScale(scale);

		self:updateDistScoreText();

		if self.bubbleDistTime > 0.3 then
			self.bubbleDist = false;
		end

	end

	if self.bubbleKill then

		local scale = 0;

		self.bubbleKillTime = self.bubbleKillTime + dt;

		if self.bubbleKillTime < 0.21 then
			scale = 1.5;
		else
			scale = math.mapClamped(0.2, 1.5, 0.3, 1.0, self.bubbleKillTime);
		end

		self.killsText:setGlyphScale(scale);
		self.killsTextShdw:setGlyphScale(scale);

		self:updateKillScoreText();

		if self.bubbleKillTime > 0.3 then
			self.bubbleKill = false;
		end

	end

	if self.bubbleBonus then

		local scale = 0;

		self.bubbleBonusTime = self.bubbleBonusTime + dt;

		if self.bubbleBonusTime < 0.21 then
			scale = 1.5;
		else
			scale = math.mapClamped(0.2, 1.5, 0.3, 1.0, self.bubbleBonusTime);
		end

		self.bonusText:setGlyphScale(scale);
		self.bonusTextShdw:setGlyphScale(scale);

		self:updateBonusScoreText();

		if self.bubbleBonusTime > 0.3 then
			self.bubbleBonus = false;
		end

	end

	if self.bubbleLevel then

		local scaleX = 0;
		local scaleY = 0;

		if self.levelUpCount < 1 then
			self.bubbleLevel = false;

		else
			self.bubbleLevelTime = self.bubbleLevelTime + dt;

			if self.bubbleLevelTime < 0.1 then
				scaleX = math.mapClamped(0, 0.25, 0.1, 1.25, self.bubbleLevelTime);
				scaleY = math.mapClamped(0, 0.25, 0.1, 2.0, self.bubbleLevelTime);
			elseif self.bubbleLevelTime >= 0.1 and self.bubbleLevelTime < 0.2 then
				scaleX = 1.25;
				scaleY = 1.5;
			else
				scaleX = math.mapClamped(0.2, 1.25, 0.35, 1.0, self.bubbleLevelTime);
				scaleY = math.mapClamped(0.2, 2.0, 0.35, 1.0, self.bubbleLevelTime);
			end

			self.LevelBar:setScale(scaleX, scaleY);

			if self.bubbleLevelTime > 0.35 then
				self.bubbleLevel = false;
			end
		end

	end

	if self.bubbleHiScore then

		local scale = 0;

		self.bubbleHiScoreTime = self.bubbleHiScoreTime + dt;

		scale = math.mapClamped(0, 2.0, 0.35, 1.0, self.bubbleHiScoreTime);

		self.hiScore:setGlyphScale(scale);
		self.hiScoreShdw:setGlyphScale(scale);

		self:updateHiScoreText();

		if self.bubbleHiScoreTime > 0.35 then
			self.bubbleHiScore = false;
		end

	end

end

----------------------------------------------------------------------

function StateResults:isBusy()

   return StoreMgr:isBusy();

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:updateXP()

	self.startLevel	= App.data:getCurrentPlayerLevel();
	self.startXP		= App.data:getCurrentPlayerXP();
	self.startReqXP	= App.data:getXPLevelReq();
	self.finalScore	= App.lastGameScore;
	self.levelUpCount	= 0;
	self.levelPopUp	= false;
	self.tickPause		= true;
	self.animSpdScl	= 1.0;
	self.scoreTime		= 0.0;
	self.distTime		= 0.0;
	self.killTime		= 0.0;
	self.bonusTime		= 0.0;
	self.levelMax		= false;

	local curLevel				= self.startLevel;
	local animLngth			= 100;
	local minScoreTime		= 0.30;
	local maxScoreTime		= 0.75;
	local xp						= 0;

	GuestMgr:updateTargetScore(self.finalScore);

	if HACK_ALWAYS_LEVEL then
		xp = (self.startReqXP - self.startXP);
	else
		xp = math.clamp(self.finalScore, 0, self.startReqXP - self.startXP);
	end

	App.data:addXP(xp);

	if curLevel < App.data:getCurrentPlayerLevel() then

		self.levelUpCount = self.levelUpCount + 1;
		curLevel = curLevel + 1;
	end

	while App.data:canIncreasePlayerLevel() do

		App.data:addXP(0);

		if curLevel < App.data:getCurrentPlayerLevel() then

			self.levelUpCount = self.levelUpCount + 1;
			curLevel = curLevel + 1;
		end

	end

	if	self.startLevel >= App.data:getMaxPlayerLevel() then
		self.levelMax = true;
	end

	if self.levelMax then
		self.levelText:setText('Level Max');
		self.levelTextShdw:setText('Level Max');
	else
		self.levelText:setText('Level '..self.startLevel);
		self.levelTextShdw:setText('Level '..self.startLevel);
	end

	-- Anim is 100 frames
	if self.levelMax then
		self.startLevelFrame = math.clamp(self.startXP/self.startReqXP, 0, 1.00) * animLngth;
	else
		self.startLevelFrame = math.clamp(self.startXP/self.startReqXP, 0, 0.95) * animLngth;
	end
	self.startLevelFrame	= math.floor(self.startLevelFrame);

	self.startLevelFrame = self.startLevelFrame/30;

	self.LevelBar:setSpan(self.startLevelFrame, self.startLevelFrame );
	self.LevelBar:start();

	local animTime = 0;

	if self.levelUpCount < 1 then
		if self.levelMax then
			animTime = math.clamp(App.data:getCurrentPlayerXP()/App.data:getXPLevelReq(), 0, 1.00)*animLngth;
		else
			animTime = math.clamp(App.data:getCurrentPlayerXP()/App.data:getXPLevelReq(), 0, 0.98)*animLngth;
		end

		animTime = math.floor(animTime);

		animTime = (animTime/30) - self.startLevelFrame;
	else
		animTime = (animLngth/30) - self.startLevelFrame;
	end

	self.distTime		= math.mapClamped(15, minScoreTime, 30, maxScoreTime, App.lastGameDistance);
	self.killTime		= math.mapClamped(15, minScoreTime, 30, maxScoreTime, App.lastGameKill);
	self.bonusTime		= math.mapClamped(15, minScoreTime, 30, maxScoreTime, App.lastGameBonus);
	self.scoreTime		= self.distTime + self.killTime + self.bonusTime;

	self.animSpdScl = animTime/self.scoreTime;

	if self.animSpdScl == 0 then
		self.animSpdScl = 1;
	end

	self.LevelBar:setSpeed(self.animSpdScl);

--	print('StateResults:updateXP', App.lastGameDistance, App.lastGameKill, App.lastGameBonus, self.finalScore, self.distTime, self.killTime, self.bonusTime, self.scoreTime, animTime, self.animSpdScl);

end

----------------------------------------------------------------

function StateResults:startLevelUpAnim()

	local animLngth	= 100;
	local endFrame		= animLngth/30;
	local level			= self.startLevel;

	self.tickPause = false;

	if	level >= App.data:getMaxPlayerLevel() then
		self.levelMax = true;
	end

	if self.levelUpCount < 1 then

		local t			= 0;
		local timer		= MOAITimer:new();
		local action;

		if self.levelMax then
			endFrame = math.clamp(App.data:getCurrentPlayerXP()/App.data:getXPLevelReq(), 0, 1.00) * animLngth;
		else
			endFrame = math.clamp(App.data:getCurrentPlayerXP()/App.data:getXPLevelReq(), 0, 0.98) * animLngth;
		end

		endFrame = math.floor(endFrame);
		endFrame = endFrame/30;

		t = endFrame - self.startLevelFrame ;

		if t == 0 then
			t = self.scoreTime;
		end

		self.LevelBar:stop();
		self.LevelBar:setSpan(self.startLevelFrame, endFrame );
		self.LevelBar:start();

		timer:setSpan(t);
		timer:setTime(0.0);
		timer:setMode(MOAITimer.NORMAL);
		timer:setSpeed(self.animSpdScl);
		action = timer:start();

		MOAICoroutine.blockOnAction(action);

	else

		for i=self.levelUpCount, 1, -1 do

			local t			= 0;
			local timer		= MOAITimer:new();
			local action;

			self.LevelBar:stop();

			if i == self.levelUpCount then
				t = endFrame - self.startLevelFrame ;
				self.LevelBar:setSpan(self.startLevelFrame, endFrame);
			else
				t = endFrame;
				self.LevelBar:setSpan(0.0, endFrame);
			end

			timer:setSpan(t);
			timer:setTime(0.0);
			timer:setMode(MOAITimer.NORMAL);
			timer:setSpeed(self.animSpdScl);
			action = timer:start();

			self.LevelBar:start();

			MOAICoroutine.blockOnAction(action);

		end

	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:animInit()

--	self.scoreTime				= 2.0;
	self.rollOver				= false;
	self.rollLoopPlaying		= false;
	self.sparks					= false;
	self.fireworks				= false;
	self.fireworkTime			= 0;
	self.totalScore			= self.finalScore
	self.distance				= App.lastGameDistance;
	self.distanceScore		= 0;
	self.enemyKills			= App.lastGameKill;
	self.enemyKillsScore		= 0;
	self.bonusScore			= 0;
	self.startHighScore		= App.data.lastHiScore;

	self.distComplete			= false;
	self.killComplete			= false;
	self.bonusComplete		= false;

	self.bubbleDist			= false;
	self.bubbleDistTime		= 0;
	self.bubbleKill			= false;
	self.bubbleKillTime		= 0;
	self.bubbleBonus			= false;
	self.bubbleBonusTime		= 0;
	self.bubbleLevel			= false;
	self.bubbleLevelTime		= 0;
	self.bubbleHiScore		= false;
	self.bubbleHiScoreTime	= 0;

	if self.startHighScore == nil then
		self.startHighScore = 0;
	end

	self.rollDistK				= App.lastGameDistance/self.distTime;
	self.rollKillK				= App.lastGameKill/self.killTime;
	self.rollBonusK			= App.lastGameBonus/self.bonusTime;

	self.visScore = 0;

   if self.resourceBar then
      self.resourceBar.CoinButton:disable();
      self.resourceBar.KeyButton:disable();
      self.resourceBar.GemButton:disable();
   end

end

----------------------------------------------------------------

function StateResults:animUpdate( dt )

	if not self.distComplete then
		self.visScore = self.visScore + (self.rollDistK * dt);

		if self.visScore < App.lastGameDistance then
			self.distanceScore = self.visScore;

			self.distanceLabel:setGlyphScale(1.25);
			self.distanceText:setGlyphScale(1.25);
			self.distanceLabelShdw:setGlyphScale(1.25);
			self.distanceTextShdw:setGlyphScale(1.25);
		else
			self.distanceScore = App.lastGameDistance;
			self.visScore = 0;

			self.distanceLabel:setGlyphScale(1.0);
			self.distanceText:setGlyphScale(1.0);
			self.distanceLabelShdw:setGlyphScale(1.0);
			self.distanceTextShdw:setGlyphScale(1.0);

			self.distComplete = true;
			self:pauseScoreTick(0.25);

			if self.distanceScore > 0 then
			--local dSting = {start={"ScoreStinger",},};
			--EventMgr:postEvent( { sounds=dSting, name="distance sting",}, "add-sfx" );
			end
		end

		self:updateDistScoreText();
	elseif not self.killComplete then
		self.visScore = self.visScore + (self.rollKillK * dt);

		if self.visScore < App.lastGameKill then
			self.enemyKillsScore = self.visScore;

			self.killLabel:setGlyphScale(1.25);
			self.killsText:setGlyphScale(1.25);
			self.killLabelShdw:setGlyphScale(1.25);
			self.killsTextShdw:setGlyphScale(1.25);
		else
			self.enemyKillsScore = App.lastGameKill;
			self.visScore = 0;

			self.killLabel:setGlyphScale(1.0);
			self.killsText:setGlyphScale(1.0);
			self.killLabelShdw:setGlyphScale(1.0);
			self.killsTextShdw:setGlyphScale(1.0);

			self.killComplete = true;
			self:pauseScoreTick(0.25);

			if self.enemyKillsScore > 0 then
			--local dSting = {start={"ScoreStinger",},};
			--EventMgr:postEvent( { sounds=dSting, name="distance sting",}, "add-sfx" );
			end
		end

		self:updateKillScoreText();
	elseif not self.bonusComplete then
		self.visScore = self.visScore + (self.rollBonusK * dt);

		if self.visScore < App.lastGameBonus then
			self.bonusScore = self.visScore;

			self.bonusLabel:setGlyphScale(1.25);
			self.bonusText:setGlyphScale(1.25);
			self.bonusLabelShdw:setGlyphScale(1.25);
			self.bonusTextShdw:setGlyphScale(1.25);
		else
			self.bonusScore = App.lastGameBonus;
			self.visScore = 0;

			self.bonusLabel:setGlyphScale(1.0);
			self.bonusText:setGlyphScale(1.0);
			self.bonusLabelShdw:setGlyphScale(1.0);
			self.bonusTextShdw:setGlyphScale(1.0);

			self.bonusComplete = true;

			if self.bonusScore > 0 then
			--local dSting = {start={"ScoreStinger",},};
			--EventMgr:postEvent( { sounds=dSting, name="distance sting",}, "add-sfx" );
			end
		end

		self:updateBonusScoreText();
	end

	local sumScore = self.distanceScore + self.enemyKillsScore + self.bonusScore;
   EventMgr:postEvent(  {distance=self.distanceScore, score=sumScore}, "avatar-score" );

	self.finalScoreText:setText(getFormattedNumber(math.ceil(sumScore))..'');
	self.finalScoreTextShdw:setText(getFormattedNumber(math.ceil(sumScore))..'');

   if sumScore > 999999999 then
      self.finalScoreText:setScale(0.95, 0.95);
      self.finalScoreTextShdw:setScale(0.95, 0.95);
   else
      self.finalScoreText:setScale(1, 1);
      self.finalScoreTextShdw:setScale(1, 1);
   end

--	print('StateResults:animUpdate', self.visScore, self.distanceScore, self.enemyKillsScore, self.bonus, sumScore);

	if self.distComplete and
		self.killComplete and
		self.bonusComplete then

      if self.resourceBar then
         self.resourceBar.CoinButton:enable();
         self.resourceBar.KeyButton:enable();
         self.resourceBar.GemButton:enable();
      end

		if self.levelUpCount and self.levelUpCount > 0 then
			EventMgr:postEvent( {sounds={start={"LevelUpSFX"}}, name="level bar max",}, "add-sfx" );
		end

		EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="anim update",}, "loop-stop" );

		self.rollOver = true;
		self.tickPause = true;
		self.finalScoreText:setText(getFormattedNumber(math.ceil(self.totalScore))..'');
		self.finalScoreTextShdw:setText(getFormattedNumber(math.ceil(self.totalScore))..'');

      if math.ceil(self.totalScore) > 999999999 then
         self.finalScoreText:setScale(0.95, 0.95);
         self.finalScoreTextShdw:setScale(0.95, 0.95);
      else
         self.finalScoreText:setScale(1, 1);
         self.finalScoreTextShdw:setScale(1, 1);
      end

		if	self.startLevel >= App.data:getMaxPlayerLevel() then
			self.levelText:setText('Level Max');
			self.levelTextShdw:setText('Level Max');
		end

		if self.finalScore > self.startHighScore then

			delay(	0.5,
						function ()
							self.bestScoreBanner:setVisible(true);
							self.bestScoreBanner:setTime(0);
                     self.bestScoreBanner:start();
                     self.bestScoreBanner:setSpeed(1.33);
							self.bubbleHiScore = true
							EventMgr:postEvent( {sounds={start={"HighScore"}}, name="high score",}, "add-sfx" );
						end	);

			delay(	1.75,
						function ()
							if self.levelUpCount and self.levelUpCount < 1 then
								self:setExitStatePermission(true, true, string.lower(App.data:getValue("App.settings.brag-access", "hi-score")) == "always");

                        if ( self.levelUpCount or 0 ) == 0 and App.lastGameScore > (App.data:getValue("feed-hi-score", 10000)) then
                           App.data:setValue("feed-hi-score", App.lastGameScore);

                           if not GuideMgr:isActive() then
                              FeedMgr:shareScreenshot( "HighScore", 0.01 );
                           end
                        end

							end

							self.levelPopUp = true;
						end	);

		else

			self:updateHiScoreText();

			delay(	0.75,
						function ()
							if self.levelUpCount and self.levelUpCount < 1 then
								self:setExitStatePermission(true, false, string.lower(App.data:getValue("App.settings.brag-access", "hi-score")) == "always");
							end

							self.levelPopUp = true;
						end);

		end
	end

end

------------------------------------------------------------------------------------

function StateResults:updateDistScoreText()

	if self.distComplete
		or math.ceil(self.distanceScore) < 1 then

		self.distanceLabel:setText("<c:ffffff>DISTANCE");
		self.distanceText:setText('<c:ffffff>'..getFormattedNumber( math.ceil(self.distanceScore) )..'m');
	else
		self.distanceLabel:setText("<c:fdca00>DISTANCE");
		self.distanceText:setText('<c:fdca00>'..getFormattedNumber( math.ceil(self.distanceScore) )..'m');
	end

	self.distanceLabelShdw:setText("DISTANCE");
	self.distanceTextShdw:setText(getFormattedNumber( math.ceil(self.distanceScore) )..'m');

end

------------------------------------------------------------------------------------

function StateResults:updateKillScoreText()

	if self.killComplete
		or math.ceil(self.enemyKillsScore) < 1 then

		self.killLabel:setText("<c:ffffff>KILL SCORE");
		self.killsText:setText('<c:ffffff>'..getFormattedNumber( math.ceil(self.enemyKillsScore) ));
	else
		self.killLabel:setText("<c:fdca00>KILL SCORE");
		self.killsText:setText('<c:fdca00>'..getFormattedNumber( math.ceil(self.enemyKillsScore) ));
	end

	self.killLabelShdw:setText("KILL SCORE");
	self.killsTextShdw:setText(getFormattedNumber( math.ceil(self.enemyKillsScore) ));

end

------------------------------------------------------------------------------------

function StateResults:updateBonusScoreText()

	if self.bonusComplete
		or math.ceil(self.bonusScore) < 1 then

		self.bonusLabel:setText("<c:ffffff>BONUS");
		self.bonusText:setText('<c:ffffff>'..getFormattedNumber( math.ceil(self.bonusScore) ));
	else
		self.bonusLabel:setText("<c:fdca00>BONUS");
		self.bonusText:setText('<c:fdca00>'..getFormattedNumber( math.ceil(self.bonusScore) ));
	end

	self.bonusLabelShdw:setText("BONUS");
	self.bonusTextShdw:setText(getFormattedNumber( math.ceil(self.bonusScore)) );

end

------------------------------------------------------------------------------------

function StateResults:updateHiScoreText()

	local score = 0;

	if self.finalScore > self.startHighScore then
		score = self.finalScore;
	else
		score = self.startHighScore;
	end

	self.hiScore:setText('<c:fdca00>'..getFormattedNumber(score));
	self.hiScoreShdw:setText(getFormattedNumber(score));

end

------------------------------------------------------------------------------------

function StateResults:pauseScoreTick( time )

	local t = time or 0.25;

	self.tickPause = true;
	self.LevelBar:pause();
	EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="anim update",}, "loop-stop" );

	delay(	t,
				function ()
					self.tickPause = false;
					self.LevelBar:start();
					EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="start sparks",}, "add-sfx" );
				end	);

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:pctScreen(x,y)

	local rX = x*(App.viewportWidth/2);
	local rY = y*(App.viewportHeight/2);

	return rX, rY;

end

------------------------------------------------------------------------------------

function StateResults:updateGoldCount()

	local text = App.data:getGoldCount();

	if text > 99999 then
		text = '99999';
	else
		text = text..'';
	end

end

------------------------------------------------------------------------------------

function StateResults:garageGuideCheck()

   if not GuideMgr:getGuideDisabled( "sale_car" ) then

      local vehicleIndexMap = App.data:getPlayerVehicleIndexMap();
      if vehicleIndexMap and #vehicleIndexMap > 0 then

         for i=1, #vehicleIndexMap do

            if App.data:isPlayerVehicleOnSale(vehicleIndexMap[i]) and
               not App.data:isPlayerVehicleLevelLocked(vehicleIndexMap[i]) and
               not App.data:isPlayerVehicleUnlocked(vehicleIndexMap[i]) then

               local vID = vehicleIndexMap[i];
               local lastSaleGuide = App.data:getValue("last-sale-guide");

               if not lastSaleGuide or lastSaleGuide ~= vID then

                  App.data:setValue( "last-sale-guide", vID );

                  App.data:setValue( "garage-carSale-show", i );

                  GuideMgr:forceGuide("sale_car");

                  --disable the "new car" guide if it hasn't already been shown.
                  local id = "newCarIndex"..i.."shown";
                  App.data:setValue( id, true );

                  return;

               end

            end
         end
      end
   end

   local guideIndex = App.data:showPlayerVehicleLevelGuide();
   if guideIndex then

      if not GuideMgr:getGuideDisabled( "car_unlocked" ) then
         local unlocked = App.data:isPlayerVehicleUnlocked(guideIndex);
         if not unlocked then

            local id = "newCarIndex"..guideIndex.."shown";
            App.data:setValue( id, true );
            App.data:setValue( "garage-newCar-show", guideIndex );

            GuideMgr:forceGuide("car_unlocked");

            return;

         end
      end

   elseif not GuideMgr:getGuideDisabled( "sale_reminder_guide" ) then

      local vehicleIndexMap = App.data:getPlayerVehicleIndexMap();
      if vehicleIndexMap and #vehicleIndexMap > 0 then

         for i=1, #vehicleIndexMap do

            if App.data:isPlayerVehicleOnSale(vehicleIndexMap[i]) then

               local vID = vehicleIndexMap[i];
               local lastSaleGuide = App.data:getValue("last-sale-reminder");

               local timerID = App.data:getValue("last-sale-timer");
               local saleTime = App.data:getPlayerVehicleSaleTime(vID);

               local cd = PromoMgr.timeBetweenSaleGuides or 60*60;

               local lastGuideTimestamp = App.data:getValue("last-sale-reminder-seen");
               local currentTime = TimeMgr:getTimeGMT();

               if lastGuideTimestamp and currentTime then
                  if (currentTime - lastGuideTimestamp) <= cd then
                     return false;
                  end
               end

               if saleTime and saleTime < SALE_REMINDER_TIME_REMAINING then

                  if not timerID or timerID ~= vID then

                     App.data:setValue( "last-sale-timer", vID );
                     App.data:setValue( "last-sale-reminder", vID );
                     App.data:setValue( "garage-carSale-show", i );
                     if currentTime then
                        App.data:setValue("last-sale-reminder-seen", currentTime );
                     end

                     GuideMgr:forceGuide("sale_reminder_guide");

                     return true;

                  end

               end

            end

         end

      end

   end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:createResults()

	local textureSheet		= FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);

	self.distanceLabel		= self:addWidget(TextBox, self.mainLayer, DISTANCE_SCORE.label.x, DISTANCE_SCORE.label.y, 280, 100, "DISTANCE", self.defaultFontName, 16, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.distanceLabelShdw	= self:addWidget(TextBox, self.mainLayer, DISTANCE_SCORE.label.x+2, DISTANCE_SCORE.label.y-2, 280, 100, "DISTANCE", self.defaultFontName, 16, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.distanceText			= self:addWidget(TextBox, self.mainLayer, DISTANCE_SCORE.text.x, DISTANCE_SCORE.text.y, 280, 100, ' ', self.defaultFontName, 20, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.distanceTextShdw	= self:addWidget(TextBox, self.mainLayer, DISTANCE_SCORE.text.x+2, DISTANCE_SCORE.text.y-2, 280, 100, ' ', self.defaultFontName, 20, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

	self.killLabel				= self:addWidget(TextBox, self.mainLayer, KILL_SCORE.label.x, KILL_SCORE.label.y, 280, 100, "KILL SCORE", self.defaultFontName, 16, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.killLabelShdw		= self:addWidget(TextBox, self.mainLayer, KILL_SCORE.label.x+2, KILL_SCORE.label.y-2, 280, 100, "KILL SCORE", self.defaultFontName, 16, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.killsText				= self:addWidget(TextBox, self.mainLayer, KILL_SCORE.text.x, KILL_SCORE.text.y, 280, 100, ' ', self.defaultFontName, 20, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.killsTextShdw		= self:addWidget(TextBox, self.mainLayer, KILL_SCORE.text.x+2, KILL_SCORE.text.y-2, 280, 100, ' ', self.defaultFontName, 20, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

	self.bonusLabel			= self:addWidget(TextBox, self.mainLayer, BONUS_SCORE.label.x, BONUS_SCORE.label.y, 280, 100, "SCORE BONUS", self.defaultFontName, 16, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.bonusLabelShdw		= self:addWidget(TextBox, self.mainLayer, BONUS_SCORE.label.x+2, BONUS_SCORE.label.y-2, 280, 100, "SCORE BONUS", self.defaultFontName, 16, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.bonusText				= self:addWidget(TextBox, self.mainLayer, BONUS_SCORE.text.x, BONUS_SCORE.text.y, 280, 100, '0', self.defaultFontName, 20, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.bonusTextShdw		= self:addWidget(TextBox, self.mainLayer, BONUS_SCORE.text.x+2, BONUS_SCORE.text.y-2, 280, 100, '0', self.defaultFontName, 20, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

	self.finalScoreLbl		= self:addWidget(TextBox, self.mainLayer, TOTAL_SCORE.label.x, TOTAL_SCORE.label.y, 640, 200, "TOTAL SCORE", self.defaultFontName, 16, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.finalScoreLblShdw	= self:addWidget(TextBox, self.mainLayer, TOTAL_SCORE.label.x+2, TOTAL_SCORE.label.y-2, 640, 200, "TOTAL SCORE", self.defaultFontName, 16, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.finalScoreText		= self:addWidget(TextBox, self.mainLayer, TOTAL_SCORE.text.x, TOTAL_SCORE.text.y, 640, 200, ' ', self.defaultFontName, 42, nil,  MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.finalScoreTextShdw	= self:addWidget(TextBox, self.mainLayer, TOTAL_SCORE.text.x+2, TOTAL_SCORE.text.y-2, 640, 200, ' ', self.defaultFontName, 42, nil,  MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

	self.levelText				= self:addWidget(TextBox, self.mainLayer, LEVEL_PROGRESS.label.x, LEVEL_PROGRESS.label.y, 550, 100, "Level ", self.defaultFontName, 15, nil,  MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.levelTextShdw		= self:addWidget(TextBox, self.mainLayer, LEVEL_PROGRESS.label.x+2, LEVEL_PROGRESS.label.y-2, 550, 100, "Level ", self.defaultFontName, 15, nil,  MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

	self.coinIcon				= self:addWidget(Image,   self.mainLayer, COIN_COLLECT.label.x, COIN_COLLECT.label.y, 48, 48, "resources/UI/GR_Icon_Coin.png");
	self.coinText				= self:addWidget(TextBox, self.mainLayer, COIN_COLLECT.text.x, COIN_COLLECT.text.y, 280, 100, '0', self.defaultFontName, 20, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.coinTextShdw			= self:addWidget(TextBox, self.mainLayer, COIN_COLLECT.text.x+2, COIN_COLLECT.text.y-2, 280, 100, '0', self.defaultFontName, 20, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

   self.hiScoreLabel       = self:addWidget(TextBox, self.mainLayer, HI_SCORE.label.x, HI_SCORE.label.y, 640, 100, "HIGH SCORE", self.defaultFontName, 16, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.hiScoreLabelShdw   = self:addWidget(TextBox, self.mainLayer, HI_SCORE.label.x+2, HI_SCORE.label.y-2, 640, 100, "HIGH SCORE", self.defaultFontName, 16, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.hiScore				= self:addWidget(TextBox, self.mainLayer, HI_SCORE.text.x,   HI_SCORE.text.y, 640, 600, ' ', self.defaultFontName, 28, nil,  MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.hiScoreShdw			= self:addWidget(TextBox, self.mainLayer, HI_SCORE.text.x+2, HI_SCORE.text.y-2, 640, 600, ' ', self.defaultFontName, 28, nil,  MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

	self.distanceLabel:setPriority(PRIORTY_6);
	self.distanceText:setPriority(PRIORTY_6);
	self.killLabel:setPriority(PRIORTY_6);
	self.killsText:setPriority(PRIORTY_6);
	self.bonusLabel:setPriority(PRIORTY_6);
	self.bonusText:setPriority(PRIORTY_6);
	self.finalScoreLbl:setPriority(PRIORTY_6);
	self.finalScoreText:setPriority(PRIORTY_6);
	self.levelText:setPriority(PRIORTY_6);
	self.coinText:setPriority(PRIORTY_6);
   self.hiScoreLabel:setPriority(PRIORTY_6);
	self.hiScore:setPriority(PRIORTY_6);
	self.coinIcon:setPriority(PRIORTY_6);

	self.distanceLabelShdw:setPriority(PRIORTY_6-1);
	self.distanceTextShdw:setPriority(PRIORTY_6-1);
	self.killLabelShdw:setPriority(PRIORTY_6-1);
	self.killsTextShdw:setPriority(PRIORTY_6-1);
	self.bonusLabelShdw:setPriority(PRIORTY_6-1);
	self.bonusTextShdw:setPriority(PRIORTY_6-1);
	self.finalScoreLblShdw:setPriority(PRIORTY_6-1);
	self.finalScoreTextShdw:setPriority(PRIORTY_6-1);
	self.levelTextShdw:setPriority(PRIORTY_6-1);
	self.coinTextShdw:setPriority(PRIORTY_6-1);
   self.hiScoreLabelShdw:setPriority(PRIORTY_6-1);
	self.hiScoreShdw:setPriority(PRIORTY_6-1);

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:createWipeVehicle()

	local vehicleIndex	= App.data:getCurrentPlayerVehicle();
	local paintIndex		= App.data:getCurrentPlayerVehiclePaintVariant();
	local armorIndex		= App.data:getPlayerArmorLevel(vehicleIndex);
	local sideIndex		= App.data:isPlayerSideWeaponUnlocked(vehicleIndex);
	local turretIndex		= App.data:isPlayerTurretWeaponUnlocked(vehicleIndex);

	self.WipeVehicleLeft		= self:addWidget(Image, self.mainLayer, -WIPE_VEHICLE_OFFSET[vehicleIndex].x, WIPE_VEHICLE_OFFSET[vehicleIndex].y, WIPE_VEHICLE_DIMENSIONS[vehicleIndex].w, WIPE_VEHICLE_DIMENSIONS[vehicleIndex].h, Vehicle_Paint[vehicleIndex][paintIndex]);
	self.WipeVehicleLeft:setScale(Wipe_Vehicle_Scale.x, Wipe_Vehicle_Scale.y);
	self.WipeVehicleLeft:setParent(self.WipeVehiclePivot);
	self.WipeVehicleLeft:setPriority(PRIORTY_7+PRIORITY_FORCE_ON_TOP);

	self.WipeVehicleRight	= self:addWidget(Image, self.mainLayer, WIPE_VEHICLE_OFFSET[vehicleIndex].x, -WIPE_VEHICLE_OFFSET[vehicleIndex].y, WIPE_VEHICLE_DIMENSIONS[vehicleIndex].w, WIPE_VEHICLE_DIMENSIONS[vehicleIndex].h, Vehicle_Paint[vehicleIndex][paintIndex]);
	self.WipeVehicleRight:setScale(-Wipe_Vehicle_Scale.x, Wipe_Vehicle_Scale.y);
	self.WipeVehicleRight:setParent(self.WipeVehiclePivot);
	self.WipeVehicleRight:setPriority(PRIORTY_7+PRIORITY_FORCE_ON_TOP);

	if armorIndex > 1 then
		armorIndex					= armorIndex - 1;
		self.WipeVehicleArmor	= {};

		for i=1, armorIndex do
			self.WipeVehicleArmor[i] = self:addWidget(Anim, self.mainLayer, 0,0,0,0, Vehicle_Armor[vehicleIndex][i], self.vehicletexture);
			self.WipeVehicleArmor[i]:setScale(Wipe_Vehicle_Scale.x, Wipe_Vehicle_Scale.y);
			self.WipeVehicleArmor[i]:setParent(self.WipeVehiclePivot);
			self.WipeVehicleArmor[i]:setPriority(ARMOR_PRIORITY[vehicleIndex][i]);
		end
	end

	if sideIndex then
		self.WipeVehicleSide		= self:addWidget(Anim, self.mainLayer, 0,0,0,0, Vehicle_Side[vehicleIndex], self.vehicletexture);
		self.WipeVehicleSide:setScale(Wipe_Vehicle_Scale.x, Wipe_Vehicle_Scale.y);
		self.WipeVehicleSide:setParent(self.WipeVehiclePivot);
		self.WipeVehicleSide:setPriority(PRIORTY_9+PRIORITY_FORCE_ON_TOP);
	end

	if turretIndex then
		self.WipeVehicleTurret	= self:addWidget(Anim, self.mainLayer, 0,0,0,0, Vehicle_Turret[vehicleIndex], self.vehicletexture);
		self.WipeVehicleTurret:setScale(Wipe_Vehicle_Scale.x, Wipe_Vehicle_Scale.y);
		self.WipeVehicleTurret:setParent(self.WipeVehiclePivot);
		self.WipeVehicleTurret:setPriority(PRIORTY_10+PRIORITY_FORCE_ON_TOP);
	end

end

----------------------------------------------------------------

function StateResults:updateWipeVehicle()

	if self.WipeVehicleLeft and self.WipeVehicleRight then
      self:deleteWidget(self.WipeVehicleLeft);
      self:deleteWidget(self.WipeVehicleRight);

		if self.WipeVehicleArmor then

			for i=1, #self.WipeVehicleArmor do
            self:deleteWidget(self.WipeVehicleArmor[i]);
			end

			self.WipeVehicleArmor = nil;
		end

		if self.WipeVehicleSide then
         self:deleteWidget(self.WipeVehicleSide);
			self.WipeVehicleSide = nil;
		end

		if self.WipeVehicleTurret then
         self:deleteWidget(self.WipeVehicleTurret);
			self.WipeVehicleTurret = nil;
		end
	end

	self:createWipeVehicle();

end

----------------------------------------------------------------

function StateResults:hideWipeVehicle( show )

	if self.WipeVehicleLeft and self.WipeVehicleRight then

		if show then
			self.WipeVehicleLeft:setVisible(false);
			self.WipeVehicleRight:setVisible(false);

			if self.WipeVehicleArmor then

				for i=1, #self.WipeVehicleArmor do
					self.WipeVehicleArmor[i]:setVisible(false);
				end
			end

			if self.WipeVehicleSide then
				self.WipeVehicleSide:setVisible(false);
			end

			if self.WipeVehicleTurret then
				self.WipeVehicleTurret:setVisible(false);
			end
		else
			self.WipeVehicleLeft:setVisible(true);
			self.WipeVehicleRight:setVisible(true);

			if self.WipeVehicleArmor then

				for i=1, #self.WipeVehicleArmor do
					self.WipeVehicleArmor[i]:setVisible(true);
				end
			end

			if self.WipeVehicleSide then
				self.WipeVehicleSide:setVisible(true);
			end

			if self.WipeVehicleTurret then
				self.WipeVehicleTurret:setVisible(true);
			end
		end

	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:startWipeAnim()

	local sSound = {start={"LevelPopUpCar",},};
	EventMgr:postEvent( { sounds=sSound, name="level popup car",}, "add-sfx" );

	sSound = {start={"Applause",},};
	EventMgr:postEvent( { sounds=sSound, name="level popup car",}, "add-sfx" );

	self.wipeActive	= true;
	self.vehicleTime	= 0.0;

	self.WipeVehiclePivot:setLoc(Vehicle_Start.x, Vehicle_Start.y);
	self:hideWipeVehicle(false);

	self.WipeAnim:stop();
	self.WipeAnim:setVisible(true);
	self.WipeAnim:setTime(0);
	self.WipeAnim:setSpeed(WIPE_ANIM_SCALE);
   --make sure we are on top of resource bar
   self.WipeAnim:setPriority(PRIORITY_FORCE_ON_TOP);
	self.WipeAnim:setListener(	MOAITimer.EVENT_TIMER_END_SPAN,
										function ()
											self.WipeAnim:stop();

											StateMgr:push( "state/state-levelup-popup.lua", {	rewardLevel=self.popupCount,
																												func =	function()
																																local animLngth	= 100;
																																local endFrame		= 0;
																																local level			= self.startLevel;

																																self.wipeActive = false;
																																self.WipeAnim:setVisible(false);
																																self:hideWipeVehicle(true);
																																self:setExitStatePermission(	true,
																																										self.finalScore > self.startHighScore,
																																										string.lower(App.data:getValue("App.settings.brag-access", "hi-score")) == "always"
																																									);

																																level = level + 1;

																																if level >= App.data:getMaxPlayerLevel() then
																																	self.levelText:setText('Level Max');
																																	self.levelTextShdw:setText('Level Max');
																																else
																																	self.levelText:setText('Level '..level);
																																	self.levelTextShdw:setText('Level '..level);
																																end

																																endFrame = math.clamp(App.data:getCurrentPlayerXP()/App.data:getXPLevelReq(), 0, 1) * animLngth;
																																endFrame = endFrame/30;

																																self.LevelBar:stop();
																																self.LevelBar:setSpan(0.0, endFrame );
																																self.LevelBar:start();
																															end} );


										end
									);

	self.WipeAnim:start();

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateResults:checkRewardGrant()

	if self.levelUpCount and self.levelUpCount > 0 then

		for i=self.levelUpCount, 1, -1 do

			print('StateResults:checkRewardGrant - 1', self.levelUpCount, App.data:getCurrentRewardLevel());

			self.levelUpCount = self.levelUpCount - 1;
			App.data:addRewardLevel();

			print('StateResults:checkRewardGrant - 2', self.levelUpCount, App.data:getCurrentRewardLevel());
		end
	end

end

----------------------------------------------------------------

function StateResults:setExitStatePermission( permission, hiScore, forceShowBrag )

	Debug.assert(self.BragButton, 'Brag Button nil');
	Debug.assert(type(self.BragButton) == 'table', 'Brag Button not a Table');
	Debug.assert((self.BragButton or {}).show, 'Brag Button show() not valid');

   if permission then
      self:garageGuideCheck();
   end

	if self.BragButton and
		type(self.BragButton) == 'table' and
		self.BragButton.show then

		if permission then
			self.BackButton:enable();
			self.BackButton:setColor(1.0, 1.0, 1.0, 1.0);
		else
			self.BackButton:disable();
			self.BackButton:setColor(0.25, 0.25, 0.25, 1.0);
		end

		if		hiScore or forceShowBrag then
			self.BragButton:show();
			self.BragButton:enable();
			self.BragButton:setColor(1.0, 1.0, 1.0, 1.0);
		else
			self.BragButton:show();
			self.BragButton:disable();
			self.BragButton:setColor(0.25, 0.25, 0.25, 1.0);
		end

		self.exitPermission = permission;

		--If you dont have Tango you cant brag
		if    (not App.data:getValue("first-result-done"))
			or (not MOAITangoSdk:tangoHasSdkSupport())         then

			self.BragButton:disable();
			self.BragButton:hide();
		end
	end

   if self.DoubleCoin then

      if App.data:canPickupBeUpgraded( PICKUP_COIN_INDEX )  and App.data:getCurrentPlayerLevel( ) > 3 then

         self.DoubleCoin:show();

         if permission then
            self.DoubleCoin:enable();
            self.DoubleCoin:setColor(1.0, 1.0, 1.0, 1.0);
         else
            self.DoubleCoin:disable();
            self.DoubleCoin:setColor(0.25, 0.25, 0.25, 1.0);
         end

      else
         self.DoubleCoin:hide();
         self.DoubleCoin:disable();
      end
   end

end

----------------------------------------------------------------

function StateResults:onBragDown()

--	print('StateResults:onBragDown');

end

----------------------------------------------------------------

function StateResults:goBrag()

	if not self.exitPermission or self.wipeActive then

		return false;
	end

--	print("Go To Brag");
	EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="go brag",}, "loop-stop" );

	StateMgr:push("state/state-brag.lua");

end

----------------------------------------------------------------

function StateResults:onBuyDoubleCoinBought(event)

   if App.lastGameGold and self.coinText and self.coinTextShdw then

      --Apply our double coin right away... otherwise it is a bit anto- climatic!
      App.data:addGold(App.lastGameGold,"Double Coin Purchased");
      App.lastGameGold = App.lastGameGold * 2;

      self.coinText:setText('<c:ffffff>'..App.lastGameGold);
      self.coinTextShdw:setText(App.lastGameGold..'');

   end

end

----------------------------------------------------------------

function StateResults:goDoubleCoin()

   PromoMgr:createPopup( "doubleCoin" );

end

----------------------------------------------------------------

function StateResults:goBack()

--	print("Go To Ranking");

	if not self.exitPermission or self.wipeActive then

		return false;
	end

	self:checkRewardGrant();

	EventMgr:postEvent( {sounds={loop={"ScoreCountUp"}}, name="go ranking",}, "loop-stop" );

   self:checkThiefVideo();

   StateMgr:clear("state/state-ranking.lua");

	if not App.data:getValue("first-result-done") and App.data:getValue("guide-upgrade-complete") then
		App.data:setValue("first-result-done", true);
	end


end

----------------------------------------------------------------

function StateResults:checkThiefVideo()

   --If we are dealing with a Thief
   if FraudMgr:shouldForceVideo() then

      --Did the thief played enough game to get a video
      if App.data:deltaValue("Thief-Video-GameCount",1) >= ( AbTestMgr:getVideoThiefGameAfter() or 1000000 ) then

         MOAIFlurry:eventStart(  "Thief-Video-2",
                                 "Ending",         "playing",
                                 "Ending-Ex",      "after-playing",
                                 "Type",           "after"              );


         local reward = AbTestMgr:getVideoMapGold() or 25;

         if AdMgr:playVideo(  self
                        ,
                           function()
                              App.data:addGold( reward, "Video Thief");
                              EventMgr:postEvent({gold=reward, playType="After Game"}, "video-thief");
                              App.data:setValue("Thief-Video-GameCount",0);

                              MOAIFlurry:eventStop(  "Thief-Video-2",
                                                      "Count",          tostring(App.data:getValue("Thief-Video-Count",1)),
                                                      "Ending",         "success",
                                                      "Ending-Ex",      "after-success"      );
                           end
                        ,
                           function()
                              MOAIFlurry:eventStop(   "Thief-Video-2",
                                                      "Ending",         "failure" ,
                                                      "Ending-Ex",      "after-failure"     );

                           end) then

               EventMgr:postEvent({gold=reward, playType="After Game"}, "video-thief-attempt");


         else

            MOAIFlurry:eventStop(   "Thief-Video-2",
                                    "Ending-Ex",         "after-No-Video",
                                    "Ending",            "No-Video"             );

         end

         return true;

      end
   end

end
----------------------------------------------------------------

return StateResults;

----------------------------------------------------------------
