----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local BUY_ICON_X				= 0
local BUY_ICON_Y				= -120;

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

----------------------------------------------------------------

local Base							= State;
local StateStoreBuyConfirm		= Base:new();

----------------------------------------------------------------

function StateStoreBuyConfirm:onLoad()

   State.onLoad( self );
   
   self.defaultFontName = "resources/font/TangoLatin.otf";
	
   local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);

	self.IS_POPUP  = true;

	-- background and icon
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "SmallBackGround", textureSheet);

	-- currency Icon
	self.BuyIconGem = self:addWidget(Anim, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 0,0, "GemB", textureSheet);
	self.BuyIconGem:setPriority(PRIORTY_1);

	-- push/pop state buttons
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 151, 0,0, "CloseButton", textureSheet, nil, self.goBack, nil, nil, nil, nil, 40);
	self.BackButton:setPriority(PRIORTY_0);
	self.ConfirmButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "SmallBuyButton", textureSheet, nil, self.goConfirm, nil, nil);
	self.ConfirmButton:setPriority(PRIORTY_0);
	
	-- text message
	self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 122, 540, 70, '<c:fefcfc>Confirm Purchase<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleText:setScale(1.5, 1.5);
	self.TitleText:setPriority(PRIORTY_0);
	self.TitleTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, 122-2, 540, 70, '<c:0b141d>Confirm Purchase<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.TitleTextShdw:setScale(1.5, 1.5);
	self.TitleTextShdw:setPriority(PRIORTY_0-1);
	self.MessageText = self:addWidget(TextBox, self.mainLayer, 0, 5, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageText:setPriority(PRIORTY_0);
	self.MessageTextShdw = self:addWidget(TextBox, self.mainLayer, 0-2, 5+2, 500, 170, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageTextShdw:setPriority(PRIORTY_0-1);
	self.BuyButtonText = self:addWidget(TextBox, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 500, 100, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.BuyButtonText:setPriority(PRIORTY_1);
	self.BuyButtonShdw = self:addWidget(TextBox, self.mainLayer, BUY_ICON_X, BUY_ICON_Y, 500, 100, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.BuyButtonShdw:setPriority(PRIORTY_1-1);

end

----------------------------------------------------------------

function StateStoreBuyConfirm:onActivate()

   State.onActivate(self);
	
	self:setMessage();

end

----------------------------------------------------------------

function StateStoreBuyConfirm:onFocus()
   
   State.onFocus(self);
   
end

----------------------------------------------------------------

function StateStoreBuyConfirm:setMessage()
	
	local text				= 'Do you want to buy\n';
	local index				= STORE_PURCHASE_DATA.index;
	local amount			= 0;
	local cost				= 0;
	local offsetBuy		= 0;
	local offsetNegX		= 0;
	
	if STORE_PURCHASE_DATA.currency == 'Key' then
		
		amount	= App.data:getStoreKeyAmount(index);
		cost		= App.data:getStoreKeyCost(index);
		text = text..getFormattedNumber(amount)..' Keys?<c>';
		
	else
		
		amount	= App.data:getStoreGoldAmount(index);
		cost		= App.data:getStoreGoldCost(index);
		text 		= text..getFormattedNumber(amount)..' Coins?<c>';
		
	end
	
	self.MessageText:setText('<c:1b3043>'..text..'<c>');
	self.MessageTextShdw:setText('<c:8fb5cd>'..text..'<c>');
	self.BuyButtonText:setText(cost.gem..'');
	self.BuyButtonShdw:setText('<c:000000>'..cost.gem);
	
	if cost.gem > 9999 then
		offsetBuy = 40;
		offsetNegX = 10;
	elseif cost.gem > 999 then
		offsetBuy = 35;
		offsetNegX = 13;
	elseif cost.gem > 99 then
		offsetBuy = 30;
		offsetNegX = 8;
	elseif cost.gem > 9 then
		offsetBuy = 25;
		offsetNegX = 3;
	else
		offsetBuy = 20;
		offsetNegX = -2;
	end

	self.BuyIconGem:setLoc(BUY_ICON_X-offsetBuy-offsetNegX, BUY_ICON_Y);
	self.BuyButtonText:setLoc(BUY_ICON_X+offsetBuy-offsetNegX, BUY_ICON_Y);
	self.BuyButtonShdw:setLoc(BUY_ICON_X+offsetBuy-offsetNegX+2, BUY_ICON_Y-2);

end

----------------------------------------------------------------

function StateStoreBuyConfirm:goConfirm()

	local index = STORE_PURCHASE_DATA.index;

	if STORE_PURCHASE_DATA.currency == 'Key' then
		self:buyKeys(index);
	else
		self:buyCoins(index);
	end

end

----------------------------------------------------------------

function StateStoreBuyConfirm:buyKeys( index )
	
	if App.data:buyStoreKey(index) then
	
		local bKeys = App.data:getStoreKeyAmount(index);
		
		EventMgr:postEvent( {  index=index, keys=bKeys }, "keys-bought" );
		
		STORE_PURCHASE_DATA = {};
		
		StateMgr:pop();
	else
		
		self:showErrorPopup();
	end
	
end

----------------------------------------------------------------

function StateStoreBuyConfirm:buyCoins( index )
	
	if App.data:buyStoreGold(index) then
	
		local bCoins = App.data:getStoreGoldAmount(index);
		
		EventMgr:postEvent( { index=index, gold=bCoins }, "gold-bought" );
		
		STORE_PURCHASE_DATA = {};
		
		StateMgr:pop();
	else
		
		self:showErrorPopup();
	end
	
end

----------------------------------------------------------------

function StateStoreBuyConfirm:showErrorPopup( message )
	
	local text = message or LocalizationMgr:getString( "NATIVE_TRY_AGAIN" );

   MOAIDialogIOS.showDialog(	LocalizationMgr:getString( "NATIVE_TRANS_FAIL" )
                              ,	text
                              ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                              ,  nil
                              ,  nil
                              ,  false
                              ,  function()
                                 end
                           );
																					
end

----------------------------------------------------------------

function StateStoreBuyConfirm:goBack()

	print("Go Back");
	
	STORE_PURCHASE_DATA = {};
	
	StateMgr:pop();

end

----------------------------------------------------------------

return StateStoreBuyConfirm;

----------------------------------------------------------------
