----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');
require('engine/utility/tableUtil')

----------------------------------------------------------------

local SLIDE_MIN               = -App.viewportWidth/2;
local SLIDE_MAX               = App.viewportWidth/2;
local SLIDE_VOLUME_MIN_X      = -150;
local SLIDE_VOLUME_MAX_X      = 150;
local VOLUME_SLIDER_OFFSET_Y  = 30;
local SLIDE_VOLUME_MIN_Y      = 188+VOLUME_SLIDER_OFFSET_Y;
local SLIDE_VOLUME_MAX_Y      = 288+VOLUME_SLIDER_OFFSET_Y;
local CONTROL_SLIDER_OFFSET_Y = 18;
local SLIDE_CONTROL_MIN_X     = -150;
local SLIDE_CONTROL_MAX_X     = 150;
local SLIDE_CONTROL_MIN_Y     = 64+CONTROL_SLIDER_OFFSET_Y;
local SLIDE_CONTROL_MAX_Y     = 164+CONTROL_SLIDER_OFFSET_Y;
local SLIDE_SCALE             = SLIDE_VOLUME_MAX_X - SLIDE_VOLUME_MIN_X;
local LABEL_VOL_X             = 0;
local LABEL_VOL_Y             = 273+VOLUME_SLIDER_OFFSET_Y;
local LABEL_CONTROL_X         = 0;
local LABEL_CONTROL_Y         = 150+CONTROL_SLIDER_OFFSET_Y;
local CHECKBOX_X              = -134;
local LABEL_FEED_X            = 28;
local LABEL_FEED_Y            = 8;
local LABEL_WEEKLY_X          = 40;
local LABEL_WEEKLY_Y          = -75;
local LABEL_DAILY_X           = 23;
local LABEL_DAILY_Y           = -158;
local LABEL_KEY_X             = 14;
local LABEL_KEY_Y             = -241;

local ROADRIOT_VERSION_X      = 0;
local ROADRIOT_VERSION_Y      = -330;
local DEBUGTXT_X              = 0;
local DEBUGTXT_Y              = 25;
local PRIORTY_0               = 10;
local PRIORTY_1               = 20;
local PRIORTY_2               = 30;
local PRIORTY_3               = 40;
local PRIORTY_4               = 50;
local PRIORTY_5               = 60;
local PRIORTY_6               = 70;

local LEVEL_DEBUG_ENABLE		= true;
local LEAGUE_DEBUG_ENABLE     = false;

if not BUILD_DEBUG then
   LEVEL_DEBUG_ENABLE	= false;
   LEAGUE_DEBUG_ENABLE  = false;
end

----------------------------------------------------------------

local Base						= State;
local StateSupport  			= Base:new();
local localApp					= nil;
local localSelf		    		= nil;
local textureSheet		    	= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
local DEFAULT_DATA_TABLE        = dofile("resources/flash-resource-bundle/Group2.lua");

----------------------------------------------------------------

function StateSupport:onLoad()

   State.onLoad( self );

   localSelf      = self;

   self.defaultFontName = "resources/font/TangoLatin.otf";

    local bgName = "O_Background";
    if App.isDeviceIPhoneX then bgName = "O_Background_iPhoneX"; end

	-- background
	self.BackDrop = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, bgName, textureSheet, self.volumeSlideOn, self.volumeSlideOff, nil, self.volumeSlideMove);
	self.Background = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, bgName, textureSheet, self.controlSlideOn, self.controlSlideOff, nil, self.controlSlideMove);

    local titleTextX = 0;
    local titleTextY = 400;


    self.TitleText = self:addWidget(TextBox, self.mainLayer, titleTextX, titleTextY, 640, 280, '', self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
    self.TitleText:setPriority(PRIORTY_3+1);
    self.TitleTextShadow = self:addWidget(TextBox, self.mainLayer, titleTextX+2, titleTextY-2, 640, 280, '', self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
    self.TitleTextShadow:setPriority(PRIORTY_3);
    self.TitleText:setText(      '<c:ffffff>SUPPORT<c:ffffff>');
    self.TitleTextShadow:setText(      '<c:000000>SUPPORT<c:000000>');


	-- state buttons
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "O_ReadyButton", textureSheet, nil, self.goBack, nil, nil);
	self.BackButton:setPriority(PRIORTY_3);

    self.EmailButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "O_BlueButton", textureSheet, nil, self.goEmail, nil, nil);
    self.EmailButton:setPriority(PRIORTY_3);
    local emailTextX = -2;
    local emailTextY = 150;

   self.EmailButtonText = self:addWidget(TextBox, self.mainLayer, emailTextX, emailTextY, 640, 280, '', self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.EmailButtonText:setPriority(PRIORTY_3+1);
   self.EmailButtonTextShadow = self:addWidget(TextBox, self.mainLayer, emailTextX+2, emailTextY-2, 640, 280, '', self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.EmailButtonTextShadow:setPriority(PRIORTY_3);

self.EmailButtonText:setText(      '<c:ffffff>CONTACT US<c:ffffff>');
self.EmailButtonTextShadow:setText(      '<c:000000>CONTACT US<c:000000>');

    self.CreditsButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,-200,0,0, "O_BlueButton", textureSheet, nil, self.goCredits, nil, nil);
    self.CreditsButton:setPriority(PRIORTY_3);
    local creditsTextX = -2;
    local creditsTextY = -50;

   self.CreditsButtonText = self:addWidget(TextBox, self.mainLayer, creditsTextX, creditsTextY, 640, 280, '', self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.CreditsButtonText:setPriority(PRIORTY_3+1);
   self.CreditsButtonTextShadow = self:addWidget(TextBox, self.mainLayer, creditsTextX+2, creditsTextY-2, 640, 280, '', self.defaultFontName, 22, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.CreditsButtonTextShadow:setPriority(PRIORTY_3);

    self.CreditsButtonText:setText(      '<c:ffffff>CREDITS<c:ffffff>');
    self.CreditsButtonTextShadow:setText(      '<c:000000>CREDITS<c:000000>');

--

   -- Player name text
   self.PlayerNameText = self:addWidget(TextBox, self.mainLayer, ROADRIOT_VERSION_X, ROADRIOT_VERSION_Y, 640, 280, '', self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.PlayerNameText:setPriority(PRIORTY_2);
   self.PlayerNameTextShadow = self:addWidget(TextBox, self.mainLayer, ROADRIOT_VERSION_X+2, ROADRIOT_VERSION_Y-2, 640, 280, '', self.defaultFontName, 14, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.PlayerNameTextShadow:setPriority(PRIORTY_2-1);

	self:_setupBasicResourceBar();

end



----------------------------------------------------------------

function StateSupport:onActivate()

   Base.onActivate(self);

   LoaderMgr:addTask( nil, self, function () StateMgr:loadState ( "state/state-credits.lua" ) end );

   local playerName = App:getJunePlayerId()  or "- unlinked -";
   self.PlayerNameText:setText(      '<c:4c8ebe>Player Id: <c:4c8ebe>' .. playerName .. ' <c>');
   self.PlayerNameTextShadow:setText('<c:000000>Player Id: <c:000000>' .. playerName .. ' <c>');

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

end

----------------------------------------------------------------

function StateSupport:onFocus()

   print("StateSupport:onFocus");

   Base.onFocus(self);
end

----------------------------------------------------------------

function StateSupport:onLoseFocus()

   print("StateSupport:onLoseFocus");

   Base.onLoseFocus(self);


end

----------------------------------------------------------------

function StateSupport:goCredits()

    print("Go To Credits");

   if LEVEL_DEBUG_ENABLE then
      StateMgr:push("state/state-cheat.lua");
   else
      StateMgr:push("state/state-credits.lua");
   end
end

----------------------------------------------------------------

function StateSupport:goEmail()

local devType = MOAIEnvironment.osBrand:lower();
local udid = MOAIEnvironment.udid;
local origDevType = devType;
if devType == "android" and false then
    self:showErrorPopup("Please contact us at roadriot@junegaming.freshdesk.com. Please mention your player id: ".. App:getJunePlayerId() .. " in the email.");
    return;
end

self.emailView = MOAIEmailViewIOS.new();

self.emailView:init();

if devType == "ios" then
    udid = MOAIEnvironment.openUdid;


    self.emailView:setListener(MOAIEmailViewIOS.MAIL_COMPOSE_RESULT_CANCELLED, function()  end)
    self.emailView:setListener(MOAIEmailViewIOS.MAIL_COMPOSE_RESULT_SAVED, function() end)
    self.emailView:setListener(MOAIEmailViewIOS.MAIL_COMPOSE_RESULT_SENT, function()  end)
    self.emailView:setListener(MOAIEmailViewIOS.MAIL_COMPOSE_RESULT_FAILED, function() self:showErrorPopup(nil);  end)
end

self.emailView:setSubject("Road Riot Support");
self.emailView:addRecepientTo("roadriot@junegaming.freshdesk.com");

    local locale = MOAIEnvironment.languageCode or "en";

local curTime = tostring(TimeMgr:getTimeGMT() or 0);
devType =            tostring(MOAIEnvironment.osBrand);

if MOAIEnvironment.devBrand then
    devType = devType .. "-" ..   tostring(MOAIEnvironment.devBrand)
end

if MOAIEnvironment.devManufacturer then
    devType = devType .. "-" ..   tostring(MOAIEnvironment.devManufacturer);
end

if MOAIEnvironment.devName then
    devType = devType .. "-" ..   tostring(MOAIEnvironment.devName);
end

if MOAIEnvironment.devModel then
    devType = devType .. "-" ..   tostring(MOAIEnvironment.devModel);
end

if MOAIEnvironment.devProduct then
    devType = devType .. "-" ..   tostring(MOAIEnvironment.devProduct);
end

local level =        tostring(App.data:getCurrentPlayerLevel());

local s = "Hi,\n\nPlease enter your feedback here\n\n";
s = s.."--------DO NOT DELETE!--------\n";
s = s.."UTC Time: " .. tostring(curTime) .. "\n";
s = s.."Game: Road Riot\n";
s = s.."Current Version: " .. tostring(App.info.version) .. "\n";
s = s.."Player ID: " .. tostring(App:getJunePlayerId()) .. "\n";
s = s.."Device Type: " .. devType .. "\n";
s = s.."Level: " .. level .. "\n";
if LoginMgr:isTango() then
    s = s.."T Id: " .. ContactMgr:getProfile():getAccountId() .. "\n";
end
s = s.."------------------------------\n";
s = s.."\n\n";
s = s.."Thanks";

    self.emailView:setBody(s);


    if origDevType == "android" or (origDevType == "ios" and self.emailView:canSendEmail()) then
        self.emailView:show(true);
    else
        self:showErrorPopup("Device not configured to send email. Please contact us at roadriot@junegaming.freshdesk.com. Please mention your player id: ".. App:getJunePlayerId() .. " in the email.");
    end
end

----------------------------------------------------------------

function StateSupport:showErrorPopup( message )

   local text = message or LocalizationMgr:getString( "NATIVE_TRY_AGAIN" );

   MOAIDialogIOS.showDialog( "Email Failed" 
                             , text
                             ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                             ,  nil
                             ,  nil
                             ,  false
                             ,  function()
                                end
   );

end

----------------------------------------------------------------------

function StateSupport:isBusy()
   return StoreMgr:isBusy();
end

----------------------------------------------------------------

function StateSupport:goBack()

	print("Go Back");
	StateMgr:pop();

end

----------------------------------------------------------------

return StateSupport;

----------------------------------------------------------------
