----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local PRIORTY_0				= 10;
local PRIORTY_1				= 20;
local PRIORTY_2				= 30;
local PRIORTY_3				= 40;
local PRIORTY_4				= 50;
local PRIORTY_5				= 60;
local PRIORTY_6				= 70;
local PRIORTY_7				= 80;
local PRIORTY_8				= 90;
local PRIORTY_9				= 100;
local PRIORTY_10				= 110;

----------------------------------------------------------------

local Base							= State;
local StateTangoBonusConfirm		= Base:new();

local Bonus_Icon_X			= 0;
local Bonus_Icon_Y			= 0;

----------------------------------------------------------------

function StateTangoBonusConfirm:onLoad()

   State.onLoad( self );

   self.defaultFontName = "resources/font/TangoLatin.otf";

   local textureSheet			= FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
   local popupSheet				= FlashMgr:getTextureSheet("resources/flash-resource-bundle/PopUPs.lua", "resources/flash-resource-bundle/PopUPs.png", 30);

	self.IS_POPUP  = true;

	-- background
	self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "SmallBackGround", popupSheet);

	self.TangoBonusIcon = self:addWidget(Anim, self.mainLayer, Bonus_Icon_X, Bonus_Icon_Y, 0,0, "ReceiveGem", textureSheet, nil, nil, true);
	self.TangoBonusIcon:setScale(1.2);

	-- push/pop state buttons
	self.CloseButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 151, 0,0, "CloseButton", popupSheet, nil, self.goBack, nil, nil);
	self.CloseButton:setPriority(PRIORTY_2);
	self.ConfirmButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "SmallOkButton", popupSheet, nil, self.goBack, nil, nil);
	self.ConfirmButton:setPriority(PRIORTY_2);
	
	-- text message
	self.TitleText = self:addWidget(TextBox, self.mainLayer, 0, 122, 540, 70, '<c:fefcfc>Welcome to Tango<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.TitleText:setScale(1.5, 1.5);
	self.TitleText:setPriority(PRIORTY_0);
	self.TitleTextShdw = self:addWidget(TextBox, self.mainLayer, 0+2, 122-2, 540, 70, '<c:0b141d>Welcome to Tango<c>', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
	self.TitleTextShdw:setScale(1.5, 1.5);
	self.TitleTextShdw:setPriority(PRIORTY_0-1);
	
	self.MessageText = self:addWidget(TextBox, self.mainLayer, 0, 45, 500, 230, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageText:setPriority(PRIORTY_1);
	self.MessageText.moaiTextBox:setLineSpacing(10);
	
	self.MessageTextShadow = self:addWidget(TextBox, self.mainLayer, 0-2, 45+2, 500, 230, '', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.MessageTextShadow:setPriority(PRIORTY_0);
	self.MessageTextShadow.moaiTextBox:setLineSpacing(10);
	
	self.BonusText = self:addWidget(TextBox, self.mainLayer, 0,Bonus_Icon_Y, 520, 230, '', self.defaultFontName, 28, "0123456789", MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.BonusText:setPriority(PRIORTY_1);
	
	self.BonusTextShadow = self:addWidget(TextBox, self.mainLayer, 0,Bonus_Icon_Y, 520, 230, '', self.defaultFontName, 28, "0123456789", MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	self.BonusTextShadow:setPriority(PRIORTY_0);

end

----------------------------------------------------------------

function StateTangoBonusConfirm:onActivate()

   State.onActivate(self);

end

----------------------------------------------------------------

function StateTangoBonusConfirm:onFocus()
   
   State.onFocus(self);
   
	self.TangoBonusIcon:swapGraphic("ReceiveGem");
	self.TangoBonusIcon:setScale(1.2);
	
	self:setMessage();
	
end

----------------------------------------------------------------

function StateTangoBonusConfirm:isUsingCameraHack()
   return false;
end


----------------------------------------------------------------

function StateTangoBonusConfirm:setMessage()
	
	local message		= "";--'Here\'s your free gift';
	local iconOffset	= 0;
	local bonusOffset	= 0;
   local bonus       = App.data:getTangoBonus();

	self.MessageText:setText('<c:1b3043>'..message..'<c>');
	self.MessageTextShadow:setText('<c:8fb5cd>'..message..'<c>');
	self.BonusText:setText('<c:fefcfc> '..bonus..'<c>');
	self.BonusTextShadow:setText('<c:0b141d> '..bonus..'<c>');
	
	if bonus > 999 then
		iconOffset = -70;
		bonusOffset = 50;
	elseif bonus > 99 then
		iconOffset = -62;
		bonusOffset = 42;
	elseif bonus > 9 then
		iconOffset = -47;
		bonusOffset = 27;
	else
		iconOffset = -40;
		bonusOffset = 20;
	end

	self.TangoBonusIcon:setLoc(iconOffset, Bonus_Icon_Y);
	self.BonusText:setLoc(bonusOffset, Bonus_Icon_Y);
	self.BonusTextShadow:setLoc(bonusOffset+2, Bonus_Icon_Y-2);

end

----------------------------------------------------------------

function StateTangoBonusConfirm:goBack()

	StateMgr:clear( "state/state-ranking.lua" );

end

----------------------------------------------------------------

return StateTangoBonusConfirm;

----------------------------------------------------------------
