----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-anim');
require('engine/utility/tableUtil')
require('engine/json/json')
require('app/cloud/june-api-manager')
require("engine/utility/stringUtils");

local json = require('json');

----------------------------------------------------------------
local Base              = State;
local StateTestLayout      = Base:new();
----------------------------------------------------------------

function  StateTestLayout:onLoad()

   State.onLoad( self );

   self.name   = "state-testlayout";
   self._possessions = nil;
   self.lastKeyTextUpdate = 0;
   self.uploaded = false;

   self.defaultFontName = "resources/font/TangoLatin.otf";
   self.unicodeFontName = "resources/font/Tango.otf";
   self.textureSheet    = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
   self.textureSheet2   = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);
   self.textureSheet3   = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group3.lua", "resources/flash-resource-bundle/Group3.png", 30);

    print("UDID = " .. MOAIEnvironment.openUdid);

    print("Possessions tablke: ", json.encode(remotePossessions));

    self:showGarageLayout();

    local testTable = {};
    local testTable2 = {
                            Possessions= {
                                pos1={
                                    LastModified = 1452458785,
                                    Value = "pos1Value",
                                    Version = "12"
                                },
                                pos2={
                                    LastModified = 1452458845,
                                    Value = "pos2Value",
                                    Version = "122"
                                }
                            }
                        };

    print("testTable nil = "..tostring(testTable == nil).." testTable.possessions nil = ".. tostring(testTable.Possessions == nil));
    print("testTable2 nil = "..tostring(testTable2 == nil).." testTable2.possessions nil = ".. tostring(testTable2.Possessions == nil).." testTable2 count = ".. tostring(#getTableKeys(testTable)));



--    self:createJunePossessions();
--    self:sendWebRequest();

self.emailView = MOAIEmailViewIOS.new();

--   self.emailView:setListener(MOAIWebViewIOS.WEB_VIEW_DID_HIDE, function() StateMgr:pop(); end)

   if self.emailView:canSendEmail() then
        print("self.emailView:canSendEMail");
       self.emailView:show(true);
    else
            print("self.emailView:canSendEMail - FALSE");
    end

end

function StateTestLayout:showGarageLayout()
    local FrameOverlay = self:addWidget(Anim, self.mainLayer, 0,0,0,0, 'GarageScrollFrameIPhoneX', self.textureSheet);
    FrameOverlay:setPriority(PRIORTY_12);
end

function StateTestLayout:createJunePossessions()
    local dir = MOAIEnvironment.documentDirectory;
    print("MOAIEnvironment.documentDirectory = ", tostring(dir));

    local fileName = dir .. "/TangoPossessions";
    local loadedChunk = StateTestLayout:readall(fileName);
    local posTable = { loadedChunk };
    local createPossessionsRequestClass = MOAIJuneGetPossessionsHandler;
    local createPossessionsRequest = createPossessionsRequestClass:new();
    createPossessionsRequest:setListener(MOAIJuneResponseHandler.RESPONSE_PROCESSED, function(...) self:_onResponseProcessed(createPossessionsRequest, {...}) end);
    createPossessionsRequest:processResponse(unpack(posTable));
end

function StateTestLayout:_onResponseProcessed(request, processedResponse)
    local success, possessions = unpack(processedResponse);
    self._possessions = possessions;
    self:createJunePossessionsUploadJson(possessions);
end

function StateTestLayout:createJunePossessionsUploadJson(possessions)
    print("StateTestLayout:createJunePossessionsUploadJson");
    local posTable = { possessions };
    local createJsonRequestClass = MOAIJuneUploadPossessionsHandler;
    local jsonRequest = createJsonRequestClass:new();
    jsonRequest:setListener(MOAIJuneResponseHandler.POSSESSIONS_JSON_CREATED, function(...) self:_onUploadJsonReceived(jsonRequest, {...}) end);
    jsonRequest:processResponse(unpack(posTable));
end

function StateTestLayout:sendWebRequest()
local requestOptions = {
                  priority = Request.PRIORITY_LOW,
                  callHandler = StateTestLayout,
                  successFunc = function(callHandler, task) callHandler:_handleAdImageFetch(task, "fileName") end,
                  url = "http://prod.api.roadriot.mgaming.net/api/status/check",
                  retryCount = 3,
               }

               local request = WebRequest.newFromBase(requestOptions);

               NetworkMgr:sendWebRequest(request);
end

function StateTestLayout:_handleAdImageFetch(task, filename)
    print("StateTestLayout:_handleAdImageFetch -> ", task:getString());
end

function StateTestLayout:readall(filename)
  local fh = assert(io.open(filename, "rb"))
  local contents = assert(fh:read("*a")) -- "a" in Lua 5.3; "*a" in Lua 5.1 and 5.2
  fh:close()
  return contents
end

----------------------------------------------------------------

return StateTestLayout;

----------------------------------------------------------------
