require('state/state')

----------------------------------------------------------------

local Base       = State;
local StateViewNativeAd = Base:new();

function StateViewNativeAd:onFocus( param )

   param = param or {};

   Base.onFocus( self );

   StateMgr:setSyncBusyDelay(0);
   disableButtonInput();

   if param.url then
      self:_displayWebView(param.url);
   end

end

----------------------------------------------------------------

function StateViewNativeAd:onLoseFocus( )

   Base.onLoseFocus(self);

   StateMgr:setSyncBusyDelay(nil);
   enableButtonInput();

end

----------------------------------------------------------------------

function StateViewNativeAd:shouldReportBusy()
   return false;
end

----------------------------------------------------------------------

function StateViewNativeAd:isBusy()
   return true;
end

----------------------------------------------------------------------

function StateViewNativeAd:getBusyName()
   return "Loading page...";
end

----------------------------------------------------------------

function StateViewNativeAd:_displayWebView(url)
   print("Creating webview.");
   self.webView = MOAIWebViewIOS.new();

   self.webView:setListener(MOAIWebViewIOS.WEB_VIEW_DID_HIDE, function() StateMgr:pop(); end)

   print("Showing webview.");
   self.webView:show(true);

   print("Loading webview request.");
   self.webView:loadRequest(url);

   --delay(3, function() StateViewNativeAd.webView:show(true); end)
end

----------------------------------------------------------------

return StateViewNativeAd
