require('engine/object/object')
require('engine/texture/texture-manager')
----------------------------------------------------------------------

Widget =
{
};

----------------------------------------------------------------------

function Widget:new( screen, parent, layer, x, y, w, h )

   local widget   = Object.new( self );

   widget.screen  = screen;
   widget.parent  = parent;
   widget.layer   = layer;
   widget.loc     = { x, y };
   widget.size    = { w, h };
   widget.scale   = { 1, 1 };
   widget.enabled = true;
   widget.hidden  = false;
   widget.color   = {1,1,1,1};

   return widget;

end

----------------------------------------------------------------------

function Widget:delete( )

   self.layer = nil;

end

----------------------------------------------------------------------

function Widget:updateClick( down, x, y )
end

----------------------------------------------------------------------

function Widget:updateMove( x, y )
end

----------------------------------------------------------------------

function Widget:isEnabled()
   return self.enabled;
end

----------------------------------------------------------------------

function Widget:enable()
   self.enabled = true;
end

----------------------------------------------------------------------

function Widget:disable()
   self.enabled = false;
end

----------------------------------------------------------------------

function Widget:setEnable( e )
   if e then
      self:enable();
   else
      self:disable();
   end
end
----------------------------------------------------------------------

function Widget:setScale( sx, sy )

   self.scale = { sx, sy };

end

----------------------------------------------------------------------

function Widget:pauseLastFrame()
end

----------------------------------------------------------------------

function Widget:getTime()
end

----------------------------------------------------------------------

function Widget:getAnimName()
end

----------------------------------------------------------------------

function Widget:setListener(  )
end

----------------------------------------------------------------------

function Widget:setParent( parent )
end


----------------------------------------------------------------------

function Widget:setPriority( priority )
end


-------------------------------------------------------------------------------------

function Widget:setAttrLink( )
end


----------------------------------------------------------------------

function Widget:addAnim()

end

----------------------------------------------------------------------

function Widget:addGraphic()
end

----------------------------------------------------------------------

function Widget:swapGraphic()
end

----------------------------------------------------------------------

function Widget:deleteAnim( )
end

----------------------------------------------------------------------

function Widget:swapAnim( anim )
end

----------------------------------------------------------------------

function Widget:setSpan()
end

----------------------------------------------------------------------

function Widget:setMode(  )
end

----------------------------------------------------------------------

function Widget:apply(  )
end

----------------------------------------------------------------------

function Widget:setAnimFrame( )
end

----------------------------------------------------------------------

function Widget:setAnimLastFrame( )
end

----------------------------------------------------------------------

function Widget:setTime(  )
end

----------------------------------------------------------------------

function Widget:start()
end

----------------------------------------------------------------------

function Widget:pause()
end

----------------------------------------------------------------------

function Widget:stop()
end

----------------------------------------------------------------------

function Widget:resetAnim()
end

----------------------------------------------------------------------

function Widget:setSpeed( speed )
end

----------------------------------------------------------------------

function Widget:isVisible()

	if self.visible == nil then

		return true;
	end

	return self.visible;

end

----------------------------------------------------------------------

function Widget:setVisible( visible )

   if visible then
      self:show();
   else
      self:hide();
   end

end

----------------------------------------------------------------------

function Widget:isInside(x,y)

   return         math.abs(x-self.loc[1]) <= self.size[1]/2*self.scale[1]
            and   math.abs(y-self.loc[2]) <= self.size[2]/2*self.scale[2];

end

----------------------------------------------------------------------

function Widget:hide()

   if not self:isHidden() then
      self.visible = false;
      self.hidden = true;
      self.hiddenColor = self:getColor();
      self:setColor( 1,1,1,0 );
   end
end

----------------------------------------------------------------------

function Widget:show()

   if self:isHidden() then
      self.visible = true;
      self.hidden = false;
      self:setColor( self.hiddenColor[1], self.hiddenColor[2], self.hiddenColor[3], self.hiddenColor[4] );
   end

end

----------------------------------------------------------------------

function Widget:isHidden()
   return self.hidden;
end

----------------------------------------------------------------------

function Widget:setLoc(x,y)

   self.loc[1] = x;
   self.loc[2] = y;

end

----------------------------------------------------------------------

function Widget:setLocX(x)

   self.loc[1] = x;

end

----------------------------------------------------------------------

function Widget:setLocY(y)

   self.loc[2] = y;

end

----------------------------------------------------------------------

function Widget:getLoc()
   if self.loc then
      return self.loc[1],self.loc[2];
   end
end

----------------------------------------------------------------------

function Widget:getLocX()
   if self.loc then
      return self.loc[1];
   end
end

----------------------------------------------------------------------

function Widget:getLocY()
   if self.loc then
      return self.loc[2];
   end
end

----------------------------------------------------------------------

function Widget:getColor()
   return self.color;
end

----------------------------------------------------------------------

function Widget:setColor( r, g, b, a  )
   self.color = {r, g, b, a};
end

----------------------------------------------------------------------

function Widget:setAlpha( a  )
   if self.color then
      self.color[4]= a;
   end
end

----------------------------------------------------------------------

function Widget:createProp( layer, x, y, w, h, filename, parent )

   local gfxQuad = MOAIGfxQuad2D.new ()
   local texture = TextureMgr:getTexture(filename, true);

   gfxQuad:setTexture ( texture )
   gfxQuad:setRect ( -w/2, -h/2, w/2, h/2 )

   if texture and texture._uv then

      --setUVRect inverse the image for us... go figure!?
      gfxQuad:setUVRect(      texture._uv.xMin or 0
                           ,  texture._uv.yMax or 1
                           ,  texture._uv.xMax or 1
                           ,  texture._uv.yMin or 0 );
   end

   local prop = MOAIProp2D.new ()
   prop:setDeck ( gfxQuad )
   prop:setPriority ( 0 )
   prop:setLoc(x,y)
   prop:setBlendMode( MOAIProp.GL_SRC_ALPHA, MOAIProp.GL_ONE_MINUS_SRC_ALPHA );

   if parent then
      prop:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, parent, MOAIProp2D.TRANSFORM_TRAIT );
   end

   layer:insertProp ( prop )

   return prop;

end

----------------------------------------------------------------------

function Widget:removeProp( prop )

   if self.layer then

      self.layer:removeProp( prop );

   end

end

----------------------------------------------------------------------

function Widget:createAnim( layer, x, y, w, h, anim, spritesheet, graphic )

   local X = x or 0;
   local Y = y or 0;

   local player

   if graphic then
      player = spritesheet:newProp(anim);

      Debug.assert(player, "Player was nil, expected prop");

      player:setPriority(0);
      player:setLoc(X, Y);
      layer:insertProp(player);
   else
      player = spritesheet:newAnimPlayer(anim);

      Debug.assert(player, "Player was nil, expected animplayer");

      for i=1,#player.props do
         player.props[i]:setPriority(0);
      end
      player.root:setLoc(X, Y);
      player:insertProps(layer);
   end

   player.layer = layer;
   player.spritesheet = spritesheet;

   return player;

end

----------------------------------------------------------------------

function Widget:forceUpdate()
   -- Does nothing; there are no props to update
   -- Allows users to call forceUpdate safely on all Widgets.
end
