----------------------------------------------------------------------
local defaultFontName = "resources/font/TangoLatin.otf";
local defaultFontSize = 16;
----------------------------------------------------------------------
TEMPLATE_GUIDE_SETS = {

------------------------------------------------------------------------------------
-- New Player
------------------------------------------------------------------------------------

   {
      name = "new_player_a",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=280, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=280, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            actions = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", frame = {x=-160, y=-185}, }, },
               { activate="slideIn", element = { name="portrait", time=0.25, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_NEW_PLAYER", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=157, y=0, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_NEW_PLAYER", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=159, y=-2, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="pullWidget", element = { type="button", name="PlayButton", priority=2001, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="PlayButton", eScl=1.1, }, },
            },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "new_player_b",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            actions = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", frame = {x=-160, y=-185}, }, },
               { activate="slideIn", element = { name="portrait", time=0.25, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_NEW_PLAYER", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_NEW_PLAYER", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="pullWidget", element = { type="button", name="PlayButton", priority=2001, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="PlayButton", eScl=1.1, }, },
            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Upgrade Car
------------------------------------------------------------------------------------

   {
      name = "upgrade_weapon_a",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_UPGRADE_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_UPGRADE_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2002, }, },


            },
         },
         {
            state="state/state-garage.lua",
            actions = {

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="currentWeaponButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="list", name="currentWeaponPips", priority=2001, }, },

            },
         },
         {
            state="state/state-garage.lua",
            actions = {


               { activate="pullWidget", deactivate="pushWidget", element = { type="list", name="purchaseBarRef", }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="purchaseFrameRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="purchaseIconRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="purchaseWeaponIconRef", }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="purchaseButtonRef", releaseCalls = {"nextPage"}, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseModeTitleRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseAcTextRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseCostRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseCostRefShdw", }, },

            },
         },
         {
            state="state/state-garage.lua",
            actions = {

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1, }, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.5, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185 }, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_UPGRADE_2", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_UPGRADE_2", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="BackButton", priority=2001, releaseCalls = {"nextPage", }, }, },
            },
         },
         {
            state="state/state-ranking.lua",
            actions = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },
               { activate="localFunc", element = { func="bountyTutorialKeyCheck", args=nil, returnFunc=nil }, },

               { activate="pullWidget", element = { type="button", name="PlayButton", priority=2001, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="PlayButton", eScl=1.1, }, },
           },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "upgrade_weapon_b",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-results.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185}, }, },
               { activate="slideIn", deactivate="slideOut", element = { name="portrait", time=0.35, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_UPGRADE_3", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=320, }, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p1", endFunc="fadeIn", time=0.75, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_UPGRADE_3", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=320, }, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p1", endFunc="fadeIn", time=0.75, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_p1", endFunc="bubbleBoxIn", time=0.75, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="BackButton", priority=2001, releaseCalls = {"nextPage"}, }, },


            },
         },
         {
            state="state/state-garage.lua",
            actions = {

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="currentWeaponButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="list", name="currentWeaponPips", priority=2001, }, },

            },
         },
         {
            state="state/state-garage.lua",
            actions = {

               { activate="pullWidget", deactivate="pushWidget", element = { type="list", name="purchaseBarRef", }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="purchaseFrameRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="purchaseIconRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="purchaseWeaponIconRef", }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="purchaseButtonRef", releaseCalls = {"nextPage"}, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseModeTitleRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseAcTextRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseCostRef", }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="purchaseCostRefShdw", }, },

            },
         },
         {
            state="state/state-garage.lua",
            actions = {

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1, }, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.5, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185 }, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_UPGRADE_2", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_UPGRADE_2", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=300, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="BackButton", priority=2001, releaseCalls = {"nextPage", }, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=1, alpha=0.7, }, },




            },
         },

      },

   },

------------------------------------------------------------------------------------

   {
      name = "upgrade_reminder_a",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_UPGRADE_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_UPGRADE_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2001, }, },



            },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "upgrade_reminder_b",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_UPGRADE_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_UPGRADE_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2001, }, },



            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Daily Challenge
------------------------------------------------------------------------------------

   -- old
   {
      name = "daily_complete_a",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=360, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=300, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=300, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=360, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_DAILY", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_DAILY", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="DailyButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="IconBadgeDaily", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="IconDailySparkle", priority=2002, }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------

   -- old
   {
      name = "daily_complete_b",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=300, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=300, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=300, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=360, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_DAILY", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_DAILY", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="DailyButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="IconBadgeDaily", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="IconDailySparkle", priority=2002, }, },


            },
         },
      },
   },

------------------------------------------------------------------------------------

   -- new
   {
      name = "daily_intro",

      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=360, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=400, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=400, }, },
      },

      pages =
      {
         {
            state    = "state/state-ranking.lua",
            init     =
            {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=400, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DAILY_INTRO_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=400, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DAILY_INTRO_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="DailyButton", priority=2001, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="IconBadgeDaily", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="IconDailySparkle", priority=2002, }, },
               { activate="localFunc", element = { func="guideDailyIntro", args=nil, }, },
            },
         },
         {
            state    = "state/state-daily.lua",
            actions  =
            {
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=240, chunkH=60, textX=-150, textY=-180, portraitX=160, portraitY=-250, dongleOffset=480}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-180, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DAILY_INTRO_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-180-2, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DAILY_INTRO_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
			{
            state		= "state/state-daily.lua",
            actions	=
            {
               { activate="localFunc", element={ func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
			},
      },
   },

------------------------------------------------------------------------------------

   {
      name = "daily_reminder",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DAILY_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DAILY_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="DailyButton", priority=2001, releaseCalls = {"nextPage"}, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="IconBadgeDaily", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="IconDailySparkle", priority=2002, }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "notification_guide_daily_success",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DAILY_SUCCESS_NOTIFY", }, },


               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },


               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DAILY_SUCCESS_NOTIFY", }, },


               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, black=false, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="OptionsButton", priority=2001, releaseCalls = {"nextPage"}, }, },

            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "notification_guide_daily_fail",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_DAILY_FAIL_NOTIFY", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },


               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DAILY_FAIL_NOTIFY", }, },


               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, black=false, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="OptionsButton", priority=2001, releaseCalls = {"nextPage"}, }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Missions
------------------------------------------------------------------------------------

   -- old
   {
      name = "mission_complete_a",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=360, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=300, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=300, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=360, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_MISSION", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_MISSION", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="MissionButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="mIconBadgeGem", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="mIconBadgeSparkle", priority=2002, }, },
            },
         },
      },
   },

------------------------------------------------------------------------------------

   -- old
   {
      name = "mission_complete_b",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=360, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=300, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=300, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=360, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_FIRST_MISSION", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FIRST_MISSION", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="MissionButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="mIconBadgeGem", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="mIconBadgeSparkle", priority=2002, }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------

   -- new
   {
      name = "mission_intro",

      guideElements  =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=360, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=300, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=300, }, },
      },

      pages =
      {
         {
            state    =  "state/state-ranking.lua",
            init     =
            {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=300, },  lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_MISSION_INTRO_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=300, },  lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_MISSION_INTRO_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="MissionButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="mIconBadgeGem", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="mIconBadgeSparkle", priority=2002, }, },
               { activate="localFunc", element = { func="guideMissionIntro", args=nil, }, },
            },
         },
         {
            state    =  "state/state-mission-popup.lua",
            actions  =
            {
               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="fadeOut", element = { name="portrait", time=0.1, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=180, chunkH=60, textX=-150, textY=-180, portraitX=160, portraitY=-185, dongleOffset=480,}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-180, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_MISSION_INTRO_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-180-2, w=350, h=300, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_MISSION_INTRO_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
			{
            state		= "state/state-mission-popup.lua",
            actions	=
            {
               { activate="localFunc", element={ func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
			},
      },
   },

------------------------------------------------------------------------------------

   {
      name = "mission_reminder",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_MISSION_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_MISSION_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="MissionButton", priority=2001, releaseCalls = {"nextPage"}, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="mIconBadgeGem", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="mIconBadgeSparkle", priority=2002, }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Car Unlock
------------------------------------------------------------------------------------

   {
      name = "car_unlocked_a_1",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },
               { deactivate="fadeOut", element = { name="blackBox", time=0.5, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_CAR_UNLOCKED_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_CAR_UNLOCKED_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2001, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonNewBadge", priority=2002, }, },

               { activate="setParent", deactivate="setParent", element = { name="GarageButtonNewBadge", parent="GarageButton", animPropIndex=3, transformOnly=true, }, },


            },
         },

      },

   },

------------------------------------------------------------------------------------

   {
      name = "car_unlocked_a_2",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_CAR_UNLOCKED_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_CAR_UNLOCKED_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2001, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonNewBadge", priority=2002, }, },

               { activate="setParent", deactivate="setParent", element = { name="GarageButtonNewBadge", parent="GarageButton", animPropIndex=3, transformOnly=true, }, },


               { deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },


            },
         },

      },


   },

------------------------------------------------------------------------------------

   {
      name = "car_unlocked_b_1",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=240, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-results.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },
               { deactivate="fadeOut", element = { name="blackBox", time=0.5, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185}, }, },
               { activate="slideIn", deactivate="slideOut", element = { name="portrait", time=0.35, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_CAR_UNLOCKED_2", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=320, }, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p1", endFunc="fadeIn", time=0.75, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_CAR_UNLOCKED_2", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=320, }, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p1", endFunc="fadeIn", time=0.75, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_p1", endFunc="bubbleBoxIn", time=0.75, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="BackButton", priority=2001, releaseCalls = {"nextPage"}, }, },
            },
         },

      },

   },
   
------------------------------------------------------------------------------------
   
   {
      name = "car_unlocked_b_2",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=240, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-results.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185}, }, },
               { activate="slideIn", deactivate="slideOut", element = { name="portrait", time=0.35, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_CAR_UNLOCKED_2", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=320, }, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p1", endFunc="fadeIn", time=0.75, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_CAR_UNLOCKED_2", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=320, }, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p1", endFunc="fadeIn", time=0.75, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_p1", endFunc="bubbleBoxIn", time=0.75, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="BackButton", priority=2001, releaseCalls = {"nextPage"}, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },


            },
         },

      },

   },

------------------------------------------------------------------------------------
-- Video
------------------------------------------------------------------------------------

   {
      name = "video_button_guide",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=130, chunkH=60, textX=130, textY=0, portraitX=-180, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
               { activate="localFunc", element = { func="guideDirectVideo", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", frame = {x=-180, y=-185}, }, },
               { activate="slideIn", element = { name="portrait", time=0.25, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_VIDEO_BUTTON", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=130, y=0, w=350, h=330, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_VIDEO_BUTTON", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=132, y=-2, w=350, h=330, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="videoRolloutButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="videoRolloutCoin", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="videoRolloutSparkle", priority=2002, }, },


            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "new_video_reward",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=130, chunkH=60, textX=130, textY=0, portraitX=-180, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
               { activate="localFunc", element = { func="guideDirectVideo", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", frame = {x=-180, y=-185}, }, },
               { activate="slideIn", element = { name="portrait", time=0.25, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_NEW_VIDEO_REWARD", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=130, y=0, w=350, h=330, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_NEW_VIDEO_REWARD", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=132, y=-2, w=350, h=330, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="videoRolloutButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="videoRolloutCoin", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="videoRolloutSparkle", priority=2002, }, },


            },
         },
      },
   },
   
------------------------------------------------------------------------------------
-- Feed
------------------------------------------------------------------------------------
   
   {
      name = "feed_guide",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",

            actions = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },

               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_FEED_NOTIFY", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_FEED_NOTIFY", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, black=false, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="OptionsButton", priority=2001, releaseCalls = {"nextPage"}, }, },

            },
         },
         {
            state="state/state-options.lua",

            actions = {

               { activate="addTimer", element = { type="timer", name="sharetimer", endFunc="nextPage", time=0.2, }, },
               { deactivate="localFunc", element = { func="EnableFeed", args=nil, }, },
            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Bounty
------------------------------------------------------------------------------------

   {
      name = "bounty_intro",
      
      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = { chunkW=360, chunkH=60, textH=360, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=400, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=400, }, },
      },
      
      pages =
      {
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },
               
               { activate="localFunc", element = { func="onBountyEntryListTutorial", args=nil, returnFunc=nil }, },
               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },
               
               { activate="addTimer", element = { type="timer", name="bintro_banner", endFunc="localFunc", time=1.9, args = {func="guideBountyBanner", returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="bnextpage_timer", endFunc="nextPage", time=3.7, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="reframe", element = { name="portrait", priority=3000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               
               { activate="constructTextBox", element = {priority=3002, chunkW=360, textH=180, chunkH=60, textX=-150, textY=-270, portraitX=160, portraitY=-185, dongleOffset=480}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=3004, frame = {x=-150, y=-270, w=350, h=300, },  lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNTY_INTRO_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=3003, frame = {x=-148, y=-270-2, w=350, h=300, },  lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNTY_INTRO_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="onBountyEntryListTutorialContinue", args=nil, returnFunc=nil }, },
               
               { activate="constructTextBox", element = {priority=3002, chunkW=360, textH=180, chunkH=60, textX=-150, textY=-270, portraitX=160, portraitY=-185, dongleOffset=240}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.35, }, },

               { activate="reframe", element = { name="guideText", priority=3004, frame = {x=-150, y=-270, w=350, h=300, },  lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNTY_INTRO_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.35, args = { name="guideText", time=0.1, black=false, }, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=3003, frame = {x=-148, y=-270-2, w=350, h=300, },  lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNTY_INTRO_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.35, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               
               { activate="addTimer", element = { type="timer", name="bnextpage_timer", endFunc="nextPage", time=0.6, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { deactivate="bubbleBoxOut", element = {}, },

               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="localFunc", element = { func="onBountyGuideExit", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "bounty_weekly_reset",

      pages =
      {

         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="onBountyEntryListWeeklyReset", args=nil, returnFunc=nil }, },
               {activate="addTimer", element = { type="timer", name="bnextpage_timer", endFunc="nextPage", time=3.8, }, },
            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "first_bounty_return_bastian",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Bastian_Defeated.png", frame = {x=0, y=0, w=445.6, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_BASTAN", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_BASTAN", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.2, black=false, }, },


            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { activate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },



            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "first_bounty_return_dana",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Dana_Defeated.png", frame = {x=0, y=0, w=550, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_DANA", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_DANA", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.2, black=false, }, },


            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.9, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { activate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },



            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "first_bounty_return_ricardo",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Ricardo_Defeated.png", frame = {x=0, y=0, w=583.5, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_RICARDO", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_RICARDO", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.2, black=false, }, },


            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { activate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },



            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "first_bounty_return_claire",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_CLAIRE", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_CLAIRE", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.2, black=false, }, },


            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { activate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },



            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "bounty_reminder_bastian",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Bastian_Defeated.png", frame = {x=0, y=0, w=445.6, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_REMINDER_BASTIAN", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_REMINDER_BASTIAN", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },

            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               { deactivate="fadeOut", element = { name="blackBox", time=1.0, black=false, }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { deactivate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "bounty_reminder_dana",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Dana_Defeated.png", frame = {x=0, y=0, w=550, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_REMINDER_DANA", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_REMINDER_DANA", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },


            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               { deactivate="fadeOut", element = { name="blackBox", time=1.0, black=false, }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { deactivate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "bounty_reminder_ricardo",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Ricardo_Defeated.png", frame = {x=0, y=0, w=583.5, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_REMINDER_RICARDO", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_REMINDER_RICARDO", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },




            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               { deactivate="fadeOut", element = { name="blackBox", time=1.0, black=false, }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { deactivate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------

   {
      name = "bounty_reminder_claire",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      };


      pages = {
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="getBountyListSize", args=nil, returnFunc="setBountiesToCollect" }, },
               { activate="localFunc", element = { func="onBountyFirstReturn", args=nil, returnFunc=nil }, },


               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=5000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },


               { activate="addTimer", element = { type="timer", name="tbox_bounty", endFunc="constructTextBox", time=2.0, args = { chunkW=360, textH=120, chunkH=60, textX=-170, textY=-390, portraitX=300, portraitY=300, priority=5001, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer_bounty", endFunc="bubbleBoxIn", time=2.0, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_REMINDER_CLAIRE", }, },

               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_REMINDER_CLAIRE", }, },

               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=2.1, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=2.1, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="localFunc", element = { func="getBountyEntryListAnim", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListImage", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListButton", args=nil, returnFunc="bountyReturnedList" }, },
               { activate="localFunc", element = { func="getBountyEntryListText", args=nil, returnFunc="bountyReturnedList" }, },




            },
         },
         {
            state="state/state-ranking.lua",

            actions = {

               { activate="localFunc", element = { func="startBountyListSpread", args=nil, returnFunc=nil }, },
               { deactivate="fadeOut", element = { name="blackBox", time=1.0, black=false, }, },
               {activate="addTimer", element = { type="timer", name="bintro_slidein", endFunc="localFunc", time=0.5, args = {func="startBountyListExit", args=true, returnFunc=nil} } },
               --{activate="addTimer", element = { type="timer", name="breturn_exit", endFunc="localFunc", time=0.5, args = {func="deleteBountyEntryList", args=nil, returnFunc=nil} } },
               { activate="addTimer", element = { type="timer", name="sharetimer7", endFunc="nextPage", time=1, }, },

               { deactivate="localFunc", element = { func="_updateRankingList", args=nil, returnFunc=nil }, },

            },
         },
      },
   },

------------------------------------------------------------------------------------
   
   {
      name = "bounty_autocollect_bastian",

      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Bastian_Defeated.png", frame = {x=0, y=0, w=445.6, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
      };

      pages =
      {
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=3000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },
               
               { activate="constructTextBox", element = {priority=3002, chunkW=360, textH=120, chunkH=60, textX=-170, textY=-180, portraitX=300, portraitY=300, dongleOffset=40}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.35, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-180, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_BASTAN", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=0.35, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-180, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_BASTAN", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=0.35, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.15, black=false, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="localFunc", element = { func="onBountyGuideExit", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "bounty_autocollect_dana",

      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Dana_Defeated.png", frame = {x=0, y=0, w=550, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
      };

      pages =
      {
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },
               
               { activate="reframe", element = { name="portrait", priority=3000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },
               
               { activate="constructTextBox", element = {priority=3002, chunkW=360, textH=120, chunkH=60, textX=-170, textY=-80, portraitX=300, portraitY=300, dongleOffset=40}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.35, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-80, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_DANA", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=0.35, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-80, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_DANA", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=0.35, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },
               
               { deactivate="fadeOut", element = { name="blackBox", time=0.15, black=false, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="localFunc", element = { func="onBountyGuideExit", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "bounty_autocollect_ricardo",

      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Ricardo_Defeated.png", frame = {x=0, y=0, w=583.5, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
      };

      pages =
      {
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },
               
               { activate="reframe", element = { name="portrait", priority=3000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },
               
               { activate="constructTextBox", element = {priority=3002, chunkW=360, textH=120, chunkH=60, textX=-170, textY=-180, portraitX=300, portraitY=300, dongleOffset=40}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.35, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-180, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_RICARDO_ALT", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=0.35, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-180, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_RICARDO_ALT", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=0.35, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },
               
               { deactivate="fadeOut", element = { name="blackBox", time=0.15, black=false, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="localFunc", element = { func="onBountyGuideExit", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
         },
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name = "bounty_autocollect_claire",

      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
      };

      pages =
      {
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },
               
               { activate="reframe", element = { name="portrait", priority=3000, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },
               
               { activate="constructTextBox", element = {priority=3002, chunkW=360, textH=120, chunkH=60, textX=-170, textY=-80, portraitX=300, portraitY=300, dongleOffset=40}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.35, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element = { name="guideText", priority=5003, frame = {x=-160, y=-80, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BOUNT_FIRST_CLAIRE_ALT", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_bounty", endFunc="fadeIn", time=0.35, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=5002, frame = {x=-158, y=-80, w=350, h=320, }, lineSpace=5, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BOUNT_FIRST_CLAIRE_ALT", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_shad_bounty", endFunc="fadeIn", time=0.35, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },
               
               { deactivate="fadeOut", element = { name="blackBox", time=0.15, black=false, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { activate="localFunc", element = { func="onBountyGuideExit", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Achievement
------------------------------------------------------------------------------------

   {
      name = "achievement_reminder",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=200, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=200, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_ACHIEV_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_ACHIEV_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="AchievementButton", priority=3001, releaseCalls = {"nextPage"}, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="achievementAlertSparkle", priority=3000, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="achievementAlertGem", priority=3001, }, },

            },
         },
      },
   },
   
------------------------------------------------------------------------------------
-- Game Center
------------------------------------------------------------------------------------
   
   {
      name = "game_center_guide",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",

            actions = {
               { activate="localFunc", element = { func="guideCloseRollout", args=nil, }, },

               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_GAME_CENTER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_GAME_CENTER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, black=false, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GameCenterButton", priority=2001, releaseCalls = {"nextPage"}, }, },

            },

         },

      },
   },
   
------------------------------------------------------------------------------------
-- Sales
------------------------------------------------------------------------------------
   
   {
      name = "sale_reminder_guide",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_SALE_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_SALE_REMINDER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2001, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonSaleBadge", priority=2002, }, },

               { activate="setParent", deactivate="setParent", element = { name="GarageButtonSaleBadge", parent="GarageButton", animPropIndex=3, transformOnly=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },


            },
         },

      },


   },
   
------------------------------------------------------------------------------------
   
   {
      name = "sale_car",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_SALE_CAR", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_SALE_CAR", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonUpgrade", priority=2001, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="GarageButtonSaleBadge", priority=2002, }, },

               { activate="setParent", deactivate="setParent", element = { name="GarageButtonSaleBadge", parent="GarageButton", animPropIndex=3, transformOnly=true, }, },

               { deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },


            },
         },
         {
            state="state/state-garage.lua",

            actions = {
               { activate="addTimer", element = { type="timer", name="sharetimer", endFunc="nextPage", time=0.01, }, },
            },
         },

      },


   },

------------------------------------------------------------------------------------
-- Mystery
------------------------------------------------------------------------------------

   {
      name = "mystery_reminder",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=190, chunkH=60, textX=130, textY=0, portraitX=-180, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {
         {
            state="state/state-ranking.lua",
            init = {
               { activate="localFunc", element = { func="guideOpenRollout", args=nil, }, },
            },
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", frame = {x=-180, y=-185}, }, },
               { activate="slideIn", element = { name="portrait", time=0.25, }, },

               { activate="changeText", element = { name="guideText", text="GUIDE_MYSTERY_REMINDER", }, },
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=130, y=0, w=350, h=330, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               --shadow
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_MYSTERY_REMINDER", }, },
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=132, y=-2, w=350, h=330, }, }, },
               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },

               { activate="addTimer", element = { type="timer", name="boxtimer", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="MysteryButton", priority=2001, releaseCalls = {"nextPage"}, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="MysteryAlertSparkle", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="MysteryAlert", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="MysteryAlertText", priority=2004, }, },



            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Drones
------------------------------------------------------------------------------------

   {
      name = "drone_unlock",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_UNLOCK_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_UNLOCK_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="DroneButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="DroneButtonNewBadge", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="DroneNewBadgeShdw", priority=2002, }, },

            },
         },
         {
            state="state/state-drone-garage.lua",
            actions = {
               { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-390, portraitX=160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_UNLOCK_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_UNLOCK_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="leftRoot", priority=2001, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="leftBuildButtonRef", priority=2003, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="leftBuildButtonRef", eScl=1.15, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="leftBuildButtonTextRef", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="leftBuildButtonTextSRef", priority=2002, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="leftBuildButtonGemIcon", priority=2003, }, },


               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="leftDrone", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="leftTitleText", priority=2003, }, },

            },
         },
         {
            state="state/state-drone-reveal.lua",
            actions = {
               { activate="nextPage", element = {}, },
            },
         },
         {
            state="state/state-drone-garage.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="localFunc", element = { func="onInfoButtonSparkle", args=nil, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-100, portraitX=160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-100, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_UNLOCK_3", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-102, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_UNLOCK_3", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },


               { activate="pullWidget", element = { type="button", name="leftInfoButton", priority=2003, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="leftInfoButton", }, },
               { deactivate="pushWidget", element = { type="button", name="leftInfoButton", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="leftSparkle", priority=2002, }, },

            },
         },

      },


   },
   
------------------------------------------------------------------------------------
   
   {
      name = "drone_unlock_garage",

      guideElements = {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
         { type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },

      },

      pages = {

         {
            state="state/state-ranking.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=200, chunkH=60, textX=-150, textY=0, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_UNLOCK_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_UNLOCK_1", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },



               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="GarageButton", priority=2001, releaseCalls = {"nextPage"}, }, },

            },
         },
         {
            state="state/state-garage.lua",
            actions = {

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="DroneButton", priority=2001, releaseCalls = {"nextPage"}, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="DroneButtonNewBadge", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="DroneNewBadgeShdw", priority=2002, }, },
            },
         },
         {
            state="state/state-drone-garage.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-390, portraitX=160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_UNLOCK_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_UNLOCK_2", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="leftRoot", priority=2001, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="leftBuildButtonRef", priority=2003, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="leftBuildButtonRef", eScl=1.15, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="leftBuildButtonTextRef", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="leftBuildButtonTextSRef", priority=2002, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="leftBuildButtonGemIcon", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="leftDrone", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="leftTitleText", priority=2003, }, },

            },
         },

      },
      {
         {
            state="state/state-drone-reveal.lua",
            actions = {
               { activate="nextPage", element = {}, },
            },
         },
         {
            state="state/state-drone-garage.lua",
            actions = {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="localFunc", element = { func="onInfoButtonSparkle", args=nil, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-100, portraitX=160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-100, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_UNLOCK_3", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-102, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_UNLOCK_3", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", element = { type="button", name="leftInfoButton", priority=2003, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element = { name="leftInfoButton", eScl=1.5, }, },
               { deactivate="pushWidget", element = { type="button", name="leftInfoButton", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="anim", name="leftSparkle", priority=2002, }, },

            },
         },

      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name	= "drone_evolve_left",

      guideElements	=
         {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
         },

      pages	=
         {
			{
               state		= "state/state-drone-garage.lua",

               actions	=
                  {
                     --background
                     { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

                     -- portrait
                     { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
                     { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
                     { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

                     --speech bubble
                     { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-390, portraitX=160, portraitY=-185, noDongle=true}, },
                     { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
                     { deactivate="bubbleBoxOut", element = {}, },

                     --text
                     { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-390, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_EVOLVE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
                     { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },

                     --text shadow
                     { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-392, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_EVOLVE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
                     { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

                     --state widgets
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveFrame", priority=2001, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveUpgradeTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveTitleTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveStars", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveSStars", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneL", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneR", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveGRays", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipFrame", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePStarOn", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxt", priority=2005, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxtS", priority=2004, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn1", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn2", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn3", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn4", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn5", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn6", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn7", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn8", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn9", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn10", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn11", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn12", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn13", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn14", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn15", priority=2003, }, },

                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxt", priority=2105, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxtShdow", priority=2104, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveIcon", priority=2104, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="droneEvolveButton", priority=2103, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
                     { activate="localFunc", element = { func="guidePullEvolveButton", args=nil, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },
                  },
			},
         },
   },
   
------------------------------------------------------------------------------------
   
   {
      name	= "drone_evolve_right",

      guideElements	=
         {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
         },

      pages	=
         {
			{
               state		= "state/state-drone-garage.lua",
               actions	=
                  {
                     --background
                     { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

                     -- portrait
                     { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1}, }, },
                     { activate="slideIn", element = { name="portrait", time=0.35, rightSide=false, }, },
                     { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=false, }, },

                     --speech bubble
                     { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=150, textY=-390, portraitX=-160, portraitY=-185, noDongle=true}, },
                     { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
                     { deactivate="bubbleBoxOut", element = {}, },

                     --text
                     { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=-390, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_EVOLVE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
                     { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
                     --text shadow
                     { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-392, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_EVOLVE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
                     { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

                     --state widgets
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveFrame", priority=2001, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveUpgradeTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveTitleTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveStars", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveSStars", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneL", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneR", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveGRays", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipFrame", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePStarOn", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxt", priority=2005, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxtS", priority=2004, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn1", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn2", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn3", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn4", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn5", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn6", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn7", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn8", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn9", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn10", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn11", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn12", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn13", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn14", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn15", priority=2003, }, },

                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxt", priority=2105, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxtShdow", priority=2104, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveIcon", priority=2104, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="droneEvolveButton", priority=2103, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
                     { activate="localFunc", element = { func="guidePullEvolveButton", args=nil, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },
                  },
			},
         },
   },
   
------------------------------------------------------------------------------------
   
   {
      name	= "drone_merge_left",

      guideElements	=
         {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
         },

      pages	=
         {
			{
               state		= "state/state-drone-garage.lua",

               actions	=
                  {
                     --background
                     { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

                     -- portrait
                     { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
                     { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },
                     { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

                     --speech bubble
                     { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-390, portraitX=160, portraitY=-185, noDongle=true}, },
                     { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
                     { deactivate="bubbleBoxOut", element = {}, },

                     --text
                     { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-390, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_MERGE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
                     { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },

                     --text shadow
                     { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-392, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_MERGE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
                     { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

                     --state widgets
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveFrame", priority=2001, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveUpgradeTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveTitleTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveStars", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveSStars", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneL", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneR", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveGRays", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipFrame", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn1", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn2", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn3", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn4", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn5", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn6", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn7", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn8", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn9", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn10", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn11", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn12", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn13", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn14", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn15", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveLevelTxt", priority=2005, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },

                  },
			},
			{
               state		= "state/state-drone-garage.lua",

               actions	=
                  {
                     { activate="localFunc", element = { func="guideSetLeftToEnd", args=nil, }, },
                     { activate="nextPage", element = {}, },
                  },
			},
         },
   },
   
------------------------------------------------------------------------------------
   
   {
      name	= "drone_merge_right",

      guideElements	=
         {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
         },

      pages	=
         {
			{
               state		= "state/state-drone-garage.lua",

               actions	=
                  {
                     --background
                     { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

                     -- portrait
                     { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1}, }, },
                     { activate="slideIn", element = { name="portrait", time=0.35, rightSide=false, }, },
                     { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=false, }, },

                     --speech bubble
                     { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=150, textY=-390, portraitX=-160, portraitY=-185, noDongle=true}, },
                     { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
                     { deactivate="bubbleBoxOut", element = {}, },

                     --text
                     { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=-390, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_MERGE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
                     { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },

                     --text shadow
                     { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=148, y=-392, w=350, h=320, }, }, },
                     { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_MERGE", }, },
                     { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
                     { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

                     --state widgets
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveFrame", priority=2001, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveUpgradeTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveTitleTxt", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveStars", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveSStars", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneL", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneR", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveGRays", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipFrame", priority=2002, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn1", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn2", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn3", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn4", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn5", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn6", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn7", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn8", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn9", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn10", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn11", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn12", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn13", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn14", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn15", priority=2003, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveLevelTxt", priority=2005, }, },
                     { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },

                  },
			},
			{
               state		= "state/state-drone-garage.lua",

               actions	=
                  {
                     { activate="localFunc", element = { func="guideSetRightToEnd", args=nil, }, },
                     { activate="nextPage", element = {}, },
                  },
			},
         },
   },

------------------------------------------------------------------------------------
   
   {
      name	= "drone_hybrid_left",

      guideElements	=
         {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
         },

      pages	=
      {
			{
            state		= "state/state-drone-garage.lua",
            actions	=
            {
               --background
               { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               -- portrait
               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=true, }, },

               --speech bubble
               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-390, portraitX=160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               --text
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_EVOLVE", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },

               --text shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_EVOLVE", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               --state widgets
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveFrame", priority=2001, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveUpgradeTxt", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveTitleTxt", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveStars", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveSStars", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneL", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneR", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveGRays", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipFrame", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePStarOn", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxt", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxtS", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn1", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn2", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn3", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn4", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn5", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn6", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn7", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn8", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn9", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn10", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn11", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn12", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn13", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn14", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn15", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxt", priority=2105, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxtShdow", priority=2104, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveIcon", priority=2104, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="droneEvolveButton", priority=2103, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="localFunc", element = { func="guidePullHybridButton", args=nil, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },
            },
			},
			{
            state		= "state/state-drone-garage.lua",
            actions	=
            {
               --background
               { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               -- portrait
               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=160, y=-185, sclX=-1, sclY=1}, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=true, }, },

               --speech bubble
               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=-150, textY=-390, portraitX=160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               --text
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=-150, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_HYBRID", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },

               --text shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=-148, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_HYBRID", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               --state widgets
               { activate="localFunc", element = { func="guideSetLeftToBuildIndex", args=nil, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },
            },
			},
			{
            state		= "state/state-drone-garage.lua",
            actions	=
            {
               { activate="localFunc", element = { func="guideDisableScreenButton", args=nil, }, },
               { activate="nextPage", element = {}, },
            },
			},
      },
   },
   
------------------------------------------------------------------------------------
   
   {
      name	= "drone_hybrid_right",

      guideElements	=
         {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Claire.png", frame = {x=0, y=0, w=320, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
         },

      pages	=
      {
			{
            state		= "state/state-drone-garage.lua",
            actions	=
            {
               --background
               { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               -- portrait
               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=false, }, },

               --speech bubble
               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=150, textY=-390, portraitX=-160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               --text
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_EVOLVE", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --text shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_EVOLVE", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               --state widgets
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveFrame", priority=2001, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveUpgradeTxt", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveTitleTxt", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveStars", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveSStars", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneL", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveDroneR", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveGRays", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipFrame", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePStarOn", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxt", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolvePStarTxtS", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn1", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn2", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn3", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn4", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn5", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn6", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn7", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn8", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn9", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn10", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn11", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn12", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn13", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn14", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolvePipOn15", priority=2003, }, },

               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxt", priority=2105, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="text", name="droneEvolveButtonTxtShdow", priority=2104, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="image", name="droneEvolveIcon", priority=2104, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="droneEvolveButton", priority=2103, releaseCalls = {"nextPage", "stopAllPulses"}, }, },
               { activate="localFunc", element = { func="guidePullHybridButton", args=nil, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },
            },
			},
			{
            state		= "state/state-drone-garage.lua",
            actions	=
            {
               --background
               { activate="fadeIn", deactivate="fadeOut", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               -- portrait
               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1}, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=false, }, },

               --speech bubble
               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=150, textY=-390, portraitX=-160, portraitY=-185, noDongle=true}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               --text
               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=-390, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_DRONE_HYBRID", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --text shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-392, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_DRONE_HYBRID", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               --state widgets
               { activate="localFunc", element = { func="guideSetRightToBuildIndex", args=nil, }, },
               { activate="pullWidget", deactivate="pushWidget", element = { type="button", name="ScreenButton", priority=2103, releaseCalls = {"nextPage"}, }, },
            },
			},
			{
            state		= "state/state-drone-garage.lua",
            actions	=
            {
               { activate="localFunc", element = { func="guideDisableScreenButton", args=nil, }, },
               { activate="nextPage", element = {}, },
            },
			},
      },
   },


------------------------------------------------------------------------------------
-- Consumable
------------------------------------------------------------------------------------

   {
      name = "consumable_store",

      guideElements	= {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame={x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame={x=0, y=0, w=320, h=669, }, },
         { type="textBox", element={chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame={x=0, y=0, w=360, h=510, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame={x=2, y=-2, w=360, h=510, }, },

      },

      pages =
      {
         {
            state="state/state-consumable-overlay-new.lua",
            actions= {
               { activate="fadeIn", element={ name="blackBox", time=0.1, alpha=0.7, }, },
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-235, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element={ name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element={chunkW=360, textH=120, chunkH=60, textX=-150, textY=-130, portraitX=160, portraitY=-235}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-130, w=350, h=600, }, lineSpace=10, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_CONSUMABLE_INTRO_1", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-132, w=350, h=600, }, lineSpace=10, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_CONSUMABLE_INTRO_1", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideBlueButton", priority=2003, releaseCalls={}, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideIcon", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideInvFrame", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideInvText", priority=2006, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideScreenButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               
               { activate="localFunc", element={ func="onDisablGuideConsmButton", args=nil, returnFunc=nil }, },
            },
         },
         {
            state="state/state-consumable-overlay-new.lua",
            actions= {
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-235, sclX=-1, sclY=1}, }, },
               
               { activate="localFunc", element={ func="onDisableGuideScrnButton", args=nil, returnFunc=nil }, },
               
               { activate="constructTextBox", element={chunkW=360, textH=120, chunkH=60, textX=-150, textY=-130, portraitX=160, portraitY=-235}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-130, w=350, h=600, }, lineSpace=10, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_CONSUMABLE_INTRO_2", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-132, w=350, h=600, }, lineSpace=10, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_CONSUMABLE_INTRO_2", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="anim", name="_guideSparkle", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideStoreButton", priority=2003, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element={ name="_guideStoreButton", eScl=1.1,}, },
               
               { activate="localFunc", element={ func="onShowGuideSparkle", args=nil, returnFunc=nil }, },
            },
         },
      },
   },

------------------------------------------------------------------------------------
-- Starter Pack
------------------------------------------------------------------------------------

   {
      name = "starter_pack",

      guideElements	=
      {
			{ type="image", name="blackBox", texture="resources/UI/blackbox.png", frame = {x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
			{ type="image", name="portrait", texture="resources/UI/Dana.png", frame = {x=0, y=0, w=550, h=669, }, },
			{ type="textBox", element = {chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
			{ type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame = {x=0, y=0, w=360, h=310, }, },
			{ type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame = {x=2, y=-2, w=360, h=310, }, },
      },

      pages =
      {
         {
            state		= "state/state-ranking.lua",
            actions	=
            {
               { activate="fadeIn", element = { name="blackBox", time=0.1, alpha=0.7, }, },

               { activate="reframe", element = { name="portrait", priority=2001, frame = {x=-160, y=-185, sclX=1, sclY=1}, }, },
               { activate="slideIn", element = { name="portrait", time=0.35, rightSide=false, }, },
               { deactivate="slideOut", element = { name="portrait", time=0.35, rightSide=false, }, },

               { activate="constructTextBox", element = {chunkW=360, textH=120, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185}, },
               { activate="addTimer", element = { type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element = { name="guideText", priority=2003, frame = {x=150, y=0, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideText", text="GUIDE_BUNDLE_STARTER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element = { name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element = { name="guideTextShadow", priority=2002, frame = {x=152, y=-2, w=350, h=320, }, }, },
               { activate="changeText", element = { name="guideTextShadow", text="GUIDE_BUNDLE_STARTER", }, },
               { activate="addTimer", element = { type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args = { name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element = { name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="localFunc", element = { func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               { deactivate="localFunc", element = { func="goStarterPack", args=nil, }, },
               { activate="nextPage", element = {}, },
            },
         },
      },
   },

------------------------------------------------------------------------------------
-- League
------------------------------------------------------------------------------------

   {
      name = "league_intro",

      guideElements	= {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame={x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame={x=0, y=0, w=320, h=669, }, },
         { type="textBox", element={chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame={x=0, y=0, w=360, h=510, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame={x=2, y=-2, w=360, h=510, }, },

      },

      pages =
      {
         {
            state="state/state-ranking.lua",
            actions= {
               { activate="fadeIn", element={ name="blackBox", time=0.1, alpha=0.7, }, },
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element={ name="portrait", time=0.35, rightSide=true, }, },

               { activate="localFunc", element={ func="onLeagueGuideClear", args=nil, returnFunc=nil }, },

               { activate="constructTextBox", element={chunkW=360, textH=180, chunkH=60, textX=-150, textY=-80, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-80, w=350, h=600, }, lineSpace=5, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_LEAGUE_REWARD_1", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-82, w=350, h=600, }, lineSpace=5, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_LEAGUE_REWARD_1", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueTimeTxt", priority=2003, }, },
               { activate="addPulse", element={ name="_guideLeagueTimeTxt", eScl=1.10, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueTimeTxtShdw", priority=2002, }, },
               { activate="addPulse", element={ name="_guideLeagueTimeTxtShdw", eScl=1.10, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideFTabL", priority=2003, releaseCalls={}, }, },
               { activate="addPulse", element={ name="_guideFTabL", eScl=1.05, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFTabLInset", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLTxt", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLTxtShdw", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLDvTxt", priority=2006, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLDvTxtShdw", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               
               { activate="localFunc", element={ func="onFriendGuideButtonDisable", args=nil, returnFunc=nil }, },
            },
         },
         {
            state="state/state-ranking.lua",
            actions= {
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-185, sclX=-1, sclY=1}, }, },
               
               { activate="localFunc", element={ func="onLeagueGuideClear", args=nil, returnFunc=nil }, },
               { activate="localFunc", element={ func="disableGuideScrnButton", args=nil, returnFunc=nil }, },
               
               { activate="constructTextBox", element={chunkW=360, textH=300, chunkH=60, textX=-150, textY=-80, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-80, w=350, h=600, }, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_LEAGUE_REWARD_2", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-82, w=350, h=600, }, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_LEAGUE_REWARD_2", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideRoot", priority=0, }, },
               { activate="addPulse", element={ name="_guideRoot", eScl=1.03,}, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideLeagueBanner", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideLeagueInset", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueInsetTxt", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueInsetTxtShdw", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideLeagueArrow", priority=2006, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueRwdText", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueRwdTextShdw", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueRwdTxtL", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideLeagueRwdGemL", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueTimeTxt", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideLeagueTimeTxtShdw", priority=2002, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               
               { activate="localFunc", element={ func="onFriendGuideButtonDisable", args=nil, returnFunc=nil }, },
            },
         },
         {
            state="state/state-ranking.lua",
            actions= {
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-185, sclX=-1, sclY=1}, }, },
               { deactivate="slideOut", element={ name="portrait", time=0.35, rightSide=true, }, },
               
               { activate="localFunc", element={ func="onLeagueGuideClear", args=nil, returnFunc=nil }, },
               
               { activate="constructTextBox", element={chunkW=360, textH=240, chunkH=60, textX=-150, textY=-80, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },
               
               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-80, w=350, h=600, }, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_LEAGUE_REWARD_3", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-82, w=350, h=600, }, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_LEAGUE_REWARD_3", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="anim", name="_guideLeagueSparkle", priority=2203, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueInfo", priority=2204, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               { activate="addPulse", element={ name="_guideLeagueInfo", eScl=1.20, }, },
               
               { activate="localFunc", element={ func="onFriendGuideButtonDisable", args=nil, returnFunc=nil }, },
            },
         },
      },
   },
   
------------------------------------------------------------------------------------
-- Friends
------------------------------------------------------------------------------------
   
   {
      name = "friends_intro",

      guideElements =
      {
         { type="image", name="blackBox", texture="resources/UI/blackbox.png", frame={x=0, y=0, w=-1, h=-1, }, alpha=0.7, },
         { type="image", name="portrait", texture="resources/UI/Claire.png", frame={x=0, y=0, w=320, h=669, }, },
         { type="textBox", element={chunkW=360, textH=280, chunkH=60, textX=150, textY=0, portraitX=-160, portraitY=-185, }, },
         { type="text", name="guideText", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=false, frame={x=0, y=0, w=360, h=510, }, },
         { type="text", name="guideTextShadow", fontName=defaultFontName, fontSize=defaultFontSize, glyphsToLoad=nil, black=true, frame={x=2, y=-2, w=360, h=510, }, },
      },

      pages =
      {
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="fadeIn", element={ name="blackBox", time=0.1, alpha=0.7, }, },
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-185, sclX=-1, sclY=1}, }, },
               { activate="slideIn", element={ name="portrait", time=0.35, rightSide=true, }, },

               { activate="localFunc", element={ func="onFriendGuideStart", args=nil, returnFunc=nil }, },

               { activate="constructTextBox", element={chunkW=360, textH=120, chunkH=60, textX=-150, textY=-80, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-80, w=320, h=600, }, lineSpace=5, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_FRIEND_BOARD_1", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-82, w=320, h=600, }, lineSpace=5, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_FRIEND_BOARD_1", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideFTabF", priority=2003, releaseCalls={}, }, },
               { activate="addPulse", element={ name="_guideFTabF", eScl=1.05, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabFTxt", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabFTxtShdw", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               
               { activate="localFunc", element={ func="onFriendGuideButtonDisable", args=nil, returnFunc=nil }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-185, sclX=-1, sclY=1}, }, },

               { activate="constructTextBox", element={chunkW=360, textH=180, chunkH=60, textX=-150, textY=-80, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-80, w=320, h=600, }, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_FRIEND_BOARD_2", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-82, w=320, h=600, }, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_FRIEND_BOARD_2", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFRoot", priority=2000, }, },
               { activate="addPulse", element={ name="_guideFRoot", eScl=1.025, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFBanner", priority=2003, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFPic", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFPicFrame", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFName", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFScore", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFLevel", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideFGift", priority=2105, releaseCalls={}, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFBadge", priority=2005, }, },
               
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               
               { activate="localFunc", element={ func="onFriendGuideButtonDisable", args=nil, returnFunc=nil }, },
            },
         },
         {
            state    = "state/state-ranking.lua",
            actions  =
            {
               { deactivate="fadeOut", element = { name="blackBox", time=0.35, alpha=0.7, }, },
               { activate="reframe", element={ name="portrait", priority=2001, frame={x=160, y=-185, sclX=-1, sclY=1}, }, },
               { deactivate="slideOut", element={ name="portrait", time=0.35, rightSide=true, }, },

               { activate="constructTextBox", element={chunkW=360, textH=120, chunkH=60, textX=-150, textY=-80, portraitX=160, portraitY=-185}, },
               { activate="addTimer", element={ type="timer", name="boxtimer_p3", endFunc="bubbleBoxIn", time=0.65, }, },
               { deactivate="bubbleBoxOut", element = {}, },

               { activate="reframe", element={ name="guideText", priority=2003, frame={x=-150, y=-80, w=320, h=600, }, }, },
               { activate="changeText", element={ name="guideText", text="GUIDE_FRIEND_BOARD_3", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideText", time=0.1, black=false, }, }, },
               { deactivate="fadeOut", element={ name="guideText", time=0.1, black=false, }, },
               --shadow
               { activate="reframe", element={ name="guideTextShadow", priority=2002, frame={x=-148, y=-82, w=320, h=600, }, }, },
               { activate="changeText", element={ name="guideTextShadow", text="GUIDE_FRIEND_BOARD_3", }, },
               { activate="addTimer", element={ type="timer", name="texttimer_p3", endFunc="fadeIn", time=0.65, args={ name="guideTextShadow", time=0.1, black=true, }, }, },
               { deactivate="fadeOut", element={ name="guideTextShadow", time=0.1, black=true, }, },

               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideFTabL", priority=2003, releaseCalls={}, }, },
               { activate="addPulse", element={ name="_guideFTabL", eScl=1.05, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="image", name="_guideFTabLInset", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLTxt", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLTxtShdw", priority=2004, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLDvTxt", priority=2006, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="text", name="_guideFTabLDvTxtShdw", priority=2005, }, },
               { activate="pullWidget", deactivate="pushWidget", element={ type="button", name="_guideLeagueScrnButton", priority=2000, releaseCalls={"nextPage", "stopAllPulses"}, }, },
               
               { activate="localFunc", element={ func="onFriendGuideButtonDisable", args=nil, returnFunc=nil }, },
            },
         },
			{
            state		= "state/state-ranking.lua",
            actions	=
            {
               { activate="localFunc", element={ func="onFriendGuideExit", args=nil, returnFunc=nil }, },
               { activate="nextPage", element = {}, },
            },
			},
      },
   },

}
