require('game/mission/mission-goal-avoid-barricade');
require('game/mission/mission-goal-avoid-damage');
require('game/mission/mission-goal-avoid-lanes');
require('game/mission/mission-goal-avoid-missile');
require('game/mission/mission-goal-avoid-pickups');
require('game/mission/mission-goal-boost-kill');
require('game/mission/mission-goal-brag');
require('game/mission/mission-goal-change-lanes');
require('game/mission/mission-goal-collect-pickups');
require('game/mission/mission-goal-daily');
require('game/mission/mission-goal-destroy-barricade');
require('game/mission/mission-goal-destroy-missile');
require('game/mission/mission-goal-die');
require('game/mission/mission-goal-distance');
require('game/mission/mission-goal-dummy');
require('game/mission/mission-goal-end');
require('game/mission/mission-goal-gift');
require('game/mission/mission-goal-gold');
require('game/mission/mission-goal-invite');
require('game/mission/mission-goal-kill-all');
require('game/mission/mission-goal-kill');
require('game/mission/mission-goal-leaderboard');
require('game/mission/mission-goal-multiplier');
require('game/mission/mission-goal-pickup-stack');
require('game/mission/mission-goal-pickup-timed');
require('game/mission/mission-goal-pickup');
require('game/mission/mission-goal-receive-key');
require('game/mission/mission-goal-score');
require('game/mission/mission-goal-sideswipe');
require('game/mission/mission-goal-spend-keys');
require('game/mission/mission-goal-tutorial');
require('game/mission/mission-goal-unlock');
require('game/mission/mission-goal-upgrade');
require('game/mission/mission-goal-weekly');

----------------------------------------------------------------------

TEMPLATE_MISSION_LIST_01 =
{
   
   {
      name     = "1",
      reward   = { gem = 1   },
      skipCost = { gold= 1*1000 },
      goals  =
      {
         {
            factory     = MissionGoalGold,
            text        = "Collect 10 Coins",
            bannerText  = "10 Coins Collected",
            twoLinePause= true,
            pauseText1	= "",
            pauseText2  = "Coins Collected",
            cumulative  = true,
            objective   = 10,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 5 Enemies",
            bannerText  = "5 Enemies Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Destroyed",
            oneShot     = false,
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 5,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect Boost x1",
            bannerText  = "Boosted!",
            pauseText   = "Collect Boost x1",
            hideNum     = true,
            type        = "powerup_speed_burst",
            cumulative  = false,
            objective   = 1,
         },
      }
   },
   
   {
      name  = "2",
      reward = { gem = 1   },
      skipCost = { gold=1*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalUpgrade,
            twoLine     = true,
            text1       = "Upgrade Armor",
            text2       = "to Level 2",
            bannerText  = "Armor L2",
            twoLinePause= true,
            pauseText1  = "Upgrade Your",
            pauseText2  = "Armor to Level 2",
            hideNum     = true,
            item        = "armor",
            vehicle     = false,
            threshold	= true,
            cumulative  = true,
            objective   = 2,
         },
         {
            factory     = MissionGoalDistance,
            twoLine		= true;
            text1       = "Reach the 250",
            text2       = "Meter Mark",
            bannerText  = "250 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 250,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 5 Tankers",
            bannerText  = "5 Tankers Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Tankers Destroyed",
            oneShot     = false,
            vicTypes    = {"fuel_truck_a"},
            deathType   =nil, --string or nil!
            cumulative  = true,
            objective   = 5,
         },

      }
   },
   
   {
      
      name  = "3",
      reward = { gem = 1   },
      skipCost = { gold=1*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            text        = "Score 2,500 in 1 Game",
            bannerText  = "2,500 in 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 2500,
         },
         {
            factory     = MissionGoalGold,
            twoLine     = true,
            text1       = "Collect 10 Coins",
            text2       = "with the Magnet",
            bannerText  = "10 Coins Magnetized",
            twoLinePause= true,
            pauseText1	= "",
            pauseText2  = "Coins Magnetized",
            magnet      = true,
            cumulative  = true,
            objective   = 10,
         },
         {
            factory     = MissionGoalUpgrade,
            twoLine     = true,
            text1       = "Upgrade Main",
            text2       = "Weapon to Lvl 3",
            bannerText  = "Main Weapon L3",
            twoLinePause= true,
            pauseText1  = "Upgrade Your Main",
            pauseText2  = "Weapon to Level 3",
            hideNum     = true,
            item        = "main-weapon",
            vehicle     = false,
            threshold	= true,
            cumulative  = true,
            objective   = 3,
         },
      }
   },
   {
      
      name  = "4",
      reward = { gem = 2   },
      skipCost = { gold=2*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalMultiplier,
            text        = "Get Multiplier to x2",
            bannerText  = "Multiplier x2",
            pauseText   = "Get a x2 Multiplier",
            hideNum     = true,
            cumulative  = false,
            objective   = 2,
         },
         {
            factory     = MissionGoalDie,
            text        = "Die Within 30 Seconds",
            bannerText  = "Quick Death",
            pauseText   = "Die Within 30 Seconds",
            hideNum     = true,
            timeLimit   = 30,
            cumulative  = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 50 Enemies",
            bannerText  = "50 Enemies Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Destroyed",
            oneShot     = false,
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
			cumulative  = true,
            objective   = 50,
         },
      }
   },
   {
      
      name  = "5",
      reward = { gem = 2   },
      skipCost = { gold=2*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe 4 Enemies",
            text2       = "in 1 Game",
            bannerText  = "4 Enemies Sideswiped",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Sideswiped in 1 Game",
            cumulative  = false,
            objective   = 4,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 1",
            text2       = "Armored Truck",
            bannerText  = "1 Armored Truck",
            twoLinePause= true,
            pauseText1  = "Armored Truck",
            pauseText2  = "Destroyed",
            vicTypes    = {"armor_truck_a",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 1,
         },
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the 1,000",
            text2       = "Meter Marker",
            bannerText  = "1,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 1000,
         },
      }
   },
   {
      
      name  = "6",
      reward = { gem = 2 },
      skipCost = { gold=2*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidMissile,
            text        = "Avoid 10 Missiles",
            bannerText  = "10 Missiles Avoided",
            pauseText   = "Missiles Avoided",
            cumulative  = true,
            objective   = 10,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 25 Enemies with",
            text2       = "Doubleshot in 1 Game",
            bannerText  = "2 Barrels, 25 Enemies",
            twoLinePause= true,
            pauseText1  = "Killed with",
            pauseText2  = "Doubleshot in 1 Game",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
			cumulative  = false,
            objective   = 25,
         },
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 5,000",
            text2       = "in 1 Game",
            bannerText  = "5,000 in 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 5000,
         },
      }
   },
   {
      
      name  = "7",
      reward = { gem = 3 },
      skipCost = { gold=3*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalPickup,
            text        = "Collect 3 Wrenches",
            bannerText  = "3 Wrenches Collected",
            pauseText   = "Wrenches Collected",
            type        = "wrench",
            cumulative  = true,
            objective   = 3,
         },
         {
            factory     = MissionGoalScore,
            text        = "Beat Your High Score",
            bannerText  = "High Score Beaten",
            pauseText   = "Beat Your High Score",
            hideNum     = true,
            highScore   = true,
            cumulative  = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 15 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "15 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 15,
         },
      }
   },
   {
      
      name  = "8",
      reward = { gem = 3  },
      skipCost = { gold=3*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalGold,
            twoLine     = true,
            text1       = "Collect 100 Coins",
            text2       = "in 1 Game",
            bannerText  = "100 Coins Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Collected",
            cumulative  = false,
            objective   = 100,
         },
         {
            factory     = MissionGoalDestroyBarricade,
            twoLine     = true,
            text1       = "Boost through",
            text2       = "2 Obstacles",
            bannerText  = "2 Obstacles Destroyed",
            twoLinePause= true,
            pauseText1  = " Obstacles",
            pauseText2  = "Boosted Through",
            hideNum     = false,
            cumulative  = true,
            objective   = 2,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect Boost x5",
            bannerText  = "Collected Boost x5",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Boosts Collected",
            type        = "powerup_speed_burst",
            cumulative  = true,
            objective   = 5,
         },
      }
   },
   {
      
      name  = "9",
      reward = { gem = 3  },
      skipCost = { gold=3*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalGold,
            twoLine     = true,
            text1       = "Collect 100 Coins",
            text2       = "with the Magnet",
            bannerText  = "100 Coins Magnetized",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Magnetized",
            magnet      = true,
            cumulative  = true,
            objective   = 100,
         },
         {
            factory     = MissionGoalUpgrade,
            twoLine     = true,
            text1       = "Purchase Any",
            text2       = "Pickup Upgrade",
            bannerText  = "Pickup Upgraded",
            twoLinePause= true,
            pauseText1  = "Purchase Any",
            pauseText2  = "Pickup Upgrade",
            hideNum     = true,
            item        = "pickup",
            vehicle     = false,
            cumulative  = true,
            objective   = 1,
         },
         {
            factory     = MissionGoalMultiplier,
            text        = "Get Multiplier to x3",
            bannerText  = "Multiplier x3",
            pauseText   = "Get Multiplier to x3",
            hideNum     = true,
            cumulative  = false,
            objective   = 3,
         },
      }
   },
   {
      
      name  = "10",
      reward = { gem = 4  },
      skipCost = { gold=4*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            text        = "Score 10,000 in 1 Game",
            bannerText  = "10,000 in 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 10000,
         },
         {
            factory     = MissionGoalAvoidBarricade,
            text        = "Avoid 25 Obstacles",
            bannerText  = "25 Obstacles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Avoided",
            cumulative  = true,
            objective   = 25,
         },
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Avoid Coins",
            text2			= "for 250m",
            bannerText  = "Coin Allergy, 250m",
				twoLinePause= true,
				pauseText1  = "Avoid Coins",
            pauseText2  = "for 250m",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 250,
         },
      }
   },
   {
      
      name  = "11",
      reward = { gem = 4  },
      skipCost = { gold=4*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            text        = "Kill 500 Enemies",
            bannerText  = "500 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Killed",
            oneShot     = false,
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 500,
            
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 10",
            text2       = "Gun Trucks",
            bannerText  = "Destroyed 10 Gun Trucks",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Gun Trucks Killed",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 10,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 3 Wrenches",
            text2       = "in 1 Game",
            bannerText  = "3 Wrenches in 1",
            twoLinePause= true,
            pauseText1  = "Wrenches",
            pauseText2  = "Collected in 1 Game",
            cumulative  = false,
            type        = "wrench",
            cumulative  = false,
            objective   = 3,
         },
      }
   },
   {
      
      name  = "12",
      reward = { gem = 4  },
      skipCost = { gold=4*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidMissile,
            text        = "Avoid 25 Missiles",
            bannerText  = "25 Missiles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Missiles Avoided",
            cumulative  = true,
            objective   = 25,
         },
         {
            factory     = MissionGoalCollectPickups,
            twoLine     = true,
            text1       = "Collect All Coins",
            text2       = "for 250 Meters",
            bannerText  = "Coin Hoarder, 250m",
            twoLinePause= true,
            pauseText1  = "Collect All Coins",
            pauseText2  = "for 250 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 250,
         },
         {
            factory     = MissionGoalChangeLanes,
            twoLine     = true,
            text1       = "Change Lanes",
            text2       = "1,000 Times",
            bannerText  = "1,000 Lane Changes",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Lane Changes",
            cumulative  = true,
            objective   = 1000,
         },
      }
   },
   {
      
      name  = "13",
      reward = { gem = 5  },
      skipCost = { gold=5*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 50 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "50 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 50,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 25 Tankers",
            bannerText  = "25 Tankers Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Tankers Destroyed",
            oneShot     = false,
            vicTypes    = {"fuel_truck_a"},
            deathType   =nil, --string or nil!
            cumulative  = true,
            objective   = 25,
         },
         {
            factory     = MissionGoalPickupStack,
            twoLine     = true,
            text1       = "Have all 4 Powers",
            text2       = "at the Same Time",
            bannerText  = "Quadruple Rainbow!",
            twoLinePause= true,
            pauseText1  = "Have all 4 Powers",
            pauseText2  = "at the Same Time",
            hideNum     = true,
            powerups    = {"powerup_speed_burst", "powerup_double", "powerup_magnet", "powerup_scoreK"},
            cumulative  = false,
            objective   = 1,
         },
      }
   },
   {
      
      name  = "14",
      reward = { gem = 5  },
      skipCost = { gold=5*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidLanes,
            twoLine     = true,
            text1       = "Avoid the Outer Lanes",
            text2       = "for 1,000 Meters",
            bannerText  = "Middle Lanes, 1,000m",
            twoLinePause= true,
            pauseText1  = "Avoid the Outer Lanes",
            pauseText2  = "for 1,000 Meters",
            hideNum     = true,
            lanes       = {1,5},
            cumulative  = false,
            objective   = 1000,
         },
         {
            factory     = MissionGoalSideswipe,
            text        = "Sideswipe 25 Enemies",
            bannerText  = "25 Enemies Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Sideswiped",
            cumulative  = true,
            objective   = 25,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 6 Gun Trucks",
            text2       = "in 1 Game",
            bannerText  = "6 Trucks, 1 Game",
            twoLinePause= true,
            pauseText1  = "Gun Trucks",
            pauseText2  = "Killed in 1 Game",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
				cumulative  = false,
            objective   = 6,
         },
      }
   },
   {
      
      name  = "15",
      reward = { gem = 5  },
      skipCost = { gold=5*1000 },
      goals =
      
      {
         {
            factory      = MissionGoalAvoidBarricade,
				text         = "Avoid 50 Obstacles",
				bannerText   = "50 Obstacles Avoided",
            twoLinePause = true,
            pauseText1   = "",
            pauseText2   = "Obstacles Avoided",
            cumulative   = true,
            objective    = 50,
         },
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "2,000 Meter Marker",
            bannerText  = "2,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 2000,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 250 Enemies",
            text2       = "with Doubleshot",
            bannerText  = "2 Barrels, 250 Enemies",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Killed with Doubleshot",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
            cumulative  = true,
            objective   = 250,
         },
      }
   },
   {
      
      name  = "16",
      reward = { gem = 6  },
      skipCost = { gold=6*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 20,000 Points",
            text2       = "in 1 Game",
            bannerText  = "20,000 Points in 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 20000,
         },
         {
            factory     = MissionGoalMultiplier,
            text        = "Get Multiplier to x4",
            bannerText  = "Multiplier x4",
            pauseText   = "Get Multiplier to x4",
            hideNum     = true,
            cumulative  = false,
            objective   = 4,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 25",
            text2       = "Magnet Powerups",
            bannerText  = "25 Magnets",
            twoLinePause= true,
            pauseText1  = "Magnet",
            pauseText2  = "Powerups Collected",
            type        = "powerup_magnet",
            cumulative  = true,
            objective   = 25,
         },
         
      },
   },
   {
      
      name  = "17",
      reward = { gem = 6  },
      skipCost = { gold=6*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKillAll,
            twoLine     = true,
            text1       = "Kill Every Enemy",
            text2       = "for 2,000 Meters",
            bannerText  = "All Enemies Killed, 2,000m",
            twoLinePause= true,
            pauseText1  = "Kill Every Enemy",
            pauseText2  = "for 2,000 Meters",
            hideNum     = true,
            enemies     = nil,
            cumulative  = false,
            objective   = 2000,
         },
         {
            factory     = MissionGoalLeaderBoard,
            twoLine     = true,
            text1       = "Reach Top 3",
            text2       = "on the Leaderboard",
            bannerText  = "Top 3 on the Leaderboard",
            twoLinePause= true,
            pauseText1  = "Reach Top 3",
            pauseText2  = "on the Leaderboard",
            hideNum     = true,
            cumulative  = true,
            objective   = 3,
         },
         {
            factory     = MissionGoalBoostKill,
            twoLine     = true,
            text1       = "Boost Through",
            text2       = "250 Enemies",
            bannerText  = "Boosted through 250 Enemies",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Boosted Through",
            cumulative  = true,
            objective   = 250,
         },
         
      },
   },
   {
      
      name  = "18",
      reward = { gem = 6  },
      skipCost = { gold=6*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Avoid All Powerups",
            text2       = "for 1,000 Meters",
            bannerText  = "Powerups Avoided, 1,000m",
            twoLinePause= true,
            pauseText1  = "Avoid All Powerups",
            pauseText2  = "for 1,000 Meters",
            hideNum     = true,
            pickups     = {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK",},
            cumulative  = false,
            objective   = 1000,
         },
         {
            factory     = MissionGoalGold,
            text        = "Collect 600 Coins",
            bannerText  = "600 Coins Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Collected",
            cumulative  = true,
            objective   = 600,
         },
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe",
            text2       = "20 Obstacles",
            bannerText  = "20 Obstacles Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Sideswiped",
            barricade   = true,
            cumulative  = true,
            objective   = 20,
         },
      },
   },
   {
      
      name  = "19",
      reward = { gem = 7  },
      skipCost = { gold=7*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDestroyMissile,
            twoLine    = true,
            text1       = "Boost through",
            text2       = "3 Missiles",
            bannerText  = "Boosted through 3 Missiles",
            twoLinePause= true,
            pauseText1  = "Missiles",
            pauseText2  = "Boosted Through",
            cumulative  = true,
            objective   = 3,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 4 Wrenches",
            text2       = "in 1 Game",
            bannerText  = "4 Wrenches in 1",
            twoLinePause= true,
            pauseText1  = "Wrenches",
            pauseText2  = "Collected in 1 Game",
            timedText	= {concat1="concat1 ",time=60,concat2=" concat2",twoLine=true,lineTwo=true,},
            type        = "wrench",
            cumulative  = false,
            objective   = 4,
         },
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Drive 2,000m Without",
            text2       = "Taking Damage",
            bannerText  = "2,000m, Zero Damage",
            twoLinePause= true,
            pauseText1  = "Drive 2,000m Without",
            pauseText2  = "Taking Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 2000,
         },
         
      }
   },
   {
      
      name  = "20",
      reward = { gem = 7  },
      skipCost = { gold=7*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            text        = "Kill 1,000 Enemies",
            bannerText  = "1,000 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Killed",
            oneShot     = false,
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 1000,
         },
         {
            factory     = MissionGoalPickupTimed,
            twoLine     = true,
            text1       = "Collect 20 Coins in",
            text2       = "10 Seconds",
            bannerText  = "20 Coins in 10 Seconds",
            twoLinePause= true,
            pauseText1  = "Collect 20 Coins in",
            pauseText2  = "a 10 Second Span",
            hideNum     = true,
            timer       = 10,
            type        = "currency",
            cumulative  = false,
            objective   = 20,
         },
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the 4,000",
            text2       = "Meter Marker",
            bannerText  = "4,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 4000,
         },
         
      },
   },
   {
      name  = "21",
      reward = { gem = 7  },
      skipCost = { gold=7*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 75 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "75 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 75,
         },
         {
            factory     = MissionGoalAvoidMissile,
            text        = "Avoid 100 Missiles",
            bannerText  = "100 Missiles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Missiles Avoided",
            cumulative  = true,
            objective   = 100,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 25",
            text2       = "Score Multipliers",
            bannerText  = "25 Multipliers",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Multipliers Collected",
            type        = "powerup_scoreK",
            cumulative  = true,
            objective   = 25,
         },
         
      }
   },
   {
      name  = "22",
      reward = { gem = 8  },
      skipCost = { gold=8*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalGold,
            twoLine     = true,
            text1       = "Collect 500 Coins",
            text2       = "with the Magnet",
            bannerText  = "500 Coins Magnetized",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Magnetized",
            magnet      = true,
			cumulative  = true,
            objective   = 500,
         },
         {
            factory     = MissionGoalChangeLanes,
            twoLine     = true,
            text1       = "Change Lanes",
            text2       = "1,500 Times",
            bannerText  = "1,500 Lane Changes",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Lane Changes",
            cumulative  = true,
            objective   = 1500,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 500 Enemies",
            text2       = "with Doubleshot",
            bannerText  = "500 Enemies, 2 Barrels",
            twoLinePause= true,
            pauseText1  = "Killed",
            pauseText2  = "with Doubleshot",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
			cumulative  = true,
            objective   = 500,
         },
         
      }
   },
   {
      name  = "23",
      reward = { gem = 8  },
      skipCost = { gold=8*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "6,000 Meter Marker",
            bannerText  = "6,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 6000,
         },
         {
            factory     = MissionGoalScore,
            text        = "Beat Your High Score",
            bannerText  = "High Score Beaten",
            pauseText   = "Beat Your High Score",
            hideNum     = true,
            highScore   = true,
            cumulative  = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalSideswipe,
            twoLine		= true,
            text1       = "Sideswipe",
            text2       = "50 Enemies",
            bannerText  = "50 Enemies Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Sideswiped",
            cumulative  = true,
            objective   = 50,
         },
         
      }
   },
   {
      name  = "24",
      reward = { gem = 8  },
      skipCost = { gold=8*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalCollectPickups,
            twoLine     = true,
            text1       = "Collect All Coins",
            text2       = "for 500 Meters",
            bannerText  = "Coin Hoarder, 500m",
            twoLinePause= true,
            pauseText1  = "Collect All Coins",
            pauseText2  = "for 500 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 500,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 100",
            text2       = "Gun Trucks",
            bannerText  = "Destroyed 100 Gun Trucks",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Gun Trucks Killed",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 100,
         },
         {
            factory     = MissionGoalUpgrade,
            twoLine     = true,
            text1       = "Upgrade Any",
            text2       = "Pickup to Level 4",
            bannerText  = "Pickup L4",
            twoLinePause= true,
            pauseText1  = "Upgrade Any",
            pauseText2  = "Pickup to Level 4",
            hideNum     = true,
            item        = "pickup",
            vehicle     = false,
            threshold	= true,
            cumulative  = true,
            objective   = 4,
         },
         
      }
   },
   {
      name  = "25",
      reward = { gem = 9  },
      skipCost = { gold=9*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 40,000 Points",
            text2       = "in 1 Game",
            bannerText  = "40,000 Points in 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 40000,
         },
         {
            factory     = MissionGoalMultiplier,
            text        = "Get Multiplier to x5",
            bannerText  = "Multiplier x5",
            pauseText   = "Get Multiplier to x5",
            hideNum     = true,
            cumulative  = false,
            objective   = 5,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 250 Enemies",
            text2       = "with Multiplier Active",
            bannerText  = "250 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "Enemies Killed",
            pauseText2  = "with Multiplier Active",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "multiplier", --string or nil!
            cumulative  = true,
            objective   = 250,
         },
      }
   },
   {
      name  = "26",
      reward = { gem = 9  },
      skipCost = { gold=9*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Score 5,000 Points",
            text2       = "without Powerups",
            bannerText  = "Powerups Avoided, 5,000",
            twoLinePause= true,
            pauseText1  = "Score 5,000 Points",
            pauseText2  = "without Powerups",
            hideNum     = true,
            pickups     = {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   = 5000,
            cumulative  = false,
            score		= true,
         },
         {
            factory     = MissionGoalGold,
            twoLine		= true,
            text1       = "Collect 150 Coins",
            text2		= "in 1 Game",
            bannerText  = "150 Coins, 1 Game",
            twoLinePause= true,
            pauseText1  = "Coins",
            pauseText2  = "Collected in 1 Game",
            cumulative  = false,
            objective   = 150,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect 25 Wrenches",
            bannerText  = "25 Wrenches Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Wrenches Collected",
            type        = "wrench",
            cumulative  = true,
            objective   = 25,
         },
         
      }
   },
   {
      name  = "27",
      reward = { gem = 9  },
      skipCost = { gold=9*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalSpendKeys,
            twoLine     = true,
            text1       = "Use 12 Keys",
            text2       = "in 1 Hour",
            bannerText  = "12 Keys in 1 Hour!",
            twoLinePause= true,
            pauseText1  = "Use 12 Keys",
            pauseText2  = "in 1 Hour",
            hideNum     = true,
            cumulative  = true,
            objective   = 12,
            timer       = 3600,
         },
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Reach 4,000 Meters",
            text2       = "Without Damage",
            bannerText  = "4,000m, Zero Damage",
            twoLinePause= true,
            pauseText1  = "Drive 4,000 Meters",
            pauseText2  = "Without Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 4000,
         },
         {
            factory     = MissionGoalBoostKill,
            twoLine     = true,
            text1       = "Boost Through",
            text2       = "500 Enemies",
            bannerText  = "500 Boost Kills",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Boosted Through",
            cumulative  = true,
            objective   = 500,
         },
         
      }
   },
   {
      name  = "28",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "8,000 Meter Marker",
            bannerText  = "8,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 8000,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 50 Tankers",
            bannerText  = "50 Tankers Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Tankers Destroyed",
            oneShot     = false,
            vicTypes    = {"fuel_truck_a"},
            deathType   =nil, --string or nil!
            cumulative  = true,
            objective   = 50,
         },
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Avoid All Coins",
            text2       = "for 500 Meters",
            bannerText  = "Coin Allergy, 500m",
            twoLinePause= true,
            pauseText1  = "Avoid All Coins",
            pauseText2  = "for 500 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 500,
         },
         
      }
   },
   {
      name  = "29",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalLeaderBoard,
            twoLine     = true,
            text1       = "Reach First Place",
            text2       = "on the Leaderboard",
            bannerText  = "First Place!",
            twoLinePause= true,
            pauseText1  = "Reach First Place",
            pauseText2  = "on the Leaderboard",
            hideNum     = true,
            cumulative  = true,
            objective   = 1,
         },
         {
            factory     = MissionGoalAvoidBarricade,
            text        = "Avoid 100 Obstacles",
            bannerText  = "100 Obstacles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Avoided",
            cumulative  = true,
            objective   = 100,
         },
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe 6 Enemies",
            text2       = "in 1 Game",
            bannerText  = "6 Sideswipes in 1 Game",
            twoLinePause= true,
            pauseText1  = "Enemies Sideswiped",
            pauseText2  = "in 1 Game",
            cumulative  = false,
            objective   = 6,
         },
         
      }
   },
   {
      name  = "30",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 60,000 Points",
            text2       = "in 1 Game",
            bannerText  = "60,000 Points, 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 60000,
         },
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Avoid All Powerups",
            text2       = "for 1,500 Meters",
            bannerText  = "Powerups Avoided, 1,500",
            twoLinePause= true,
            pauseText1  = "Avoid All Powerups",
            pauseText2  = "for 1,500 Meters",
            hideNum     = true,
            pickups     = {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   = 1500,
            cumulative  = false,
            score       = false,
         },
         {
            factory     = MissionGoalKill,
            text        = "Kill 1,500 Enemies",
            bannerText  = "1,500 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Killed",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 1500,
         },
      }
   },
   {
      name  = "31",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 100 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "100 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 100,
         },
         {
            factory     = MissionGoalGold,
            text        = "Collect 1,500 Coins",
            bannerText  = "1,500 Coins Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Collected",
            cumulative  = true,
            objective   = 1500,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 50",
            text2       = "Magnet Powerups",
            bannerText  = "50 Magnets",
            twoLinePause= true,
            pauseText1  = "Magnet",
            pauseText2  = "Powerups Collected",
            type        = "powerup_magnet",
            cumulative  = true,
            objective   = 50,
         },
      }
   },
   {
      name  = "32",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 15",
            text2       = "Armored Trucks",
            bannerText  = "15 Armored Trucks",
            twoLinePause= true,
            pauseText1  = "Armored Trucks",
            pauseText2  = "Destroyed",
            vicTypes    = {"armor_truck_a",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 15,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect Boost x15",
            bannerText  = "Collected Boost x15",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Boosts Collected",
            type        = "powerup_speed_burst",
            cumulative  = true,
            objective   = 15,
         },
         {
            factory     = MissionGoalCollectPickups,
            twoLine     = true,
            text1       = "Collect All Coins",
            text2       = "for 1,000 Meters",
            bannerText  = "Coin Hoarder, 1,000m",
            twoLinePause= true,
            pauseText1  = "Collect All Coins",
            pauseText2  = "for 1,000 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 1000,
         },
      }
   },
   {
      name  = "33",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKillAll,
            twoLine     = true,
            text1       = "Kill Every Enemy",
            text2       = "for 3,500 Meters",
            bannerText  = "All Enemies Killed, 3,500m",
            twoLinePause= true,
            pauseText1  = "Kill Every Enemy",
            pauseText2  = "for 3,500 Meters",
            hideNum     = true,
            enemies     = nil,
            cumulative  = false,
            objective   = 3500,
         },
         {
            factory     = MissionGoalChangeLanes,
            twoLine     = true,
            text1       = "Change Lanes",
            text2       = "2,000 Times",
            bannerText  = "2,000 Lane Changes",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Lane Changes",
            cumulative  = true,
            objective   = 2000,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 750 Enemies",
            text2       = "with Doubleshot",
            bannerText  = "750 Enemies, 2 Barrels",
            twoLinePause= true,
            pauseText1  = "Killed",
            pauseText2  = "with Doubleshot",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
			cumulative  = true,
            objective   = 750,
         },
      }
   },
   {
      name  = "34",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "10,000 Meter Marker",
            bannerText  = "10,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 10000,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 150",
            text2       = "Gun Trucks",
            bannerText  = "Destroyed 150 Gun Trucks",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Gun Trucks Killed",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 150,
         },
         {
            factory     = MissionGoalAvoidMissile,
            text        = "Avoid 200 Missiles",
            bannerText  = "200 Missiles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Missiles Avoided",
            cumulative  = true,
            objective   = 200,
         },
      }
   },
   {
      name  = "35",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe",
            text2       = "25 Obstacles",
            bannerText  = "25 Obstacles Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Sideswiped",
            barricade   = true,
            cumulative  = true,
            objective   = 25,
         },
         {
            factory     = MissionGoalAvoidLanes,
            twoLine     = true,
            text1       = "Avoid the Outer Lanes",
            text2       = "for the first 2,000m",
            bannerText  = "Middle Lanes, 2,000m",
            twoLinePause= true,
            pauseText1  = "Avoid the Outer Lanes",
            pauseText2  = "for the first 2,000m",
            hideNum     = true,
            lanes       = {1,5},
            cumulative  = false,
            objective   = 2000,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect 50 Wrenches",
            bannerText  = "50 Wrenches Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Wrenches Collected",
            type        = "wrench",
            cumulative  = true,
            objective   = 50,
         },
      }
   },
   {
      name  = "36",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 80,000 Points",
            text2       = "in 1 Game",
            bannerText  = "80,000 Points, 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 80000,
         },
         {
            factory     = MissionGoalBoostKill,
            twoLine     = true,
            text1       = "Boost Through",
            text2       = "1,000 Enemies",
            bannerText  = "1,000 Boost Kills",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Boosted Through",
            cumulative  = true,
            objective   = 1000,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 50",
            text2       = "Score Multipliers",
            bannerText  = "50 Multipliers",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Multipliers Collected",
            type        = "powerup_scoreK",
            cumulative  = true,
            objective   = 50,
         },
      }
   },
   {
      name  = "37",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDestroyBarricade,
            twoLine     = true,
            text1       = "Boost through",
            text2       = "8 Obstacles",
            bannerText  = "8 Obstacles Destroyed",
            twoLinePause= true,
            pauseText1  = " Obstacles",
            pauseText2  = "Boosted Through",
            hideNum     = false,
            cumulative  = true,
            objective   = 8,
         },
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe 8 Enemies",
            text2       = "in 1 Game",
            bannerText  = "8 Sideswipes in 1 Game",
            twoLinePause= true,
            pauseText1  = "Enemies Sideswiped",
            pauseText2  = "in 1 Game",
            cumulative  = false,
            objective   = 8,
         },
         {
            factory     = MissionGoalUpgrade,
            twoLine     = true,
            text1       = "Upgrade Any",
            text2       = "Pickup to Level 6",
            bannerText  = "Pickup L6",
            twoLinePause= true,
            pauseText1  = "Upgrade Any",
            pauseText2  = "Pickup to Level 6",
            hideNum     = true,
            item        = "pickup",
            vehicle     = false,
            threshold	= true,
            cumulative  = true,
            objective   = 6,
         },
      }
   },
   {
      name  = "38",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Reach 6,000 Meters",
            text2       = "Without Damage",
            bannerText  = "6,000m, Zero Damage",
            twoLinePause= true,
            pauseText1  = "Drive 6,000 Meters",
            pauseText2  = "Without Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 6000,
         },
         {
            factory     = MissionGoalGold,
            twoLine		= true,
            text1       = "Collect 200 Coins",
            text2       = "in 1 Game",
            bannerText  = "200 Coins, 1 Game",
            twoLinePause= true,
            pauseText1  = "Coins",
            pauseText2  = "Collected in 1 Game",
            cumulative  = false,
            objective   = 200,
         },
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Score 7,500 Points",
            text2       = "without Powerups",
            bannerText  = "Powerups Avoided, 7,500",
            twoLinePause= true,
            pauseText1  = "Score 7,500 Points",
            pauseText2  = "without Powerups",
            hideNum     = true,
            pickups     = {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   = 7500,
            cumulative  = false,
            score		= true,
         },
      }
   },
   {
      name  = "39",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalSideswipe,
            twoLine		= true,
            text1       = "Sideswipe",
            text2       = "75 Enemies",
            bannerText  = "75 Enemies Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Sideswiped",
            cumulative  = true,
            objective   = 75,
         },
         {
            factory     = MissionGoalAvoidBarricade,
            text        = "Avoid 150 Obstacles",
            bannerText  = "150 Obstacles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Avoided",
            cumulative  = true,
            objective   = 150,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 5 Wrenches",
            text2       = "in 1 Game",
            bannerText  = "5 Wrenches in 1",
            twoLinePause= true,
            pauseText1  = "Wrenches",
            pauseText2  = "Collected in 1 Game",
            timedText	= {concat1="concat1 ",time=60,concat2=" concat2",twoLine=true,lineTwo=true,},
            type        = "wrench",
            cumulative  = false,
            objective   = 5,
         },
      }
   },
   {
      name  = "40",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "12,500 Meter Marker",
            bannerText  = "12,500 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 12500,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 150 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "150 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 150,
         },
         {
            factory     = MissionGoalGold,
            text        = "Collect 3,000 Coins",
            bannerText  = "3,000 Coins Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Collected",
            cumulative  = true,
            objective   = 3000,
         },
      }
   },
   {
      name  = "41",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 100,000 Points",
            text2       = "in 1 Game",
            bannerText  = "100,000 Points, 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 100000,
         },
         {
            factory     = MissionGoalGold,
            twoLine     = true,
            text1       = "Collect 1,000 Coins",
            text2       = "with the Magnet",
            bannerText  = "1,000 Coins Magnetized",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Magnetized",
            magnet      = true,
			cumulative  = true,
            objective   = 1000,
         },
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Avoid All Coins",
            text2       = "for 750 Meters",
            bannerText  = "Coin Allergy, 750m",
            twoLinePause= true,
            pauseText1  = "Avoid All Coins",
            pauseText2  = "for 750 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 750,
         },

      }
   },
   {
      name  = "42",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            text        = "Beat Your High Score",
            bannerText  = "High Score Beaten",
            pauseText   = "Beat Your High Score",
            hideNum     = true,
            highScore   = true,
            cumulative  = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 8 Gun Trucks",
            text2       = "in 1 Game",
            bannerText  = "8 Trucks, 1 Game",
            twoLinePause= true,
            pauseText1  = "Gun Trucks",
            pauseText2  = "Killed in 1 Game",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = false,
            objective   = 8,
         },
         {
            factory     = MissionGoalPickupStack,
            twoLine     = true,
            text1       = "Have all 4 Powers",
            text2       = "at the Same Time",
            bannerText  = "Quadruple Rainbow!",
            twoLinePause= true,
            pauseText1  = "Have all 4 Powers",
            pauseText2  = "at the Same Time",
            hideNum     = true,
            powerups    = {"powerup_speed_burst", "powerup_double", "powerup_magnet", "powerup_scoreK"},
            cumulative  = false,
            objective   = 1,
         },
      }
   },
   {
      name  = "43",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Reach 8,000 Meters",
            text2       = "Without Damage",
            bannerText  = "8,000m, Zero Damage",
            twoLinePause= true,
            pauseText1  = "Drive 8,000 Meters",
            pauseText2  = "Without Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 8000,
         },
         {
            factory     = MissionGoalLeaderBoard,
            twoLine     = true,
            text1       = "Reach Top 3",
            text2       = "on the Leaderboard",
            bannerText  = "Top 3 on the Leaderboard",
            twoLinePause= true,
            pauseText1  = "Reach Top 3",
            pauseText2  = "on the Leaderboard",
            hideNum     = true,
            cumulative  = true,
            objective   = 3,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 1,000 Enemies",
            text2       = "with Doubleshot",
            bannerText  = "1,000 Enemies, 2 Barrels",
            twoLinePause= true,
            pauseText1  = "Killed",
            pauseText2  = "with Doubleshot",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
			cumulative  = true,
            objective   = 1000,
         },
      }
   },
   {
      name  = "44",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            text        = "Kill 2,000 Enemies",
            bannerText  = "2,000 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Killed",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 2000,
         },
         {
            factory     = MissionGoalCollectPickups,
            twoLine     = true,
            text1       = "Collect All Coins",
            text2       = "for 1,500 Meters",
            bannerText  = "Coin Hoarder, 1,500m",
            twoLinePause= true,
            pauseText1  = "Collect All Coins",
            pauseText2  = "for 1,500 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 1500,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 75 Tankers",
            bannerText  = "75 Tankers Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Tankers Destroyed",
            oneShot     = false,
            vicTypes    = {"fuel_truck_a"},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 75,
         },
      }
   },
   {
      name  = "45",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "15,000 Meter Marker",
            bannerText  = "15,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 15000,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 30",
            text2       = "Armored Trucks",
            bannerText  = "30 Armored Trucks",
            twoLinePause= true,
            pauseText1  = "Armored Trucks",
            pauseText2  = "Destroyed",
            vicTypes    = {"armor_truck_a",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 30,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect Boost x30",
            bannerText  = "Collected Boost x30",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Boosts Collected",
            type        = "powerup_speed_burst",
            cumulative  = true,
            objective   = 30,
         },
      }
   },
   
      {
      name  = "46",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 125,000 Points",
            text2       = "in 1 Game",
            bannerText  = "125,000 Points, 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 125000,
         },
         {
            factory     = MissionGoalGold,
            twoLine		= true,
            text1       = "Collect 250 Coins",
            text2       = "in 1 Game",
            bannerText  = "250 Coins, 1 Game",
            twoLinePause= true,
            pauseText1  = "Coins",
            pauseText2  = "Collected in 1 Game",
            cumulative  = false,
            objective   = 250,
         },
         {
            factory     = MissionGoalDestroyBarricade,
            twoLine     = true,
            text1       = "Boost through",
            text2       = "12 Obstacles",
            bannerText  = "12 Obstacles Destroyed",
            twoLinePause= true,
            pauseText1  = " Obstacles",
            pauseText2  = "Boosted Through",
            hideNum     = false,
            cumulative  = true,
            objective   = 12,
         },
      }
   },
   {
      name  = "47",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 200 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "200 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 200,
         },
         {
            factory     = MissionGoalGold,
            text        = "Collect 4,000 Coins",
            bannerText  = "4,000 Coins Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Collected",
            cumulative  = true,
            objective   = 4000,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 75",
            text2       = "Magnet Powerups",
            bannerText  = "75 Magnets",
            twoLinePause= true,
            pauseText1  = "Magnet",
            pauseText2  = "Powerups Collected",
            type        = "powerup_magnet",
            cumulative  = true,
            objective   = 75,
         },
      }
   },
   {
      name  = "48",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 40",
            text2       = "Armored Trucks",
            bannerText  = "40 Armored Trucks",
            twoLinePause= true,
            pauseText1  = "Armored Trucks",
            pauseText2  = "Destroyed",
            vicTypes    = {"armor_truck_a",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 40,
         },
         {
            factory     = MissionGoalDestroyMissile,
            twoLine    = true,
            text1       = "Boost through",
            text2       = "6 Missiles",
            bannerText  = "Boosted through 6 Missiles",
            twoLinePause= true,
            pauseText1  = "Missiles",
            pauseText2  = "Boosted Through",
            cumulative  = true,
            objective   = 6,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 75",
            text2       = "Score Multipliers",
            bannerText  = "75 Multipliers",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Multipliers Collected",
            type        = "powerup_scoreK",
            cumulative  = true,
            objective   = 75,
         },
      }
   },
   {
      name  = "49",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKillAll,
            twoLine     = true,
            text1       = "Kill Every Enemy",
            text2       = "for 5,000 Meters",
            bannerText  = "All Enemies Killed, 5,000m",
            twoLinePause= true,
            pauseText1  = "Kill Every Enemy",
            pauseText2  = "for 5,000 Meters",
            hideNum     = true,
            enemies     = nil,
            cumulative  = false,
            objective   = 5000,
         },
         {
            factory     = MissionGoalChangeLanes,
            twoLine     = true,
            text1       = "Change Lanes",
            text2       = "3,000 Times",
            bannerText  = "3,000 Lane Changes",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Lane Changes",
            cumulative  = true,
            objective   = 3000,
         },
         {
            factory     = MissionGoalMultiplier,
            text        = "Get Multiplier to x5",
            bannerText  = "Multiplier x5",
            pauseText   = "Get Multiplier to x5",
            hideNum     = true,
            cumulative  = false,
            objective   = 5,
         },
      }
   },
   {
      name  = "50",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "17,500 Meter Marker",
            bannerText  = "17,500 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 17500,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 200",
            text2       = "Gun Trucks",
            bannerText  = "Destroyed 200 Gun Trucks",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Gun Trucks Killed",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 200,
         },
         {
            factory     = MissionGoalAvoidMissile,
            text        = "Avoid 300 Missiles",
            bannerText  = "300 Missiles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Missiles Avoided",
            cumulative  = true,
            objective   = 300,
         },
      }
   },
   {
      name  = "51",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe",
            text2       = "30 Obstacles",
            bannerText  = "30 Obstacles Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Sideswiped",
            barricade   = true,
            cumulative  = true,
            objective   = 30,
         },
         {
            factory     = MissionGoalAvoidLanes,
            twoLine     = true,
            text1       = "Avoid the Outer Lanes",
            text2       = "for 3,000 Meters",
            bannerText  = "Middle Lanes, 3,000m",
            twoLinePause= true,
            pauseText1  = "Avoid the Outer Lanes",
            pauseText2  = "for 3,000 Meters",
            hideNum     = true,
            lanes       = {1,5},
            cumulative  = false,
            objective   = 3000,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect 100 Wrenches",
            bannerText  = "100 Wrenches Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Wrenches Collected",
            type        = "wrench",
            cumulative  = true,
            objective   = 100,
         },
      }
   },
   {
      name  = "52",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 150,000 Points",
            text2       = "in 1 Game",
            bannerText  = "150,000 Points, 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 150000,
         },
         {
            factory     = MissionGoalBoostKill,
            twoLine     = true,
            text1       = "Boost Through",
            text2       = "1,500 Enemies",
            bannerText  = "1,500 Boost Kills",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Boosted Through",
            cumulative  = true,
            objective   = 1500,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect Boost x45",
            bannerText  = "Collected Boost x45",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Boosts Collected",
            type        = "powerup_speed_burst",
            cumulative  = true,
            objective   = 45,
         },
      }
   },
   {
      name  = "53",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 1250 Enemies",
            text2       = "with Doubleshot",
            bannerText  = "1250 Enemies, 2 Barrels",
            twoLinePause= true,
            pauseText1  = "Killed",
            pauseText2  = "with Doubleshot",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
			cumulative  = true,
            objective   = 1250,
         },
         {
            factory     = MissionGoalSideswipe,
            twoLine     = true,
            text1       = "Sideswipe 10 Enemies",
            text2       = "in 1 Game",
            bannerText  = "10 Sideswipes in 1 Game",
            twoLinePause= true,
            pauseText1  = "Enemies",
            pauseText2  = "Swiped in 1 Game",
            cumulative  = false,
            objective   = 10,
         },
         {
            factory     = MissionGoalKill,
            text        = "Kill 2,500 Enemies",
            bannerText  = "2,500 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Killed",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 2500,
         },
      }
   },
   {
      name  = "54",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Reach 10,000 Meters",
            text2       = "Without Damage",
            bannerText  = "10,000m, Zero Damage",
            twoLinePause= true,
            pauseText1  = "Drive 10,000 Meters",
            pauseText2  = "Without Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 10000,
         },
         {
            factory     = MissionGoalGold,
            twoLine		= true,
            text1       = "Collect 300 Coins",
            text2       = "in 1 Game",
            bannerText  = "300 Coins, 1 Game",
            twoLinePause= true,
            pauseText1  = "Coins",
            pauseText2  = "Collected in 1 Game",
            cumulative  = false,
            objective   = 300,
         },
         {
            factory     = MissionGoalAvoidPickups,
            twoLine     = true,
            text1       = "Score 10,000 Points",
            text2       = "without Powerups",
            bannerText  = "Powerups Avoided, 10,000",
            twoLinePause= true,
            pauseText1  = "Score 10,000 Points",
            pauseText2  = "without Powerups",
            hideNum     = true,
            pickups     = {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   = 10000,
            cumulative  = false,
            score		= true,
         },
      }
   },
   {
      name  = "55",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalSideswipe,
            twoLine		= true,
            text1       = "Sideswipe",
            text2       = "100 Enemies",
            bannerText  = "100 Enemies Sideswiped",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Sideswiped",
            cumulative  = true,
            objective   = 100,
         },
         {
            factory     = MissionGoalAvoidBarricade,
            text        = "Avoid 200 Obstacles",
            bannerText  = "200 Obstacles Avoided",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Obstacles Avoided",
            cumulative  = true,
            objective   = 200,
         },
         {
            factory     = MissionGoalDistance,
            twoLine     = true,
            text1       = "Reach the",
            text2       = "20,000 Meter Marker",
            bannerText  = "20,000 Meters Reached",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Meters Reached",
            cumulative  = false,
            objective   = 20000,
         },
      }
   },
   {
      name  = "56",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 500 Enemies",
            text2       = "with Multiplier Active",
            bannerText  = "500 Enemies during Multiplier",
            twoLinePause= true,
            pauseText1  = "Enemies Killed",
            pauseText2  = "with Multiplier Active",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "multiplier", --string or nil!
            cumulative  = true,
            objective   = 500,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 250 Enemies",
            text2       = "with Tanker Explosions",
            bannerText  = "250 Enemies Exploded",
            twoLinePause= true,
            pauseText1  = " Enemies Killed",
            pauseText2  = "in Tanker Explosions",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "area", --string or nil!
            cumulative  = true,
            objective   = 250,
         },
         {
            factory     = MissionGoalGold,
            text        = "Collect 5,000 Coins",
            bannerText  = "5,000 Coins Collected",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Collected",
            cumulative  = true,
            objective   = 5000,
         },
      }
   },
   {
      name  = "57",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            twoLine     = true,
            text1       = "Score 175,000 Points",
            text2       = "in 1 Game",
            bannerText  = "175,000 Points, 1 Game",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Points in 1 Game",
            cumulative  = false,
            objective   = 175000,
         },
         {
            factory     = MissionGoalGold,
            twoLine     = true,
            text1       = "Collect 2,500 Coins",
            text2       = "with the Magnet",
            bannerText  = "2,500 Coins Magnetized",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Coins Magnetized",
            magnet      = true,
			cumulative  = true,
            objective   = 2500,
         },
         {
            factory     = MissionGoalPickup,
            twoLine     = true,
            text1       = "Collect 100",
            text2       = "Magnet Powerups",
            bannerText  = "100 Magnets",
            twoLinePause= true,
            pauseText1  = "Magnet",
            pauseText2  = "Powerups Collected",
            type        = "powerup_magnet",
            cumulative  = true,
            objective   = 100,
         },

      }
   },
   {
      name  = "58",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalScore,
            text        = "Beat Your High Score",
            bannerText  = "High Score Beaten",
            pauseText   = "Beat Your High Score",
            hideNum     = true,
            highScore   = true,
            cumulative  = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Destroy 10 Gun Trucks",
            text2       = "in 1 Game",
            bannerText  = "10 Trucks, 1 Game",
            twoLinePause= true,
            pauseText1  = "Gun Trucks",
            pauseText2  = "Killed in 1 Game",
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = false,
            objective   = 10,
         },
         {
            factory     = MissionGoalPickupStack,
            twoLine     = true,
            text1       = "Have all 4 Powers",
            text2       = "at the Same Time",
            bannerText  = "Quadruple Rainbow!",
            twoLinePause= true,
            pauseText1  = "Have all 4 Powers",
            pauseText2  = "at the Same Time",
            hideNum     = true,
            powerups    = {"powerup_speed_burst", "powerup_double", "powerup_magnet", "powerup_scoreK"},
            cumulative  = false,
            objective   = 1,
         },
      }
   },
   {
      name  = "59",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Reach 12,000 Meters",
            text2       = "Without Damage",
            bannerText  = "12,000m, Zero Damage",
            twoLinePause= true,
            pauseText1  = "Drive 12,000 Meters",
            pauseText2  = "Without Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 12000,
         },
         {
            factory     = MissionGoalLeaderBoard,
            twoLine     = true,
            text1       = "Reach Top 3",
            text2       = "on the Leaderboard",
            bannerText  = "Top 3 on the Leaderboard",
            twoLinePause= true,
            pauseText1  = "Reach Top 3",
            pauseText2  = "on the Leaderboard",
            hideNum     = true,
            cumulative  = true,
            objective   = 3,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 1,500 Enemies",
            text2       = "with Doubleshot",
            bannerText  = "1,500 Enemies, 2 Barrels",
            twoLinePause= true,
            pauseText1  = "Killed",
            pauseText2  = "with Doubleshot",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = "doubleshot", --string or nil!
			cumulative  = true,
            objective   = 1500,
         },
      }
   },
   {
      name  = "60",
      reward = { gem = 10  },
      skipCost = { gold=10*1000 },
      goals =
      
      {
         {
            factory     = MissionGoalKill,
            text        = "Kill 3,000 Enemies",
            bannerText  = "3,000 Enemies Killed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Enemies Killed",
            vicTypes    = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a", "fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 3000,
         },
         {
            factory     = MissionGoalCollectPickups,
            twoLine     = true,
            text1       = "Collect All Coins",
            text2       = "for 2,000 Meters",
            bannerText  = "Coin Hoarder, 2,000m",
            twoLinePause= true,
            pauseText1  = "Collect All Coins",
            pauseText2  = "for 2,000 Meters",
            hideNum     = true,
            pickups     = {"currency",},
            cumulative  = false,
            objective   = 2000,
         },
         {
            factory     = MissionGoalKill,
            text        = "Destroy 100 Tankers",
            bannerText  = "100 Tankers Destroyed",
            twoLinePause= true,
            pauseText1  = "",
            pauseText2  = "Tankers Destroyed",
            oneShot     = false,
            vicTypes    = {"fuel_truck_a"},
            deathType   = nil, --string or nil!
            cumulative  = true,
            objective   = 100,
         },
      }
   },

--//////////////////////////////////////////////
--// RECCURING MISSIONS 61-75
--//////////////////////////////////////////////	

{
    name  = "61",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Enemies
    --// Boost Through X Obstacles
    --// Collect X Coins
	
    {
        {
            factory     		= MissionGoalKill,
            text                = "Destroy 3,500 Enemies",
            bannerText  		= "3,500 Enemies Destroyed",
            twoLinePause        = true,
            pauseText1          = " ",
            pauseText2          = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 3500,
        },
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "25 Obstacles",
            bannerText  		= "25 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 25,
        },
        {
            factory     		= MissionGoalGold,
            twoLine     		= true,
            text1       		= "Collect 5,000 Coins",
            text2       		= "with the Magnet",
            bannerText  		= "5,000 Coins Magnetized",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Coins Magnetized",
            magnet      		= true,
            cumulative  		= true,
            objective   		= 5000,
        },
    }
},

{
    name  = "62",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Gun Trucks
	--// Collect X Wrenches
	--// Score X in One Game
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 250",
            text2       		= "Gun Trucks",
            bannerText  		= "Destroyed 250 Gun Trucks",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Gun Trucks Killed",
            vicTypes    		= {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 250,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect 150 Wrenches",
            bannerText  		= "150 Wrenches Collected",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Wrenches Collected",
            cumulative  		= false,
            type        		= "wrench",
            cumulative  		= true,
            objective   		= 150,
        },
		{
            factory     		= MissionGoalScore,
            twoLine     		= true,
            text1        		= "Score 200,000",
            text2               = "in One Game",
            bannerText  		= "200,000 in One Game",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Points in One Game",
            cumulative  		= false,
            objective   		= 200000,
		},
    }
},

{
 	name  = "63",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Double Shot
	--// Avoid X Obstacles
	--// Reach the X Meter Marker
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1               = "Kill 1,750 Enemies",
            text2       		= "by Doubleshot",
            bannerText  		= "2 Barrels, 1,750 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative  		= true,
            objective   		= 1750,
		},	
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 250 Obstacles",
            bannerText  		= "250 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 250,
		},
		{
            factory     		= MissionGoalDistance,
            twoLine     		= true,
            text1       		= "Reach the",
            text2       		= "25,000 Meter Marker",
            bannerText  		= "25,000 Meters Reached",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Meters Reached",
            cumulative  		= false,
            objective   		= 25000,
		},  
    }
},

{
    name  = "64",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Change Lanes X Times
	--// Collect All Coins for X Meters
	--// Avoid X Missiles
      
    {
		{
            factory     		= MissionGoalChangeLanes,
            twoLine     		= true,
            text1       		= "Change Lanes",
            text2       		= "4,000 Times",
            bannerText  		= "4,000 Lane Changes",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Lane Changes",
            cumulative  		= true,
            objective   		= 4000,
        },
		{
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 2,500 Meters",
            bannerText  		= "Coin Hoarder, 2,500m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 2,500 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 2500,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 400 Missiles",
            bannerText  		= "400 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 400,
		},
   	}
},

{
    name  = "65",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Enemies
	--// Collect X Boosts
	--// Beat Your High Score
      
    {
        {
            factory     		= MissionGoalKill,
            text                = "Destroy 4,000 Enemies",
            bannerText  		= "4,000 Enemies Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Enemies Destroyed",
            vicTypes            = {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 4000,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x60",
            bannerText  		= "Collected Boost x60",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 60,
		},
		{
            factory     		= MissionGoalScore,
            text        		= "Beat Your High Score",
            bannerText  		= "High Score Beaten",
            pauseText   		= "Beat Your High Score",
            hideNum     		= true,
            highScore   		= true,
            cumulative  		= false,
            objective   		= 1,
		}, 
    }
},

{
    name  = "66",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Multiplier Active
	--// Collect X Multipliers
	--// Drive X Meters Without Taking Damage
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 750 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "750 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed with Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 750,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 100",
            text2       		= "Score Multipliers",
            bannerText  		= "100 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 100,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 14,000m Without",
            text2       		= "Taking Damage",
            bannerText  		= "14,000m, Zero Damage",
            twoLinePause        = true,
            pauseText1  		= "Drive 14,000m Without",
            pauseText2  		= "Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 14000,
		},     
    }
},

{
    name  = "67",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Tankers
	--// Collect X Magnet Powerups
	--// Reach the Top 3 on the Leaderboards
      
    {
        {
            factory     		= MissionGoalKill,
            text        		= "Destroy 125 Tankers",
            bannerText  		= "125 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes            = {"fuel_truck_a"},
            deathType   		=nil, --string or nil!
            cumulative  		= true,
            objective   		= 125,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 125",
            text2       		= "Magnet Powerups",
            bannerText  		= "125 Magnets",
            twoLinePause        = true,
            pauseText1  		= " Magnet",
            pauseText2  		= "Powerups Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 125,
		},
		{
            factory     		= MissionGoalLeaderBoard,
            twoLine     		= true,
            text1       		= "Reach Top 3",
            text2       		= "on the Leaderboard",
            bannerText  		= "Top 3 on the Leaderboard",
            twoLinePause        = true,
            pauseText1  		= "Reach Top 3",
            pauseText2  		= "on the Leaderboard",
            hideNum     		= true,
            cumulative  		= true,
            objective   		= 3,
		},
    }
},

{
    name  = "68",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Armored Trucks
	--// Have All 4 Powerups at the Same Time
	--// Sideswipe X Obstacles
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 75",
            text2       		= "Armored Trucks",
            bannerText  		= "75 Armored Trucks",
            twoLinePause        = true,
            pauseText1  		= " Armored",
            pauseText2  		= "Trucks Destroyed",
            vicTypes    		= {"armor_truck_a",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 75,
        },
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalSideswipe,
            twoLine     		= true,
            text1       		= "Sideswipe",
            text2       		= "40 Obstacles",
            bannerText  		= "40 Obstacles Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Sideswiped",
            barricade   		= true,
            cumulative  		= true,
            objective   		= 40,
		},   
    }
},

{
    name  = "69",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Score X Points Without Powerups
	--// Sideswipe X Enemies
	--// Collect All Coins for X Meters
      
    {
		{
            factory     		= MissionGoalAvoidPickups,
            twoLine     		= true,
            text1       		= "Score 20,000",
            text2       		= "without Powerups",
            bannerText  		= "Powerups Avoided, 20000",
            twoLinePause        = true,
            pauseText1  		= "Score 20,000",
            pauseText2  		= "without Powerups",
            hideNum     		= true,
            pickups     		= {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   		= 20000,
            cumulative  		= false,
            score               = true,
		},
		{
            factory     		= MissionGoalSideswipe,
            twoLine     		= true,
            text1        		= "Sideswipe",
            text2       		= "125 Enemies",
            bannerText  		= "125 Enemies Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Enemies Sideswiped",
            cumulative  		= true,
            objective   		= 125,
		},
        {
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 3,000 Meters",
            bannerText  		= "Coin Hoarder, 3,000m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 3,000 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 3000,
        },
    }
},

{
    name  = "70",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Boost Through X Enemies
	--// Get Multiplier to x5
	--// Avoid the Outer Lanes for X Meters
    
    {
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "2,000 Enemies",
            bannerText  		= "Boosted through 2,000 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 2000,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},
		{
            factory     		= MissionGoalAvoidLanes,
            twoLine     		= true,
            text1       		= "Avoid Outer Lanes",
            text2       		= "for 4,000 Meters",
            bannerText  		= "Middle Lanes, 4,000m",
            twoLinePause        = true,
            pauseText1  		= "Avoid Outer Lanes",
            pauseText2  		= "for 4,000 Meters",
            hideNum     		= true,
            lanes       		= {1,5},
            cumulative  		= false,
            objective   		= 4000,
		},
    }
},

{
    name  = "71",
    reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Destroy X Enemies
	--// Destroy X Enemies With Tanker Explosions
	--// Destroy X Tankers
      
	{
        {
            factory     		= MissionGoalKill,
            text                = "Destroy 4,500 Enemies",
            bannerText  		= "4,500 Enemies Destroyed",
            twoLinePause        = true,
            pauseText1          = " ",
            pauseText2          = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 4500,
        },
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 300 Enemies",
            text2       		= "by Tanker Explosions",
            bannerText  		= "300 Enemies Exploded",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Explosions",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "area", --string or nil!
            cumulative  		= true,
            objective   		= 300,
		},
		{
            factory     		= MissionGoalKill,
            text        		= "Destroy 150 Tankers",
            bannerText  		= "150 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes    		= {"fuel_truck_a"},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 150,
		},       
	}
},

{
	name  = "72",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Have All 4 Powerups at the Same Time
	--// Collect X Multipliers
	--// Collect X Magnet Powerups
      
	{
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 125",
            text2       		= "Score Multipliers",
            bannerText  		= "125 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 125,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 150",
            text2       		= "Magnet Powerups",
            bannerText  		= "150 Magnets",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Magnets Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 150,
		},       
	}
},

{
	name  = "73",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Boost Through X Enemies
	--// Boost Through X Obstacles
	--// Collect X Boosts
      
	{
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "2500 Enemies",
            bannerText  		= "Boosted through 2500 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 2500,
		},
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "50 Obstacles",
            bannerText  		= "50 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 50,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x75",
            bannerText  		= "Collected Boost x75",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 75,
		},       
	}
},

{
	name  = "74",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Kill X Enemies with Double Shot
	--// Kill X Enemies With Multiplier Active
	--// Get Multiplier to x5
      
	{
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 2,000 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 2,000 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed with Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative          = true,
            objective   		= 2000,
		},	
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 1,000 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "1,000 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed with Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 1000,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},      
    }
},

{
	name  = "75",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Avoid X Obstacles
	--// Avoid X Missiles
	--// Drive X Meters Without Taking Damage
      
	{
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 300 Obstacles",
            bannerText  		= "300 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 300,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 500 Missiles",
            bannerText  		= "500 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 500,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 16,000m Without",
            text2       		= "Taking Damage",
            bannerText  		= "16000m, Zero Damage",
            twoLinePause        = true,
            pauseText1  		= "Drive 16,000m Without",
            pauseText2  		= "Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 16000,
		},     
	}
},

--//////////////////////////////////////////////
--// RECCURING MISSIONS 76-90
--//////////////////////////////////////////////	

{
    name  = "76",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Enemies
    --// Boost Through X Obstacles
    --// Collect X Coins
	
    {
        {
            factory     		= MissionGoalKill,
            text                = "Destroy 5,000 Enemies",
            bannerText  		= "5,000 Enemies Destroyed",
            twoLinePause   		= true,
            pauseText1          = " ",
            pauseText2          = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 5000,
        },
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "75 Obstacles",
            bannerText  		= "75 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 75,
        },
        {
            factory     		= MissionGoalGold,
            twoLine     		= true,
            text1       		= "Collect 7,500 Coins",
            text2       		= "with the Magnet",
            bannerText  		= "7,500 Coins Magnetized",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Coins Magnetized",
            magnet      		= true,
            cumulative  		= true,
            objective   		= 7500,
        },
    }
},

{
    name  = "77",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Gun Trucks
	--// Collect X Wrenches
	--// Score X in One Game
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 300",
            text2       		= "Gun Trucks",
            bannerText  		= "Destroyed 300 Gun Trucks",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Gun Trucks Killed",
            vicTypes    		= {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 300,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect 200 Wrenches",
            bannerText  		= "200 Wrenches Collected",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Wrenches Collected",
            cumulative  		= false,
            type        		= "wrench",
            cumulative  		= true,
            objective   		= 200,
        },
		{
            factory     		= MissionGoalScore,
				twoLine     		= true,
            text1        		= "Score 250,000",
				text2					= "in 1 Game",
            bannerText  		= "250,000 in 1 Game",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "in 1 Game",
            cumulative  		= false,
            objective   		= 250000,
		},
    }
},

{
 	name  = "78",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Double Shot
	--// Avoid X Obstacles
	--// Reach the X Meter Marker
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1             = "Kill 2,500 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 2,500 Enemies",
            twoLinePause      = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative  		= true,
            objective   		= 2500,
		},	
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 400 Obstacles",
            bannerText  		= "400 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 400,
		},
		{
            factory     		= MissionGoalDistance,
            twoLine     		= true,
            text1       		= "Reach the",
            text2       		= "30,000 Meter Marker",
            bannerText  		= "30,000 Meters Reached",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Meters Reached",
            cumulative  		= false,
            objective   		= 30000,
		},  
    }
},

{
    name  = "79",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Change Lanes X Times
	--// Collect All Coins for X Meters
	--// Avoid X Missiles
      
    {
		{
            factory     		= MissionGoalChangeLanes,
            twoLine     		= true,
            text1       		= "Change Lanes",
            text2       		= "5,000 Times",
            bannerText  		= "5,000 Lane Changes",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Lane Changes",
            cumulative  		= true,
            objective   		= 5000,
        },
		{
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 3,500 Meters",
            bannerText  		= "Coin Hoarder, 3,500m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 3,500 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 3500,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 600 Missiles",
            bannerText  		= "600 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 600,
		},
   	}
},

{
    name  = "80",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Enemies
	--// Collect X Boosts
	--// Beat Your High Score
      
    {
        {
            factory     		= MissionGoalKill,
            text                = "Destroy 5,500 Enemies",
            bannerText  		= "5,500 Enemies Destroyed",
            twoLinePause   		= true,
            pauseText1          = " ",
            pauseText2          = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 5500,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x90",
            bannerText  		= "Collected Boost x90",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 90,
		},
		{
            factory     		= MissionGoalScore,
            text        		= "Beat Your High Score",
            bannerText  		= "High Score Beaten",
            pauseText   		= "Beat Your High Score",
            hideNum     		= true,
            highScore   		= true,
            cumulative  		= false,
            objective   		= 1,
		}, 
    }
},

{
    name  = "81",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Multiplier Active
	--// Collect X Multipliers
	--// Drive X Meters Without Taking Damage
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 1,250 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "1,250 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 1250,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 150",
            text2       		= "Score Multipliers",
            bannerText  		= "150 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= " Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 150,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 18,000m Without",
            text2       		= "Taking Damage",
            bannerText  		= "18,000m, Zero Damage",
            twoLinePause      = true,
            pauseText1  		= "Drive 18,000m Without",
            pauseText2  		= "Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 18000,
		},     
    }
},

{
    name  = "82",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Tankers
	--// Collect X Magnet Powerups
	--// Reach the Top 3 on the Leaderboards
      
    {
        {
            factory     		= MissionGoalKill,
            text        		= "Destroy 175 Tankers",
            bannerText  		= "175 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes            = {"fuel_truck_a"},
            deathType   		=nil, --string or nil!
            cumulative  		= true,
            objective   		= 175,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 175",
            text2       		= "Magnet Powerups",
            bannerText  		= "175 Magnets",
            twoLinePause        = true,
            pauseText1  		= "Magnet",
            pauseText2  		= "Powerups Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 175,
		},
		{
            factory     		= MissionGoalLeaderBoard,
            twoLine     		= true,
            text1       		= "Reach Top 3",
            text2       		= "on the Leaderboard",
            bannerText  		= "Top 3 on the Leaderboard",
            twoLinePause        = true,
            pauseText1  		= "Reach Top 3",
            pauseText2  		= "on the Leaderboard",
            hideNum     		= true,
            cumulative  		= true,
            objective   		= 3,
		},
    }
},

{
    name  = "83",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Armored Trucks
	--// Have All 4 Powerups at the Same Time
	--// Sideswipe X Obstacles
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 100",
            text2       		= "Armored Trucks",
            bannerText  		= "100 Armored Trucks",
            twoLinePause        = true,
            pauseText1  		= " Armored",
            pauseText2  		= "Trucks Destroyed",
            vicTypes    		= {"armor_truck_a",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 100,
        },
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalSideswipe,
            twoLine     		= true,
            text1       		= "Sideswipe",
            text2       		= "50 Obstacles",
            bannerText  		= "50 Obstacles Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Sideswiped",
            barricade   		= true,
            cumulative  		= true,
            objective   		= 50,
		},   
    }
},

{
    name  = "84",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Score X Points Without Powerups
	--// Sideswipe X Enemies
	--// Collect All Coins for X Meters
      
    {
		{
            factory     		= MissionGoalAvoidPickups,
            twoLine     		= true,
            text1       		= "Score 40,000",
            text2       		= "without Powerups",
            bannerText  		= "Powerups Avoided, 40,000",
            twoLinePause        = true,
            pauseText1  		= "Score 40,000",
            pauseText2  		= "without Powerups",
            hideNum     		= true,
            pickups     		= {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   		= 40000,
            cumulative  		= false,
            score               = true,
		},
		{
            factory     		= MissionGoalSideswipe,
            text        		= "Sideswipe 150 Enemies",
            bannerText  		= "150 Enemies Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= " Enemies Sideswiped",
            cumulative  		= true,
            objective   		= 150,
		},
        {
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 4,000 Meters",
            bannerText  		= "Coin Hoarder, 4,000m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 4,000 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 4000,
        },
    }
},

{
    name  = "85",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Boost Through X Enemies
	--// Get Multiplier to x5
	--// Avoid the Outer Lanes for X Meters
    
    {
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "3,000 Enemies",
            bannerText  		= "Boosted through 3,000 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 3000,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},
		{
            factory     		= MissionGoalAvoidLanes,
            twoLine     		= true,
            text1       		= "Avoid the Outer Lanes",
            text2       		= "for 5,000 Meters",
            bannerText  		= "Middle Lanes, 5,000m",
            twoLinePause        = true,
            pauseText1  		= "Avoid the Outer Lanes",
            pauseText2  		= "for 5,000 Meters",
            hideNum     		= true,
            lanes       		= {1,5},
            cumulative  		= false,
            objective   		= 5000,
		},
    }
},

{
    name  = "86",
    reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Destroy X Enemies
	--// Destroy X Enemies With Tanker Explosions
	--// Destroy X Tankers
      
	{
        {
            factory     		= MissionGoalKill,
            text                = "Destroy 6,000 Enemies",
            bannerText  		= "6,000 Enemies Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 6000,
        },
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 350 Enemies",
            text2       		= "with Tanker Explosions",
            bannerText  		= "350 Enemies Exploded",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Explosions",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "area", --string or nil!
            cumulative  		= true,
            objective   		= 350,
		},
		{
            factory     		= MissionGoalKill,
            text        		= "Destroy 200 Tankers",
            bannerText  		= "200 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes    		= {"fuel_truck_a"},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 200,
		},       
	}
},

{
	name  = "87",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Have All 4 Powerups at the Same Time
	--// Collect X Multipliers
	--// Collect X Magnet Powerups
      
	{
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 175",
            text2       		= "Score Multipliers",
            bannerText  		= "175 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 175,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 200",
            text2       		= "Magnet Powerups",
            bannerText  		= "200 Magnets",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Magnets Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 200,
		},       
	}
},

{
	name  = "88",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Boost Through X Enemies
	--// Boost Through X Obstacles
	--// Collect X Boosts
      
	{
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "3,500 Enemies",
            bannerText  		= "Boosted through 3,500 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 3500,
		},
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "100 Obstacles",
            bannerText  		= "100 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 100,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x105",
            bannerText  		= "Collected Boost x105",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 105,
		},       
	}
},

{
	name  = "89",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Kill X Enemies with Double Shot
	--// Kill X Enemies With Multiplier Active
	--// Get Multiplier to x5
      
	{
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 2,750 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 2,750 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative          = true,
            objective   		= 2750,
		},	
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 1,500 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "1,500 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 1,500,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},      
    }
},

{
	name  = "90",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Avoid X Obstacles
	--// Avoid X Missiles
	--// Drive X Meters Without Taking Damage
      
	{
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 500 Obstacles",
            bannerText  		= "500 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 500,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 700 Missiles",
            bannerText  		= "700 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 700,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 20,000m Without",
            text2       		= "Taking Damage",
            bannerText  		= "20000m, Zero Damage",
            twoLinePause      = true,
            pauseText1  		= "Drive 20,000m Without",
            pauseText2  		= "Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 20000,
		},     
	}
},

--//////////////////////////////////////////////
--// RECCURING MISSIONS 91-105
--//////////////////////////////////////////////	

{
    name  = "91",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Enemies
    --// Boost Through X Obstacles
    --// Collect X Coins
	
    {
        {
            factory     		= MissionGoalKill,
            twoLine           = true,
            text1             = "Destroy 6,500",
            text2             = "Enemies",
            bannerText  		= "6,500 Enemies Destroyed",
            twoLinePause      = true,
            pauseText1        = " ",
            pauseText2        = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 6500,
        },
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "125 Obstacles",
            bannerText  		= "125 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 125,
        },
        {
            factory     		= MissionGoalGold,
            twoLine     		= true,
            text1       		= "Collect 10,000 Coins",
            text2       		= "with the Magnet",
            bannerText  		= "10,000 Coins Magnetized",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Coins Magnetized",
            magnet      		= true,
            cumulative  		= true,
            objective   		= 10000,
        },
    }
},

{
    name  = "92",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Gun Trucks
	--// Collect X Wrenches
	--// Score X in One Game
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 350",
            text2       		= "Gun Trucks",
            bannerText  		= "Destroyed 350 Gun Trucks",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Gun Trucks Killed",
            vicTypes    		= {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 350,
		},
        {
            factory     		= MissionGoalPickup,
            twoLine           = true,
            text1             = "Collect 250",
            text2             = "Wrenches",
            bannerText  		= "250 Wrenches Collected",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Wrenches Collected",
            cumulative  		= false,
            type        		= "wrench",
            cumulative  		= true,
            objective   		= 250,
        },
		{
            factory     		= MissionGoalScore,
            twoLine           = true,
            text1        		= "Score 300,000",
            text2        		= "in 1 Game",
            bannerText  		= "300,000 in 1 Game",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Points in 1 Game",
            cumulative  		= false,
            objective   		= 300000,
		},
    }
},

{
 	name  = "93",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Double Shot
	--// Avoid X Obstacles
	--// Reach the X Meter Marker
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1               = "Kill 3,000 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 3,000 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative  		= true,
            objective   		= 3000,
		},	
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 600 Obstacles",
            bannerText  		= "600 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 600,
		},
		{
            factory     		= MissionGoalDistance,
            twoLine     		= true,
            text1       		= "Reach the",
            text2       		= "35,000 Meter Marker",
            bannerText  		= "35,000 Meters Reached",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Meters Reached",
            cumulative  		= false,
            objective   		= 35000,
		},  
    }
},

{
    name  = "94",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Change Lanes X Times
	--// Collect All Coins for X Meters
	--// Avoid X Missiles
      
    {
		{
            factory     		= MissionGoalChangeLanes,
            twoLine     		= true,
            text1       		= "Change Lanes",
            text2       		= "6,000 Times",
            bannerText  		= "6,000 Lane Changes",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Lane Changes",
            cumulative  		= true,
            objective   		= 6000,
        },
		{
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 4,500 Meters",
            bannerText  		= "Coin Hoarder, 4,500m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 4,500 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 4500,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 800 Missiles",
            bannerText  		= "800 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 800,
		},
   	}
},

{
    name  = "95",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Enemies
	--// Collect X Boosts
	--// Beat Your High Score
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine           = true,
            text1             = "Destroy 7,000",
            text2             = "Enemies",
            bannerText  		= "7,000 Enemies Destroyed",
            twoLinePause      = true,
            pauseText1        = " ",
            pauseText2        = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 7000,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x120",
            bannerText  		= "Collected Boost x120",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 120,
		},
		{
            factory     		= MissionGoalScore,
            text        		= "Beat Your High Score",
            bannerText  		= "High Score Beaten",
            pauseText   		= "Beat Your High Score",
            hideNum     		= true,
            highScore   		= true,
            cumulative  		= false,
            objective   		= 1,
		}, 
    }
},

{
    name  = "96",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Multiplier Active
	--// Collect X Multipliers
	--// Drive X Meters Without Taking Damage
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 1,750 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "1,750 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 1750,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 200",
            text2       		= "Score Multipliers",
            bannerText  		= "200 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= " Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 200,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 22,000m Without",
            text2       		= "Taking Damage",
            bannerText  		= "22,000m, Zero Damage",
            twoLinePause        = true,
            pauseText1  		= "Drive 22,000m Without",
            pauseText2  		= "Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 22000,
		},     
    }
},

{
    name  = "97",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Tankers
	--// Collect X Magnet Powerups
	--// Reach the Top 3 on the Leaderboards
      
    {
        {
            factory     		= MissionGoalKill,
            text        		= "Destroy 225 Tankers",
            bannerText  		= "225 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes            = {"fuel_truck_a"},
            deathType   		=nil, --string or nil!
            cumulative  		= true,
            objective   		= 225,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 225",
            text2       		= "Magnet Powerups",
            bannerText  		= "225 Magnets",
            twoLinePause        = true,
            pauseText1  		= "Magnet",
            pauseText2  		= "Powerups Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 225,
		},
		{
            factory     		= MissionGoalLeaderBoard,
            twoLine     		= true,
            text1       		= "Reach Top 3",
            text2       		= "on the Leaderboard",
            bannerText  		= "Top 3 on the Leaderboard",
            twoLinePause        = true,
            pauseText1  		= "Reach Top 3",
            pauseText2  		= "on the Leaderboard",
            hideNum     		= true,
            cumulative  		= true,
            objective   		= 3,
		},
    }
},

{
    name  = "98",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Armored Trucks
	--// Have All 4 Powerups at the Same Time
	--// Sideswipe X Obstacles
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 125",
            text2       		= "Armored Trucks",
            bannerText  		= "125 Armored Trucks",
            twoLinePause        = true,
            pauseText1  		= " Armored",
            pauseText2  		= "Trucks Destroyed",
            vicTypes    		= {"armor_truck_a",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 125,
        },
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalSideswipe,
            twoLine     		= true,
            text1       		= "Sideswipe",
            text2       		= "60 Obstacles",
            bannerText  		= "60 Obstacles Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Sideswiped",
            barricade   		= true,
            cumulative  		= true,
            objective   		= 60,
		},   
    }
},

{
    name  = "99",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Score X Points Without Powerups
	--// Sideswipe X Enemies
	--// Collect All Coins for X Meters
      
    {
		{
            factory     		= MissionGoalAvoidPickups,
            twoLine     		= true,
            text1       		= "Score 60,000",
            text2       		= "without Powerups",
            bannerText  		= "Powerups Avoided, 60,000",
            twoLinePause        = true,
            pauseText1  		= "Score 60,000",
            pauseText2  		= "without Powerups",
            hideNum     		= true,
            pickups     		= {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   		= 60000,
            cumulative  		= false,
            score               = true,
		},
		{
            factory     		= MissionGoalSideswipe,
            text        		= "Sideswipe 175 Enemies",
            bannerText  		= "175 Enemies Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= " Enemies Sideswiped",
            cumulative  		= true,
            objective   		= 175,
		},
        {
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 5,000 Meters",
            bannerText  		= "Coin Hoarder, 5,000m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 5,000 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 5000,
        },
    }
},

{
    name  = "100",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Boost Through X Enemies
	--// Get Multiplier to x5
	--// Avoid the Outer Lanes for X Meters
    
    {
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "4,000 Enemies",
            bannerText  		= "Boosted through 4,000 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 4000,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},
		{
            factory     		= MissionGoalAvoidLanes,
            twoLine     		= true,
            text1       		= "Avoid the Outer Lanes",
            text2       		= "for 5,000 Meters",
            bannerText  		= "Middle Lanes, 5,000m",
            twoLinePause        = true,
            pauseText1  		= "Avoid the Outer Lanes",
            pauseText2  		= "for 5,000 Meters",
            hideNum     		= true,
            lanes       		= {1,5},
            cumulative  		= false,
            objective   		= 5000,
		},
    }
},

{
    name  = "101",
    reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Destroy X Enemies
	--// Destroy X Enemies With Tanker Explosions
	--// Destroy X Tankers
      
	{
        {
            factory     		= MissionGoalKill,
            twoLine           = true,
            text1             = "Destroy 7,500",
            text2             = "Enemies",
            bannerText  		= "7,500 Enemies Destroyed",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 7500,
        },
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 400 Enemies",
            text2       		= "with Tanker Explosions",
            bannerText  		= "400 Enemies Exploded",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Explosions",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "area", --string or nil!
            cumulative  		= true,
            objective   		= 400,
		},
		{
            factory     		= MissionGoalKill,
            text        		= "Destroy 250 Tankers",
            bannerText  		= "250 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes    		= {"fuel_truck_a"},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 250,
		},       
	}
},

{
	name  = "102",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Have All 4 Powerups at the Same Time
	--// Collect X Multipliers
	--// Collect X Magnet Powerups
      
	{
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 225",
            text2       		= "Score Multipliers",
            bannerText  		= "225 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 225,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 250",
            text2       		= "Magnet Powerups",
            bannerText  		= "250 Magnets",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Magnets Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 250,
		},       
	}
},

{
	name  = "103",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Boost Through X Enemies
	--// Boost Through X Obstacles
	--// Collect X Boosts
      
	{
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "4,500 Enemies",
            bannerText  		= "Boosted through 4,500 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 4500,
		},
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "150 Obstacles",
            bannerText  		= "150 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 150,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x135",
            bannerText  		= "Collected Boost x135",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 135,
		},       
	}
},

{
	name  = "104",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Kill X Enemies with Double Shot
	--// Kill X Enemies With Multiplier Active
	--// Get Multiplier to x5
      
	{
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 3,250 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 3,250 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative          = true,
            objective   		= 3250,
		},	
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 2,000 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "2,000 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 2000,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},      
    }
},

{
	name  = "105",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Avoid X Obstacles
	--// Avoid X Missiles
	--// Drive X Meters Without Taking Damage
      
	{
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 700 Obstacles",
            bannerText  		= "700 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 700,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 900 Missiles",
            bannerText  		= "900 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 900,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 24,000 Meters",
            text2       		= "Without Taking Damage",
            bannerText  		= "24000m, Zero Damage",
            twoLinePause        = true,
            pauseText1  		= "Drive 24,000 Meters",
            pauseText2  		= "Without Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 24000,
		},     
	}
},

--//////////////////////////////////////////////
--// RECCURING MISSIONS 106-120
--//////////////////////////////////////////////	

{
    name  = "106",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Enemies
    --// Boost Through X Obstacles
    --// Collect X Coins
	
    {
        {
            factory     		= MissionGoalKill,
            twoLine           = true,
            text1             = "Destroy 8,000",
            text2             = "Enemies",
            bannerText  		= "8,000 Enemies Destroyed",
            twoLinePause      = true,
            pauseText1        = " ",
            pauseText2        = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 8000,
        },
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "175 Obstacles",
            bannerText  		= "175 Obstacles Destroyed",
            twoLinePause        = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 175,
        },
        {
            factory     		= MissionGoalGold,
            twoLine     		= true,
            text1       		= "Collect 15,000 Coins",
            text2       		= "with the Magnet",
            bannerText  		= "15,000 Coins Magnetized",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Coins Magnetized",
            magnet      		= true,
            cumulative  		= true,
            objective   		= 15000,
        },
    }
},

{
    name  = "107",
    reward   = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Destroy X Gun Trucks
	--// Collect X Wrenches
	--// Score X in One Game
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 400",
            text2       		= "Gun Trucks",
            bannerText  		= "Destroyed 400 Gun Trucks",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Gun Trucks Killed",
            vicTypes    		= {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 400,
		},
        {
            factory     		= MissionGoalPickup,
            twoLine           = true,
            text1             = "Collect 300",
            text2             = "Wrenches",
            bannerText  		= "300 Wrenches Collected",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Wrenches Collected",
            cumulative  		= false,
            type        		= "wrench",
            cumulative  		= true,
            objective   		= 300,
        },
		{
            factory     		= MissionGoalScore,
            twoLine           = true,
            text1        		= "Score 400,000",
            text2        		= "in 1 Game",
            bannerText  		= "400,000 in 1 Game",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Points in 1 Game",
            cumulative  		= false,
            objective   		= 400000,
		},
    }
},

{
 	name  = "108",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Double Shot
	--// Avoid X Obstacles
	--// Reach the X Meter Marker
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1               = "Kill 3,500 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 3,500 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative  		= true,
            objective   		= 3500,
		},	
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 800 Obstacles",
            bannerText  		= "800 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 800,
		},
		{
            factory     		= MissionGoalDistance,
            twoLine     		= true,
            text1       		= "Reach the",
            text2       		= "40,000 Meter Marker",
            bannerText  		= "40,000 Meters Reached",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Meters Reached",
            cumulative  		= false,
            objective   		= 40000,
		},  
    }
},

{
    name  = "109",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Change Lanes X Times
	--// Collect All Coins for X Meters
	--// Avoid X Missiles
      
    {
		{
            factory     		= MissionGoalChangeLanes,
            twoLine     		= true,
            text1       		= "Change Lanes",
            text2       		= "7,000 Times",
            bannerText  		= "7,000 Lane Changes",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Lane Changes",
            cumulative  		= true,
            objective   		= 7000,
        },
		{
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 5,500 Meters",
            bannerText  		= "Coin Hoarder, 5,500m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 5,500 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 5500,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 1,000 Missiles",
            bannerText  		= "1,000 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 1000,
		},
   	}
},

{
    name  = "110",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Enemies
	--// Collect X Boosts
	--// Beat Your High Score
      
    {
        {
            factory     		= MissionGoalKill,
            twoLine           = true,
            text1             = "Destroy 8,500",
            text2             = "Enemies",
            bannerText  		= "8,500 Enemies Destroyed",
            twoLinePause   	= true,
            pauseText1        = " ",
            pauseText2        = "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 8500,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x150",
            bannerText  		= "Collected Boost x150",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 150,
		},
		{
            factory     		= MissionGoalScore,
            text        		= "Beat Your High Score",
            bannerText  		= "High Score Beaten",
            pauseText   		= "Beat Your High Score",
            hideNum     		= true,
            highScore   		= true,
            cumulative  		= false,
            objective   		= 1,
		}, 
    }
},
{
   name  = "111",
   reward = { gem = 0  },
   skipCost = { gold= 0 },
   final = true,
   goals =
   
   {
      {
         factory     = MissionGoalEnd,
         text        = "End",
         bannerText  = "End",
         cumulative  = false,
         objective   = 1,
      },
      {
         factory     = MissionGoalEnd,
         text        = "End",
         bannerText  = "End",
         cumulative  = false,
         objective   = 1,
      },
      {
         factory     = MissionGoalEnd,
         text        = "End",
         bannerText  = "End",
         cumulative  = false,
         objective   = 1,
      },
      
   }
},
--[[

{
    name  = "111",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Kill X Enemies with Multiplier Active
	--// Collect X Multipliers
	--// Drive X Meters Without Taking Damage
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 2,250 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "2,250 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 2250,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 250",
            text2       		= "Score Multipliers",
            bannerText  		= "250 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= " Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 250,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 26,000 Meters",
            text2       		= "Without Taking Damage",
            bannerText  		= "26,000m, Zero Damage",
            twoLinePause        = true,
            pauseText1  		= "Drive 26,000 Meters",
            pauseText2  		= "Without Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 26000,
		},     
    }
},

{
    name  = "112",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Tankers
	--// Collect X Magnet Powerups
	--// Reach the Top 3 on the Leaderboards
      
    {
        {
            factory     		= MissionGoalKill,
            text        		= "Destroy 275 Tankers",
            bannerText  		= "275 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes            = {"fuel_truck_a"},
            deathType   		=nil, --string or nil!
            cumulative  		= true,
            objective   		= 275,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 275",
            text2       		= "Magnet Powerups",
            bannerText  		= "275 Magnets",
            twoLinePause        = true,
            pauseText1  		= "Magnet",
            pauseText2  		= "Powerups Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 275,
		},
		{
            factory     		= MissionGoalLeaderBoard,
            twoLine     		= true,
            text1       		= "Reach Top 3",
            text2       		= "on the Leaderboard",
            bannerText  		= "Top 3 on the Leaderboard",
            twoLinePause        = true,
            pauseText1  		= "Reach Top 3",
            pauseText2  		= "on the Leaderboard",
            hideNum     		= true,
            cumulative  		= true,
            objective   		= 3,
		},
    }
},

{
    name  = "113",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Destroy X Armored Trucks
	--// Have All 4 Powerups at the Same Time
	--// Sideswipe X Obstacles
      
    {
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 150",
            text2       		= "Armored Trucks",
            bannerText  		= "150 Armored Trucks",
            twoLinePause        = true,
            pauseText1  		= " Armored",
            pauseText2  		= "Trucks Destroyed",
            vicTypes    		= {"armor_truck_a",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 150,
        },
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalSideswipe,
            twoLine     		= true,
            text1       		= "Sideswipe",
            text2       		= "70 Obstacles",
            bannerText  		= "70 Obstacles Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Sideswiped",
            barricade   		= true,
            cumulative  		= true,
            objective   		= 70,
		},   
    }
},

{
    name  = "114",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

	--// Score X Points Without Powerups
	--// Sideswipe X Enemies
	--// Collect All Coins for X Meters
      
    {
		{
            factory     		= MissionGoalAvoidPickups,
            twoLine     		= true,
            text1       		= "Score 80,000",
            text2       		= "without Powerups",
            bannerText  		= "Powerups Avoided, 80,000",
            twoLinePause        = true,
            pauseText1  		= "Score 80,000",
            pauseText2  		= "without Powerups",
            hideNum     		= true,
            pickups     		= {"powerup_speed_burst","powerup_scoreK","powerup_double","powerup_magnet"},
            objective   		= 80000,
            cumulative  		= false,
            score               = true,
		},
		{
            factory     		= MissionGoalSideswipe,
            text        		= "Sideswipe 200 Enemies",
            bannerText  		= "200 Enemies Sideswiped",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= " Enemies Sideswiped",
            cumulative  		= true,
            objective   		= 200,
		},
        {
            factory     		= MissionGoalCollectPickups,
            twoLine     		= true,
            text1       		= "Collect All Coins",
            text2       		= "for 6,000 Meters",
            bannerText  		= "Coin Hoarder, 6,000m",
            twoLinePause        = true,
            pauseText1  		= "Collect All Coins",
            pauseText2  		= "for 6,000 Meters",
            hideNum     		= true,
            pickups     		= {"currency",},
            cumulative  		= false,
            objective   		= 6000,
        },
    }
},

{
    name  = "115",
    reward = { gem = 10  },
    skipCost = { gold=10*1000 },
    goals =

    --// Boost Through X Enemies
	--// Get Multiplier to x5
	--// Avoid the Outer Lanes for X Meters
    
    {
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "5,000 Enemies",
            bannerText  		= "Boosted through 5,000 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 5000,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},
		{
            factory     		= MissionGoalAvoidLanes,
            twoLine     		= true,
            text1       		= "Avoid the Outer Lanes",
            text2       		= "for 5,000 Meters",
            bannerText  		= "Middle Lanes, 5,000m",
            twoLinePause        = true,
            pauseText1  		= "Avoid the Outer Lanes",
            pauseText2  		= "for 5,000 Meters",
            hideNum     		= true,
            lanes       		= {1,5},
            cumulative  		= false,
            objective   		= 5000,
		},
    }
},

{
    name  = "116",
    reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Destroy X Enemies
	--// Destroy X Enemies With Tanker Explosions
	--// Destroy X Tankers
      
	{
        {
            factory     		= MissionGoalKill,
            twoLine           = true,
            text1             = "Destroy 9,000",
            text2             = "Enemies",
            bannerText  		= "9,000 Enemies Destroyed",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Enemies Killed",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 9000,
        },
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Destroy 450 Enemies",
            text2       		= "with Tanker Explosions",
            bannerText  		= "450 Enemies Exploded",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Explosions",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "area", --string or nil!
            cumulative  		= true,
            objective   		= 450,
		},
		{
            factory     		= MissionGoalKill,
            text        		= "Destroy 300 Tankers",
            bannerText  		= "300 Tankers Destroyed",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Tankers Destroyed",
            oneShot     		= false,
            vicTypes    		= {"fuel_truck_a"},
            deathType   		= nil, --string or nil!
            cumulative  		= true,
            objective   		= 300,
		},       
	}
},

{
	name  = "117",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Have All 4 Powerups at the Same Time
	--// Collect X Multipliers
	--// Collect X Magnet Powerups
      
	{
		{
            factory     		= MissionGoalPickupStack,
            twoLine     		= true,
            text1       		= "Have all 4 Powers",
            text2       		= "at the Same Time",
            bannerText  		= "Quadruple Rainbow!",
            twoLinePause        = true,
            pauseText1  		= "Have all 4 Powers",
            pauseText2  		= "at the Same Time",
            hideNum     		= true,
            powerups    		= {"powerup_speed_burst","powerup_double","powerup_magnet","powerup_scoreK"},
            cumulative  		= false,
            objective   		= 1,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 275",
            text2       		= "Score Multipliers",
            bannerText  		= "275 Multipliers",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Multipliers Collected",
            type        		= "powerup_scoreK",
            cumulative  		= true,
            objective   		= 275,
		},
		{
            factory     		= MissionGoalPickup,
            twoLine     		= true,
            text1       		= "Collect 300",
            text2       		= "Magnet Powerups",
            bannerText  		= "300 Magnets",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Magnets Collected",
            type        		= "powerup_magnet",
            cumulative  		= true,
            objective   		= 300,
		},       
	}
},

{
	name  = "118",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Boost Through X Enemies
	--// Boost Through X Obstacles
	--// Collect X Boosts
      
	{
		{
            factory     		= MissionGoalBoostKill,
            twoLine     		= true,
            text1       		= "Boost Through",
            text2       		= "5,500 Enemies",
            bannerText  		= "Boosted through 5,500 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Boosted Through",
            cumulative  		= true,
            objective   		= 5500,
		},
        {
            factory     		= MissionGoalDestroyBarricade,
            twoLine     		= true,
            text1       		= "Boost through",
            text2       		= "200 Obstacles",
            bannerText  		= "200 Obstacles Destroyed",
            twoLinePause      = true,
            pauseText1  		= " Obstacles",
            pauseText2  		= "Boosted Through",
            hideNum     		= false,
            cumulative  		= true,
            objective   		= 200,
		},
        {
            factory     		= MissionGoalPickup,
            text              = "Collect Boost x165",
            bannerText  		= "Collected Boost x165",
            twoLinePause      = true,
            pauseText1  		= " ",
            pauseText2  		= "Boosts Collected",
            type        		= "powerup_speed_burst",
            cumulative  		= true,
            objective   		= 165,
		},       
	}
},

{
	name  = "119",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Kill X Enemies with Double Shot
	--// Kill X Enemies With Multiplier Active
	--// Get Multiplier to x5
      
	{
        {
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 3,750 Enemies",
            text2       		= "with Doubleshot",
            bannerText  		= "2 Barrels, 3,750 Enemies",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Doubleshot",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "doubleshot", --string or nil!
            cumulative          = true,
            objective   		= 3750,
		},	
		{
            factory     		= MissionGoalKill,
            twoLine     		= true,
            text1       		= "Kill 2,500 Enemies",
            text2       		= "with Multiplier Active",
            bannerText  		= "2,500 Enemies Killed",
            twoLinePause        = true,
            pauseText1  		= " Enemies",
            pauseText2  		= "Killed by Multiplier",
            vicTypes    		= {"muscle_a","wagon_a","bus_a","muscle_b","wagon_b","bus_b","muscle_c","wagon_c","bus_c","armor_truck_a","fuel_truck_a","pickup_a","pickup_b","pickup_c","sedan_a","sedan_b","sedan_c","fullsize_a","fullsize_b","fullsize_c","towtruck_a","towtruck_b","towtruck_c","dualie_a","dualie_b","dualie_c","jeep_a","jeep_b","jeep_c","apc_a","apc_b","apc_c","launcher_a","launcher_b","launcher_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   		= "multiplier", --string or nil!
            cumulative  		= true,
            objective   		= 2500,
		},
		{
            factory     		= MissionGoalMultiplier,
            text        		= "Get Multiplier to x5",
            bannerText  		= "Multiplier x5",
            pauseText   		= "Get Multiplier to x5",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 5,
		},      
    }
},

{
	name  = "120",
	reward = { gem = 10  },
	skipCost = { gold=10*1000 },
	goals =

	--// Avoid X Obstacles
	--// Avoid X Missiles
	--// Drive X Meters Without Taking Damage
      
	{
		{
            factory     		= MissionGoalAvoidBarricade,
            text        		= "Avoid 900 Obstacles",
            bannerText  		= "900 Obstacles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Obstacles Avoided",
            cumulative  		= true,
            objective   		= 900,
		},
		{
            factory     		= MissionGoalAvoidMissile,
            text        		= "Avoid 1,000 Missiles",
            bannerText  		= "1,000 Missiles Avoided",
            twoLinePause        = true,
            pauseText1  		= " ",
            pauseText2  		= "Missiles Avoided",
            cumulative  		= true,
            objective   		= 1000,
		},
		{
            factory     		= MissionGoalAvoidDamage,
            twoLine     		= true,
            text1       		= "Drive 28,000 Meters",
            text2       		= "Without Taking Damage",
            bannerText  		= "28,000m, Zero Damage",
            twoLinePause        = true,
            pauseText1  		= "Drive 28,000 Meters",
            pauseText2  		= "Without Taking Damage",
            hideNum     		= true,
            cumulative  		= false,
            objective   		= 28000,
		},     
	}
},

{
   name  = "121",
   reward = { gem = 0  },
   skipCost = { gold= 0 },
   final = true,
   goals =
   
   {
      {
         factory     = MissionGoalEnd,
         text        = "End",
         bannerText  = "End",
         cumulative  = false,
         objective   = 1,
      },
      {
         factory     = MissionGoalEnd,
         text        = "End",
         bannerText  = "End",
         cumulative  = false,
         objective   = 1,
      },
      {
         factory     = MissionGoalEnd,
         text        = "End",
         bannerText  = "End",
         cumulative  = false,
         objective   = 1,
      },
      
   }
},
]]

}

--[[


   {
      
      name  = "Junk",
      reward = { gem = 3  },
      skipCost = { gold=10*1000 },

      goals =
      
      {
         {
            factory     = MissionGoalSideswipe,
            text        = "Sideswipe 12 Enemies",
            bannerText  = "12 Enemies Sideswiped",
            pauseText   = "Enemies Sideswiped",
            cumulative  = true,
            objective   = 12,
         },
         {
            factory     = MissionGoalDaily,
            twoLine     = true,
            text1       = "Complete a",
            text2       = "Daily Mission",
            bannerText  = "Daily Mission Complete",
            twoLinePause= true,
            pauseText1  = "Complete a",
            pauseText2  = "Daily Mission",
            hideNum     = true,
            objective   = 1,
         },
         {
            factory     = MissionGoalPickup,
            text        = "Collect 3 Wrenches",
            bannerText  = "3 Wrenches Collected",
            pauseText   = "Wrenches Collected",
            cumulative  = true,
            type        = "wrench", 
            objective   = 3,
         },
         {
            factory     = MissionGoalKill,
            twoLine     = true,
            text1       = "Kill 5 Gun Trucks in 1",
            text2       = "Game without Damage",
            bannerText  = "Gun Truck Predator",
            twoLinePause= true,
            pauseText1  = "Gun Trucks in 1",
            pauseText2  = "Game without Damage",
            cumulative  = false,
            vicTypes    = {"pickup_a","pickup_b","pickup_c","dualie_a","dualie_b","dualie_c","halftrack_a","halftrack_b","halftrack_c",},
            deathType   = nil, --string or nil!
            pristine    = true,
            objective   = 5,
         },
         {
            factory     = MissionGoalUnlock,
            text        = "Unlock a new Paint Job",
            bannerText  = "Stylin'!",
            pauseText   = "Unlock a new Paint Job",
            hideNum     = true,
            item        = "paint",
            vehicle     = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalAvoidDamage,
            twoLine     = true,
            text1       = "Drive 2000 Meters",
            text2       = "Without Taking Damage",
            bannerText  = "Ironman, 2000m",
            twoLinePause= true,
            pauseText1  = "Drive 1500 Meters",
            pauseText2  = "Without Taking Damage",
            hideNum     = true,
            cumulative  = false,
            objective   = 2000,
         },
         {
            factory     = MissionGoalBoostKill,
            twoLine     = true,
            text1       = "Boost Through 15",
            text2       = "Enemies in 1 Game",
            bannerText  = "Booster Pack",
            twoLinePause= true,
            pauseText1  = "Enemies Boosted",
            pauseText2  = "Through in 1 Game",
            cumulative  = false,
            objective   = 15,
         },
         {
            factory     = MissionGoalDummy,
            twoLine     = true,
            text1       = "First Place on the",
            text2       = "Weekly Leaderboard",
            bannerText  = "First Place this Week!",
            twoLinePause= true,
            pauseText1  = "First Place on the",
            pauseText2  = "Weekly Leaderboard",
				hideNum     = true,
            cumulative  = true,
            objective   = 1,
         },
         {
            factory     = MissionGoalUpgrade,
            twoLine    = true,
            text1       = "Upgrade Your",
            text2       = "Main Weapon",
            bannerText  = "Main Weapon Upgraded",
            twoLinePause= true,
            pauseText1  = "Upgrade Your",
            pauseText2  = "Main Weapon",
            hideNum     = true,
            item        = "main-weapon",
            vehicle     = false,
				cumulative  = false,
            objective   = 1,
         },
         {
            factory     = MissionGoalUpgrade,
            twoLine    = true,
            text1       = "Purchase 1",
            text2       = "Armor Upgrade",
            bannerText  = "Armor Upgraded",
            twoLinePause= true,
            pauseText1  = "Purchase 1",
            pauseText2  = "Armor Upgrade",
            hideNum     = true,
            item        = "armor",
            vehicle     = false,
            cumulative  = true,
            objective   = 1,
         },
      }
   },
}

]]
----------------------------------------------------------------------
