----------------------------------------------------------------

require('flash/flash-manager')
require('state/state');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-image');
require('ui/ui-anim');

----------------------------------------------------------------

local SWIPE_MIN_X					= -App.viewportHeight/2;
local SWIPE_MAX_X					= App.viewportHeight/2;
local SWIPE_MIN_Y					= -App.viewportWidth/2;
local SWIPE_MAX_Y					= App.viewportWidth/2;
local SWIPE_MIN_DELTA_X			= 75;
local SWIPE_MIN_DELTA_Y			= 75;
local SWIPE_WIN_MIN_X			= -App.viewportWidth/2;
local SWIPE_WIN_MAX_X			= App.viewportWidth/2;
local SWIPE_WIN_MIN_Y			= -362;
local SWIPE_WIN_MAX_Y			= 386;
local SWIPE_BUFFER				= 70;
local SWIPE_CAR_MIN_X			= -35;
local SWIPE_CAR_MAX_X			= App.viewportWidth/2;
local MODE_TRAY_HOME_X			= -165;
local MODE_TRAY_HOME_Y			= 0;
local MODE_TRAY_SHIFT			= 350;
local SHOP_TRAY_HOME_X			= 0;
local SHOP_TRAY_HOME_Y			= 0;
local SHOP_TRAY_SHIFT			= 150;
local MODE_SHIFT					= 300;
local ITEM_HOME_X					= 150;
local ITEM_HOME_Y					= 0;
local ITEM_SPACING				= 800;
local PURCHASE_PIVOT_X			= -ITEM_HOME_X + MODE_TRAY_HOME_X;
local PURCHASE_PIVOT_Y			= -ITEM_HOME_Y + MODE_TRAY_HOME_Y;
local MODE_X						= 0;
local MODE_Y						= 240;
local PURCHASE_X					= 0;
local PURCHASE_Y					= -93;
local COST_ICON_X					= 0;
local COST_ICON_Y					= -210;
local COST_X						= 20;
local COST_Y						= -210;

local GODMODE						= false;
local PRIORTY_0					= 10;
local PRIORTY_1					= 20;
local PRIORTY_2					= 30;
local PRIORTY_3					= 40;
local PRIORTY_4					= 50;
local PRIORTY_5					= 60;
local PRIORTY_6					= 70;
local PRIORTY_7					= 80;
local PRIORTY_8					= 90;
local PRIORTY_9					= 100;
local PRIORTY_10					= 110;
local PRIORTY_11					= 120;
local PRIORTY_12					= 130;
local PRIORTY_13					= 140;
local PRIORTY_14					= 150;
local PRIORTY_15					= 160;
local PRIORTY_16					= 170;
local PRIORTY_17					= 180;
local PRIORTY_18					= 190;
local PRIORTY_19					= 200;

-- flashes per second
local FLASHING_TEXT_RATE		= 0.75;
local FLASHING_TEXT_MIN_ALPHA	= 0.25;

----------------------------------------------------------------

local Base							= State;
local StateGarage					= Base:new();
local localApp						= nil;
local localSelf					= nil;

local textureSheet 				= FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
local textureTurret				= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group3.lua", "resources/flash-resource-bundle/Group3.png", 30);
local texturePowerUp				= FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group3.lua", "resources/flash-resource-bundle/Group3.png", 30);
local maxVehicleCount;

----------------------------------------------------------------

local textureLibrary =
{
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
	{spriteSheet = nil,},
};

textureLibrary[1].spriteSheet = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group3.lua", "resources/flash-resource-bundle/Group3.png", 30);
textureLibrary[2].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[3].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[4].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[5].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[6].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[7].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[8].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[9].spriteSheet = textureLibrary[1].spriteSheet;
textureLibrary[10].spriteSheet = textureLibrary[1].spriteSheet;

local VEHICLE_DIMENSIONS =
{
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=160,	h=640,},
	{w=320,	h=640,},
};

local VEHICLE_SCALE =
{
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
};

local ARMOR_SCALE =
{
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
	{w=0.81,h=0.9,}, -- HACK: Laser v2 armor isn't scaled properly
	{w=0.9,	h=0.9,},
	{w=0.9,	h=0.9,},
};

local VEHICLE_OFFSET =
{
	{x=(VEHICLE_DIMENSIONS[1].w/2)*VEHICLE_SCALE[1].w,		y=0*VEHICLE_SCALE[1].h,	},
	{x=(VEHICLE_DIMENSIONS[2].w/2)*VEHICLE_SCALE[2].w,		y=0*VEHICLE_SCALE[2].h,	},
	{x=(VEHICLE_DIMENSIONS[3].w/2)*VEHICLE_SCALE[3].w,		y=0*VEHICLE_SCALE[3].h,	},
	{x=(VEHICLE_DIMENSIONS[4].w/2)*VEHICLE_SCALE[4].w,		y=0*VEHICLE_SCALE[4].h,	},
	{x=(VEHICLE_DIMENSIONS[4].w/2)*VEHICLE_SCALE[4].w,		y=0*VEHICLE_SCALE[4].h,	},
	{x=(VEHICLE_DIMENSIONS[1].w/2)*VEHICLE_SCALE[1].w,		y=0*VEHICLE_SCALE[1].h,	},
	{x=(VEHICLE_DIMENSIONS[2].w/2)*VEHICLE_SCALE[2].w,		y=0*VEHICLE_SCALE[2].h,	},
	{x=(VEHICLE_DIMENSIONS[3].w/2)*VEHICLE_SCALE[3].w,		y=0*VEHICLE_SCALE[3].h,	},
	{x=(VEHICLE_DIMENSIONS[4].w/2)*VEHICLE_SCALE[4].w,		y=0*VEHICLE_SCALE[4].h,	},
	{x=(VEHICLE_DIMENSIONS[4].w/2)*VEHICLE_SCALE[4].w,		y=0*VEHICLE_SCALE[4].h,	},
	{x=0,																	y=0,							},
};

local Paint_List =
{
	{
		{Name = "resources/Vehicle/Player_SportsCar/Sportscar_Blue_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar/Sportscar_Black_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar/Sportscar_Red_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar/Sportscar_Silver_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar/Sportscar_Pink_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar/Sportscar_Yellow_ArmorLevel01.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Black_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Blue_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Red_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Green_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Pink_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Teal_ArmorLevel01.png",},
	},
	
	{
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Red_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Black_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Blue_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Silver_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Purple_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Orange_ArmorLevel01.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Yellow.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Black.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Blue.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Green.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Pink.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Red.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Silver.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Black.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Red.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Green.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Blue.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Orange.png",},
	},
	{
		{Name = "resources/Vehicle/Player_SportsCar_V2/Sportscar_Base_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar_V2/Sportscar_Black_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar_V2/Sportscar_Blue_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar_V2/Sportscar_Green_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar_V2/Sportscar_Orange_ArmorLevel01.png",},
		{Name = "resources/Vehicle/Player_SportsCar_V2/Sportscar_Yellow_ArmorLevel01.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Base_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Black_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Red_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Yellow_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Purple_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Teal_ArmorLevel01.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Blue_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Black_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Red_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Silver_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Green_ArmorLevel01.png",},
		{Name = "resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Yellow_ArmorLevel01.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Silver.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Black.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Blue.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Orange.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Yellow.png",},
		{Name = "resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Red.png",},
	},
	{
		{Name = "resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Orange.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Black.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Red.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Green.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Blue.png",},
		{Name = "resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Silver.png",},
	},
	{
		{Name = "resources/UI/Player_Vehicles/PlayerVehicle_ComingSoon.png",},
		{Name = "resources/UI/Player_Vehicles/PlayerVehicle_ComingSoon.png",},
		{Name = "resources/UI/Player_Vehicles/PlayerVehicle_ComingSoon.png",},
		{Name = "resources/UI/Player_Vehicles/PlayerVehicle_ComingSoon.png",},
		{Name = "resources/UI/Player_Vehicles/PlayerVehicle_ComingSoon.png",},
		{Name = "resources/UI/Player_Vehicles/PlayerVehicle_ComingSoon.png",},
	},
};

local SideWpn_List =
{
	{Name = "Car_SportscarSideWeapon",},
	{Name = "Car_SandrailSideWeapon",},
	{Name = "Car_MissileCarSideWeapon",},
	{Name = "Car_LazerSideWeapon",},
	{Name = "Car_BlastSideWeapon",},
	{Name = "Car_SportscarSideWeapon",},
	{Name = "Car_SandrailSideWeapon",},
	{Name = "Car_MissileCarSideWeapon",},
	{Name = "Car_LazerSideWeapon",},
	{Name = "Car_BlastSideWeapon",},
	{Name = "Car_SandrailSideWeapon",},
};

local Armor_List =
{
	{
		{Name = "Car_SportscarAmor02",},
		{Name = "Car_SportscarAmor03",},
		{Name = "Car_SportscarAmor04",},
		{Name = "Car_SportscarAmor05",},
		{Name = "Car_SportscarAmor06",},
		{Name = "Car_SportscarAmor07",},
		{Name = "Car_SportscarAmor08",},
		{Name = "Car_SportscarAmor09",},
		{Name = "Car_SportscarAmor10",},
		{Name = "Car_SportscarAmor11",},
		{Name = "Car_SportscarAmor12",},
		{Name = "Car_SportscarAmor13",},
		{Name = "Car_SportscarAmor14",},
		{Name = "Car_SportscarAmor15",},
	},
	{
		{Name = "Car_SandrailAmor02",},
		{Name = "Car_SandrailAmor03",},
		{Name = "Car_SandrailAmor04",},
		{Name = "Car_SandrailAmor05",},
		{Name = "Car_SandrailAmor06",},
		{Name = "Car_SandrailAmor07",},
		{Name = "Car_SandrailAmor08",},
		{Name = "Car_SandrailAmor09",},
		{Name = "Car_SandrailAmor10",},
		{Name = "Car_SandrailAmor11",},
		{Name = "Car_SandrailAmor12",},
		{Name = "Car_SandrailAmor13",},
		{Name = "Car_SandrailAmor14",},
		{Name = "Car_SandrailAmor15",},
	},
	{
		{Name = "Car_MissileCarAmor02",},
		{Name = "Car_MissileCarAmor03",},
		{Name = "Car_MissileCarAmor04",},
		{Name = "Car_MissileCarAmor05",},
		{Name = "Car_MissileCarAmor06",},
		{Name = "Car_MissileCarAmor07",},
		{Name = "Car_MissileCarAmor08",},
		{Name = "Car_MissileCarAmor09",},
		{Name = "Car_MissileCarAmor10",},
		{Name = "Car_MissileCarAmor11",},
		{Name = "Car_MissileCarAmor12",},
		{Name = "Car_MissileCarAmor13",},
		{Name = "Car_MissileCarAmor14",},
		{Name = "Car_MissileCarAmor15",},
	},
	{
		{Name = "Car_LazerAmor02",},
		{Name = "Car_LazerAmor03",},
		{Name = "Car_LazerAmor04",},
		{Name = "Car_LazerAmor05",},
		{Name = "Car_LazerAmor06",},
		{Name = "Car_LazerAmor07",},
		{Name = "Car_LazerAmor08",},
		{Name = "Car_LazerAmor09",},
		{Name = "Car_LazerAmor10",},
		{Name = "Car_LazerAmor11",},
		{Name = "Car_LazerAmor12",},
		{Name = "Car_LazerAmor13",},
		{Name = "Car_LazerAmor14",},
		{Name = "Car_LazerAmor15",},
	},
	{
		{Name = "Car_BlastAmor02",},
		{Name = "Car_BlastAmor03",},
		{Name = "Car_BlastAmor04",},
		{Name = "Car_BlastAmor05",},
		{Name = "Car_BlastAmor06",},
		{Name = "Car_BlastAmor07",},
		{Name = "Car_BlastAmor08",},
		{Name = "Car_BlastAmor09",},
		{Name = "Car_BlastAmor10",},
		{Name = "Car_BlastAmor11",},
		{Name = "Car_BlastAmor12",},
		{Name = "Car_BlastAmor13",},
		{Name = "Car_BlastAmor14",},
		{Name = "Car_BlastAmor15",},
	},
	{
		{Name = "Car_SportscarV2Amor02",},
		{Name = "Car_SportscarV2Amor03",},
		{Name = "Car_SportscarV2Amor04",},
		{Name = "Car_SportscarV2Amor05",},
		{Name = "Car_SportscarV2Amor06",},
		{Name = "Car_SportscarV2Amor07",},
		{Name = "Car_SportscarV2Amor08",},
		{Name = "Car_SportscarV2Amor09",},
		{Name = "Car_SportscarV2Amor10",},
		{Name = "Car_SportscarV2Amor11",},
		{Name = "Car_SportscarV2Amor12",},
		{Name = "Car_SportscarV2Amor13",},
		{Name = "Car_SportscarV2Amor14",},
		{Name = "Car_SportscarV2Amor15",},
	},
	{
		{Name = "Car_SandrailV2Amor02",},
		{Name = "Car_SandrailV2Amor03",},
		{Name = "Car_SandrailV2Amor04",},
		{Name = "Car_SandrailV2Amor05",},
		{Name = "Car_SandrailV2Amor06",},
		{Name = "Car_SandrailV2Amor07",},
		{Name = "Car_SandrailV2Amor08",},
		{Name = "Car_SandrailV2Amor09",},
		{Name = "Car_SandrailV2Amor10",},
		{Name = "Car_SandrailV2Amor11",},
		{Name = "Car_SandrailV2Amor12",},
		{Name = "Car_SandrailV2Amor13",},
		{Name = "Car_SandrailV2Amor14",},
		{Name = "Car_SandrailV2Amor15",},
	},
	{
		{Name = "Car_MissilecarV2Armor02",},
		{Name = "Car_MissilecarV2Armor03",},
		{Name = "Car_MissilecarV2Armor04",},
		{Name = "Car_MissilecarV2Armor05",},
		{Name = "Car_MissilecarV2Armor06",},
		{Name = "Car_MissilecarV2Armor07",},
		{Name = "Car_MissilecarV2Armor08",},
		{Name = "Car_MissilecarV2Armor09",},
		{Name = "Car_MissilecarV2Armor10",},
		{Name = "Car_MissilecarV2Armor11",},
		{Name = "Car_MissilecarV2Armor12",},
		{Name = "Car_MissilecarV2Armor13",},
		{Name = "Car_MissilecarV2Armor14",},
		{Name = "Car_MissilecarV2Armor15",},
	},
	{
		{Name = "Car_LazerV2Amor02",},
		{Name = "Car_LazerV2Amor03",},
		{Name = "Car_LazerV2Amor04",},
		{Name = "Car_LazerV2Amor05",},
		{Name = "Car_LazerV2Amor06",},
		{Name = "Car_LazerV2Amor07",},
		{Name = "Car_LazerV2Amor08",},
		{Name = "Car_LazerV2Amor09",},
		{Name = "Car_LazerV2Amor10",},
		{Name = "Car_LazerV2Amor11",},
		{Name = "Car_LazerV2Amor12",},
		{Name = "Car_LazerV2Amor13",},
		{Name = "Car_LazerV2Amor14",},
		{Name = "Car_LazerV2Amor15",},
	},
	{
		{Name = "Car_BlastV2Amor02",},
		{Name = "Car_BlastV2Amor03",},
		{Name = "Car_BlastV2Amor04",},
		{Name = "Car_BlastV2Amor05",},
		{Name = "Car_BlastV2Amor06",},
		{Name = "Car_BlastV2Amor07",},
		{Name = "Car_BlastV2Amor08",},
		{Name = "Car_BlastV2Amor09",},
		{Name = "Car_BlastV2Amor10",},
		{Name = "Car_BlastV2Amor11",},
		{Name = "Car_BlastV2Amor12",},
		{Name = "Car_BlastV2Amor13",},
		{Name = "Car_BlastV2Amor14",},
		{Name = "Car_BlastV2Amor15",},
	},
	{
		{Name = "Car_SportscarAmor02",},
		{Name = "Car_SportscarAmor03",},
		{Name = "Car_SportscarAmor04",},
		{Name = "Car_SportscarAmor05",},
		{Name = "Car_SportscarAmor06",},
		{Name = "Car_SportscarAmor07",},
		{Name = "Car_SportscarAmor08",},
		{Name = "Car_SportscarAmor09",},
		{Name = "Car_SportscarAmor10",},
		{Name = "Car_SportscarAmor11",},
		{Name = "Car_SportscarAmor12",},
		{Name = "Car_SportscarAmor13",},
		{Name = "Car_SportscarAmor14",},
		{Name = "Car_SportscarAmor15",},
	},
};

local ARMOR_PRIORITY =
{
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3-1,	--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3-1,	--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-2,	--12
		PRIORTY_3-2,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3-1,	--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-2,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3-1,	--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3-1,	--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-2,	--12
		PRIORTY_3-2,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3-1,	--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-2,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3-2,	--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
	{
		PRIORTY_3,		--2
		PRIORTY_3,		--3
		PRIORTY_3,		--4
		PRIORTY_3,		--5
		PRIORTY_3-1,	--6
		PRIORTY_3-1,	--7
		PRIORTY_3,		--8
		PRIORTY_3-1,	--9
		PRIORTY_3-1,	--10
		PRIORTY_3+1,	--11
		PRIORTY_3-1,	--12
		PRIORTY_3-1,	--13
		PRIORTY_3-1,	--14
		PRIORTY_3-1,	--15
	},
};

local TurretWpn_List =
{
	{Name = "Car_SportscarTurretCannon",},
	{Name = "Car_SandrailTurretMagnet",},
	{Name = "Car_MissilecarTurretTwinRocket",},
	{Name = "Car_LazerTurret",},
	{Name = "Car_BlastTurret",},
	{Name = "Car_SportscarTurretCannon",},
	{Name = "Car_SandrailTurretMagnet",},
	{Name = "Car_MissilecarTurretTwinRocket",},
	{Name = "Car_LazerTurret",},
	{Name = "Car_BlastTurret",},
	{Name = "Car_SportscarTurretCannon",},
};

local VENDOR_LIST =
{
	{
		mode		= "CarMode",
		numItems	= App.data:getPlayerVehicleCount(),
	},

	{
		mode		= "FrontWeaponMode",
		numItems	= 1,
	},

	{
		mode		= "TurretMode",
		numItems	= 1,
	},

	{
		mode		= "SideWeaponMode",
		numItems	= 1,
	},

	{
		mode		= "PaintMode",
		numItems	= 1,
	},

	{
		mode		= "ArmorMode",
		numItems	= 1,
	},
};

local Icon_Vehicle =
{
	"resources/Vehicle/Player_SportsCar/Sportscar_Blue_ArmorLevel01.png",
	"resources/Vehicle/PlayerVehicle_Sandrail/Sandrail_Black_ArmorLevel01.png",
	"resources/Vehicle/PlayerVehicle_MissileCar/Missilecar_Red_ArmorLevel01.png",
	"resources/Vehicle/PlayerVehicle_LazerCar/LazerCar_Yellow.png",
	"resources/Vehicle/PlayerVehicle_BlastCar/BlastCar_Silver.png",
	"resources/Vehicle/Player_SportsCar_V2/Sportscar_Base_ArmorLevel01.png",
	"resources/Vehicle/PlayerVehicle_MagnetCar_V2/MagnetCar_Base_ArmorLevel01.png",
	"resources/Vehicle/PlayerVehicle_MissileCar_V2/MissilecarV2_Blue_ArmorLevel01.png",
	"resources/Vehicle/PlayerVehicle_LazerCarV2/LazerCarV2_Silver.png",
	"resources/Vehicle/PlayerVehicle_BlastCarV2/BlastCarV2_Orange.png",
	"resources/Vehicle/Player_SportsCar/Sportscar_Blue_ArmorLevel01.png",
};
local Icon_Vehicle_W = 64;
local Icon_Vehicle_H = 256;
local Icon_Vehicle_K = 0.6;

local Icon_MainWeapon =
{
	{
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
	{
		"Icon_Bullet_Level16",
		"Icon_Bullet_Level17",
		"Icon_Bullet_Level18",
		"Icon_Bullet_Level19",
		"Icon_Bullet_Level20",
		"Icon_Bullet_Level21",
		"Icon_Bullet_Level22",
		"Icon_Bullet_Level23",
		"Icon_Bullet_Level24",
		"Icon_Bullet_Level25",
		"Icon_Bullet_Level26",
		"Icon_Bullet_Level27",
		"Icon_Bullet_Level28",
		"Icon_Bullet_Level29",
		"Icon_Bullet_Level30",
	},
	{
		"Icon_Bullet_Level31",
		"Icon_Bullet_Level32",
		"Icon_Bullet_Level33",
		"Icon_Bullet_Level34",
		"Icon_Bullet_Level35",
		"Icon_Bullet_Level36",
		"Icon_Bullet_Level37",
		"Icon_Bullet_Level38",
		"Icon_Bullet_Level39",
		"Icon_Bullet_Level40",
		"Icon_Bullet_Level41",
		"Icon_Bullet_Level42",
		"Icon_Bullet_Level43",
		"Icon_Bullet_Level44",
		"Icon_Bullet_Level45",
	},
	{
		"Icon_Bullet_Level46",
		"Icon_Bullet_Level47",
		"Icon_Bullet_Level48",
		"Icon_Bullet_Level49",
		"Icon_Bullet_Level50",
		"Icon_Bullet_Level51",
		"Icon_Bullet_Level52",
		"Icon_Bullet_Level53",
		"Icon_Bullet_Level54",
		"Icon_Bullet_Level55",
		"Icon_Bullet_Level56",
		"Icon_Bullet_Level57",
		"Icon_Bullet_Level58",
		"Icon_Bullet_Level59",
		"Icon_Bullet_Level60",
	},
	{
		"Icon_Bullet_Level61",
		"Icon_Bullet_Level62",
		"Icon_Bullet_Level63",
		"Icon_Bullet_Level64",
		"Icon_Bullet_Level65",
		"Icon_Bullet_Level66",
		"Icon_Bullet_Level67",
		"Icon_Bullet_Level68",
		"Icon_Bullet_Level69",
		"Icon_Bullet_Level70",
		"Icon_Bullet_Level71",
		"Icon_Bullet_Level72",
		"Icon_Bullet_Level73",
		"Icon_Bullet_Level74",
		"Icon_Bullet_Level75",
	},
	{
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
	{
		"Icon_Bullet_Level16",
		"Icon_Bullet_Level17",
		"Icon_Bullet_Level18",
		"Icon_Bullet_Level19",
		"Icon_Bullet_Level20",
		"Icon_Bullet_Level21",
		"Icon_Bullet_Level22",
		"Icon_Bullet_Level23",
		"Icon_Bullet_Level24",
		"Icon_Bullet_Level25",
		"Icon_Bullet_Level26",
		"Icon_Bullet_Level27",
		"Icon_Bullet_Level28",
		"Icon_Bullet_Level29",
		"Icon_Bullet_Level30",
	},
	{
		"Icon_Bullet_Level31",
		"Icon_Bullet_Level32",
		"Icon_Bullet_Level33",
		"Icon_Bullet_Level34",
		"Icon_Bullet_Level35",
		"Icon_Bullet_Level36",
		"Icon_Bullet_Level37",
		"Icon_Bullet_Level38",
		"Icon_Bullet_Level39",
		"Icon_Bullet_Level40",
		"Icon_Bullet_Level41",
		"Icon_Bullet_Level42",
		"Icon_Bullet_Level43",
		"Icon_Bullet_Level44",
		"Icon_Bullet_Level45",
	},
	{
		"Icon_Bullet_Level46",
		"Icon_Bullet_Level47",
		"Icon_Bullet_Level48",
		"Icon_Bullet_Level49",
		"Icon_Bullet_Level50",
		"Icon_Bullet_Level51",
		"Icon_Bullet_Level52",
		"Icon_Bullet_Level53",
		"Icon_Bullet_Level54",
		"Icon_Bullet_Level55",
		"Icon_Bullet_Level56",
		"Icon_Bullet_Level57",
		"Icon_Bullet_Level58",
		"Icon_Bullet_Level59",
		"Icon_Bullet_Level60",
	},
	{
		"Icon_Bullet_Level61",
		"Icon_Bullet_Level62",
		"Icon_Bullet_Level63",
		"Icon_Bullet_Level64",
		"Icon_Bullet_Level65",
		"Icon_Bullet_Level66",
		"Icon_Bullet_Level67",
		"Icon_Bullet_Level68",
		"Icon_Bullet_Level69",
		"Icon_Bullet_Level70",
		"Icon_Bullet_Level71",
		"Icon_Bullet_Level72",
		"Icon_Bullet_Level73",
		"Icon_Bullet_Level74",
		"Icon_Bullet_Level75",
	},
	{
		"Icon_Bullet_Level61",
		"Icon_Bullet_Level62",
		"Icon_Bullet_Level63",
		"Icon_Bullet_Level64",
		"Icon_Bullet_Level65",
		"Icon_Bullet_Level66",
		"Icon_Bullet_Level67",
		"Icon_Bullet_Level68",
		"Icon_Bullet_Level69",
		"Icon_Bullet_Level70",
		"Icon_Bullet_Level71",
		"Icon_Bullet_Level72",
		"Icon_Bullet_Level73",
		"Icon_Bullet_Level74",
		"Icon_Bullet_Level75",
	},
};

local Icon_SideWeapon =
{
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level16",
		"Icon_Bullet_Level17",
		"Icon_Bullet_Level18",
		"Icon_Bullet_Level19",
		"Icon_Bullet_Level20",
		"Icon_Bullet_Level21",
		"Icon_Bullet_Level22",
		"Icon_Bullet_Level23",
		"Icon_Bullet_Level24",
		"Icon_Bullet_Level25",
		"Icon_Bullet_Level26",
		"Icon_Bullet_Level27",
		"Icon_Bullet_Level28",
		"Icon_Bullet_Level29",
		"Icon_Bullet_Level30",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level31",
		"Icon_Bullet_Level32",
		"Icon_Bullet_Level33",
		"Icon_Bullet_Level34",
		"Icon_Bullet_Level35",
		"Icon_Bullet_Level36",
		"Icon_Bullet_Level37",
		"Icon_Bullet_Level38",
		"Icon_Bullet_Level39",
		"Icon_Bullet_Level40",
		"Icon_Bullet_Level41",
		"Icon_Bullet_Level42",
		"Icon_Bullet_Level43",
		"Icon_Bullet_Level44",
		"Icon_Bullet_Level45",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level46",
		"Icon_Bullet_Level47",
		"Icon_Bullet_Level48",
		"Icon_Bullet_Level49",
		"Icon_Bullet_Level50",
		"Icon_Bullet_Level51",
		"Icon_Bullet_Level52",
		"Icon_Bullet_Level53",
		"Icon_Bullet_Level54",
		"Icon_Bullet_Level55",
		"Icon_Bullet_Level56",
		"Icon_Bullet_Level57",
		"Icon_Bullet_Level58",
		"Icon_Bullet_Level59",
		"Icon_Bullet_Level60",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level61",
		"Icon_Bullet_Level62",
		"Icon_Bullet_Level63",
		"Icon_Bullet_Level64",
		"Icon_Bullet_Level65",
		"Icon_Bullet_Level66",
		"Icon_Bullet_Level67",
		"Icon_Bullet_Level68",
		"Icon_Bullet_Level69",
		"Icon_Bullet_Level70",
		"Icon_Bullet_Level71",
		"Icon_Bullet_Level72",
		"Icon_Bullet_Level73",
		"Icon_Bullet_Level74",
		"Icon_Bullet_Level75",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level16",
		"Icon_Bullet_Level17",
		"Icon_Bullet_Level18",
		"Icon_Bullet_Level19",
		"Icon_Bullet_Level20",
		"Icon_Bullet_Level21",
		"Icon_Bullet_Level22",
		"Icon_Bullet_Level23",
		"Icon_Bullet_Level24",
		"Icon_Bullet_Level25",
		"Icon_Bullet_Level26",
		"Icon_Bullet_Level27",
		"Icon_Bullet_Level28",
		"Icon_Bullet_Level29",
		"Icon_Bullet_Level30",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level31",
		"Icon_Bullet_Level32",
		"Icon_Bullet_Level33",
		"Icon_Bullet_Level34",
		"Icon_Bullet_Level35",
		"Icon_Bullet_Level36",
		"Icon_Bullet_Level37",
		"Icon_Bullet_Level38",
		"Icon_Bullet_Level39",
		"Icon_Bullet_Level40",
		"Icon_Bullet_Level41",
		"Icon_Bullet_Level42",
		"Icon_Bullet_Level43",
		"Icon_Bullet_Level44",
		"Icon_Bullet_Level45",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level46",
		"Icon_Bullet_Level47",
		"Icon_Bullet_Level48",
		"Icon_Bullet_Level49",
		"Icon_Bullet_Level50",
		"Icon_Bullet_Level51",
		"Icon_Bullet_Level52",
		"Icon_Bullet_Level53",
		"Icon_Bullet_Level54",
		"Icon_Bullet_Level55",
		"Icon_Bullet_Level56",
		"Icon_Bullet_Level57",
		"Icon_Bullet_Level58",
		"Icon_Bullet_Level59",
		"Icon_Bullet_Level60",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level61",
		"Icon_Bullet_Level62",
		"Icon_Bullet_Level63",
		"Icon_Bullet_Level64",
		"Icon_Bullet_Level65",
		"Icon_Bullet_Level66",
		"Icon_Bullet_Level67",
		"Icon_Bullet_Level68",
		"Icon_Bullet_Level69",
		"Icon_Bullet_Level70",
		"Icon_Bullet_Level71",
		"Icon_Bullet_Level72",
		"Icon_Bullet_Level73",
		"Icon_Bullet_Level74",
		"Icon_Bullet_Level75",
	},
	{
		"Icon_SideWeapon",
		"Icon_Bullet_Level61",
		"Icon_Bullet_Level62",
		"Icon_Bullet_Level63",
		"Icon_Bullet_Level64",
		"Icon_Bullet_Level65",
		"Icon_Bullet_Level66",
		"Icon_Bullet_Level67",
		"Icon_Bullet_Level68",
		"Icon_Bullet_Level69",
		"Icon_Bullet_Level70",
		"Icon_Bullet_Level71",
		"Icon_Bullet_Level72",
		"Icon_Bullet_Level73",
		"Icon_Bullet_Level74",
		"Icon_Bullet_Level75",
	},
};

local Icon_Turret =
{
	{
		"Icon_Turret_Cannon",
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
	{
		"Icon_Turret_Magnet",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
	},
	{
		"Icon_Turret_Missile",
		"Icon_Rocket_Level01",
		"Icon_Rocket_Level02",
		"Icon_Rocket_Level03",
		"Icon_Rocket_Level04",
		"Icon_Rocket_Level05",
		"Icon_Rocket_Level06",
		"Icon_Rocket_Level07",
		"Icon_Rocket_Level08",
		"Icon_Rocket_Level09",
		"Icon_Rocket_Level10",
		"Icon_Rocket_Level11",
		"Icon_Rocket_Level12",
		"Icon_Rocket_Level13",
		"Icon_Rocket_Level14",
		"Icon_Rocket_Level15",
	},
	{
		"Icon_Turret_Missile",
		"Icon_Lazer_Level01",
		"Icon_Lazer_Level02",
		"Icon_Lazer_Level03",
		"Icon_Lazer_Level04",
		"Icon_Lazer_Level05",
		"Icon_Lazer_Level06",
		"Icon_Lazer_Level07",
		"Icon_Lazer_Level08",
		"Icon_Lazer_Level09",
		"Icon_Lazer_Level10",
		"Icon_Lazer_Level11",
		"Icon_Lazer_Level12",
		"Icon_Lazer_Level13",
		"Icon_Lazer_Level14",
		"Icon_Lazer_Level15",
	},
	{
		"Icon_Turret_Magnet",
		"Icon_Blast_Level01",
		"Icon_Blast_Level02",
		"Icon_Blast_Level03",
		"Icon_Blast_Level04",
		"Icon_Blast_Level05",
		"Icon_Blast_Level06",
		"Icon_Blast_Level07",
		"Icon_Blast_Level08",
		"Icon_Blast_Level09",
		"Icon_Blast_Level10",
		"Icon_Blast_Level11",
		"Icon_Blast_Level12",
		"Icon_Blast_Level13",
		"Icon_Blast_Level14",
		"Icon_Blast_Level15",
	},
	{
		"Icon_Turret_Cannon",
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
	{
		"Icon_Turret_Magnet",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade1",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade2",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
		"Icon_MagnetUpGrade3",
	},
	{
		"Icon_Turret_Missile",
		"Icon_Rocket_Level01",
		"Icon_Rocket_Level02",
		"Icon_Rocket_Level03",
		"Icon_Rocket_Level04",
		"Icon_Rocket_Level05",
		"Icon_Rocket_Level06",
		"Icon_Rocket_Level07",
		"Icon_Rocket_Level08",
		"Icon_Rocket_Level09",
		"Icon_Rocket_Level10",
		"Icon_Rocket_Level11",
		"Icon_Rocket_Level12",
		"Icon_Rocket_Level13",
		"Icon_Rocket_Level14",
		"Icon_Rocket_Level15",
	},
	{
		"Icon_Turret_Missile",
		"Icon_Lazer_Level01",
		"Icon_Lazer_Level02",
		"Icon_Lazer_Level03",
		"Icon_Lazer_Level04",
		"Icon_Lazer_Level05",
		"Icon_Lazer_Level06",
		"Icon_Lazer_Level07",
		"Icon_Lazer_Level08",
		"Icon_Lazer_Level09",
		"Icon_Lazer_Level10",
		"Icon_Lazer_Level11",
		"Icon_Lazer_Level12",
		"Icon_Lazer_Level13",
		"Icon_Lazer_Level14",
		"Icon_Lazer_Level15",
	},
	{
		"Icon_Turret_Magnet",
		"Icon_Blast_Level01",
		"Icon_Blast_Level02",
		"Icon_Blast_Level03",
		"Icon_Blast_Level04",
		"Icon_Blast_Level05",
		"Icon_Blast_Level06",
		"Icon_Blast_Level07",
		"Icon_Blast_Level08",
		"Icon_Blast_Level09",
		"Icon_Blast_Level10",
		"Icon_Blast_Level11",
		"Icon_Blast_Level12",
		"Icon_Blast_Level13",
		"Icon_Blast_Level14",
		"Icon_Blast_Level15",
	},
	{
		"Icon_Turret_Cannon",
		"Icon_Bullet_Level01",
		"Icon_Bullet_Level02",
		"Icon_Bullet_Level03",
		"Icon_Bullet_Level04",
		"Icon_Bullet_Level05",
		"Icon_Bullet_Level06",
		"Icon_Bullet_Level07",
		"Icon_Bullet_Level08",
		"Icon_Bullet_Level09",
		"Icon_Bullet_Level10",
		"Icon_Bullet_Level11",
		"Icon_Bullet_Level12",
		"Icon_Bullet_Level13",
		"Icon_Bullet_Level14",
		"Icon_Bullet_Level15",
	},
};

local Icon_Armor =
{
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
	"Icon_Armor",
};

local Paint_Frame		= {	file="resources/UI/PaintButton_Frame.png",			w=90,		h=80	};
local Paint_Glow		= {	file="resources/UI/PaintButton_SelectedFrame.png",	w=100,	h=90	};
local Paint_Color		= {	file="resources/UI/PaintButton_ColorSquare.png",	w=80,		h=70	};
local Paint_Stripe	= {	file="resources/UI/PaintButton_Stripes.png",			w=44,		h=66	};

local Paint_Loc =
{
	{	x=-223+170,		y=167		},	{	x=-117+170,		y=167		},
	{	x=-223+170,		y=54		},	{	x=-117+170,		y=54		},
	{	x=-223+170,		y=-57		},	{	x=-117+170,		y=-57		},
};

local Icon_Paint =
{
	-- Sports
	{
		{	color = {	r=0/255,		g=103/255,	b=220/255	},	stripe = {	r=163/255,	g=192/255,	b=226/255	}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=214/255,	g=27/255,	b=37/255		}	},
		{	color = {	r=231/255,	g=20/255,	b=14/255		},	stripe = {	r=243/255,	g=208/255,	b=1/255		}	},
		{	color = {	r=150/255,	g=150/255,	b=170/255	},	stripe = {	r=27/255,	g=231/255,	b=227/255	}	},
		{	color = {	r=229/255,	g=68/255,	b=226/255	},	stripe = {	r=152/255,	g=3/255,		b=244/255	}	},
		{	color = {	r=241/255,	g=218/255,	b=68/255		},	stripe = {	r=57/255,	g=40/255,	b=224/255	}	},
	},
	-- Magnet
	{
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=173/255,	g=173/255,	b=173/255	}	},
		{	color = {	r=18/255,	g=43/255,	b=232/255	},	stripe = {	r=138/255,	g=152/255,	b=255/255	}	},
		{	color = {	r=233/255,	g=0/255,		b=0/255		},	stripe = {	r=255/255,	g=128/255,	b=128/255	}	},
		{	color = {	r=0/255,		g=174/255,	b=32/255		},	stripe = {	r=128/255,	g=228/255,	b=146/255	}	},
		{	color = {	r=221/255,	g=85/255,	b=218/255	},	stripe = {	r=251/255,	g=191/255,	b=255/255	}	},
		{	color = {	r=57/255,	g=183/255,	b=199/255	},	stripe = {	r=159/255,	g=224/255,	b=232/255	}	},
	},
	-- Missile
	{
		{	color = {	r=255/255,	g=29/255,	b=29/255		},	stripe = {	r=255/255,	g=167/255,	b=0/255		}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=208/255,	g=36/255,	b=36/255		}	},
		{	color = {	r=82/255,	g=90/255,	b=255/255	},	stripe = {	r=186/255,	g=187/255,	b=255/255	}	},
		{	color = {	r=197/255,	g=217/255,	b=217/255	},	stripe = {	r=85/255,	g=90/255,	b=90/255		}	},
		{	color = {	r=130/255,	g=50/255,	b=220/255	},	stripe = {	r=209/255,	g=120/255,	b=244/255	}	},
		{	color = {	r=250/255,	g=133/255,	b=0/255		},	stripe = {	r=83/255,	g=50/255,	b=187/255	}	},
	},
	-- Laser
	{
		{	color = {	r=251/255,	g=251/255,	b=21/255		},	stripe = {	r=128/255,	g=179/255,	b=252/255	}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=58/255,	g=246/255,	b=255/255	}	},
		{	color = {	r=84/255,	g=117/255,	b=252/255	},	stripe = {	r=197/255,	g=70/255,	b=61/255		}	},
		{	color = {	r=164/255,	g=247/255,	b=89/255		},	stripe = {	r=249/255,	g=244/255,	b=33/255		}	},
		{	color = {	r=232/255,	g=112/255,	b=253/255	},	stripe = {	r=153/255,	g=98/255,	b=251/255	}	},
		{	color = {	r=228/255,	g=78/255,	b=65/255		},	stripe = {	r=252/255,	g=232/255,	b=230/255	}	},
	},
	-- Blast
	{
		{	color = {	r=214/255,	g=249/255,	b=249/255	},	stripe = {	r=85/255,	g=118/255,	b=230/255	}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=146/255,	g=19/255,	b=19/255		}	},
		{	color = {	r=254/255,	g=49/255,	b=0/255		},	stripe = {	r=239/255,	g=158/255,	b=151/255	}	},
		{	color = {	r=0/255,		g=237/255,	b=0/255		},	stripe = {	r=145/255,	g=226/255,	b=0/255		}	},
		{	color = {	r=0/255,		g=120/255,	b=255/255	},	stripe = {	r=15/255,	g=175/255,	b=246/255	}	},
		{	color = {	r=255/255,	g=114/255,	b=0/255		},	stripe = {	r=255/255,	g=184/255,	b=0/255		}	},
	},
	-- Sports Mk2
	{
		{	color = {	r=209/255,	g=1/255,		b=1/255		},	stripe = {	r=209/255,	g=1/255,		b=1/255		}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=214/255,	g=0/255,		b=26/255		}	},
		{	color = {	r=63/255,	g=139/255,	b=228/255	},	stripe = {	r=155/255,	g=192/255,	b=233/255	}	},
		{	color = {	r=27/255,	g=209/255,	b=57/255		},	stripe = {	r=65/255,	g=65/255,	b=65/255		}	},
		{	color = {	r=237/255,	g=132/255,	b=81/255		},	stripe = {	r=177/255,	g=171/255,	b=177/255	}	},
		{	color = {	r=236/255,	g=234/255,	b=49/255		},	stripe = {	r=255/255,	g=253/255,	b=232/255	}	},
	},
	-- Magnet Mk2
	{
		{	color = {	r=74/255,	g=113/255,	b=214/255	},	stripe = {	r=230/255,	g=230/255,	b=230/255	}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=255/255,	g=126/255,	b=20/255	}	},
		{	color = {	r=174/255,	g=174/255,	b=174/255	},	stripe = {	r=230/255,	g=20/255,	b=0/255		}	},
		{	color = {	r=244/255,	g=179/255,	b=98/255		},	stripe = {	r=45/255,	g=75/255,	b=117/255	}	},
		{	color = {	r=147/255,	g=118/255,	b=215/255	},	stripe = {	r=251/255,	g=216/255,	b=126/255	}	},
		{	color = {	r=105/255,	g=204/255,	b=206/255	},	stripe = {	r=240/255,	g=240/255,	b=240/255	}	},
	},
	-- Missile Mk2
	{
		{	color = {	r=95/255,	g=136/255,	b=231/255	},	stripe = {	r=240/255,	g=79/255,	b=43/255		}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=64/255,	g=56/255,	b=232/255	}	},
		{	color = {	r=209/255,	g=1/255,		b=1/255		},	stripe = {	r=212/255,	g=212/255,	b=212/255	}	},
		{	color = {	r=189/255,	g=189/255,	b=189/255	},	stripe = {	r=255/255,	g=48/255,	b=48/255		}	},
		{	color = {	r=126/255,	g=235/255,	b=64/255		},	stripe = {	r=191/255,	g=160/255,	b=109/255	}	},
		{	color = {	r=237/255,	g=194/255,	b=66/255		},	stripe = {	r=65/255,	g=65/255,	b=65/255	}	},
	},
	-- Laser Mk2
	{
		{	color = {	r=207/255,	g=207/255,	b=207/255	},	stripe = {	r=1/255,		g=247/255,	b=235/255	}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=4/255,		g=255/255,	b=0/255		}	},
		{	color = {	r=23/255,	g=62/255,	b=217/255	},	stripe = {	r=0/255,		g=255/255,	b=143/255	}	},
		{	color = {	r=217/255,	g=120/255,	b=23/255		},	stripe = {	r=71/255,	g=160/255,	b=255/255	}	},
		{	color = {	r=240/255,	g=232/255,	b=51/255		},	stripe = {	r=252/255,	g=114/255,	b=0/255		}	},
		{	color = {	r=209/255,	g=1/255,		b=1/255		},	stripe = {	r=255/255,	g=255/255,	b=255/255	}	},
	},
	-- Blast Mk2
	{
		{	color = {	r=255/255,	g=114/255,	b=0/255		},	stripe = {	r=41/255,	g=81/255,	b=255/255	}	},
		{	color = {	r=65/255,	g=65/255,	b=65/255		},	stripe = {	r=255/255,	g=117/255,	b=26/255		}	},
		{	color = {	r=254/255,	g=49/255,	b=0/255		},	stripe = {	r=247/255,	g=200/255,	b=79/255		}	},
		{	color = {	r=0/255,		g=237/255,	b=0/255		},	stripe = {	r=65/255,	g=65/255,	b=65/255		}	},
		{	color = {	r=0/255,		g=120/255,	b=255/255	},	stripe = {	r=255/255,	g=255/255,	b=255/255	}	},
		{	color = {	r=214/255,	g=249/255,	b=249/255	},	stripe = {	r=46/255,	g=92/255,	b=171/255	}	},
	},
	-- Coming Soon
	{
		{	color = {	r=1.0,		g=1.0,		b=1.0		},		stripe = {	r=1.0,		g=1.0,		b=1.0		}	},
		{	color = {	r=1.0,		g=1.0,		b=1.0		},		stripe = {	r=1.0,		g=1.0,		b=1.0		}	},
		{	color = {	r=1.0,		g=1.0,		b=1.0		},		stripe = {	r=1.0,		g=1.0,		b=1.0		}	},
		{	color = {	r=1.0,		g=1.0,		b=1.0		},		stripe = {	r=1.0,		g=1.0,		b=1.0		}	},
		{	color = {	r=1.0,		g=1.0,		b=1.0		},		stripe = {	r=1.0,		g=1.0,		b=1.0		}	},
		{	color = {	r=1.0,		g=1.0,		b=1.0		},		stripe = {	r=1.0,		g=1.0,		b=1.0		}	},
	},
};

local SubCatergory_Vehicle =
{
	"Sports Car",
	"Magnet Car",
	"Missile Car",
	"Laser Car",
	"Blast Car",
	"Sports Car II",
	"Magnet Car II",
	"Missile Car II",
	"Laser Car II",
	"Blast Car II",
	"Mystery",
};

local SubCatergory_MainWeapon =
{
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
};

local SubCatergory_SideWeapon =
{
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
};

local SubCatergory_Turret =
{
	"Cannon",
	"Magnet",
	"Missile",
	"Laser",
	"Blast",
	"Cannon",
	"Magnet",
	"Missile",
	"Laser",
	"Blast",
	"Empty",
};

local SubCatergory_Armor =
{
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
	" ",
};

local SubCatergory_Paint =
{
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
	{
		"",
		"",
		"",
		"",
		"",
		"",
	},
};

local Desc_Vehicle =
{
	'<c:84c7eb>Medium-armored vehicle equipped with forward cannons<c>',
	'<c:84c7eb>Light-armored vehicle equipped with a magnet turret<c>',
	'<c:84c7eb>Medium-armored vehicle equipped with missile launchers<c>',
	'<c:84c7eb>Light-armored vehicle equipped with a laser turret<c>',
	'<c:84c7eb>Heavy-armored vehicle equipped with a mega cannon<c>',
	'<c:84c7eb>Medium-armored vehicle equipped with forward cannons<c>',
	'<c:84c7eb>Light-armored vehicle equipped with a magnet turret<c>',
	'<c:84c7eb>Medium-armored vehicle equipped with missile launchers<c>',
	'<c:84c7eb>Light-armored vehicle equipped with a laser turret<c>',
	'<c:84c7eb>Heavy-armored vehicle equipped with a mega cannon<c>',
	'<c:84c7eb>Coming\nSoon!<c>',
};

local Desc_MainWeapon =
{
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
	'<c:84c7eb>Forward-firing cannons that are upgradeable for more damage<c>',
};

local Desc_SideWeapon =
{
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
	'<c:84c7eb>Twin cannons designed to destroy adjacent enemies<c>',
};

local Desc_Turret =
{
	'<c:84c7eb>Automated weapon mounted on a 360-degree swivel<c>',
	'<c:84c7eb>Electromagnets designed to collect coins and powerups<c>',
	'<c:84c7eb>Guided high explosive missiles<c>',
	'<c:84c7eb>Laser weapon that cuts through multiple targets<c>',
	'<c:84c7eb>Mega cannon that blasts through muliple targets<c>',
	'<c:84c7eb>Automated weapon mounted on a 360-degree swivel<c>',
	'<c:84c7eb>Electromagnets designed to collect coins and powerups<c>',
	'<c:84c7eb>Guided high explosive missiles<c>',
	'<c:84c7eb>Laser weapon that cuts through multiple targets<c>',
	'<c:84c7eb>Mega cannon that blasts through muliple targets<c>',
	'<c:84c7eb>Automated weapon mounted on a 360-degree swivel<c>',
};

local Desc_Armor =
{
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
	'<c:84c7eb>Spikes and plates to reduce incoming damage<c>',
};

local Desc_Paint =
{
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
	{
		' ',
		' ',
		' ',
		' ',
		' ',
		' ',
	},
};

----------------------------------------------------------------

function  StateGarage:onLoad()

   State.onLoad( self );

   localSelf			= self;
   self.name         = "state-garage";

	maxVehicleCount	= App.data:getPlayerVehicleCount();

	--coming soon car
	--VENDOR_LIST[1].numItems = maxVehicleCount + 1;

   self.defaultFontName = "resources/font/TangoLatin.otf";

	-- background and frames
	self.BackDrop = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ItemsBackDrop", textureSheet, self.swipeDown, self.swipeOff, nil, self.swipeMove);
	self.ButtonRack = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "ItemRack3", textureSheet);
	self.ButtonRack:setPriority(PRIORTY_0);
	self.FrameOverlay = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "GarageScrollFrame", textureSheet);
	self.FrameOverlay:setPriority(PRIORTY_12);
	self.slideInBound = false;
	self.swipeOn = false;
	self.SwipeStartX = nil;
	self.SwipeStarty = nil;


	-- purchase frame
	self.PurchaseRackPivot = MOAITransform2D.new();
	self.PurchaseRackPivot:setLoc(MODE_TRAY_HOME_X, MODE_TRAY_HOME_Y);
	self.PurchaseRack = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "ItemRack2", textureSheet);
	self.PurchaseRack:setPriority(PRIORTY_10);
	self.PurchaseRack:setParent(self.PurchaseRackPivot);
	self.PurchaseButton = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "OpenAndCloseButton", textureSheet);
	self.PurchaseButton:setPriority(PRIORTY_10+1);
	self.PurchaseButton:setParent(self.PurchaseRackPivot);

	-- overlays and direction arrows
	-- Michel the detection padding is the second from the last parameter on the addwidgets for the arrow buttons
	self.ArrowUpButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ArrowUpCar", textureSheet, nil, self.RegressItemList, nil, nil, nil, nil, 25, true);
	self.ArrowUpButton:setSpan(29/30);
	self.ArrowUpButton:setMode(MOAITimer.LOOP);
	self.ArrowUpButton:setPriority(PRIORTY_10);
	self.ArrowUpButton:setVisible(false);
	self.ArrowDownButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ArrowDownCar", textureSheet, nil, self.AdvanceItemList, nil, nil, nil, nil, 25, true);
	self.ArrowDownButton:setSpan(29/30);
	self.ArrowDownButton:setMode(MOAITimer.LOOP);
	self.ArrowDownButton:setPriority(PRIORTY_10);
	self.ArrowDownButton:setVisible(false);

	-- go back
	self.BackButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ReadyButton", textureSheet, nil, self.goBack, nil, nil);
	self.BackButton:setPriority(PRIORTY_13);

	-- mode text
	self.ModeText = self:addWidget(TextBox, self.mainLayer, MODE_X, MODE_Y, 400, 156, ' ', self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
	self.ModeText:setPriority(PRIORTY_11);
	self.ModeShadowText = self:addWidget(TextBox, self.mainLayer, MODE_X + 3, MODE_Y - 3, 400, 156, ' ', self.defaultFontName, 24, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.LEFT_JUSTIFY, {0,0,0,1});
	self.ModeShadowText:setPriority(PRIORTY_11 - 1);

   if StateMgr.headerAvailable then
      self.Title = self:addWidget(Anim, self.mainLayer, 0,430,0,0, "TitleGarage", textureSheet, nil, nil, true);
      self.Title:setPriority(PRIORTY_13);
   end

   self.resourceBar = ResourceBar:new( self, 0, self:_calcHeaderLocY(), self.mainLayer, self.mainPartition  );

	-- mode misc
	self.GarageMode			= 'CarMode';
	self.prevMode				= 'CarMode';
	self.modeList				= nil;
	self._vehicleIndexMap	= App.data:getPlayerVehicleIndexMap();

	self:CreateVendorItemList();
	self:createModeButtonList();

end

----------------------------------------------------------------

function StateGarage:onActivate()

   Base.onActivate(self);

	if DroneMgr:isEnabled() and not AbTestMgr:isDroneButtonLocOnRanking() then
		-- pickup button
		self.PickUpButton = self:addWidget(ButtonImage, self.mainLayer, -215, -423, 155, 106, "resources/UI/pickup_grey.png", nil, self.goPickUp, nil, nil);
		self.PickUpButton:setPriority(PRIORTY_13);

		-- drone buttons
		self.DroneButton				= self:addWidget(ButtonImage, self.mainLayer, -41, -423, 155, 106, "resources/UI/drone_garage_grey.png", nil, self.goDrone, nil, nil);
		self.DroneButtonNewBadge	= self:addWidget(Anim, self.mainLayer, -53, 35, 0,0, "NEWShopButton", textureSheet, nil, nil, true);
		self.DroneButtonSaleBadge	= self:addWidget(Anim, self.mainLayer, -48, 31, 0,0, "SALEShopButton", textureSheet, nil, nil, true);
		self.DroneNewBadgeShdw		= self:addWidget(Image, self.mainLayer, 7, -5, 66, 25, "resources/square.png", {0, 0, 0, 0.35});
		self.DroneSaleBadgeShdw		= self:addWidget(Image, self.mainLayer, 8, -5, 80, 30, "resources/square.png", {0, 0, 0, 0.35});

		self.DroneNewBadgeShdw:setPriority(PRIORTY_13+1);
		self.DroneNewBadgeShdw:setRot(28);
		self.DroneNewBadgeShdw:setParent(self.DroneButtonNewBadge.anim);
		self.DroneSaleBadgeShdw:setPriority(PRIORTY_13+1);
		self.DroneSaleBadgeShdw:setRot(28);
		self.DroneSaleBadgeShdw:setParent(self.DroneButtonSaleBadge.anim);

		self.DroneButton:setPriority(PRIORTY_13);
		self.DroneButtonNewBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.DroneButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
		self.DroneButtonNewBadge:setPriority(PRIORTY_13+2);
		self.DroneButtonNewBadge:setVisible(false);
		self.DroneButtonSaleBadge.anim:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.DroneButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
		self.DroneButtonSaleBadge:setPriority(PRIORTY_13+2);
		self.DroneButtonSaleBadge:setVisible(false);
	else
		-- pickup button
		self.PickUpButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "7 OnPowerUpButton", textureSheet, nil, self.goPickUp, nil, nil);
		self.PickUpButton:setPriority(PRIORTY_13);
	end

   LoaderMgr:addTask( "Load Gem",      self, function () StateMgr:loadState ( "state/state-gem.lua" ) end );
   LoaderMgr:addTask( "Load Coin",     self, function () StateMgr:loadState ( "state/state-coin.lua" ) end );

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

end

----------------------------------------------------------------

function StateGarage:onFocus()

   Base.onFocus(self);

	maxVehicleCount			= App.data:getPlayerVehicleShowableCount();
	self._vehicleIndexMap	= App.data:getPlayerVehicleIndexMap();
	self._flashingTextList	= {};

	self:updateDroneArrow();
	self:recreateVehicle();

	if not self.keepRackOpen then
		self:setInitPurchaseRack();
		self:updateItemListIndexPos();
	end

   self.keepRackOpen			= nil;

	self:updatePurchaseData(self.GarageMode);
	self:updateModeButtonList();
	self:UpdateArrows();
	self:newCarBadgeCheck();

end

----------------------------------------------------------------

function StateGarage:onDataMerged()

	Base.onDataMerged(self);
   self:goBack();
   
end

----------------------------------------------------------------

function StateGarage:onLoseFocus( )

   Base.onLoseFocus(self);

	if not self.keepRackOpen then
		self.GarageMode = 'CarMode';
		self.prevMode = 'CarMode';
	end

   App.data:save();

end

----------------------------------------------------------------

function StateGarage:onUpdate( dt )

	Base.onUpdate(self, dt);

	if self.autoAdvance then
		self:autoAdvanceUpdate( dt );
	end

	if self.autoRegress then
		self:autoRegressUpdate( dt );
	end

	if self.VendorListAction then
		if not self.VendorListAction:isBusy() then
			self:MonitorListAction();
		end
	end

	if self.PurchaseRack.action then
		if not self.PurchaseRack.action:isBusy() then
			self.PurchaseRack.action = nil;
		end
	end

	if self._flashingTextList and next(self._flashingTextList) ~= nil then
		self:_updateFlashingText( dt );
	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:_getVehicleID( index )

	local i = index or 1;

	return self._vehicleIndexMap[i] or 1;

end

------------------------------------------------------------------------------------

function StateGarage:_getVehicleIndex( id )

	for k,v in pairs(self._vehicleIndexMap) do
		if v == id then
			return k;
		end
	end

	return #self._vehicleIndexMap + 1;

end

----------------------------------------------------------------

function StateGarage:updateDroneArrow()

	if not DroneMgr:isEnabled() or AbTestMgr:isDroneButtonLocOnRanking() then
		return;
	elseif DroneMgr:isDroneLevelLocked() then
		self.DroneButton:disable();
		self.DroneButton:setColor(0.35, 0.35, 0.35, 1);
	else
		self.DroneButton:enable();
		self.DroneButton:setColor(1,1,1,1);
	end

	if DroneMgr:isPurchaseAvailable() then
		self.DroneButton:swapImage("resources/UI/drone_garage_green.png");
	else
		self.DroneButton:swapImage("resources/UI/drone_garage_grey.png");
	end

	if not DroneMgr:isDroneLevelLocked() and not App.data:getValue("new-unlock-drones", false) then
		self.DroneButtonNewBadge:setVisible(true);
		self.DroneNewBadgeShdw:setVisible(true);
		self.DroneButtonSaleBadge:setVisible(false);
		self.DroneSaleBadgeShdw:setVisible(false);
	else
		self.DroneButtonNewBadge:setVisible(false);
		self.DroneNewBadgeShdw:setVisible(false);
	end

end

------------------------------------------------------------------------------------

function StateGarage:createModeButtonList()

	-- mode buttons
	local pivot, index	= self:GetItemInfo("CarMode");
	local x					= -155;
	local x2					= -317;
	local x3					= -392;


	self.FrontWeaponButton		= {};
	self.SideWeaponButton		= {};
	self.TurretButton				= {};
	self.ArmorButton				= {};
	self.PaintButton				= {};
	self.ModePurchaseElements	= {};

	for i=1,#pivot do

		local y		= -(ITEM_SPACING * (i-1));
		local vId	= self:_getVehicleID(i);

		self.FrontWeaponButton[i]	= self:addWidget(		ButtonAnim, self.mainLayer, self.mainPartition, x, y, 0,0, "2 OffFrontWeaponButton", textureSheet, nil,
																		function ()
																			if self:isModeButtonVisible(i) then
																				self:setFrontWeaponMode();
																			end
																		end,
																		nil, nil	);
		self.SideWeaponButton[i]	= self:addWidget(		ButtonAnim, self.mainLayer, self.mainPartition, x, y, 0,0, "3 OffSideWeaponButton", textureSheet, nil,
																		function ()
																			if self:isModeButtonVisible(i) then
																				self:setSideWeaponMode();
																			end
																		end,
																		nil, nil	);
		self.TurretButton[i]			= self:addWidget(		ButtonAnim, self.mainLayer, self.mainPartition, x, y, 0,0, "4 OffTurretButton", textureSheet, nil,
																		function ()
																			if self:isModeButtonVisible(i) then
																				self:setTurretMode();
																			end
																		end,
																		nil, nil	);
		self.ArmorButton[i]			= self:addWidget(		ButtonAnim, self.mainLayer, self.mainPartition, x, y, 0,0, "5 OffArmorButton", textureSheet, nil,
																		function ()
																			if self:isModeButtonVisible(i) then
																				self:setArmorMode();
																			end
																		end,
																		nil	);
		self.PaintButton[i]			= self:addWidget(		ButtonAnim, self.mainLayer, self.mainPartition, x, y, 0,0, "6 OffPaintButton", textureSheet, nil,
																		function ()
																			if self:isModeButtonVisible(i) then
																				self:setPaintMode();
																			end
																		end,
																		nil, nil	);

		self.FrontWeaponButton[i].index	= i;
		self.SideWeaponButton[i].index	= i;
		self.TurretButton[i].index			= i;
		self.ArmorButton[i].index			= i;
		self.PaintButton[i].index			= i;

		self.FrontWeaponButton[i]:setPriority(PRIORTY_1);
		self.SideWeaponButton[i]:setPriority(PRIORTY_1);
		self.TurretButton[i]:setPriority(PRIORTY_1);
		self.ArmorButton[i]:setPriority(PRIORTY_1);
		self.PaintButton[i]:setPriority(PRIORTY_1);

		self.FrontWeaponButton[i]:setParent(pivot[1]);
		self.SideWeaponButton[i]:setParent(pivot[1]);
		self.TurretButton[i]:setParent(pivot[1]);
		self.ArmorButton[i]:setParent(pivot[1]);
		self.PaintButton[i]:setParent(pivot[1]);

		self.ModePurchaseElements[i]							= self:buildPurchaseData(pivot[1], vId, x2, y, 'CarMode');

		self.ModePurchaseElements[i].mainLevelPips		= self:_buildLevelPips(pivot[1], App.data:getPlayerMainWeaponMaxLevel(vId), x3, y+249);
		self.ModePurchaseElements[i].sideLevelPips		= self:_buildLevelPips(pivot[1], App.data:getPlayerSideWeaponMaxLevel(vId), x3, y-20);
		self.ModePurchaseElements[i].turretLevelPips		= self:_buildLevelPips(pivot[1], App.data:getPlayerTurretWeaponMaxLevel(vId), x3, y-154);
		self.ModePurchaseElements[i].armorLevelPips		= self:_buildLevelPips(pivot[1], App.data:getPlayerArmorMaxLevel(vId), x3, y+116);

		self.ModePurchaseElements[i].modeTitle:setLoc(x2, MODE_Y + y);
		self.ModePurchaseElements[i].actionText:setLoc(x2, PURCHASE_Y + y);
		self.ModePurchaseElements[i].prereqText:setLoc(x2, COST_Y + y);
		self.ModePurchaseElements[i].costIcon:setLoc(x2, COST_ICON_Y + y);
		self.ModePurchaseElements[i].cost:setLoc(x2+20, COST_Y + y);
		self.ModePurchaseElements[i].costShdw:setLoc(x2+20+2, COST_Y + y-2);

	end

	self.modeList =
	{
		self.FrontWeaponButton,
		self.SideWeaponButton,
		self.TurretButton,
		self.ArmorButton,
		self.PaintButton,
	};

	--Disabled because of AB test
	--If this is call too early it will eventually request the price to
	--unlock a vehicle which is part of an AB test
	--and we might not have downloaded the cloud file yet
	--so postpone until onFocus
	--self:updateModeButtonList();

end

----------------------------------------------------------------

function StateGarage:isModeButtonVisible( index )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == self.GarageMode then

--			print("StateGarage:isModeButtonVisible", self.GarageMode, i, self:_getVehicleID(i), maxVehicleCount, index);

			if i > maxVehicleCount then
				return false;
			end

			if not App.data:isPlayerVehicleUnlocked(self:_getVehicleID(i)) then
				return false;
			end

			if self.VendorList[i].index == index then
				return true;
			else
				return false;
			end
		end
	end

	return false;

end

----------------------------------------------------------------

function StateGarage:_buildLevelPips( pivot, maxLevel, x, y )

	local tempTable	= {};
	local pipWidth		= 10;

	for i=1,maxLevel do

		local x2 = x + (pipWidth/2) + (pipWidth*(i - 1));

		tempTable[i] = self:addWidget(Anim, self.mainLayer, x2, y, 0,0, "PipsButtons", textureSheet);
		tempTable[i]:setPriority(PRIORTY_2);
		tempTable[i]:setParent(pivot);

	end

	return tempTable;

end

----------------------------------------------------------------

function StateGarage:_updateModePips( pips, currentLevel )

	local count = currentLevel;

	for i=1,#pips do
		if count > 0 then
			pips[i]:apply(5/30);

			count = count - 1;
		else
			pips[i]:apply(0);
		end
	end

end

----------------------------------------------------------------

function StateGarage:updateModeButtonList()

	local pivot, index	= self:GetItemInfo("CarMode");
	local vehicleIndex	= App.data:getCurrentPlayerVehicle();
	local canBuy			= false;

	-- test front weapon
	canBuy = false;

	if App.data:canUpgradePlayerMainWeapon(vehicleIndex) and ( App.data:getCurrentMainWeaponLevel() < App.data:getPlayerMainWeaponMaxLevel(vehicleIndex)) then
		canBuy = true;
	end

	if canBuy then
		for i=1,#pivot do
			if self.FrontWeaponButton[i]:getAnimName() ~= '2 OnFrontWeaponButton' then
				self.FrontWeaponButton[i]:swapAnim('2 OnFrontWeaponButton');
				self.FrontWeaponButton[i]:setPriority(PRIORTY_1);
				self.FrontWeaponButton[i]:setParent(pivot[1]);
			end
		end
	else
		for i=1,#pivot do
			if self.FrontWeaponButton[i]:getAnimName() ~= '2 OffFrontWeaponButton' then
				self.FrontWeaponButton[i]:swapAnim('2 OffFrontWeaponButton');
				self.FrontWeaponButton[i]:setPriority(PRIORTY_1);
				self.FrontWeaponButton[i]:setParent(pivot[1]);
			end
		end
	end

	-- test side weapon
	canBuy = false;

	if App.data:canUpgradePlayerSideWeapon(vehicleIndex) and ( App.data:getCurrentSideWeaponLevel() < App.data:getPlayerSideWeaponMaxLevel(vehicleIndex)) then
		canBuy = true;
	end

	if canBuy then
		for i=1,#pivot do
			if self.SideWeaponButton[i]:getAnimName() ~= '3 OnSideWeaponButton' then
				self.SideWeaponButton[i]:swapAnim('3 OnSideWeaponButton');
				self.SideWeaponButton[i]:setPriority(PRIORTY_1);
				self.SideWeaponButton[i]:setParent(pivot[1]);
			end
		end
	else
		for i=1,#pivot do
			if self.SideWeaponButton[i]:getAnimName() ~= '3 OffSideWeaponButton' then
				self.SideWeaponButton[i]:swapAnim('3 OffSideWeaponButton');
				self.SideWeaponButton[i]:setPriority(PRIORTY_1);
				self.SideWeaponButton[i]:setParent(pivot[1]);
			end
		end
	end

	-- test turret weapon
	canBuy = false;

	if App.data:canUpgradePlayerTurretWeapon(vehicleIndex) and ( App.data:getCurrentPlayerTurretWeaponLevel() < App.data:getPlayerTurretWeaponMaxLevel(vehicleIndex)) then
		canBuy = true;
	end

	if canBuy then
		for i=1,#pivot do
			if self.TurretButton[i]:getAnimName() ~= '4 OnTurretButton' then
				self.TurretButton[i]:swapAnim('4 OnTurretButton');
				self.TurretButton[i]:setPriority(PRIORTY_1);
				self.TurretButton[i]:setParent(pivot[1]);
			end
		end
	else
		for i=1,#pivot do
			if self.TurretButton[i]:getAnimName() ~= '4 OffTurretButton' then
				self.TurretButton[i]:swapAnim('4 OffTurretButton');
				self.TurretButton[i]:setPriority(PRIORTY_1);
				self.TurretButton[i]:setParent(pivot[1]);
			end
		end
	end

	-- test armor
	canBuy = false;

	if App.data:canUpgradePlayerArmor(vehicleIndex) and ( App.data:getCurrentArmorLevel() < App.data:getPlayerArmorMaxLevel(vehicleIndex)) then
		canBuy = true;
	end

	if canBuy then
		for i=1,#pivot do
			if self.ArmorButton[i]:getAnimName() ~= '5 OnArmorButton' then
				self.ArmorButton[i]:swapAnim('5 OnArmorButton');
				self.ArmorButton[i]:setPriority(PRIORTY_1);
				self.ArmorButton[i]:setParent(pivot[1]);
			end
		end
	else
		for i=1,#pivot do
			if self.ArmorButton[i]:getAnimName() ~= '5 OffArmorButton' then
				self.ArmorButton[i]:swapAnim('5 OffArmorButton');
				self.ArmorButton[i]:setPriority(PRIORTY_1);
				self.ArmorButton[i]:setParent(pivot[1]);
			end
		end
	end

	-- test paint
	canBuy = false;

	for i=1,6 do
		if App.data:canUnlockPlayerVehiclePaintVariant(vehicleIndex, i) and not App.data:isPlayerVehiclePaintVariantUnlocked(vehicleIndex, i) then
			canBuy = true;
		end
	end

	if canBuy then
		for i=1,#pivot do
			if self.ArmorButton[i]:getAnimName() ~= '6 OnPaintButton' then
				self.PaintButton[i]:swapAnim('6 OnPaintButton');
				self.PaintButton[i]:setPriority(PRIORTY_1);
				self.PaintButton[i]:setParent(pivot[1]);
			end
		end
	else
		for i=1,#pivot do
			if self.ArmorButton[i]:getAnimName() ~= '6 OffPaintButton' then
				self.PaintButton[i]:swapAnim('6 OffPaintButton');
				self.PaintButton[i]:setPriority(PRIORTY_1);
				self.PaintButton[i]:setParent(pivot[1]);
			end
		end
	end

	-- test Power Ups
	canBuy = false;

	for i=1,5 do
		if App.data:canAffordUpgradePickup(i) then
			canBuy = true;
		end
	end

	if canBuy and self.PickUpButton then
		if not DroneMgr:isEnabled() or AbTestMgr:isDroneButtonLocOnRanking() then
			if self.PickUpButton:getAnimName() ~= '7 OnPowerUpButton' then
				self.PickUpButton:swapAnim('7 OnPowerUpButton');
				self.PickUpButton:setPriority(PRIORTY_13);
			end
		else
			self.PickUpButton:swapImage("resources/UI/pickup_green.png");
		end
	elseif self.PickUpButton then
		if not DroneMgr:isEnabled() or AbTestMgr:isDroneButtonLocOnRanking() then
			if self.PickUpButton:getAnimName() ~= '7 OffPowerUpButton' then
				self.PickUpButton:swapAnim('7 OffPowerUpButton');
				self.PickUpButton:setPriority(PRIORTY_13);
			end
		else
			self.PickUpButton:swapImage("resources/UI/pickup_grey.png");
		end
	end

	-- update all level pips
	for i=1,maxVehicleCount do
		local vId		= self:_getVehicleID(i);
		local main		= App.data:getPlayerMainWeaponLevel(vId);
		local side		= App.data:getPlayerSideWeaponLevel(vId);
		local turret	= App.data:getPlayerTurretWeaponLevel(vId);
		local armor		= App.data:getPlayerArmorLevel(vId);

		self:_updateModePips(self.ModePurchaseElements[i].mainLevelPips, main);
		self:_updateModePips(self.ModePurchaseElements[i].sideLevelPips, side);
		self:_updateModePips(self.ModePurchaseElements[i].turretLevelPips, turret);
		self:_updateModePips(self.ModePurchaseElements[i].armorLevelPips, armor);
	end

	-- update all elements
	self:updateModePurchaseElements();

end

----------------------------------------------------------------

function StateGarage:updateModePurchaseElements()

	local pivot, index = self:GetItemInfo("CarMode");
	local x = -317;

	for i=1,#self.ModePurchaseElements do

		local y		= -(ITEM_SPACING * (i-1));
		local vId	= self:_getVehicleID(i);

		if i <= maxVehicleCount and
			App.data:isPlayerVehicleUnlocked(vId) then

			-- hide mode buttons
			for j=1,#self.modeList do
				self.modeList[j][i]:enable();
				self.modeList[j][i]:setVisible(true);
			end

			self.ModePurchaseElements[i].frame:setVisible(false);
			self.ModePurchaseElements[i].modeTitle:setVisible(false);
			self:_removeFlashingTextBox(self.ModePurchaseElements[i].actionText);
			self.ModePurchaseElements[i].actionText:setVisible(false);
			self.ModePurchaseElements[i].prereqText:setVisible(false);
			self.ModePurchaseElements[i].costIcon:setVisible(false);
			self.ModePurchaseElements[i].cost:setVisible(false);
			self.ModePurchaseElements[i].costShdw:setVisible(false);
			self.ModePurchaseElements[i].buyButton:disable();
			self.ModePurchaseElements[i].buyButton:setVisible(false);
			self.ModePurchaseElements[i].buyButtononReleasedFunc = nil;

			if self.ModePurchaseElements[i].icon and self.ModePurchaseElements[i].icon.anchor then
				self.ModePurchaseElements[i].icon.left:setVisible(false);
				self.ModePurchaseElements[i].icon.right:setVisible(false);
			end
		else

			-- hide mode buttons
			for j=1,#self.modeList do
				self.modeList[j][i]:disable();
				self.modeList[j][i]:setVisible(false);
			end

			self.ModePurchaseElements[i].frame:setVisible(true);

			local titleTxt = 'Vehicles\n'..SubCatergory_Vehicle[math.clamp(vId, 1, #SubCatergory_Vehicle)];

			self.ModePurchaseElements[i].modeTitle:setVisible(true);
			if self.ModePurchaseElements[i].modeTitle:getText(titleTxt) ~= titleTxt then
				self.ModePurchaseElements[i].modeTitle:setText(titleTxt);
			end

			-- vehicle icon
			self:_updateVehicleIcon(self.ModePurchaseElements[i].icon, vId);

			-- cost, cost icon, and buy button
			local cost		= { gold = nil, gem = nil };
			local price		= 0;

			if i > maxVehicleCount then
				self.ModePurchaseElements[i].costIcon:setVisible(false);
				self.ModePurchaseElements[i].cost:setVisible(false);
				self.ModePurchaseElements[i].costShdw:setVisible(false);
				self.ModePurchaseElements[i].buyButton:setVisible(false);
				self.ModePurchaseElements[i].buyButtononReleasedFunc = nil;
			else

				cost = App.data:getPlayerVehicleUnlockCost(vId);

				self.ModePurchaseElements[i].cost:setVisible(true);
				self.ModePurchaseElements[i].costShdw:setVisible(true);

				if cost.gold and cost.gem then
					if cost.gold > 0 then
						price = cost.gold;

						if self.ModePurchaseElements[i].cost:getText() ~= ''..cost.gold then
							self.ModePurchaseElements[i].cost:setText(''..cost.gold);
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>'..cost.gold);
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonCoin');
						self.ModePurchaseElements[i].costIcon:setScale(1.0, 1.0);
					elseif cost.gem > 0 then
						price = cost.gem;

						if self.ModePurchaseElements[i].cost:getText() ~= ''..cost.gem then
							self.ModePurchaseElements[i].cost:setText(''..cost.gem);
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>'..cost.gem);
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonGem');
						self.ModePurchaseElements[i].costIcon:setScale(0.6, 0.6);
					else

						if self.ModePurchaseElements[i].cost:getText() ~= '0' then
							self.ModePurchaseElements[i].cost:setText('0');
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>0');
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonCoin');
						self.ModePurchaseElements[i].costIcon:setScale(1.0, 1.0);
					end
				elseif cost.gold then
					if cost.gold > 0 then
						price = cost.gold;

						if self.ModePurchaseElements[i].cost:getText() ~= ''..cost.gold then
							self.ModePurchaseElements[i].cost:setText(''..cost.gold);
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>'..cost.gold);
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonCoin');
						self.ModePurchaseElements[i].costIcon:setScale(1.0, 1.0);
					else

						if self.ModePurchaseElements[i].cost:getText() ~= '0' then
							self.ModePurchaseElements[i].cost:setText('0');
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>0');
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonCoin');
						self.ModePurchaseElements[i].costIcon:setScale(1.0, 1.0);
					end
				elseif cost.gem then
					if cost.gem > 0 then
						price = cost.gem;

						if self.ModePurchaseElements[i].cost:getText()~= ''..cost.gem then
							self.ModePurchaseElements[i].cost:setText(''..cost.gem);
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>'..cost.gem);
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonGem');
						self.ModePurchaseElements[i].costIcon:setScale(0.6, 0.6);
					else

						if self.ModePurchaseElements[i].cost:getText()~= '0' then
							self.ModePurchaseElements[i].cost:setText('0');
							self.ModePurchaseElements[i].costShdw:setText('<c:000000>0');
						end

						self.ModePurchaseElements[i].costIcon:swapGraphic('BuyButtonGem');
						self.ModePurchaseElements[i].costIcon:setScale(0.6, 0.6);
					end
				end

				local offset = 20;

				if price > 99999 then
					offset = 68;
					self.ModePurchaseElements[i].cost:setGlyphScale(0.9);
					self.ModePurchaseElements[i].costShdw:setGlyphScale(0.9);
				elseif price > 9999 then
					offset = 60;
					self.ModePurchaseElements[i].cost:setGlyphScale(1.0);
					self.ModePurchaseElements[i].costShdw:setGlyphScale(1.0);
				elseif price > 999 then
					offset = 50;
					self.ModePurchaseElements[i].cost:setGlyphScale(1.1);
					self.ModePurchaseElements[i].costShdw:setGlyphScale(1.1);
				elseif price > 99 then
					offset = 40;
					self.ModePurchaseElements[i].cost:setGlyphScale(1.1);
					self.ModePurchaseElements[i].costShdw:setGlyphScale(1.1);
				elseif price > 9 then
					offset = 30;
					self.ModePurchaseElements[i].cost:setGlyphScale(1.1);
					self.ModePurchaseElements[i].costShdw:setGlyphScale(1.1);
				else
					self.ModePurchaseElements[i].cost:setGlyphScale(1.1);
					self.ModePurchaseElements[i].costShdw:setGlyphScale(1.1);
				end

				self.ModePurchaseElements[i].costIcon:setLoc(x-offset, COST_ICON_Y + y);
				self.ModePurchaseElements[i].costIcon:setPriority(PRIORTY_11+1);
				self.ModePurchaseElements[i].costIcon:setParent(pivot[1]);
				self.ModePurchaseElements[i].costIcon:setVisible(true);

				-- buy button
				local button	= 'BuyButton';

				if cost.gold and cost.gem then
					if cost.gold > 0 then
						if cost.gold > App.data:getGoldCount() then
							button = 'BuyLockButton';
						end
					elseif cost.gem > 0 then
						if cost.gem > App.data:getGemCount() then
							button = 'BuyLockButton';
						end
					else
						button = 'BuyButton';
					end
				elseif cost.gold then
					if cost.gold > App.data:getGoldCount() then
						button = 'BuyLockButton';
					else
						button = 'BuyButton';
					end
				else
					if cost.gem > App.data:getGemCount() then
						button = 'BuyLockButton';
					else
						button = 'BuyButton';
					end
				end

				self.ModePurchaseElements[i].buyButton:swapAnim(button);
				self.ModePurchaseElements[i].buyButton:setLoc(x, y);
				self.ModePurchaseElements[i].buyButton:setPriority(PRIORTY_11-1);
				self.ModePurchaseElements[i].buyButton:setParent(pivot[1]);
				self.ModePurchaseElements[i].buyButton:enable();
				self.ModePurchaseElements[i].buyButton:setVisible(true);

				self.ModePurchaseElements[i].buyButtononReleasedFunc =	function ()
																								if self:isModeButtonVisible(i) then
																									self:purchaseItem();
																								end
																							end;
			end

			-- description text
			self:_removeFlashingTextBox(self.ModePurchaseElements[i].actionText);
			if Desc_Vehicle[i] == '<c:84c7eb>Coming\nSoon!<c>' then
				self.ModePurchaseElements[i].actionText:setGlyphScale(1.0);
			else
				self.ModePurchaseElements[i].actionText:setGlyphScale(0.65);
			end

         local vDesc = Desc_Vehicle[i];

         self.ModePurchaseElements[i].actionText:setVisible(true);
         self.ModePurchaseElements[i].actionText:setText(Desc_Vehicle[i]);

         local playerLevel    = App.data:getCurrentPlayerLevel()              or 1;
         local unlockLevel    = App.data:getVehicleUnlockableLevel(vId)       or 10000;
         local earlyLevel     = App.data:getVehicleEarlyUnlockableLevel(vId)  or 10000;
         local earlyCosts     = App.data:getVehicleEarlyUnlockCostTable(vId);

			-- level prereq text
         if playerLevel < unlockLevel then

				local text = "<c:e01506>Requires\nLevel "..unlockLevel.."<c>";

            --Is there an Early access price
            if earlyLevel and earlyLevel < unlockLevel  and earlyCosts then

               local costText = tostring(earlyCosts.car);

               self.ModePurchaseElements[i].cost:setText(costText);
               self.ModePurchaseElements[i].costShdw:setText('<c:000000>'..costText);

               if playerLevel >= earlyLevel then

                  self.ModePurchaseElements[i].actionText:setText("Early Access:\nRegular price at level "..unlockLevel..".");
                  self.ModePurchaseElements[i].prereqText:setVisible(false);

               else
                  --self.ModePurchaseElements[i].actionText:setText("<c:84c7eb>Early Access:\nLevel "..earlyLevel.."<c>");
                  self.ModePurchaseElements[i].prereqText:setText("<c:e01506>Requires\nLevel "..earlyLevel.."<c>");
                  self.ModePurchaseElements[i].prereqText:setVisible(true);

                  self.ModePurchaseElements[i].buyButton:stop();
                  self.ModePurchaseElements[i].buyButton:disable();
                  self.ModePurchaseElements[i].buyButton:setVisible(false);

                  self.ModePurchaseElements[i].costIcon:setVisible(false);
                  self.ModePurchaseElements[i].cost:setVisible(false);
                  self.ModePurchaseElements[i].costShdw:setVisible(false);

               end
            else

               self.ModePurchaseElements[i].prereqText:setVisible(true);

               if Desc_Vehicle[vId] ~= '<c:84c7eb>Coming\nSoon!<c>' then
                  if self.ModePurchaseElements[i].prereqText:getText()~= text then
                     self.ModePurchaseElements[i].prereqText:setText(text);
                  end
               else
                  self.ModePurchaseElements[i].prereqText:setVisible(false);
               end

               self.ModePurchaseElements[i].costIcon:setVisible(false);
               self.ModePurchaseElements[i].cost:setVisible(false);
               self.ModePurchaseElements[i].costShdw:setVisible(false);
               self.ModePurchaseElements[i].buyButton:stop();
               self.ModePurchaseElements[i].buyButton:disable();
               self.ModePurchaseElements[i].buyButton:setVisible(false);

            end

			elseif App.data:isPlayerVehicleOnSale(vId) then
				self.ModePurchaseElements[i].actionText:setText('<c:84c7eb>Car is on sale for '..App.data:getPlayerVehicleSaleText(vId));
				self.ModePurchaseElements[i].prereqText:setVisible(false);
				self:_addFlashingTextBox(self.ModePurchaseElements[i].actionText);
			else
				self.ModePurchaseElements[i].prereqText:setVisible(false);
			end
		end

	end

end

----------------------------------------------------------------

function StateGarage:disableModeButtons()

	for i=1,#self.modeList do
		for j=1,#self.modeList[i] do
			self.modeList[i][j]:disable();
		end
	end

end

----------------------------------------------------------------

function StateGarage:enableModeButtons()

	for i=1,#self.modeList do
		for j=1,#self.modeList[i] do
			self.modeList[i][j]:enable();
		end
	end

end

----------------------------------------------------------------

function StateGarage:_addFlashingTextBox( id )

	if not self._flashingTextList then
		self._flashingTextList = {};
	end

	if id and not self._flashingTextList[id] then
		self._flashingTextList[id] = id;
	end

end

----------------------------------------------------------------

function StateGarage:_removeFlashingTextBox( id )

	if not self._flashingTextList then
		self._flashingTextList = {};
	end

	if id and self._flashingTextList[id] then
		self._flashingTextList[id] = nil;
	end

end

----------------------------------------------------------------

function StateGarage:_updateFlashingText( dt )

	if not self._flashingTextTimer then
		self._flashingTextTimer = 0;
	end

	self._flashingTextTimer = self._flashingTextTimer + FLASHING_TEXT_RATE*dt;

	if self._flashingTextTimer > 1 then
		self._flashingTextTimer = 0;
	end

	local alpha = math.clamp(self._flashingTextTimer * math.pi, 0, math.pi);

	alpha = math.mapClamped(0, FLASHING_TEXT_MIN_ALPHA, 1, 1, math.sin(alpha));

	for k,v in pairs(self._flashingTextList) do
		v:setAlpha(alpha);
	end

	alpha = nil;

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:CreateVendorItemList()

	self.VendorList						= {};
	self.VendorListAction				= nil;

	for i=1,#VENDOR_LIST do
		local temp = {}

		temp.mode				= VENDOR_LIST[i].mode;
		temp.pivots				= self:createPivots(VENDOR_LIST[i].numItems);
		temp.index				= 1;
		temp.vehicle			= {};
		temp.visObj				= nil;
		temp.txtObj				= nil;
		temp.purchasePivot	= MOAITransform2D.new();
		temp.purchase			= {};

		temp.purchasePivot:setLoc(PURCHASE_PIVOT_X, PURCHASE_PIVOT_Y);
		temp.purchasePivot:setParent(temp.pivots[1]);

		table.insert(self.VendorList, temp);
	end

	self:createPurchaseObjects();
	self:updateItemListIndexPos();
	self:createVehicle();

end

----------------------------------------------------------------

function StateGarage:createPivots( maxSize )

	local list = {}

	for i=1,maxSize do
		list[i] = MOAITransform2D.new();
		if i == 1 then
			list[i]:setLoc(ITEM_HOME_X, ITEM_HOME_Y);
		else
			list[i]:setLoc(ITEM_HOME_X, ITEM_HOME_Y - (ITEM_SPACING * (i-1)));
			list[i]:setParent(list[1]);
		end
	end

	return list;

end

----------------------------------------------------------------

function StateGarage:AddItemVisObj( mode, visObjects )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then
			self.VendorList[i].visObj = visObjects;

			return true;
		end
	end

end

----------------------------------------------------------------

function StateGarage:SwapItemVisObj( mode, visObjects )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then

			if mode == "PaintMode" then
				for j=1,#self.VendorList[i].visObj do
					self.VendorList[i].visObj[j].left:delete();
					self.VendorList[i].visObj[j].right:delete();
				end
			else
				for j=1,#self.VendorList[i].visObj do
					self.VendorList[i].visObj[j]:deleteAnim();
				end
			end

			self.VendorList[i].visObj = visObjects;

			return true;
		end
	end

end

----------------------------------------------------------------

function StateGarage:AddItemTxtObj( mode, txtObjects )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then
			self.VendorList[i].txtObj = txtObjects;

			return true;
		end
	end

end

----------------------------------------------------------------

function StateGarage:CheckValidItemMode( mode )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then
			return true;
		end
	end

	return false;

end

----------------------------------------------------------------

function StateGarage:GetItemInfo( mode )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then
			return self.VendorList[i].pivots, self.VendorList[i].index, self.VendorList[i].visObj, self.VendorList[i].vehicle, self.VendorList[i].purchasePivot, self.VendorList[i].purchase, self.VendorList[i].txtObj;
		end
	end

end


----------------------------------------------------------------

function StateGarage:BuildItemList( parentList, itemList, spriteSheet, x_offset, y_offset, graphic, isText, paintIndex, vehicleIndex )

	local prop = {};
	local x = 0 + x_offset;

	for i=1,#parentList do
		local y = y_offset - (ITEM_SPACING * (i-1));

		--print("StateGarage:BuildItemList", i, x, y, itemList[i].Name, graphic, isText, paintIndex, vehicleIndex, VEHICLE_DIMENSIONS[vehicleIndex].w, VEHICLE_DIMENSIONS[vehicleIndex].h, itemList[paintIndex].Name);

		if isText then
			prop[i] = self:addWidget(TextBox, self.mainLayer, x, y, 350, 340, ' ', self.defaultFontName, 16, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.LEFT_JUSTIFY);
			prop[i]:setPriority(PRIORTY_9 + 1);
		elseif paintIndex then
			local temp = {left=nil, right=nil};
			temp.left = self:addWidget(Image, self.mainLayer, -x, y, VEHICLE_DIMENSIONS[vehicleIndex].w, VEHICLE_DIMENSIONS[vehicleIndex].h, itemList[paintIndex].Name);
			temp.right = self:addWidget(Image, self.mainLayer, x, y, VEHICLE_DIMENSIONS[vehicleIndex].w, VEHICLE_DIMENSIONS[vehicleIndex].h, itemList[paintIndex].Name);
			temp.left:setPriority(PRIORTY_9);
			temp.right:setPriority(PRIORTY_9);
			prop[i] = temp;
		else
			prop[i] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, itemList[i].Name, spriteSheet, nil, nil, graphic);
			prop[i]:setPriority(PRIORTY_9);
		end

		if paintIndex then
			prop[i].left:setScale(VEHICLE_SCALE[vehicleIndex].w, VEHICLE_SCALE[vehicleIndex].h);
			prop[i].right:setScale(-VEHICLE_SCALE[vehicleIndex].w, VEHICLE_SCALE[vehicleIndex].h);
			prop[i].left:setParent(parentList[1]);
			prop[i].right:setParent(parentList[1]);
		else
			prop[i]:setScale(0.9, 0.9);
			prop[i]:setParent(parentList[1]);
		end

	end

	return prop;

end

----------------------------------------------------------------

function StateGarage:HideObjects( list, mode )

	if list then

		if mode == "PaintMode" then

			for i=1,#list do
				list[i].left:setVisible(false);
				list[i].right:setVisible(false);
			end
		else

			for i=1,#list do
				list[i]:setVisible(false);
			end
		end
	end

end

----------------------------------------------------------------

function StateGarage:ShowObjects( list, mode )

	if list then

		if mode == "PaintMode" then

			for i=1,#list do
				list[i].left:setVisible(true);
				list[i].right:setVisible(true);
			end
		else

			for i=1,#list do
				list[i]:setVisible(true);
			end
		end
	end

end

----------------------------------------------------------------

function StateGarage:_hideVehicleArmor( armor )

	for i=1, #armor do
		armor[i]:setVisible(false);
	end

end

----------------------------------------------------------------

function StateGarage:_showVehicleArmor( armor )

	for i=1, #armor do
		armor[i]:setVisible(true);
	end

end

----------------------------------------------------------------

function StateGarage:HideAllItemObj()

	for i=1,#self.VendorList do
		if self.VendorList[i].mode ~= "CarMode" then

			self:HideObjects(self.VendorList[i].visObj, self.VendorList[i].mode);

			if self.VendorList[i].txtObj then
				self:HideObjects(self.VendorList[i].txtObj, self.VendorList[i].mode);
			end
		end



		if self.VendorList[i].mode == "CarMode" then
			for j=1,#self.VendorList[i].vehicle do
				local locked = true;

				if		App.data:isPlayerVehicleUnlocked(j)
					or	not App.data:isPlayerVehicleLevelLocked(j)
					or	(j > maxVehicleCount) then

					locked = false;
				end

				self.VendorList[i].vehicle[j].BodyLeft:setVisible(true);
				self.VendorList[i].vehicle[j].BodyRight:setVisible(true);
				self.VendorList[i].vehicle[j].Lock:setVisible( locked );
				if self.VendorList[i].vehicle[j].Armor then
					self:_showVehicleArmor(self.VendorList[i].vehicle[j].Armor);
				end
				if self.VendorList[i].vehicle[j].SideWeapon then
					self.VendorList[i].vehicle[j].SideWeapon:setVisible(true);
				end
				if self.VendorList[i].vehicle[j].Turret then
					self.VendorList[i].vehicle[j].Turret:setVisible(true);
				end
			end
		end
	end

end

----------------------------------------------------------------

function StateGarage:ShowItemObj( mode )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == "CarMode" and mode == "CarMode" then

			for j=1,#self.VendorList[i].vehicle do
				local locked = true;

				if		App.data:isPlayerVehicleUnlocked(j)
					or	not App.data:isPlayerVehicleLevelLocked(j)
					or	(j > maxVehicleCount) then
					locked = false;
				end

				self.VendorList[i].vehicle[j].BodyLeft:setVisible(true);
				self.VendorList[i].vehicle[j].BodyRight:setVisible(true);
				self.VendorList[i].vehicle[j].Lock:setVisible( locked );
				if self.VendorList[i].vehicle[j].Armor then
					self:_showVehicleArmor(self.VendorList[i].vehicle[j].Armor);
				end
				if self.VendorList[i].vehicle[j].SideWeapon then
					self.VendorList[i].vehicle[j].SideWeapon:setVisible(true);
				end
				if self.VendorList[i].vehicle[j].Turret then
					self.VendorList[i].vehicle[j].Turret:setVisible(true);
				end
			end
		elseif self.VendorList[i].mode == mode then
			self:ShowObjects(self.VendorList[i].visObj, self.VendorList[i].mode);

			if self.VendorList[i].txtObj then
				self:ShowObjects(self.VendorList[i].txtObj, self.VendorList[i].mode);
			end
		end

		if self.VendorList[i].mode == "CarMode" and mode == "PaintMode" then
			for j=1,#self.VendorList[i].vehicle do
				self.VendorList[i].vehicle[j].BodyLeft:setVisible(false);
				self.VendorList[i].vehicle[j].BodyRight:setVisible(false);
				if self.VendorList[i].vehicle[j].Armor then
					self:_hideVehicleArmor(self.VendorList[i].vehicle[j].Armor);
				end
				if self.VendorList[i].vehicle[j].SideWeapon then
					self.VendorList[i].vehicle[j].SideWeapon:setVisible(false);
				end
				if self.VendorList[i].vehicle[j].Turret then
					self.VendorList[i].vehicle[j].Turret:setVisible(false);
				end
			end
		end
	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:createVehicle()

	local pivot, index, visObj, vehicle = self:GetItemInfo("CarMode");

	for i=1,#pivot do
		local y = -(ITEM_SPACING * (i-1));

		table.insert(vehicle, self:buildVehicle(pivot, self:_getVehicleID(i), 0, y));
	end

end

----------------------------------------------------------------

function StateGarage:buildVehicle( pivot, index, x, y )

	local vehicle	= {}
	local paintIndex;
	local armorIndex;
	local sideWpnIndex;
	local turretIndex;
	local isLocked	= true;
	local vIndex	= self:_getVehicleIndex(index);

	paintIndex = App.data:getPlayerVehiclePaintVariant(vIndex);

	if not App.data:isPlayerVehiclePaintVariantUnlocked( vIndex, paintIndex ) then
		paintIndex = 1;
	end

	if not App.data:isPlayerVehicleLevelLocked( vIndex ) or (vIndex > maxVehicleCount) then
		isLocked = false;
	end

	if App.data:isPlayerVehicleUnlocked( vIndex ) then

		isLocked = false;

		if App.data:isPlayerArmorUnlocked( vIndex ) then
			armorIndex = App.data:getPlayerArmorLevel(vIndex);
		else
			armorIndex = 0;
		end

		if App.data:isPlayerSideWeaponUnlocked( vIndex ) then
			sideWpnIndex = App.data:getPlayerSideWeaponLevel(vIndex);
		else
			sideWpnIndex = 0;
		end

		if App.data:isPlayerTurretWeaponUnlocked( vIndex ) then
			turretIndex = App.data:getPlayerTurretWeaponLevel(vIndex);
		else
			turretIndex = 0;
		end
	else
		armorIndex = 0;
		sideWpnIndex = 0;
		turretIndex = 0;
	end

   local cost = App.data:getPlayerTurretWeaponUpgradeCost(vIndex);

   if cost then

      local gold	= cost.gold or 0;
      local gem	= cost.gem or 0;

      if gold < 1 and gem < 1 and turretIndex < 1 then
         turretIndex = 1;
      end

	end

	if vIndex > App.data:getPlayerVehicleCount() then
		armorIndex = 0;
		sideWpnIndex = 0;
		turretIndex = 0;
	end

	local turretTpl	= TemplateMgr:getPlayerVehicleTurretWeapon(vIndex);

   if turretTpl and turretIndex < #turretTpl.level then

		local tpl   = turretTpl.level[turretIndex+1];

		if tpl then

			local gold	= tpl.cost.gold or 0;
			local gem	= tpl.cost.gem or 0;

			if gold < 1 and gem < 1 and turretIndex < 1 then
				turretIndex = 1;
			end
		end
	end

	vehicle.BodyLeft	= self:addWidget(Image, self.mainLayer, x-VEHICLE_OFFSET[vIndex].x, y+VEHICLE_OFFSET[vIndex].y, VEHICLE_DIMENSIONS[vIndex].w, VEHICLE_DIMENSIONS[vIndex].h, Paint_List[vIndex][paintIndex].Name);
	vehicle.BodyRight	= self:addWidget(Image, self.mainLayer, x+VEHICLE_OFFSET[vIndex].x, y+VEHICLE_OFFSET[vIndex].y, VEHICLE_DIMENSIONS[vIndex].w, VEHICLE_DIMENSIONS[vIndex].h, Paint_List[vIndex][paintIndex].Name);
	vehicle.Lock		= self:addWidget(Anim, self.mainLayer, x, y, 0, 0, 'UpGradeLocked', textureSheet);

	if armorIndex <= 1 then
		vehicle.Armor = nil;
	else
		armorIndex = armorIndex - 1;
		vehicle.Armor = {};

		for i=1,armorIndex do
			vehicle.Armor[i] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, Armor_List[vIndex][i].Name, textureLibrary[vIndex].spriteSheet);
			vehicle.Armor[i]:setPriority(ARMOR_PRIORITY[vIndex][i]);
			vehicle.Armor[i]:setScale(ARMOR_SCALE[vIndex].w, ARMOR_SCALE[vIndex].h);
			vehicle.Armor[i]:setParent(pivot[1]);
		end
	end

	if sideWpnIndex < 1 then
		vehicle.SideWeapon = nil;
	else
		vehicle.SideWeapon = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, SideWpn_List[vIndex].Name, textureLibrary[vIndex].spriteSheet);
	end

	if turretIndex < 1 then
		vehicle.Turret = nil;
	else
		vehicle.Turret = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, TurretWpn_List[vIndex].Name, textureTurret);
		vehicle.Turret:setLoc(x, y);
	end

	if vehicle.BodyLeft and vehicle.BodyRight then
		vehicle.BodyLeft:setPriority(PRIORTY_1);
		vehicle.BodyLeft:setScale(VEHICLE_SCALE[vIndex].w, VEHICLE_SCALE[vIndex].h);
		vehicle.BodyLeft:setParent(pivot[1]);
		vehicle.BodyRight:setPriority(PRIORTY_1);
		vehicle.BodyRight:setScale(-VEHICLE_SCALE[vIndex].w, VEHICLE_SCALE[vIndex].h);
		vehicle.BodyRight:setParent(pivot[1]);
		vehicle.Lock:setPriority(PRIORTY_7+1);
		vehicle.Lock:setParent(pivot[1]);
		vehicle.Lock:setVisible(isLocked);
	end

	if vehicle.SideWeapon then
		vehicle.SideWeapon:setPriority(PRIORTY_5);
		vehicle.SideWeapon:setScale(VEHICLE_SCALE[vIndex].w, VEHICLE_SCALE[vIndex].h);
		vehicle.SideWeapon:setParent(pivot[1]);
	end

	if vehicle.Turret then
		vehicle.Turret:setPriority(PRIORTY_7);
		vehicle.Turret:setScale(VEHICLE_SCALE[vIndex].w, VEHICLE_SCALE[vIndex].h);
		vehicle.Turret:setParent(pivot[1]);
	end

--	print("StateGarage:buildVehicle", vIndex, index, y, paintIndex, armorIndex, sideWpnIndex, turretIndex, Paint_List[index][paintIndex].Name, vehicle.Turret);

	return vehicle;

end

----------------------------------------------------------------

function StateGarage:updateVehicle( attribute, vehicleIndex, item, spritesheet )

	local pivot, index, visObj, vehicle = self:GetItemInfo("CarMode");
	local x,y			= vehicle[vehicleIndex].BodyLeft:getLoc();
	local armorIndex	= 0;
	local vId			= self:_getVehicleID(vehicleIndex);
	local vId2			= self:_getVehicleID(index);
	local priority;

	x = x + VEHICLE_OFFSET[vehicleIndex].x;
	y = -(ITEM_SPACING * (vehicleIndex - 1)) + VEHICLE_OFFSET[vehicleIndex].y;

	if attribute == "Body" then

		priority = PRIORTY_1;

		if			vehicle[vehicleIndex]
			and	vehicle[vehicleIndex]["BodyLeft"] and vehicle[vehicleIndex]["BodyRight"] then

			vehicle[vehicleIndex]["BodyLeft"]:swapImage(item);
			vehicle[vehicleIndex]["BodyRight"]:swapImage(item);
			vehicle[vehicleIndex]["BodyLeft"]:setVisible(false);
			vehicle[vehicleIndex]["BodyRight"]:setVisible(false);
		else
			vehicle[vehicleIndex]["BodyLeft"]	= self:addWidget(Image, self.mainLayer, x-VEHICLE_OFFSET[vId]["x"], y+VEHICLE_OFFSET[vId]["y"], VEHICLE_DIMENSIONS[vId2]["w"], VEHICLE_DIMENSIONS[vId2]["h"], item);
			vehicle[vehicleIndex]["BodyRight"]	= self:addWidget(Image, self.mainLayer, x+VEHICLE_OFFSET[vId]["x"], y+VEHICLE_OFFSET[vId]["y"], VEHICLE_DIMENSIONS[vId2]["w"], VEHICLE_DIMENSIONS[vId2]["h"], item);
			vehicle[vehicleIndex]["BodyLeft"]:setVisible(false);
			vehicle[vehicleIndex]["BodyRight"]:setVisible(false);
		end
	elseif attribute == "Armor" then

		armorIndex = App.data:getPlayerArmorLevel(vId);
		armorIndex = math.clamp(armorIndex-1, 1, #Armor_List[vId]);

		if vehicle[vehicleIndex][attribute] then
			for i=1,armorIndex do
				if vehicle[vehicleIndex][attribute][i] then
					vehicle[vehicleIndex][attribute][i]:swapAnim(Armor_List[vId][i].Name);
					vehicle[vehicleIndex][attribute][i]:setParent(pivot[1]);
				elseif not vehicle[vehicleIndex][attribute][i] then
					vehicle[vehicleIndex][attribute][i] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, Armor_List[vId][i].Name, spritesheet);
					vehicle[vehicleIndex][attribute][i]:setParent(pivot[1]);
				end
			end
		else
			vehicle[vehicleIndex][attribute] = {};
			for i=1,armorIndex do
				vehicle[vehicleIndex][attribute][i] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, Armor_List[vId][i].Name, spritesheet);
				vehicle[vehicleIndex][attribute][i]:setParent(pivot[1]);
			end
		end
	elseif attribute == "SideWeapon" then
		priority = PRIORTY_5;
		if vehicle[vehicleIndex][attribute] then
			vehicle[vehicleIndex][attribute]:swapAnim(item);
		else
			vehicle[vehicleIndex][attribute] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, item, spritesheet);
		end
	elseif attribute == "Turret" then
		priority = PRIORTY_7;
		if vehicle[vehicleIndex][attribute] then
			vehicle[vehicleIndex][attribute]:swapAnim(item);
		else
			vehicle[vehicleIndex][attribute] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, item, spritesheet);
		end
	end

	if attribute == "Body" then
		vehicle[vehicleIndex]["BodyLeft"]:setScale(VEHICLE_SCALE[vId].w, VEHICLE_SCALE[vId].h);
		vehicle[vehicleIndex]["BodyLeft"]:setParent(pivot[1]);
		vehicle[vehicleIndex]["BodyLeft"]:setPriority(priority);
		vehicle[vehicleIndex]["BodyRight"]:setScale(-VEHICLE_SCALE[vId].w, VEHICLE_SCALE[vId].h);
		vehicle[vehicleIndex]["BodyRight"]:setParent(pivot[1]);
		vehicle[vehicleIndex]["BodyRight"]:setPriority(priority);
	elseif attribute == "Armor" then
		for i=1, #vehicle[vehicleIndex][attribute] do
			vehicle[vehicleIndex][attribute][i]:setPriority(ARMOR_PRIORITY[vId][i]);
			vehicle[vehicleIndex][attribute][i]:setScale(ARMOR_SCALE[vId].w, ARMOR_SCALE[vId].h);
		end
	else
		vehicle[vehicleIndex][attribute]:setScale(0.9, 0.9);
		vehicle[vehicleIndex][attribute]:setParent(pivot[1]);
		vehicle[vehicleIndex][attribute]:setPriority(priority);
	end

-- print("StateGarage:updateVehicle", vehicleIndex, vId, attribute, paintIndex, armorIndex, sideWpnIndex, turretIndex)

end

----------------------------------------------------------------

function StateGarage:recreateVehicle()

	local pivot, index, visObj, vehicle = self:GetItemInfo("CarMode");

	for i=1,#pivot do
		local y = -(ITEM_SPACING * (i-1));

		self:rebuildVehicle(pivot, self:_getVehicleID(i), vehicle[i], 0, y);
	end

end

----------------------------------------------------------------

function StateGarage:rebuildVehicle( pivot, index, vehicle, x, y )

	local paintIndex;
	local armorIndex;
	local sideWpnIndex;
	local turretIndex;
	local isLocked = true;

	paintIndex = App.data:getPlayerVehiclePaintVariant(index);

	if not App.data:isPlayerVehiclePaintVariantUnlocked( index, paintIndex ) then
		paintIndex = 1;
	end

	if not App.data:isPlayerVehicleLevelLocked( index ) or (index > maxVehicleCount) then
		isLocked = false;
	end

	if App.data:isPlayerVehicleUnlocked( index ) then

		isLocked = false;

		if App.data:isPlayerArmorUnlocked( index ) then
			armorIndex = App.data:getPlayerArmorLevel(index);
		else
			armorIndex = 0;
		end

		if App.data:isPlayerSideWeaponUnlocked( index ) then
			sideWpnIndex = App.data:getPlayerSideWeaponLevel(index);
		else
			sideWpnIndex = 0;
		end

		if App.data:isPlayerTurretWeaponUnlocked( index ) then
			turretIndex = App.data:getPlayerTurretWeaponLevel(index);
		else
			turretIndex = 0;
		end
	else
		armorIndex		= 0;
		sideWpnIndex	= 0;
		turretIndex		= 0;
	end

	local turretTpl	= TemplateMgr:getPlayerVehicleTurretWeapon(index);

   if turretTpl and turretIndex < #turretTpl.level then

		local tpl   = turretTpl.level[turretIndex+1];

		if tpl then

			local gold	= tpl.cost.gold or 0;
			local gem	= tpl.cost.gem or 0;

			if gold < 1 and gem < 1 and turretIndex < 1 then
				turretIndex = 1;
			end
		end
	end

	if index > App.data:getPlayerVehicleCount() then
		armorIndex		= 0;
		sideWpnIndex	= 0;
		turretIndex		= 0;
	end

--	print("StateGarage:rebuildVehicle", index, y, paintIndex, armorIndex, sideWpnIndex, turretIndex, Paint_List[index][paintIndex].Name, vehicle.Turret);

	if	vehicle.BodyLeft and vehicle.BodyRight then
		vehicle.BodyLeft:swapImage(Paint_List[index][paintIndex].Name);
		vehicle.BodyRight:swapImage(Paint_List[index][paintIndex].Name);
		vehicle.BodyLeft:setParent(pivot[1]);
		vehicle.BodyRight:setParent(pivot[1]);
		vehicle.BodyLeft:setScale(VEHICLE_SCALE[index].w, VEHICLE_SCALE[index].h);
		vehicle.BodyRight:setScale(-VEHICLE_SCALE[index].w, VEHICLE_SCALE[index].h);
		vehicle.BodyLeft:setPriority(PRIORTY_1);
		vehicle.BodyRight:setPriority(PRIORTY_1);
		vehicle.Lock:setPriority(PRIORTY_7+1);
		vehicle.Lock:setParent(pivot[1]);
		vehicle.Lock:setVisible(isLocked);
	end

	if vehicle.Armor then
		if armorIndex <= 1 then
			for i=1, #vehicle.Armor do
				vehicle.Armor[i]:deleteAnim();
			end
			vehicle.Armor = nil;
		else
			armorIndex = math.clamp(armorIndex-1, 1, #Armor_List[index]);

			for i=1,armorIndex do
				if vehicle.Armor[i] then
					vehicle.Armor[i]:swapAnim(Armor_List[index][i].Name);
				else
					vehicle.Armor[i] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, Armor_List[index][i].Name, textureLibrary[index].spriteSheet);
				end

				vehicle.Armor[i]:setParent(pivot[1]);
				vehicle.Armor[i]:setLoc(x, y);
				vehicle.Armor[i]:setScale(ARMOR_SCALE[index].w, ARMOR_SCALE[index].h);
				vehicle.Armor[i]:setPriority(ARMOR_PRIORITY[index][i]);
			end
		end
	elseif not vehicle.Armor and armorIndex > 1 then
		armorIndex		= armorIndex - 1;
		vehicle.Armor	= {};

		for i=1,armorIndex do
			vehicle.Armor[i] = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, Armor_List[index][i].Name, textureLibrary[index].spriteSheet);
			vehicle.Armor[i]:setParent(pivot[1]);
			vehicle.Armor[i]:setLoc(x, y);
			vehicle.Armor[i]:setScale(ARMOR_SCALE[index].w, ARMOR_SCALE[index].h);
			vehicle.Armor[i]:setPriority(ARMOR_PRIORITY[index][i]);
		end
	end

	if vehicle.SideWeapon then
		if sideWpnIndex < 1 then
			vehicle.SideWeapon:deleteAnim();
			vehicle.SideWeapon = nil;
		else
			vehicle.SideWeapon:swapAnim(SideWpn_List[index].Name);
			vehicle.SideWeapon:setParent(pivot[1]);
			vehicle.SideWeapon:setLoc(x, y);
			vehicle.SideWeapon:setScale(VEHICLE_SCALE[index].w, VEHICLE_SCALE[index].h);
			vehicle.SideWeapon:setPriority(PRIORTY_5);
		end
	elseif not vehicle.SideWeapon and sideWpnIndex > 0 then
		vehicle.SideWeapon = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, SideWpn_List[index].Name, textureLibrary[index].spriteSheet);
		vehicle.SideWeapon:setParent(pivot[1]);
		vehicle.SideWeapon:setLoc(x, y);
		vehicle.SideWeapon:setScale(VEHICLE_SCALE[index].w, VEHICLE_SCALE[index].h);
		vehicle.SideWeapon:setPriority(PRIORTY_5);
	end

	if vehicle.Turret then
		if turretIndex < 1 then
			vehicle.Turret:deleteAnim();
			vehicle.Turret = nil;
		else
			vehicle.Turret:swapAnim(TurretWpn_List[index].Name);
			vehicle.Turret:setParent(pivot[1]);
			vehicle.Turret:setLoc(x, y);
			vehicle.Turret:setScale(VEHICLE_SCALE[index].w, VEHICLE_SCALE[index].h);
			vehicle.Turret:setPriority(PRIORTY_7);
		end
	elseif not vehicle.Turret and turretIndex > 0 then
		vehicle.Turret = self:addWidget(Anim, self.mainLayer, x, y, 0, 0, TurretWpn_List[index].Name, textureLibrary[index].spriteSheet);
		vehicle.Turret:setParent(pivot[1]);
		vehicle.Turret:setLoc(x, y);
		vehicle.Turret:setScale(VEHICLE_SCALE[index].w, VEHICLE_SCALE[index].h);
		vehicle.Turret:setPriority(PRIORTY_7);
	end

	if vehicle.Lock then
		vehicle.Lock:setVisible(isLocked);
	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:createPurchaseObjects()

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);

		for j=1,#pivot do
			local y = -(ITEM_SPACING * (j-1));

			table.insert(purchase, self:buildPurchaseData(purchasePivot, j, 0, y, VENDOR_LIST[i].mode));
		end

	end

	self.PurchaseRack.active = false;
--	self:setInitPurchaseRack();

end

----------------------------------------------------------------

function StateGarage:buildPurchaseData( pivot, index, x, y, mode )

	--print("StateGarage:buildPurchaseData", pivot, index, x, y);

	local purchaseData	= {};

	purchaseData.frame		= self:addWidget(Anim, self.mainLayer, x,y, 0,0, "ItemCrate", textureSheet);
	purchaseData.modeTitle	= self:addWidget(TextBox, self.mainLayer, MODE_X, MODE_Y + y, 400, 120, ' ', self.defaultFontName, 15, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	purchaseData.levelBar	= nil;
	purchaseData.actionText	= self:addWidget(TextBox, self.mainLayer, PURCHASE_X, PURCHASE_Y + y, 190, 190, ' ', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	purchaseData.prereqText	= self:addWidget(TextBox, self.mainLayer, PURCHASE_X, COST_Y + y, 190, 190, '', self.defaultFontName, 15.3, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	purchaseData.costIcon	= self:addWidget(Anim, self.mainLayer, COST_ICON_X, COST_ICON_Y + y, 0,0, "BuyButtonCoin", textureSheet, nil, nil, true);
	purchaseData.cost			= self:addWidget(TextBox, self.mainLayer, COST_X, COST_Y + y, 400, 120, ' ', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	purchaseData.costShdw	= self:addWidget(TextBox, self.mainLayer, COST_X+2, COST_Y + y-2, 400, 120, ' ', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	purchaseData.paintText	= self:addWidget(TextBox, self.mainLayer, 0, COST_Y + 20 + y, 400, 120, ' ', self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
	purchaseData.buyButton	= self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, x,y, 0,0, "BuyButton", textureSheet, nil, self.purchaseItem, nil, nil);

	purchaseData.frame:setPriority(PRIORTY_10+1);
	purchaseData.modeTitle:setPriority(PRIORTY_11);
	purchaseData.actionText:setPriority(PRIORTY_11);
	purchaseData.prereqText:setPriority(PRIORTY_11);
	purchaseData.costIcon:setPriority(PRIORTY_11+1);
	purchaseData.cost:setPriority(PRIORTY_11+1);
	purchaseData.costShdw:setPriority(PRIORTY_11);
	purchaseData.paintText:setPriority(PRIORTY_11);
	purchaseData.buyButton:setPriority(PRIORTY_11-1);

	purchaseData.frame:setParent(pivot);
	purchaseData.modeTitle:setParent(pivot);
	purchaseData.actionText:setParent(pivot);
	purchaseData.prereqText:setParent(pivot);
	purchaseData.costIcon:setParent(pivot);
	purchaseData.cost:setParent(pivot);
	purchaseData.costShdw:setParent(pivot);
	purchaseData.paintText:setParent(pivot);
	purchaseData.buyButton:setParent(pivot);

	-- special case for paints
	if mode ~= 'PaintMode' then
		if mode == 'CarMode' then
			purchaseData.icon				= self:_buildVehicleIcon(index, PRIORTY_11, pivot, x, y+10);
		else
			purchaseData.icon				= self:addWidget(Anim, self.mainLayer, x, y+20, 0,0, "Icon_Armor", texturePowerUp);
			purchaseData.icon:setPriority(PRIORTY_11);
			purchaseData.icon:setParent(pivot);
		end
	else
		purchaseData.paintButton		= self:_buildPaintButtons( PRIORTY_11, pivot, x, y );
	end

	return purchaseData;

end

----------------------------------------------------------------

function StateGarage:_buildVehicleIcon( index, priority, pivot, x, y )

	local icon	= {};

	icon.anchor	= MOAITransform2D.new();
	icon.anchor:setLoc(x,y);
	icon.anchor:setParent(pivot);

	icon.left	= self:addWidget(Image, self.mainLayer, -(Icon_Vehicle_W/2)*Icon_Vehicle_K, (Icon_Vehicle_H/2)*Icon_Vehicle_K, Icon_Vehicle_W*Icon_Vehicle_K, Icon_Vehicle_H*Icon_Vehicle_K, Icon_Vehicle[self:_getVehicleID(index)]);
	icon.right	= self:addWidget(Image, self.mainLayer, (Icon_Vehicle_W/2)*Icon_Vehicle_K, (Icon_Vehicle_H/2)*Icon_Vehicle_K, Icon_Vehicle_W*Icon_Vehicle_K, Icon_Vehicle_H*Icon_Vehicle_K, Icon_Vehicle[self:_getVehicleID(index)]);

	icon.right:setScale(-1,1);

	icon.left:setParent(icon.anchor);
	icon.right:setParent(icon.anchor);

	icon.left:setPriority(priority);
	icon.right:setPriority(priority);

	return icon;

end

----------------------------------------------------------------

function StateGarage:_updateVehicleIcon( icon, index )

	if index and icon and icon.anchor and icon.left and icon.right then
		icon.left:swapImage(Icon_Vehicle[index]);
		icon.right:swapImage(Icon_Vehicle[index]);

		icon.right:setScale(-1,1);

		icon.left:setParent(icon.anchor);
		icon.right:setParent(icon.anchor);
	end

end

----------------------------------------------------------------

function StateGarage:_buildPaintButtons( priority, pivot, x, y )

	local vehicleIndex	= App.data:getCurrentPlayerVehicle();
	local temp				= {};

	self.paintBuyIndex	= App.data:getCurrentPlayerVehiclePaintVariant();

	for i=1,#Icon_Paint[1] do

		temp[i]					= {};
		temp[i].paintFrame	= self:addWidget(ButtonImage,	self.mainLayer, Paint_Loc[i].x+x, Paint_Loc[i].y+y, Paint_Frame.w, Paint_Frame.h, Paint_Frame.file, nil, nil, nil, nil, true);
		temp[i].paintGlow		= self:addWidget(Image, self.mainLayer, 0,0, Paint_Glow.w, Paint_Glow.h, Paint_Glow.file);
		temp[i].paintColor	= self:addWidget(Image, self.mainLayer, 0,0, Paint_Color.w, Paint_Color.h, Paint_Color.file);
		temp[i].paintStripe	= self:addWidget(Image, self.mainLayer, 0,0, Paint_Stripe.w, Paint_Stripe.h, Paint_Stripe.file);

		temp[i].paintFrame:setInViewTest(	function()
															local x,y = temp[i].paintFrame:getLoc();

															return math.isInBoundary(x, y, -App.viewportWidth/2, 0, Paint_Loc[#Paint_Loc].y-Paint_Frame.h, Paint_Loc[1].y+Paint_Frame.h);
														end
													);

		temp[i].paintFrame.onReleasedFunc	=	function()
																self.paintBuyIndex = i;
																self:_updatePaintVehicle();
																self:callItemListIndexTasks('PaintMode', self.paintBuyIndex);
															end

		temp[i].paintFrame:setPriority(priority);
		temp[i].paintGlow:setPriority(priority+1);
		temp[i].paintColor:setPriority(priority+2);
		temp[i].paintStripe:setPriority(priority+3);

		temp[i].paintFrame:setParent(pivot);
		temp[i].paintGlow.prop:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, temp[i].paintFrame.prop, MOAIProp2D.TRANSFORM_TRAIT );
		temp[i].paintColor.prop:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, temp[i].paintFrame.prop, MOAIProp2D.TRANSFORM_TRAIT );
		temp[i].paintStripe.prop:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, temp[i].paintFrame.prop, MOAIProp2D.TRANSFORM_TRAIT );
	end

	return temp;

end

----------------------------------------------------------------

function StateGarage:_updatePaintButton( pivot, paintButton, y )

	local vehicleIndex	= App.data:getCurrentPlayerVehicle();

	for i=1,#paintButton do
		if i ~= self.paintBuyIndex then
			paintButton[i].paintGlow:setVisible(false);
			paintButton[i].paintFrame:enable();
		else
			paintButton[i].paintGlow:setVisible(true);
			paintButton[i].paintFrame:disable();
		end

		paintButton[i].paintColor:setColor(Icon_Paint[vehicleIndex][i].color.r, Icon_Paint[vehicleIndex][i].color.g, Icon_Paint[vehicleIndex][i].color.b, 1);
		paintButton[i].paintStripe:setColor(Icon_Paint[vehicleIndex][i].stripe.r, Icon_Paint[vehicleIndex][i].stripe.g, Icon_Paint[vehicleIndex][i].stripe.b, 1);
	end

end

----------------------------------------------------------------

function StateGarage:_hidePaintButton( button )

	if	button and #button > 0 then
		for k,v in ipairs(button) do
			v.paintFrame:setVisible(false);
			v.paintGlow:setVisible(false);
			v.paintColor:setVisible(false);
			v.paintStripe:setVisible(false);

			v.paintFrame:disable();
		end
	end

end

----------------------------------------------------------------

function StateGarage:_showPaintButton( button )

	if	button and #button > 0 then
		for k,v in ipairs(button) do
			v.paintFrame:setVisible(true);
			v.paintGlow:setVisible(true);
			v.paintColor:setVisible(true);
			v.paintStripe:setVisible(true);

			v.paintFrame:enable();
		end
	end

end

----------------------------------------------------------------

function StateGarage:_updatePaintVehicle()

	local list, index, objList = self:GetItemInfo('PaintMode');
	local vehicleIndex = App.data:getCurrentPlayerVehicle();

	if not objList then
		self:AddItemVisObj(self.GarageMode, self:BuildItemList(list, Paint_List[vehicleIndex], textureLibrary[vehicleIndex].spriteSheet, VEHICLE_OFFSET[vehicleIndex].x, VEHICLE_OFFSET[vehicleIndex].y, nil, nil, self.paintBuyIndex, vehicleIndex));
	else
		self:SwapItemVisObj(self.GarageMode, self:BuildItemList(list, Paint_List[vehicleIndex], textureLibrary[vehicleIndex].spriteSheet, VEHICLE_OFFSET[vehicleIndex].x, VEHICLE_OFFSET[vehicleIndex].y, nil, nil, self.paintBuyIndex, vehicleIndex));
	end

end

----------------------------------------------------------------

function StateGarage:buildLevelBar( index, pivot, maxLevel )

	local temp = {};
	local y = -(ITEM_SPACING * (index-1));
	local offset = 12;

	for i=1,maxLevel do

		local x = ((-maxLevel/2) * offset) + ((i - 1) * offset) + (offset/2);

		temp[i] = self:addWidget(Anim, self.mainLayer, x,y+20, 0,0, "Pips", textureSheet);
		temp[i]:setPriority(PRIORTY_11+1);
		temp[i]:setParent(pivot);

	end

	return temp;

end

----------------------------------------------------------------

function StateGarage:updatePowerBar( meter, itemLevel, maxLevel )

--	print('StateGarage:updatePowerBar', meter, itemLevel, maxLevel);

	if not meter then

		return false;
	end

	local count = 1;
	local onFrame = 5/30;

	for i=1,maxLevel do

		meter[i]:setVisible(true);
		meter[i]:stop();

		if count <= itemLevel then
			meter[i]:setSpan(onFrame,onFrame);
			meter[i]:setTime(onFrame);
			meter[i]:start();
			count = count + 1;
		else
			meter[i]:setSpan(0);
			meter[i]:setTime(0);
			meter[i]:start();
		end

	end

end

----------------------------------------------------------------

function StateGarage:hidePowerBar( meter )

	if meter then
		for i=1,#meter do
			meter[i]:setVisible(false);
		end
	end

end

----------------------------------------------------------------

function StateGarage:updatePurchaseData( mode )

	local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(mode);

	if mode == "CarMode" then

		for i=1,#pivot do

			local vId			= self:_getVehicleID(i);
			local cost			= App.data:getPlayerVehicleUnlockCost(vId);
			local itemLevel	= nil;
			local maxLevel		= nil;
			local maxedOut		= App.data:isPlayerVehicleUnlocked(vId);

			if i > maxVehicleCount then
				maxedOut = true;
			end

			if maxedOut or cost == nil then
				cost = { gold=nil, gem=nil };
			end

			self:updatePurchaseButton(i, purchasePivot, purchase[i], Icon_Vehicle[vId], SubCatergory_Vehicle[vId], App.data:isPlayerVehicleUnlocked(vId), cost.gold, cost.gem, itemLevel, maxLevel, Desc_Vehicle[vId], true, maxedOut, true);
		end

	elseif mode == "FrontWeaponMode" then

		for i=1,#pivot do

			local vehicleIndex	= App.data:getCurrentPlayerVehicle();
			local vId				= self:_getVehicleID(vehicleIndex);
			local cost				= App.data:getPlayerMainWeaponUpgradeCost(vehicleIndex);
			local itemLevel		= App.data:getPlayerMainWeaponLevel(vehicleIndex);
			local maxLevel			= App.data:getPlayerMainWeaponMaxLevel(vehicleIndex);
			local maxedOut;

			if itemLevel < maxLevel then
				maxedOut = false;
			else
				maxedOut = true;
			end

			if maxedOut or cost == nil then
				cost = { gold=nil, gem=nil };
			end

			self:updatePurchaseButton(i, purchasePivot, purchase[i], Icon_MainWeapon[vehicleIndex][itemLevel], SubCatergory_MainWeapon[vehicleIndex], App.data:isPlayerMainWeaponUnlocked(vehicleIndex), cost.gold, cost.gem, itemLevel, maxLevel, Desc_MainWeapon[vehicleIndex], nil, maxedOut);
		end

	elseif mode == "TurretMode" then

		for i=1,#pivot do

			local vehicleIndex	= App.data:getCurrentPlayerVehicle();
			local vId				= self:_getVehicleID(i);
			local cost				= App.data:getPlayerTurretWeaponUpgradeCost(vehicleIndex);
			local itemLevel		= App.data:getPlayerTurretWeaponLevel(vehicleIndex);
			local maxLevel			= App.data:getPlayerTurretWeaponMaxLevel(vehicleIndex);
			local maxedOut;

			if itemLevel < maxLevel then
				maxedOut = false;
			else
				maxedOut = true;
			end

			if maxedOut or cost == nil then
				cost = { gold=nil, gem=nil };
			end



         local turretDesc  = Desc_Turret[vehicleIndex];
         local flashing    = false;

         local onSale, saleIndex, saleID, salePrice  = App.data:isVehicleTurretOnSale( vehicleIndex );

         if not App.data:isPlayerTurretWeaponUnlocked(vehicleIndex) and onSale and salePrice then
            turretDesc = "<c:84c7eb>Turret is on sale for "..App.data:getVehicleTurretSaleText(vehicleIndex);
            flashing = true;
         end

			self:updatePurchaseButton(i, purchasePivot, purchase[i], Icon_Turret[vehicleIndex][itemLevel+1], SubCatergory_Turret[vehicleIndex], App.data:isPlayerTurretWeaponUnlocked(vehicleIndex), cost.gold, cost.gem, itemLevel, maxLevel, turretDesc, nil, maxedOut, nil, nil, flashing);
		end

	elseif mode == "SideWeaponMode" then

		for i=1,#pivot do

			local vehicleIndex	= App.data:getCurrentPlayerVehicle();
			local vId				= self:_getVehicleID(i);
			local cost				= App.data:getPlayerSideWeaponUpgradeCost(vehicleIndex);
			local itemLevel		= App.data:getPlayerSideWeaponLevel(vehicleIndex);
			local maxLevel			= App.data:getPlayerSideWeaponMaxLevel(vehicleIndex);
			local maxedOut;

			if itemLevel < maxLevel then
				maxedOut = false;
			else
				maxedOut = true;
			end

			if maxedOut or cost == nil then
				cost = { gold=nil, gem=nil };
			end


         local sideDesc = Desc_SideWeapon[vehicleIndex];
         local flashing = false;


         local onSale, saleIndex, saleID, salePrice  = App.data:isVehicleSideWeaponOnSale( vehicleIndex );

         if not App.data:isPlayerSideWeaponUnlocked(vehicleIndex) and onSale and salePrice then
            sideDesc = "<c:84c7eb>Side Weapons are on sale for "..App.data:getVehicleSideWeaponSaleText(vehicleIndex);
            flashing = true;
         end


			self:updatePurchaseButton(i, purchasePivot, purchase[i], Icon_SideWeapon[vehicleIndex][itemLevel+1], SubCatergory_MainWeapon[vehicleIndex], App.data:isPlayerSideWeaponUnlocked(vehicleIndex), cost.gold, cost.gem, itemLevel, maxLevel, sideDesc, nil, maxedOut, nil, nil, flashing);
		end

	elseif mode == "PaintMode" then

		for i=1,#pivot do

			local vehicleIndex	= App.data:getCurrentPlayerVehicle();
			local vId				= self:_getVehicleID(i);
			local cost				= App.data:getPlayerVehiclePaintVariantUnlockCost(vehicleIndex, self.paintBuyIndex);
			local itemLevel		= 0;
			local maxLevel			= 1;
			local maxedOut;

			if self.paintBuyIndex < 2 then
				maxedOut = true;
			else
				maxedOut = App.data:isPlayerVehiclePaintVariantUnlocked(vehicleIndex, self.paintBuyIndex);
			end

			if maxedOut or cost == nil then
				cost = { gold=nil, gem=nil };
			end

			self:updatePurchaseButton(i, purchasePivot, purchase[i], Icon_Paint[vehicleIndex][i], SubCatergory_Paint[vehicleIndex][i], App.data:isPlayerVehiclePaintVariantUnlocked(vehicleIndex, self.paintBuyIndex), cost.gold, cost.gem, itemLevel, maxLevel, Desc_Paint[vehicleIndex][i], true, maxedOut, nil, true);
		end

	elseif mode == "ArmorMode" then

		for i=1,#pivot do

			local vehicleIndex	= App.data:getCurrentPlayerVehicle();
			local vId				= self:_getVehicleID(i);
			local cost				= App.data:getPlayerArmorUpgradeCost(vehicleIndex);
			local itemLevel		= App.data:getPlayerArmorLevel(vehicleIndex);
			local maxLevel			= App.data:getPlayerArmorMaxLevel(vehicleIndex);
			local maxedOut;

			if itemLevel < maxLevel then
				maxedOut = false;
			else
				maxedOut = true;
			end

			if maxedOut or cost == nil then
				cost = { gold=nil, gem=nil };
			end

			self:updatePurchaseButton(i, purchasePivot, purchase[i], Icon_Armor[i], SubCatergory_Armor[vehicleIndex], App.data:isPlayerArmorUnlocked(vehicleIndex), cost.gold, cost.gem, itemLevel, maxLevel, Desc_Armor[vehicleIndex], nil, maxedOut);
		end

	end

end

----------------------------------------------------------------

function StateGarage:updatePurchaseButton(index, pivot, purchaseData, icon, name, isUnlocked, costGold, costGem, itemLevel, maxLevel, desc, disableItemLevelUI, isMaxedOut, isVehicle, isPaint, isFlashing)

	--print('StateGarage:updatePurchaseButton', index, pivot, purchaseData, icon, name, isUnlocked, costGold, costGem, itemLevel, maxLevel, desc, disableItemLevelUI, isMaxedOut, isVehicle, isPaint);

	local isCostValid		= true;
	local button			= 'BuyButton';
	local y					= -(ITEM_SPACING * (index-1));
	local mode				= self.GarageMode;
	local offset			= 20;

	-- category
	local modeTitle;

	if mode == "CarMode" then
		modeTitle = "Vehicles";
	elseif mode == "FrontWeaponMode" then
		modeTitle = "Main\nWeapon";
	elseif mode == "TurretMode" then
		modeTitle = "Special";
	elseif mode == "SideWeaponMode" then
		modeTitle = "Side\nWeapon";
	elseif mode == "PaintMode" then
		modeTitle = "Paint Shop\n";
	elseif mode == "PowerUpMode" then
		modeTitle = "Pick Up";
	elseif mode == "ArmorMode" then
		modeTitle = "Armor";
	end

	purchaseData.modeTitle:setVisible(true);

	-- name
	if name ~= ' ' then
		modeTitle = modeTitle..'\n'..name..'';
	end

	if purchaseData.modeTitle:getText() ~= modeTitle then
		purchaseData.modeTitle:setText(modeTitle);
	end

	-- icon or paint buttons
	if purchaseData.icon then
		if purchaseData.icon.anchor then
			self:_updateVehicleIcon(purchaseData.icon, self:_getVehicleID(index));
		else
			purchaseData.icon:swapAnim(icon);
			purchaseData.icon:setLoc(0, y+20);
			purchaseData.icon:setPriority(PRIORTY_11);
			purchaseData.icon:setParent(pivot);
		end
	elseif purchaseData.paintButton then
		self:_updatePaintButton( pivot, purchaseData.paintButton, y );
	end

	-- power level
	if disableItemLevelUI then
		if purchaseData.levelBar then
			self:hidePowerBar(purchaseData.levelBar);
		end
	else
		if not purchaseData.levelBar then
			purchaseData.levelBar = self:buildLevelBar(index, pivot, maxLevel);
		end

		self:updatePowerBar(purchaseData.levelBar, itemLevel, maxLevel);
	end

	-- cost and cost icon
	if (costGold or costGem) and not isMaxedOut then

		local price = 0;

		purchaseData.cost:setVisible(true);
		purchaseData.costShdw:setVisible(true);

		if costGold and costGem then
			if costGold > 0 then
				price = costGold;

				if purchaseData.cost:getText() ~= ''..costGold then
					purchaseData.cost:setText(''..costGold);
					purchaseData.costShdw:setText('<c:000000>'..costGold);
				end

				purchaseData.costIcon:swapGraphic('BuyButtonCoin');
				purchaseData.costIcon:setScale(1.0, 1.0);
			elseif costGem > 0 then
				price = costGold;

				if purchaseData.cost:getText() ~= ''..costGem then
					purchaseData.cost:setText(''..costGem);
					purchaseData.costShdw:setText('<c:000000>'..costGem);
				end

				purchaseData.costIcon:swapGraphic('BuyButtonGem');
				purchaseData.costIcon:setScale(0.6, 0.6);
			else

				if purchaseData.cost:getText() ~= '0' then
					purchaseData.cost:setText('0');
					purchaseData.costShdw:setText('<c:000000>0');
				end

				purchaseData.costIcon:swapGraphic('BuyButtonCoin');
				purchaseData.costIcon:setScale(1.0, 1.0);
			end
		elseif costGold then
			if costGold > 0 then
				price = costGold;

				if purchaseData.cost:getText() ~= ''..costGold then
					purchaseData.cost:setText(''..costGold);
					purchaseData.costShdw:setText('<c:000000>'..costGold);
				end

				purchaseData.costIcon:swapGraphic('BuyButtonCoin');
				purchaseData.costIcon:setScale(1.0, 1.0);
			else

				if purchaseData.cost:getText() ~= '0' then
					purchaseData.cost:setText('0');
					purchaseData.costShdw:setText('<c:000000>0');
				end

				purchaseData.costIcon:swapGraphic('BuyButtonCoin');
				purchaseData.costIcon:setScale(1.0, 1.0);
			end
		elseif costGem then
			if costGem > 0 then
				price = costGem;

				if purchaseData.cost:getText() ~= ''..costGem then
					purchaseData.cost:setText(''..costGem);
					purchaseData.costShdw:setText('<c:000000>'..costGem);
				end

				purchaseData.costIcon:swapGraphic('BuyButtonGem');
				purchaseData.costIcon:setScale(0.6, 0.6);
			else

				if purchaseData.cost:getText() ~= '0' then
					purchaseData.cost:setText('0');
					purchaseData.costShdw:setText('<c:000000>0');
				end

				purchaseData.costIcon:swapGraphic('BuyButtonGem');
				purchaseData.costIcon:setScale(0.6, 0.6);
			end
		end

		if price > 99999 then
			offset = 68;
			purchaseData.cost:setGlyphScale(0.9);
			purchaseData.costShdw:setGlyphScale(0.9);
		elseif price > 9999 then
			offset = 60;
			purchaseData.cost:setGlyphScale(1.0);
			purchaseData.costShdw:setGlyphScale(1.0);
		elseif price > 999 then
			offset = 50;
			purchaseData.cost:setGlyphScale(1.1);
			purchaseData.costShdw:setGlyphScale(1.1);
		elseif price > 99 then
			offset = 40;
			purchaseData.cost:setGlyphScale(1.1);
			purchaseData.costShdw:setGlyphScale(1.1);
		elseif price > 9 then
			offset = 30;
			purchaseData.cost:setGlyphScale(1.1);
			purchaseData.costShdw:setGlyphScale(1.1);
		else
			purchaseData.cost:setGlyphScale(1.1);
			purchaseData.costShdw:setGlyphScale(1.1);
		end

		purchaseData.costIcon:setLoc(COST_ICON_X - offset, COST_ICON_Y + y);
		purchaseData.costIcon:setPriority(PRIORTY_11+1);
		purchaseData.costIcon:setParent(pivot);
		purchaseData.costIcon:setVisible(true);
	else
		isCostValid = false;
		purchaseData.costIcon:setVisible(false);
		purchaseData.cost:setVisible(false);
		purchaseData.costShdw:setVisible(false);
	end

	-- buy/upgrade button
	if isMaxedOut or not isCostValid then
		purchaseData.costIcon:setVisible(false);
		purchaseData.cost:setVisible(false);
		purchaseData.costShdw:setVisible(false);
		purchaseData.buyButton:stop();
		purchaseData.buyButton:disable();
		purchaseData.buyButton:setVisible(false);
	else
		if costGold and costGem then
			if costGold > 0 then
				if costGold > App.data:getGoldCount() then
					button = 'BuyLockButton';
				end
			elseif costGem > 0 then
				if costGem > App.data:getGemCount() then
					button = 'BuyLockButton';
				end
			else
				button = 'BuyButton';
			end
		elseif costGold then
			if costGold > App.data:getGoldCount() then
				button = 'BuyLockButton';
			else
				button = 'BuyButton';
			end
		else
			if costGem > App.data:getGemCount() then
				button = 'BuyLockButton';
			else
				button = 'BuyButton';
			end
		end

		purchaseData.buyButton:swapAnim(button);
		purchaseData.buyButton:setLoc(0, y);
		purchaseData.buyButton:setPriority(PRIORTY_11-1);
		purchaseData.buyButton:setParent(pivot);
		purchaseData.buyButton:enable();
		purchaseData.buyButton:setColor(1.0, 1.0, 1.0, 1.0);

	end

	-- set description text
	purchaseData.actionText:setVisible(true);

	if purchaseData.actionText:getText() ~= desc then
		purchaseData.actionText:setText(desc);
	end

	if desc == '<c:84c7eb>Coming\nSoon!<c>' then
		purchaseData.actionText:setGlyphScale(1.0);
	else
		purchaseData.actionText:setGlyphScale(0.65);
	end

   if isFlashing then
      self:_addFlashingTextBox(purchaseData.actionText);
   else
      self:_removeFlashingTextBox(purchaseData.actionText);
   end

	-- check for level unlock on vehicles
	if isVehicle then

		if App.data:isPlayerVehicleLevelLocked(index) and not App.data:isPlayerVehicleUnlocked(index) then

			local text = "<c:e01506>Requires\nLevel "..App.data:getVehicleUnlockableLevel(index).."<c>";

			purchaseData.prereqText:setVisible(true);

			if desc ~= '<c:84c7eb>Coming\nSoon!<c>' then
				if purchaseData.prereqText:getText() ~= text then
					purchaseData.prereqText:setText(text);
				end
			else
				purchaseData.prereqText:setVisible(false);
			end

			purchaseData.costIcon:setVisible(false);
			purchaseData.cost:setVisible(false);
			purchaseData.costShdw:setVisible(false);
			purchaseData.buyButton:stop();
			purchaseData.buyButton:disable();
			purchaseData.buyButton:setVisible(false);
		else
			purchaseData.prereqText:setVisible(false);
		end
	else
		purchaseData.prereqText:setVisible(false);
	end

	-- check for equipped paint
	if isPaint and isUnlocked then
		purchaseData.paintText:setVisible(true);
		purchaseData.paintText:setText('Equipped');
		purchaseData.costIcon:setVisible(false);
	elseif isPaint then
		purchaseData.paintText:setVisible(false);
		purchaseData.costIcon:setLoc(COST_ICON_X-offset, COST_ICON_Y+20+y);
		purchaseData.cost:setLoc(COST_X, COST_Y+20+y);
		purchaseData.costShdw:setLoc(COST_X+2, COST_Y+20+y-2);
		purchaseData.buyButton:setLoc(0, 20+y);
	else
		purchaseData.paintText:setVisible(false);
		purchaseData.cost:setLoc(COST_X, COST_Y+y);
		purchaseData.costShdw:setLoc(COST_X+2, COST_Y+y-2);
	end

--joe: guide references
---------------------------------------------------------
	self.purchaseFrameRef		= purchaseData.frame       or {};
	self.purchaseModeTitleRef	= purchaseData.modeTitle   or {};
	self.purchaseBarRef			= purchaseData.levelBar    or {};
	self.purchaseAcTextRef		= purchaseData.actionText  or {};
	self.purchaseIconRef			= purchaseData.costIcon    or {};
	self.purchaseCostRef			= purchaseData.cost        or {};
	self.purchaseCostRefShdw	= purchaseData.costShdw    or {};
	self.purchaseButtonRef		= purchaseData.buyButton   or {};
	self.purchaseWeaponIconRef	= purchaseData.icon        or {};
	self.currentWeaponButton	= self.FrontWeaponButton[App.data:getCurrentPlayerVehicle()] or {};
   self.currentWeaponPips     = self.ModePurchaseElements[App.data:getCurrentPlayerVehicle()].mainLevelPips or {};

   self.purchaseFrameRef.priority		= (purchaseData.frame      or {}).priority;
	self.purchaseModeTitleRef.priority	= (purchaseData.modeTitle  or {}).priority;
	self.purchaseBarRef.priority			= (purchaseData.levelBar   or {}).priority;
	self.purchaseAcTextRef.priority		= (purchaseData.actionText or {}).priority;
	self.purchaseIconRef.priority			= (purchaseData.costIcon   or {}).priority;
	self.purchaseCostRef.priority			= (purchaseData.cost       or {}).priority;
	self.purchaseButtonRef.priority		= (purchaseData.buyButton  or {}).priority;
	self.purchaseWeaponIconRef.priority	= (purchaseData.icon       or {}).priority;
	self.currentWeaponButton.priority	= (self.FrontWeaponButton[App.data:getCurrentPlayerVehicle()] or {}).priority;
   self.currentWeaponPips.priority     = (self.ModePurchaseElements[App.data:getCurrentPlayerVehicle()].mainLevelPips or {}).priority;

----------------------------------------------------------

end

----------------------------------------------------------------

function StateGarage:hidePurchaseButtons()

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);

		for j=1,#pivot do
			purchase[j].frame:setVisible(false);
			purchase[j].modeTitle:setVisible(false);

			if purchase[j].icon then
				if purchase[j].icon.anchor then
					purchase[j].icon.left:setVisible(false);
					purchase[j].icon.right:setVisible(false);
				else
					purchase[j].icon:setVisible(false);
				end
			else
				self:_hidePaintButton(purchase[j].paintButton);
			end

			self:hidePowerBar(purchase[j].levelBar);
			purchase[j].actionText:setVisible(false);
			purchase[j].costIcon:setVisible(false);
			purchase[j].cost:setVisible(false);
			purchase[j].costShdw:setVisible(false);
			purchase[j].buyButton:setVisible(false);
			purchase[j].buyButton:disable();
			purchase[j].paintText:setVisible(false);
		end
	end

end

----------------------------------------------------------------

function StateGarage:showPurchaseButtons( mode )

	local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(mode);

	for i=1,#pivot do
		purchase[i].frame:setVisible(true);
		purchase[i].modeTitle:setVisible(true);

		if purchase[i].icon then
			if purchase[i].icon.anchor then
				purchase[i].icon.left:setVisible(true);
				purchase[i].icon.right:setVisible(true);
			else
				purchase[i].icon:setVisible(true);
			end
		else
			self:_showPaintButton(purchase[i].paintButton);
		end

		purchase[i].actionText:setVisible(true);
		purchase[i].costIcon:setVisible(true);
		purchase[i].cost:setVisible(true);
		purchase[i].buyButton:setVisible(true);
	end

	self:updatePurchaseData(mode);

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:setInitPurchaseRack()

	self.PurchaseRackPivot:setLoc(MODE_TRAY_HOME_X-MODE_TRAY_SHIFT, MODE_TRAY_HOME_Y);

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);
		local x,y = purchasePivot:getLoc();

		purchasePivot:setLoc(PURCHASE_PIVOT_X-MODE_TRAY_SHIFT, y);
	end

	self:HideAllItemObj();
	self:enableModeButtons();
	self:hidePurchaseButtons();
	self.PurchaseRack.action = nil;
	self.PurchaseRack.active = false;
	self.GarageMode = 'CarMode';

end

----------------------------------------------------------------

function StateGarage:hidePurchaseRack()

	if self.PurchaseRack.active and not self.PurchaseRack.action then

		EventMgr:postEvent( {sounds={start={"SwipeOut"}}, name="swipe move y",}, "add-sfx" );

		self:resetItemListIndexPos();

		local thread = MOAICoroutine.new();

		thread:run(
			function ()
				self:waitHideRack();
			end
		);

	end

end

----------------------------------------------------------------

function StateGarage:waitHideRack()

	self.PurchaseRack.action = self.PurchaseRackPivot:moveLoc(-MODE_TRAY_SHIFT, 0, 0.2, MOAIEaseType.EASE_IN);
	self:HideAllItemObj();
	self:recreateVehicle();

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);

		purchasePivot:moveLoc(-MODE_TRAY_SHIFT, 0, 0.2, MOAIEaseType.EASE_IN);
	end

	MOAICoroutine.blockOnAction(self.PurchaseRack.action);

	self.PurchaseRackPivot:setLoc(MODE_TRAY_HOME_X-MODE_TRAY_SHIFT, MODE_TRAY_HOME_Y);

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);
		local x,y = purchasePivot:getLoc();

		purchasePivot:setLoc(PURCHASE_PIVOT_X-MODE_TRAY_SHIFT, y);
	end

	self:enableModeButtons();
	self:hidePurchaseButtons();
	self.PurchaseRack.action = nil;
	self.PurchaseRack.active = false;
	self.GarageMode = 'CarMode';
	self:UpdateArrows();

end

----------------------------------------------------------------

function StateGarage:showPurchaseRack( mode )

	if not self.PurchaseRack.active and not self.PurchaseRack.action then

		EventMgr:postEvent( {sounds={start={"SwipeIn"}}, name="swipe move y",}, "add-sfx" );

		local thread = MOAICoroutine.new();

		self:disableModeButtons();
		self:showPurchaseButtons(mode);

		thread:run(
			function ()
				self:waitShowRack();
			end
		);

	end

end

----------------------------------------------------------------

function StateGarage:waitShowRack()

	self.PurchaseRack.action = self.PurchaseRackPivot:moveLoc(MODE_TRAY_SHIFT, 0, 0.2, MOAIEaseType.EASE_IN);

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);

		purchasePivot:moveLoc(MODE_TRAY_SHIFT, 0, 0.2, MOAIEaseType.EASE_IN);
	end

	MOAICoroutine.blockOnAction(self.PurchaseRack.action);

	self.PurchaseRackPivot:setLoc(MODE_TRAY_HOME_X, MODE_TRAY_HOME_Y);

	for i=1,#VENDOR_LIST do

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(VENDOR_LIST[i].mode);
		local x,y = purchasePivot:getLoc();

		purchasePivot:setLoc(PURCHASE_PIVOT_X, y);
	end

	self.PurchaseRack.action = nil;
	self.PurchaseRack.active = true;

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:AdvanceItemListIndex( mode )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then
			self.VendorList[i].index = self.VendorList[i].index + 1;
			return true;
		end
	end

end

----------------------------------------------------------------

function StateGarage:RegressItemListIndex( mode )

	for i=1,#self.VendorList do
		if self.VendorList[i].mode == mode then
			self.VendorList[i].index = self.VendorList[i].index - 1;
			return true;
		end
	end

end

----------------------------------------------------------------

function StateGarage:AdvanceItemList()

	local list;
	local index;
	local visObj;
	local count;
	local mode = 'CarMode';

	if self.VendorListAction then
		return false;
	end

	if mode then
		if self:CheckValidItemMode(mode) then
			list, index, visObj = self:GetItemInfo(mode);

			if self.PurchaseRack.active then

				if self.PurchaseRack.action then
					self.PurchaseRack.action:stop();
					self.PurchaseRack.action = nil;
				end

				self:hidePurchaseRack();

			end

			if visObj then
				count = math.min(#visObj, maxVehicleCount);
			else
				count = math.min(#list, maxVehicleCount);
			end

			if (index + 1) > count then
				self:ResetItemListPos();
				return false;
			else
				EventMgr:postEvent( {sounds={start={"SwipeIn"}}, name="swipe move y",}, "add-sfx" );
				self:AdvanceItemListIndex(mode);
			end
		else
			return false;
		end

		index = index + 1;
		self:callItemListIndexTasks(mode, index);

		local X,Y = list[1]:getLoc();
		local target = (ITEM_SPACING * (index - 1)) + ITEM_HOME_Y;

		self.VendorListAction = list[1]:seekLoc(X, target, 0.25, MOAIEaseType.EASE_IN);
		self:UpdateArrows();

	end

end

----------------------------------------------------------------

function StateGarage:RegressItemList()

	local list;
	local index;
	local mode = 'CarMode';

	if self.VendorListAction then
		return false;
	end

	if mode then
		if self:CheckValidItemMode(mode) then
			list, index = self:GetItemInfo(mode);

			if self.PurchaseRack.active then

				if self.PurchaseRack.action then
					self.PurchaseRack.action:stop();
					self.PurchaseRack.action = nil;
				end

				self:hidePurchaseRack();

			end

			if (index - 1) < 1 then
				self:ResetItemListPos();
				return false;
			else
				self:RegressItemListIndex(mode);
				EventMgr:postEvent( {sounds={start={"SwipeIn"}}, name="swipe move y",}, "add-sfx" );
			end
		else
			return false;
		end

		index = index - 1;
		self:callItemListIndexTasks(mode, index);

		local X,Y = list[1]:getLoc();
		local target = (ITEM_SPACING * (index - 1)) + ITEM_HOME_Y;

		self.VendorListAction = list[1]:seekLoc(X, target, 0.25, MOAIEaseType.EASE_IN);
		self:UpdateArrows();

	end

end

----------------------------------------------------------------

function StateGarage:UpdateItemListPos( x, y )

	local list;
	local index;
	local visObj;
	local mode = self.GarageMode;

	if self.VendorListAction then
		return false;
	end

	if mode then

		if self:CheckValidItemMode(mode) then
			list, index, visObj = self:GetItemInfo(mode);

			if visObj then
				if #visObj < 2 then

					return false;
				end
			elseif #list < 2 then

				return false
			end
		else
			return false;
		end

		local X,Y = list[1]:getLoc();
		local delta = y - self.SwipeStartY;
		local target = (ITEM_SPACING * (index - 1)) + ITEM_HOME_Y + delta;
		list[1]:setLoc(X, target);
	end

end

----------------------------------------------------------------

function StateGarage:ResetItemListPos()

	local list;
	local index;
	local mode = self.GarageMode;

	if self.VendorListAction then
		return false;
	end

	if mode then

		if self:CheckValidItemMode(mode) then
			list, index = self:GetItemInfo(mode);
		else
			return false;
		end

		local X,Y = list[1]:getLoc();
		local target = (ITEM_SPACING * (index - 1)) + ITEM_HOME_Y;

		self.VendorListAction = list[1]:seekLoc(X, target, 0.25);

	end

end

----------------------------------------------------------------

function StateGarage:updateItemListIndexPos()

	local carIndex = self:_getVehicleIndex(App.data:getCurrentPlayerVehicle());
	local x;
	local y;
	local target;

	if carIndex < 1 then
		carIndex = 1;
	end

	if self.VendorListAction then
		self.VendorListAction:stop();
		self.VendorListAction = nil;
	end

	x,y = self.VendorList[1].pivots[1]:getLoc();
	target = (ITEM_SPACING * (carIndex - 1)) + ITEM_HOME_Y;
	self.VendorList[1].pivots[1]:setLoc(x, target);
	self.VendorList[1].index = carIndex;

	--print("StateGarage:updateItemListIndexPos", mode, carIndex);

end

----------------------------------------------------------------

function StateGarage:resetItemListIndexPos()

	local carIndex = self:_getVehicleIndex(App.data:getCurrentPlayerVehicle());
	local x;
	local y;
	local target;

	if carIndex < 1 then
		carIndex = 1;
	end

	if self.VendorListAction then
		self.VendorListAction:stop();
		self.VendorListAction = nil;
	end

	x,y = self.VendorList[1].pivots[1]:getLoc();
	target = (ITEM_SPACING * (carIndex - 1)) + ITEM_HOME_Y;
	self.VendorListAction = self.VendorList[1].pivots[1]:seekLoc(x, target, 0.15);
	self.VendorList[1].index = carIndex;

	--print("StateGarage:resetItemListIndexPos", mode, carIndex);

end

----------------------------------------------------------------

function StateGarage:MonitorListAction()

	local list;
	local index;
	local mode = self.GarageMode;

	if self.VendorListAction then
		self.VendorListAction:stop();
	end

	self.VendorListAction = nil;
	list, index = self:GetItemInfo(mode);

	Debug.assert(mode, 'Garage mode being monitored is nil');
	Debug.assert(list, 'Garage list being monitored is nil');
	Debug.assert(index, 'Garage index  being monitored is nil');

	if list and index then

		local X,Y = list[1]:getLoc();
		local target = (ITEM_SPACING * (index - 1)) + ITEM_HOME_Y;

		list[1]:setLoc(X, target);
	end

	if mode == 'CarMode' then
		if App.data:isPlayerVehicleUnlocked(self:_getVehicleID(index)) then
			self:enableModeButtons();
		else
			self:disableModeButtons();
		end
	end

end

----------------------------------------------------------------

function StateGarage:callItemListIndexTasks( mode, index )

	local vehicleIndex = App.data:getCurrentPlayerVehicle();

	if mode == "CarMode" then

		if App.data:isPlayerVehicleUnlocked(self:_getVehicleID(index)) then

			App.data:setCurrentPlayerVehicle(self:_getVehicleID(index));

			if not App.data:isPlayerVehiclePaintVariantUnlocked(self:_getVehicleID(index), App.data:getCurrentPlayerVehiclePaintVariant()) then
				App.data:setCurrentPlayerVehiclePaintVariant(1);
				self.paintBuyIndex = 1;
			end
		end

		self:updateModeButtonList();

	elseif mode == "FrontWeaponMode" then

	elseif mode == "TurretMode" then

	elseif mode == "SideWeaponMode" then

	elseif mode == "PaintMode" then

		App.data:setCurrentPlayerVehiclePaintVariant(index);

		if App.data:isPlayerVehiclePaintVariantUnlocked(vehicleIndex, index) then
			self:updateVehicle("Body", self:_getVehicleIndex(vehicleIndex), Paint_List[vehicleIndex][index].Name, textureLibrary[vehicleIndex].spriteSheet);
		end

	elseif mode == "PowerUpMode" then

	elseif mode == "ArmorMode" then

	end

	self:updatePurchaseData(mode);

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:UpdateArrows()

	local index;
	local list;
	local mode = 'CarMode';

	if mode then

		self.ArrowUpButton:stop();
		self.ArrowDownButton:stop();

		if self:CheckValidItemMode(mode) then
			list, index = self:GetItemInfo(mode);
		else
			self.ArrowUpButton:setVisible(false);
			self.ArrowDownButton:setVisible(false);

			self.ArrowUpButton:disable();
			self.ArrowDownButton:disable();

			return false;
		end

		if #list == 1 or maxVehicleCount == 1 then
			self.ArrowUpButton:setVisible(false);
			self.ArrowDownButton:setVisible(false);
			self.ArrowUpButton:disable();
			self.ArrowDownButton:disable();
		elseif index == 1 and index < #list then
			self.ArrowUpButton:setVisible(false);
			self.ArrowUpButton:disable();
			self.ArrowDownButton:start();
			self.ArrowDownButton:setVisible(true);
			self.ArrowDownButton:enable();
		elseif index == math.min(#list, maxVehicleCount) then
			self.ArrowUpButton:start();
			self.ArrowUpButton:setVisible(true);
			self.ArrowUpButton:enable();
			self.ArrowDownButton:setVisible(false);
			self.ArrowDownButton:disable();
		else
			self.ArrowUpButton:start();
			self.ArrowDownButton:start();
			self.ArrowUpButton:setVisible(true);
			self.ArrowDownButton:setVisible(true);
			self.ArrowUpButton:enable();
			self.ArrowDownButton:enable();
		end
	else
		self.ArrowUpButton:stop();
		self.ArrowDownButton:stop();
		self.ArrowUpButton:setVisible(false);
		self.ArrowDownButton:setVisible(false);
		self.ArrowUpButton:disable();
		self.ArrowDownButton:disable();
	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:newCarBadgeCheck()

	--index of the car to be shown
   local displayCar = App.data:getValue("garage-newCar-show");
   if displayCar then

		--scroll down to the new car
		local currentCar	= App.data:getCurrentPlayerVehicle();

      local vID = self:_getVehicleID(displayCar);

      local newPosition = self:_getVehicleIndex(vID);

		local nCars = newPosition - currentCar;

		if nCars ~= 0 then
			self:autoAdvanceCars( nCars );
		end

      App.data:setValue("garage-newCar-show", nil);

	else

      displayCar = App.data:getValue("garage-carSale-show");

      if displayCar and displayCar > 0 then

         --scroll down to the new car
         local currentCar	= App.data:getCurrentPlayerVehicle();

         local vID = self:_getVehicleID(displayCar);

         local newPosition = self:_getVehicleIndex(vID);

         local nCars = newPosition - currentCar;

         if nCars ~= 0 then
            self:autoAdvanceCars( nCars );
         end

         App.data:setValue("garage-carSale-show", -1);

      end
   end

end

------------------------------------------------------------------------------------

function StateGarage:autoAdvanceCars( nCars )

	if nCars > 0 then
		self.autoAdvance = true;
	else
		self.autoRegress = true;
	end

	self.numAdvances = nCars;
	self.advanceTimerReset = 0.5;
	self.advanceTimer = self.advanceTimerReset;


end

------------------------------------------------------------------------------------

function StateGarage:autoAdvanceUpdate( dt )

	self.advanceTimer = self.advanceTimer - dt;

	if self.advanceTimer <= 0 then

		self:AdvanceItemList();
		self.numAdvances = self.numAdvances - 1;

		if self.numAdvances <= 0 then
			self.autoAdvance = false;
		else
			self.advanceTimer = self.advanceTimerReset;
		end
	end


end

------------------------------------------------------------------------------------

function StateGarage:autoRegressUpdate( dt )

	self.advanceTimer = self.advanceTimer - dt;

	if self.advanceTimer <= 0 then

		self:RegressItemList();
		self.numAdvances = self.numAdvances + 1;

		if self.numAdvances >= 0 then
			self.autoRegress = false;
		else
			self.advanceTimer = self.advanceTimerReset;
		end
	end


end

------------------------------------------------------------------------------------

function StateGarage:resetAutoAdvance( )

   self.autoAdvance = false;
   self.autoRegress = false;
   self.numAdvances = 0;

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:setFrontWeaponMode()

	if not self.swipeOn and not self.VendorListAction and not self.PurchaseRack.active then
		if self.GarageMode ~= "FrontWeaponMode" then

			--print("GarageMode == FrontWeaponMode");

			self.GarageMode = "FrontWeaponMode";
			self.prevMode = self.GarageMode;

			self:hidePurchaseButtons();
			self:resetItemListIndexPos();
			self:ShowItemObj(self.GarageMode);
			self:UpdateArrows();
			self:showPurchaseRack(self.GarageMode);
		end
	end

end

----------------------------------------------------------------

function StateGarage:setTurretMode()

	if not self.swipeOn and not self.VendorListAction and not self.PurchaseRack.active then
		if self.GarageMode ~= "TurretMode" then

			--print("GarageMode == TurretMode");

			self.GarageMode = "TurretMode";
			self.prevMode = self.GarageMode;

			self:hidePurchaseButtons();
			self:resetItemListIndexPos();
			self:ShowItemObj(self.GarageMode);
			self:UpdateArrows();
			self:showPurchaseRack(self.GarageMode);
		end
	end

end

----------------------------------------------------------------

function StateGarage:setSideWeaponMode()

	if not self.swipeOn and not self.VendorListAction and not self.PurchaseRack.active then
		if self.GarageMode ~= "SideWeaponMode" then

			--print("GarageMode == SideWeaponMode");

			self.GarageMode = "SideWeaponMode";
			self.prevMode = self.GarageMode;

			self:hidePurchaseButtons();
			self:resetItemListIndexPos();
			self:ShowItemObj(self.GarageMode);
			self:UpdateArrows();
			self:showPurchaseRack(self.GarageMode);
		end
	end

end

----------------------------------------------------------------

function StateGarage:setPaintMode()

	if not self.swipeOn and not self.VendorListAction and not self.PurchaseRack.active then
		if self.GarageMode ~= "PaintMode" then

			--print("GarageMode == PaintMode");

			self.GarageMode = "PaintMode";
			self.prevMode = self.GarageMode;
			self.paintBuyIndex = App.data:getCurrentPlayerVehiclePaintVariant();

			if not App.data:isPlayerVehiclePaintVariantUnlocked( App.data:getCurrentPlayerVehicle(), self.paintBuyIndex ) then
				App.data:setCurrentPlayerVehiclePaintVariant(1);
				self.paintBuyIndex = 1;
			end

			self:_updatePaintVehicle();
			self:hidePurchaseButtons();
			self:resetItemListIndexPos();
			self:ShowItemObj(self.GarageMode);
			self:UpdateArrows();
			self:showPurchaseRack(self.GarageMode);
		end
	end

end

----------------------------------------------------------------

function StateGarage:setArmorMode()

	if not self.swipeOn and not self.VendorListAction and not self.PurchaseRack.active then
		if self.GarageMode ~= "ArmorMode" then

			--print("GarageMode == ArmorMode");

			self.GarageMode = "ArmorMode";
			self.prevMode = self.GarageMode;

			self:hidePurchaseButtons();
			self:resetItemListIndexPos();
			self:ShowItemObj(self.GarageMode);
			self:UpdateArrows();
			self:showPurchaseRack(self.GarageMode);
		end
	end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:_isValidVehicleIndex( index )

	if			index
		and	index > 0
		and	index <= App.data:getPlayerVehicleCount() then

		return true;
	end

	return false;

end

----------------------------------------------------------------

function StateGarage:purchaseItem()

	local mode = self.GarageMode;
	local index;
	local level;
	local currentVehicle = App.data:getCurrentPlayerVehicle();

	if self.SwipeOn or self.VendorListAction then

		return false;
	end

	if mode == "CarMode" then
		index			= self.VendorList[1].index;
		local vId	= self:_getVehicleID(index);

		if self:_isValidVehicleIndex(index) then

			if not App.data:canUnlockPlayerVehicle(vId) then

				local cost = App.data:getPlayerVehicleUnlockCost(vId);

				AUTO_PURCHASE_DATA.state      = 'StateGarage';
				AUTO_PURCHASE_DATA.carIndex   = ""..vId;
				AUTO_PURCHASE_DATA.reason1    = 'Unlock-Car';
				AUTO_PURCHASE_DATA.reason2    = 'Unlock-Car-'..vId;
				AUTO_PURCHASE_DATA.currency	= 'Gem';
				AUTO_PURCHASE_DATA.price		= cost.gem;
				self.keepRackOpen					= true;
				AUTO_PURCHASE_FUNC				=	function()
																self:purchaseItem();
															end

				StateMgr:push("state/state-auto-purchase-popup-maz.lua");

				return false;
			end

			App.data:unlockPlayerVehicle(vId);
			self.VendorList[1].vehicle[index].Lock:setVisible(false);
			self:callItemListIndexTasks(mode, index);
			self:updateModeButtonList();
			self:recreateVehicle();

         if not GuideMgr:isActive() then
				FeedMgr:shareScreenshot( "UnlockCar"..vId, 0.01 );
         end
		end

	elseif mode == "FrontWeaponMode" then
		index			= self.VendorList[2].index;

		if self:_isValidVehicleIndex(currentVehicle) then

			if not App.data:canUpgradePlayerMainWeapon(currentVehicle) then

				local cost = App.data:getPlayerMainWeaponUpgradeCost(currentVehicle);

				AUTO_PURCHASE_DATA.state      = 'StateGarage';
				AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
				AUTO_PURCHASE_DATA.reason1    = 'Upgrade-Main-Car';
				AUTO_PURCHASE_DATA.reason2    = 'Upgrade-Main-Car-'..currentVehicle;
				AUTO_PURCHASE_DATA.currency	= 'Coin';
				AUTO_PURCHASE_DATA.price		= cost.gold;
				self.keepRackOpen					= true;
				AUTO_PURCHASE_FUNC				=	function()
																self:purchaseItem();
															end

				StateMgr:push("state/state-auto-purchase-popup-maz.lua");

				return false;
			end

			App.data:upgradePlayerMainWeapon(currentVehicle);
			self:callItemListIndexTasks(mode, index);
			self:updateModeButtonList();

         if not GuideMgr:isActive() then
         	FeedMgr:shareScreenshot( "MainWeaponUpgrade", 0.01 );
         end

		end

	elseif mode == "TurretMode" then
		index			= self.VendorList[3].index;

		if self:_isValidVehicleIndex(currentVehicle) then

			if not App.data:canUpgradePlayerTurretWeapon(currentVehicle) then

				local cost = App.data:getPlayerTurretWeaponUpgradeCost(currentVehicle);

				if App.data:isPlayerTurretWeaponUnlocked(currentVehicle) then

					AUTO_PURCHASE_DATA.state      = 'StateGarage';
					AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
					AUTO_PURCHASE_DATA.reason1    = 'Upgrade-Turret-Car';
					AUTO_PURCHASE_DATA.reason2    = 'Upgrade-Turret-Car-'..currentVehicle;
					AUTO_PURCHASE_DATA.currency	= 'Coin';
					AUTO_PURCHASE_DATA.price		= cost.gold;
				else

					AUTO_PURCHASE_DATA.state      = 'StateGarage';
					AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
					AUTO_PURCHASE_DATA.reason1    = 'Unlock-Turret-Car';
					AUTO_PURCHASE_DATA.reason2    = 'Unlock-Turret-Car-'..currentVehicle;
					AUTO_PURCHASE_DATA.currency	= 'Gem';
					AUTO_PURCHASE_DATA.price		= cost.gem;
				end

				self.keepRackOpen						= true;
				AUTO_PURCHASE_FUNC					=	function()
																	self:purchaseItem();
																end

				StateMgr:push("state/state-auto-purchase-popup-maz.lua");

				return false;
			end

			App.data:upgradePlayerTurretWeapon(currentVehicle);
			self:updateVehicle("Turret", self:_getVehicleIndex(currentVehicle), TurretWpn_List[currentVehicle].Name, textureTurret);
			self:callItemListIndexTasks(mode, index);
			self:updateModeButtonList();

         if not GuideMgr:isActive() then
            if App.data:getPlayerTurretWeaponLevel( currentVehicle ) <= 1 then
               FeedMgr:shareScreenshot( "TurretUnlock", 0.01 );
            else
               FeedMgr:shareScreenshot( "TurretUpgrade", 0.01 );
            end
         end

		end

	elseif mode == "SideWeaponMode" then
		index			= self.VendorList[4].index;

		if self:_isValidVehicleIndex(currentVehicle) then

			if not App.data:canUpgradePlayerSideWeapon(currentVehicle) then

				local cost = App.data:getPlayerSideWeaponUpgradeCost(currentVehicle);

				if App.data:isPlayerSideWeaponUnlocked(currentVehicle) then
					AUTO_PURCHASE_DATA.state      = 'StateGarage';
					AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
					AUTO_PURCHASE_DATA.reason1    = 'Upgrade-Side-Car';
					AUTO_PURCHASE_DATA.reason2    = 'Upgrade-Side-Car-'..currentVehicle;
					AUTO_PURCHASE_DATA.currency	= 'Coin';
					AUTO_PURCHASE_DATA.price		= cost.gold;
				else
					AUTO_PURCHASE_DATA.state      = 'StateGarage';
					AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
					AUTO_PURCHASE_DATA.reason1    = 'Unlock-Side-Car';
					AUTO_PURCHASE_DATA.reason2    = 'Unlock-Side-Car-'..currentVehicle;
					AUTO_PURCHASE_DATA.currency	= 'Gem';
					AUTO_PURCHASE_DATA.price		= cost.gem;
				end

				self.keepRackOpen						= true;
				AUTO_PURCHASE_FUNC					=	function()
																	self:purchaseItem();
																end

				StateMgr:push("state/state-auto-purchase-popup-maz.lua");

				return false;
			end

			App.data:upgradePlayerSideWeapon(currentVehicle);
			self:updateVehicle("SideWeapon", self:_getVehicleIndex(currentVehicle), SideWpn_List[currentVehicle].Name, textureLibrary[currentVehicle].spriteSheet);
			self:callItemListIndexTasks(mode, index);
			self:updateModeButtonList();

         if not GuideMgr:isActive() then
            if App.data:getPlayerSideWeaponLevel( currentVehicle ) <= 1 then
               FeedMgr:shareScreenshot( "SideWeaponUnlock", 0.01 );
            else
               FeedMgr:shareScreenshot( "SideWeaponUpgrade", 0.01 );
            end
         end

		end

	elseif mode == "PaintMode" then
		index			= self.paintBuyIndex;

		if self:_isValidVehicleIndex(currentVehicle) then

			if not App.data:canUnlockPlayerVehiclePaintVariant(currentVehicle, index) then

				local cost = App.data:getPlayerVehiclePaintVariantUnlockCost(currentVehicle, index);

				AUTO_PURCHASE_DATA.state      = 'StateGarage';
				AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
				AUTO_PURCHASE_DATA.reason1    = 'Unlock-Paint-Car';
				AUTO_PURCHASE_DATA.reason2    = 'Unlock-Paint-Car-'..currentVehicle;
				AUTO_PURCHASE_DATA.currency	= 'Gem';
				AUTO_PURCHASE_DATA.price		= cost.gem;
				self.keepRackOpen					= true;
				AUTO_PURCHASE_FUNC				=	function()
																self:purchaseItem();
															end

				StateMgr:push("state/state-auto-purchase-popup-maz.lua");

				return false;
			end

			App.data:unlockPlayerVehiclePaintVariant( currentVehicle, index );
			self:updateVehicle("Body", self:_getVehicleIndex(currentVehicle), Paint_List[currentVehicle][index].Name, textureLibrary[currentVehicle].spriteSheet);
			self:callItemListIndexTasks(mode, index);
			self:updateModeButtonList();

         if not GuideMgr:isActive() then
            FeedMgr:shareScreenshot( "PaintJobUnlocked", 0.01 );
         end
		end

	elseif mode == "ArmorMode" then
		index			= self.VendorList[6].index;

		if self:_isValidVehicleIndex(currentVehicle) then

			if not App.data:canUpgradePlayerArmor(currentVehicle) then

				local cost = App.data:getPlayerArmorUpgradeCost(currentVehicle);

				AUTO_PURCHASE_DATA.state      = 'StateGarage';
				AUTO_PURCHASE_DATA.carIndex   = ""..currentVehicle;
				AUTO_PURCHASE_DATA.reason1    = 'Upgrade-Armor-Car';
				AUTO_PURCHASE_DATA.reason2    = 'Upgrade-Armor-Car-'..currentVehicle;
				AUTO_PURCHASE_DATA.currency	= 'Coin';
				AUTO_PURCHASE_DATA.price		= cost.gold;
				self.keepRackOpen					= true;
				AUTO_PURCHASE_FUNC				=	function()
																self:purchaseItem();
															end

				StateMgr:push("state/state-auto-purchase-popup-maz.lua");

				return false;
			end

			App.data:upgradePlayerArmor(currentVehicle);
			level = App.data:getPlayerArmorLevel(currentVehicle);

			if level > 1 then
				level = level - 1;
				self:updateVehicle("Armor", self:_getVehicleIndex(currentVehicle), Armor_List[currentVehicle][level].Name, textureLibrary[currentVehicle].spriteSheet);
			end

			self:callItemListIndexTasks(mode, index);
			self:updateModeButtonList();

         if not GuideMgr:isActive() then
            FeedMgr:shareScreenshot( "ArmorUpgrade", 0.01 );
         end
		end

	else

		return false;
	end

	--print("StateGarage:purchaseItem", mode, index, currentVehicle, level);

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateGarage:isInBoundary( x, y, xMin, xMax, yMin, yMax )

	if x >= xMin and x <= xMax then
		if y >= yMin and y <= yMax then

			return true;
		end
	end

	return false;

end

----------------------------------------------------------------

function StateGarage:swipeDown(screen, x, y)

	if y < SWIPE_MAX_Y and y > SWIPE_MIN_Y then
		if x < SWIPE_MAX_X and x > SWIPE_MIN_X then

--			print("Swipe On", x, y);

			self.SwipeOn = false;
			self.SwipeStartX = x;
			self.SwipeStartY = y;
		end
	end

	if math.isInBoundary(x, y, SWIPE_WIN_MIN_X, SWIPE_WIN_MAX_X, SWIPE_WIN_MIN_Y, SWIPE_WIN_MAX_Y) then
		self.slideInBound = true;
	end

	if not self.PurchaseRack.active then
		for i=1, #self.modeList do
			for j=1, #self.modeList[i] do
				if self.modeList[i][j] then
					if self.modeList[i][j]:isInside(x, y) then
						self.slideInBound = false;

						return true;
					end
				end
			end
		end
	end

	if self.PurchaseRack.active and self.GarageMode then

		local pivot, index, visObj, vehicle, purchasePivot, purchase = self:GetItemInfo(self.GarageMode);

		for i=1, #purchase do
			if purchase[i].buyButton then
				if purchase[i].buyButton:isInside(x, y) and purchase[i].buyButton:isEnabled() then
					self.slideInBound = false;

					return true;
				end
			end
		end
	end

end

----------------------------------------------------------------

function StateGarage:swipeOff(screen, x, y)

--	print("Swipe Off", x, y);

	if self:isInBoundary(x, y, -38, SWIPE_MAX_X, -355, 385) and not self.SwipeOn then
		self:hidePurchaseRack();
	end

	self.slideInBound = false;
	self.SwipeOn = false;
	self.SwipeStartX = nil;
	self.SwipeStartY = nil;

end

----------------------------------------------------------------

function StateGarage:swipeMove(parent, x, y)

	if not self.slideInBound then
		return false;
	end

	if y < SWIPE_MAX_Y and y > SWIPE_MIN_Y then
		if x < SWIPE_MAX_X and x > SWIPE_MIN_X then
			if self.SwipeStartX and self.SwipeStartY then
				if self:isUnderSwipeBuffer(x, y) then
--					print("Swipe within buffer");

					return false;
				end

--				print("Swipe Move", x, y);

				self.SwipeOn = true;
--				self:UpdateItemListPos(x, y);

				local deltaX = x - self.SwipeStartX;
				local deltaY = self.SwipeStartY - y;

				if			math.abs(deltaY) > SWIPE_MIN_DELTA_Y
					and	self.SwipeStartX >= SWIPE_CAR_MIN_X
					and	self.SwipeStartX <= SWIPE_CAR_MAX_X then
--					print("Swipe Move Y Complete", x, y);

					if deltaY > 0 then
						self:RegressItemList();
					else
						self:AdvanceItemList();
					end

					self.SwipeStartX = nil;
					self.SwipeStartY = nil;

					return true;
				end

				if deltaX < -SWIPE_MIN_DELTA_X then
--					print("Swipe Move -X Complete", x, y);

					self:hidePurchaseRack();
					self.SwipeStartX = nil;
					self.SwipeStartY = nil;

					return true;
				end

				if deltaX > SWIPE_MIN_DELTA_X then
--					print("Swipe Move X Complete", x, y);

					self:activatePrevRack();
					self.SwipeStartX = nil;
					self.SwipeStartY = nil;

					return true;
				end

			end
		end
	end

end

function StateGarage:isUnderSwipeBuffer( x, y )

	local deltaX = x - self.SwipeStartX;
	local deltaY = y - self.SwipeStartY;
	local delta = math.pow(deltaX, 2) + math.pow(deltaY, 2);

	delta = math.sqrt(delta);

	if delta < SWIPE_BUFFER then
		self.SwipeOn = false;

		return true;
	end

	return false;

end

----------------------------------------------------------------

function StateGarage:activatePrevRack()

	local mode = self.prevMode;

	if mode == "FrontWeaponMode" then
		self:setFrontWeaponMode();
	elseif mode == "TurretMode" then
		self:setTurretMode();
	elseif mode == "SideWeaponMode" then
		self:setSideWeaponMode();
	elseif mode == "PaintMode" then
		self:setPaintMode();
	elseif mode == "ArmorMode" then
		self:setArmorMode();
	end

end

----------------------------------------------------------------

function StateGarage:goPickUp()

	self.keepRackOpen = nil;

	StateMgr:push("state/state-pickup.lua");

end

----------------------------------------------------------------

function StateGarage:goDrone()

	if not App.data:getValue("new-unlock-drones", false) then
		App.data:setValue("new-unlock-drones", true);
	end

	StateMgr:push("state/state-drone-garage.lua");

end

----------------------------------------------------------------

function  StateGarage:goBack()

	self.keepRackOpen = nil;
   self:resetAutoAdvance();

	StateMgr:clear("state/state-ranking.lua");

end

----------------------------------------------------------------

return StateGarage;

----------------------------------------------------------------
