----------------------------------------------------------------

require('flash/flash-manager')
require('app/contact/contact-manager')
require('app/feed/feed-manager')
require('app/ranking/ranking-manager')
require('state/state');
require('state/banner/banner-manager');
require('state/resourceBar/resourceBar');
require('ui/ui-button/ui-button-image');
require('ui/ui-button/ui-button-anim');
require('ui/ui-scroll-list');
require('ui/ui-roll-out');
require('ui/ui-image');
require('ui/ui-anim');
require('state/guide/guide-manager')
require('app/promo/promo-manager')
require('engine/utility/tableUtil')
require('app/ad/native-ad-retriever')
require('engine/utility/tableUtil')

----------------------------------------------------------------

local SLIDE_MIN               = -App.viewportHeight/2;
local SLIDE_MAX               = App.viewportHeight/2;
local SWIPE_WIN_MIN_X         = -App.viewportWidth/2;
local SWIPE_WIN_MAX_X         = App.viewportWidth/2;
local SWIPE_WIN_MIN_Y         = -245;
local SWIPE_WIN_MAX_Y         = 285;
local ROLLOUT_X               = 0;
local ROLLOUT_Y               = 0;
local ROLLOUT_SHIFT           = 570;
local RANK_LIST_HOME_X        = 0;
local RANK_LIST_HOME_Y        = 220;
local RANK_LIST_SLIDE_LEFT    = -960;
local RANK_LIST_SPACING       = 132;
local RANK_DISPLAY_MAX        = 4;
local WEEKLY_X                = 0;
local WEEKLY_Y                = 330;
local KEY_TIME_X              = 175;
local KEY_TIME_Y              = -343;
local KEY_COUNT_X             = 10;
local KEY_COUNT_Y             = 0;
local PRIORTY_0               = 10;
local PRIORTY_1               = 20;
local PRIORTY_2               = 30;
local PRIORTY_3               = 40;
local PRIORTY_4               = 50;
local PRIORTY_5               = 60;
local PRIORTY_6               = 70;
local PRIORTY_7               = 80;
local PRIORTY_1000            = 11000;

local NOTIFICATION_OFFSET_X   = 47.5;
local NOTIFICATION_OFFSET_Y   = 36;

local WEEKLY_ONE_WEEK         = 7*24*60*60;

local LIST_STATE_LEAGUE       = "list-league";
local LIST_STATE_FRIENDS      = "list-friends";

local BOUNTY_STATE_ACTIVE     = 1;
local BOUNTY_STATE_READY      = 2;
local BOUNTY_STATE_COLLECTING = 3;
local BOUNTY_STATE_INACTIVE   = 4;
local BOUNTY_ANIM_TIME        = 0.25;
local BOUNTY_ICON_WIDTH       = 48;
local BOUNTY_ICON_HEIGHT      = 48;
local BOUNTY_IMAGE_RETICLE    = "resources/UI/Bounty/Icon_GhostBountyButton_Reticle.png";
local BOUNTY_IMAGE_CHECK      = "resources/UI/Bounty/Icon_GhostBountyButton_Checkmark.png";
local AD_ICON                 = "resources/UI/AdStarburst.png";
local INFO_BUTTON             = "resources/UI/info_button.png";

local USER_NAME_FONT_SIZE     = 16;
local USER_SCORE_FONT_SIZE    = 18;
local USER_LEVEL_FONT_SIZE    = 12;

local GO_HINT_SCREEN                 = false;
local DEBUG_PROMOS_ON                = false;
local BOUNTY_INTRO_HACK              = false;
local HACK_BOUNTY_COUNT              = nil;
local HACK_ALWAYS_SHOW_STARTER_PROMO = false;
local HACK_LEAGUE_RESULT_POPUP       = false;

if not BUILD_DEBUG then
   DEBUG_PROMOS_ON            = false;
   BOUNTY_INTRO_HACK          = false;
   HACK_BOUNTY_COUNT          = nil;
   HACK_LEAGUE_RESULT_POPUP   = false;
end

----------------------------------------------------------------

local REWARD_POS                      =
{
    left    = {iconX = 30,  iconY = 0, textX = 95, textY = 0},
    right   = {iconX = 900, iconY = 0, textX = 1030, textY = 0},
};

local LEAGUE_TAB =
{
   "resources/UI/League/LB_diamondtab.png",    -- diamond
   "resources/UI/League/LB_plattab.png",       -- platinum
   "resources/UI/League/LB_goldtab.png",       -- gold
   "resources/UI/League/LB_silvertab.png",     -- silver
   "resources/UI/League/LB_bronzetab.png",     -- bronze
};

local LEAGUE_INSET =
{
   "resources/UI/League/LB_insetDmnd.png",     -- diamond
   "resources/UI/League/LB_insetPlat.png",     -- platinum
   "resources/UI/League/LB_insetGold.png",     -- gold
   "resources/UI/League/LB_insetSilver.png",   -- silver
   "resources/UI/League/LB_insetBronze.png",   -- bronze
};

local LEAGUE_BANNER =
{
   "resources/UI/League/LB_diamondbanner.png", -- diamond
   "resources/UI/League/LB_platbanner.png",    -- platinum
   "resources/UI/League/LB_goldbanner.png",    -- gold
   "resources/UI/League/LB_silverbanner.png",  -- silver
   "resources/UI/League/LB_bronzebanner.png",  -- bronze
};

local LEAGUE_BACKPLATE =
{
   "resources/UI/League/LB_backDmnd.png",      -- diamond
   "resources/UI/League/LB_backPlat.png",      -- platinum
   "resources/UI/League/LB_backGold.png",      -- gold
   "resources/UI/League/LB_backSilver.png",    -- silver
   "resources/UI/League/LB_backBronze.png",    -- bronze
};

local LEAGUE_BACKPLATE_PLAYER =
{
   "resources/UI/League/LB_pbackDmnd.png",     -- diamond
   "resources/UI/League/LB_pbackPlat.png",     -- platinum
   "resources/UI/League/LB_pbackGold.png",     -- gold
   "resources/UI/League/LB_pbackSilver.png",   -- silver
   "resources/UI/League/LB_pbackBronze.png",   -- bronze
};

local LEAGUE_TROPHY =
{
   "resources/UI/League/LC_trophy-dmnd.png",
   "resources/UI/League/LC_trophy-plat.png",
   "resources/UI/League/LC_trophy-gold.png",
   "resources/UI/League/LC_trophy-silv.png",
   "resources/UI/League/LC_trophy-brnz.png",
};

----------------------------------------------------------------
local Base              = State;
local StateRanking      = Base:new();
----------------------------------------------------------------

function  StateRanking:onLoad()

   State.onLoad( self );

--    self.isSameSession = false;
   self.name   = "state-ranking";
   self.lastKeyTextUpdate = 0;
    App:CheckStatuses();

   self.defaultFontName = "resources/font/TangoLatin.otf";
   self.unicodeFontName = "resources/font/Tango.otf";
   self.textureSheet    = FlashMgr:getTextureSheet("resources/flash-resource-bundle/MainScreen.lua", "resources/flash-resource-bundle/MainScreen.png", 30);
   self.textureSheet2   = FlashMgr:getTextureSheet("resources/flash-resource-bundle/Group2.lua", "resources/flash-resource-bundle/Group2.png", 30);

   -- background and frames
   self.BackDrop = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IBBackDrop", self.textureSheet);
   self.BackDrop:setPriority(1);
   self.BackDrop:setColor(0.7, 0.7, 0.7, 1);
   self.Frame = self:addWidget(Anim, self.mainLayer, 0,0, 640/2, 1136/2, "IBScrollFrame", self.textureSheet);
   self.Frame:setPriority(PRIORTY_4);

   -- push/pop state buttons
   self.PlayButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 170, -422, 0,0, "PlayButton", self.textureSheet, nil, self.goGame, nil, nil);
   self.PlayButton:setPriority(PRIORTY_6);

   -- play game anim
   self.KeyUseAnim = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "UsedKey", self.textureSheet);
   self.KeyUseAnim:setPriority(PRIORTY_1000);

   -- tap screen Button
   self._guideLeagueScrnButton = self:addWidget(ButtonImage, self.mainLayer, 0,0, 1400, 1200, "resources/square.png", nil, nil, nil, nil);
   self._guideLeagueScrnButton:setPriority(PRIORITY_0);
   self._guideLeagueScrnButton:setColor(1,1,1,0);

   -- resource bar
   self:_setupBasicResourceBar();

   -- scrolling list object
   self.ScrollList = self:addWidget( ScrollList,
                                     self.mainLayer,
                                     RANK_LIST_HOME_X, RANK_LIST_HOME_Y,
                                     { {SWIPE_WIN_MIN_X, SWIPE_WIN_MAX_X}, {SWIPE_WIN_MIN_Y, SWIPE_WIN_MAX_Y} },
                                     nil,
                                     nil,
                                     { 0, (1/40)*RANK_LIST_SPACING },
                                     { nil, RANK_LIST_SPACING },
                                     { 0, 1 },
                                     nil,
                                     { 100, 50 },
                                     {0, RANK_LIST_SPACING},
                                     nil,
                                     { {-200, 200}, {SLIDE_MIN, SLIDE_MAX} },
                                     nil, nil, nil, nil, nil, nil,
                                     "ScrollBarButton", self.textureSheet, 12, 0, 145, PRIORTY_5 );

   self.ScrollListF = self:addWidget( ScrollList,
                                      self.mainLayer,
                                      RANK_LIST_HOME_X, RANK_LIST_HOME_Y,
                                      { {SWIPE_WIN_MIN_X, SWIPE_WIN_MAX_X}, {SWIPE_WIN_MIN_Y, SWIPE_WIN_MAX_Y} },
                                      nil,
                                      nil,
                                      { 0, (1/40)*RANK_LIST_SPACING },
                                      { nil, RANK_LIST_SPACING },
                                      { 0, 1 },
                                      nil,
                                      { 100, 50 },
                                      {0, RANK_LIST_SPACING},
                                      nil,
                                      { {-200, 200}, {SLIDE_MIN, SLIDE_MAX} },
                                      nil, nil, nil, nil, nil, nil,
                                      "ScrollBarButton", self.textureSheet, 12, 0, 145, PRIORTY_5 );

   -- rollout object
   self.RollOut = self:addWidget( RollOut,
                                  self.mainLayer,
                                  self.mainPartition,
                                  ROLLOUT_X, ROLLOUT_Y,
                                  {ROLLOUT_SHIFT, 0},
                                  "IconTryOut", self.textureSheet, 0, 0, PRIORTY_6,
                                  "IconTryInButton", self.textureSheet, 0, 0, PRIORTY_7,
                                  "IconTryOutButton", self.textureSheet, 0, 0, PRIORTY_7 );


   self:createEntryCache();
   self:createRollOut();

end

------------------------------------------------------------------------------------

function StateRanking:onActivate()

   Base.onActivate(self);

   if not self.GarageButton then
      if DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking() then

         -- Create two square garage buttons: car and drone
         self.GarageButton = self:addWidget(ButtonImage, self.mainLayer, -225, -423, 155, 106, "resources/UI/car_garage_grey.png", nil, self.goGarage, nil, nil);
         self.GarageButtonNewBadge  = self:addWidget(Anim, self.mainLayer, -53, 35, 0,0, "NEWShopButton", self.textureSheet, nil, nil, true);
         self.GarageButtonSaleBadge = self:addWidget(Anim, self.mainLayer, -48, 31, 0,0, "SALEShopButton", self.textureSheet, nil, nil, true);
         self.GarageNewBadgeShdw    = self:addWidget(Image, self.mainLayer, 7, -5, 66, 25, "resources/square.png", {0, 0, 0, 0.35});
         self.GarageSaleBadgeShdw   = self:addWidget(Image, self.mainLayer, 8, -5, 80, 30, "resources/square.png", {0, 0, 0, 0.35});

         self.GarageNewBadgeShdw:setPriority(PRIORTY_7-1);
         self.GarageNewBadgeShdw:setRot(28);
         self.GarageNewBadgeShdw:setParent(self.GarageButtonNewBadge.anim);
         self.GarageSaleBadgeShdw:setPriority(PRIORTY_7-1);
         self.GarageSaleBadgeShdw:setRot(28);
         self.GarageSaleBadgeShdw:setParent(self.GarageButtonSaleBadge.anim);

         self.GarageButton:setPriority(PRIORTY_6);
         self.GarageButtonNewBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
         self.GarageButtonNewBadge:setPriority(PRIORTY_7);
         self.GarageButtonNewBadge:setScale(0.75, 0.75);
         self.GarageButtonNewBadge:setVisible(false);
         self.GarageButtonSaleBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
         self.GarageButtonSaleBadge:setPriority(PRIORTY_7);
         self.GarageButtonSaleBadge:setScale(0.75, 0.75);
         self.GarageButtonSaleBadge:setVisible(false);

         -- drone buttons
         self.DroneButton = self:addWidget(ButtonImage, self.mainLayer, -62, -423, 155, 106, "resources/UI/drone_garage_grey.png", nil, self.goDrone, nil, nil);
         self.DroneButtonNewBadge   = self:addWidget(Anim, self.mainLayer, -53, 35, 0,0, "NEWShopButton", self.textureSheet, nil, nil, true);
         self.DroneButtonSaleBadge  = self:addWidget(Anim, self.mainLayer, -48, 31, 0,0, "SALEShopButton", self.textureSheet, nil, nil, true);
         self.DroneNewBadgeShdw     = self:addWidget(Image, self.mainLayer, 7, -5, 66, 25, "resources/square.png", {0, 0, 0, 0.35});
         self.DroneSaleBadgeShdw        = self:addWidget(Image, self.mainLayer, 8, -5, 80, 30, "resources/square.png", {0, 0, 0, 0.35});

         self.DroneNewBadgeShdw:setPriority(PRIORTY_7-1);
         self.DroneNewBadgeShdw:setRot(28);
         self.DroneNewBadgeShdw:setParent(self.DroneButtonNewBadge.anim);
         self.DroneSaleBadgeShdw:setPriority(PRIORTY_7-1);
         self.DroneSaleBadgeShdw:setRot(28);
         self.DroneSaleBadgeShdw:setParent(self.DroneButtonSaleBadge.anim);

         self.DroneButton:setPriority(PRIORTY_6);
         self.DroneButtonNewBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.DroneButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
         self.DroneButtonNewBadge:setPriority(PRIORTY_7);
         self.DroneButtonNewBadge:setScale(0.75, 0.75);
         self.DroneButtonNewBadge:setVisible(false);
         self.DroneButtonSaleBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.DroneButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
         self.DroneButtonSaleBadge:setPriority(PRIORTY_7);
         self.DroneButtonSaleBadge:setScale(0.75, 0.75);
         self.DroneButtonSaleBadge:setVisible(false);
      else

         -- Create one large car garage button
         self.GarageButton          = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "ShopButton", self.textureSheet, nil, self.goGarage, nil, nil);
         self.GarageButtonNewBadge  = self:addWidget(Anim, self.mainLayer, 8, 44, 0,0, "NEWShopButton", self.textureSheet, nil, nil, true);
         self.GarageButtonSaleBadge = self:addWidget(Anim, self.mainLayer, 10, 40, 0,0, "SALEShopButton", self.textureSheet, nil, nil, true);

         self.GarageButton:setPriority(PRIORTY_6);
         self.GarageButtonNewBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.anim.props[3], MOAIProp2D.TRANSFORM_TRAIT );
         self.GarageButtonNewBadge:setPriority(PRIORTY_7);
         self.GarageButtonNewBadge:setVisible(false);
         self.GarageButtonSaleBadge.anim:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.anim.props[3], MOAIProp2D.TRANSFORM_TRAIT );
         self.GarageButtonSaleBadge:setPriority(PRIORTY_7);
         self.GarageButtonSaleBadge:setVisible(false);
      end
   end

   if LeagueMgr:isLeagueEnabled() then
      self:_activateLeagueUI();
   elseif not LeagueMgr:isLeagueEnabled() then
      self:_activateNonLeagueUI();
   end

   if self._ListState == nil then
      self._ListState = LIST_STATE_FRIENDS;
   end

   if self.resourceBar then
      self.resourceBar:createConsumableButton();
   end

   --We waited so long to give a chance to ab-test to get the value it asked for
   App.data:setRegenKeyEnable(true);

   LoaderMgr:addTask( nil, self, function () StateMgr:loadState ( "state/state-options.lua" ) end );
   MessageMgr:setEnableAutoCheck( true );

   self:_setupAutoFeed();

   self:_TryAutoAuthenticate();

end

function StateRanking:_activateLeagueUI()

   if self.LeagueTabOn then
      -- League UI has already been created; we don't want to recreate it
      return;
   end

   -- Title Text and dont add if in less than 16:9 aspect ratio
   self.Title = self:addWidget(Image, self.mainLayer, 0, 480, 414*0.9, 70*0.9, "resources/UI/League/LB_Title.png");
   self.Title:setPriority(PRIORTY_5);

   -- League Info
   self.leagueInfo    = self:addWidget(ButtonImage, self.mainLayer, 225, 480, 48, 48, INFO_BUTTON, nil, self.goLeagueInfo, nil, nil);
   self.leagueSparkle = self:addWidget(Anim, self.mainLayer, 225, 480, 0,0, "NotificationSparkle", self.textureSheet);

   self.leagueInfo:setPriority(PRIORTY_6);
   self.leagueSparkle:setPriority(PRIORTY_6-1);
   self.leagueInfo:setInputXtra( 24, 24 );
   self.leagueInfo:setPressedScale( 1.25, 1.25 );
   self.leagueSparkle:setScale(1.25, 1.25);
   self.leagueSparkle:setSpan(29/30);
   self.leagueSparkle:setMode(MOAITimer.LOOP);
   self.leagueSparkle:setVisible(false);

   -- League Tabs
   self.LeagueTabOn       = self:addWidget(ButtonImage, self.mainLayer, 150, 320, 290, 70, LEAGUE_TAB[1], nil, self._showLeagueList, nil, nil);
   self.LeagueTabInset    = self:addWidget(Image, self.mainLayer, 95, -2, 48, 48, LEAGUE_INSET[1]);
   --self.LeagueTabOff      = self:addWidget(Image, self.mainLayer, 0,0, 290, 70, "resources/UI/League/LB_tabcover.png");
   self.LeagueText        = self:addWidget(TextBox, self.mainLayer, 30, -2, 290, 100, "I", self.defaultFontName, 18, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.LeagueTextShdw    = self:addWidget(TextBox, self.mainLayer, 30+2, -2-2, 290, 100, "I", self.defaultFontName, 18, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   self.LeagueDivText     = self:addWidget(TextBox, self.mainLayer, 95, -2, 290, 100, "I", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.LeagueDivTextShdw = self:addWidget(TextBox, self.mainLayer, 95+2, -2-2, 290, 100, "I", self.defaultFontName, 13, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   self.FriendTabOn       = self:addWidget(ButtonImage, self.mainLayer, -150, 320, 290, 70, "resources/UI/League/LB_friendstab.png", nil, self._showFriendList, nil, nil);
   --self.FriendTabOff      = self:addWidget(Image, self.mainLayer, 0,0, 290, 70, "resources/UI/League/LB_tabcover.png");
   self.FriendTabTxt      = self:addWidget(TextBox, self.mainLayer, 0, -2, 290, 100, "FRIENDS", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.FriendTabTxtShdw  = self:addWidget(TextBox, self.mainLayer, 0, -2, 290, 100, "FRIENDS", self.defaultFontName, 18, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});

   self.LeagueTabOn:setPriority(PRIORTY_6);
   self.LeagueTabInset:setPriority(PRIORTY_6+1);
   --self.LeagueTabOff:setPriority(PRIORTY_7);
   self.LeagueTabOn:setPressedScale(1.1, 1);
   self.LeagueTabOn:setInputXtra(0, 20);
   self.LeagueText:setPriority(PRIORTY_6+3);
   self.LeagueTextShdw:setPriority(PRIORTY_6+2);
   self.LeagueDivText:setPriority(PRIORTY_6+3);
   self.LeagueDivTextShdw:setPriority(PRIORTY_6+2);
   self.FriendTabOn:setPriority(PRIORTY_6);
   --self.FriendTabOff:setPriority(PRIORTY_7);
   self.FriendTabOn:setPressedScale(1.1, 1);
   self.FriendTabOn:setInputXtra(0, 20);
   self.FriendTabTxt:setPriority(PRIORTY_6+3);
   self.FriendTabTxtShdw:setPriority(PRIORTY_6+2);

   self.LeagueTabInset:setAttrLink(    MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   --self.LeagueTabOff:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   self.LeagueText:setAttrLink(        MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   self.LeagueTextShdw:setAttrLink(    MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   self.LeagueDivText:setAttrLink(     MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   self.LeagueDivTextShdw:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   --self.FriendTabOff:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, self.FriendTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   self.FriendTabTxt:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, self.FriendTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
   self.FriendTabTxtShdw:setAttrLink(  MOAIProp2D.INHERIT_TRANSFORM, self.FriendTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );

   -- Timer
   self.TimerText     = self:addWidget(TextBox, self.mainLayer, 90, 400, 640, 100, "", self.defaultFontName, 15, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.TimerTextShdw = self:addWidget(TextBox, self.mainLayer, 93, 397, 640, 100, "", self.defaultFontName, 15, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   self.TimerText:setPriority(PRIORTY_6+1);
   self.TimerTextShdw:setPriority(PRIORTY_6);

   if App.viewHeight/App.viewWidth <= 1.7 then
      self.Title:setScale(0.75, 0.75);
      self.Title:setLoc(0, 445);
      self.leagueInfo:setScale(0.75, 0.75);
      self.leagueInfo:setLoc(170, 445);
      self.leagueSparkle:setScale(1, 1);
      self.leagueSparkle:setLoc(170, 445);
      self.TimerText:setLoc(90, 385);
      self.TimerTextShdw:setLoc(93, 382);
   end

   local leagueObjects = self.ScrollList:getEntryCacheObject(1);

   if     leagueObjects
      and leagueObjects.rbanner then

      --ref for league guide
      self._guideRoot               = leagueObjects.root;
      self._guideLeagueBanner       = leagueObjects.rbanner;
      self._guideLeagueArrow        = leagueObjects.arrowUp;
      self._guideLeagueInfo         = self.leagueInfo;
      self._guideLeagueSparkle      = self.leagueSparkle;
      self._guideLeagueInset        = leagueObjects.rInset;
      self._guideLeagueInsetTxt     = leagueObjects.insetTxt;
      self._guideLeagueInsetTxtShdw = leagueObjects.insetTxtShdw;
      self._guideLeagueRwdText      = leagueObjects.rwrdTxt;
      self._guideLeagueRwdTextShdw  = leagueObjects.rwrdTxtShdw;
      self._guideLeagueRwdTxtL      = leagueObjects.rwrdTxtL;
      self._guideLeagueRwdGemL      = leagueObjects.rewardGemL;
      self._guideLeagueTimeTxt      = self.TimerText;
      self._guideLeagueTimeTxtShdw  = self.TimerTextShdw;
   end

   local friendObjects = self.ScrollListF:getEntryCacheObject(1);

   if friendObjects and friendObjects.root then

      --ref for friend guide
      self._guideFRoot           = friendObjects.root;
      self._guideFBanner         = friendObjects.banner;
      self._guideFPic            = friendObjects.portrait;
      self._guideFPicFrame       = friendObjects.picFrame;
      self._guideFName           = friendObjects.userName;
      self._guideFScore          = friendObjects.userScore;
      self._guideFLevel          = friendObjects.userLevel;
      self._guideFGift           = friendObjects.gift;
      self._guideFBadge          = friendObjects.badge_1;
      self._guideFTabF           = self.FriendTabOn;
      self._guideFTabFTxt        = self.FriendTabTxt;
      self._guideFTabFTxtShdw    = self.FriendTabTxtShdw;
      self._guideFTabL           = self.LeagueTabOn;
      self._guideFTabLInset      = self.LeagueTabInset;
      self._guideFTabLTxt        = self.LeagueText;
      self._guideFTabLTxtShdw    = self.LeagueTextShdw;
      self._guideFTabLDvTxt      = self.LeagueDivText;
      self._guideFTabLDvTxtShdw  = self.LeagueDivTextShdw;
      self._guideFBannerBackup   = friendObjects.banner;
      self._guideFGiftBackup     = friendObjects.gift;
   end

end

function StateRanking:_activateNonLeagueUI()

   if self.InviteButton then
      -- Non-league UI has already been created; we don't want to recreate it
      return;
   end

   -- Title Text
   self.Title = self:addWidget(Image, self.mainLayer, 0, 430, 414*0.9, 70*0.9, "resources/UI/League/LB_Title.png");
   self.Title:setPriority(PRIORTY_5);

   -- top invite button
   self.InviteButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "InviteButton", self.textureSheet, nil, self.goInvite, nil, nil, nil, nil, 20);
   self.InviteButton:setPriority(PRIORTY_6);

   self.InviteRewardIcon = self:addWidget(Anim, self.mainLayer, 143,0,0,0, "BuyButtonCoin", self.textureSheet, nil, nil, true);
   self.InviteRewardIcon:setParent(self.InviteButton.anim.props[2]);
   self.InviteRewardIcon:setPriority(PRIORTY_6+1);

   self.InviteRewardTitle = self:addWidget(TextBox, self.mainLayer, 143, 0, 280, 60, 'Invite Friend', self.defaultFontName, 14.4, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.InviteRewardTitle:setParent(self.InviteButton.anim.props[2]);
   self.InviteRewardTitle:setPriority(PRIORTY_6+1);

   self.InviteRewardText = self:addWidget(TextBox, self.mainLayer, 143,0, 280, 60, '', self.defaultFontName, 14.4, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.InviteRewardText:setParent(self.InviteButton.anim.props[2]);
   self.InviteRewardText:setPriority(PRIORTY_6+1);

   -- top video button
   self.VideoButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "InviteButton", self.textureSheet, nil, self.goVideoPromo, nil, self._toggleList, nil, nil, 20);
   self.VideoButton:setPriority(PRIORTY_6);
   self.VideoButton:setVisible(false);
   self.VideoButton:disable();

   self.VideoRewardIcon = self:addWidget(Anim, self.mainLayer, 143,0,0,0, "BuyButtonCoin", self.textureSheet, nil, nil, true);
   self.VideoRewardIcon:setParent(self.VideoButton.anim.props[2]);
   self.VideoRewardIcon:setPriority(PRIORTY_6+1);
   self.VideoRewardIcon:setVisible(false);

   self.VideoRewardTitle = self:addWidget(TextBox, self.mainLayer, 143, 0, 280, 60, "Earn Coins", self.defaultFontName, 14.4, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.VideoRewardTitle:setParent(self.VideoButton.anim.props[2]);
   self.VideoRewardTitle:setPriority(PRIORTY_6+1);
   self.VideoRewardTitle:setVisible(true);

   self.VideoRewardText = self:addWidget(TextBox, self.mainLayer, 113,0, 280, 60, "", self.defaultFontName, 14.4, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.VideoRewardText:setParent(self.VideoButton.anim.props[2]);
   self.VideoRewardText:setPriority(PRIORTY_6+1);
   self.VideoRewardText:setVisible(false);

   -- weekly rank reset time and keys
   self.WeeklyText = self:addWidget(TextBox, self.mainLayer, WEEKLY_X, WEEKLY_Y, 580, 75, ' ', self.defaultFontName, 14, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.WeeklyText:setPriority(PRIORTY_6);
   self.WeeklyTextShd = self:addWidget(TextBox, self.mainLayer, WEEKLY_X+2, WEEKLY_Y-2, 580, 75, ' ', self.defaultFontName, 14, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.WeeklyTextShd:setPriority(PRIORTY_6-1);
   self.WeeklyTimeText = self:addWidget(TextBox, self.mainLayer, WEEKLY_X-150, WEEKLY_Y+1, 580, 75, ' ', self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.WeeklyTimeText:setPriority(PRIORTY_6);
   self.WeeklyTimeTextShd = self:addWidget(TextBox, self.mainLayer, WEEKLY_X-150+2, WEEKLY_Y+1-2, 580, 75, ' ', self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.WeeklyTimeTextShd:setPriority(PRIORTY_6-1);
end

----------------------------------------------------------------

function StateRanking:onDeactivate( )

   Base.onDeactivate(self);

end

------------------------------------------------------------------------------------

function StateRanking:onFocus()

   Base.onFocus(self);

    if UpdateMgr:isUpdateMandatory() then
         MOAIDialogIOS.showDialog(    LocalizationMgr:getString( "NATIVE_UPDATE_TITLE" )
                           ,    LocalizationMgr:getString( "NATIVE_UPDATE_MSG" )
                           ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                           ,  nil
                           ,  nil
                           ,  false
                           ,  function()
                                 App:gotoUpdatePage();
                              end
                        );
        return;
    end

   self.startingGame = false;
   self.willShowGuide = false;

   self.ScrollList:enable();
   self:onLeagueGuideExit();
   self:_updateRankingList();
   self:enableAds();
   App.data:updateRewardLevel();
   self.KeyUseAnim:stop();
   self.KeyUseAnim:setVisible(false);
   App:updateMissionActivate();
   App:updateAchievementActivate();

   if not App.data:getValue("unlock-mystery-freebie" ) then
      if App.data:isMysteryUnlocked() then
         local t = App.data:getFreebieCount("mystery");
         if t and t <= 0 then
            App.data:setValue("unlock-mystery-freebie", true );
            App.data:giveFreebie("mystery", 1, "Unlock Mystery");
         else
            App.data:setValue("unlock-mystery-freebie", true );
         end
      end
   end

   --This is to force picking an AB cohort asap
   AbTestMgr:getRewardInfoTableMap();

   local seenDaily          = App.data:getValue('hasSeenDaily');
   local dailyReward        = App.data:getDailyChallengeRewardToCollect();
   local missionComplete    = App.data:isCurrentMissionCompleted();
   local achvComplete       = AchievementMgr:isPendingRewards();

   -- if they have deleted their local data, but a mission is complete, set the variable.
   if missionComplete then
      local mGames = App.data:getValue("mission-games-since-complete");
      if not mGames or mGames == -1 then
         App.data:setValue( "mission-games-since-complete", 0 );
      end
   end

   if dailyReward then
      local dGames = App.data:getValue("daily-games-since-complete");
      if not dGames or dGames == -1 then
         App.data:setValue( "daily-games-since-complete", 0 );
      end
   end

   if achvComplete then
      local aGames = App.data:getValue("achv-games-since-complete");
      if not aGames or aGames == -1 then
         App.data:setValue( "achv-games-since-complete", 0 );
      end
   end

   self:updateGarageArrow();
   self:updateDroneArrow();

   self:videoButtonSetup();
   self:videoButtonCheck();
   self:holidayButtonCheck();
   self:carSaleButtonCheck();

   if not LeagueMgr:isLeagueEnabled() and not self.videoSwap then
      self:setInviteButtonText();
   end

   if BountyMgr:isBountyResetTime() then
      BountyMgr:resetBounty();
   end

   if self:_canShowRewardScreen() then
      self:_updateRankingList();

      if self:_showRewardScreen() then
         return; -- XXX RETURN HERE
      end
   end

   self:_updateKeyInfo();

   EventMgr:addListener(self, self.onNewPofilePicture, "new-profile-picture");
   EventMgr:addListener(self, self._updateRankingList, "ghost-tango-authenticate-update");

   if App.data:getValue("garage-carSale-show") then
      self.GarageButtonSaleBadge:setVisible(true);

      if DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking() then
         self.GarageButtonSaleBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
         self.GarageSaleBadgeShdw:setVisible(true);
      else
         self.GarageButtonSaleBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.anim.props[3], MOAIProp2D.TRANSFORM_TRAIT );
      end
   else
      self.GarageButtonSaleBadge:setParent(nil);
      self.GarageButtonSaleBadge:clearAttrLink ( MOAIProp2D.ATTR_VISIBLE );
      self.GarageButtonSaleBadge:clearAttrLink ( MOAIProp2D.INHERIT_TRANSFORM );
      self.GarageButtonSaleBadge:setVisible(false);


      if DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking() then
         self.GarageSaleBadgeShdw:setVisible(false);
      end
   end

   if App.data:getValue("garage-newCar-show") then
      self.GarageButtonNewBadge:setVisible(true);
      self.GarageButtonSaleBadge:setVisible(false);

      if DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking() then
         self.GarageButtonNewBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.prop, MOAIProp2D.TRANSFORM_TRAIT );
         self.GarageNewBadgeShdw:setVisible(true);
         self.GarageSaleBadgeShdw:setVisible(false);
      else
         self.GarageButtonNewBadge:setAttrLink ( MOAIProp2D.INHERIT_TRANSFORM, self.GarageButton.anim.props[3], MOAIProp2D.TRANSFORM_TRAIT );
      end
   else
      self.GarageButtonNewBadge:setParent(nil);
      self.GarageButtonNewBadge:clearAttrLink ( MOAIProp2D.ATTR_VISIBLE );
      self.GarageButtonNewBadge:clearAttrLink ( MOAIProp2D.INHERIT_TRANSFORM );
      self.GarageButtonNewBadge:setVisible(false);

      if DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking() then
         self.GarageNewBadgeShdw:setVisible(false);
      end
   end

   if DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking() then
      if not DroneMgr:isDroneLevelLocked() and not App.data:getValue("new-unlock-drones", false) and not DroneMgr:anyDroneCollected() then
         self.DroneButtonNewBadge:setVisible(true);
         self.DroneNewBadgeShdw:setVisible(true);
         self.DroneButtonSaleBadge:setVisible(false);
         self.DroneSaleBadgeShdw:setVisible(false);
      else
         self.DroneButtonNewBadge:setVisible(false);
         self.DroneNewBadgeShdw:setVisible(false);
      end
   end

   -- Guide check needs to happen before pop up.  Otherwise they might overlap.
   if not AdMgr:isInterstitialShowing() then
      self:guideCheck();
      PromoMgr:attemptPopUpDisplay();
   end

   if App.data:getCurrentPlayerLevel() >= App.data:getConsumableUnlockLevel() then
      local cEnabled = App.data:getValue("consumables-enabled" );
      if not cEnabled then
         App.data:setValue("consumables-enabled", true );
      end
   end

   if BOUNTY_INTRO_HACK then
      if self.bhack then
         self.bhack = nil;
         GuideMgr:addSet("bounty_weekly_reset");
      else
         GuideMgr:addSet("bounty_intro");
         self.bhack = true;
      end
   end

    self:offerCheck();

   local rollOutOpen = self.RollOut:updateRollOutAutoOpen();

end

function StateRanking:offerCheck()

    self.willShowGuide = GuideMgr:isActive() or GuideMgr:isBusy();

    if not AdMgr:isInterstitialShowing() and not self.willShowGuide  and App.data:getCurrentPlayerLevel() > 2 and not App.isSameOfferSession then

        App.isSameOfferSession = true;
        local offerLaunchCount = App.data:getValue("offer-launch-count");
        local prevLaunchCount = 0;

        if not offerLaunchCount then
            offerLaunchCount = -1;
        end

        prevLaunchCount = offerLaunchCount;

        if offerLaunchCount > 1 then offerLaunchCount = -1 end


        offerLaunchCount = offerLaunchCount + 1;
        App.data:setValue("offer-launch-count",offerLaunchCount);

        if prevLaunchCount == 1 then
            StateMgr:push( "state/state-promo-popup-offers.lua");
        end
    end
end

----------------------------------------------------------------

function StateRanking:onDataMerged()

   Base.onDataMerged(self);

   if not GuideMgr:isActive() and not GuideMgr:isBusy() then
      self:_updateRankingList();
   end

end

----------------------------------------------------------------

function StateRanking:onLoseFocus( )

   Base.onLoseFocus(self);

   EventMgr:rmvListener( self );

   --For now, we only enable ads on this page
   self:disableAds();

   AdMgr:clearAdImpressions();

   if not GuideMgr:isActive() and not GuideMgr:isBusy() then
      self:_deleteBountyEntryList();
   end

end

----------------------------------------------------------------

function StateRanking:_shouldShowGameCenter()

   if (self.GameCenterButton and MOAIGameCenterIOS) then
      return AbTestMgr:isGameCenterEnabled() and MOAIGameCenterIOS:isAuthenticated();
   end

end

----------------------------------------------------------------

function StateRanking:onEnterForeground( )

   Base:onEnterForeground( );

    if self.focus then
        self:offerCheck();
    end
end

----------------------------------------------------------------

function StateRanking:onUpdate( dt )

   Base.onUpdate( self, dt );

   if MessageMgr:anyGiftWaiting() then
      MessageMgr:consumeGift();
   end

   if self:_shouldUpdateKeyInfo() then
      self:_updateKeyInfo();
   end

   if self.bountyVFXList and #self.bountyVFXList > 0 then
      self:updateBountyVFX(dt);
   end

   self:_updateNativeAds(dt)
end

----------------------------------------------------------------

-- Handle native ad visibility for ad impressions
function StateRanking:_updateNativeAds(dt)

   for i, v in ipairs(self.EntryList) do
      if v.tangoID == "NativeAd" and self.ScrollList:isEntryInView(i, 0, 0) then
         Debug.assert(v.adUID, "Ad was missing a UID!?");

         local ad = AdMgr:findNativeAdWithUID(v.adUID);

         if Debug.assertType(ad, {"table", "userdata"}, "StateRanking:_updateNativeAds -> ad") then
            AdMgr:handleNativeAdImpression(ad);
         end
      end
   end

end

----------------------------------------------------------------

function StateRanking:_setupAutoFeed()

   if FeedMgr:isEnable() then

      if not App.data:getValue("feed_enabling_default_set") then

         App.data:setValue("feed_enabling_default_set", true);

         if AbTestMgr:getFeedEnablingDefault() then
            App.data:setValue( "feed_notification_active", true );
         end

      end
   end

end

----------------------------------------------------------------

function StateRanking:_canShowRewardScreen()

   if not OnlineMgr:isOnline() and LeagueMgr:isLeagueEnabled() then
      return false;
   end

   if LeagueMgr:isLeagueEnabled() and App.data:isLeagueUnlocked() and self.EntryList and #self.EntryList <= 1 then
      return false;
   end

   RankingMgr:updateWeeklyReset();

   if not RankingMgr:isLastWeekRankingValid() then
      return false;
   end

   if GuideMgr:isBusy() then
      return false;
   end

   return true;

end

----------------------------------------------------------------

function StateRanking:_TryAutoAuthenticate()

   if self._autoAuthenticate  then

      self._autoAuthenticate = false;

      if LoginMgr:isTango() then
         MOAIFlurry:eventStop( "TangoForcedAuthentication-2", "ending", "success" );
      else
         MOAIFlurry:eventStop( "TangoForcedAuthentication-2", "ending", "failure" );
      end

   elseif not StateRanking.autoAuthenticateAttempt then

      if self:_shouldAutoAuthenticate() then

         local gpTgt = AbTestMgr:getValue("auto_authentication") or -100;

         self._autoAuthenticate = true;

         --Avoid getting in a place where users ar stuck if authentication fails
         StateRanking.autoAuthenticateAttempt = true;

         if  gpTgt < 0 then

            StateMgr:push("state/state-tangobonus-reminder.lua");

         else

            local attempt = App.data:deltaValue("attempt-auto-tango-2", 1);

            MOAIFlurry:eventStart( "TangoForcedAuthentication-2", "ending", "processing", "attempt-count", tostring(attempt) );

            StateMgr:push("state/state-authenticate-confirm.lua");

         end

      end

   end
end

----------------------------------------------------------------

function  StateRanking:_shouldAutoAuthenticate()

   if CloudMgr:isMasterUpToDate() or MOAIEnvironment.osBrand == "Android" then

      if     ( MOAITangoSdk:tangoHasSdkSupport() )
         and ( OnlineMgr:isOnline() )
         and ( not LoginMgr:isTango() )
         and ( not StateRanking.autoAuthenticateAttempt )
         and ( not GuideMgr:isActive() ) then

         local gpTgt = AbTestMgr:getValue("auto_authentication") or -100;

         if gpTgt then
            return  gpTgt and gpTgt > -100 and App.data:getGamePlayed() >= math.abs(gpTgt);
         end
      end
   end

end

------------------------------------------------------------------------------------
-- Guide Check
------------------------------------------------------------------------------------

function StateRanking:guideCheck()

   if not self._autoAuthenticate then

      -- new player
      if       not GuideMgr:getGuideDisabled( "new_player" )
         and   not App.data:getValue("guide-intro-complete") then

         local keys = App.data:getKeyCount();

         if keys > 0 then
            self.ScrollList:disable();
            self.ScrollListF:disable();
            GuideMgr:addSet("new_player");
            App.data:setValue( "guide-intro-complete", true );
            return;
         end
      end

      -- upgrade car
      if not GuideMgr:getGuideDisabled( "upgrade_weapon" ) then
         if not App.data:getValue("guide-upgrade-complete") then
            local pLvl  = App.data:getCurrentPlayerLevel();
            local wLvl = App.data:getCurrentMainWeaponLevel();
            local veh = App.data:getCurrentPlayerVehicle();
            local canUp = App.data:canUpgradePlayerMainWeapon( veh );

            if pLvl == 2 and wLvl == 1 and veh == 1 and canUp then
               self.ScrollList:disable();
               GuideMgr:addSet("upgrade_weapon");
               App.data:setValue( "guide-upgrade-complete", true );
               return;
            end
         end
      end

      -- friends onboarding
      if     LeagueMgr:isLeagueEnabled()
         and App.data:getCurrentPlayerLevel() == App.data:getFriendsUnlockLevel()
         and not App.data:getValue("friends-intro-seen", false) then

            App.data:setValue("friends-intro-seen", true);
            GuideMgr:addSet("friends_intro");
            return;
      end

      -- daily onboarding
      if       not App.data:getValue("daily-intro-seen", false)
         and   App.data:getCurrentPlayerLevel() == App.data:getDailyUnlockLevel() then

         if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
            self.ScrollListF:disable();
         else
            self.ScrollList:disable();
         end

         GuideMgr:addSet("daily_intro");
         App.data:setValue( "daily-intro-seen", true );
         return;
      end

      -- bounty intro/reset
      if       App.data:isBountyUnlocked()
         and   not App.data:getValue("bounty-weekly-intro-seen") then

         if not App.data:getValue("bounty-intro-seen") then
            if BountyMgr:anyBountyCollected() then
               App.data:setValue("bounty-intro-seen", true);
               App.data:setValue("bounty-weekly-intro-seen", true);
               return;
            end
         end

         if not App.data:getValue("bounty-intro-seen") then

            if not GuideMgr:getGuideDisabled( "bounty_intro" ) then
               App.data:setValue("bounty-intro-seen", true);
               App.data:setValue("bounty-weekly-intro-seen", true);
               GuideMgr:addSet("bounty_intro");
               return;
            end
         else

            if not GuideMgr:getGuideDisabled( "bounty_weekly_reset" ) then
               App.data:setValue("bounty-weekly-intro-seen", true);
               GuideMgr:addSet("bounty_weekly_reset");
               return;
            end
         end
      end

      -- drone onboarding
      if DroneMgr:isEnabled() and not GuideMgr:getGuideDisabled( "drone_unlock" ) then
         if  not DroneMgr:isDroneLevelLocked()
         and not App.data:getValue("guide-drone-complete") then

            if not DroneMgr:anyDroneCollected() then
               if AbTestMgr:isDroneButtonLocOnRanking() then
                  self.ScrollList:disable();
                  GuideMgr:addSet("drone_unlock");
               else
                  GuideMgr:addSet("drone_unlock_garage");
               end
               App.data:setValue( "guide-drone-complete", true );
               return;
            else
               App.data:setValue( "guide-drone-complete", true );
               return;
            end
         end
      end

      -- mission onboarding
      if       not App.data:getValue("mission-intro-seen", false)
         and   App.data:getCurrentPlayerLevel() == App.data:getMissionUnlockLevel() then

         if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
            self.ScrollListF:disable();
         else
            self.ScrollList:disable();
         end

         GuideMgr:addSet("mission_intro");
         App.data:setValue( "mission-intro-seen", true );
         return;
      end

      -- league onboarding
      if     LeagueMgr:isLeagueEnabled()
         and App.data:getCurrentPlayerLevel() == App.data:getLeagueUnlockLevel()
         and not App.data:getValue("league-intro-seen", false) then

         App.data:setValue("league-intro-seen", true);
         GuideMgr:addSet("league_intro");
         return;
      end

      --old bounty collection/reminder
      if       App.data:isBountyUnlocked()
         and   not LeagueMgr:isLeagueEnabled()
         and   BountyMgr:getBountyReadyToCollectCount() > 0 then

         self:_createBountyEntryData( BOUNTY_STATE_READY );
         self:_createBountyEntryList();

         if self.bountyEntryList and #self.bountyEntryList > 0 then

            if not GuideMgr:getGuideDisabled( "first_bounty_return" ) then

               if not App.data:getValue("bounty-first-return-seen") then

                  if self.highestReady then
                     if self.highestReady == "__GHOST_01" then
                        GuideMgr:addSet("first_bounty_return_bastian");
                        App.data:setValue("bounty-first-return-seen", true);
                        self.highestReady = nil;
                        return;
                     elseif self.highestReady == "__GHOST_02" then
                        GuideMgr:addSet("first_bounty_return_dana");
                        App.data:setValue("bounty-first-return-seen", true);
                        self.highestReady = nil;
                        return;
                     elseif self.highestReady == "__GHOST_03" then
                        GuideMgr:addSet("first_bounty_return_ricardo");
                        App.data:setValue("bounty-first-return-seen", true);
                        self.highestReady = nil;
                        return;
                     else
                        GuideMgr:addSet("first_bounty_return_claire");
                        App.data:setValue("bounty-first-return-seen", true);
                        self.highestReady = nil;
                        return;
                     end
                  end

               end

            end

            if not GuideMgr:getGuideDisabled( "bounty_reminder" ) then
               local games = App.data:getValue( "guide-games-since-bounty-collect" );
               if games then
                  if games == -1 then
                     App.data:setValue( "guide-games-since-bounty-collect", 0 );
                  end
                  if games >= GuideMgr:getReminderSpacing( "bounty" ) then

                     if self.highestReady then
                        if self.highestReady == "__GHOST_01" then
                           GuideMgr:addSet("bounty_reminder_bastian");
                           App.data:setValue( "guide-games-since-bounty-collect", 0 );
                           self.highestReady = nil;
                           return;
                        elseif self.highestReady == "__GHOST_02" then
                           GuideMgr:addSet("bounty_reminder_dana");
                           App.data:setValue( "guide-games-since-bounty-collect", 0 );
                           self.highestReady = nil;
                           return;
                        elseif self.highestReady == "__GHOST_03" then
                           GuideMgr:addSet("bounty_reminder_ricardo");
                           App.data:setValue( "guide-games-since-bounty-collect", 0 );
                           self.highestReady = nil;
                           return;
                        else
                           GuideMgr:addSet("bounty_reminder_claire");
                           App.data:setValue( "guide-games-since-bounty-collect", 0 );
                           self.highestReady = nil;
                           return;
                        end
                     end
                  end
               end
            end
         end
      end

      -- new bounty collection for autocollect
      if       App.data:isBountyUnlocked()
         and   LeagueMgr:isLeagueEnabled()
         and   not App.data:getValue("bounty-autocollection-seen", false)
         and   App.data:getValue("guide-bounty-collected", false) then

         App.data:setValue( "bounty-autocollection-seen", true );

         local id = App.data:getValue("guide-bounty-collected", "");

         if id == "__GHOST_01" then
             GuideMgr:addSet("bounty_autocollect_bastian");
            return;
         end

         if id == "__GHOST_02" then
            GuideMgr:addSet("bounty_autocollect_dana");
            return;
         end

         if id == "__GHOST_03" then
            GuideMgr:addSet("bounty_autocollect_ricardo");
            return;
         end

         GuideMgr:addSet("bounty_autocollect_claire");

         return;
      end

      -- upgrade reminder
      if not GuideMgr:getGuideDisabled( "upgrade_reminder" ) then
         local games = App.data:getValue( "guide-games-since-upgrade" );
         if games then
            if games > GuideMgr:getReminderSpacing( "upgrade" ) then
               GuideMgr:addSet("upgrade_reminder");
               App.data:setValue( "guide-games-since-upgrade", 0 );
               return;
            end
         end
      end

      -- daily reminder
      if not GuideMgr:getGuideDisabled( "daily_reminder" ) then
         local dGames = App.data:getValue("daily-games-since-complete");
         if dGames and App.data:getDailyChallengeRewardToCollect() then
            if dGames >= GuideMgr:getReminderSpacing( "daily" ) then
               App.data:setValue("daily-games-since-complete", -1);
               GuideMgr:addSet("daily_reminder");
               return;
            end
         end
      end

      -- mission reminder
      if not GuideMgr:getGuideDisabled( "mission_reminder" ) then
         local mGames = App.data:getValue("mission-games-since-complete");
         if mGames and App.data:isCurrentMissionCompleted() then
            if mGames >= GuideMgr:getReminderSpacing( "mission" ) then
               App.data:setValue("mission-games-since-complete", -1);
               GuideMgr:addSet("mission_reminder");
               return;
            end
         end
      end

      -- achievement reminder
      if not GuideMgr:getGuideDisabled( "achievement_reminder" ) then
         local aGames = App.data:getValue("achv-games-since-complete");
         if aGames and AchievementMgr:isPendingRewards() then
            if aGames >= GuideMgr:getReminderSpacing( "achievement" ) then
               App.data:setValue("achv-games-since-complete", -1);
               GuideMgr:addSet("achievement_reminder");
               return;
            end
         end
      end

      --joe this is where it checks the "notification" pop up guide start
      -- make sure the notification manager isn't active
      -- master needs to be updated for this to check anything at all
      --then the flag that determines AB test
      --then the AB logic.
      -- A is after collecting daily reward
      -- B is after missing a daily
      -- start the correct guide
      if CloudMgr:isMasterUpToDate() then

         if not App.data:getValue("notification-guide-complete") and not App.data:getValue("notification-guide-disabled") then

            if not GuideMgr:getGuideDisabled( "notification_daily_success" ) then
               if App.data:getValue( "notification-guide-success" ) then
                  App.data:setValue( "notification-guide-complete", true );
                  EventMgr:postEvent( {ab="daily-success"}, "notify-guide-start" );
                  GuideMgr:addSet("notification_guide_daily_success");
                  return;
               end
            end

            if not GuideMgr:getGuideDisabled( "notification_daily_fail" ) then
               if App.data:getValue( "notification-guide-fail" ) then
                  App.data:setValue( "notification-guide-complete", true );
                  EventMgr:postEvent( {ab="daily-missed"}, "notify-guide-start" );
                  GuideMgr:addSet("notification_guide_daily_fail");
                  return;
               end
            end
         end
      end

      -- Check video button guide
      if App:isVideoRewardEnabled() then

         if self:isVideoRewardReady() then

            local newRewardGuide, newGuideMinLvl = AbTestMgr:getVideoMapGuide();
            local currentPlayerLevel = App.data:getCurrentPlayerLevel();

            if newRewardGuide and newGuideMinLvl and currentPlayerLevel and currentPlayerLevel >= newGuideMinLvl then

               self.videoRewardLvlID = "video_button_new_reward_"..newGuideMinLvl;

               if not App.data:getValue(self.videoRewardLvlID) then
                  self.videoGuideSetName = newRewardGuide;
                  self.playVideoRewardGuide = true;
               end
            end

            if self.playVideoRewardGuide and self.videoGuideSetName then

               if self.videoGuideSetName == "new" then

                  if not GuideMgr:getGuideDisabled( "new_video_reward" ) then
                     GuideMgr:addSet("new_video_reward");
                     App.data:setValue( self.videoRewardLvlID, true );
                     self.playVideoRewardGuide = nil;
                     self.videoGuideSetName = nil;
                     return;
                  end

               elseif self.videoGuideSetName == "first" then

                  if not GuideMgr:getGuideDisabled( "video_button_guide" ) then
                     GuideMgr:addSet("video_button_guide");
                     App.data:setValue( self.videoRewardLvlID, true );
                     self.playVideoRewardGuide = nil;
                     self.videoGuideSetName = nil;
                     return;
                  end
               end
            end
         end
      end

      -- feed
      if FeedMgr:isEnable() then

         if not GuideMgr:getGuideDisabled( "feed_guide" ) then

            if not App.data:getValue("feed_guide_done") then

               local guide  = AbTestMgr:getFeedEnablingGuide();
               if guide and guide > 0 and App.data:getCurrentPlayerLevel() >= guide  then
                  GuideMgr:addSet("feed_guide");
                  App.data:setValue("feed_guide_done", true);
                  return;
               end

            end

         end

      end

      -- game center
      if self:_shouldShowGameCenter() and OnlineMgr:isOnline() then

         if not GuideMgr:getGuideDisabled( "game_center_guide" ) then

            if not App.data:getValue("game-center-guide-done") then

               local gcMap = AbTestMgr:getGameCenterMap();
               local level = App.data:getCurrentPlayerLevel();
               if gcMap and gcMap.enabled and gcMap.guide and level >= gcMap.guide then

                  GuideMgr:addSet("game_center_guide");
                  App.data:setValue("game-center-guide-done", true);

               end

            end

         end

      end

      -- starter bundle
      if self:_shouldShowStarterPackPromo() then

         local lvlGames = App.data:getValue("App.settings.starter-pack-level-games", {12, 30});

         -- If the starter pack has been shown less than once...
         if App.data:getValue("guide_starter_pack_first_count", 0) < 1 or HACK_ALWAYS_SHOW_STARTER_PROMO then

            -- Show the promo and record the game count for the first time we show the promo
            App.data:setValue("guide_starter_pack_first_count", App.data:getGamePlayed());
            GuideMgr:addSet("starter_pack");
            return;

         -- If the starter pack has been shown at least once...
         elseif App.data:getValue("guide_starter_pack_first_count", 0) > 0
                and App.data:getGamePlayed() >= ( App.data:getValue("guide_starter_pack_first_count", 0) + (AbTestMgr:getStarterPackGamesBeforeRepeat() or lvlGames[2]) )
                and not App.data:getValue("guide_starter_pack_final", false) then

            -- Show the promo for a final time and save a flag that indicates the pack has already been shown the final time.
            App.data:setValue("guide_starter_pack_final", true);
            GuideMgr:addSet("starter_pack");
            return;
         end

      end

      -- mystery reminder
      if not GuideMgr:getGuideDisabled( "mystery_reminder" ) then

         local mysteryGames   = App.data:getValue("mystery-games-since-screen");
         local mTokens        = App.data:getFreebieCount("mystery");
         local mSpacing       = GuideMgr:getReminderSpacing("mystery");
         if mysteryGames and mysteryGames >= mSpacing and mTokens and mTokens > 0 then
            App.data:setValue("mystery-games-since-screen", 0);
            GuideMgr:addSet("mystery_reminder");
            return;
         end
      end

   end

end

function StateRanking:_shouldShowStarterPackPromo()

   if HACK_ALWAYS_SHOW_STARTER_PROMO then
      return true;
   end

   local enable   = AbTestMgr:isStarterPackEnabled();
   local lvlGames = App.data:getValue("App.settings.starter-pack-level-games", {12, 30});

   if enable == nil then
      enable = App.data:getValue("App.settings.starter-pack-enable", true);
   end

   return not App.data:isPayer()
      and enable
      and App.data:getCurrentPlayerLevel() >= (AbTestMgr:getStarterPackLevel() or lvlGames[1])
      and not App.data:getValue("guide_starter_pack_final", false);

end

------------------------------------------------------------------------------------

function StateRanking:guideBountyBanner()

   EventMgr:postEvent( {}, "bounty-activated" );

end

------------------------------------------------------------------------------------

function StateRanking:bountyTutorialKeyCheck()

   local count = App.data:getKeyCount();

   if count < 1 then
      App.data:addKey( 1, "BountyIntro" );
   end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateRanking:videoRolloutButtonCheck( f )

   --check if video button is enabled or not.
   if App:isVideoRewardEnabled() and AbTestMgr:getVideoButtonEnabled( ) then

      self.videoRolloutButton:setVisible(true);
      self.videoRolloutButton:enable();

      local newRewardGuide, newGuideMinLvl = AbTestMgr:getVideoMapGuide();
      local currentPlayerLevel = App.data:getCurrentPlayerLevel();

      if newRewardGuide and newGuideMinLvl and currentPlayerLevel and currentPlayerLevel >= newGuideMinLvl then

         self.videoRewardLvlID = "video_button_new_reward_"..newGuideMinLvl;

         if not App.data:getValue(self.videoRewardLvlID) then
            self.videoGuideSetName = newRewardGuide;
            self.playVideoRewardGuide = true;
         end
      end

      local sparkleTimer = AbTestMgr:getVideoButtonSparkle();

      if sparkleTimer and sparkleTimer > 0 and self:isVideoRewardReady() then

         local time = TimeMgr:getTimeGMT();
         local timestamp = App.data:getValue("video-button-sparkle-timestamp");

         if time then

            if not timestamp then
               timestamp = time;
               App.data:setValue( "video-button-sparkle-timestamp", time );
            end

            if (time - timestamp) >= sparkleTimer then
               self.shouldSparkle = true;
            else
               self.shouldSparkle = false;
            end

         end

      end


      if self.shouldSparkle and f and f ~= "onFocus" and self:isVideoRewardReady() then

         self.shouldSparkle = nil;

         self.videoRolloutCoin:setVisible(true);
         self.videoRolloutCoin:start();
         self.videoRolloutSparkle:setVisible(true);
         self.videoRolloutSparkle:start();
      else
         self.videoRolloutCoin:stop();
         self.videoRolloutCoin:setVisible(false);
         self.videoRolloutSparkle:stop();
         self.videoRolloutSparkle:setVisible(false);

      end

   else
      self.videoRolloutButton:setVisible(false);
      self.videoRolloutButton:disable();
      self.videoRolloutCoin:stop();
      self.videoRolloutSparkle:stop();
      self.videoRolloutCoin:setVisible(false);
      self.videoRolloutSparkle:setVisible(false);
   end

end

------------------------------------------------------------------------------------

function StateRanking:videoRolloutButtonCooldownCheck()

   local rolloutTimer = AbTestMgr:getVideoButtonRollout();

   if App:isVideoRewardEnabled() and rolloutTimer and rolloutTimer > 0 and self:isVideoRewardReady() then

      local time = TimeMgr:getTimeGMT();
      local timestamp = App.data:getValue("video-button-rollout-timestamp");

      if time then

         if not timestamp then
            timestamp = time;
            App.data:setValue( "video-button-rollout-timestamp", time );
         end

         if (time - timestamp) >= rolloutTimer then
            local sparkleTimer = AbTestMgr:getVideoButtonSparkle();
            if sparkleTimer and sparkleTimer > 0 then
               self.shouldSparkle = true;
            end
            App.data:setValue( "video-button-rollout-timestamp", time );
            -- self:showRollOut();


         end

      end

   end


end

------------------------------------------------------------------------------------

function StateRanking:guideDirectVideo()

   self.videoGuideButtonClick = true;

end

------------------------------------------------------------------------------------

function StateRanking:videoRolloutButtonReleased()

   local time = TimeMgr:getTimeGMT();

   App.data:setValue( "video-button-sparkle-timestamp", time );
   self.shouldSparkle = nil;
   App.data:setValue( "video-button-rollout-timestamp", time );

   local vidRolloutTarget = AbTestMgr:getVideoButtonTarget();

   if not self:isVideoRewardReady() then
      vidRolloutTarget = "popup";
   end

   if (vidRolloutTarget and vidRolloutTarget == "video") or self.videoGuideButtonClick then

      self.videoGuideButtonClick = nil;

      -- Start video
      EventMgr:postEvent( {target="video"}, "on-video-button" );

      self:goVideoGold();
      self.RollOut:closeRollOut();

   elseif vidRolloutTarget and vidRolloutTarget == "popup" then

      --Go to gold popup
      EventMgr:postEvent( {target="popup"}, "on-video-button" );
      PromoMgr:createPopup( "goldPageStore" );
      self.RollOut:closeRollOut();

   else
      print("Problems with button target:", vidRolloutTarget);
   end

end

----------------------------------------------------------------

function StateRanking:goVideoGold()

   StateMgr:push("state/state-video-play.lua", {rewardType="gold", rewardAmount=AbTestMgr:getVideoMapGold( ) or 100} );

end

------------------------------------------------------------------------------------
-- Sales
------------------------------------------------------------------------------------

function StateRanking:carSaleButtonCheck()

   local vehicleIndexMap = App.data:getPlayerVehicleIndexMap();

   if vehicleIndexMap and #vehicleIndexMap > 0 then

      for i=1, #vehicleIndexMap do

         if App.data:isPlayerVehicleOnSale(vehicleIndexMap[i]) and not App.data:isPlayerVehicleLevelLocked(vehicleIndexMap[i]) then

            if not App.data:getValue( "garage-carSale-show" ) then
               App.data:setValue( "garage-carSale-show", -1 );
            end

            break;
         elseif i == #vehicleIndexMap then
            App.data:setValue( "garage-carSale-show", nil );
         end
      end
   end

end

------------------------------------------------------------------------------------
-- Holidays
------------------------------------------------------------------------------------

function StateRanking:holidayButtonCheck()

   --MQL: disable holiday UI

--[[

   if not LeagueMgr:isLeagueEnabled() then

      local sale = PromoMgr:getCurrentSales("holiday");
      if sale then

         if not self.HolidayButton then

            self.HolidayButton = self:addWidget(ButtonImage, self.mainLayer, 134.85, 340, 322, 90, "resources/holiday/S_InviteSalesButton.png", nil, function ()
                                                   MOAIFlurry:event("Promo-Holiday-Ranking-Button", "Result", "success", "success_level", ""..( App.data:getCurrentPlayerLevel() or "unknown"));
                                                   StateMgr:push("state/state-gem.lua");
            end);
            self.HolidayButton:setPriority(PRIORTY_6);

         end

         if self.holidayButtonShowing then

            self.HolidayButton:setVisible(false);
            self.HolidayButton:disable();

            self.InviteButton:setVisible(true);
            self.InviteButton:enable();
            self.InviteRewardIcon:setVisible(true);
            self.InviteRewardTitle:setVisible(true);
            self.InviteRewardText:setVisible(true);

            self.holidayButtonShowing = false;

         else

            self.HolidayButton:setVisible(true);
            self.HolidayButton:enable();

            self.InviteButton:setVisible(false);
            self.InviteButton:disable();
            self.InviteRewardIcon:setVisible(false);
            self.InviteRewardTitle:setVisible(false);
            self.InviteRewardText:setVisible(false);

            self.holidayButtonShowing = true;
         end

         self.VideoButton:setVisible(false);
         self.VideoButton:disable();
         self.VideoRewardIcon:setVisible(false);
         self.VideoRewardTitle:setVisible(false);
         self.VideoRewardText:setVisible(false);

      else

         if self.HolidayButton then
            self.HolidayButton:setVisible(false);
            self.HolidayButton:disable();
         end

      end
   end

]]

end

------------------------------------------------------------------------------------
-- Video stuff
------------------------------------------------------------------------------------

function StateRanking:videoButtonSetup()

   self.videoGoldEnabled = false;
   self.videoKeyEnabled  = false;

   if App:isVideoRewardEnabled() then

      local limit = AbTestMgr:getVideoMapLimit( );

      if limit and limit > 0 then
         self.videoGoldEnabled = (AbTestMgr:getVideoMapGold() or 0 ) > 0;
         self.videoKeyEnabled  = (AbTestMgr:getVideoMapKeys() or 0 ) > 0;
      end

   end

end

------------------------------------------------------------------------------------

function StateRanking:videoButtonCheck()

   if LeagueMgr:isLeagueEnabled() or (not self.videoGoldEnabled) then
      -- Don't update video button
      return;
   end

   if not self.videoSwap then

      self:setVideoButtonText()

      self.videoSwap = true;

      self.VideoButton:setVisible(true);
      self.VideoButton:enable();
      self.VideoRewardIcon:setVisible(true);
      self.VideoRewardTitle:setVisible(true);
      self.VideoRewardText:setVisible(true);

      self.InviteButton:setVisible(false);
      self.InviteButton:disable();
      self.InviteRewardIcon:setVisible(false);
      self.InviteRewardTitle:setVisible(false);
      self.InviteRewardText:setVisible(false);

   elseif self.videoSwap then

      self.videoSwap = false;

      self.VideoButton:setVisible(false);
      self.VideoButton:disable();
      self.VideoRewardIcon:setVisible(false);
      self.VideoRewardTitle:setVisible(false);
      self.VideoRewardText:setVisible(false);

      self.InviteButton:setVisible(true);
      self.InviteButton:enable();
      self.InviteRewardIcon:setVisible(true);
      self.InviteRewardTitle:setVisible(true);
      self.InviteRewardText:setVisible(true);

   end

end

------------------------------------------------------------------------------------

function StateRanking:_showRewardScreen()

   if LeagueMgr:isLeagueEnabled() then
      if App.data:isLeagueUnlocked() and (App.data:getValue("league-intro-seen", false) or App.data:getCurrentPlayerLevel() > App.data:getLeagueUnlockLevel()) then
         StateMgr:push("state/state-league-reward-popup.lua");

         return true;
      else
         RankingMgr:cycleScore();

         return false;
      end
   else
      StateMgr:push("state/state-weekly-popup.lua");

      return true;
   end

end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

function StateRanking:_giveSigninBonus()

   if LoginMgr:isTango() and App.data:getCurrentPlayerLevel() > 1 and App.data:getGamePlayed() >= 3 then

      local signingBonus = App.data:hasReceiveTangoBonus();

      if not signingBonus and not App.data:getValue('BonusPopup') then
         App.data:setValue('BonusPopup', true);
         StateMgr:push("state/state-tangobonus-confirm.lua");

         return false;
      end

      if not signingBonus then

         App.data:receiveTangoBonus(  );
         EventMgr:postEvent( { bonus = App.data:getTangoBonus() }, 'tango-bonus' );

      end

   end

end

------------------------------------------------------------------------------------
-- update misc info
------------------------------------------------------------------------------------

function StateRanking:setInviteButtonText()

   if LeagueMgr:isLeagueEnabled() then
      -- League UI doesn't have the invite button
      return;
   end

   Debug.assert( TimeMgr:getTimeGMT(), "StateRanking:setInviteButtonText() -> TimeMgr:getTimeGMT()" );

   local count   = 0;
   local value   = App.data:getInviteRewardGold();
   local reward  = 0;
   local offsetT = 0;
   local offsetC = 0;
   local text    = 'Invite Friend';
   local timeTbl = App.data:getValue("App.settings.invite-cooldown") or {INVITE_TIME_LIMIT, INVITE_TIME_LIMIT, INVITE_TIME_LIMIT};
   local invCount;

   for i=1,ContactMgr:getFriendsCount() do
      local contact = ContactMgr:getFriend(i);

      if contact and not contact:isAppInstalled() then
         invCount = math.clamp(getCoolDownCount("Invite2Tracker", contact:getAccountId()) or 1, 1, #timeTbl);

         if not isTimeInLim('Invite2', contact:getAccountId(), timeTbl[invCount], TimeMgr:getTimeGMT() ) then
            count = count + 1;
         end
      end
   end

   reward = count * value;

   if reward < 1 then
      reward = 0;
   elseif reward > 9999 then
      reward = 9999;
   end

   if reward > 999 then
      offsetC = 51;
   elseif reward > 99 then
      offsetC = 65;
   elseif reward > 9 then
      offsetC = 82;
   elseif reward > 0 then
      offsetC = 100;
   elseif reward == 0 then
      offsetC = 95;
      offsetT = 35;
      reward = '';
   end

   self.InviteRewardText:setText(''..reward);
   self.InviteRewardIcon:setLoc(offsetC+143, 0);
   self.InviteRewardTitle:setLoc(offsetT+143, 0);

end

------------------------------------------------------------------------------------

function StateRanking:setVideoButtonText()

   local count   = 0;
   local value   = AbTestMgr:getVideoMapGold() or 0;
   local reward  = 0;
   local offsetT = 0;
   local offsetC = 0;
   local text    = 'Invite Friend';

   count = App.data:getValue("videos-remaining");
   if not count then
      count = AbTestMgr:getVideoMapLimit() or 0;
   end

   --joe: this calculates total available reward
   --reward = count * value;

   --joe: this calculates reward per video
   reward = value;

   if reward < 1 then
      reward = 0;
   elseif reward > 9999 then
      reward = 9999;
   end

   --joehack coin spacing on the reward button
   --Until we get the spacing right on the reward value, just show the coin icon
   reward = 0;

   if reward > 999 then
      offsetC = 51;
   elseif reward > 99 then
      offsetC = 65;
   elseif reward > 9 then
      offsetC = 82;
   elseif reward > 0 then
      offsetC = 100;
   elseif reward == 0 then
      offsetC = 95;
      offsetT = 35;
      reward = '';
   end

   self.VideoRewardText:setText(''..reward);
   self.VideoRewardIcon:setLoc(offsetC+128, 0);
   self.VideoRewardTitle:setLoc(offsetT+148, 0);

end

----------------------------------------------------------------

function StateRanking:updateGarageArrow()

   local ab  = DroneMgr:isEnabled() and AbTestMgr:isDroneButtonLocOnRanking();
   local veh = App.data:getCurrentPlayerVehicle();

   local can = ( App.data:canUpgradePlayerMainWeapon(veh) and (App.data:getCurrentMainWeaponLevel() < App.data:getPlayerMainWeaponMaxLevel(veh)))
            or ( App.data:canUpgradePlayerArmor(veh) and (App.data:getCurrentArmorLevel() < App.data:getPlayerArmorMaxLevel(veh)))
            or ( App.data:canUpgradePlayerSideWeapon(veh) and (App.data:getCurrentSideWeaponLevel() < App.data:getPlayerSideWeaponMaxLevel(veh)))
            or ( App.data:canUpgradePlayerTurretWeapon(veh) and (App.data:getCurrentPlayerTurretWeaponLevel() < App.data:getPlayerTurretWeaponMaxLevel(veh)));

   local anim = nil;

   if can then
      if ab then
         anim = "resources/UI/car_garage_green.png";
      else
         anim = "NotificationUpGrade";
      end
   else
      if ab then
         anim = "resources/UI/car_garage_grey.png";
      else
         anim = "ShopButton";
      end
   end

   if self.GarageButtonAnim ~= anim then

      self.GarageButtonAnim = anim;

      if self.GarageButton.swapImage then
         self.GarageButton:swapImage( anim );

      elseif self.GarageButton.swapAnim then
         self.GarageButton:swapAnim( anim );

      end

   end

end

----------------------------------------------------------------

function StateRanking:updateDroneArrow()

   if not DroneMgr:isEnabled() or not AbTestMgr:isDroneButtonLocOnRanking() then
      return;
   elseif DroneMgr:isDroneLevelLocked() then
      --self.DroneButton:disable();
      self.DroneButton:setColor(0.35, 0.35, 0.35, 1);
   else
      self.DroneButton:enable();
      self.DroneButton:setColor(1,1,1,1);
   end

   if DroneMgr:isPurchaseAvailable() then
      self.DroneButton:swapImage("resources/UI/drone_garage_green.png");
   else
      self.DroneButton:swapImage("resources/UI/drone_garage_grey.png");
   end

end

----------------------------------------------------------------

function StateRanking:_isDownloadingRank()

   if OnlineMgr:isOnline() then

      return ContactMgr:isDownloading()
          or RankingMgr:isDownloading();

   end

   return false;

end

----------------------------------------------------------------

function StateRanking:_areRankUpToDate()

   if OnlineMgr:isOnline() then

      if  ContactMgr:isUpToDate()
      and RankingMgr:areScoreUpToDate() then
         return true;
      end

   end

   return false;

end

----------------------------------------------------------------

function StateRanking:_shouldUpdateKeyInfo()
   -- MOAI stores elapsed time in seconds
   return MOAISim.getElapsedTime() >= self.lastKeyTextUpdate + 1;
end

----------------------------------------------------------------

function StateRanking:_updateCountdownText()

   local weeklyTime  = math.clamp(RankingMgr:getTimeToReset(), 1, WEEKLY_ONE_WEEK);
   local center      = false;

   self.lastKeyTextUpdate = MOAISim.getElapsedTime();

   if self:_areRankUpToDate() then

      if not LeagueMgr:isLeagueEnabled() then

         local WeeklyTimeMin    = weeklyTime/60;
         local weeklyTimeHour   = WeeklyTimeMin/60;
         local WeeklyTimeDay    = weeklyTimeHour/24;

         if WeeklyTimeMin < 1 then
           WeeklyTimeMin = 1;
         end

         self.WeeklyTextShd:setText("");

         if WeeklyTimeDay > 1 then
            self.WeeklyText:setText("<c:1b354f>Resets in        days<c>");
            self.WeeklyTimeText:setText("<c:ffd334>"..math.floor(WeeklyTimeDay).."<c>");
            self.WeeklyTimeTextShd:setText("<c:000000>"..math.floor(WeeklyTimeDay).."<c>");
            self.WeeklyTimeText:setLoc(WEEKLY_X-150, WEEKLY_Y+1);
            self.WeeklyTimeTextShd:setLoc(WEEKLY_X-150+2, WEEKLY_Y+1-2);
         elseif weeklyTimeHour > 1 then
            if weeklyTimeHour > 9 then
               self.WeeklyText:setText("<c:1b354f>Resets in           hours<c>");
               self.WeeklyTimeText:setText("<c:ffd334>"..math.floor(weeklyTimeHour).."<c>");
               self.WeeklyTimeTextShd:setText("<c:000000>"..math.floor(weeklyTimeHour).."<c>");
               self.WeeklyTimeText:setLoc(WEEKLY_X-143, WEEKLY_Y+1);
               self.WeeklyTimeTextShd:setLoc(WEEKLY_X-143+2, WEEKLY_Y+1-2);
            else
               self.WeeklyText:setText("<c:1b354f>Resets in        hours<c>");
               self.WeeklyTimeText:setText("<c:ffd334>"..math.floor(weeklyTimeHour).."<c>");
               self.WeeklyTimeTextShd:setText("<c:000000>"..math.floor(weeklyTimeHour).."<c>");
               self.WeeklyTimeText:setLoc(WEEKLY_X-150, WEEKLY_Y+1);
               self.WeeklyTimeTextShd:setLoc(WEEKLY_X-150+2, WEEKLY_Y+1-2);
            end
         else
            if WeeklyTimeMin > 9 then
               self.WeeklyText:setText("<c:1b354f>Resets in          min<c>");
               self.WeeklyTimeText:setText("<c:ffd334>"..math.floor(WeeklyTimeMin).."<c>");
               self.WeeklyTimeTextShd:setText("<c:000000>"..math.floor(WeeklyTimeMin).."<c>");
               self.WeeklyTimeText:setLoc(WEEKLY_X-143, WEEKLY_Y+1);
               self.WeeklyTimeTextShd:setLoc(WEEKLY_X-143+2, WEEKLY_Y+1-2)
            else
               self.WeeklyText:setText("<c:1b354f>Resets in        min<c>");
               self.WeeklyTimeText:setText("<c:ffd334>"..math.floor(WeeklyTimeMin).."<c>");
               self.WeeklyTimeTextShd:setText("<c:000000>"..math.floor(WeeklyTimeMin).."<c>");
               self.WeeklyTimeText:setLoc(WEEKLY_X-150, WEEKLY_Y+1);
               self.WeeklyTimeTextShd:setLoc(WEEKLY_X-150+2, WEEKLY_Y+1-2);
            end
         end
      elseif LeagueMgr:isLeagueEnabled() then

         weeklyTime  = math.clamp(RankingMgr:getTimeToReset(), 0, WEEKLY_ONE_WEEK);

         local txt = "";

         if App.data:isLeagueUnlocked() then

            local day  = math.floor( weeklyTime/(60*60*24) );
            local hour = math.floor( weeklyTime/(60*60) - day*24 );
            local min  = math.floor( weeklyTime/60 - day*24*60 - hour*60 );
            local sec  = weeklyTime - day*24*60*60 - hour*60*60 - min*60;

            if day+hour+min <= 0 then
               if sec < 1 and sec > 0 then
                  sec = 1;
               end
            else
               sec = math.floor(sec);
            end

            if day == 0 and hour == 0 and min == 0 and sec <= 1 then
               txt = "Syncing to leaderboard server...";
               center = true;

               self.TimerText:setAlignment(MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
               self.TimerTextShdw:setAlignment(MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
            else
               txt = "Weekly Rewards in " .. day .. "d " .. hour .. "h " .. min .. "m " .. sec .. "s";

               self.TimerText:setAlignment(MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
               self.TimerTextShdw:setAlignment(MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
            end
         end

         self.TimerText:setText(txt);
         self.TimerTextShdw:setText(txt);
         self.TimerText:setVisible(true);
         self.TimerTextShdw:setVisible(true);
      end
   else

      if not LeagueMgr:isLeagueEnabled() then
         if self:_isDownloadingRank() then
            self.WeeklyText:setText("<c:ffd334>  Updating...<c>");
            self.WeeklyTextShd:setText("<c:000000>  Updating...<c>");
         else
            self.WeeklyText:setText("<c:ffd334>  You are offline<c>");
            self.WeeklyTextShd:setText("<c:000000>  You are offline<c>");
         end

         self.WeeklyTimeText:setText("");
         self.WeeklyTimeTextShd:setText("");
      elseif LeagueMgr:isLeagueEnabled() and App.data:isLeagueUnlocked() then
         if self:_isDownloadingRank() then
            local updateText = "Updating...";
            self.TimerText:setText(updateText);
            self.TimerTextShdw:setText(updateText);
         else
            local offlineText = "Offline - Go online to compete!";
            self.TimerText:setText(offlineText);
            self.TimerTextShdw:setText(offlineText);
         end

         center = true;

         self.TimerText:setAlignment(MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
         self.TimerTextShdw:setAlignment(MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
      elseif LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
         self.TimerText:setVisible(false);
         self.TimerTextShdw:setVisible(false);
      end
   end

   if self.TimerText and self.TimerTextShdw then

      if center then
         if App.viewHeight/App.viewWidth <= 1.7 then
            self.TimerText:setLoc(0, 385);
            self.TimerTextShdw:setLoc(3, 382);
         else
            self.TimerText:setLoc(0, 400);
            self.TimerTextShdw:setLoc(3, 397);
         end
      else
         if App.viewHeight/App.viewWidth <= 1.7 then
            self.TimerText:setLoc(90, 385);
            self.TimerTextShdw:setLoc(93, 382);
         else
            self.TimerText:setLoc(90, 400);
            self.TimerTextShdw:setLoc(93, 397);
         end
      end
   end

   if self:_canShowRewardScreen() then
      self:_updateRankingList();
      self:_showRewardScreen();
   end

end

----------------------------------------------------------------

function StateRanking:_updateKeyInfo()

   local count       = App.data:getKeyCount();
   local time        = 0;
   local countdown   = App.data:calcKeyTimeToRegen();
   local countTime   = "";
   local sec;

   if count >= 6 then
      time = 33/30;
   elseif count == 5 then
      time = 26/30;
   elseif count == 4 then
      time = 21/30;
   elseif count == 3 then
      time = 16/30;
   elseif count == 2 then
      time = 11/30;
   elseif count == 1 then
      time = 6/30;
   else
      time = 0
   end

   if countdown then
      sec = math.floor(countdown%60);

      local secStr = tostring(sec)

      if sec < 10 then
         secStr = "0" .. tostring(sec)
      end

      countTime = '<c:6abffd>Replenish in ' .. math.floor(countdown / 60) .. ":" .. secStr;
   end

   -- Key Tray
   if count >= 6 then
      self.KeyMax:setVisible(true);
      self.KeyMax:setText('<c:6abffd>Max Keys');
      self.KeyTime:setVisible(false);
   else
      self.KeyMax:setVisible(false);
      self.KeyTime:setVisible(true);
      self.KeyTime:setText(countTime);
   end

   self.KeyTray:stop();
   self.KeyTray:apply(time);

   if count > 999 then
      count = 999;
   end

   self:_updateCountdownText();

end

------------------------------------------------------------------------------------
-- Leaderboard scrolling lists
------------------------------------------------------------------------------------

function StateRanking:_updateRankingList()

   if not GuideMgr:isActive() and not GuideMgr:isBusy() then
      self:_deleteBountyEntryList();
   end

   if not BountyMgr:isBountyListValid() then
      BountyMgr:refreshBountyList();
   end

   local DEFAULT_ENTRIES_ABOVE_PLAYER = 3;

   local sPos = math.clamp(AbTestMgr:getGuestFriendRankPageOffset() or App.data:getValue("App.settings.leaderboard-offset", DEFAULT_ENTRIES_ABOVE_PLAYER), 0, DEFAULT_ENTRIES_ABOVE_PLAYER);

   BountyMgr:getBountySelection();
   self:createEntryList();

   self:_addLeagueBannersToList(self.EntryList);

   self:_updateRankingListsWithNativeAds();

   self.ScrollList:goToEntry(1);
   self.ScrollList:setEntryCount(nil, #self.EntryList);
   self.ScrollList:setEntryData(self.EntryList, true);
   self.ScrollList:goToEntry( math.max( self:_getPlayerEntryPos(self.EntryList) - sPos, 1 ) );
   self.ScrollListF:goToEntry(1);
   self.ScrollListF:setEntryCount(nil, #self.EntryListF);
   self.ScrollListF:setEntryData(self.EntryListF, true);
   self.ScrollListF:goToEntry( math.max( self:_getPlayerEntryPos(self.EntryListF) - sPos, 1 ) );

   if LeagueMgr:isLeagueEnabled() then

      local l, d = LeagueMgr:getPlayerPlacement();
      local n1, n2 = LeagueMgr:getLeagueName(l,d);

      if LEAGUE_TAB[l] and LEAGUE_INSET[l] then
         if self.LeagueTabOn:swapImage(LEAGUE_TAB[l]) then
            self.LeagueTabInset:swapImage(LEAGUE_INSET[l]);
            self.LeagueTabInset:setAttrLink(    MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
            self.LeagueText:setAttrLink(        MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
            self.LeagueTextShdw:setAttrLink(    MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
            --self.LeagueTabOff:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
            self.LeagueDivText:setAttrLink(     MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
            self.LeagueDivTextShdw:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, self.LeagueTabOn.prop, MOAIProp2D.TRANSFORM_TRAIT );
         end

         self.LeagueText:setText(string.upper(n1));
         self.LeagueTextShdw:setText(string.upper(n1));
         self.LeagueDivText:setText(string.upper(n2));
         self.LeagueDivTextShdw:setText(string.upper(n2));
      end

      --self:_showFriendList(false);
      --self.LeagueTabOff:setVisible(true);
      --self.FriendTabOff:setVisible(false);

      if App.data:isLeagueUnlocked() then
         self.leagueInfo:setVisible(true);
         self.leagueInfo:enable();
         self.LeagueTabOn:enable();
         self.FriendTabOn:enable();

         if self._ListState == LIST_STATE_FRIENDS then
            self:_showFriendList(false);
         else
            self:_showLeagueList(false);
         end
      else
         self.leagueInfo:setVisible(false);
         self.leagueInfo:disable();
         self.LeagueTabOn:enable();
         self.FriendTabOn:enable();
         self:_showFriendList(false);
      end
   else
      self.ScrollList:show();
      self.ScrollListF:hide();
   end

   self:_giveSigninBonus();

end

----------------------------------------------------------------

function StateRanking:_addLeagueBannersToList(list)

   local leagueReward = self:createLeagueRewardData();

   -- Add league reward banners
   if App.data:getCurrentPlayerLevel() > 1 and LeagueMgr:isLeagueEnabled() and leagueReward then

      local count = 0;

      for _, leagueEntry in ipairs(leagueReward) do
         table.insert(list, leagueEntry.insertIndex + count, leagueEntry);
         count = count + 1;
      end
   end

end

----------------------------------------------------------------

function StateRanking:_updateRankingListsWithNativeAds()

   local isLeague = true; -- TODO Don't hardcode
   local NUM_ADS = 5;

   AdMgr:attemptNativeAdFetch(NUM_ADS);

   local adEntries = self:createNativeAdEntries(isLeague);

   print("Num native ad entries:", #adEntries);

   self:_addAdEntriesToEntryList(self.EntryList, adEntries, isLeague);

   -- Don't pass any ad entries - only the Tango authenticate ad will show.
   self:_addAdEntriesToEntryList(self.EntryListF, {});

end

----------------------------------------------------------------

function StateRanking:_addAdEntriesToEntryList(entryList, adEntries, isLeagueList)

   local tangoAd = self:createTangoMessage(isLeagueList);

   if not isTableEmpty(adEntries) then

      adEntries = makeShuffled(adEntries);

      -- Tango ad should always be first to show
      if tangoAd then
         table.insert(adEntries, 1, tangoAd);
      end

      -- Mix ads into the leaderboard
      if not isTableEmpty(entryList) then

         self:_insertAdsIntoList(entryList, adEntries);

      else
         -- Add one ad to the list if the list is empty.
         table.insert(entryList, adEntries[1]);
      end

   else
      print("MISSING NATIVE AD ENTRIES!")

      -- If we don't have ads, the Tango ad should go at the end of the leaderboard
      if tangoAd then
         table.insert(entryList, tangoAd);
      end

   end

end

----------------------------------------------------------------

-- Add ads at a specified interval.
-- Ads should not appear on the same page as league reward banners.
function StateRanking:_insertAdsIntoList(entryList, adEntries)

   local ENTRIES_PER_PAGE = 4;

   local INSERTION_INTERVAL = 4; -- TODO Don't hardcode

   local nextAdIndex = 1;
   local entriesUntilInsertion = INSERTION_INTERVAL;

   local i = 1;

   while i <= #entryList do

      if nextAdIndex > #adEntries then
         break;
      end

      local entry = entryList[i];

      if entry.tangoID == "RewardPanel" then

         -- We don't want ads on the same page as league banners
         entriesUntilInsertion = ENTRIES_PER_PAGE;
      end

      local isRewardPanelAhead = false;
      local offendingEntryIndex = 0;

      -- Look ahead for league reward banners
      for x = 1, ENTRIES_PER_PAGE do

         local lookAheadIndex = math.min(i + x, #entryList);

         if entryList[lookAheadIndex].tangoID == "RewardPanel" then

            isRewardPanelAhead = true;
            offendingEntryIndex = lookAheadIndex;
            break;

         end

      end

      if entriesUntilInsertion <= 0 and not isRewardPanelAhead then

         Debug.assert(adEntries[nextAdIndex] ~= nil);

         table.insert(entryList, i, adEntries[nextAdIndex]);
         entriesUntilInsertion = INSERTION_INTERVAL;
         nextAdIndex = nextAdIndex + 1;

      end

      entriesUntilInsertion = entriesUntilInsertion - 1;
      i = i + 1;

   end

end

----------------------------------------------------------------

function StateRanking:_updateScrollListEntryData(data, entry)

   local l,d = LeagueMgr:getPlayerPlacement();

   if data.isLeagueList then
      if entry.banner:swapImage( LEAGUE_BACKPLATE[l] ) then
         entry.pbanner:swapImage( LEAGUE_BACKPLATE_PLAYER[l] );

         entry.banner:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, entry.root.prop, MOAIProp2D.TRANSFORM_TRAIT );
         entry.pbanner:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, entry.root.prop, MOAIProp2D.TRANSFORM_TRAIT );
      end
   end

   self:_hideCacheObject(entry);

   entry.rankNum:setVisible(true);
   entry.picFrame:setVisible(true);
   entry.portrait:setVisible(true);
   entry.userName:setVisible(true);
   entry.userScore:setVisible(true);
   entry.userLevel:setVisible(true);
   entry.adStarburst:setVisible(false);
   entry.linkGo:setVisible(false);

   entry.linkGo:disable();
   entry.picFrame:disable();
   entry.picFrame:setInputXtra(0, 0);

   entry.userName:setMetaFont("resources/font/Tango.otf", USER_NAME_FONT_SIZE, data.name);
   entry.userName:setText(data.name);

   if data.isLeagueList and not OnlineMgr:isOnline() and LeagueMgr:isLeagueEnabled() then

      entry.rankNum:setText("-");

      if data.tangoID ~= "RewardPanel" then

         if self.localPlayerID == data.tangoID then
            entry.userScore:setText(data.score);
            entry.userScore:setMetaFont("resources/font/TangoLatin.otf", USER_SCORE_FONT_SIZE, tostring(data.score));
            entry.userScore:setColor(1,1,1,1);

            entry.userLevel:setText(data.level);

         else

            local offlineText = "OFFLINE";
            entry.userScore:setText(offlineText);
            entry.userScore:setMetaFont("resources/font/TangoLatin.otf", USER_LEVEL_FONT_SIZE, offlineText);
            entry.userScore:setColor(1,1,1,0.6);

            entry.userLevel:setText("Level ---");
         end

      end

   else

      entry.rankNum:setText(data.rank);

      if data.rankInt == 1 then
         entry.badge_1:setVisible(true);
      elseif data.rankInt == 2 then
         entry.badge_2:setVisible(true);
      elseif data.rankInt == 3 then
         entry.badge_3:setVisible(true);
      end

      entry.userScore:setMetaFont("resources/font/TangoLatin.otf", USER_SCORE_FONT_SIZE, tostring(data.score));
      entry.userScore:setText(data.score);
      entry.userScore:setColor(1,1,1,1);

      entry.userLevel:setText(data.level);
   end

   if data.rankInt > 999 then
      entry.rankNum:setGlyphScale(0.40);
   elseif data.rankInt > 99 then
      entry.rankNum:setGlyphScale(0.60);
   elseif data.rankInt > 9 then
      entry.rankNum:setGlyphScale(0.80);
   else
      entry.rankNum:setGlyphScale(1.00);
   end

   if data.portrait ~= nil then
      if entry.portrait:getImageName() ~= data.portrait then
         entry.portrait:swapImage(data.portrait);
         entry.portrait:setParent(entry.picFrame.prop);
         entry.portrait:setLoc(0, 0);
         entry.portrait:setPriority(PRIORTY_1);
      end
   else
      Debug.error("data.portrait was nil! Name: " .. tostring(data.name));
   end

   if self.localPlayerID == data.tangoID then
      entry.banner:setVisible(false);
      entry.pbanner:setVisible(true);
      entry.clock:setVisible(false);
      entry.gift:setVisible(false);
      entry.gift:disable();
      entry.invite:setVisible(true);
      entry.invite:enable();

      if       LeagueMgr:isLeagueEnabled()
         and   App.data:isFriendsUnlocked()
         and   not data.isLeagueList
         and   data.rankInt == 1 then

         self._guideFBanner   = entry.pbanner;
         self._guideFGift     = entry.invite;
      else
         self._guideFBanner   = self._guideFBannerBackup;
         self._guideFGift     = self._guideFGiftBackup;
      end
   else
      entry.banner:setVisible(true);
      entry.pbanner:setVisible(false);
      entry.invite:setVisible(false);
      entry.invite:disable();

      if data.used then
         entry.clock:setVisible(true);
         entry.gift:setVisible(false);
         entry.gift:disable();
      else
         entry.clock:setVisible(false);
         entry.gift:setVisible(true);
         entry.gift:enable();
         entry.gift.onReleasedFunc = function()
            self:sendGift(data, entry);
         end
      end
   end

   if data.bountyState ~= nil then

      if data.bountyState < BOUNTY_STATE_INACTIVE then
         entry.bountyCheck:setVisible(false);
         entry.bountyHalo:setVisible(false);
         entry.bountyIcon:setVisible(true);
         entry.bountySparkle:stop();
         entry.bountySparkle:setVisible(false);
         entry.bountyNotif:stop();
         entry.bountyNotif:setVisible(false);
         entry.bountyGem:setVisible(false);

         if data.bountyState == BOUNTY_STATE_ACTIVE then
            if data.scoreInt < 1 then
               entry.bountyIcon:setAlpha(0.25);
            else
               entry.bountyIcon:setAlpha(1.00);
            end
         end

         if data.bountyState == BOUNTY_STATE_READY then
            self:_removeBountyVFXEntry(data.tangoID);
            entry.picFrame:enable();
            entry.picFrame.onReleasedFunc =
               function ()
                  self:collectBounty(data, entry);
               end

            entry.bountySparkle:setVisible(true);
            entry.bountySparkle:start();
            entry.bountyNotif:setVisible(true);
            entry.bountyNotif:start();
            entry.bountyGem:setVisible(true);
            entry.bountyIcon:setVisible(false);
         else
            entry.picFrame:disable();
            entry.bountySparkle:stop();
            entry.bountySparkle:setVisible(false);
         end

         if data.bountyState == BOUNTY_STATE_COLLECTING then
            entry.bountyCheck:setVisible(true);
            entry.bountyHalo:setVisible(true);
            entry.bountyIcon:setVisible(false);
         end
      else
         self:_removeBountyVFXEntry(data.tangoID);
         entry.picFrame:disable();
         entry.bountySparkle:stop();
         entry.bountySparkle:setVisible(false);
         entry.bountyCheck:setVisible(true);
         entry.bountyHalo:setVisible(false);
         entry.bountyNotif:stop();
         entry.bountyNotif:setVisible(false);
         entry.bountyGem:setVisible(false);
         entry.bountyIcon:setVisible(false);
      end

   else
      entry.picFrame:disable();
      entry.bountySparkle:stop();
      entry.bountySparkle:setVisible(false);
      entry.bountyCheck:setVisible(false);
      entry.bountyHalo:setVisible(false);
      entry.bountyNotif:stop();
      entry.bountyNotif:setVisible(false);
      entry.bountyGem:setVisible(false);
      entry.bountyIcon:setVisible(false);
   end

   if data.tangoID == "ConnectToTango" then
      entry.rankNum:setVisible(false);
      entry.userName:setVisible(false);
      entry.userScore:setVisible(false);
      entry.userLevel:setVisible(false);
      entry.clock:setVisible(false);
      entry.gift:setVisible(false);
      entry.invite:setVisible(false);
      entry.bountySparkle:stop();
      entry.bountySparkle:setVisible(false);
      entry.bountyCheck:setVisible(false);
      entry.bountyHalo:setVisible(false);
      entry.bountyNotif:stop();
      entry.bountyNotif:setVisible(false);
      entry.bountyGem:setVisible(false);
      entry.bountyIcon:setVisible(false);
      entry.tangoConnectText:setVisible(true);
      entry.tangoGemIcon:setVisible(true);
      entry.badge_1:setVisible(false);
      entry.badge_2:setVisible(false);
      entry.badge_3:setVisible(false);

      entry.portrait:setVisible(true);
      entry.portrait:swapImage("resources/UI/TangoLogo.png");

      entry.picFrame:setVisible(true);
      entry.picFrame:enable();
      entry.picFrame.onReleasedFunc = self.goTangoConnect;

      entry.linkGo:setVisible(true);
      entry.linkGo:enable();
      entry.linkGo.onReleasedFunc = self.goTangoConnect;

      entry.gift:disable();
      entry.invite:disable();

   else
      entry.tangoConnectText:setVisible(false);
      entry.tangoGemIcon:setVisible(false);
   end

   if data.tangoID == "NativeAd" then

      entry.clock:setVisible(false);
      entry.adStarburst:setVisible(true);
      entry.badge_1:setVisible(false);
      entry.badge_2:setVisible(false);
      entry.badge_3:setVisible(false);

      local onReleasedFunc =
         function()
            local ad = AdMgr:findNativeAdWithUID(data.adUID);
            Debug.assert(ad, "Missing ad");

            AdMgr:handleNativeAdClick(ad);

            AdMgr:sendUserToURL(ad.click_url);
         end

      entry.picFrame:enable();
      entry.picFrame.onReleasedFunc = onReleasedFunc;
      entry.picFrame:setInputXtra(400, 0);

      entry.linkGo:setVisible(true);
      entry.linkGo:enable();
      entry.linkGo.onReleasedFunc = onReleasedFunc;
   else
      entry.adStarburst:setVisible(false);
   end

   if data.tangoID == "RewardPanel" then

      if LEAGUE_BANNER[l] then
         if entry.rbanner:swapImage( LEAGUE_BANNER[l] ) then
            entry.rInset:swapImage( LEAGUE_INSET[l] );
            entry.trophy:swapImage( LEAGUE_TROPHY[ math.max(l-1, 1) ] );

            entry.rbanner:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, entry.root.prop, MOAIProp2D.TRANSFORM_TRAIT );
            entry.rInset:setAttrLink(  MOAIProp2D.INHERIT_TRANSFORM, entry.root.prop, MOAIProp2D.TRANSFORM_TRAIT );
            entry.trophy:setAttrLink(  MOAIProp2D.INHERIT_TRANSFORM, entry.root.prop, MOAIProp2D.TRANSFORM_TRAIT );
            entry.rInset:setVisible(false);
            entry.trophy:setVisible(false);
         end
      end

      entry.clock:setVisible(false);
      entry.picFrame:setVisible(false);
      entry.portrait:setVisible(false);
      entry.banner:setVisible(false);
      entry.pbanner:setVisible(false);
      entry.rbanner:setVisible(true);
      entry.rwrdTxt:setVisible(true);
      entry.rwrdTxtShdw:setVisible(true);
      entry.badge_1:setVisible(false);
      entry.badge_2:setVisible(false);
      entry.badge_3:setVisible(false);
      entry.userScore:setVisible(false);
      entry.userLevel:setVisible(false);

      local gem  = data.gemReward or 0;
      local coin = data.goldReward or 0;

      if gem > 0 then
         entry.rewardGemL:setVisible(true);
         entry.rwrdTxtL:setVisible(true);
         entry.rwrdTxtL:setText(getFormattedNumber(gem));
      elseif coin > 0 then
         entry.rewardCoinL:setVisible(true);
         entry.rwrdTxtL:setVisible(true);
         entry.rwrdTxtL:setText(getFormattedNumber(coin));
      end

      local n1, n2Prm   = LeagueMgr:getLeagueName(l, math.max(d-1, 1));
      local n1, n2Dm    = LeagueMgr:getLeagueName(l, math.min(d+1, LeagueMgr:getLeagueDivCount(l)));

      if data.arrowUp then
         entry.arrowUp:setVisible(true);

         if d <= 1 then
            entry.rInset:setVisible(true);
            entry.trophy:setVisible(true);
         else
            entry.rInset:setVisible(true);
            entry.insetTxt:setVisible(true);
            entry.insetTxtShdw:setVisible(true);
            entry.insetTxt:setText( string.upper(n2Prm) );
            entry.insetTxtShdw:setText( string.upper(n2Prm) );
         end
      else
         entry.arrowUp:setVisible(false);
      end

      if data.arrowDown then
         entry.arrowDown:setVisible(true);

         entry.rInset:setVisible(true);
         entry.insetTxt:setVisible(true);
         entry.insetTxtShdw:setVisible(true);
         entry.insetTxt:setText( string.upper(n2Dm) );
         entry.insetTxtShdw:setText( string.upper(n2Dm) );
      else
         entry.arrowDown:setVisible(false);
      end
   end

end

function StateRanking:_createScrollListCacheEntry(list)

   Debug.assertType(list, "table", "StateRanking:_createScrollListCacheEntry -> list");

   local tempTable = {};

   -- standard elements
   tempTable.root          = self:addWidget(Image, self.mainLayer, 0, 0, 1, 1, "resources/square.png");
   tempTable.banner        = self:addWidget(Image, self.mainLayer, 0, 0, 844, 130, "resources/UI/League/LB_rankingbanner.png");
   tempTable.pbanner       = self:addWidget(Image, self.mainLayer, 0, 0, 844, 130, "resources/UI/League/LB_playerbanner.png");
   tempTable.rankNum       = self:addWidget(TextBox, self.mainLayer, -290, 0, 82, 96, '', self.defaultFontName, 16, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.picFrame      = self:addWidget(ButtonImage, self.mainLayer, -215, 0, PORTRAIT_FRAME_WIDTH, PORTRAIT_FRAME_HEIGHT, "resources/UI/PlayerPortraitRing.png", nil, nil, nil, nil, true);
   tempTable.portrait      = self:addWidget(Image, self.mainLayer, 0, 0, PORTRAIT_WIDTH,  PORTRAIT_HEIGHT,  "resources/UI/PlayerPortrait.png");
   tempTable.userName      = self:addWidget(TextBox, self.mainLayer, 15, 24, 350, 40, '', self.unicodeFontName, USER_NAME_FONT_SIZE, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.userScore     = self:addWidget(TextBox, self.mainLayer, 45, -20, 320, 96, '', self.defaultFontName, USER_SCORE_FONT_SIZE, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.userLevel     = self:addWidget(TextBox, self.mainLayer, 15, -20, 350, 40, '', self.defaultFontName, USER_LEVEL_FONT_SIZE, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.clock         = self:addWidget(Anim, self.mainLayer, 265, 0, 0,0, "BragClockButton",self.textureSheet);
   tempTable.gift          = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 0, 0,0, "GiftButton", self.textureSheet, nil, nil, nil, nil, nil, nil, 30);
   tempTable.invite        = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 265, 0, 0,0, "SmallInviteButton", self.textureSheet, nil, self.goInvite, nil, nil, nil, nil, 30);
   tempTable.bountySparkle = self:addWidget(Anim, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2, -PORTRAIT_FRAME_HEIGHT/2, 0,0, "NotificationSparkle", self.textureSheet);
   tempTable.bountyCheck   = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2, -PORTRAIT_FRAME_HEIGHT/2, BOUNTY_ICON_WIDTH, BOUNTY_ICON_HEIGHT,  BOUNTY_IMAGE_CHECK);
   tempTable.bountyHalo    = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2, -PORTRAIT_FRAME_HEIGHT/2, 96, 96, "resources/UI/Bounty/WhiteFlash_small.png");
   tempTable.bountyNotif   = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "NotificationIconMystery_Counter", self.textureSheet);
   tempTable.bountyGem     = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IG_Gem_small", self.textureSheet2, nil, nil, true);
   tempTable.bountyIcon    = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2, -PORTRAIT_FRAME_HEIGHT/2, BOUNTY_ICON_WIDTH, BOUNTY_ICON_HEIGHT,  BOUNTY_IMAGE_RETICLE);
   tempTable.adStarburst   = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16, 40, 40, AD_ICON);
   tempTable.linkGo        = self:addWidget(ButtonImage, self.mainLayer, 0, 0, 72, 68, "resources/UI/linkgobutton.png", nil, nil, nil, nil, true);

   tempTable.rbanner       = self:addWidget(Image, self.mainLayer, 0, -12, 750, 150, LEAGUE_BANNER[1]);
   tempTable.rInset        = self:addWidget(Image, self.mainLayer, 250, -2.5, 70, 70, LEAGUE_INSET[1]);
   tempTable.insetTxt      = self:addWidget(TextBox, self.mainLayer, 248, -2.5, 200, 100, "I", self.defaultFontName, 19, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.insetTxtShdw  = self:addWidget(TextBox, self.mainLayer, 248+2, -2.5-2, 200, 100, "I", self.defaultFontName, 19, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   tempTable.trophy        = self:addWidget(Image, self.mainLayer, 250, 3.25, 80, 80, LEAGUE_TROPHY[1]);
   tempTable.arrowUp       = self:addWidget(Image, self.mainLayer, 289, -2.5, 40, 40, "resources/UI/League/LB_arrowpromote.png");
   tempTable.arrowDown     = self:addWidget(Image, self.mainLayer, 289, -2.5, 40, 40, "resources/UI/League/LB_arrowdemote.png");
   tempTable.rwrdTxt       = self:addWidget(TextBox, self.mainLayer, 0, -2.5, 612, 100, "WEEKLY REWARD", self.defaultFontName, 19, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.rwrdTxtShdw   = self:addWidget(TextBox, self.mainLayer, 2, -2.5-2, 612, 100, "WEEKLY REWARD", self.defaultFontName, 19, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY, {0,0,0,1});
   tempTable.rwrdTxtL      = self:addWidget(TextBox, self.mainLayer, REWARD_POS.left.textX, REWARD_POS.left.textY-2.5, 200, 100, "reward left", self.defaultFontName, 19, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   tempTable.rewardGemL    = self:addWidget(Image, self.mainLayer, REWARD_POS.left.iconX, REWARD_POS.left.iconY-2.5, 64, 64, "resources/UI/GR_Icon_Gem.png");
   tempTable.rewardCoinL   = self:addWidget(Image, self.mainLayer, REWARD_POS.left.iconX, REWARD_POS.left.iconY-2.5, 64, 64, "resources/UI/GR_Icon_Coin.png");

   tempTable.badge_1 = self:addWidget(Image, self.mainLayer, -289, 0, 52, 52, "resources/UI/League/LR_Badge_1.png");
   tempTable.badge_2 = self:addWidget(Image, self.mainLayer, -289, 0, 52, 52, "resources/UI/League/LR_Badge_2.png");
   tempTable.badge_3 = self:addWidget(Image, self.mainLayer, -289, 0, 52, 52, "resources/UI/League/LR_Badge_3.png");

   tempTable.userLevel:setColor(1, 1, 1, 0.6);
   tempTable.bountySparkle:setScale(0.7,0.7);
   tempTable.bountySparkle:setSpan(29/30);
   tempTable.bountySparkle:setMode(MOAITimer.LOOP);
   tempTable.bountySparkle:stop();
   tempTable.bountyNotif:setScale(0.9,0.9);
   tempTable.bountyNotif:setSpan(1.0);
   tempTable.bountyNotif:setMode(MOAITimer.LOOP);
   tempTable.bountyNotif:stop();
   tempTable.adStarburst:setVisible(false);

   -- tango connect
   --local connectText = '<c:6abffd>Play with your Tango\nfriends and get<c>';
   local connectText = 'Play with your Tango\nfriends and get';
   local bonus       = App.data:getTangoBonus() or 5;

   tempTable.tangoConnectText = self:addWidget( TextBox,
                                                self.mainLayer,
                                                110,
                                                0,
                                                540,
                                                140,
                                                connectText .. '         ' .. bonus,
                                                self.defaultFontName, 16, nil,
                                                MOAITextBox.LEFT_JUSTIFY,
                                                MOAITextBox.CENTER_JUSTIFY );

   tempTable.tangoGemIcon = self:addWidget(Anim, self.mainLayer, 90, -20, 0, 0, "BuyButtonGem", self.textureSheet, nil, nil, true);
   tempTable.tangoGemIcon:setScale(0.6, 0.6);

   tempTable.picFrame:setInViewTest( function() return list:isEntryCacheObjInView(tempTable.picFrame.prop); end );

   tempTable.gift:setInViewTest( function() return list:isEntryCacheObjInView(tempTable.gift.anim.root); end );

   tempTable.invite:setInViewTest( function() return list:isEntryCacheObjInView(tempTable.invite.anim.root); end );

   tempTable.linkGo:setInViewTest( function() return list:isEntryCacheObjInView(tempTable.linkGo.prop); end );

   -- parenting,                                                         location,                            and priority
   tempTable.banner:setAttrLink(           MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.pbanner:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rankNum:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.picFrame:setAttrLink(         MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.portrait:setAttrLink(         MOAIProp2D.INHERIT_TRANSFORM, tempTable.picFrame.prop,             MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.userName:setAttrLink(         MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.userScore:setAttrLink(        MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.userLevel:setAttrLink(        MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.clock:setAttrLink(            MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.gift:setAttrLink(             MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.invite:setAttrLink(           MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.bountySparkle:setAttrLink(    MOAIProp2D.INHERIT_TRANSFORM, tempTable.picFrame.prop,             MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.bountyCheck:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, tempTable.picFrame.prop,             MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.bountyHalo:setAttrLink(       MOAIProp2D.INHERIT_TRANSFORM, tempTable.picFrame.prop,             MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.bountyNotif:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, tempTable.picFrame.prop,             MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.bountyGem:setAttrLink(        MOAIProp2D.INHERIT_TRANSFORM, tempTable.bountyNotif.anim.props[1], MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.bountyIcon:setAttrLink(       MOAIProp2D.INHERIT_TRANSFORM, tempTable.picFrame.prop,             MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.adStarburst:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, tempTable.userLevel.moaiTextBox,     MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.tangoConnectText:setAttrLink( MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.tangoGemIcon:setAttrLink(     MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.linkGo:setAttrLink(           MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rbanner:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rInset:setAttrLink(           MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.insetTxt:setAttrLink(         MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.insetTxtShdw:setAttrLink(     MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.trophy:setAttrLink(           MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.arrowUp:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.arrowDown:setAttrLink(        MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rwrdTxt:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rwrdTxtShdw:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rwrdTxtL:setAttrLink(         MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rewardGemL:setAttrLink(       MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.rewardCoinL:setAttrLink(      MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.badge_1:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.badge_2:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );
   tempTable.badge_3:setAttrLink(          MOAIProp2D.INHERIT_TRANSFORM, tempTable.root.prop,                 MOAIProp2D.TRANSFORM_TRAIT    );

   tempTable.pbanner:setLoc(0, 0);
   tempTable.rankNum:setLoc(-290, 0)
   tempTable.picFrame:setLoc(-215, 0);
   tempTable.portrait:setLoc(0, 0);
   tempTable.userName:setLoc(15, 24);
   tempTable.userScore:setLoc(45, -20);
   tempTable.userLevel:setLoc(15, -20);
   tempTable.clock:setLoc(265, 0);
   tempTable.gift:setLoc(265, 0);
   tempTable.invite:setLoc(265, 0);
   tempTable.bountySparkle:setLoc(-PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16);
   tempTable.bountyCheck:setLoc(-PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16);
   tempTable.bountyHalo:setLoc(-PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16);
   tempTable.bountyNotif:setLoc(-PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16);
   tempTable.bountyGem:setLoc(0, 0);
   tempTable.bountyIcon:setLoc(-PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16);
   tempTable.adStarburst:setLoc(0, 0);
   tempTable.linkGo:setLoc(265, 0);

   tempTable.root:setPriority(0);
   tempTable.banner:setPriority(PRIORTY_0);
   tempTable.pbanner:setPriority(PRIORTY_0);
   tempTable.rankNum:setPriority(PRIORTY_1);
   tempTable.picFrame:setPriority(PRIORTY_1+1);
   tempTable.portrait:setPriority(PRIORTY_1);
   tempTable.userName:setPriority(PRIORTY_1);
   tempTable.userScore:setPriority(PRIORTY_1);
   tempTable.userLevel:setPriority(PRIORTY_1);
   tempTable.clock:setPriority(PRIORTY_1);
   tempTable.gift:setPriority(PRIORTY_1);
   tempTable.invite:setPriority(PRIORTY_1);
   tempTable.bountySparkle:setPriority(PRIORTY_1+2);
   tempTable.bountyCheck:setPriority(PRIORTY_1+3);
   tempTable.bountyHalo:setPriority(PRIORTY_1+7);
   tempTable.bountyNotif:setPriority(PRIORTY_1+3);
   tempTable.bountyGem:setPriority(PRIORTY_1+4);
   tempTable.bountyIcon:setPriority(PRIORTY_1+5);
   tempTable.adStarburst:setPriority(PRIORTY_1+5);
   tempTable.tangoConnectText:setPriority(PRIORTY_1);
   tempTable.tangoGemIcon:setPriority(PRIORTY_1);
   tempTable.linkGo:setPriority(PRIORTY_1);
   tempTable.rbanner:setPriority(PRIORTY_0+1);
   tempTable.rInset:setPriority(PRIORTY_1);
   tempTable.insetTxt:setPriority(PRIORTY_1+3);
   tempTable.insetTxtShdw:setPriority(PRIORTY_1+2);
   tempTable.trophy:setPriority(PRIORTY_1);
   tempTable.arrowUp:setPriority(PRIORTY_1+4);
   tempTable.arrowDown:setPriority(PRIORTY_1+4);
   tempTable.rwrdTxt:setPriority(PRIORTY_1+1);
   tempTable.rwrdTxtShdw:setPriority(PRIORTY_1);
   tempTable.rwrdTxtL:setPriority(PRIORTY_1);
   tempTable.rewardGemL:setPriority(PRIORTY_1+1);
   tempTable.rewardCoinL:setPriority(PRIORTY_1+1);
   tempTable.badge_1:setPriority(PRIORTY_1+1);
   tempTable.badge_2:setPriority(PRIORTY_1+1);
   tempTable.badge_3:setPriority(PRIORTY_1+1);

   return tempTable;

end

function StateRanking:createEntryCache()

   local listTbl = {self.ScrollList, self.ScrollListF}

   for _, list in pairs(listTbl) do

      list:setEntryObjectDataUpdateFunction( function( data, object ) self:_updateScrollListEntryData(data, object); end );

      list:setEntryObjectLocUpdateFunction( function( x, y, object ) object.root:setLoc(x,y); end );

      list:setEntryObjectParentUpdateFunction( function( target, object ) object.root:setParent(target); end );

      list:setEntryCacheObjects( nil, 10, function() return self:_createScrollListCacheEntry(list); end );

   end

end

----------------------------------------------------------------

-- FIXME the ScrollList class has a hideCacheObject method - should this still exist?
function StateRanking:_hideCacheObject( obj )

   if not obj then
      return;
   end

   for _, v in pairs(obj) do
      if type(v) == "table" then
         if v.stop then
            v:stop();
         end

         if v.disable then
            v:disable();
         end

         if v.setVisible then
            v:setVisible(false);
         elseif v.hide then
            v:hide();
         end
      end
   end

end

----------------------------------------------------------------

function StateRanking:_getPlayerEntryPos( list, tangoId )

   local id = tangoId or self.localPlayerID;

   if list then
      for k,v in ipairs(list) do

         if v.tangoID and v.tangoID == id then
            return k;
         end
      end
   end

   return 1;

end

----------------------------------------------------------------

function StateRanking:onNewPofilePicture()

   self:updatePortait();

   if LeagueMgr:isLeagueEnabled() then

      -- NC: Updating profile pictures causes both scroll lists to update,
      -- and thus both scroll lists try to show at the same time.
      -- This detects which one is being shown and hides the other one.
      -- As an unintended side effect, this causes the current scroll position to jump.
      -- MQL: Modified to check explicitly if either scrolling list is enabled,
      -- due to guides disabling both lists,
      -- and thus causing both lists to show.

      if self.ScrollListF:isEnabled() then
         self.ScrollListF:setEntryData(self.EntryListF);
      elseif self.ScrollList:isEnabled() then
         self.ScrollList:setEntryData(self.EntryList);
      end
   else
      self.ScrollList:setEntryData(self.EntryList);
   end


end

----------------------------------------------------------------

function StateRanking:updatePortait()

   if self.EntryList and self.EntryListF then
      local listTbl = {self.EntryList or {}, self.EntryListF or {}};

      for k,v in ipairs (listTbl) do
         for _, entry in ipairs(v) do

            local profile = ContactMgr:findContact(entry.tangoID);
            if profile then
               local update = ContactMgr:getContactPicture(profile) or "resources/UI/PlayerPortrait.png";

               if update ~= entry.portrait then
                  entry.portrait = update;
               end
            end
         end
      end
   end

end

----------------------------------------------------------------

function StateRanking:_createDefaultEntry(rank)

   Debug.assertType(rank, "number", "StateRanking:_createDefaultEntry -> rank");

   local entry = {};

   entry.tangoID     = nil;
   entry.portrait    = "resources/UI/PlayerPortrait.png";

   entry.name        = 'Unknown<c>';
   entry.score       = '---';
   entry.level       = '';
   entry.rank        = tostring(rank);
   entry.rankInt     = rank;

   entry.bountyState = nil;
   entry.isGhost     = function() return false; end

   return entry;
end

function StateRanking:_createEntryFromPlayer(player, rank)

   Debug.assertType(player, "table", "StateRanking:_createEntryFromPlayer -> player");
   Debug.assertType(rank, "number", "StateRanking:_createEntryFromPlayer -> rank");

   local entry = {};

   entry.tangoID  = player.tangoId;
   entry.portrait = ContactMgr:getContactPicture(player.contact) or "resources/UI/PlayerPortrait.png";

   -- Set name
   local name = "Friend";
   if entry.tangoID == self.localPlayerID then
      player.level = App.data:getCurrentPlayerLevel();
      name = "You";
   end
   entry.name = createUserNameDisplay(player.contact:getFirstName(), player.contact:getLastName(), true, name, 24);

   -- Set level
   if player.level and player.level > 0 then
      entry.level = "Level " .. player.level;
   else
      entry.level = "";
   end

   -- Set score and rank
   if player.score < 1 then
      entry.score = '---';
      entry.rank  = '-';
   else
      if entry.tangoID == self.localPlayerID then
         entry.score = getFormattedNumber(player.score);
         entry.rank = tostring(rank);
      else
         entry.score = getFormattedNumber(player.score);
         entry.rank = tostring(rank);
      end
   end
   entry.scoreInt = player.score;
   entry.rankInt  = rank;

   -- Set bounty state
   if BountyMgr:isBountyEntryValid(entry.tangoID) then

      if BountyMgr:isBountyEntryNotCollected(entry.tangoID) then

         if BountyMgr:isBountyEntryCollectReady(entry.tangoID) then
            entry.bountyState = BOUNTY_STATE_READY;
         else
            entry.bountyState = BOUNTY_STATE_ACTIVE;
         end

      else
         entry.bountyState = BOUNTY_STATE_INACTIVE;
      end

   else
      entry.bountyState = nil;
   end

   -- Set isGhost
   if player.contact:isGhost() then
      entry.isGhost = function() return true; end
   else
      entry.isGhost = function() return false; end
   end

   return entry;
end

function StateRanking:createEntryList( )

   Debug.assert( TimeMgr:getTimeGMT(), "StateRanking:createEntryList() -> TimeMgr:getTimeGMT()" );

   self.EntryList     = {};
   self.EntryListF    = {};
   self.bountyVFXList = nil;
   self.localPlayerID = ContactMgr:getProfile():getAccountId();

   local timeTbl = App.data:getValue("App.settings.gift-cooldown") or { GIFT_TIME_LIMIT, GIFT_TIME_LIMIT, GIFT_TIME_LIMIT, GIFT_TIME_LIMIT };
   local l       = RankingMgr:getRankingList();
   local lRnk    = RankingMgr:getPlayerRank();
   local listTbl = { self.EntryList, self.EntryListF };
   local giftCount;
   local f, fRnk;

   -- League only
   if LeagueMgr:isLeagueEnabled() then
      l, lRnk = RankingMgr:getRankingLeagueList();
      f, fRnk = RankingMgr:getRankingFriendsList();

      self._leagueIndex, self._divisionIndex = LeagueMgr:getPlayerPlacement();
   end

   for k, v in ipairs( { l, f } ) do
      for rank, player in ipairs(v) do

         local entry = {};

         if player.contact then
            entry = self:_createEntryFromPlayer(player, rank);
         else
            entry = self:_createDefaultEntry(rank);
         end

         if LeagueMgr:isLeagueEnabled() and k == 1 then
            entry.isLeagueList = true;
         else
            entry.isLeagueList = false;
         end

         if entry.tangoID then
            giftCount = math.clamp(getCoolDownCount("Gift2Tracker", entry.tangoID) or 1, 1, #timeTbl);

            if isTimeInLim('Gift2', entry.tangoID, timeTbl[giftCount], TimeMgr:getTimeGMT() ) then
               entry.used = true;
            else
               entry.used = false;
            end
         else
            entry.used = false;
         end

         if self.localPlayerID == entry.tangoID then
            entry.used = true;
         end

         table.insert(listTbl[k], entry);
      end
   end

end

----------------------------------------------------------------

function StateRanking:createTangoMessage(isLeague)

   if (not LoginMgr:isTango() and ( MOAITangoSdk:tangoHasSdkSupport() or MOAIEnvironment.osBrand == "Android" ) ) or HACK_NO_AUTHENTICATION then

      local t = {};

      t.tangoID      = "ConnectToTango";
      t.portrait     = "resources/UI/PlayerPortrait.png";
      t.name         = "";
      t.score        = "";
      t.level        = "";
      t.rank         = "";
      t.rankInt      = 1;
      t.bountyState  = nil;
      t.isGhost      = function () return false; end
      t.used         = true;
      t.isLeagueList = isLeague;

      return t;
   end

   return nil;

end

----------------------------------------------------------------

function StateRanking:createNativeAdEntries(isLeague)

   local adEntries = {};

   for i, v in ipairs(AdMgr:getNativeAds()) do

      local entry = {};

      entry.tangoID      = "NativeAd";
      entry.portrait     = AdMgr:getNativeAdImageFromUID(v.uid) or "resources/UI/PlayerPortrait.png";
      entry.name         = v.title;
      entry.score        = "";
      entry.level        = "Sponsored Ad";
      --entry.level        = "<c:ffffff4f>Sponsored Ad</>";
      --entry.level      = "<c:ffffff4f>" .. v.subtitle .. "</>";
      entry.rank         = "";
      entry.rankInt      = 1;
      entry.bountyState  = nil;
      entry.isGhost      = function() return false; end
      entry.used         = true;
      entry.adUID        = v.uid;
      entry.isLeagueList = isLeague;

      table.insert(adEntries, entry);
   end

   return adEntries;

end

----------------------------------------------------------------

function StateRanking:createLeagueRewardData()

   local result = nil;

   if not LeagueMgr:isLeagueEnabled() then
      return result;
   end

   local l, d = LeagueMgr:getPlayerPlacement();
   local tbl  = LeagueMgr:getRewardTable(l, d);
   local size = LeagueMgr:getPlayerCohortSize() or 1;

   if tbl then

      local index = 1;
      result = {};

      for _, v in ipairs(tbl) do
         local t = {};

         t.tangoID      = "RewardPanel";
         t.portrait     = "resources/UI/PlayerPortrait.png";
         t.name         = "";
         t.score        = "";
         t.level        = "";
         t.rank         = "";
         t.rankInt      = 1;
         t.bountyState  = nil;
         t.isGhost      = function () return false; end
         t.used         = true;
         t.gemReward    = v.gem;
         t.goldReward   = v.gold;
         t.insertIndex  = index;
         t.isLeagueList = true;
         index          = v.minRank + 1;

         if LeagueMgr:canPromote(l, d, v.minRank) then
            t.arrowUp   = true;
         else
            t.arrowUp   = false;
         end

         if LeagueMgr:canDemote(l, d, v.minRank) then
            t.arrowDown = true;
         else
            t.arrowDown = false;
         end

         if t.insertIndex < size then
            table.insert(result, t);
         end
      end

   end

   return result;

end

------------------------------------------------------------------------------------
-- Bounty guide
------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryData( state, ghostFilter )

   if not self.EntryList then
      return;
   end

   self.bountyData = nil;

   if state == BOUNTY_STATE_ACTIVE then
      self.bountyData = self:_createBountyEntryDataActiveState(ghostFilter)
   elseif state == BOUNTY_STATE_READY then
      local t = self:_createBountyEntryDataReadyState(ghostFilter)
      self.bountyData = t.data;
      self.highestRankedGhost = t.ghost;
      self.highestReady = t.highest;
   elseif state == BOUNTY_STATE_INACTIVE then
      self.bountyData = self:_createBountyEntryDataInactiveState(ghostFilter)
   else
      self.bountyData = self:_createBountyEntryDataAllState(ghostFilter)
   end

end

------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryDataAllState( ghostFilter )

   local t     = {};
   local list  = self.EntryList;

   if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
      list  = self.EntryListF;
   end

   for i=1,#list do
      if BountyMgr:isBountyEntryValid(list[i].tangoID) then
         if not ghostFilter then
            table.insert(t, list[i]);
         elseif ghostFilter and list[i]:isGhost() then
            table.insert(t, list[i])
         end
      end
   end

   return t;

end

------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryDataActiveState( ghostFilter )

   local t = {};

   for i=1,#self.EntryList do
      if BountyMgr:isBountyEntryActive(self.EntryList[i].tangoID) then
         if not ghostFilter then
            table.insert(t, self.EntryList[i]);
         elseif ghostFilter and self.EntryList[i]:isGhost() then
            table.insert(t, self.EntryList[i])
         end
      end
   end

   return t;

end

------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryDataInactiveState( ghostFilter )

   local t = {};

   for i=1,#self.EntryList do
      if not BountyMgr:isBountyEntryNotCollected(self.EntryList[i].tangoID) then
         if not ghostFilter then
            table.insert(t, self.EntryList[i]);
         elseif ghostFilter and self.EntryList[i]:isGhost() then
            table.insert(t, self.EntryList[i])
         end
      end
   end

   return t;

end

------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryDataReadyState( ghostFilter )

   local t = {};
   local hGhost = nil;
   local hReady = nil;

   for i=1,#self.EntryList do
      if BountyMgr:isBountyEntryCollectReady(self.EntryList[i].tangoID) then
         if not ghostFilter then
            table.insert(t, self.EntryList[i]);
            if not hGhost and self.EntryList[i]:isGhost() then
               hGhost =self.EntryList[i].tangoID;
            end
            if not hReady then
               hReady = self.EntryList[i].tangoID;
            end
         elseif ghostFilter and self.EntryList[i]:isGhost() then
            table.insert(t, self.EntryList[i])
            if not hGhost then
               hGhost =self.EntryList[i].tangoID;
            end
         end
        end
   end

   local retTable = {data=t, ghost=hGhost, highest=hReady};
   return retTable;

end

------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryList()

   if not self.bountyListPivot then
      self.bountyListPivot = MOAITransform2D.new();
   end

   self.bountyListPivot:setLoc(RANK_LIST_HOME_X, RANK_LIST_HOME_Y);
   self:_deleteBountyEntryList();

   self.bountyEntryList   = {};
   self.bountyGuideAnim   = {};
   self.bountyGuideImage  = {};
   self.bountyGuideButton = {};
   self.bountyGuideText   = {};

   Debug.assert(self.bountyData, "No bounty data to build an entry list!");

   local count = #self.bountyData + (HACK_BOUNTY_COUNT or 0);

   for i=1,count do
      table.insert(self.bountyEntryList, self:_createBountyEntryListObj(self.bountyData[i], i));
   end

end

------------------------------------------------------------------------------------

function StateRanking:_createBountyEntryListObj( data, index )

   Debug.assert(self.bountyData, "No bounty data to build an entry object!")

   if not data then
      self.bountyData[index] = {};
      self.bountyData[index].name               = "TEST";
      self.bountyData[index].rankInt            = index;
      self.bountyData[index].rank               = tostring(self.bountyData[index].rankInt);
      self.bountyData[index].portrait           = "resources/UI/PlayerPortrait.png";
      self.bountyData[index].score              = "---";
      self.bountyData[index].level              = "---";
      self.bountyData[index].used               = false;

      data = self.bountyData[index];
   end

   local l,d         = LeagueMgr:getPlayerPlacement();
   local t              = {};
   local offset         = math.min(-(RANK_LIST_SPACING * (#self.bountyData)), -App.viewportHeight);

   if LeagueMgr:isLeagueEnabled() and App.data:isLeagueUnlocked() then
      t.banner          = self:addWidget(Image, self.mainLayer, 0, offset, 844, 130, LEAGUE_BACKPLATE[l]);
   else
      t.banner          = self:addWidget(Image, self.mainLayer, 0, offset, 844, 130, "resources/UI/League/LB_rankingbanner.png");
   end

   t.rankNum            = self:addWidget(TextBox, self.mainLayer, -290, 0, 82, 96, data.rank, self.defaultFontName, USER_NAME_FONT_SIZE, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   t.picFrame           = self:addWidget(ButtonImage, self.mainLayer, -215, 0, PORTRAIT_FRAME_WIDTH, PORTRAIT_FRAME_HEIGHT, "resources/UI/PlayerPortraitRing.png", nil, nil, nil, nil, true);
   t.portrait           = self:addWidget(Image, self.mainLayer, 0,0, PORTRAIT_WIDTH,  PORTRAIT_HEIGHT,  data.portrait);
   t.userName           = self:addWidget(TextBox, self.mainLayer, 15, 24, 350, 40, data.name, self.defaultFontName, USER_NAME_FONT_SIZE, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   t.userScore          = self:addWidget(TextBox, self.mainLayer, 50, -20, 320, 96, data.score, self.defaultFontName, USER_SCORE_FONT_SIZE, nil, MOAITextBox.RIGHT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   t.userLevel          = self:addWidget(TextBox, self.mainLayer, 15, -25, 350, 40, data.level, self.defaultFontName, USER_LEVEL_FONT_SIZE, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);

   if data.rankInt <= 3 and data.rankInt > 0 then
      t.badge           = self:addWidget(Image, self.mainLayer, -290, 0, 52, 52, "resources/UI/League/LR_Badge_"..data.rankInt..".png");
   else
      t.badge           = self:addWidget(Image, self.mainLayer, -290, 0, 0.001, 0.001, "resources/square.png");
   end

   t.userName:setMetaFont("resources/font/Tango.otf", USER_NAME_FONT_SIZE, data.name);

   t.picFrame:setInputXtra(150, 10);
   t.userLevel:setColor(1,1,1,0.6);

   if data.used then
      t.input = self:addWidget(Anim, self.mainLayer, 265, 0, 0,0, "BragClockButton", self.textureSheet);
   else
      t.input = self:addWidget(Anim, self.mainLayer, 265, 0, 0,0, "GiftButton", self.textureSheet);
      t.input:setColor(0.2, 0.2, 0.2, 1.0);
   end

   if data.rankInt > 999 then
      t.rankNum:setGlyphScale(0.40);
   elseif data.rankInt > 99 then
      t.rankNum:setGlyphScale(0.60);
   elseif data.rankInt > 9 then
      t.rankNum:setGlyphScale(0.80);
   else
      t.rankNum:setGlyphScale(1.00);
   end

   t.userName:setText(data.name);

   t.bountySparkle      = self:addWidget(Anim, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16, 0,0, "NotificationSparkle", self.textureSheet);
   t.bountyCheck        = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16, BOUNTY_ICON_WIDTH, BOUNTY_ICON_HEIGHT,  BOUNTY_IMAGE_CHECK);
   t.bountyNotif        = self:addWidget(Anim, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16, 0,0, "NotificationIconMystery_Counter", self.textureSheet);
   t.bountyGem          = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "IG_Gem_small", self.textureSheet2, nil, nil, true);
   t.bountyIcon         = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16, BOUNTY_ICON_WIDTH, BOUNTY_ICON_HEIGHT,  BOUNTY_IMAGE_RETICLE);
   t.bountyHalo         = self:addWidget(Image, self.mainLayer, -PORTRAIT_FRAME_WIDTH/2+14, -PORTRAIT_FRAME_HEIGHT/2+16, 96, 96, "resources/UI/Bounty/WhiteFlash_small.png");

   t.banner:setPriority(PRIORTY_0+10);
   t.rankNum:setPriority(PRIORTY_1+10);
   t.picFrame:setPriority(PRIORTY_1+1+10);
   t.portrait:setPriority(PRIORTY_1+10);
   t.userName:setPriority(PRIORTY_1+10);
   t.userScore:setPriority(PRIORTY_1+10);
   t.userLevel:setPriority(PRIORTY_1+10);
   t.badge:setPriority(PRIORTY_1+11);
   t.input:setPriority(PRIORTY_1+10);
   t.bountySparkle:setPriority(PRIORTY_1+2+10);
   t.bountyCheck:setPriority(PRIORTY_1+3+10);
   t.bountyNotif:setPriority(PRIORTY_1+3+10);
   t.bountyGem:setPriority(PRIORTY_1+4+10);
   t.bountyIcon:setPriority(PRIORTY_1+5+10);
   t.bountyHalo:setPriority(PRIORTY_1+7+10);

   t.banner:setParent(          self.bountyListPivot            );
   t.rankNum:setParent(         t.banner.prop              );
   t.picFrame:setParent(        t.banner.prop              );
   t.portrait:setParent(        t.picFrame.prop                 );
   t.userName:setParent(        t.banner.prop              );
   t.userScore:setParent(       t.banner.prop              );
   t.userLevel:setParent(       t.banner.prop              );
   t.badge:setParent(            t.banner.prop              );
   t.input:setParent(            t.banner.prop              );
   t.bountySparkle:setParent(    t.picFrame.prop                 );
   t.bountyCheck:setParent(      t.picFrame.prop                     );
   t.bountyNotif:setParent(      t.picFrame.prop                     );
   t.bountyGem:setParent(        t.bountyNotif.anim.props[1]     );
   t.bountyIcon:setParent(       t.picFrame.prop                 );
   t.bountyHalo:setParent(       t.picFrame.prop                 );

   t.bountySparkle:setScale(0.7,0.7);
   t.bountySparkle:setSpan(29/30);
   t.bountySparkle:setMode(MOAITimer.LOOP);
   t.bountySparkle:stop();
   t.bountySparkle:setVisible(false);
   t.bountyCheck:setVisible(false);
   t.bountyNotif:setScale(1.3,1.3);
   t.bountyGem:setScale(1.1,1.1);
   t.bountyNotif:setSpan(1.0);
   t.bountyNotif:setMode(MOAITimer.LOOP);
   t.bountyNotif:stop();
   t.bountyNotif:setVisible(false);
   t.bountyGem:setVisible(false);
   t.bountyIcon:setVisible(false);
   t.bountyHalo:setVisible(false);

   if data.bountyState == BOUNTY_STATE_ACTIVE then
      t.bountyIcon:setVisible(true);
   elseif data.bountyState == BOUNTY_STATE_READY then
      t.bountySparkle:setVisible(true);
      t.bountySparkle:start();
      t.bountyNotif:setVisible(true);
      t.bountyNotif:start();
      t.bountyGem:setVisible(true);

      t.picFrame:enable();
      t.picFrame.onReleasedFunc =
         function ()
            local thread = MOAICoroutine.new();
            thread:run(function() self:_startBountyListEntryCollectionAnim(t); end);

            App.data:addBountyReward(data.tangoID);
         end
   else
      t.bountyCheck:setVisible(true);
   end

   table.insert(self.bountyGuideAnim, t.banner);
   table.insert(self.bountyGuideAnim, t.input);
   table.insert(self.bountyGuideAnim, t.bountySparkle);
   table.insert(self.bountyGuideAnim, t.bountyNotif);
   table.insert(self.bountyGuideAnim, t.bountyGem);
   table.insert(self.bountyGuideImage, t.portrait);
   table.insert(self.bountyGuideImage, t.bountyCheck);
   table.insert(self.bountyGuideImage, t.bountyIcon);
   table.insert(self.bountyGuideImage, t.bountyHalo);
   table.insert(self.bountyGuideImage, t.badge);
   table.insert(self.bountyGuideButton, t.picFrame);
   table.insert(self.bountyGuideText, t.rankNum);
   table.insert(self.bountyGuideText, t.userName);
   table.insert(self.bountyGuideText, t.userScore);
   table.insert(self.bountyGuideText, t.userLevel);

   return t;

end

------------------------------------------------------------------------------------

function StateRanking:_deleteBountyEntryList()

   if self.bountyEntryList and #self.bountyEntryList > 0 then

      for _,v in pairs(self.bountyEntryList) do
         self:deleteWidget(v.banner);
         self:deleteWidget(v.rankNum);
         self:deleteWidget(v.picFrame);
         self:deleteWidget(v.portrait);
         self:deleteWidget(v.userName);
         self:deleteWidget(v.userScore);
         self:deleteWidget(v.userLevel);
         self:deleteWidget(v.badge);
         self:deleteWidget(v.input);
         self:deleteWidget(v.bountySparkle);
         self:deleteWidget(v.bountyCheck);
         self:deleteWidget(v.bountyNotif);
         self:deleteWidget(v.bountyGem);
         self:deleteWidget(v.bountyIcon);
         self:deleteWidget(v.bountyHalo);
      end

      if self.topBar then
         self:deleteWidget(self.topBar);
      end

      if self.botBar then
         self:deleteWidget(self.botBar);
      end

      self.bountyEntryList      = nil;
      self.bountyGuideAnim      = nil;
      self.bountyGuideImage     = nil;
      self.bountyGuideButton    = nil;
      self.bountyGuideText      = nil;

   end

end

------------------------------------------------------------------------------------

function StateRanking:_hideBountyEntryElement( element )

   if self.bountyEntryList and #self.bountyEntryList > 0 then

      for k,v in pairs(self.bountyEntryList) do
         v[element]:setVisible(false);
      end
   end

end

------------------------------------------------------------------------------------

function StateRanking:_startBountyListIntro( element, autoplay, pauseAfterStamp )

   self:pullBountyPriorities( self:getBountyEntryListAnim() );
   self:pullBountyPriorities( self:getBountyEntryListImage() );
   self:pullBountyPriorities( self:getBountyEntryListButton() );
   self:pullBountyPriorities( self:getBountyEntryListText() );

   local x,y = self.ScrollList:getLoc();

   if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
      x,y = self.ScrollListF:getLoc();

      self.ScrollListF:disable();

      self.bountyEntryListAction = self.ScrollListF:seekLoc(RANK_LIST_SLIDE_LEFT, y, 0.4, MOAIEaseType.EASE_OUT);
   else

      self.ScrollList:disable();

      self.bountyEntryListAction = self.ScrollList:seekLoc(RANK_LIST_SLIDE_LEFT, y, 0.4, MOAIEaseType.EASE_OUT);
   end

   if self.bountyEntryListAction then
      MOAICoroutine.blockOnAction(self.bountyEntryListAction);
   end

   self:_startBountyListCycle(element, autoplay, pauseAfterStamp );

end

------------------------------------------------------------------------------------

function StateRanking:_startWeeklyIntro( element, autoplay )

   local x,y = self.ScrollList:getLoc();

   if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
      x,y = self.ScrollListF:getLoc();

      self.ScrollListF:disable();
      self.ScrollListF:setLoc(RANK_LIST_SLIDE_LEFT, y );
   else
      self.ScrollList:disable();
      self.ScrollList:setLoc(RANK_LIST_SLIDE_LEFT, y );
   end

   self:_startBountyListCycle(element, autoplay);

end

------------------------------------------------------------------------------------

function StateRanking:_startBountyListCycle( element, autoplay, pauseAfterStamp  )

   Debug.assert( self.bountyEntryList, "StateRanking:_startBountyListCycle->self.bountyEntryList-1"  );

   if self.bountyEntryList then

      for i = 1, #(self.bountyEntryList or {}) do

         Debug.assert(self.bountyEntryList, "StateRanking:_startBountyListCycle -> self.bountyEntryList");

         if self.bountyEntryList and self.bountyEntryList[i] and self.bountyEntryList[i].banner then

            if self.bountyEntryList[i].picFrame and self.bountyEntryList[i].picFrame.onReleasedFunc then
               self.bountyEntryList[i].picFrame:enable();
            else
               self.bountyEntryList[i].picFrame:disable();
            end

            if i <= RANK_DISPLAY_MAX then
               local offset = -(RANK_LIST_SPACING * (i - 1));

               self.bountyEntryListAction = self.bountyEntryList[i].banner:seekLoc(0, offset, 0.35, MOAIEaseType.EASE_OUT);
            else
               local offset = RANK_LIST_SPACING * (i - RANK_DISPLAY_MAX);
               local off2   = -(RANK_LIST_SPACING * (i - 1));

               self.bountyEntryListAction = self.bountyListPivot:seekLoc(RANK_LIST_HOME_X, RANK_LIST_HOME_Y+offset, 0.35, MOAIEaseType.EASE_OUT);
               self.bountyEntryList[i].banner:seekLoc(0, off2, 0.25, MOAIEaseType.EASE_OUT);
            end

            local sSound = {start={"SwipeOut",},};
            EventMgr:postEvent( { sounds=sSound, name="achievement sting",}, "add-sfx" );

            if self.bountyEntryListAction then
               MOAICoroutine.blockOnAction(self.bountyEntryListAction);
               Debug.assert(self.bountyEntryList ~= nil, "StateRanking:_startBountyListCycle -> self.bountyEntryList (missing after coroutine)");
            end
         end
      end

      Debug.assert( self.bountyEntryList, "StateRanking:_startBountyListCycle->self.bountyEntryList-2"  );

      if self.bountyEntryList then
         if element and autoplay then
            self:startBountyListElementStampAnim(element, autoplay, pauseAfterStamp);
         elseif autoplay then
            self:startBountyListSpread( autoplay );
         end
      end
   end


end

------------------------------------------------------------------------------------

function StateRanking:startBountyListElementStampAnim( element, autoplay, pauseAfterStamp )

   local action;

   Debug.assert( self.bountyEntryList, "StateRanking:startBountyListElementStampAnim->self.bountyEntryList-1"  );

   if self.bountyEntryList then

      for i = 1, #(self.bountyEntryList or {}) do

         Debug.assert(self.bountyEntryList, "StateRanking:startBountyListElementStampAnim -> self.bountyEntryList-2");

         if self.bountyEntryList and self.bountyEntryList[i] and self.bountyEntryList[i][element] then
            self.bountyEntryList[i][element]:setVisible(true);
            self.bountyEntryList[i][element]:setScale(40,40);
            self.bountyEntryList[i][element]:setAlpha(0);
            self.bountyEntryList[i][element]:setPriority(5001);

            if i < #self.bountyEntryList then
               local t = MOAITimer.new();

               t:setSpan(0.25);
               t:setTime(0);
               t:setMode(MOAITimer.NORMAL);

               self.bountyEntryList[i][element]:seekScale(1, 1, BOUNTY_ANIM_TIME, MOAIEaseType.LINEAR);
               action = t:start();
            else
               action = self.bountyEntryList[i][element]:seekScale(1, 1, BOUNTY_ANIM_TIME, MOAIEaseType.LINEAR);
            end

            local sSound = {start={"BountyCrosshairs",},};

            EventMgr:postEvent( { sounds=sSound, name="achievement sting",}, "add-sfx" );
            self.bountyEntryList[i][element]:seekAlpha(1, BOUNTY_ANIM_TIME, MOAIEaseType.LINEAR);

            if action then
               MOAICoroutine.blockOnAction(action);
            end

            if self.bountyEntryList and self.bountyEntryList[i] and self.bountyEntryList[i][element] then
               self.bountyEntryList[i][element]:setPriority(2050);
            else
               Debug.assert(self.bountyEntryList and self.bountyEntryList[i] and self.bountyEntryList[i][element], "StateRanking:startBountyListElementStampAnim -> self.bountyEntryList and self.bountyEntryList[i] and self.bountyEntryList[i][element]");
            end
         end
      end

      Debug.assert(self.bountyEntryList, "StateRanking:startBountyListElementStampAnim -> self.bountyEntryList-3");

      if autoplay and self.bountyEntryList and not pauseAfterStamp then
         self:startBountyListSpread( autoplay );
      end
   end

end

------------------------------------------------------------------------------------

function StateRanking:_startBountyListEntryCollectionAnim( entry )

   if entry then
      local action;

      entry.picFrame:disable();
      entry.bountySparkle:setVisible(false);
      entry.bountySparkle:stop();
      entry.bountyNotif:setVisible(false);
      entry.bountyNotif:stop();
      entry.bountyGem:setVisible(false);
      entry.bountyCheck:setVisible(true);
      entry.bountyHalo:setVisible(true);

      entry.bountyHalo:setScale(5,5);

      entry.bountyHalo:seekAlpha(0, BOUNTY_ANIM_TIME, MOAIEaseType.LINEAR);

      action = entry.bountyHalo:seekScale(1, 1, BOUNTY_ANIM_TIME, MOAIEaseType.LINEAR);

      if action then
         MOAICoroutine.blockOnAction(action);
      end

      entry.bountyHalo:setVisible(false);
   end

   EventMgr:postEvent( {}, "bounty-entry-collected" );

end

------------------------------------------------------------------------------------

function StateRanking:startBountyListSpread( autoplay, noPushPriority )

   if not noPushPriority then
      self:pushBountyPriorities( self:getBountyEntryListAnim() );
      self:pushBountyPriorities( self:getBountyEntryListImage() );
      self:pushBountyPriorities( self:getBountyEntryListButton() );
      self:pushBountyPriorities( self:getBountyEntryListText() );
   end

   local x, y  = self.ScrollList:getLoc();
   local t     = MOAITimer.new();
   local list  = self.EntryList;

   if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
      x,y   = self.ScrollListF:getLoc();
      list  = self.EntryListF;
   end

   t:setSpan(0.75);
   t:setTime(0);
   t:setMode(MOAITimer.NORMAL);

   self.bountyEntryListAction = t:start();

   self.bountyListPivot:seekLoc(RANK_LIST_HOME_X, y, 0.4, MOAIEaseType.EASE_OUT);

   for i = 1, #(self.bountyEntryList or {}) do

      if self.bountyEntryList[i] and self.bountyEntryList[i].banner then

         local offset = -(RANK_LIST_SPACING * (self:_getPlayerEntryPos(list, self.bountyData[i].tangoID) - 1));

         self.bountyEntryList[i].banner:seekLoc(0, offset, 0.4, MOAIEaseType.EASE_OUT);
      end
   end

   if self.bountyEntryListAction then
      MOAICoroutine.blockOnAction(self.bountyEntryListAction);
   end

   Debug.assert( self.bountyEntryList, "StateRanking:startBountyListSpread->self.bountyEntryList" );

   if autoplay and self.bountyEntryList then
      self:startBountyListExit( autoplay, noPushPriority );
   end

end

------------------------------------------------------------------------------------

function StateRanking:startBountyListExit( autoplay )

   if noPushPriority then
      self:pushBountyPriorities( self:getBountyEntryListAnim() );
      self:pushBountyPriorities( self:getBountyEntryListImage() );
      self:pushBountyPriorities( self:getBountyEntryListButton() );
      self:pushBountyPriorities( self:getBountyEntryListText() );
   end

   local sSound = {start={"SwipeIn",},};
   EventMgr:postEvent( { sounds=sSound, name="achievement sting",}, "add-sfx" );

   local x,y = self.ScrollList:getLoc();

   if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
      x,y = self.ScrollListF:getLoc();

      self.bountyEntryListAction = self.ScrollListF:seekLoc(RANK_LIST_HOME_X, y, 0.4, MOAIEaseType.EASE_OUT);
   else
      self.bountyEntryListAction = self.ScrollList:seekLoc(RANK_LIST_HOME_X, y, 0.4, MOAIEaseType.EASE_OUT);
   end

   if self.bountyEntryListAction then
      MOAICoroutine.blockOnAction(self.bountyEntryListAction);
   end

   if autoplay then

      if LeagueMgr:isLeagueEnabled() and not App.data:isLeagueUnlocked() then
         self.ScrollListF:show();
      else
         self.ScrollList:show();
      end

      self:_deleteBountyEntryList();
   end

end

------------------------------------------------------------------------------------

function StateRanking:isBountyReadyAvailable()

   for _, v in ipairs(self.EntryList) do

      if v.bountyState == BOUNTY_STATE_READY then
         return true;
      end
   end

   return false;

end

------------------------------------------------------------------------------------

function StateRanking:pullBountyPriorities( rList )

   if rList then

      for i,v in pairs(rList) do

         v.oldPriority =  v.priority;
         if v.priority then
            v.priority = v.priority + 2002;
         else
            v.priority = 2002;
         end

         v:setPriority(v.priority);
         local x,y = v:getLoc(true);
         v:setLoc(x,y);

      end

   end

end

------------------------------------------------------------------------------------

function StateRanking:pushBountyPriorities( rList )

   if rList then
      for i,v in pairs(rList) do
         if v.oldPriority then
            v.priority = v.oldPriority;
            v.oldPriority =  nil;
         else
            v.priority = (45);
         end
         v:setPriority(v.priority);
         local x,y = v:getLoc(true);
         v:setLoc(x,y);
      end
   end

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListAnim()

   return self.bountyGuideAnim;

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListImage()

   return self.bountyGuideImage;

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListButton()

   return self.bountyGuideButton;

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListText()

   return self.bountyGuideText;

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListCount()

   if self.bountyEntryList then
      return #self.bountyEntryList
   end

   return 0;

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListReadyIndex()

   for i,v in ipairs(self.EntryList) do

      if v.bountyState == BOUNTY_STATE_READY then
         return GhostMgr:getGhostIndex(self.EntryList[i].tangoID);
      end
   end

end

------------------------------------------------------------------------------------

function StateRanking:getBountyEntryListGhostReadyIndex()

   for i,v in ipairs(self.EntryList) do

      if v.bountyState == BOUNTY_STATE_READY and v:isGhost() then
         return GhostMgr:getGhostIndex(self.EntryList[i].tangoID);
      end
      if v:isGhost() then
         return GhostMgr:getGhostIndex(self.EntryList[i].tangoID);
      end
   end

end

------------------------------------------------------------------------------------

function StateRanking:getBountyListSize()

   if self.bountyData then
      return #self.bountyData;
   end

end

------------------------------------------------------------------------------------

function StateRanking:onBountyEntryListTutorial()

   if LeagueMgr:isLeagueEnabled() then

      if App.data:isLeagueUnlocked() then
         self:_showLeagueList(false);
         self.ScrollList:disable();
      else
         self:_showFriendList(false);
         self.ScrollListF:disable();
      end
   else
      self.ScrollList:disable();
   end

   self:_createBountyEntryData();
   self:_createBountyEntryList();

   self:_hideBountyEntryElement("bountyIcon");

   local thread = MOAICoroutine.new();

   thread:run(
      function ()
         self:_startBountyListIntro("bountyIcon", true, true);
      end
   );

end

------------------------------------------------------------------------------------

function StateRanking:onBountyEntryListTutorialContinue()

   if self.bountyEntryList then
      self:startBountyListSpread(true, true);
   end

end

------------------------------------------------------------------------------------

function StateRanking:onBountyFirstReturn()

   local thread = MOAICoroutine.new();
   thread:run(function () self:_startBountyListIntro(); end);

end

------------------------------------------------------------------------------------

function StateRanking:onBountyEntryListWeeklyReset()

   if LeagueMgr:isLeagueEnabled() and App.data:isLeagueUnlocked() then
      self:_showLeagueList(false);
   end

   self.ScrollList:disable();

   self:_createBountyEntryData();
   self:_createBountyEntryList();
   self:_hideBountyEntryElement("bountyIcon");

   EventMgr:postEvent( {}, "bounty-reset" );

   local w  = App.viewportWidth;
   local h  = App.viewportHeight/2;
   local y1 = App.viewportHeight/2;
   local y2 = -App.viewportHeight/2 + 37;


   self.topBar = self:addWidget(Image, self.mainLayer, 0, y1, w,h,  "resources/UI/blackbox.png");
   self.botBar = self:addWidget(Image, self.mainLayer, 0, y2, w,h,  "resources/UI/blackbox.png");
   self.topBar:setAlpha(0.8);
   self.botBar:setAlpha(0.8);
   self.topBar:setPriority(5000);
   self.botBar:setPriority(5000);

   local thread = MOAICoroutine.new();
   thread:run( function () self:_startWeeklyIntro( "bountyIcon", true); end );

end

------------------------------------------------------------------------------------

function StateRanking:onBountyEntryListReset()

   self:_createBountyEntryData();
   self:_createBountyEntryList();

   local thread = MOAICoroutine.new();

   thread:run(
      function ()
         self:_startBountyListIntro();
      end
   );

end

------------------------------------------------------------------------------------

function StateRanking:onBountyEntryListCollect()

   self:_createBountyEntryData(BOUNTY_STATE_READY);
   self:_createBountyEntryList();

   local thread = MOAICoroutine.new();
   thread:run(function() self:_startBountyListIntro(); end );

end


------------------------------------------------------------------------------------

function StateRanking:onBountyEntryListBeginExit()

   local thread = MOAICoroutine.new();

   thread:run(
      function ()
         self:startBountyListSpread();
      end
   );

end

------------------------------------------------------------------------------------

function StateRanking:bountyClearCheck()

   if self.clearState then
      self.clearState = nil;
      StateMgr:clear ( "state/state-ranking.lua" );
   end

end

------------------------------------------------------------------------------------

function StateRanking:onBountyGuideExit()

   if LeagueMgr:isLeagueEnabled() then

      if App.data:isLeagueUnlocked() then
         self.ScrollList:enable();
      else
         self.ScrollListF:enable();
      end
   else
      self.ScrollList:enable();
   end

end


------------------------------------------------------------------------------------
-- League leaderboard guide
------------------------------------------------------------------------------------


function StateRanking:onLeagueGuideClear()

   self:_showLeagueList(false);
   self.ScrollList:goToEntry(1);
   self.ScrollList:disable();

   if self._guideLeagueInfo then
      self._guideLeagueSparkle:setVisible(true);
      self._guideLeagueSparkle:start();
   end

   if self._guideLeaguePlayerBanner then

      if self._guideLeaguePlayerBanner.action and self._guideLeaguePlayerBanner.action.stop then
         self._guideLeaguePlayerBanner.action:stop();
      end

      for _,v in pairs(self._guideLeaguePlayerBanner) do
         self:deleteWidget(v);
      end

      self._guideLeaguePlayerBanner = nil;
   end

end

------------------------------------------------------------------------------------

function StateRanking:onLeagueGuideExit()

   self:disableGuideScrnButton();

   if not self._guideLeagueInfo then
      return;
   end

   if self._guideLeagueSparkle then
      self._guideLeagueSparkle:stop();
      self._guideLeagueSparkle:setVisible(false);
   end

end

------------------------------------------------------------------------------------

function StateRanking:disableGuideScrnButton()
   self._guideLeagueScrnButton:disable();
end

------------------------------------------------------------------------------------

function StateRanking:enableGuideScrnButton()
   self._guideLeagueScrnButton:enable();
end


------------------------------------------------------------------------------------
-- Friends leaderboard guide
------------------------------------------------------------------------------------


function StateRanking:onFriendGuideStart()

   self:_showFriendList(false);
   self.ScrollListF:goToEntry(1);
   self.ScrollListF:disable();

end

------------------------------------------------------------------------------------

function StateRanking:onFriendGuideButtonDisable()

   self._guideFGift:disable();
   self._guideFTabF:disable();
   self._guideFTabL:disable();

end

------------------------------------------------------------------------------------

function StateRanking:onFriendGuideExit()

   self.ScrollListF:enable();
   self._guideFGift:enable();
   self._guideFTabF:enable();
   self._guideFTabL:disable();
   self:disableGuideScrnButton();

end


------------------------------------------------------------------------------------
-- Roll out
------------------------------------------------------------------------------------

function StateRanking:createRollOut()

   -- inside rollout
   self:_createDailyButton();
   self:_createMissionButton();
   self:_createAchievementButton();
   self:_createMysteryButton();
   self:_createVideoButton();

   -- outside rollout
   self:_createOptionButton();
   self:_createGameCenterButton();
   self:_createKeyTray();

end

----------------------------------------------------------------

function StateRanking:_createDailyButton()

   self.DailyButton       = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "DailyButton", self.textureSheet, nil, self.goDaily, nil, nil);
   self.dIconBadgeCoin    = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationIconCoin", self.textureSheet);
   self.dIconBadgeGem     = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationIconGem", self.textureSheet);
   self.dIconBadgeSparkle = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationSparkle", self.textureSheet);
   self.IconBadgeDaily    = self.dIconBadgeCoin;
   self.IconDailySparkle  = self.dIconBadgeSparkle;

   self.DailyButton:setPriority(PRIORTY_7);
   self.dIconBadgeCoin:setPriority(PRIORTY_7+1);
   self.dIconBadgeCoin:setScale(0.9,0.9);
   self.dIconBadgeCoin:setSpan(29/30);
   self.dIconBadgeCoin:setMode(MOAITimer.LOOP);
   self.dIconBadgeCoin:setParent(self.DailyButton.anim.props[1]);
   self.dIconBadgeCoin:setVisible(false);
   self.dIconBadgeGem:setPriority(PRIORTY_7+1);
   self.dIconBadgeGem:setScale(0.9,0.9);
   self.dIconBadgeGem:setSpan(29/30);
   self.dIconBadgeGem:setMode(MOAITimer.LOOP);
   self.dIconBadgeGem:setParent(self.DailyButton.anim.props[1]);
   self.dIconBadgeGem:setVisible(false);
   self.dIconBadgeSparkle:setPriority(PRIORTY_7);
   self.dIconBadgeSparkle:setScale(0.9,0.9);
   self.dIconBadgeSparkle:setSpan(29/30);
   self.dIconBadgeSparkle:setMode(MOAITimer.LOOP);
   self.dIconBadgeSparkle:setParent(self.DailyButton.anim.props[1]);
   self.dIconBadgeSparkle:setVisible(false);
   self.RollOut:addRollOutElement(  self.DailyButton, 0,0, "open", false,
                                    function()
                                       local flag = App.data:isDailyUnlocked();

                                       if not flag then
                                          self.dIconBadgeCoin:stop();
                                          self.dIconBadgeGem:stop();
                                          self.dIconBadgeSparkle:stop();
                                          self.dIconBadgeCoin:setVisible(false);
                                          self.dIconBadgeGem:setVisible(false);
                                          self.dIconBadgeSparkle:setVisible(false);
                                       end

                                       return not flag;
                                    end,

                                    function()
                                       local dailyReward    = App.data:getDailyChallengeRewardToCollect();
                                       local flag           = false;

                                       if dailyReward then

                                          flag = self:rolloutABCheck( "daily" );

                                          if dailyReward.gem > 0 then
                                             self.dIconBadgeCoin:setVisible(false);
                                             self.IconBadgeDaily = self.dIconBadgeGem;
                                          elseif dailyReward.gold > 0 then
                                             self.dIconBadgeGem:setVisible(false);
                                             self.IconBadgeDaily = self.dIconBadgeCoin;
                                          end

                                          MOAIFlurry:event("Daily-Badge-Show");
                                          self.IconBadgeDaily:start();
                                          self.IconDailySparkle:start();
                                          self.IconBadgeDaily:setVisible(true);
                                          self.IconDailySparkle:setVisible(true);
                                       else
                                          self.IconBadgeDaily:stop();
                                          self.IconDailySparkle:stop();
                                          self.IconBadgeDaily:setVisible(false);
                                          self.IconDailySparkle:setVisible(false);
                                       end

                                       return flag;
                                    end
   );

end

----------------------------------------------------------------

function StateRanking:_createMissionButton()

   self.MissionButton     = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "MessageButton", self.textureSheet, nil, self.goMission, nil, nil);
   self.mIconBadgeGem     = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationIconGem", self.textureSheet);
   self.mIconBadgeSparkle = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "NotificationSparkle", self.textureSheet);

   self.MissionButton:setPriority(PRIORTY_7);
   self.mIconBadgeGem:setPriority(PRIORTY_7+1);
   self.mIconBadgeGem:setScale(0.9,0.9);
   self.mIconBadgeGem:setSpan(29/30);
   self.mIconBadgeGem:setMode(MOAITimer.LOOP);
   self.mIconBadgeGem:setParent(self.MissionButton.anim.props[1]);
   self.mIconBadgeGem:setVisible(false);
   self.mIconBadgeSparkle:setPriority(PRIORTY_7);
   self.mIconBadgeSparkle:setScale(0.9,0.9);
   self.mIconBadgeSparkle:setSpan(29/30);
   self.mIconBadgeSparkle:setMode(MOAITimer.LOOP);
   self.mIconBadgeSparkle:setParent(self.mIconBadgeGem.anim.props[1]);
   self.mIconBadgeSparkle:setVisible(false);
   self.RollOut:addRollOutElement(  self.MissionButton, 0,0, "open", false,
                                    function()
                                       local flag = App.data:isMissionUnlocked();

                                       if not flag then
                                          self.mIconBadgeGem:stop();
                                          self.mIconBadgeSparkle:stop();
                                          self.mIconBadgeGem:setVisible(false);
                                          self.mIconBadgeSparkle:setVisible(false);
                                       end

                                       return not flag;
                                    end,

                                    function()
                                       local missionComplete = App.data:isCurrentMissionCompleted();

                                       if missionComplete then
                                          self.mIconBadgeGem:start();
                                          self.mIconBadgeSparkle:start();
                                          self.mIconBadgeGem:setVisible(true);
                                          self.mIconBadgeSparkle:setVisible(true);
                                          missionComplete = self:rolloutABCheck( "mission" );
                                       else
                                          self.mIconBadgeGem:stop();
                                          self.mIconBadgeSparkle:stop();
                                          self.mIconBadgeGem:setVisible(false);
                                          self.mIconBadgeSparkle:setVisible(false);
                                       end

                                       return missionComplete;
                                    end
   );

end

----------------------------------------------------------------

function StateRanking:_createAchievementButton()

   self.AchievementButton       = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "AchievementButton", self.textureSheet, nil, self.goAchievement, nil, nil);
   self.achievementAlertGem     = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationIconGem", self.textureSheet);
   self.achievementAlertSparkle = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "NotificationSparkle", self.textureSheet);

   self.AchievementButton:setPriority(PRIORTY_7);
   self.achievementAlertGem:setPriority(PRIORTY_7+2);
   self.achievementAlertGem:setScale(0.9,0.9);
   self.achievementAlertGem:setSpan(29/30);
   self.achievementAlertGem:setMode(MOAITimer.LOOP);
   self.achievementAlertGem:setVisible(false);
   self.achievementAlertGem:setParent(self.AchievementButton.anim.props[1]);
   self.achievementAlertSparkle:setPriority(PRIORTY_7+1);
   self.achievementAlertSparkle:setScale(0.9,0.9);
   self.achievementAlertSparkle:setSpan(29/30);
   self.achievementAlertSparkle:setMode(MOAITimer.LOOP);
   self.achievementAlertSparkle:setVisible(false);
   self.achievementAlertSparkle:setParent(self.achievementAlertGem.anim.props[1]);
   self.RollOut:addRollOutElement(  self.AchievementButton, 0,0, "open", false,
                                    function()
                                       local flag = App.data:isAchievementUnlocked();

                                       if not flag then
                                          self.achievementAlertGem:stop();
                                          self.achievementAlertSparkle:stop();
                                          self.achievementAlertGem:setVisible(false);
                                          self.achievementAlertSparkle:setVisible(false);
                                       end

                                       return not flag;
                                    end,

                                    function()
                                       local achvComplete = AchievementMgr:isPendingRewards();

                                       if achvComplete then
                                          self.achievementAlertGem:start();
                                          self.achievementAlertSparkle:start();
                                          self.achievementAlertGem:setVisible(true);
                                          self.achievementAlertSparkle:setVisible(true);
                                          achvComplete = self:rolloutABCheck( "achv" );
                                       else
                                          self.achievementAlertGem:stop();
                                          self.achievementAlertSparkle:stop();
                                          self.achievementAlertGem:setVisible(false);
                                          self.achievementAlertSparkle:setVisible(false);
                                       end

                                       return achvComplete;
                                    end
   );

end

----------------------------------------------------------------

function StateRanking:_createMysteryButton()

   self.MysteryButton       = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "MysteryButton", self.textureSheet, nil, self.goMystery, nil, nil);
   self.MysteryAlert        = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationIconMystery_Counter", self.textureSheet);
   self.MysteryAlertSparkle = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "NotificationSparkle", self.textureSheet);
   self.MysteryAlertText    = self:addWidget(TextBox, self.mainLayer, -3,2, 580, 75, "", self.defaultFontName, 20, nil, MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);

   self.MysteryButton:setPriority(PRIORTY_7);
   self.MysteryAlert:setPriority(PRIORTY_7+2);
   self.MysteryAlert:setScale(0.9,0.9);
   self.MysteryAlert:setSpan(1.0);
   self.MysteryAlert:setMode(MOAITimer.LOOP);
   self.MysteryAlert:setVisible(false);
   self.MysteryAlert:setParent(self.MysteryButton.anim.props[1]);
   self.MysteryAlertSparkle:setPriority(PRIORTY_7+1);
   self.MysteryAlertSparkle:setScale(0.9,0.9);
   self.MysteryAlertSparkle:setSpan(29/30);
   self.MysteryAlertSparkle:setMode(MOAITimer.LOOP);
   self.MysteryAlertSparkle:setParent(self.MysteryAlert.anim.props[1]);
   self.MysteryAlertText:setPriority(PRIORTY_7+3);
   self.MysteryAlertText:setParent(self.MysteryAlert.anim.props[1]);
   self.RollOut:addRollOutElement(  self.MysteryButton, 0,0, "open", false,
                                    function()
                                       local flag = App.data:isMysteryUnlocked();

                                       if not flag then
                                          self.MysteryAlert:stop();
                                          self.MysteryAlertSparkle:stop();
                                          self.MysteryAlert:setVisible(false);
                                          self.MysteryAlertSparkle:setVisible(false);
                                          self.MysteryAlertText:setVisible(false);
                                       end

                                       return not flag;
                                    end,

                                    function()
                                       local count  = App.data:getFreebieCount("mystery");
                                       local flag   = count > 0;

                                       if flag then
                                          self.MysteryAlert:start();
                                          self.MysteryAlertSparkle:start();
                                          self.MysteryAlert:setVisible(true);
                                          self.MysteryAlertSparkle:setVisible(true);
                                          self.MysteryAlertText:setVisible(true);
                                          self.MysteryAlertText:setText(tostring(count));
                                          flag = self:rolloutABCheck( "mystery" );
                                       else
                                          self.MysteryAlert:stop();
                                          self.MysteryAlertSparkle:stop();
                                          self.MysteryAlert:setVisible(false);
                                          self.MysteryAlertSparkle:setVisible(false);
                                          self.MysteryAlertText:setVisible(false);
                                       end

                                       return flag;
                                    end,

                                   function()
                                      local count  = App.data:getFreebieCount("mystery");
                                      local flag   = count > 0;

                                      if flag then
                                         self.MysteryAlert:start();
                                         self.MysteryAlertSparkle:start();
                                         self.MysteryAlert:setVisible(true);
                                         self.MysteryAlertSparkle:setVisible(true);
                                         self.MysteryAlertText:setVisible(true);
                                         self.MysteryAlertText:setText(tostring(count));
                                      else
                                         self.MysteryAlert:stop();
                                         self.MysteryAlertSparkle:stop();
                                         self.MysteryAlert:setVisible(false);
                                         self.MysteryAlertSparkle:setVisible(false);
                                         self.MysteryAlertText:setVisible(false);
                                      end
                                   end
   );

end

----------------------------------------------------------------

function StateRanking:_createVideoButton()

   self.videoRolloutButton  = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, 0,0,0,0, "VideoButton", self.textureSheet, nil, self.videoRolloutButtonReleased, nil, nil);
   self.videoRolloutCoin    = self:addWidget(Anim, self.mainLayer, NOTIFICATION_OFFSET_X,NOTIFICATION_OFFSET_Y,0,0, "NotificationIconCoin", self.textureSheet);
   self.videoRolloutSparkle = self:addWidget(Anim, self.mainLayer, 0,0,0,0, "NotificationSparkle", self.textureSheet);

   self.videoRolloutButton:setPriority(PRIORTY_7);
   self.videoRolloutButton:disable();
   self.videoRolloutCoin:setPriority(PRIORTY_7+2);
   self.videoRolloutCoin:setScale(0.9,0.9);
   self.videoRolloutCoin:setSpan(29/30);
   self.videoRolloutCoin:setMode(MOAITimer.LOOP);
   self.videoRolloutCoin:setParent(self.videoRolloutButton.anim.props[1]);
   self.videoRolloutCoin:setVisible(false);
   self.videoRolloutSparkle:setPriority(PRIORTY_7+1);
   self.videoRolloutSparkle:setScale(0.9,0.9);
   self.videoRolloutSparkle:setSpan(29/30);
   self.videoRolloutSparkle:setMode(MOAITimer.LOOP);
   self.videoRolloutSparkle:setParent(self.videoRolloutCoin.anim.props[1]);
   self.videoRolloutSparkle:setVisible(false);
   self.RollOut:addRollOutElement(  self.videoRolloutButton, 0,0, "open", false,
                                    function()
                                       local flag = App:isVideoRewardEnabled() and AbTestMgr:getVideoButtonEnabled();

                                       if not flag then
                                          self.videoRolloutCoin:stop();
                                          self.videoRolloutSparkle:stop();
                                          self.videoRolloutCoin:setVisible(false);
                                          self.videoRolloutSparkle:setVisible(false);
                                       else
                                          if not self:isVideoRewardReady() or self.RollOut:isRollOutClosed() then
                                             self.videoRolloutCoin:stop();
                                             self.videoRolloutSparkle:stop();
                                             self.videoRolloutCoin:setVisible(false);
                                             self.videoRolloutSparkle:setVisible(false);
                                          else
                                             self.videoRolloutCoin:start();
                                             self.videoRolloutSparkle:start();
                                             self.videoRolloutCoin:setVisible(true);
                                             self.videoRolloutSparkle:setVisible(true);
                                          end
                                       end

                                       return not flag;
                                    end,

                                    function()

                                       if App:isVideoRewardEnabled() and AbTestMgr:getVideoButtonEnabled() and self:isVideoRewardReady() then
                                          return self:rolloutABCheck( "video" );
                                       end

                                       return false;

                                    end,

                                    function()
                                       local flag = App:isVideoRewardEnabled() and AbTestMgr:getVideoButtonEnabled();
                                       if not self:isVideoRewardReady() or self.RollOut:isRollOutClosed() then
                                          self.videoRolloutCoin:stop();
                                          self.videoRolloutSparkle:stop();
                                          self.videoRolloutCoin:setVisible(false);
                                          self.videoRolloutSparkle:setVisible(false);
                                       else
                                          self.videoRolloutCoin:start();
                                          self.videoRolloutSparkle:start();
                                          self.videoRolloutCoin:setVisible(true);
                                          self.videoRolloutSparkle:setVisible(true);
                                       end
                                    end

   );

end

----------------------------------------------------------------

function StateRanking:_createOptionButton()

   self.OptionsButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, ROLLOUT_SHIFT-200,0,0,0, "OptionsIcon", self.textureSheet, nil, self.goOption, nil, nil);

   self.OptionsButton:setPriority(PRIORTY_7);
   self.RollOut:addRollOutElement( self.OptionsButton, ROLLOUT_SHIFT-200, 0, "closed", false );

end

----------------------------------------------------------------

function StateRanking:_createGameCenterButton()

   if MOAIEnvironment.osBrand == "iOS" then
      self.GameCenterButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, ROLLOUT_SHIFT-222,0,0,0, "IOSGamecenter_icon", self.textureSheet, nil, self.goGameCenter, nil, nil);

      self.GameCenterButton:setPriority(PRIORTY_7);
      self.RollOut:addRollOutElement(   self.GameCenterButton, ROLLOUT_SHIFT-222, 0, "closed", false,
                                        function()
                                           local flag = self:_shouldShowGameCenter();

                                           if flag then
                                              self.GameCenterButton:enable();
                                              self.GameCenterButton:setVisible(true);
                                           else
                                              self.GameCenterButton:disable();
                                              self.GameCenterButton:setVisible(false);
                                           end

                                           return not flag;
                                        end
      );
   end

end

----------------------------------------------------------------

function StateRanking:_createKeyTray()

   self.KeyTray   = self:addWidget(Anim, self.mainLayer, ROLLOUT_SHIFT,0, 640/2, 1136/2, "KayTry", self.textureSheet);
   self.KeyButton = self:addWidget(ButtonAnim, self.mainLayer, self.mainPartition, ROLLOUT_SHIFT,0,0,0, "KayTryAdd", self.textureSheet, nil, self.goKeyStore, nil, nil, nil, nil, 40);
   self.KeyTime   = self:addWidget(TextBox, self.mainLayer, KEY_TIME_X+ROLLOUT_SHIFT, KEY_TIME_Y, 250, 54, '', self.defaultFontName, 14, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);
   self.KeyMax    = self:addWidget(TextBox, self.mainLayer, KEY_TIME_X+56+ROLLOUT_SHIFT, KEY_TIME_Y, 250, 54, '', self.defaultFontName, 14, nil, MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY);

   self.KeyTray:setPriority(PRIORTY_5-1);
   self.KeyButton:setPriority(PRIORTY_5-1);
   self.KeyTime:setPriority(PRIORTY_5-1);
   self.KeyMax:setPriority(PRIORTY_5-1);
   self.RollOut:addRollOutElement( self.KeyTray, ROLLOUT_SHIFT, 0, "closed", false );
   self.RollOut:addRollOutElement( self.KeyButton, ROLLOUT_SHIFT, 0, "closed", false );
   self.RollOut:addRollOutElement( self.KeyTime, KEY_TIME_X+ROLLOUT_SHIFT, KEY_TIME_Y, "closed", false );
   self.RollOut:addRollOutElement( self.KeyMax, KEY_TIME_X+56+ROLLOUT_SHIFT, KEY_TIME_Y, "closed", false );

end

----------------------------------------------------------------

function StateRanking:guideDisableKeyButton()
   self.KeyButton:disable();
end

----------------------------------------------------------------

function StateRanking:guideEnableKeyButton()
   self.KeyButton:enable();
end

----------------------------------------------------------------

function StateRanking:guideOpenRollout()

   self.RollOut:setRollOutOpened()
   self.RollOut.closeButton:disable();

end

----------------------------------------------------------------

function StateRanking:guideCloseRollout()

   self.RollOut:setRollOutClosed()
   self.RollOut.openButton:disable();

end

----------------------------------------------------------------

function StateRanking:guideDailyIntro()

   self.IconDailySparkle:setVisible(true);
   self.IconDailySparkle:start();

end

----------------------------------------------------------------

function StateRanking:guideMissionIntro()

   self.mIconBadgeSparkle:setVisible(true);
   self.mIconBadgeSparkle:start();

end

----------------------------------------------------------------

function StateRanking:rolloutABCheck( button )

   if not button then
      return;
   end

   local gamesFlag   = false;
   local timeFlag    = false;

   local g     = AbTestMgr:getRolloutGames( button );
   local gId   = "rollout_games_"..button;
   local t     = AbTestMgr:getRolloutTime( button );
   local tId   = "rollout_timestamp_"..button;

   local cTime = TimeMgr:getTimeGMT();

   local games = App.data:getValue(gId);
   if not games then
      App.data:setValue(gId,0);
      gamesFlag = true;
   end

   local timeStamp = App.data:getValue(tId);
   if not timeStamp then
      App.data:setValue(tId,cTime);
      timeFlag = true;
   end

   if g and not gamesFlag then
      if games >= g then
         App.data:setValue(gId,0);
         App.data:setValue(tId,cTime);
         gamesFlag = true;
      end
   end

   if t and not timeFlag then
      if (cTime-timeStamp) >= (t) then
         App.data:setValue(gId,0);
         App.data:setValue(tId,cTime);
         timeFlag = true;
      end
   end

   return gamesFlag and timeFlag;
end

------------------------------------------------------------------------------------
-- Misc functionality
------------------------------------------------------------------------------------

function StateRanking:sendGift( data, object )

   Debug.assert( TimeMgr:getTimeGMT(),    "StateRanking:StateRanking:sendGift() -> TimeMgr:getTimeGMT()"   );

   local time          = TimeMgr:getTimeGMT();
   local giftTemplates = MessageMgr:getGiftTemplateList();

   --To simplify our logic and make the UX more responsive
   --Only check if the user is online and assume it will go through
   if (not OnlineMgr:isOnline()) or (not time) or (not giftTemplates) then

      MOAIDialogIOS.showDialog(     LocalizationMgr:getString( "NATIVE_CONNECT_ERROR" )
                                    ,  LocalizationMgr:getString( "DEFAULT_ERROR_NETWORK_MESSAGE" )
                                    ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                                    ,  nil
                                    ,  nil
                                    ,  false
                                    ,  function()
                                       end
      );

   else
      data.used = true;

      object.clock:setVisible(true);
      object.gift:setVisible(false);
      object.gift:disable();

      if data.tangoID then
         App.data:setValue("Gift2-"..data.tangoID, time);
         EventMgr:postEvent( {item = "key"}, "gift-sent" );
         MessageMgr:sendGift( giftTemplates[math.random(1,#giftTemplates)], ContactMgr:findContact(data.tangoID) );

         local giftCount = getCoolDownCount("Gift2Tracker", data.tangoID);

         if not giftCount then
            setCoolDownCount("Gift2Tracker", data.tangoID, 1);
         else
            setCoolDownCount("Gift2Tracker", data.tangoID, giftCount+1);
         end
      end
   end
end

----------------------------------------------------------------

function StateRanking:collectBounty( data, object )

   if data and data.tangoID then
      object.bountySparkle:stop();
      object.bountySparkle:setVisible(false);
      object.bountyNotif:stop();
      object.bountyNotif:setVisible(false);
      object.bountyGem:setVisible(false);
      object.bountyCheck:setVisible(true);
      object.picFrame:disable();

      data.bountyState = BOUNTY_STATE_COLLECTING;

      App.data:addBountyReward(data.tangoID);

      if not self.bountyVFXList then
         self.bountyVFXList = {};
      end

      table.insert(self.bountyVFXList, {entry=data, plate=object, time=0});
   end

end

----------------------------------------------------------------

function StateRanking:_removeBountyVFXEntry( tangoID )

   if tangoID and self.bountyVFXList and #self.bountyVFXList > 0 then

      for i=#self.bountyVFXList,1,-1 do
         if self.bountyVFXList[i].entry.tangoID == tangoID then
            table.remove(self.bountyVFXList, i);
         end
      end
   end

end

----------------------------------------------------------------

function StateRanking:updateBountyVFX( dt )

   for i=#self.bountyVFXList,1,-1 do
      self.bountyVFXList[i].time = self.bountyVFXList[i].time + dt;

      if self.bountyVFXList[i].time > BOUNTY_ANIM_TIME then
         self.bountyVFXList[i].entry.bountyState = BOUNTY_STATE_INACTIVE;

         self.bountyVFXList[i].plate.bountyCheck:setVisible(true);
         self.bountyVFXList[i].plate.bountyHalo:setVisible(false);
         table.remove(self.bountyVFXList, i);
      else
         local scale = 1.2 + 5*(self.bountyVFXList[i].time/BOUNTY_ANIM_TIME);
         local alpha = math.max(0, 1 - self.bountyVFXList[i].time/BOUNTY_ANIM_TIME);

         self.bountyVFXList[i].plate.bountyHalo:setScale(scale, scale);
         self.bountyVFXList[i].plate.bountyHalo:setAlpha(alpha);
      end
   end

end

------------------------------------------------------------------------------------
-- Exit State
------------------------------------------------------------------------------------

function StateRanking:onBackButton()

   self:goQuit();

end

----------------------------------------------------------------

function StateRanking:goQuit()

   StateMgr:push("state/state-quit-confirm.lua");

end

----------------------------------------------------------------

function StateRanking:goTangoConnect()

   if MOAITangoSdk:tangoHasSdkSupport() then
      StateMgr:push("state/state-authenticate-confirm.lua");
   else
      installTango();
   end

end

----------------------------------------------------------------

function StateRanking:goInvite()

   StateMgr:push("state/state-invite.lua");

end

----------------------------------------------------------------

function StateRanking:goDaily()

   if App.data:isDailyUnlocked() then

      StateMgr:push("state/state-daily.lua");

   else

      local lvl = App.data:getDailyUnlockLevel();
      local msg = "";
      if lvl then
         msg = LocalizationMgr:getString( "NATIVE_DAILY_MSG_1C1" )..lvl..LocalizationMgr:getString( "NATIVE_DAILY_MSG_1C2" );
      else
         msg = LocalizationMgr:getString( "NATIVE_DAILY_MSG_2" );
      end

      MOAIDialogIOS.showDialog(     LocalizationMgr:getString( "NATIVE_DAILY_TITLE" )
                                    ,   msg
                                    ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                                    ,  nil
                                    ,  nil
                                    ,  false
                                    ,  function()
                                       end
      );

   end

end

----------------------------------------------------------------

function StateRanking:goMission()

   if App.data:isMissionUnlocked() then

      StateMgr:push("state/state-mission-popup.lua");

   else

      local lvl = App.data:getMissionUnlockLevel();
      local msg = "";
      if lvl then
         msg = LocalizationMgr:getString( "NATIVE_MISSION_MSG_1C1" )..lvl..LocalizationMgr:getString( "NATIVE_MISSION_MSG_1C2" );
      else
         msg = LocalizationMgr:getString( "NATIVE_MISSION_MSG_2" );
      end

      MOAIDialogIOS.showDialog(     LocalizationMgr:getString( "NATIVE_MISSION_TITLE" )
                                    ,   msg
                                    ,  LocalizationMgr:getString( "NATIVE_OK_BTN" )
                                    ,  nil
                                    ,  nil
                                    ,  false
                                    ,  function()
                                       end
      );
   end

end

----------------------------------------------------------------

function StateRanking:goMail()

   -- StateMgr:push("state/state-mailbox.lua");

end

----------------------------------------------------------------

function StateRanking:goKeyStore()

   if LeagueMgr:isLeagueEnabled() and HACK_LEAGUE_RESULT_POPUP then
      StateMgr:push("state/state-league-reward-popup.lua");
   else
      StateMgr:push("state/state-key.lua");
   end

end

----------------------------------------------------------------

function StateRanking:goAchievement()

   if not self.achievementLoaded then

      self.achievementLoading = true;

      StateMgr:setSyncBusyDelay(0);

      disableButtonInput();

      delay( 0.1,
             function()

                StateMgr:setSyncBusyDelay();

                self.achievementLoading = nil;
                self.achievementLoaded = true;
                enableButtonInput();
                StateMgr:push("state/state-achievement.lua");

      end );

   else

      StateMgr:push("state/state-achievement.lua");

   end

end

----------------------------------------------------------------

function StateRanking:goOption()

   if DEBUG_PROMOS_ON then
      self:promoTest();
   else
      StateMgr:push("state/state-options.lua");
   end

end

----------------------------------------------------------------

function StateRanking:goLeagueInfo()
   StateMgr:push("state/state-league-codex.lua");
end

----------------------------------------------------------------

function StateRanking:goGameCenter()

   if MOAIGameCenterIOS then
      StateMgr:push("state/state-game-center-leaderboard.lua");
   end

end

----------------------------------------------------------------------

function StateRanking:isBusy()
   return self.mysteryLoading or self.achievementLoading;
end

----------------------------------------------------------------------

function StateRanking:getBusyName()
   return "Loading...";
end

----------------------------------------------------------------

function StateRanking:goMystery()

   if not self.mysteryLoaded then

      self.mysteryLoading = true;

      StateMgr:setSyncBusyDelay(0);

      disableButtonInput();

      delay( 0.1,
             function()

                StateMgr:setSyncBusyDelay();

                self.mysteryLoading = nil;
                self.mysteryLoaded = true;
                enableButtonInput();
                StateMgr:push("state/state-mystery-box.lua");
      end );
   else

      StateMgr:push("state/state-mystery-box.lua");

   end

end

----------------------------------------------------------------

function StateRanking:goVideoPromo()
   PromoMgr:createPopup( "goldPageRanking" );
end

----------------------------------------------------------------

function StateRanking:promoTest()

   --quick hack to run through all the promo panels.
   --I usually replace the "goOption" state push, to have a button to cycle through.

   local popupNameTable = {
	  "updateGame",
	  "channelPage",
	  "rateGame",
	  "goldPageRanking",
	  "goldPageStore",
	  "keyPageStore",
	  "keyPagePlay",
	  "doubleCoin",
	  "oldTangoLogin",
     "newDrones",
     "carSale",
	  "tangoLogin",
   };

   if self.pIndexTest then
      self.pIndexTest = self.pIndexTest + 1;

      if self.pIndexTest > 11 then
         self.pIndexTest = 1;
      end

      PromoMgr:createPopup( popupNameTable[self.pIndexTest] );
   else
      self.pIndexTest = 1;
      self:promoTest()
   end

end

----------------------------------------------------------------

function StateRanking:goGarage()
   StateMgr:push("state/state-garage.lua");
end

----------------------------------------------------------------

function StateRanking:goDrone()

   if DroneMgr:isDroneLevelLocked() then
      StateMgr:push("state/state-drone-locked-popup.lua");
   else
      if not App.data:getValue("new-unlock-drones", false) then
         App.data:setValue("new-unlock-drones", true);
      end

      StateMgr:push("state/state-drone-garage.lua");
   end

end

----------------------------------------------------------------

function StateRanking:_setListVisibility(scrollList, entryList, visible, shouldScroll)

   local sPos = math.clamp(AbTestMgr:getGuestFriendRankPageOffset() or App.data:getValue("App.settings.leaderboard-offset", 4), 0, 4);

   -- MQL: Second parameter is optional parameter for hiding list,
   -- and thus, we pass in not visible.
   scrollList:setEntryData(entryList, not visible);

   if visible then
      scrollList:show();
   else
      scrollList:hide();
   end

   if shouldScroll then
      scrollList:advanceToEntry( math.max( self:_getPlayerEntryPos(entryList) - sPos, 1 ), 0.5 );
   end

end

----------------------------------------------------------------

function StateRanking:goStarterPack()
   StateMgr:push("state/state-starter-pack-popup.lua");
end

----------------------------------------------------------------

function StateRanking:_showLeagueList(shouldScroll)

   if App.data:isLeagueUnlocked() then
      if shouldScroll == nil then
         shouldScroll = true;
      end

      --self.LeagueTabOff:setVisible(false);
      --self.FriendTabOff:setVisible(true);

      -- Show league list
      self:_setListVisibility(self.ScrollList, self.EntryList, true, shouldScroll);

      -- Hide friend list
      self:_setListVisibility(self.ScrollListF, self.EntryListF, false, false);

      self._ListState = LIST_STATE_LEAGUE;
   else
      StateMgr:push("state/state-league-locked-popup.lua");
   end

end

----------------------------------------------------------------

function StateRanking:_showFriendList(shouldScroll)

   if shouldScroll == nil then
      shouldScroll = true;
   end

   --self.LeagueTabOff:setVisible(true);
   --self.FriendTabOff:setVisible(false);

   -- Show friend list
   self:_setListVisibility(self.ScrollListF, self.EntryListF, true, shouldScroll);

   -- Hide league list
   self:_setListVisibility(self.ScrollList, self.EntryList, false, false);

   self._ListState = LIST_STATE_FRIENDS;

end

----------------------------------------------------------------

function StateRanking:goGame()

   --If we are dealing with a Thief
   if FraudMgr:shouldForceVideo() and App.data:getValue("Thief-Video-GameCount",1) >= ( AbTestMgr:getVideoThiefGameBefore() or 1000000 ) then

      MOAIFlurry:eventStart(  "Thief-Video-2",
                              "Ending",         "playing",
                              "Ending-Ex",      "before-playing",
                              "Type",           "before"             );

      if AdMgr:playVideo(  self
                           ,
                           function()
                              App.data:addKey( 1, "Video Thief");
                              EventMgr:postEvent({keys=1, playType="After Game"}, "video-thief");
                              App.data:setValue("Thief-Video-GameCount",0);

                              MOAIFlurry:eventStop(  "Thief-Video-2",
                                                     "Count",             tostring(App.data:getValue("Thief-Video-Count",1)),
                                                     "Ending",            "success" ,
                                                     "Ending-Ex",         "before-success"                                     );
                              self:_goGame();
                           end
                           ,
                           function()
                              MOAIFlurry:eventStop(   "Thief-Video-2",
                                                      "Ending",            "failure" ,
                                                      "Ending-Ex",         "before-failure"                                           );

                              self:_goGame();
      end) then

         EventMgr:postEvent({keys=1, playType="After Game"}, "video-thief-attempt");

      else

         MOAIFlurry:eventStop(   "Thief-Video-2",
                                 "Ending",            "no-video" ,
                                 "Ending-Ex",         "before-no-video"     );

         self:_goGame();
      end
   else
      self:_goGame();
   end

end

----------------------------------------------------------------

function StateRanking:_goGame()

   if not self.startingGame then

      self.startingGame = true;

      --disable right away to increase chance of fading away before game start
      self:disableAds();

      disableButtonInput();

      if App.data:consumeKey() then

         local stamp = MOAISim.getDeviceTime(); -- XXX UNUSED?

         self.KeyUseAnim:stop();
         self.KeyUseAnim:setVisible(true);
         self.KeyUseAnim:setSpan(0, 29/30);
         self.KeyUseAnim:setTime(0);

         if AbTestMgr:isHintPopupEnabled() then
            self.KeyUseAnim:setSpeed(1.5);
         end

         self.KeyUseAnim:start();
         EventMgr:postEvent( {sounds={start={"GameStart"}}, name="goGame",}, "add-sfx" );

         if AbTestMgr:isHintPopupEnabled() then
            delay( 29/30/1.5,
                   function()
                      enableButtonInput();
                      App.gameReviveIndex = 0;
                      App.VideoReviveCount = 0;
                      StateMgr:push( "state/state-hint-popup.lua", { state= "state/state-game.lua", anim= self.KeyUseAnim } );
            end );
         else
            delay( 0.22,
                   function()
                      EventMgr:postEvent( { }, "game-load" );

                      delay( 0.10, function()
                                enableButtonInput();
                                App:collectGarbageNow();

                                if StateMgr:getDataServerErrorCount() == 0 then
                                   App.gameReviveIndex = 0;
                                   App.VideoReviveCount = 0;
                                   StateMgr:swap("state/state-game.lua");
                                end
                      end );
            end );
         end
      else
         self.startingGame = false;

         enableButtonInput();

         if self.videoKeyEnabled then
            PromoMgr:createPopup( "keyPagePlay" );
         else

            AUTO_PURCHASE_DATA.currency     = 'Key';
            AUTO_PURCHASE_DATA.price        = 1;
            self.startingGame               = false;
            AUTO_PURCHASE_FUNC              =
               function()
                  delay( 0.1,
                         function() self:goGame(); end
                  );
               end
            enableButtonInput();
            StateMgr:push("state/state-auto-purchase-popup-maz.lua");
         end
      end
   end

end

----------------------------------------------------------------

return StateRanking;

----------------------------------------------------------------
